/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs

/* First part of user prologue.  */
#line 1 "gram.y"


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 1996-2025, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET constraint_exclusion TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_am.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "commands/trigger.h"
#include "gramparse.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/parser.h"
#include "utils/datetime.h"
#include "utils/xml.h"


/*
 * Location tracking support.  Unlike bison's default, we only want
 * to track the start position not the end position of each nonterminal.
 * Nonterminals that reduce to empty receive position "-1".  Since a
 * production's leading RHS nonterminal(s) may have reduced to empty,
 * we have to scan to find the first one that's not -1.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		(Current) = (-1); \
		for (int _i = 1; _i <= (N); _i++) \
		{ \
			if ((Rhs)[_i] >= 0) \
			{ \
				(Current) = (Rhs)[_i]; \
				break; \
			} \
		} \
	} while (0)

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	ObjectType	objtype;
	List	   *objs;
} PrivTarget;

/* Private struct for the result of import_qualification production */
typedef struct ImportQual
{
	ImportForeignSchemaType type;
	List	   *table_names;
} ImportQual;

/* Private struct for the result of select_limit & limit_clause productions */
typedef struct SelectLimit
{
	Node	   *limitOffset;
	Node	   *limitCount;
	LimitOption limitOption;	/* indicates presence of WITH TIES */
	ParseLoc	offsetLoc;		/* location of OFFSET token, if present */
	ParseLoc	countLoc;		/* location of LIMIT/FETCH token, if present */
	ParseLoc	optionLoc;		/* location of WITH TIES, if present */
} SelectLimit;

/* Private struct for the result of group_clause production */
typedef struct GroupClause
{
	bool		distinct;
	List	   *list;
} GroupClause;

/* Private structs for the result of key_actions and key_action productions */
typedef struct KeyAction
{
	char		action;
	List	   *cols;
} KeyAction;

typedef struct KeyActions
{
	KeyAction *updateAction;
	KeyAction *deleteAction;
} KeyActions;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20
#define CAS_NOT_ENFORCED			0x40
#define CAS_ENFORCED				0x80


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static RawStmt *makeRawStmt(Node *stmt, int stmt_location);
static void updateRawStmtEnd(RawStmt *rs, int end_location);
static void updatePreparableStmtEnd(Node *n, int end_location);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBoolAConst(bool state, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Node *v, int location);
static RoleSpec *makeRoleSpec(RoleSpecType type, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								SelectLimit *limitClause,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg, int location);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Float *v);
static Node *makeAndExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeOrExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeNotExpr(Node *expr, int location);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod,
								  int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns, core_yyscan_t yyscanner);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static RangeVar *makeRangeVarFromQualifiedName(char *name, List *namelist, int location,
											   core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *is_enforced,
			   bool *not_valid, bool *no_inherit, core_yyscan_t yyscanner);
static PartitionStrategy parsePartitionStrategy(char *strategy, int location,
												core_yyscan_t yyscanner);
static void preprocess_pubobj_list(List *pubobjspec_list,
								   core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


#line 286 "gram.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "gram.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_IDENT = 3,                      /* IDENT  */
  YYSYMBOL_UIDENT = 4,                     /* UIDENT  */
  YYSYMBOL_FCONST = 5,                     /* FCONST  */
  YYSYMBOL_SCONST = 6,                     /* SCONST  */
  YYSYMBOL_USCONST = 7,                    /* USCONST  */
  YYSYMBOL_BCONST = 8,                     /* BCONST  */
  YYSYMBOL_XCONST = 9,                     /* XCONST  */
  YYSYMBOL_Op = 10,                        /* Op  */
  YYSYMBOL_ICONST = 11,                    /* ICONST  */
  YYSYMBOL_PARAM = 12,                     /* PARAM  */
  YYSYMBOL_TYPECAST = 13,                  /* TYPECAST  */
  YYSYMBOL_DOT_DOT = 14,                   /* DOT_DOT  */
  YYSYMBOL_COLON_EQUALS = 15,              /* COLON_EQUALS  */
  YYSYMBOL_EQUALS_GREATER = 16,            /* EQUALS_GREATER  */
  YYSYMBOL_LESS_EQUALS = 17,               /* LESS_EQUALS  */
  YYSYMBOL_GREATER_EQUALS = 18,            /* GREATER_EQUALS  */
  YYSYMBOL_NOT_EQUALS = 19,                /* NOT_EQUALS  */
  YYSYMBOL_ABORT_P = 20,                   /* ABORT_P  */
  YYSYMBOL_ABSENT = 21,                    /* ABSENT  */
  YYSYMBOL_ABSOLUTE_P = 22,                /* ABSOLUTE_P  */
  YYSYMBOL_ACCESS = 23,                    /* ACCESS  */
  YYSYMBOL_ACTION = 24,                    /* ACTION  */
  YYSYMBOL_ADD_P = 25,                     /* ADD_P  */
  YYSYMBOL_ADMIN = 26,                     /* ADMIN  */
  YYSYMBOL_AFTER = 27,                     /* AFTER  */
  YYSYMBOL_AGGREGATE = 28,                 /* AGGREGATE  */
  YYSYMBOL_ALL = 29,                       /* ALL  */
  YYSYMBOL_ALSO = 30,                      /* ALSO  */
  YYSYMBOL_ALTER = 31,                     /* ALTER  */
  YYSYMBOL_ALWAYS = 32,                    /* ALWAYS  */
  YYSYMBOL_ANALYSE = 33,                   /* ANALYSE  */
  YYSYMBOL_ANALYZE = 34,                   /* ANALYZE  */
  YYSYMBOL_AND = 35,                       /* AND  */
  YYSYMBOL_ANY = 36,                       /* ANY  */
  YYSYMBOL_ARRAY = 37,                     /* ARRAY  */
  YYSYMBOL_AS = 38,                        /* AS  */
  YYSYMBOL_ASC = 39,                       /* ASC  */
  YYSYMBOL_ASENSITIVE = 40,                /* ASENSITIVE  */
  YYSYMBOL_ASSERTION = 41,                 /* ASSERTION  */
  YYSYMBOL_ASSIGNMENT = 42,                /* ASSIGNMENT  */
  YYSYMBOL_ASYMMETRIC = 43,                /* ASYMMETRIC  */
  YYSYMBOL_ATOMIC = 44,                    /* ATOMIC  */
  YYSYMBOL_AT = 45,                        /* AT  */
  YYSYMBOL_ATTACH = 46,                    /* ATTACH  */
  YYSYMBOL_ATTRIBUTE = 47,                 /* ATTRIBUTE  */
  YYSYMBOL_AUTHORIZATION = 48,             /* AUTHORIZATION  */
  YYSYMBOL_BACKWARD = 49,                  /* BACKWARD  */
  YYSYMBOL_BEFORE = 50,                    /* BEFORE  */
  YYSYMBOL_BEGIN_P = 51,                   /* BEGIN_P  */
  YYSYMBOL_BETWEEN = 52,                   /* BETWEEN  */
  YYSYMBOL_BIGINT = 53,                    /* BIGINT  */
  YYSYMBOL_BINARY = 54,                    /* BINARY  */
  YYSYMBOL_BIT = 55,                       /* BIT  */
  YYSYMBOL_BOOLEAN_P = 56,                 /* BOOLEAN_P  */
  YYSYMBOL_BOTH = 57,                      /* BOTH  */
  YYSYMBOL_BREADTH = 58,                   /* BREADTH  */
  YYSYMBOL_BY = 59,                        /* BY  */
  YYSYMBOL_CACHE = 60,                     /* CACHE  */
  YYSYMBOL_CALL = 61,                      /* CALL  */
  YYSYMBOL_CALLED = 62,                    /* CALLED  */
  YYSYMBOL_CASCADE = 63,                   /* CASCADE  */
  YYSYMBOL_CASCADED = 64,                  /* CASCADED  */
  YYSYMBOL_CASE = 65,                      /* CASE  */
  YYSYMBOL_CAST = 66,                      /* CAST  */
  YYSYMBOL_CATALOG_P = 67,                 /* CATALOG_P  */
  YYSYMBOL_CHAIN = 68,                     /* CHAIN  */
  YYSYMBOL_CHAR_P = 69,                    /* CHAR_P  */
  YYSYMBOL_CHARACTER = 70,                 /* CHARACTER  */
  YYSYMBOL_CHARACTERISTICS = 71,           /* CHARACTERISTICS  */
  YYSYMBOL_CHECK = 72,                     /* CHECK  */
  YYSYMBOL_CHECKPOINT = 73,                /* CHECKPOINT  */
  YYSYMBOL_CLASS = 74,                     /* CLASS  */
  YYSYMBOL_CLOSE = 75,                     /* CLOSE  */
  YYSYMBOL_CLUSTER = 76,                   /* CLUSTER  */
  YYSYMBOL_COALESCE = 77,                  /* COALESCE  */
  YYSYMBOL_COLLATE = 78,                   /* COLLATE  */
  YYSYMBOL_COLLATION = 79,                 /* COLLATION  */
  YYSYMBOL_COLUMN = 80,                    /* COLUMN  */
  YYSYMBOL_COLUMNS = 81,                   /* COLUMNS  */
  YYSYMBOL_COMMENT = 82,                   /* COMMENT  */
  YYSYMBOL_COMMENTS = 83,                  /* COMMENTS  */
  YYSYMBOL_COMMIT = 84,                    /* COMMIT  */
  YYSYMBOL_COMMITTED = 85,                 /* COMMITTED  */
  YYSYMBOL_COMPRESSION = 86,               /* COMPRESSION  */
  YYSYMBOL_CONCURRENTLY = 87,              /* CONCURRENTLY  */
  YYSYMBOL_CONDITIONAL = 88,               /* CONDITIONAL  */
  YYSYMBOL_CONFIGURATION = 89,             /* CONFIGURATION  */
  YYSYMBOL_CONFLICT = 90,                  /* CONFLICT  */
  YYSYMBOL_CONNECTION = 91,                /* CONNECTION  */
  YYSYMBOL_CONSTRAINT = 92,                /* CONSTRAINT  */
  YYSYMBOL_CONSTRAINTS = 93,               /* CONSTRAINTS  */
  YYSYMBOL_CONTENT_P = 94,                 /* CONTENT_P  */
  YYSYMBOL_CONTINUE_P = 95,                /* CONTINUE_P  */
  YYSYMBOL_CONVERSION_P = 96,              /* CONVERSION_P  */
  YYSYMBOL_COPY = 97,                      /* COPY  */
  YYSYMBOL_COST = 98,                      /* COST  */
  YYSYMBOL_CREATE = 99,                    /* CREATE  */
  YYSYMBOL_CROSS = 100,                    /* CROSS  */
  YYSYMBOL_CSV = 101,                      /* CSV  */
  YYSYMBOL_CUBE = 102,                     /* CUBE  */
  YYSYMBOL_CURRENT_P = 103,                /* CURRENT_P  */
  YYSYMBOL_CURRENT_CATALOG = 104,          /* CURRENT_CATALOG  */
  YYSYMBOL_CURRENT_DATE = 105,             /* CURRENT_DATE  */
  YYSYMBOL_CURRENT_ROLE = 106,             /* CURRENT_ROLE  */
  YYSYMBOL_CURRENT_SCHEMA = 107,           /* CURRENT_SCHEMA  */
  YYSYMBOL_CURRENT_TIME = 108,             /* CURRENT_TIME  */
  YYSYMBOL_CURRENT_TIMESTAMP = 109,        /* CURRENT_TIMESTAMP  */
  YYSYMBOL_CURRENT_USER = 110,             /* CURRENT_USER  */
  YYSYMBOL_CURSOR = 111,                   /* CURSOR  */
  YYSYMBOL_CYCLE = 112,                    /* CYCLE  */
  YYSYMBOL_DATA_P = 113,                   /* DATA_P  */
  YYSYMBOL_DATABASE = 114,                 /* DATABASE  */
  YYSYMBOL_DAY_P = 115,                    /* DAY_P  */
  YYSYMBOL_DEALLOCATE = 116,               /* DEALLOCATE  */
  YYSYMBOL_DEC = 117,                      /* DEC  */
  YYSYMBOL_DECIMAL_P = 118,                /* DECIMAL_P  */
  YYSYMBOL_DECLARE = 119,                  /* DECLARE  */
  YYSYMBOL_DEFAULT = 120,                  /* DEFAULT  */
  YYSYMBOL_DEFAULTS = 121,                 /* DEFAULTS  */
  YYSYMBOL_DEFERRABLE = 122,               /* DEFERRABLE  */
  YYSYMBOL_DEFERRED = 123,                 /* DEFERRED  */
  YYSYMBOL_DEFINER = 124,                  /* DEFINER  */
  YYSYMBOL_DELETE_P = 125,                 /* DELETE_P  */
  YYSYMBOL_DELIMITER = 126,                /* DELIMITER  */
  YYSYMBOL_DELIMITERS = 127,               /* DELIMITERS  */
  YYSYMBOL_DEPENDS = 128,                  /* DEPENDS  */
  YYSYMBOL_DEPTH = 129,                    /* DEPTH  */
  YYSYMBOL_DESC = 130,                     /* DESC  */
  YYSYMBOL_DETACH = 131,                   /* DETACH  */
  YYSYMBOL_DICTIONARY = 132,               /* DICTIONARY  */
  YYSYMBOL_DISABLE_P = 133,                /* DISABLE_P  */
  YYSYMBOL_DISCARD = 134,                  /* DISCARD  */
  YYSYMBOL_DISTINCT = 135,                 /* DISTINCT  */
  YYSYMBOL_DO = 136,                       /* DO  */
  YYSYMBOL_DOCUMENT_P = 137,               /* DOCUMENT_P  */
  YYSYMBOL_DOMAIN_P = 138,                 /* DOMAIN_P  */
  YYSYMBOL_DOUBLE_P = 139,                 /* DOUBLE_P  */
  YYSYMBOL_DROP = 140,                     /* DROP  */
  YYSYMBOL_EACH = 141,                     /* EACH  */
  YYSYMBOL_ELSE = 142,                     /* ELSE  */
  YYSYMBOL_EMPTY_P = 143,                  /* EMPTY_P  */
  YYSYMBOL_ENABLE_P = 144,                 /* ENABLE_P  */
  YYSYMBOL_ENCODING = 145,                 /* ENCODING  */
  YYSYMBOL_ENCRYPTED = 146,                /* ENCRYPTED  */
  YYSYMBOL_END_P = 147,                    /* END_P  */
  YYSYMBOL_ENFORCED = 148,                 /* ENFORCED  */
  YYSYMBOL_ENUM_P = 149,                   /* ENUM_P  */
  YYSYMBOL_ERROR_P = 150,                  /* ERROR_P  */
  YYSYMBOL_ESCAPE = 151,                   /* ESCAPE  */
  YYSYMBOL_EVENT = 152,                    /* EVENT  */
  YYSYMBOL_EXCEPT = 153,                   /* EXCEPT  */
  YYSYMBOL_EXCLUDE = 154,                  /* EXCLUDE  */
  YYSYMBOL_EXCLUDING = 155,                /* EXCLUDING  */
  YYSYMBOL_EXCLUSIVE = 156,                /* EXCLUSIVE  */
  YYSYMBOL_EXECUTE = 157,                  /* EXECUTE  */
  YYSYMBOL_EXISTS = 158,                   /* EXISTS  */
  YYSYMBOL_EXPLAIN = 159,                  /* EXPLAIN  */
  YYSYMBOL_EXPRESSION = 160,               /* EXPRESSION  */
  YYSYMBOL_EXTENSION = 161,                /* EXTENSION  */
  YYSYMBOL_EXTERNAL = 162,                 /* EXTERNAL  */
  YYSYMBOL_EXTRACT = 163,                  /* EXTRACT  */
  YYSYMBOL_FALSE_P = 164,                  /* FALSE_P  */
  YYSYMBOL_FAMILY = 165,                   /* FAMILY  */
  YYSYMBOL_FETCH = 166,                    /* FETCH  */
  YYSYMBOL_FILTER = 167,                   /* FILTER  */
  YYSYMBOL_FINALIZE = 168,                 /* FINALIZE  */
  YYSYMBOL_FIRST_P = 169,                  /* FIRST_P  */
  YYSYMBOL_FLOAT_P = 170,                  /* FLOAT_P  */
  YYSYMBOL_FOLLOWING = 171,                /* FOLLOWING  */
  YYSYMBOL_FOR = 172,                      /* FOR  */
  YYSYMBOL_FORCE = 173,                    /* FORCE  */
  YYSYMBOL_FOREIGN = 174,                  /* FOREIGN  */
  YYSYMBOL_FORMAT = 175,                   /* FORMAT  */
  YYSYMBOL_FORWARD = 176,                  /* FORWARD  */
  YYSYMBOL_FREEZE = 177,                   /* FREEZE  */
  YYSYMBOL_FROM = 178,                     /* FROM  */
  YYSYMBOL_FULL = 179,                     /* FULL  */
  YYSYMBOL_FUNCTION = 180,                 /* FUNCTION  */
  YYSYMBOL_FUNCTIONS = 181,                /* FUNCTIONS  */
  YYSYMBOL_GENERATED = 182,                /* GENERATED  */
  YYSYMBOL_GLOBAL = 183,                   /* GLOBAL  */
  YYSYMBOL_GRANT = 184,                    /* GRANT  */
  YYSYMBOL_GRANTED = 185,                  /* GRANTED  */
  YYSYMBOL_GREATEST = 186,                 /* GREATEST  */
  YYSYMBOL_GROUP_P = 187,                  /* GROUP_P  */
  YYSYMBOL_GROUPING = 188,                 /* GROUPING  */
  YYSYMBOL_GROUPS = 189,                   /* GROUPS  */
  YYSYMBOL_HANDLER = 190,                  /* HANDLER  */
  YYSYMBOL_HAVING = 191,                   /* HAVING  */
  YYSYMBOL_HEADER_P = 192,                 /* HEADER_P  */
  YYSYMBOL_HOLD = 193,                     /* HOLD  */
  YYSYMBOL_HOUR_P = 194,                   /* HOUR_P  */
  YYSYMBOL_IDENTITY_P = 195,               /* IDENTITY_P  */
  YYSYMBOL_IF_P = 196,                     /* IF_P  */
  YYSYMBOL_ILIKE = 197,                    /* ILIKE  */
  YYSYMBOL_IMMEDIATE = 198,                /* IMMEDIATE  */
  YYSYMBOL_IMMUTABLE = 199,                /* IMMUTABLE  */
  YYSYMBOL_IMPLICIT_P = 200,               /* IMPLICIT_P  */
  YYSYMBOL_IMPORT_P = 201,                 /* IMPORT_P  */
  YYSYMBOL_IN_P = 202,                     /* IN_P  */
  YYSYMBOL_INCLUDE = 203,                  /* INCLUDE  */
  YYSYMBOL_INCLUDING = 204,                /* INCLUDING  */
  YYSYMBOL_INCREMENT = 205,                /* INCREMENT  */
  YYSYMBOL_INDENT = 206,                   /* INDENT  */
  YYSYMBOL_INDEX = 207,                    /* INDEX  */
  YYSYMBOL_INDEXES = 208,                  /* INDEXES  */
  YYSYMBOL_INHERIT = 209,                  /* INHERIT  */
  YYSYMBOL_INHERITS = 210,                 /* INHERITS  */
  YYSYMBOL_INITIALLY = 211,                /* INITIALLY  */
  YYSYMBOL_INLINE_P = 212,                 /* INLINE_P  */
  YYSYMBOL_INNER_P = 213,                  /* INNER_P  */
  YYSYMBOL_INOUT = 214,                    /* INOUT  */
  YYSYMBOL_INPUT_P = 215,                  /* INPUT_P  */
  YYSYMBOL_INSENSITIVE = 216,              /* INSENSITIVE  */
  YYSYMBOL_INSERT = 217,                   /* INSERT  */
  YYSYMBOL_INSTEAD = 218,                  /* INSTEAD  */
  YYSYMBOL_INT_P = 219,                    /* INT_P  */
  YYSYMBOL_INTEGER = 220,                  /* INTEGER  */
  YYSYMBOL_INTERSECT = 221,                /* INTERSECT  */
  YYSYMBOL_INTERVAL = 222,                 /* INTERVAL  */
  YYSYMBOL_INTO = 223,                     /* INTO  */
  YYSYMBOL_INVOKER = 224,                  /* INVOKER  */
  YYSYMBOL_IS = 225,                       /* IS  */
  YYSYMBOL_ISNULL = 226,                   /* ISNULL  */
  YYSYMBOL_ISOLATION = 227,                /* ISOLATION  */
  YYSYMBOL_JOIN = 228,                     /* JOIN  */
  YYSYMBOL_JSON = 229,                     /* JSON  */
  YYSYMBOL_JSON_ARRAY = 230,               /* JSON_ARRAY  */
  YYSYMBOL_JSON_ARRAYAGG = 231,            /* JSON_ARRAYAGG  */
  YYSYMBOL_JSON_EXISTS = 232,              /* JSON_EXISTS  */
  YYSYMBOL_JSON_OBJECT = 233,              /* JSON_OBJECT  */
  YYSYMBOL_JSON_OBJECTAGG = 234,           /* JSON_OBJECTAGG  */
  YYSYMBOL_JSON_QUERY = 235,               /* JSON_QUERY  */
  YYSYMBOL_JSON_SCALAR = 236,              /* JSON_SCALAR  */
  YYSYMBOL_JSON_SERIALIZE = 237,           /* JSON_SERIALIZE  */
  YYSYMBOL_JSON_TABLE = 238,               /* JSON_TABLE  */
  YYSYMBOL_JSON_VALUE = 239,               /* JSON_VALUE  */
  YYSYMBOL_KEEP = 240,                     /* KEEP  */
  YYSYMBOL_KEY = 241,                      /* KEY  */
  YYSYMBOL_KEYS = 242,                     /* KEYS  */
  YYSYMBOL_LABEL = 243,                    /* LABEL  */
  YYSYMBOL_LANGUAGE = 244,                 /* LANGUAGE  */
  YYSYMBOL_LARGE_P = 245,                  /* LARGE_P  */
  YYSYMBOL_LAST_P = 246,                   /* LAST_P  */
  YYSYMBOL_LATERAL_P = 247,                /* LATERAL_P  */
  YYSYMBOL_LEADING = 248,                  /* LEADING  */
  YYSYMBOL_LEAKPROOF = 249,                /* LEAKPROOF  */
  YYSYMBOL_LEAST = 250,                    /* LEAST  */
  YYSYMBOL_LEFT = 251,                     /* LEFT  */
  YYSYMBOL_LEVEL = 252,                    /* LEVEL  */
  YYSYMBOL_LIKE = 253,                     /* LIKE  */
  YYSYMBOL_LIMIT = 254,                    /* LIMIT  */
  YYSYMBOL_LISTEN = 255,                   /* LISTEN  */
  YYSYMBOL_LOAD = 256,                     /* LOAD  */
  YYSYMBOL_LOCAL = 257,                    /* LOCAL  */
  YYSYMBOL_LOCALTIME = 258,                /* LOCALTIME  */
  YYSYMBOL_LOCALTIMESTAMP = 259,           /* LOCALTIMESTAMP  */
  YYSYMBOL_LOCATION = 260,                 /* LOCATION  */
  YYSYMBOL_LOCK_P = 261,                   /* LOCK_P  */
  YYSYMBOL_LOCKED = 262,                   /* LOCKED  */
  YYSYMBOL_LOGGED = 263,                   /* LOGGED  */
  YYSYMBOL_MAPPING = 264,                  /* MAPPING  */
  YYSYMBOL_MATCH = 265,                    /* MATCH  */
  YYSYMBOL_MATCHED = 266,                  /* MATCHED  */
  YYSYMBOL_MATERIALIZED = 267,             /* MATERIALIZED  */
  YYSYMBOL_MAXVALUE = 268,                 /* MAXVALUE  */
  YYSYMBOL_MERGE = 269,                    /* MERGE  */
  YYSYMBOL_MERGE_ACTION = 270,             /* MERGE_ACTION  */
  YYSYMBOL_METHOD = 271,                   /* METHOD  */
  YYSYMBOL_MINUTE_P = 272,                 /* MINUTE_P  */
  YYSYMBOL_MINVALUE = 273,                 /* MINVALUE  */
  YYSYMBOL_MODE = 274,                     /* MODE  */
  YYSYMBOL_MONTH_P = 275,                  /* MONTH_P  */
  YYSYMBOL_MOVE = 276,                     /* MOVE  */
  YYSYMBOL_NAME_P = 277,                   /* NAME_P  */
  YYSYMBOL_NAMES = 278,                    /* NAMES  */
  YYSYMBOL_NATIONAL = 279,                 /* NATIONAL  */
  YYSYMBOL_NATURAL = 280,                  /* NATURAL  */
  YYSYMBOL_NCHAR = 281,                    /* NCHAR  */
  YYSYMBOL_NESTED = 282,                   /* NESTED  */
  YYSYMBOL_NEW = 283,                      /* NEW  */
  YYSYMBOL_NEXT = 284,                     /* NEXT  */
  YYSYMBOL_NFC = 285,                      /* NFC  */
  YYSYMBOL_NFD = 286,                      /* NFD  */
  YYSYMBOL_NFKC = 287,                     /* NFKC  */
  YYSYMBOL_NFKD = 288,                     /* NFKD  */
  YYSYMBOL_NO = 289,                       /* NO  */
  YYSYMBOL_NONE = 290,                     /* NONE  */
  YYSYMBOL_NORMALIZE = 291,                /* NORMALIZE  */
  YYSYMBOL_NORMALIZED = 292,               /* NORMALIZED  */
  YYSYMBOL_NOT = 293,                      /* NOT  */
  YYSYMBOL_NOTHING = 294,                  /* NOTHING  */
  YYSYMBOL_NOTIFY = 295,                   /* NOTIFY  */
  YYSYMBOL_NOTNULL = 296,                  /* NOTNULL  */
  YYSYMBOL_NOWAIT = 297,                   /* NOWAIT  */
  YYSYMBOL_NULL_P = 298,                   /* NULL_P  */
  YYSYMBOL_NULLIF = 299,                   /* NULLIF  */
  YYSYMBOL_NULLS_P = 300,                  /* NULLS_P  */
  YYSYMBOL_NUMERIC = 301,                  /* NUMERIC  */
  YYSYMBOL_OBJECT_P = 302,                 /* OBJECT_P  */
  YYSYMBOL_OBJECTS_P = 303,                /* OBJECTS_P  */
  YYSYMBOL_OF = 304,                       /* OF  */
  YYSYMBOL_OFF = 305,                      /* OFF  */
  YYSYMBOL_OFFSET = 306,                   /* OFFSET  */
  YYSYMBOL_OIDS = 307,                     /* OIDS  */
  YYSYMBOL_OLD = 308,                      /* OLD  */
  YYSYMBOL_OMIT = 309,                     /* OMIT  */
  YYSYMBOL_ON = 310,                       /* ON  */
  YYSYMBOL_ONLY = 311,                     /* ONLY  */
  YYSYMBOL_OPERATOR = 312,                 /* OPERATOR  */
  YYSYMBOL_OPTION = 313,                   /* OPTION  */
  YYSYMBOL_OPTIONS = 314,                  /* OPTIONS  */
  YYSYMBOL_OR = 315,                       /* OR  */
  YYSYMBOL_ORDER = 316,                    /* ORDER  */
  YYSYMBOL_ORDINALITY = 317,               /* ORDINALITY  */
  YYSYMBOL_OTHERS = 318,                   /* OTHERS  */
  YYSYMBOL_OUT_P = 319,                    /* OUT_P  */
  YYSYMBOL_OUTER_P = 320,                  /* OUTER_P  */
  YYSYMBOL_OVER = 321,                     /* OVER  */
  YYSYMBOL_OVERLAPS = 322,                 /* OVERLAPS  */
  YYSYMBOL_OVERLAY = 323,                  /* OVERLAY  */
  YYSYMBOL_OVERRIDING = 324,               /* OVERRIDING  */
  YYSYMBOL_OWNED = 325,                    /* OWNED  */
  YYSYMBOL_OWNER = 326,                    /* OWNER  */
  YYSYMBOL_PARALLEL = 327,                 /* PARALLEL  */
  YYSYMBOL_PARAMETER = 328,                /* PARAMETER  */
  YYSYMBOL_PARSER = 329,                   /* PARSER  */
  YYSYMBOL_PARTIAL = 330,                  /* PARTIAL  */
  YYSYMBOL_PARTITION = 331,                /* PARTITION  */
  YYSYMBOL_PASSING = 332,                  /* PASSING  */
  YYSYMBOL_PASSWORD = 333,                 /* PASSWORD  */
  YYSYMBOL_PATH = 334,                     /* PATH  */
  YYSYMBOL_PERIOD = 335,                   /* PERIOD  */
  YYSYMBOL_PLACING = 336,                  /* PLACING  */
  YYSYMBOL_PLAN = 337,                     /* PLAN  */
  YYSYMBOL_PLANS = 338,                    /* PLANS  */
  YYSYMBOL_POLICY = 339,                   /* POLICY  */
  YYSYMBOL_POSITION = 340,                 /* POSITION  */
  YYSYMBOL_PRECEDING = 341,                /* PRECEDING  */
  YYSYMBOL_PRECISION = 342,                /* PRECISION  */
  YYSYMBOL_PRESERVE = 343,                 /* PRESERVE  */
  YYSYMBOL_PREPARE = 344,                  /* PREPARE  */
  YYSYMBOL_PREPARED = 345,                 /* PREPARED  */
  YYSYMBOL_PRIMARY = 346,                  /* PRIMARY  */
  YYSYMBOL_PRIOR = 347,                    /* PRIOR  */
  YYSYMBOL_PRIVILEGES = 348,               /* PRIVILEGES  */
  YYSYMBOL_PROCEDURAL = 349,               /* PROCEDURAL  */
  YYSYMBOL_PROCEDURE = 350,                /* PROCEDURE  */
  YYSYMBOL_PROCEDURES = 351,               /* PROCEDURES  */
  YYSYMBOL_PROGRAM = 352,                  /* PROGRAM  */
  YYSYMBOL_PUBLICATION = 353,              /* PUBLICATION  */
  YYSYMBOL_QUOTE = 354,                    /* QUOTE  */
  YYSYMBOL_QUOTES = 355,                   /* QUOTES  */
  YYSYMBOL_RANGE = 356,                    /* RANGE  */
  YYSYMBOL_READ = 357,                     /* READ  */
  YYSYMBOL_REAL = 358,                     /* REAL  */
  YYSYMBOL_REASSIGN = 359,                 /* REASSIGN  */
  YYSYMBOL_RECURSIVE = 360,                /* RECURSIVE  */
  YYSYMBOL_REF_P = 361,                    /* REF_P  */
  YYSYMBOL_REFERENCES = 362,               /* REFERENCES  */
  YYSYMBOL_REFERENCING = 363,              /* REFERENCING  */
  YYSYMBOL_REFRESH = 364,                  /* REFRESH  */
  YYSYMBOL_REINDEX = 365,                  /* REINDEX  */
  YYSYMBOL_RELATIVE_P = 366,               /* RELATIVE_P  */
  YYSYMBOL_RELEASE = 367,                  /* RELEASE  */
  YYSYMBOL_RENAME = 368,                   /* RENAME  */
  YYSYMBOL_REPEATABLE = 369,               /* REPEATABLE  */
  YYSYMBOL_REPLACE = 370,                  /* REPLACE  */
  YYSYMBOL_REPLICA = 371,                  /* REPLICA  */
  YYSYMBOL_RESET = 372,                    /* RESET  */
  YYSYMBOL_RESTART = 373,                  /* RESTART  */
  YYSYMBOL_RESTRICT = 374,                 /* RESTRICT  */
  YYSYMBOL_RETURN = 375,                   /* RETURN  */
  YYSYMBOL_RETURNING = 376,                /* RETURNING  */
  YYSYMBOL_RETURNS = 377,                  /* RETURNS  */
  YYSYMBOL_REVOKE = 378,                   /* REVOKE  */
  YYSYMBOL_RIGHT = 379,                    /* RIGHT  */
  YYSYMBOL_ROLE = 380,                     /* ROLE  */
  YYSYMBOL_ROLLBACK = 381,                 /* ROLLBACK  */
  YYSYMBOL_ROLLUP = 382,                   /* ROLLUP  */
  YYSYMBOL_ROUTINE = 383,                  /* ROUTINE  */
  YYSYMBOL_ROUTINES = 384,                 /* ROUTINES  */
  YYSYMBOL_ROW = 385,                      /* ROW  */
  YYSYMBOL_ROWS = 386,                     /* ROWS  */
  YYSYMBOL_RULE = 387,                     /* RULE  */
  YYSYMBOL_SAVEPOINT = 388,                /* SAVEPOINT  */
  YYSYMBOL_SCALAR = 389,                   /* SCALAR  */
  YYSYMBOL_SCHEMA = 390,                   /* SCHEMA  */
  YYSYMBOL_SCHEMAS = 391,                  /* SCHEMAS  */
  YYSYMBOL_SCROLL = 392,                   /* SCROLL  */
  YYSYMBOL_SEARCH = 393,                   /* SEARCH  */
  YYSYMBOL_SECOND_P = 394,                 /* SECOND_P  */
  YYSYMBOL_SECURITY = 395,                 /* SECURITY  */
  YYSYMBOL_SELECT = 396,                   /* SELECT  */
  YYSYMBOL_SEQUENCE = 397,                 /* SEQUENCE  */
  YYSYMBOL_SEQUENCES = 398,                /* SEQUENCES  */
  YYSYMBOL_SERIALIZABLE = 399,             /* SERIALIZABLE  */
  YYSYMBOL_SERVER = 400,                   /* SERVER  */
  YYSYMBOL_SESSION = 401,                  /* SESSION  */
  YYSYMBOL_SESSION_USER = 402,             /* SESSION_USER  */
  YYSYMBOL_SET = 403,                      /* SET  */
  YYSYMBOL_SETS = 404,                     /* SETS  */
  YYSYMBOL_SETOF = 405,                    /* SETOF  */
  YYSYMBOL_SHARE = 406,                    /* SHARE  */
  YYSYMBOL_SHOW = 407,                     /* SHOW  */
  YYSYMBOL_SIMILAR = 408,                  /* SIMILAR  */
  YYSYMBOL_SIMPLE = 409,                   /* SIMPLE  */
  YYSYMBOL_SKIP = 410,                     /* SKIP  */
  YYSYMBOL_SMALLINT = 411,                 /* SMALLINT  */
  YYSYMBOL_SNAPSHOT = 412,                 /* SNAPSHOT  */
  YYSYMBOL_SOME = 413,                     /* SOME  */
  YYSYMBOL_SOURCE = 414,                   /* SOURCE  */
  YYSYMBOL_SQL_P = 415,                    /* SQL_P  */
  YYSYMBOL_STABLE = 416,                   /* STABLE  */
  YYSYMBOL_STANDALONE_P = 417,             /* STANDALONE_P  */
  YYSYMBOL_START = 418,                    /* START  */
  YYSYMBOL_STATEMENT = 419,                /* STATEMENT  */
  YYSYMBOL_STATISTICS = 420,               /* STATISTICS  */
  YYSYMBOL_STDIN = 421,                    /* STDIN  */
  YYSYMBOL_STDOUT = 422,                   /* STDOUT  */
  YYSYMBOL_STORAGE = 423,                  /* STORAGE  */
  YYSYMBOL_STORED = 424,                   /* STORED  */
  YYSYMBOL_STRICT_P = 425,                 /* STRICT_P  */
  YYSYMBOL_STRING_P = 426,                 /* STRING_P  */
  YYSYMBOL_STRIP_P = 427,                  /* STRIP_P  */
  YYSYMBOL_SUBSCRIPTION = 428,             /* SUBSCRIPTION  */
  YYSYMBOL_SUBSTRING = 429,                /* SUBSTRING  */
  YYSYMBOL_SUPPORT = 430,                  /* SUPPORT  */
  YYSYMBOL_SYMMETRIC = 431,                /* SYMMETRIC  */
  YYSYMBOL_SYSID = 432,                    /* SYSID  */
  YYSYMBOL_SYSTEM_P = 433,                 /* SYSTEM_P  */
  YYSYMBOL_SYSTEM_USER = 434,              /* SYSTEM_USER  */
  YYSYMBOL_TABLE = 435,                    /* TABLE  */
  YYSYMBOL_TABLES = 436,                   /* TABLES  */
  YYSYMBOL_TABLESAMPLE = 437,              /* TABLESAMPLE  */
  YYSYMBOL_TABLESPACE = 438,               /* TABLESPACE  */
  YYSYMBOL_TARGET = 439,                   /* TARGET  */
  YYSYMBOL_TEMP = 440,                     /* TEMP  */
  YYSYMBOL_TEMPLATE = 441,                 /* TEMPLATE  */
  YYSYMBOL_TEMPORARY = 442,                /* TEMPORARY  */
  YYSYMBOL_TEXT_P = 443,                   /* TEXT_P  */
  YYSYMBOL_THEN = 444,                     /* THEN  */
  YYSYMBOL_TIES = 445,                     /* TIES  */
  YYSYMBOL_TIME = 446,                     /* TIME  */
  YYSYMBOL_TIMESTAMP = 447,                /* TIMESTAMP  */
  YYSYMBOL_TO = 448,                       /* TO  */
  YYSYMBOL_TRAILING = 449,                 /* TRAILING  */
  YYSYMBOL_TRANSACTION = 450,              /* TRANSACTION  */
  YYSYMBOL_TRANSFORM = 451,                /* TRANSFORM  */
  YYSYMBOL_TREAT = 452,                    /* TREAT  */
  YYSYMBOL_TRIGGER = 453,                  /* TRIGGER  */
  YYSYMBOL_TRIM = 454,                     /* TRIM  */
  YYSYMBOL_TRUE_P = 455,                   /* TRUE_P  */
  YYSYMBOL_TRUNCATE = 456,                 /* TRUNCATE  */
  YYSYMBOL_TRUSTED = 457,                  /* TRUSTED  */
  YYSYMBOL_TYPE_P = 458,                   /* TYPE_P  */
  YYSYMBOL_TYPES_P = 459,                  /* TYPES_P  */
  YYSYMBOL_UESCAPE = 460,                  /* UESCAPE  */
  YYSYMBOL_UNBOUNDED = 461,                /* UNBOUNDED  */
  YYSYMBOL_UNCONDITIONAL = 462,            /* UNCONDITIONAL  */
  YYSYMBOL_UNCOMMITTED = 463,              /* UNCOMMITTED  */
  YYSYMBOL_UNENCRYPTED = 464,              /* UNENCRYPTED  */
  YYSYMBOL_UNION = 465,                    /* UNION  */
  YYSYMBOL_UNIQUE = 466,                   /* UNIQUE  */
  YYSYMBOL_UNKNOWN = 467,                  /* UNKNOWN  */
  YYSYMBOL_UNLISTEN = 468,                 /* UNLISTEN  */
  YYSYMBOL_UNLOGGED = 469,                 /* UNLOGGED  */
  YYSYMBOL_UNTIL = 470,                    /* UNTIL  */
  YYSYMBOL_UPDATE = 471,                   /* UPDATE  */
  YYSYMBOL_USER = 472,                     /* USER  */
  YYSYMBOL_USING = 473,                    /* USING  */
  YYSYMBOL_VACUUM = 474,                   /* VACUUM  */
  YYSYMBOL_VALID = 475,                    /* VALID  */
  YYSYMBOL_VALIDATE = 476,                 /* VALIDATE  */
  YYSYMBOL_VALIDATOR = 477,                /* VALIDATOR  */
  YYSYMBOL_VALUE_P = 478,                  /* VALUE_P  */
  YYSYMBOL_VALUES = 479,                   /* VALUES  */
  YYSYMBOL_VARCHAR = 480,                  /* VARCHAR  */
  YYSYMBOL_VARIADIC = 481,                 /* VARIADIC  */
  YYSYMBOL_VARYING = 482,                  /* VARYING  */
  YYSYMBOL_VERBOSE = 483,                  /* VERBOSE  */
  YYSYMBOL_VERSION_P = 484,                /* VERSION_P  */
  YYSYMBOL_VIEW = 485,                     /* VIEW  */
  YYSYMBOL_VIEWS = 486,                    /* VIEWS  */
  YYSYMBOL_VIRTUAL = 487,                  /* VIRTUAL  */
  YYSYMBOL_VOLATILE = 488,                 /* VOLATILE  */
  YYSYMBOL_WHEN = 489,                     /* WHEN  */
  YYSYMBOL_WHERE = 490,                    /* WHERE  */
  YYSYMBOL_WHITESPACE_P = 491,             /* WHITESPACE_P  */
  YYSYMBOL_WINDOW = 492,                   /* WINDOW  */
  YYSYMBOL_WITH = 493,                     /* WITH  */
  YYSYMBOL_WITHIN = 494,                   /* WITHIN  */
  YYSYMBOL_WITHOUT = 495,                  /* WITHOUT  */
  YYSYMBOL_WORK = 496,                     /* WORK  */
  YYSYMBOL_WRAPPER = 497,                  /* WRAPPER  */
  YYSYMBOL_WRITE = 498,                    /* WRITE  */
  YYSYMBOL_XML_P = 499,                    /* XML_P  */
  YYSYMBOL_XMLATTRIBUTES = 500,            /* XMLATTRIBUTES  */
  YYSYMBOL_XMLCONCAT = 501,                /* XMLCONCAT  */
  YYSYMBOL_XMLELEMENT = 502,               /* XMLELEMENT  */
  YYSYMBOL_XMLEXISTS = 503,                /* XMLEXISTS  */
  YYSYMBOL_XMLFOREST = 504,                /* XMLFOREST  */
  YYSYMBOL_XMLNAMESPACES = 505,            /* XMLNAMESPACES  */
  YYSYMBOL_XMLPARSE = 506,                 /* XMLPARSE  */
  YYSYMBOL_XMLPI = 507,                    /* XMLPI  */
  YYSYMBOL_XMLROOT = 508,                  /* XMLROOT  */
  YYSYMBOL_XMLSERIALIZE = 509,             /* XMLSERIALIZE  */
  YYSYMBOL_XMLTABLE = 510,                 /* XMLTABLE  */
  YYSYMBOL_YEAR_P = 511,                   /* YEAR_P  */
  YYSYMBOL_YES_P = 512,                    /* YES_P  */
  YYSYMBOL_ZONE = 513,                     /* ZONE  */
  YYSYMBOL_FORMAT_LA = 514,                /* FORMAT_LA  */
  YYSYMBOL_NOT_LA = 515,                   /* NOT_LA  */
  YYSYMBOL_NULLS_LA = 516,                 /* NULLS_LA  */
  YYSYMBOL_WITH_LA = 517,                  /* WITH_LA  */
  YYSYMBOL_WITHOUT_LA = 518,               /* WITHOUT_LA  */
  YYSYMBOL_MODE_TYPE_NAME = 519,           /* MODE_TYPE_NAME  */
  YYSYMBOL_MODE_PLPGSQL_EXPR = 520,        /* MODE_PLPGSQL_EXPR  */
  YYSYMBOL_MODE_PLPGSQL_ASSIGN1 = 521,     /* MODE_PLPGSQL_ASSIGN1  */
  YYSYMBOL_MODE_PLPGSQL_ASSIGN2 = 522,     /* MODE_PLPGSQL_ASSIGN2  */
  YYSYMBOL_MODE_PLPGSQL_ASSIGN3 = 523,     /* MODE_PLPGSQL_ASSIGN3  */
  YYSYMBOL_524_ = 524,                     /* '<'  */
  YYSYMBOL_525_ = 525,                     /* '>'  */
  YYSYMBOL_526_ = 526,                     /* '='  */
  YYSYMBOL_527_ = 527,                     /* '+'  */
  YYSYMBOL_528_ = 528,                     /* '-'  */
  YYSYMBOL_529_ = 529,                     /* '*'  */
  YYSYMBOL_530_ = 530,                     /* '/'  */
  YYSYMBOL_531_ = 531,                     /* '%'  */
  YYSYMBOL_532_ = 532,                     /* '^'  */
  YYSYMBOL_UMINUS = 533,                   /* UMINUS  */
  YYSYMBOL_534_ = 534,                     /* '['  */
  YYSYMBOL_535_ = 535,                     /* ']'  */
  YYSYMBOL_536_ = 536,                     /* '('  */
  YYSYMBOL_537_ = 537,                     /* ')'  */
  YYSYMBOL_538_ = 538,                     /* '.'  */
  YYSYMBOL_539_ = 539,                     /* ';'  */
  YYSYMBOL_540_ = 540,                     /* ','  */
  YYSYMBOL_541_ = 541,                     /* ':'  */
  YYSYMBOL_YYACCEPT = 542,                 /* $accept  */
  YYSYMBOL_parse_toplevel = 543,           /* parse_toplevel  */
  YYSYMBOL_stmtmulti = 544,                /* stmtmulti  */
  YYSYMBOL_toplevel_stmt = 545,            /* toplevel_stmt  */
  YYSYMBOL_stmt = 546,                     /* stmt  */
  YYSYMBOL_opt_single_name = 547,          /* opt_single_name  */
  YYSYMBOL_opt_qualified_name = 548,       /* opt_qualified_name  */
  YYSYMBOL_opt_concurrently = 549,         /* opt_concurrently  */
  YYSYMBOL_opt_drop_behavior = 550,        /* opt_drop_behavior  */
  YYSYMBOL_CallStmt = 551,                 /* CallStmt  */
  YYSYMBOL_CreateRoleStmt = 552,           /* CreateRoleStmt  */
  YYSYMBOL_opt_with = 553,                 /* opt_with  */
  YYSYMBOL_OptRoleList = 554,              /* OptRoleList  */
  YYSYMBOL_AlterOptRoleList = 555,         /* AlterOptRoleList  */
  YYSYMBOL_AlterOptRoleElem = 556,         /* AlterOptRoleElem  */
  YYSYMBOL_CreateOptRoleElem = 557,        /* CreateOptRoleElem  */
  YYSYMBOL_CreateUserStmt = 558,           /* CreateUserStmt  */
  YYSYMBOL_AlterRoleStmt = 559,            /* AlterRoleStmt  */
  YYSYMBOL_opt_in_database = 560,          /* opt_in_database  */
  YYSYMBOL_AlterRoleSetStmt = 561,         /* AlterRoleSetStmt  */
  YYSYMBOL_DropRoleStmt = 562,             /* DropRoleStmt  */
  YYSYMBOL_CreateGroupStmt = 563,          /* CreateGroupStmt  */
  YYSYMBOL_AlterGroupStmt = 564,           /* AlterGroupStmt  */
  YYSYMBOL_add_drop = 565,                 /* add_drop  */
  YYSYMBOL_CreateSchemaStmt = 566,         /* CreateSchemaStmt  */
  YYSYMBOL_OptSchemaEltList = 567,         /* OptSchemaEltList  */
  YYSYMBOL_schema_stmt = 568,              /* schema_stmt  */
  YYSYMBOL_VariableSetStmt = 569,          /* VariableSetStmt  */
  YYSYMBOL_set_rest = 570,                 /* set_rest  */
  YYSYMBOL_generic_set = 571,              /* generic_set  */
  YYSYMBOL_set_rest_more = 572,            /* set_rest_more  */
  YYSYMBOL_var_name = 573,                 /* var_name  */
  YYSYMBOL_var_list = 574,                 /* var_list  */
  YYSYMBOL_var_value = 575,                /* var_value  */
  YYSYMBOL_iso_level = 576,                /* iso_level  */
  YYSYMBOL_opt_boolean_or_string = 577,    /* opt_boolean_or_string  */
  YYSYMBOL_zone_value = 578,               /* zone_value  */
  YYSYMBOL_opt_encoding = 579,             /* opt_encoding  */
  YYSYMBOL_NonReservedWord_or_Sconst = 580, /* NonReservedWord_or_Sconst  */
  YYSYMBOL_VariableResetStmt = 581,        /* VariableResetStmt  */
  YYSYMBOL_reset_rest = 582,               /* reset_rest  */
  YYSYMBOL_generic_reset = 583,            /* generic_reset  */
  YYSYMBOL_SetResetClause = 584,           /* SetResetClause  */
  YYSYMBOL_FunctionSetResetClause = 585,   /* FunctionSetResetClause  */
  YYSYMBOL_VariableShowStmt = 586,         /* VariableShowStmt  */
  YYSYMBOL_ConstraintsSetStmt = 587,       /* ConstraintsSetStmt  */
  YYSYMBOL_constraints_set_list = 588,     /* constraints_set_list  */
  YYSYMBOL_constraints_set_mode = 589,     /* constraints_set_mode  */
  YYSYMBOL_CheckPointStmt = 590,           /* CheckPointStmt  */
  YYSYMBOL_DiscardStmt = 591,              /* DiscardStmt  */
  YYSYMBOL_AlterTableStmt = 592,           /* AlterTableStmt  */
  YYSYMBOL_alter_table_cmds = 593,         /* alter_table_cmds  */
  YYSYMBOL_partition_cmd = 594,            /* partition_cmd  */
  YYSYMBOL_index_partition_cmd = 595,      /* index_partition_cmd  */
  YYSYMBOL_alter_table_cmd = 596,          /* alter_table_cmd  */
  YYSYMBOL_alter_column_default = 597,     /* alter_column_default  */
  YYSYMBOL_opt_collate_clause = 598,       /* opt_collate_clause  */
  YYSYMBOL_alter_using = 599,              /* alter_using  */
  YYSYMBOL_replica_identity = 600,         /* replica_identity  */
  YYSYMBOL_reloptions = 601,               /* reloptions  */
  YYSYMBOL_opt_reloptions = 602,           /* opt_reloptions  */
  YYSYMBOL_reloption_list = 603,           /* reloption_list  */
  YYSYMBOL_reloption_elem = 604,           /* reloption_elem  */
  YYSYMBOL_alter_identity_column_option_list = 605, /* alter_identity_column_option_list  */
  YYSYMBOL_alter_identity_column_option = 606, /* alter_identity_column_option  */
  YYSYMBOL_set_statistics_value = 607,     /* set_statistics_value  */
  YYSYMBOL_set_access_method_name = 608,   /* set_access_method_name  */
  YYSYMBOL_PartitionBoundSpec = 609,       /* PartitionBoundSpec  */
  YYSYMBOL_hash_partbound_elem = 610,      /* hash_partbound_elem  */
  YYSYMBOL_hash_partbound = 611,           /* hash_partbound  */
  YYSYMBOL_AlterCompositeTypeStmt = 612,   /* AlterCompositeTypeStmt  */
  YYSYMBOL_alter_type_cmds = 613,          /* alter_type_cmds  */
  YYSYMBOL_alter_type_cmd = 614,           /* alter_type_cmd  */
  YYSYMBOL_ClosePortalStmt = 615,          /* ClosePortalStmt  */
  YYSYMBOL_CopyStmt = 616,                 /* CopyStmt  */
  YYSYMBOL_copy_from = 617,                /* copy_from  */
  YYSYMBOL_opt_program = 618,              /* opt_program  */
  YYSYMBOL_copy_file_name = 619,           /* copy_file_name  */
  YYSYMBOL_copy_options = 620,             /* copy_options  */
  YYSYMBOL_copy_opt_list = 621,            /* copy_opt_list  */
  YYSYMBOL_copy_opt_item = 622,            /* copy_opt_item  */
  YYSYMBOL_opt_binary = 623,               /* opt_binary  */
  YYSYMBOL_copy_delimiter = 624,           /* copy_delimiter  */
  YYSYMBOL_opt_using = 625,                /* opt_using  */
  YYSYMBOL_copy_generic_opt_list = 626,    /* copy_generic_opt_list  */
  YYSYMBOL_copy_generic_opt_elem = 627,    /* copy_generic_opt_elem  */
  YYSYMBOL_copy_generic_opt_arg = 628,     /* copy_generic_opt_arg  */
  YYSYMBOL_copy_generic_opt_arg_list = 629, /* copy_generic_opt_arg_list  */
  YYSYMBOL_copy_generic_opt_arg_list_item = 630, /* copy_generic_opt_arg_list_item  */
  YYSYMBOL_CreateStmt = 631,               /* CreateStmt  */
  YYSYMBOL_OptTemp = 632,                  /* OptTemp  */
  YYSYMBOL_OptTableElementList = 633,      /* OptTableElementList  */
  YYSYMBOL_OptTypedTableElementList = 634, /* OptTypedTableElementList  */
  YYSYMBOL_TableElementList = 635,         /* TableElementList  */
  YYSYMBOL_TypedTableElementList = 636,    /* TypedTableElementList  */
  YYSYMBOL_TableElement = 637,             /* TableElement  */
  YYSYMBOL_TypedTableElement = 638,        /* TypedTableElement  */
  YYSYMBOL_columnDef = 639,                /* columnDef  */
  YYSYMBOL_columnOptions = 640,            /* columnOptions  */
  YYSYMBOL_column_compression = 641,       /* column_compression  */
  YYSYMBOL_opt_column_compression = 642,   /* opt_column_compression  */
  YYSYMBOL_column_storage = 643,           /* column_storage  */
  YYSYMBOL_opt_column_storage = 644,       /* opt_column_storage  */
  YYSYMBOL_ColQualList = 645,              /* ColQualList  */
  YYSYMBOL_ColConstraint = 646,            /* ColConstraint  */
  YYSYMBOL_ColConstraintElem = 647,        /* ColConstraintElem  */
  YYSYMBOL_opt_unique_null_treatment = 648, /* opt_unique_null_treatment  */
  YYSYMBOL_generated_when = 649,           /* generated_when  */
  YYSYMBOL_opt_virtual_or_stored = 650,    /* opt_virtual_or_stored  */
  YYSYMBOL_ConstraintAttr = 651,           /* ConstraintAttr  */
  YYSYMBOL_TableLikeClause = 652,          /* TableLikeClause  */
  YYSYMBOL_TableLikeOptionList = 653,      /* TableLikeOptionList  */
  YYSYMBOL_TableLikeOption = 654,          /* TableLikeOption  */
  YYSYMBOL_TableConstraint = 655,          /* TableConstraint  */
  YYSYMBOL_ConstraintElem = 656,           /* ConstraintElem  */
  YYSYMBOL_DomainConstraint = 657,         /* DomainConstraint  */
  YYSYMBOL_DomainConstraintElem = 658,     /* DomainConstraintElem  */
  YYSYMBOL_opt_no_inherit = 659,           /* opt_no_inherit  */
  YYSYMBOL_opt_without_overlaps = 660,     /* opt_without_overlaps  */
  YYSYMBOL_opt_column_list = 661,          /* opt_column_list  */
  YYSYMBOL_columnList = 662,               /* columnList  */
  YYSYMBOL_optionalPeriodName = 663,       /* optionalPeriodName  */
  YYSYMBOL_opt_column_and_period_list = 664, /* opt_column_and_period_list  */
  YYSYMBOL_columnElem = 665,               /* columnElem  */
  YYSYMBOL_opt_c_include = 666,            /* opt_c_include  */
  YYSYMBOL_key_match = 667,                /* key_match  */
  YYSYMBOL_ExclusionConstraintList = 668,  /* ExclusionConstraintList  */
  YYSYMBOL_ExclusionConstraintElem = 669,  /* ExclusionConstraintElem  */
  YYSYMBOL_OptWhereClause = 670,           /* OptWhereClause  */
  YYSYMBOL_key_actions = 671,              /* key_actions  */
  YYSYMBOL_key_update = 672,               /* key_update  */
  YYSYMBOL_key_delete = 673,               /* key_delete  */
  YYSYMBOL_key_action = 674,               /* key_action  */
  YYSYMBOL_OptInherit = 675,               /* OptInherit  */
  YYSYMBOL_OptPartitionSpec = 676,         /* OptPartitionSpec  */
  YYSYMBOL_PartitionSpec = 677,            /* PartitionSpec  */
  YYSYMBOL_part_params = 678,              /* part_params  */
  YYSYMBOL_part_elem = 679,                /* part_elem  */
  YYSYMBOL_table_access_method_clause = 680, /* table_access_method_clause  */
  YYSYMBOL_OptWith = 681,                  /* OptWith  */
  YYSYMBOL_OnCommitOption = 682,           /* OnCommitOption  */
  YYSYMBOL_OptTableSpace = 683,            /* OptTableSpace  */
  YYSYMBOL_OptConsTableSpace = 684,        /* OptConsTableSpace  */
  YYSYMBOL_ExistingIndex = 685,            /* ExistingIndex  */
  YYSYMBOL_CreateStatsStmt = 686,          /* CreateStatsStmt  */
  YYSYMBOL_stats_params = 687,             /* stats_params  */
  YYSYMBOL_stats_param = 688,              /* stats_param  */
  YYSYMBOL_AlterStatsStmt = 689,           /* AlterStatsStmt  */
  YYSYMBOL_CreateAsStmt = 690,             /* CreateAsStmt  */
  YYSYMBOL_create_as_target = 691,         /* create_as_target  */
  YYSYMBOL_opt_with_data = 692,            /* opt_with_data  */
  YYSYMBOL_CreateMatViewStmt = 693,        /* CreateMatViewStmt  */
  YYSYMBOL_create_mv_target = 694,         /* create_mv_target  */
  YYSYMBOL_OptNoLog = 695,                 /* OptNoLog  */
  YYSYMBOL_RefreshMatViewStmt = 696,       /* RefreshMatViewStmt  */
  YYSYMBOL_CreateSeqStmt = 697,            /* CreateSeqStmt  */
  YYSYMBOL_AlterSeqStmt = 698,             /* AlterSeqStmt  */
  YYSYMBOL_OptSeqOptList = 699,            /* OptSeqOptList  */
  YYSYMBOL_OptParenthesizedSeqOptList = 700, /* OptParenthesizedSeqOptList  */
  YYSYMBOL_SeqOptList = 701,               /* SeqOptList  */
  YYSYMBOL_SeqOptElem = 702,               /* SeqOptElem  */
  YYSYMBOL_opt_by = 703,                   /* opt_by  */
  YYSYMBOL_NumericOnly = 704,              /* NumericOnly  */
  YYSYMBOL_NumericOnly_list = 705,         /* NumericOnly_list  */
  YYSYMBOL_CreatePLangStmt = 706,          /* CreatePLangStmt  */
  YYSYMBOL_opt_trusted = 707,              /* opt_trusted  */
  YYSYMBOL_handler_name = 708,             /* handler_name  */
  YYSYMBOL_opt_inline_handler = 709,       /* opt_inline_handler  */
  YYSYMBOL_validator_clause = 710,         /* validator_clause  */
  YYSYMBOL_opt_validator = 711,            /* opt_validator  */
  YYSYMBOL_opt_procedural = 712,           /* opt_procedural  */
  YYSYMBOL_CreateTableSpaceStmt = 713,     /* CreateTableSpaceStmt  */
  YYSYMBOL_OptTableSpaceOwner = 714,       /* OptTableSpaceOwner  */
  YYSYMBOL_DropTableSpaceStmt = 715,       /* DropTableSpaceStmt  */
  YYSYMBOL_CreateExtensionStmt = 716,      /* CreateExtensionStmt  */
  YYSYMBOL_create_extension_opt_list = 717, /* create_extension_opt_list  */
  YYSYMBOL_create_extension_opt_item = 718, /* create_extension_opt_item  */
  YYSYMBOL_AlterExtensionStmt = 719,       /* AlterExtensionStmt  */
  YYSYMBOL_alter_extension_opt_list = 720, /* alter_extension_opt_list  */
  YYSYMBOL_alter_extension_opt_item = 721, /* alter_extension_opt_item  */
  YYSYMBOL_AlterExtensionContentsStmt = 722, /* AlterExtensionContentsStmt  */
  YYSYMBOL_CreateFdwStmt = 723,            /* CreateFdwStmt  */
  YYSYMBOL_fdw_option = 724,               /* fdw_option  */
  YYSYMBOL_fdw_options = 725,              /* fdw_options  */
  YYSYMBOL_opt_fdw_options = 726,          /* opt_fdw_options  */
  YYSYMBOL_AlterFdwStmt = 727,             /* AlterFdwStmt  */
  YYSYMBOL_create_generic_options = 728,   /* create_generic_options  */
  YYSYMBOL_generic_option_list = 729,      /* generic_option_list  */
  YYSYMBOL_alter_generic_options = 730,    /* alter_generic_options  */
  YYSYMBOL_alter_generic_option_list = 731, /* alter_generic_option_list  */
  YYSYMBOL_alter_generic_option_elem = 732, /* alter_generic_option_elem  */
  YYSYMBOL_generic_option_elem = 733,      /* generic_option_elem  */
  YYSYMBOL_generic_option_name = 734,      /* generic_option_name  */
  YYSYMBOL_generic_option_arg = 735,       /* generic_option_arg  */
  YYSYMBOL_CreateForeignServerStmt = 736,  /* CreateForeignServerStmt  */
  YYSYMBOL_opt_type = 737,                 /* opt_type  */
  YYSYMBOL_foreign_server_version = 738,   /* foreign_server_version  */
  YYSYMBOL_opt_foreign_server_version = 739, /* opt_foreign_server_version  */
  YYSYMBOL_AlterForeignServerStmt = 740,   /* AlterForeignServerStmt  */
  YYSYMBOL_CreateForeignTableStmt = 741,   /* CreateForeignTableStmt  */
  YYSYMBOL_ImportForeignSchemaStmt = 742,  /* ImportForeignSchemaStmt  */
  YYSYMBOL_import_qualification_type = 743, /* import_qualification_type  */
  YYSYMBOL_import_qualification = 744,     /* import_qualification  */
  YYSYMBOL_CreateUserMappingStmt = 745,    /* CreateUserMappingStmt  */
  YYSYMBOL_auth_ident = 746,               /* auth_ident  */
  YYSYMBOL_DropUserMappingStmt = 747,      /* DropUserMappingStmt  */
  YYSYMBOL_AlterUserMappingStmt = 748,     /* AlterUserMappingStmt  */
  YYSYMBOL_CreatePolicyStmt = 749,         /* CreatePolicyStmt  */
  YYSYMBOL_AlterPolicyStmt = 750,          /* AlterPolicyStmt  */
  YYSYMBOL_RowSecurityOptionalExpr = 751,  /* RowSecurityOptionalExpr  */
  YYSYMBOL_RowSecurityOptionalWithCheck = 752, /* RowSecurityOptionalWithCheck  */
  YYSYMBOL_RowSecurityDefaultToRole = 753, /* RowSecurityDefaultToRole  */
  YYSYMBOL_RowSecurityOptionalToRole = 754, /* RowSecurityOptionalToRole  */
  YYSYMBOL_RowSecurityDefaultPermissive = 755, /* RowSecurityDefaultPermissive  */
  YYSYMBOL_RowSecurityDefaultForCmd = 756, /* RowSecurityDefaultForCmd  */
  YYSYMBOL_row_security_cmd = 757,         /* row_security_cmd  */
  YYSYMBOL_CreateAmStmt = 758,             /* CreateAmStmt  */
  YYSYMBOL_am_type = 759,                  /* am_type  */
  YYSYMBOL_CreateTrigStmt = 760,           /* CreateTrigStmt  */
  YYSYMBOL_TriggerActionTime = 761,        /* TriggerActionTime  */
  YYSYMBOL_TriggerEvents = 762,            /* TriggerEvents  */
  YYSYMBOL_TriggerOneEvent = 763,          /* TriggerOneEvent  */
  YYSYMBOL_TriggerReferencing = 764,       /* TriggerReferencing  */
  YYSYMBOL_TriggerTransitions = 765,       /* TriggerTransitions  */
  YYSYMBOL_TriggerTransition = 766,        /* TriggerTransition  */
  YYSYMBOL_TransitionOldOrNew = 767,       /* TransitionOldOrNew  */
  YYSYMBOL_TransitionRowOrTable = 768,     /* TransitionRowOrTable  */
  YYSYMBOL_TransitionRelName = 769,        /* TransitionRelName  */
  YYSYMBOL_TriggerForSpec = 770,           /* TriggerForSpec  */
  YYSYMBOL_TriggerForOptEach = 771,        /* TriggerForOptEach  */
  YYSYMBOL_TriggerForType = 772,           /* TriggerForType  */
  YYSYMBOL_TriggerWhen = 773,              /* TriggerWhen  */
  YYSYMBOL_FUNCTION_or_PROCEDURE = 774,    /* FUNCTION_or_PROCEDURE  */
  YYSYMBOL_TriggerFuncArgs = 775,          /* TriggerFuncArgs  */
  YYSYMBOL_TriggerFuncArg = 776,           /* TriggerFuncArg  */
  YYSYMBOL_OptConstrFromTable = 777,       /* OptConstrFromTable  */
  YYSYMBOL_ConstraintAttributeSpec = 778,  /* ConstraintAttributeSpec  */
  YYSYMBOL_ConstraintAttributeElem = 779,  /* ConstraintAttributeElem  */
  YYSYMBOL_CreateEventTrigStmt = 780,      /* CreateEventTrigStmt  */
  YYSYMBOL_event_trigger_when_list = 781,  /* event_trigger_when_list  */
  YYSYMBOL_event_trigger_when_item = 782,  /* event_trigger_when_item  */
  YYSYMBOL_event_trigger_value_list = 783, /* event_trigger_value_list  */
  YYSYMBOL_AlterEventTrigStmt = 784,       /* AlterEventTrigStmt  */
  YYSYMBOL_enable_trigger = 785,           /* enable_trigger  */
  YYSYMBOL_CreateAssertionStmt = 786,      /* CreateAssertionStmt  */
  YYSYMBOL_DefineStmt = 787,               /* DefineStmt  */
  YYSYMBOL_definition = 788,               /* definition  */
  YYSYMBOL_def_list = 789,                 /* def_list  */
  YYSYMBOL_def_elem = 790,                 /* def_elem  */
  YYSYMBOL_def_arg = 791,                  /* def_arg  */
  YYSYMBOL_old_aggr_definition = 792,      /* old_aggr_definition  */
  YYSYMBOL_old_aggr_list = 793,            /* old_aggr_list  */
  YYSYMBOL_old_aggr_elem = 794,            /* old_aggr_elem  */
  YYSYMBOL_opt_enum_val_list = 795,        /* opt_enum_val_list  */
  YYSYMBOL_enum_val_list = 796,            /* enum_val_list  */
  YYSYMBOL_AlterEnumStmt = 797,            /* AlterEnumStmt  */
  YYSYMBOL_opt_if_not_exists = 798,        /* opt_if_not_exists  */
  YYSYMBOL_CreateOpClassStmt = 799,        /* CreateOpClassStmt  */
  YYSYMBOL_opclass_item_list = 800,        /* opclass_item_list  */
  YYSYMBOL_opclass_item = 801,             /* opclass_item  */
  YYSYMBOL_opt_default = 802,              /* opt_default  */
  YYSYMBOL_opt_opfamily = 803,             /* opt_opfamily  */
  YYSYMBOL_opclass_purpose = 804,          /* opclass_purpose  */
  YYSYMBOL_CreateOpFamilyStmt = 805,       /* CreateOpFamilyStmt  */
  YYSYMBOL_AlterOpFamilyStmt = 806,        /* AlterOpFamilyStmt  */
  YYSYMBOL_opclass_drop_list = 807,        /* opclass_drop_list  */
  YYSYMBOL_opclass_drop = 808,             /* opclass_drop  */
  YYSYMBOL_DropOpClassStmt = 809,          /* DropOpClassStmt  */
  YYSYMBOL_DropOpFamilyStmt = 810,         /* DropOpFamilyStmt  */
  YYSYMBOL_DropOwnedStmt = 811,            /* DropOwnedStmt  */
  YYSYMBOL_ReassignOwnedStmt = 812,        /* ReassignOwnedStmt  */
  YYSYMBOL_DropStmt = 813,                 /* DropStmt  */
  YYSYMBOL_object_type_any_name = 814,     /* object_type_any_name  */
  YYSYMBOL_object_type_name = 815,         /* object_type_name  */
  YYSYMBOL_drop_type_name = 816,           /* drop_type_name  */
  YYSYMBOL_object_type_name_on_any_name = 817, /* object_type_name_on_any_name  */
  YYSYMBOL_any_name_list = 818,            /* any_name_list  */
  YYSYMBOL_any_name = 819,                 /* any_name  */
  YYSYMBOL_attrs = 820,                    /* attrs  */
  YYSYMBOL_type_name_list = 821,           /* type_name_list  */
  YYSYMBOL_TruncateStmt = 822,             /* TruncateStmt  */
  YYSYMBOL_opt_restart_seqs = 823,         /* opt_restart_seqs  */
  YYSYMBOL_CommentStmt = 824,              /* CommentStmt  */
  YYSYMBOL_comment_text = 825,             /* comment_text  */
  YYSYMBOL_SecLabelStmt = 826,             /* SecLabelStmt  */
  YYSYMBOL_opt_provider = 827,             /* opt_provider  */
  YYSYMBOL_security_label = 828,           /* security_label  */
  YYSYMBOL_FetchStmt = 829,                /* FetchStmt  */
  YYSYMBOL_fetch_args = 830,               /* fetch_args  */
  YYSYMBOL_from_in = 831,                  /* from_in  */
  YYSYMBOL_opt_from_in = 832,              /* opt_from_in  */
  YYSYMBOL_GrantStmt = 833,                /* GrantStmt  */
  YYSYMBOL_RevokeStmt = 834,               /* RevokeStmt  */
  YYSYMBOL_privileges = 835,               /* privileges  */
  YYSYMBOL_privilege_list = 836,           /* privilege_list  */
  YYSYMBOL_privilege = 837,                /* privilege  */
  YYSYMBOL_parameter_name_list = 838,      /* parameter_name_list  */
  YYSYMBOL_parameter_name = 839,           /* parameter_name  */
  YYSYMBOL_privilege_target = 840,         /* privilege_target  */
  YYSYMBOL_grantee_list = 841,             /* grantee_list  */
  YYSYMBOL_grantee = 842,                  /* grantee  */
  YYSYMBOL_opt_grant_grant_option = 843,   /* opt_grant_grant_option  */
  YYSYMBOL_GrantRoleStmt = 844,            /* GrantRoleStmt  */
  YYSYMBOL_RevokeRoleStmt = 845,           /* RevokeRoleStmt  */
  YYSYMBOL_grant_role_opt_list = 846,      /* grant_role_opt_list  */
  YYSYMBOL_grant_role_opt = 847,           /* grant_role_opt  */
  YYSYMBOL_grant_role_opt_value = 848,     /* grant_role_opt_value  */
  YYSYMBOL_opt_granted_by = 849,           /* opt_granted_by  */
  YYSYMBOL_AlterDefaultPrivilegesStmt = 850, /* AlterDefaultPrivilegesStmt  */
  YYSYMBOL_DefACLOptionList = 851,         /* DefACLOptionList  */
  YYSYMBOL_DefACLOption = 852,             /* DefACLOption  */
  YYSYMBOL_DefACLAction = 853,             /* DefACLAction  */
  YYSYMBOL_defacl_privilege_target = 854,  /* defacl_privilege_target  */
  YYSYMBOL_IndexStmt = 855,                /* IndexStmt  */
  YYSYMBOL_opt_unique = 856,               /* opt_unique  */
  YYSYMBOL_access_method_clause = 857,     /* access_method_clause  */
  YYSYMBOL_index_params = 858,             /* index_params  */
  YYSYMBOL_index_elem_options = 859,       /* index_elem_options  */
  YYSYMBOL_index_elem = 860,               /* index_elem  */
  YYSYMBOL_opt_include = 861,              /* opt_include  */
  YYSYMBOL_index_including_params = 862,   /* index_including_params  */
  YYSYMBOL_opt_collate = 863,              /* opt_collate  */
  YYSYMBOL_opt_asc_desc = 864,             /* opt_asc_desc  */
  YYSYMBOL_opt_nulls_order = 865,          /* opt_nulls_order  */
  YYSYMBOL_CreateFunctionStmt = 866,       /* CreateFunctionStmt  */
  YYSYMBOL_opt_or_replace = 867,           /* opt_or_replace  */
  YYSYMBOL_func_args = 868,                /* func_args  */
  YYSYMBOL_func_args_list = 869,           /* func_args_list  */
  YYSYMBOL_function_with_argtypes_list = 870, /* function_with_argtypes_list  */
  YYSYMBOL_function_with_argtypes = 871,   /* function_with_argtypes  */
  YYSYMBOL_func_args_with_defaults = 872,  /* func_args_with_defaults  */
  YYSYMBOL_func_args_with_defaults_list = 873, /* func_args_with_defaults_list  */
  YYSYMBOL_func_arg = 874,                 /* func_arg  */
  YYSYMBOL_arg_class = 875,                /* arg_class  */
  YYSYMBOL_param_name = 876,               /* param_name  */
  YYSYMBOL_func_return = 877,              /* func_return  */
  YYSYMBOL_func_type = 878,                /* func_type  */
  YYSYMBOL_func_arg_with_default = 879,    /* func_arg_with_default  */
  YYSYMBOL_aggr_arg = 880,                 /* aggr_arg  */
  YYSYMBOL_aggr_args = 881,                /* aggr_args  */
  YYSYMBOL_aggr_args_list = 882,           /* aggr_args_list  */
  YYSYMBOL_aggregate_with_argtypes = 883,  /* aggregate_with_argtypes  */
  YYSYMBOL_aggregate_with_argtypes_list = 884, /* aggregate_with_argtypes_list  */
  YYSYMBOL_opt_createfunc_opt_list = 885,  /* opt_createfunc_opt_list  */
  YYSYMBOL_createfunc_opt_list = 886,      /* createfunc_opt_list  */
  YYSYMBOL_common_func_opt_item = 887,     /* common_func_opt_item  */
  YYSYMBOL_createfunc_opt_item = 888,      /* createfunc_opt_item  */
  YYSYMBOL_func_as = 889,                  /* func_as  */
  YYSYMBOL_ReturnStmt = 890,               /* ReturnStmt  */
  YYSYMBOL_opt_routine_body = 891,         /* opt_routine_body  */
  YYSYMBOL_routine_body_stmt_list = 892,   /* routine_body_stmt_list  */
  YYSYMBOL_routine_body_stmt = 893,        /* routine_body_stmt  */
  YYSYMBOL_transform_type_list = 894,      /* transform_type_list  */
  YYSYMBOL_opt_definition = 895,           /* opt_definition  */
  YYSYMBOL_table_func_column = 896,        /* table_func_column  */
  YYSYMBOL_table_func_column_list = 897,   /* table_func_column_list  */
  YYSYMBOL_AlterFunctionStmt = 898,        /* AlterFunctionStmt  */
  YYSYMBOL_alterfunc_opt_list = 899,       /* alterfunc_opt_list  */
  YYSYMBOL_opt_restrict = 900,             /* opt_restrict  */
  YYSYMBOL_RemoveFuncStmt = 901,           /* RemoveFuncStmt  */
  YYSYMBOL_RemoveAggrStmt = 902,           /* RemoveAggrStmt  */
  YYSYMBOL_RemoveOperStmt = 903,           /* RemoveOperStmt  */
  YYSYMBOL_oper_argtypes = 904,            /* oper_argtypes  */
  YYSYMBOL_any_operator = 905,             /* any_operator  */
  YYSYMBOL_operator_with_argtypes_list = 906, /* operator_with_argtypes_list  */
  YYSYMBOL_operator_with_argtypes = 907,   /* operator_with_argtypes  */
  YYSYMBOL_DoStmt = 908,                   /* DoStmt  */
  YYSYMBOL_dostmt_opt_list = 909,          /* dostmt_opt_list  */
  YYSYMBOL_dostmt_opt_item = 910,          /* dostmt_opt_item  */
  YYSYMBOL_CreateCastStmt = 911,           /* CreateCastStmt  */
  YYSYMBOL_cast_context = 912,             /* cast_context  */
  YYSYMBOL_DropCastStmt = 913,             /* DropCastStmt  */
  YYSYMBOL_opt_if_exists = 914,            /* opt_if_exists  */
  YYSYMBOL_CreateTransformStmt = 915,      /* CreateTransformStmt  */
  YYSYMBOL_transform_element_list = 916,   /* transform_element_list  */
  YYSYMBOL_DropTransformStmt = 917,        /* DropTransformStmt  */
  YYSYMBOL_ReindexStmt = 918,              /* ReindexStmt  */
  YYSYMBOL_reindex_target_relation = 919,  /* reindex_target_relation  */
  YYSYMBOL_reindex_target_all = 920,       /* reindex_target_all  */
  YYSYMBOL_opt_reindex_option_list = 921,  /* opt_reindex_option_list  */
  YYSYMBOL_AlterTblSpcStmt = 922,          /* AlterTblSpcStmt  */
  YYSYMBOL_RenameStmt = 923,               /* RenameStmt  */
  YYSYMBOL_opt_column = 924,               /* opt_column  */
  YYSYMBOL_opt_set_data = 925,             /* opt_set_data  */
  YYSYMBOL_AlterObjectDependsStmt = 926,   /* AlterObjectDependsStmt  */
  YYSYMBOL_opt_no = 927,                   /* opt_no  */
  YYSYMBOL_AlterObjectSchemaStmt = 928,    /* AlterObjectSchemaStmt  */
  YYSYMBOL_AlterOperatorStmt = 929,        /* AlterOperatorStmt  */
  YYSYMBOL_operator_def_list = 930,        /* operator_def_list  */
  YYSYMBOL_operator_def_elem = 931,        /* operator_def_elem  */
  YYSYMBOL_operator_def_arg = 932,         /* operator_def_arg  */
  YYSYMBOL_AlterTypeStmt = 933,            /* AlterTypeStmt  */
  YYSYMBOL_AlterOwnerStmt = 934,           /* AlterOwnerStmt  */
  YYSYMBOL_CreatePublicationStmt = 935,    /* CreatePublicationStmt  */
  YYSYMBOL_PublicationObjSpec = 936,       /* PublicationObjSpec  */
  YYSYMBOL_pub_obj_list = 937,             /* pub_obj_list  */
  YYSYMBOL_AlterPublicationStmt = 938,     /* AlterPublicationStmt  */
  YYSYMBOL_CreateSubscriptionStmt = 939,   /* CreateSubscriptionStmt  */
  YYSYMBOL_AlterSubscriptionStmt = 940,    /* AlterSubscriptionStmt  */
  YYSYMBOL_DropSubscriptionStmt = 941,     /* DropSubscriptionStmt  */
  YYSYMBOL_RuleStmt = 942,                 /* RuleStmt  */
  YYSYMBOL_RuleActionList = 943,           /* RuleActionList  */
  YYSYMBOL_RuleActionMulti = 944,          /* RuleActionMulti  */
  YYSYMBOL_RuleActionStmt = 945,           /* RuleActionStmt  */
  YYSYMBOL_RuleActionStmtOrEmpty = 946,    /* RuleActionStmtOrEmpty  */
  YYSYMBOL_event = 947,                    /* event  */
  YYSYMBOL_opt_instead = 948,              /* opt_instead  */
  YYSYMBOL_NotifyStmt = 949,               /* NotifyStmt  */
  YYSYMBOL_notify_payload = 950,           /* notify_payload  */
  YYSYMBOL_ListenStmt = 951,               /* ListenStmt  */
  YYSYMBOL_UnlistenStmt = 952,             /* UnlistenStmt  */
  YYSYMBOL_TransactionStmt = 953,          /* TransactionStmt  */
  YYSYMBOL_TransactionStmtLegacy = 954,    /* TransactionStmtLegacy  */
  YYSYMBOL_opt_transaction = 955,          /* opt_transaction  */
  YYSYMBOL_transaction_mode_item = 956,    /* transaction_mode_item  */
  YYSYMBOL_transaction_mode_list = 957,    /* transaction_mode_list  */
  YYSYMBOL_transaction_mode_list_or_empty = 958, /* transaction_mode_list_or_empty  */
  YYSYMBOL_opt_transaction_chain = 959,    /* opt_transaction_chain  */
  YYSYMBOL_ViewStmt = 960,                 /* ViewStmt  */
  YYSYMBOL_opt_check_option = 961,         /* opt_check_option  */
  YYSYMBOL_LoadStmt = 962,                 /* LoadStmt  */
  YYSYMBOL_CreatedbStmt = 963,             /* CreatedbStmt  */
  YYSYMBOL_createdb_opt_list = 964,        /* createdb_opt_list  */
  YYSYMBOL_createdb_opt_items = 965,       /* createdb_opt_items  */
  YYSYMBOL_createdb_opt_item = 966,        /* createdb_opt_item  */
  YYSYMBOL_createdb_opt_name = 967,        /* createdb_opt_name  */
  YYSYMBOL_opt_equal = 968,                /* opt_equal  */
  YYSYMBOL_AlterDatabaseStmt = 969,        /* AlterDatabaseStmt  */
  YYSYMBOL_AlterDatabaseSetStmt = 970,     /* AlterDatabaseSetStmt  */
  YYSYMBOL_DropdbStmt = 971,               /* DropdbStmt  */
  YYSYMBOL_drop_option_list = 972,         /* drop_option_list  */
  YYSYMBOL_drop_option = 973,              /* drop_option  */
  YYSYMBOL_AlterCollationStmt = 974,       /* AlterCollationStmt  */
  YYSYMBOL_AlterSystemStmt = 975,          /* AlterSystemStmt  */
  YYSYMBOL_CreateDomainStmt = 976,         /* CreateDomainStmt  */
  YYSYMBOL_AlterDomainStmt = 977,          /* AlterDomainStmt  */
  YYSYMBOL_opt_as = 978,                   /* opt_as  */
  YYSYMBOL_AlterTSDictionaryStmt = 979,    /* AlterTSDictionaryStmt  */
  YYSYMBOL_AlterTSConfigurationStmt = 980, /* AlterTSConfigurationStmt  */
  YYSYMBOL_any_with = 981,                 /* any_with  */
  YYSYMBOL_CreateConversionStmt = 982,     /* CreateConversionStmt  */
  YYSYMBOL_ClusterStmt = 983,              /* ClusterStmt  */
  YYSYMBOL_cluster_index_specification = 984, /* cluster_index_specification  */
  YYSYMBOL_VacuumStmt = 985,               /* VacuumStmt  */
  YYSYMBOL_AnalyzeStmt = 986,              /* AnalyzeStmt  */
  YYSYMBOL_utility_option_list = 987,      /* utility_option_list  */
  YYSYMBOL_analyze_keyword = 988,          /* analyze_keyword  */
  YYSYMBOL_utility_option_elem = 989,      /* utility_option_elem  */
  YYSYMBOL_utility_option_name = 990,      /* utility_option_name  */
  YYSYMBOL_utility_option_arg = 991,       /* utility_option_arg  */
  YYSYMBOL_opt_analyze = 992,              /* opt_analyze  */
  YYSYMBOL_opt_verbose = 993,              /* opt_verbose  */
  YYSYMBOL_opt_full = 994,                 /* opt_full  */
  YYSYMBOL_opt_freeze = 995,               /* opt_freeze  */
  YYSYMBOL_opt_name_list = 996,            /* opt_name_list  */
  YYSYMBOL_vacuum_relation = 997,          /* vacuum_relation  */
  YYSYMBOL_vacuum_relation_list = 998,     /* vacuum_relation_list  */
  YYSYMBOL_opt_vacuum_relation_list = 999, /* opt_vacuum_relation_list  */
  YYSYMBOL_ExplainStmt = 1000,             /* ExplainStmt  */
  YYSYMBOL_ExplainableStmt = 1001,         /* ExplainableStmt  */
  YYSYMBOL_PrepareStmt = 1002,             /* PrepareStmt  */
  YYSYMBOL_prep_type_clause = 1003,        /* prep_type_clause  */
  YYSYMBOL_PreparableStmt = 1004,          /* PreparableStmt  */
  YYSYMBOL_ExecuteStmt = 1005,             /* ExecuteStmt  */
  YYSYMBOL_execute_param_clause = 1006,    /* execute_param_clause  */
  YYSYMBOL_DeallocateStmt = 1007,          /* DeallocateStmt  */
  YYSYMBOL_InsertStmt = 1008,              /* InsertStmt  */
  YYSYMBOL_insert_target = 1009,           /* insert_target  */
  YYSYMBOL_insert_rest = 1010,             /* insert_rest  */
  YYSYMBOL_override_kind = 1011,           /* override_kind  */
  YYSYMBOL_insert_column_list = 1012,      /* insert_column_list  */
  YYSYMBOL_insert_column_item = 1013,      /* insert_column_item  */
  YYSYMBOL_opt_on_conflict = 1014,         /* opt_on_conflict  */
  YYSYMBOL_opt_conf_expr = 1015,           /* opt_conf_expr  */
  YYSYMBOL_returning_clause = 1016,        /* returning_clause  */
  YYSYMBOL_returning_with_clause = 1017,   /* returning_with_clause  */
  YYSYMBOL_returning_options = 1018,       /* returning_options  */
  YYSYMBOL_returning_option = 1019,        /* returning_option  */
  YYSYMBOL_returning_option_kind = 1020,   /* returning_option_kind  */
  YYSYMBOL_DeleteStmt = 1021,              /* DeleteStmt  */
  YYSYMBOL_using_clause = 1022,            /* using_clause  */
  YYSYMBOL_LockStmt = 1023,                /* LockStmt  */
  YYSYMBOL_opt_lock = 1024,                /* opt_lock  */
  YYSYMBOL_lock_type = 1025,               /* lock_type  */
  YYSYMBOL_opt_nowait = 1026,              /* opt_nowait  */
  YYSYMBOL_opt_nowait_or_skip = 1027,      /* opt_nowait_or_skip  */
  YYSYMBOL_UpdateStmt = 1028,              /* UpdateStmt  */
  YYSYMBOL_set_clause_list = 1029,         /* set_clause_list  */
  YYSYMBOL_set_clause = 1030,              /* set_clause  */
  YYSYMBOL_set_target = 1031,              /* set_target  */
  YYSYMBOL_set_target_list = 1032,         /* set_target_list  */
  YYSYMBOL_MergeStmt = 1033,               /* MergeStmt  */
  YYSYMBOL_merge_when_list = 1034,         /* merge_when_list  */
  YYSYMBOL_merge_when_clause = 1035,       /* merge_when_clause  */
  YYSYMBOL_merge_when_tgt_matched = 1036,  /* merge_when_tgt_matched  */
  YYSYMBOL_merge_when_tgt_not_matched = 1037, /* merge_when_tgt_not_matched  */
  YYSYMBOL_opt_merge_when_condition = 1038, /* opt_merge_when_condition  */
  YYSYMBOL_merge_update = 1039,            /* merge_update  */
  YYSYMBOL_merge_delete = 1040,            /* merge_delete  */
  YYSYMBOL_merge_insert = 1041,            /* merge_insert  */
  YYSYMBOL_merge_values_clause = 1042,     /* merge_values_clause  */
  YYSYMBOL_DeclareCursorStmt = 1043,       /* DeclareCursorStmt  */
  YYSYMBOL_cursor_name = 1044,             /* cursor_name  */
  YYSYMBOL_cursor_options = 1045,          /* cursor_options  */
  YYSYMBOL_opt_hold = 1046,                /* opt_hold  */
  YYSYMBOL_SelectStmt = 1047,              /* SelectStmt  */
  YYSYMBOL_select_with_parens = 1048,      /* select_with_parens  */
  YYSYMBOL_select_no_parens = 1049,        /* select_no_parens  */
  YYSYMBOL_select_clause = 1050,           /* select_clause  */
  YYSYMBOL_simple_select = 1051,           /* simple_select  */
  YYSYMBOL_with_clause = 1052,             /* with_clause  */
  YYSYMBOL_cte_list = 1053,                /* cte_list  */
  YYSYMBOL_common_table_expr = 1054,       /* common_table_expr  */
  YYSYMBOL_opt_materialized = 1055,        /* opt_materialized  */
  YYSYMBOL_opt_search_clause = 1056,       /* opt_search_clause  */
  YYSYMBOL_opt_cycle_clause = 1057,        /* opt_cycle_clause  */
  YYSYMBOL_opt_with_clause = 1058,         /* opt_with_clause  */
  YYSYMBOL_into_clause = 1059,             /* into_clause  */
  YYSYMBOL_OptTempTableName = 1060,        /* OptTempTableName  */
  YYSYMBOL_opt_table = 1061,               /* opt_table  */
  YYSYMBOL_set_quantifier = 1062,          /* set_quantifier  */
  YYSYMBOL_distinct_clause = 1063,         /* distinct_clause  */
  YYSYMBOL_opt_all_clause = 1064,          /* opt_all_clause  */
  YYSYMBOL_opt_distinct_clause = 1065,     /* opt_distinct_clause  */
  YYSYMBOL_opt_sort_clause = 1066,         /* opt_sort_clause  */
  YYSYMBOL_sort_clause = 1067,             /* sort_clause  */
  YYSYMBOL_sortby_list = 1068,             /* sortby_list  */
  YYSYMBOL_sortby = 1069,                  /* sortby  */
  YYSYMBOL_select_limit = 1070,            /* select_limit  */
  YYSYMBOL_opt_select_limit = 1071,        /* opt_select_limit  */
  YYSYMBOL_limit_clause = 1072,            /* limit_clause  */
  YYSYMBOL_offset_clause = 1073,           /* offset_clause  */
  YYSYMBOL_select_limit_value = 1074,      /* select_limit_value  */
  YYSYMBOL_select_offset_value = 1075,     /* select_offset_value  */
  YYSYMBOL_select_fetch_first_value = 1076, /* select_fetch_first_value  */
  YYSYMBOL_I_or_F_const = 1077,            /* I_or_F_const  */
  YYSYMBOL_row_or_rows = 1078,             /* row_or_rows  */
  YYSYMBOL_first_or_next = 1079,           /* first_or_next  */
  YYSYMBOL_group_clause = 1080,            /* group_clause  */
  YYSYMBOL_group_by_list = 1081,           /* group_by_list  */
  YYSYMBOL_group_by_item = 1082,           /* group_by_item  */
  YYSYMBOL_empty_grouping_set = 1083,      /* empty_grouping_set  */
  YYSYMBOL_rollup_clause = 1084,           /* rollup_clause  */
  YYSYMBOL_cube_clause = 1085,             /* cube_clause  */
  YYSYMBOL_grouping_sets_clause = 1086,    /* grouping_sets_clause  */
  YYSYMBOL_having_clause = 1087,           /* having_clause  */
  YYSYMBOL_for_locking_clause = 1088,      /* for_locking_clause  */
  YYSYMBOL_opt_for_locking_clause = 1089,  /* opt_for_locking_clause  */
  YYSYMBOL_for_locking_items = 1090,       /* for_locking_items  */
  YYSYMBOL_for_locking_item = 1091,        /* for_locking_item  */
  YYSYMBOL_for_locking_strength = 1092,    /* for_locking_strength  */
  YYSYMBOL_locked_rels_list = 1093,        /* locked_rels_list  */
  YYSYMBOL_values_clause = 1094,           /* values_clause  */
  YYSYMBOL_from_clause = 1095,             /* from_clause  */
  YYSYMBOL_from_list = 1096,               /* from_list  */
  YYSYMBOL_table_ref = 1097,               /* table_ref  */
  YYSYMBOL_joined_table = 1098,            /* joined_table  */
  YYSYMBOL_alias_clause = 1099,            /* alias_clause  */
  YYSYMBOL_opt_alias_clause = 1100,        /* opt_alias_clause  */
  YYSYMBOL_opt_alias_clause_for_join_using = 1101, /* opt_alias_clause_for_join_using  */
  YYSYMBOL_func_alias_clause = 1102,       /* func_alias_clause  */
  YYSYMBOL_join_type = 1103,               /* join_type  */
  YYSYMBOL_opt_outer = 1104,               /* opt_outer  */
  YYSYMBOL_join_qual = 1105,               /* join_qual  */
  YYSYMBOL_relation_expr = 1106,           /* relation_expr  */
  YYSYMBOL_extended_relation_expr = 1107,  /* extended_relation_expr  */
  YYSYMBOL_relation_expr_list = 1108,      /* relation_expr_list  */
  YYSYMBOL_relation_expr_opt_alias = 1109, /* relation_expr_opt_alias  */
  YYSYMBOL_tablesample_clause = 1110,      /* tablesample_clause  */
  YYSYMBOL_opt_repeatable_clause = 1111,   /* opt_repeatable_clause  */
  YYSYMBOL_func_table = 1112,              /* func_table  */
  YYSYMBOL_rowsfrom_item = 1113,           /* rowsfrom_item  */
  YYSYMBOL_rowsfrom_list = 1114,           /* rowsfrom_list  */
  YYSYMBOL_opt_col_def_list = 1115,        /* opt_col_def_list  */
  YYSYMBOL_opt_ordinality = 1116,          /* opt_ordinality  */
  YYSYMBOL_where_clause = 1117,            /* where_clause  */
  YYSYMBOL_where_or_current_clause = 1118, /* where_or_current_clause  */
  YYSYMBOL_OptTableFuncElementList = 1119, /* OptTableFuncElementList  */
  YYSYMBOL_TableFuncElementList = 1120,    /* TableFuncElementList  */
  YYSYMBOL_TableFuncElement = 1121,        /* TableFuncElement  */
  YYSYMBOL_xmltable = 1122,                /* xmltable  */
  YYSYMBOL_xmltable_column_list = 1123,    /* xmltable_column_list  */
  YYSYMBOL_xmltable_column_el = 1124,      /* xmltable_column_el  */
  YYSYMBOL_xmltable_column_option_list = 1125, /* xmltable_column_option_list  */
  YYSYMBOL_xmltable_column_option_el = 1126, /* xmltable_column_option_el  */
  YYSYMBOL_xml_namespace_list = 1127,      /* xml_namespace_list  */
  YYSYMBOL_xml_namespace_el = 1128,        /* xml_namespace_el  */
  YYSYMBOL_json_table = 1129,              /* json_table  */
  YYSYMBOL_json_table_path_name_opt = 1130, /* json_table_path_name_opt  */
  YYSYMBOL_json_table_column_definition_list = 1131, /* json_table_column_definition_list  */
  YYSYMBOL_json_table_column_definition = 1132, /* json_table_column_definition  */
  YYSYMBOL_path_opt = 1133,                /* path_opt  */
  YYSYMBOL_json_table_column_path_clause_opt = 1134, /* json_table_column_path_clause_opt  */
  YYSYMBOL_Typename = 1135,                /* Typename  */
  YYSYMBOL_opt_array_bounds = 1136,        /* opt_array_bounds  */
  YYSYMBOL_SimpleTypename = 1137,          /* SimpleTypename  */
  YYSYMBOL_ConstTypename = 1138,           /* ConstTypename  */
  YYSYMBOL_GenericType = 1139,             /* GenericType  */
  YYSYMBOL_opt_type_modifiers = 1140,      /* opt_type_modifiers  */
  YYSYMBOL_Numeric = 1141,                 /* Numeric  */
  YYSYMBOL_opt_float = 1142,               /* opt_float  */
  YYSYMBOL_Bit = 1143,                     /* Bit  */
  YYSYMBOL_ConstBit = 1144,                /* ConstBit  */
  YYSYMBOL_BitWithLength = 1145,           /* BitWithLength  */
  YYSYMBOL_BitWithoutLength = 1146,        /* BitWithoutLength  */
  YYSYMBOL_Character = 1147,               /* Character  */
  YYSYMBOL_ConstCharacter = 1148,          /* ConstCharacter  */
  YYSYMBOL_CharacterWithLength = 1149,     /* CharacterWithLength  */
  YYSYMBOL_CharacterWithoutLength = 1150,  /* CharacterWithoutLength  */
  YYSYMBOL_character = 1151,               /* character  */
  YYSYMBOL_opt_varying = 1152,             /* opt_varying  */
  YYSYMBOL_ConstDatetime = 1153,           /* ConstDatetime  */
  YYSYMBOL_ConstInterval = 1154,           /* ConstInterval  */
  YYSYMBOL_opt_timezone = 1155,            /* opt_timezone  */
  YYSYMBOL_opt_interval = 1156,            /* opt_interval  */
  YYSYMBOL_interval_second = 1157,         /* interval_second  */
  YYSYMBOL_JsonType = 1158,                /* JsonType  */
  YYSYMBOL_a_expr = 1159,                  /* a_expr  */
  YYSYMBOL_b_expr = 1160,                  /* b_expr  */
  YYSYMBOL_c_expr = 1161,                  /* c_expr  */
  YYSYMBOL_func_application = 1162,        /* func_application  */
  YYSYMBOL_func_expr = 1163,               /* func_expr  */
  YYSYMBOL_func_expr_windowless = 1164,    /* func_expr_windowless  */
  YYSYMBOL_func_expr_common_subexpr = 1165, /* func_expr_common_subexpr  */
  YYSYMBOL_xml_root_version = 1166,        /* xml_root_version  */
  YYSYMBOL_opt_xml_root_standalone = 1167, /* opt_xml_root_standalone  */
  YYSYMBOL_xml_attributes = 1168,          /* xml_attributes  */
  YYSYMBOL_xml_attribute_list = 1169,      /* xml_attribute_list  */
  YYSYMBOL_xml_attribute_el = 1170,        /* xml_attribute_el  */
  YYSYMBOL_document_or_content = 1171,     /* document_or_content  */
  YYSYMBOL_xml_indent_option = 1172,       /* xml_indent_option  */
  YYSYMBOL_xml_whitespace_option = 1173,   /* xml_whitespace_option  */
  YYSYMBOL_xmlexists_argument = 1174,      /* xmlexists_argument  */
  YYSYMBOL_xml_passing_mech = 1175,        /* xml_passing_mech  */
  YYSYMBOL_within_group_clause = 1176,     /* within_group_clause  */
  YYSYMBOL_filter_clause = 1177,           /* filter_clause  */
  YYSYMBOL_window_clause = 1178,           /* window_clause  */
  YYSYMBOL_window_definition_list = 1179,  /* window_definition_list  */
  YYSYMBOL_window_definition = 1180,       /* window_definition  */
  YYSYMBOL_over_clause = 1181,             /* over_clause  */
  YYSYMBOL_window_specification = 1182,    /* window_specification  */
  YYSYMBOL_opt_existing_window_name = 1183, /* opt_existing_window_name  */
  YYSYMBOL_opt_partition_clause = 1184,    /* opt_partition_clause  */
  YYSYMBOL_opt_frame_clause = 1185,        /* opt_frame_clause  */
  YYSYMBOL_frame_extent = 1186,            /* frame_extent  */
  YYSYMBOL_frame_bound = 1187,             /* frame_bound  */
  YYSYMBOL_opt_window_exclusion_clause = 1188, /* opt_window_exclusion_clause  */
  YYSYMBOL_row = 1189,                     /* row  */
  YYSYMBOL_explicit_row = 1190,            /* explicit_row  */
  YYSYMBOL_implicit_row = 1191,            /* implicit_row  */
  YYSYMBOL_sub_type = 1192,                /* sub_type  */
  YYSYMBOL_all_Op = 1193,                  /* all_Op  */
  YYSYMBOL_MathOp = 1194,                  /* MathOp  */
  YYSYMBOL_qual_Op = 1195,                 /* qual_Op  */
  YYSYMBOL_qual_all_Op = 1196,             /* qual_all_Op  */
  YYSYMBOL_subquery_Op = 1197,             /* subquery_Op  */
  YYSYMBOL_expr_list = 1198,               /* expr_list  */
  YYSYMBOL_func_arg_list = 1199,           /* func_arg_list  */
  YYSYMBOL_func_arg_expr = 1200,           /* func_arg_expr  */
  YYSYMBOL_func_arg_list_opt = 1201,       /* func_arg_list_opt  */
  YYSYMBOL_type_list = 1202,               /* type_list  */
  YYSYMBOL_array_expr = 1203,              /* array_expr  */
  YYSYMBOL_array_expr_list = 1204,         /* array_expr_list  */
  YYSYMBOL_extract_list = 1205,            /* extract_list  */
  YYSYMBOL_extract_arg = 1206,             /* extract_arg  */
  YYSYMBOL_unicode_normal_form = 1207,     /* unicode_normal_form  */
  YYSYMBOL_overlay_list = 1208,            /* overlay_list  */
  YYSYMBOL_position_list = 1209,           /* position_list  */
  YYSYMBOL_substr_list = 1210,             /* substr_list  */
  YYSYMBOL_trim_list = 1211,               /* trim_list  */
  YYSYMBOL_in_expr = 1212,                 /* in_expr  */
  YYSYMBOL_case_expr = 1213,               /* case_expr  */
  YYSYMBOL_when_clause_list = 1214,        /* when_clause_list  */
  YYSYMBOL_when_clause = 1215,             /* when_clause  */
  YYSYMBOL_case_default = 1216,            /* case_default  */
  YYSYMBOL_case_arg = 1217,                /* case_arg  */
  YYSYMBOL_columnref = 1218,               /* columnref  */
  YYSYMBOL_indirection_el = 1219,          /* indirection_el  */
  YYSYMBOL_opt_slice_bound = 1220,         /* opt_slice_bound  */
  YYSYMBOL_indirection = 1221,             /* indirection  */
  YYSYMBOL_opt_indirection = 1222,         /* opt_indirection  */
  YYSYMBOL_opt_asymmetric = 1223,          /* opt_asymmetric  */
  YYSYMBOL_json_passing_clause_opt = 1224, /* json_passing_clause_opt  */
  YYSYMBOL_json_arguments = 1225,          /* json_arguments  */
  YYSYMBOL_json_argument = 1226,           /* json_argument  */
  YYSYMBOL_json_wrapper_behavior = 1227,   /* json_wrapper_behavior  */
  YYSYMBOL_json_behavior = 1228,           /* json_behavior  */
  YYSYMBOL_json_behavior_type = 1229,      /* json_behavior_type  */
  YYSYMBOL_json_behavior_clause_opt = 1230, /* json_behavior_clause_opt  */
  YYSYMBOL_json_on_error_clause_opt = 1231, /* json_on_error_clause_opt  */
  YYSYMBOL_json_value_expr = 1232,         /* json_value_expr  */
  YYSYMBOL_json_format_clause = 1233,      /* json_format_clause  */
  YYSYMBOL_json_format_clause_opt = 1234,  /* json_format_clause_opt  */
  YYSYMBOL_json_quotes_clause_opt = 1235,  /* json_quotes_clause_opt  */
  YYSYMBOL_json_returning_clause_opt = 1236, /* json_returning_clause_opt  */
  YYSYMBOL_json_predicate_type_constraint = 1237, /* json_predicate_type_constraint  */
  YYSYMBOL_json_key_uniqueness_constraint_opt = 1238, /* json_key_uniqueness_constraint_opt  */
  YYSYMBOL_json_name_and_value_list = 1239, /* json_name_and_value_list  */
  YYSYMBOL_json_name_and_value = 1240,     /* json_name_and_value  */
  YYSYMBOL_json_object_constructor_null_clause_opt = 1241, /* json_object_constructor_null_clause_opt  */
  YYSYMBOL_json_array_constructor_null_clause_opt = 1242, /* json_array_constructor_null_clause_opt  */
  YYSYMBOL_json_value_expr_list = 1243,    /* json_value_expr_list  */
  YYSYMBOL_json_aggregate_func = 1244,     /* json_aggregate_func  */
  YYSYMBOL_json_array_aggregate_order_by_clause_opt = 1245, /* json_array_aggregate_order_by_clause_opt  */
  YYSYMBOL_opt_target_list = 1246,         /* opt_target_list  */
  YYSYMBOL_target_list = 1247,             /* target_list  */
  YYSYMBOL_target_el = 1248,               /* target_el  */
  YYSYMBOL_qualified_name_list = 1249,     /* qualified_name_list  */
  YYSYMBOL_qualified_name = 1250,          /* qualified_name  */
  YYSYMBOL_name_list = 1251,               /* name_list  */
  YYSYMBOL_name = 1252,                    /* name  */
  YYSYMBOL_attr_name = 1253,               /* attr_name  */
  YYSYMBOL_file_name = 1254,               /* file_name  */
  YYSYMBOL_func_name = 1255,               /* func_name  */
  YYSYMBOL_AexprConst = 1256,              /* AexprConst  */
  YYSYMBOL_Iconst = 1257,                  /* Iconst  */
  YYSYMBOL_Sconst = 1258,                  /* Sconst  */
  YYSYMBOL_SignedIconst = 1259,            /* SignedIconst  */
  YYSYMBOL_RoleId = 1260,                  /* RoleId  */
  YYSYMBOL_RoleSpec = 1261,                /* RoleSpec  */
  YYSYMBOL_role_list = 1262,               /* role_list  */
  YYSYMBOL_PLpgSQL_Expr = 1263,            /* PLpgSQL_Expr  */
  YYSYMBOL_PLAssignStmt = 1264,            /* PLAssignStmt  */
  YYSYMBOL_plassign_target = 1265,         /* plassign_target  */
  YYSYMBOL_plassign_equals = 1266,         /* plassign_equals  */
  YYSYMBOL_ColId = 1267,                   /* ColId  */
  YYSYMBOL_type_function_name = 1268,      /* type_function_name  */
  YYSYMBOL_NonReservedWord = 1269,         /* NonReservedWord  */
  YYSYMBOL_ColLabel = 1270,                /* ColLabel  */
  YYSYMBOL_BareColLabel = 1271,            /* BareColLabel  */
  YYSYMBOL_unreserved_keyword = 1272,      /* unreserved_keyword  */
  YYSYMBOL_col_name_keyword = 1273,        /* col_name_keyword  */
  YYSYMBOL_type_func_name_keyword = 1274,  /* type_func_name_keyword  */
  YYSYMBOL_reserved_keyword = 1275,        /* reserved_keyword  */
  YYSYMBOL_bare_label_keyword = 1276       /* bare_label_keyword  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  931
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   122812

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  542
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  735
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3435
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  6500

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   779


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   531,     2,     2,
     536,   537,   529,   527,   540,   528,   538,   530,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   541,   539,
     524,   526,   525,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   534,     2,   535,   532,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   533
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   916,   916,   921,   925,   930,   938,   946,   962,   974,
     988,   989,   993,   994,   995,   996,   997,   998,   999,  1000,
    1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,
    1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,
    1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,
    1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,
    1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,
    1111,  1112,  1113,  1114,  1115,  1116,  1118,  1125,  1126,  1130,
    1131,  1135,  1136,  1140,  1141,  1142,  1151,  1167,  1179,  1180,
    1181,  1190,  1191,  1195,  1196,  1200,  1205,  1209,  1219,  1227,
    1231,  1235,  1240,  1244,  1292,  1294,  1298,  1302,  1306,  1310,
    1324,  1343,  1352,  1364,  1365,  1369,  1378,  1387,  1396,  1418,
    1426,  1434,  1442,  1450,  1458,  1476,  1495,  1507,  1508,  1519,
    1530,  1541,  1557,  1576,  1581,  1589,  1590,  1591,  1592,  1593,
    1594,  1608,  1615,  1622,  1632,  1643,  1654,  1658,  1668,  1678,
    1687,  1699,  1700,  1710,  1724,  1732,  1742,  1755,  1765,  1775,
    1784,  1796,  1808,  1809,  1813,  1814,  1817,  1819,  1823,  1824,
    1825,  1826,  1830,  1831,  1832,  1838,  1850,  1854,  1858,  1875,
    1883,  1884,  1885,  1889,  1890,  1891,  1895,  1896,  1900,  1904,
    1905,  1914,  1923,  1935,  1944,  1956,  1957,  1962,  1963,  1968,
    1975,  1982,  1989,  1996,  2007,  2018,  2019,  2023,  2024,  2032,
    2048,  2055,  2062,  2069,  2076,  2096,  2106,  2116,  2126,  2136,
    2148,  2160,  2170,  2180,  2190,  2202,  2214,  2224,  2234,  2244,
    2254,  2264,  2274,  2286,  2298,  2308,  2321,  2322,  2327,  2341,
    2354,  2370,  2387,  2397,  2407,  2417,  2427,  2437,  2446,  2455,
    2465,  2474,  2484,  2494,  2510,  2520,  2530,  2540,  2550,  2567,
    2577,  2587,  2597,  2608,  2622,  2638,  2648,  2657,  2682,  2696,
    2705,  2716,  2727,  2735,  2744,  2753,  2761,  2769,  2778,  2787,
    2796,  2804,  2812,  2821,  2829,  2837,  2846,  2855,  2864,  2873,
    2882,  2891,  2902,  2910,  2919,  2928,  2937,  2946,  2955,  2964,
    2972,  2980,  2988,  2995,  3006,  3007,  3011,  3020,  3024,  3025,
    3029,  3037,  3045,  3053,  3064,  3067,  3068,  3072,  3073,  3078,
    3082,  3086,  3091,  3098,  3100,  3105,  3109,  3113,  3124,  3131,
    3132,  3136,  3137,  3142,  3197,  3210,  3224,  3236,  3243,  3247,
    3261,  3274,  3275,  3280,  3290,  3301,  3312,  3339,  3346,  3380,
    3416,  3440,  3441,  3445,  3446,  3455,  3456,  3457,  3460,  3461,
    3466,  3467,  3471,  3475,  3479,  3483,  3487,  3491,  3495,  3499,
    3503,  3507,  3511,  3515,  3519,  3523,  3527,  3536,  3540,  3544,
    3548,  3552,  3553,  3558,  3562,  3569,  3576,  3577,  3578,  3579,
    3580,  3581,  3585,  3589,  3597,  3608,  3628,  3648,  3669,  3690,
    3711,  3745,  3746,  3747,  3748,  3749,  3756,  3763,  3764,  3768,
    3769,  3773,  3774,  3778,  3782,  3789,  3793,  3800,  3801,  3802,
    3806,  3807,  3810,  3834,  3853,  3875,  3876,  3880,  3881,  3885,
    3886,  3890,  3891,  3895,  3896,  3900,  3908,  3909,  3910,  3942,
    3954,  3962,  3975,  3987,  4001,  4011,  4021,  4046,  4067,  4068,
    4069,  4073,  4074,  4078,  4079,  4080,  4099,  4107,  4115,  4123,
    4131,  4139,  4151,  4163,  4164,  4165,  4169,  4170,  4171,  4172,
    4173,  4174,  4175,  4176,  4177,  4178,  4187,  4195,  4199,  4213,
    4226,  4245,  4261,  4279,  4295,  4315,  4360,  4368,  4372,  4387,
    4403,  4404,  4408,  4409,  4413,  4414,  4418,  4419,  4423,  4424,
    4428,  4429,  4432,  4438,  4439,  4442,  4446,  4454,  4459,  4465,
    4466,  4470,  4475,  4482,  4483,  4487,  4497,  4507,  4515,  4524,
    4537,  4549,  4556,  4564,  4572,  4580,  4588,  4598,  4599,  4603,
    4604,  4607,  4619,  4620,  4623,  4634,  4645,  4659,  4660,  4665,
    4666,  4667,  4670,  4671,  4672,  4673,  4676,  4677,  4680,  4681,
    4684,  4704,  4717,  4739,  4740,  4743,  4749,  4755,  4772,  4781,
    4803,  4817,  4834,  4850,  4851,  4852,  4864,  4878,  4895,  4909,
    4910,  4922,  4943,  4954,  4968,  4977,  4989,  4990,  4993,  4994,
    4997,  4998,  5001,  5005,  5009,  5013,  5017,  5021,  5025,  5029,
    5033,  5037,  5041,  5045,  5049,  5053,  5057,  5061,  5067,  5068,
    5072,  5073,  5074,  5081,  5084,  5085,  5097,  5113,  5129,  5130,
    5138,  5139,  5143,  5144,  5148,  5149,  5153,  5154,  5158,  5159,
    5169,  5181,  5182,  5195,  5203,  5221,  5230,  5242,  5245,  5249,
    5253,  5257,  5264,  5276,  5287,  5290,  5294,  5307,  5317,  5327,
    5337,  5347,  5357,  5367,  5377,  5387,  5397,  5407,  5417,  5427,
    5446,  5458,  5459,  5460,  5461,  5465,  5466,  5470,  5471,  5481,
    5490,  5503,  5504,  5508,  5512,  5520,  5524,  5528,  5535,  5539,
    5544,  5549,  5556,  5563,  5568,  5578,  5591,  5607,  5608,  5613,
    5614,  5618,  5619,  5629,  5639,  5648,  5666,  5687,  5708,  5730,
    5764,  5780,  5781,  5785,  5794,  5809,  5819,  5832,  5833,  5845,
    5854,  5872,  5897,  5915,  5930,  5931,  5935,  5936,  5940,  5941,
    5945,  5946,  5950,  5964,  5968,  5969,  5973,  5974,  5975,  5976,
    5977,  5987,  5999,  6000,  6011,  6034,  6067,  6068,  6069,  6073,
    6075,  6097,  6099,  6101,  6103,  6105,  6110,  6111,  6115,  6116,
    6120,  6132,  6133,  6137,  6146,  6150,  6154,  6159,  6169,  6170,
    6174,  6175,  6179,  6180,  6184,  6185,  6189,  6190,  6191,  6195,
    6199,  6200,  6201,  6205,  6206,  6211,  6212,  6240,  6241,  6242,
    6243,  6244,  6245,  6246,  6247,  6260,  6271,  6286,  6288,  6293,
    6298,  6300,  6305,  6316,  6317,  6318,  6319,  6330,  6350,  6362,
    6375,  6386,  6397,  6409,  6418,  6426,  6434,  6444,  6454,  6464,
    6474,  6484,  6495,  6505,  6518,  6521,  6522,  6525,  6529,  6536,
    6537,  6538,  6539,  6540,  6541,  6544,  6547,  6548,  6556,  6563,
    6564,  6567,  6569,  6580,  6592,  6604,  6616,  6628,  6657,  6658,
    6674,  6690,  6691,  6695,  6708,  6718,  6727,  6737,  6747,  6748,
    6751,  6752,  6755,  6756,  6757,  6762,  6773,  6783,  6796,  6797,
    6801,  6810,  6823,  6834,  6848,  6859,  6882,  6893,  6912,  6923,
    6934,  6945,  6956,  6967,  6978,  6989,  7000,  7011,  7022,  7033,
    7048,  7049,  7050,  7051,  7052,  7053,  7054,  7055,  7056,  7057,
    7058,  7059,  7060,  7070,  7071,  7072,  7073,  7074,  7078,  7079,
    7080,  7081,  7082,  7083,  7084,  7085,  7090,  7091,  7092,  7096,
    7097,  7100,  7101,  7104,  7106,  7111,  7112,  7123,  7135,  7136,
    7137,  7147,  7156,  7165,  7174,  7183,  7192,  7201,  7210,  7219,
    7228,  7242,  7251,  7260,  7269,  7278,  7287,  7296,  7305,  7317,
    7318,  7332,  7343,  7354,  7365,  7376,  7387,  7398,  7409,  7420,
    7431,  7444,  7445,  7448,  7449,  7459,  7466,  7475,  7484,  7493,
    7502,  7511,  7520,  7529,  7538,  7547,  7556,  7565,  7574,  7583,
    7592,  7601,  7610,  7621,  7622,  7625,  7626,  7636,  7654,  7670,
    7698,  7700,  7702,  7704,  7712,  7722,  7723,  7726,  7734,  7742,
    7750,  7757,  7768,  7772,  7779,  7783,  7794,  7803,  7812,  7821,
    7830,  7839,  7848,  7857,  7866,  7875,  7884,  7893,  7902,  7910,
    7919,  7928,  7937,  7946,  7955,  7964,  7973,  7986,  7987,  7991,
    7992,  7997,  7998,  8008,  8019,  8033,  8045,  8063,  8064,  8068,
    8075,  8076,  8077,  8080,  8081,  8091,  8102,  8103,  8107,  8111,
    8115,  8126,  8140,  8155,  8173,  8174,  8175,  8176,  8177,  8178,
    8179,  8191,  8223,  8258,  8259,  8263,  8264,  8267,  8268,  8273,
    8285,  8304,  8309,  8314,  8321,  8322,  8325,  8326,  8329,  8330,
    8334,  8335,  8336,  8339,  8340,  8341,  8357,  8371,  8386,  8400,
    8417,  8418,  8421,  8422,  8426,  8427,  8431,  8432,  8437,  8451,
    8459,  8467,  8483,  8484,  8488,  8489,  8504,  8515,  8526,  8537,
    8548,  8562,  8563,  8564,  8565,  8566,  8572,  8576,  8591,  8592,
    8598,  8608,  8612,  8617,  8625,  8667,  8671,  8675,  8679,  8687,
    8688,  8692,  8704,  8705,  8710,  8711,  8716,  8717,  8724,  8728,
    8732,  8736,  8740,  8744,  8748,  8752,  8756,  8760,  8764,  8768,
    8772,  8776,  8780,  8784,  8789,  8796,  8800,  8804,  8808,  8812,
    8818,  8819,  8825,  8835,  8839,  8850,  8856,  8865,  8871,  8872,
    8876,  8877,  8881,  8882,  8885,  8899,  8903,  8918,  8927,  8936,
    8949,  8950,  8955,  8956,  8973,  8984,  8995,  9006,  9017,  9028,
    9042,  9053,  9067,  9078,  9092,  9100,  9102,  9104,  9109,  9111,
    9116,  9117,  9122,  9141,  9151,  9152,  9156,  9160,  9172,  9184,
    9196,  9210,  9211,  9212,  9216,  9229,  9230,  9240,  9253,  9257,
    9261,  9265,  9272,  9294,  9307,  9320,  9335,  9336,  9339,  9340,
    9343,  9344,  9354,  9364,  9382,  9392,  9402,  9412,  9422,  9432,
    9442,  9452,  9462,  9472,  9482,  9492,  9502,  9513,  9524,  9534,
    9544,  9554,  9564,  9574,  9584,  9595,  9606,  9617,  9628,  9639,
    9650,  9661,  9672,  9683,  9694,  9705,  9716,  9728,  9740,  9752,
    9764,  9776,  9788,  9799,  9810,  9822,  9834,  9845,  9856,  9865,
    9875,  9885,  9895,  9905,  9915,  9925,  9935,  9945,  9955,  9970,
    9971,  9974,  9975,  9985,  9995, 10005, 10015, 10026, 10036, 10048,
   10049, 10059, 10069, 10079, 10089, 10099, 10109, 10119, 10129, 10139,
   10149, 10159, 10169, 10179, 10189, 10199, 10209, 10219, 10229, 10239,
   10249, 10259, 10269, 10279, 10289, 10299, 10309, 10319, 10338, 10348,
   10349, 10352, 10354, 10356, 10362, 10363, 10364, 10365, 10366, 10378,
   10394, 10403, 10412, 10421, 10430, 10439, 10448, 10457, 10466, 10475,
   10484, 10493, 10502, 10511, 10520, 10529, 10538, 10547, 10556, 10565,
   10574, 10583, 10592, 10601, 10629, 10637, 10646, 10672, 10681, 10688,
   10694, 10721, 10732, 10741, 10749, 10751, 10773, 10781, 10791, 10801,
   10820, 10839, 10849, 10859, 10869, 10880, 10891, 10902, 10913, 10924,
   10942, 10951, 10968, 10986, 10987, 10988, 10993, 10999, 11008, 11009,
   11010, 11011, 11012, 11016, 11017, 11020, 11021, 11022, 11023, 11027,
   11028, 11029, 11041, 11052, 11053, 11056, 11066, 11073, 11093, 11103,
   11112, 11122, 11132, 11141, 11150, 11159, 11168, 11177, 11186, 11195,
   11207, 11216, 11228, 11229, 11230, 11234, 11237, 11240, 11243, 11246,
   11253, 11255, 11257, 11262, 11264, 11268, 11269, 11270, 11282, 11296,
   11310, 11329, 11351, 11352, 11353, 11354, 11364, 11381, 11392, 11393,
   11397, 11398, 11402, 11406, 11410, 11428, 11429, 11430, 11431, 11432,
   11433, 11434, 11441, 11442, 11453, 11461, 11469, 11478, 11488, 11506,
   11515, 11524, 11533, 11545, 11549, 11560, 11572, 11590, 11597, 11614,
   11628, 11638, 11647, 11656, 11666, 11678, 11690, 11701, 11702, 11713,
   11724, 11736, 11748, 11760, 11772, 11782, 11795, 11796, 11810, 11834,
   11843, 11853, 11865, 11877, 11891, 11892, 11904, 11925, 11936, 11948,
   11960, 11964, 11971, 11972, 11976, 11983, 11984, 11985, 11989, 11990,
   11991, 11995, 11996, 12000, 12001, 12004, 12005, 12008, 12009, 12013,
   12014, 12018, 12025, 12027, 12032, 12033, 12046, 12054, 12065, 12073,
   12084, 12085, 12086, 12087, 12088, 12089, 12090, 12091, 12092, 12093,
   12103, 12114, 12115, 12119, 12120, 12121, 12122, 12123, 12133, 12141,
   12159, 12179, 12180, 12190, 12199, 12208, 12217, 12236, 12255, 12259,
   12267, 12273, 12280, 12286, 12293, 12302, 12303, 12307, 12309, 12314,
   12325, 12335, 12345, 12351, 12360, 12369, 12375, 12384, 12390, 12391,
   12395, 12396, 12400, 12412, 12413, 12424, 12440, 12441, 12452, 12463,
   12464, 12467, 12468, 12469, 12470, 12471, 12472, 12473, 12474, 12477,
   12478, 12482, 12483, 12484, 12495, 12515, 12516, 12520, 12525, 12549,
   12560, 12561, 12573, 12594, 12595, 12605, 12612, 12619, 12626, 12636,
   12649, 12650, 12654, 12655, 12659, 12660, 12664, 12677, 12690, 12699,
   12708, 12717, 12726, 12738, 12750, 12762, 12765, 12766, 12767, 12768,
   12769, 12770, 12773, 12774, 12775, 12823, 12824, 12828, 12842, 12857,
   12858, 12865, 12873, 12881, 12889, 12897, 12905, 12916, 12917, 12949,
   12966, 12984, 12985, 13005, 13009, 13013, 13028, 13035, 13042, 13052,
   13053, 13056, 13072, 13073, 13074, 13078, 13088, 13099, 13105, 13117,
   13130, 13136, 13137, 13141, 13153, 13161, 13166, 13171, 13176, 13181,
   13189, 13197, 13202, 13207, 13214, 13215, 13219, 13220, 13221, 13228,
   13229, 13233, 13234, 13238, 13239, 13243, 13244, 13248, 13252, 13253,
   13256, 13265, 13278, 13284, 13290, 13294, 13309, 13310, 13314, 13326,
   13342, 13354, 13366, 13378, 13393, 13396, 13401, 13402, 13410, 13430,
   13431, 13433, 13438, 13439, 13443, 13444, 13447, 13448, 13473, 13482,
   13492, 13493, 13497, 13498, 13499, 13500, 13501, 13505, 13518, 13525,
   13532, 13539, 13540, 13544, 13545, 13549, 13550, 13554, 13555, 13559,
   13571, 13572, 13573, 13574, 13578, 13579, 13589, 13597, 13616, 13617,
   13621, 13622, 13628, 13633, 13642, 13650, 13659, 13666, 13674, 13683,
   13692, 13696, 13701, 13708, 13737, 13741, 13755, 13776, 13798, 13811,
   13828, 13834, 13839, 13845, 13852, 13853, 13863, 13869, 13877, 13881,
   13885, 13892, 13900, 13905, 13906, 13907, 13908, 13912, 13913, 13928,
   13932, 13940, 13947, 13954, 13961, 13968, 13979, 13980, 13993, 13997,
   14005, 14019, 14033, 14034, 14049, 14060, 14073, 14078, 14079, 14082,
   14083, 14086, 14087, 14092, 14093, 14098, 14099, 14108, 14113, 14114,
   14118, 14122, 14128, 14153, 14164, 14178, 14179, 14183, 14197, 14254,
   14268, 14270, 14275, 14277, 14279, 14281, 14283, 14288, 14290, 14295,
   14303, 14314, 14342, 14343, 14347, 14349, 14354, 14363, 14383, 14403,
   14421, 14433, 14448, 14449, 14453, 14456, 14469, 14474, 14481, 14486,
   14492, 14497, 14506, 14508, 14511, 14515, 14516, 14517, 14518, 14519,
   14520, 14525, 14531, 14546, 14547, 14548, 14549, 14550, 14561, 14567,
   14575, 14576, 14582, 14587, 14592, 14597, 14602, 14607, 14612, 14617,
   14623, 14629, 14635, 14642, 14664, 14673, 14677, 14685, 14689, 14697,
   14709, 14730, 14734, 14740, 14744, 14757, 14765, 14775, 14777, 14779,
   14781, 14783, 14785, 14790, 14791, 14798, 14807, 14815, 14824, 14835,
   14843, 14844, 14845, 14849, 14851, 14853, 14855, 14857, 14859, 14861,
   14866, 14871, 14877, 14885, 14890, 14897, 14904, 14908, 14912, 14920,
   14955, 14956, 14958, 14967, 14974, 14990, 14992, 14994, 14996, 14998,
   15000, 15002, 15004, 15006, 15008, 15010, 15012, 15014, 15016, 15019,
   15021, 15024, 15026, 15028, 15030, 15033, 15038, 15047, 15052, 15061,
   15066, 15075, 15080, 15090, 15099, 15108, 15117, 15136, 15145, 15154,
   15163, 15172, 15189, 15198, 15207, 15216, 15225, 15234, 15243, 15247,
   15251, 15259, 15267, 15275, 15283, 15304, 15327, 15339, 15346, 15362,
   15367, 15373, 15380, 15387, 15395, 15403, 15420, 15439, 15465, 15467,
   15469, 15471, 15473, 15475, 15477, 15479, 15481, 15483, 15485, 15487,
   15489, 15491, 15493, 15495, 15497, 15499, 15501, 15505, 15509, 15514,
   15530, 15531, 15532, 15549, 15562, 15564, 15566, 15578, 15603, 15615,
   15627, 15635, 15646, 15657, 15667, 15673, 15682, 15692, 15702, 15715,
   15725, 15756, 15792, 15802, 15813, 15814, 15815, 15822, 15829, 15833,
   15837, 15841, 15845, 15849, 15853, 15857, 15861, 15865, 15869, 15873,
   15877, 15884, 15888, 15892, 15896, 15898, 15905, 15912, 15919, 15926,
   15937, 15951, 15961, 15972, 15988, 15998, 16005, 16012, 16019, 16023,
   16031, 16040, 16049, 16053, 16057, 16061, 16065, 16069, 16078, 16082,
   16092, 16096, 16100, 16105, 16116, 16122, 16136, 16147, 16161, 16177,
   16189, 16199, 16208, 16217, 16225, 16247, 16263, 16287, 16289, 16293,
   16295, 16297, 16300, 16303, 16306, 16307, 16310, 16318, 16328, 16329,
   16332, 16333, 16334, 16337, 16338, 16339, 16344, 16348, 16352, 16356,
   16363, 16364, 16372, 16373, 16377, 16378, 16386, 16387, 16391, 16392,
   16397, 16406, 16408, 16423, 16426, 16454, 16455, 16458, 16459, 16467,
   16475, 16483, 16492, 16502, 16520, 16566, 16575, 16584, 16593, 16602,
   16614, 16615, 16616, 16617, 16618, 16632, 16633, 16634, 16637, 16638,
   16641, 16644, 16645, 16646, 16649, 16650, 16653, 16654, 16655, 16656,
   16657, 16658, 16659, 16660, 16661, 16662, 16663, 16664, 16667, 16669,
   16674, 16676, 16681, 16683, 16685, 16687, 16689, 16691, 16703, 16707,
   16714, 16718, 16724, 16728, 16738, 16750, 16751, 16754, 16755, 16758,
   16762, 16766, 16772, 16773, 16778, 16788, 16789, 16790, 16791, 16792,
   16793, 16794, 16795, 16799, 16800, 16801, 16802, 16807, 16812, 16821,
   16842, 16846, 16851, 16862, 16879, 16885, 16886, 16887, 16890, 16898,
   16908, 16923, 16924, 16928, 16940, 16941, 16944, 16945, 16948, 16952,
   16959, 16963, 16967, 16976, 16988, 16989, 16993, 16994, 16998, 16999,
   17002, 17003, 17008, 17009, 17013, 17014, 17018, 17030, 17031, 17032,
   17033, 17034, 17035, 17036, 17037, 17038, 17042, 17044, 17049, 17050,
   17051, 17052, 17053, 17054, 17055, 17057, 17061, 17063, 17065, 17068,
   17072, 17075, 17079, 17088, 17106, 17113, 17118, 17124, 17125, 17126,
   17127, 17128, 17132, 17141, 17155, 17156, 17157, 17158, 17159, 17168,
   17169, 17170, 17171, 17172, 17176, 17178, 17188, 17191, 17197, 17198,
   17199, 17203, 17204, 17205, 17209, 17210, 17214, 17232, 17252, 17253,
   17262, 17263, 17267, 17268, 17271, 17279, 17287, 17295, 17318, 17319,
   17330, 17334, 17340, 17342, 17347, 17349, 17351, 17361, 17363, 17374,
   17378, 17382, 17386, 17390, 17399, 17407, 17439, 17443, 17450, 17458,
   17462, 17466, 17472, 17473, 17475, 17476, 17477, 17481, 17522, 17550,
   17554, 17558, 17564, 17566, 17580, 17617, 17630, 17631, 17634, 17635,
   17652, 17653, 17654, 17659, 17660, 17661, 17666, 17667, 17668, 17669,
   17675, 17676, 17677, 17678, 17679, 17685, 17686, 17706, 17707, 17708,
   17709, 17710, 17711, 17712, 17713, 17714, 17715, 17716, 17717, 17718,
   17719, 17720, 17721, 17722, 17723, 17724, 17725, 17726, 17727, 17728,
   17729, 17730, 17731, 17732, 17733, 17734, 17735, 17736, 17737, 17738,
   17739, 17740, 17741, 17742, 17743, 17744, 17745, 17746, 17747, 17748,
   17749, 17750, 17751, 17752, 17753, 17754, 17755, 17756, 17757, 17758,
   17759, 17760, 17761, 17762, 17763, 17764, 17765, 17766, 17767, 17768,
   17769, 17770, 17771, 17772, 17773, 17774, 17775, 17776, 17777, 17778,
   17779, 17780, 17781, 17782, 17783, 17784, 17785, 17786, 17787, 17788,
   17789, 17790, 17791, 17792, 17793, 17794, 17795, 17796, 17797, 17798,
   17799, 17800, 17801, 17802, 17803, 17804, 17805, 17806, 17807, 17808,
   17809, 17810, 17811, 17812, 17813, 17814, 17815, 17816, 17817, 17818,
   17819, 17820, 17821, 17822, 17823, 17824, 17825, 17826, 17827, 17828,
   17829, 17830, 17831, 17832, 17833, 17834, 17835, 17836, 17837, 17838,
   17839, 17840, 17841, 17842, 17843, 17844, 17845, 17846, 17847, 17848,
   17849, 17850, 17851, 17852, 17853, 17854, 17855, 17856, 17857, 17858,
   17859, 17860, 17861, 17862, 17863, 17864, 17865, 17866, 17867, 17868,
   17869, 17870, 17871, 17872, 17873, 17874, 17875, 17876, 17877, 17878,
   17879, 17880, 17881, 17882, 17883, 17884, 17885, 17886, 17887, 17888,
   17889, 17890, 17891, 17892, 17893, 17894, 17895, 17896, 17897, 17898,
   17899, 17900, 17901, 17902, 17903, 17904, 17905, 17906, 17907, 17908,
   17909, 17910, 17911, 17912, 17913, 17914, 17915, 17916, 17917, 17918,
   17919, 17920, 17921, 17922, 17923, 17924, 17925, 17926, 17927, 17928,
   17929, 17930, 17931, 17932, 17933, 17934, 17935, 17936, 17937, 17938,
   17939, 17940, 17941, 17942, 17943, 17944, 17945, 17946, 17947, 17948,
   17949, 17950, 17951, 17952, 17953, 17954, 17955, 17956, 17957, 17958,
   17959, 17960, 17961, 17962, 17963, 17964, 17965, 17966, 17967, 17968,
   17969, 17970, 17971, 17972, 17973, 17974, 17975, 17976, 17977, 17978,
   17979, 17980, 17981, 17982, 17983, 17984, 17985, 17986, 17987, 17988,
   17989, 17990, 17991, 17992, 17993, 17994, 17995, 17996, 17997, 17998,
   17999, 18000, 18001, 18002, 18003, 18004, 18005, 18006, 18007, 18008,
   18009, 18010, 18011, 18012, 18013, 18014, 18015, 18016, 18017, 18018,
   18019, 18020, 18021, 18022, 18023, 18024, 18025, 18026, 18027, 18028,
   18029, 18030, 18031, 18032, 18033, 18034, 18035, 18049, 18050, 18051,
   18052, 18053, 18054, 18055, 18056, 18057, 18058, 18059, 18060, 18061,
   18062, 18063, 18064, 18065, 18066, 18067, 18068, 18069, 18070, 18071,
   18072, 18073, 18074, 18075, 18076, 18077, 18078, 18079, 18080, 18081,
   18082, 18083, 18084, 18085, 18086, 18087, 18088, 18089, 18090, 18091,
   18092, 18093, 18094, 18095, 18096, 18097, 18098, 18099, 18100, 18101,
   18102, 18103, 18104, 18105, 18106, 18107, 18108, 18109, 18110, 18111,
   18125, 18126, 18127, 18128, 18129, 18130, 18131, 18132, 18133, 18134,
   18135, 18136, 18137, 18138, 18139, 18140, 18141, 18142, 18143, 18144,
   18145, 18146, 18147, 18157, 18158, 18159, 18160, 18161, 18162, 18163,
   18164, 18165, 18166, 18167, 18168, 18169, 18170, 18171, 18172, 18173,
   18174, 18175, 18176, 18177, 18178, 18179, 18180, 18181, 18182, 18183,
   18184, 18185, 18186, 18187, 18188, 18189, 18190, 18191, 18192, 18193,
   18194, 18195, 18196, 18197, 18198, 18199, 18200, 18201, 18202, 18203,
   18204, 18205, 18206, 18207, 18208, 18209, 18210, 18211, 18212, 18213,
   18214, 18215, 18216, 18217, 18218, 18219, 18220, 18221, 18222, 18223,
   18224, 18225, 18226, 18227, 18228, 18229, 18230, 18231, 18232, 18233,
   18234, 18247, 18248, 18249, 18250, 18251, 18252, 18253, 18254, 18255,
   18256, 18257, 18258, 18259, 18260, 18261, 18262, 18263, 18264, 18265,
   18266, 18267, 18268, 18269, 18270, 18271, 18272, 18273, 18274, 18275,
   18276, 18277, 18278, 18279, 18280, 18281, 18282, 18283, 18284, 18285,
   18286, 18287, 18288, 18289, 18290, 18291, 18292, 18293, 18294, 18295,
   18296, 18297, 18298, 18299, 18300, 18301, 18302, 18303, 18304, 18305,
   18306, 18307, 18308, 18309, 18310, 18311, 18312, 18313, 18314, 18315,
   18316, 18317, 18318, 18319, 18320, 18321, 18322, 18323, 18324, 18325,
   18326, 18327, 18328, 18329, 18330, 18331, 18332, 18333, 18334, 18335,
   18336, 18337, 18338, 18339, 18340, 18341, 18342, 18343, 18344, 18345,
   18346, 18347, 18348, 18349, 18350, 18351, 18352, 18353, 18354, 18355,
   18356, 18357, 18358, 18359, 18360, 18361, 18362, 18363, 18364, 18365,
   18366, 18367, 18368, 18369, 18370, 18371, 18372, 18373, 18374, 18375,
   18376, 18377, 18378, 18379, 18380, 18381, 18382, 18383, 18384, 18385,
   18386, 18387, 18388, 18389, 18390, 18391, 18392, 18393, 18394, 18395,
   18396, 18397, 18398, 18399, 18400, 18401, 18402, 18403, 18404, 18405,
   18406, 18407, 18408, 18409, 18410, 18411, 18412, 18413, 18414, 18415,
   18416, 18417, 18418, 18419, 18420, 18421, 18422, 18423, 18424, 18425,
   18426, 18427, 18428, 18429, 18430, 18431, 18432, 18433, 18434, 18435,
   18436, 18437, 18438, 18439, 18440, 18441, 18442, 18443, 18444, 18445,
   18446, 18447, 18448, 18449, 18450, 18451, 18452, 18453, 18454, 18455,
   18456, 18457, 18458, 18459, 18460, 18461, 18462, 18463, 18464, 18465,
   18466, 18467, 18468, 18469, 18470, 18471, 18472, 18473, 18474, 18475,
   18476, 18477, 18478, 18479, 18480, 18481, 18482, 18483, 18484, 18485,
   18486, 18487, 18488, 18489, 18490, 18491, 18492, 18493, 18494, 18495,
   18496, 18497, 18498, 18499, 18500, 18501, 18502, 18503, 18504, 18505,
   18506, 18507, 18508, 18509, 18510, 18511, 18512, 18513, 18514, 18515,
   18516, 18517, 18518, 18519, 18520, 18521, 18522, 18523, 18524, 18525,
   18526, 18527, 18528, 18529, 18530, 18531, 18532, 18533, 18534, 18535,
   18536, 18537, 18538, 18539, 18540, 18541, 18542, 18543, 18544, 18545,
   18546, 18547, 18548, 18549, 18550, 18551, 18552, 18553, 18554, 18555,
   18556, 18557, 18558, 18559, 18560, 18561, 18562, 18563, 18564, 18565,
   18566, 18567, 18568, 18569, 18570, 18571, 18572, 18573, 18574, 18575,
   18576, 18577, 18578, 18579, 18580, 18581, 18582, 18583, 18584, 18585,
   18586, 18587, 18588, 18589, 18590, 18591, 18592, 18593, 18594, 18595,
   18596, 18597, 18598, 18599, 18600, 18601, 18602, 18603, 18604, 18605,
   18606, 18607, 18608, 18609, 18610, 18611, 18612, 18613, 18614, 18615,
   18616, 18617, 18618, 18619, 18620, 18621, 18622, 18623, 18624, 18625,
   18626, 18627, 18628, 18629, 18630, 18631, 18632, 18633, 18634, 18635,
   18636, 18637, 18638, 18639, 18640, 18641, 18642, 18643, 18644, 18645,
   18646, 18647, 18648, 18649, 18650, 18651, 18652, 18653, 18654, 18655,
   18656, 18657, 18658, 18659, 18660, 18661, 18662, 18663, 18664, 18665,
   18666, 18667, 18668, 18669, 18670, 18671, 18672, 18673, 18674, 18675,
   18676, 18677, 18678, 18679, 18680, 18681, 18682, 18683, 18684, 18685,
   18686, 18687, 18688, 18689, 18690, 18691, 18692, 18693, 18694, 18695,
   18696, 18697, 18698, 18699, 18700, 18701
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "IDENT", "UIDENT",
  "FCONST", "SCONST", "USCONST", "BCONST", "XCONST", "Op", "ICONST",
  "PARAM", "TYPECAST", "DOT_DOT", "COLON_EQUALS", "EQUALS_GREATER",
  "LESS_EQUALS", "GREATER_EQUALS", "NOT_EQUALS", "ABORT_P", "ABSENT",
  "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER", "AGGREGATE",
  "ALL", "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE", "AND", "ANY",
  "ARRAY", "AS", "ASC", "ASENSITIVE", "ASSERTION", "ASSIGNMENT",
  "ASYMMETRIC", "ATOMIC", "AT", "ATTACH", "ATTRIBUTE", "AUTHORIZATION",
  "BACKWARD", "BEFORE", "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT",
  "BOOLEAN_P", "BOTH", "BREADTH", "BY", "CACHE", "CALL", "CALLED",
  "CASCADE", "CASCADED", "CASE", "CAST", "CATALOG_P", "CHAIN", "CHAR_P",
  "CHARACTER", "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS", "CLOSE",
  "CLUSTER", "COALESCE", "COLLATE", "COLLATION", "COLUMN", "COLUMNS",
  "COMMENT", "COMMENTS", "COMMIT", "COMMITTED", "COMPRESSION",
  "CONCURRENTLY", "CONDITIONAL", "CONFIGURATION", "CONFLICT", "CONNECTION",
  "CONSTRAINT", "CONSTRAINTS", "CONTENT_P", "CONTINUE_P", "CONVERSION_P",
  "COPY", "COST", "CREATE", "CROSS", "CSV", "CUBE", "CURRENT_P",
  "CURRENT_CATALOG", "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_SCHEMA",
  "CURRENT_TIME", "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR", "CYCLE",
  "DATA_P", "DATABASE", "DAY_P", "DEALLOCATE", "DEC", "DECIMAL_P",
  "DECLARE", "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER",
  "DELETE_P", "DELIMITER", "DELIMITERS", "DEPENDS", "DEPTH", "DESC",
  "DETACH", "DICTIONARY", "DISABLE_P", "DISCARD", "DISTINCT", "DO",
  "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH", "ELSE", "EMPTY_P",
  "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P", "ENFORCED", "ENUM_P",
  "ERROR_P", "ESCAPE", "EVENT", "EXCEPT", "EXCLUDE", "EXCLUDING",
  "EXCLUSIVE", "EXECUTE", "EXISTS", "EXPLAIN", "EXPRESSION", "EXTENSION",
  "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY", "FETCH", "FILTER",
  "FINALIZE", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR", "FORCE", "FOREIGN",
  "FORMAT", "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION", "FUNCTIONS",
  "GENERATED", "GLOBAL", "GRANT", "GRANTED", "GREATEST", "GROUP_P",
  "GROUPING", "GROUPS", "HANDLER", "HAVING", "HEADER_P", "HOLD", "HOUR_P",
  "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P",
  "IMPORT_P", "IN_P", "INCLUDE", "INCLUDING", "INCREMENT", "INDENT",
  "INDEX", "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P",
  "INNER_P", "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD",
  "INT_P", "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS",
  "ISNULL", "ISOLATION", "JOIN", "JSON", "JSON_ARRAY", "JSON_ARRAYAGG",
  "JSON_EXISTS", "JSON_OBJECT", "JSON_OBJECTAGG", "JSON_QUERY",
  "JSON_SCALAR", "JSON_SERIALIZE", "JSON_TABLE", "JSON_VALUE", "KEEP",
  "KEY", "KEYS", "LABEL", "LANGUAGE", "LARGE_P", "LAST_P", "LATERAL_P",
  "LEADING", "LEAKPROOF", "LEAST", "LEFT", "LEVEL", "LIKE", "LIMIT",
  "LISTEN", "LOAD", "LOCAL", "LOCALTIME", "LOCALTIMESTAMP", "LOCATION",
  "LOCK_P", "LOCKED", "LOGGED", "MAPPING", "MATCH", "MATCHED",
  "MATERIALIZED", "MAXVALUE", "MERGE", "MERGE_ACTION", "METHOD",
  "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P", "NAMES",
  "NATIONAL", "NATURAL", "NCHAR", "NESTED", "NEW", "NEXT", "NFC", "NFD",
  "NFKC", "NFKD", "NO", "NONE", "NORMALIZE", "NORMALIZED", "NOT",
  "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF", "NULLS_P",
  "NUMERIC", "OBJECT_P", "OBJECTS_P", "OF", "OFF", "OFFSET", "OIDS", "OLD",
  "OMIT", "ON", "ONLY", "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER",
  "ORDINALITY", "OTHERS", "OUT_P", "OUTER_P", "OVER", "OVERLAPS",
  "OVERLAY", "OVERRIDING", "OWNED", "OWNER", "PARALLEL", "PARAMETER",
  "PARSER", "PARTIAL", "PARTITION", "PASSING", "PASSWORD", "PATH",
  "PERIOD", "PLACING", "PLAN", "PLANS", "POLICY", "POSITION", "PRECEDING",
  "PRECISION", "PRESERVE", "PREPARE", "PREPARED", "PRIMARY", "PRIOR",
  "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "PROCEDURES", "PROGRAM",
  "PUBLICATION", "QUOTE", "QUOTES", "RANGE", "READ", "REAL", "REASSIGN",
  "RECURSIVE", "REF_P", "REFERENCES", "REFERENCING", "REFRESH", "REINDEX",
  "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE", "REPLACE", "REPLICA",
  "RESET", "RESTART", "RESTRICT", "RETURN", "RETURNING", "RETURNS",
  "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROLLUP", "ROUTINE", "ROUTINES",
  "ROW", "ROWS", "RULE", "SAVEPOINT", "SCALAR", "SCHEMA", "SCHEMAS",
  "SCROLL", "SEARCH", "SECOND_P", "SECURITY", "SELECT", "SEQUENCE",
  "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION", "SESSION_USER", "SET",
  "SETS", "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE", "SKIP",
  "SMALLINT", "SNAPSHOT", "SOME", "SOURCE", "SQL_P", "STABLE",
  "STANDALONE_P", "START", "STATEMENT", "STATISTICS", "STDIN", "STDOUT",
  "STORAGE", "STORED", "STRICT_P", "STRING_P", "STRIP_P", "SUBSCRIPTION",
  "SUBSTRING", "SUPPORT", "SYMMETRIC", "SYSID", "SYSTEM_P", "SYSTEM_USER",
  "TABLE", "TABLES", "TABLESAMPLE", "TABLESPACE", "TARGET", "TEMP",
  "TEMPLATE", "TEMPORARY", "TEXT_P", "THEN", "TIES", "TIME", "TIMESTAMP",
  "TO", "TRAILING", "TRANSACTION", "TRANSFORM", "TREAT", "TRIGGER", "TRIM",
  "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P", "TYPES_P", "UESCAPE",
  "UNBOUNDED", "UNCONDITIONAL", "UNCOMMITTED", "UNENCRYPTED", "UNION",
  "UNIQUE", "UNKNOWN", "UNLISTEN", "UNLOGGED", "UNTIL", "UPDATE", "USER",
  "USING", "VACUUM", "VALID", "VALIDATE", "VALIDATOR", "VALUE_P", "VALUES",
  "VARCHAR", "VARIADIC", "VARYING", "VERBOSE", "VERSION_P", "VIEW",
  "VIEWS", "VIRTUAL", "VOLATILE", "WHEN", "WHERE", "WHITESPACE_P",
  "WINDOW", "WITH", "WITHIN", "WITHOUT", "WORK", "WRAPPER", "WRITE",
  "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLEXISTS",
  "XMLFOREST", "XMLNAMESPACES", "XMLPARSE", "XMLPI", "XMLROOT",
  "XMLSERIALIZE", "XMLTABLE", "YEAR_P", "YES_P", "ZONE", "FORMAT_LA",
  "NOT_LA", "NULLS_LA", "WITH_LA", "WITHOUT_LA", "MODE_TYPE_NAME",
  "MODE_PLPGSQL_EXPR", "MODE_PLPGSQL_ASSIGN1", "MODE_PLPGSQL_ASSIGN2",
  "MODE_PLPGSQL_ASSIGN3", "'<'", "'>'", "'='", "'+'", "'-'", "'*'", "'/'",
  "'%'", "'^'", "UMINUS", "'['", "']'", "'('", "')'", "'.'", "';'", "','",
  "':'", "$accept", "parse_toplevel", "stmtmulti", "toplevel_stmt", "stmt",
  "opt_single_name", "opt_qualified_name", "opt_concurrently",
  "opt_drop_behavior", "CallStmt", "CreateRoleStmt", "opt_with",
  "OptRoleList", "AlterOptRoleList", "AlterOptRoleElem",
  "CreateOptRoleElem", "CreateUserStmt", "AlterRoleStmt",
  "opt_in_database", "AlterRoleSetStmt", "DropRoleStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "CreateSchemaStmt", "OptSchemaEltList",
  "schema_stmt", "VariableSetStmt", "set_rest", "generic_set",
  "set_rest_more", "var_name", "var_list", "var_value", "iso_level",
  "opt_boolean_or_string", "zone_value", "opt_encoding",
  "NonReservedWord_or_Sconst", "VariableResetStmt", "reset_rest",
  "generic_reset", "SetResetClause", "FunctionSetResetClause",
  "VariableShowStmt", "ConstraintsSetStmt", "constraints_set_list",
  "constraints_set_mode", "CheckPointStmt", "DiscardStmt",
  "AlterTableStmt", "alter_table_cmds", "partition_cmd",
  "index_partition_cmd", "alter_table_cmd", "alter_column_default",
  "opt_collate_clause", "alter_using", "replica_identity", "reloptions",
  "opt_reloptions", "reloption_list", "reloption_elem",
  "alter_identity_column_option_list", "alter_identity_column_option",
  "set_statistics_value", "set_access_method_name", "PartitionBoundSpec",
  "hash_partbound_elem", "hash_partbound", "AlterCompositeTypeStmt",
  "alter_type_cmds", "alter_type_cmd", "ClosePortalStmt", "CopyStmt",
  "copy_from", "opt_program", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "copy_delimiter",
  "opt_using", "copy_generic_opt_list", "copy_generic_opt_elem",
  "copy_generic_opt_arg", "copy_generic_opt_arg_list",
  "copy_generic_opt_arg_list_item", "CreateStmt", "OptTemp",
  "OptTableElementList", "OptTypedTableElementList", "TableElementList",
  "TypedTableElementList", "TableElement", "TypedTableElement",
  "columnDef", "columnOptions", "column_compression",
  "opt_column_compression", "column_storage", "opt_column_storage",
  "ColQualList", "ColConstraint", "ColConstraintElem",
  "opt_unique_null_treatment", "generated_when", "opt_virtual_or_stored",
  "ConstraintAttr", "TableLikeClause", "TableLikeOptionList",
  "TableLikeOption", "TableConstraint", "ConstraintElem",
  "DomainConstraint", "DomainConstraintElem", "opt_no_inherit",
  "opt_without_overlaps", "opt_column_list", "columnList",
  "optionalPeriodName", "opt_column_and_period_list", "columnElem",
  "opt_c_include", "key_match", "ExclusionConstraintList",
  "ExclusionConstraintElem", "OptWhereClause", "key_actions", "key_update",
  "key_delete", "key_action", "OptInherit", "OptPartitionSpec",
  "PartitionSpec", "part_params", "part_elem",
  "table_access_method_clause", "OptWith", "OnCommitOption",
  "OptTableSpace", "OptConsTableSpace", "ExistingIndex", "CreateStatsStmt",
  "stats_params", "stats_param", "AlterStatsStmt", "CreateAsStmt",
  "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "OptParenthesizedSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "NumericOnly_list",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_inline_handler",
  "validator_clause", "opt_validator", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "AlterForeignServerStmt",
  "CreateForeignTableStmt", "ImportForeignSchemaStmt",
  "import_qualification_type", "import_qualification",
  "CreateUserMappingStmt", "auth_ident", "DropUserMappingStmt",
  "AlterUserMappingStmt", "CreatePolicyStmt", "AlterPolicyStmt",
  "RowSecurityOptionalExpr", "RowSecurityOptionalWithCheck",
  "RowSecurityDefaultToRole", "RowSecurityOptionalToRole",
  "RowSecurityDefaultPermissive", "RowSecurityDefaultForCmd",
  "row_security_cmd", "CreateAmStmt", "am_type", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerReferencing", "TriggerTransitions", "TriggerTransition",
  "TransitionOldOrNew", "TransitionRowOrTable", "TransitionRelName",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "FUNCTION_or_PROCEDURE", "TriggerFuncArgs", "TriggerFuncArg",
  "OptConstrFromTable", "ConstraintAttributeSpec",
  "ConstraintAttributeElem", "CreateEventTrigStmt",
  "event_trigger_when_list", "event_trigger_when_item",
  "event_trigger_value_list", "AlterEventTrigStmt", "enable_trigger",
  "CreateAssertionStmt", "DefineStmt", "definition", "def_list",
  "def_elem", "def_arg", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "CreateOpFamilyStmt", "AlterOpFamilyStmt", "opclass_drop_list",
  "opclass_drop", "DropOpClassStmt", "DropOpFamilyStmt", "DropOwnedStmt",
  "ReassignOwnedStmt", "DropStmt", "object_type_any_name",
  "object_type_name", "drop_type_name", "object_type_name_on_any_name",
  "any_name_list", "any_name", "attrs", "type_name_list", "TruncateStmt",
  "opt_restart_seqs", "CommentStmt", "comment_text", "SecLabelStmt",
  "opt_provider", "security_label", "FetchStmt", "fetch_args", "from_in",
  "opt_from_in", "GrantStmt", "RevokeStmt", "privileges", "privilege_list",
  "privilege", "parameter_name_list", "parameter_name", "privilege_target",
  "grantee_list", "grantee", "opt_grant_grant_option", "GrantRoleStmt",
  "RevokeRoleStmt", "grant_role_opt_list", "grant_role_opt",
  "grant_role_opt_value", "opt_granted_by", "AlterDefaultPrivilegesStmt",
  "DefACLOptionList", "DefACLOption", "DefACLAction",
  "defacl_privilege_target", "IndexStmt", "opt_unique",
  "access_method_clause", "index_params", "index_elem_options",
  "index_elem", "opt_include", "index_including_params", "opt_collate",
  "opt_asc_desc", "opt_nulls_order", "CreateFunctionStmt",
  "opt_or_replace", "func_args", "func_args_list",
  "function_with_argtypes_list", "function_with_argtypes",
  "func_args_with_defaults", "func_args_with_defaults_list", "func_arg",
  "arg_class", "param_name", "func_return", "func_type",
  "func_arg_with_default", "aggr_arg", "aggr_args", "aggr_args_list",
  "aggregate_with_argtypes", "aggregate_with_argtypes_list",
  "opt_createfunc_opt_list", "createfunc_opt_list", "common_func_opt_item",
  "createfunc_opt_item", "func_as", "ReturnStmt", "opt_routine_body",
  "routine_body_stmt_list", "routine_body_stmt", "transform_type_list",
  "opt_definition", "table_func_column", "table_func_column_list",
  "AlterFunctionStmt", "alterfunc_opt_list", "opt_restrict",
  "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt", "oper_argtypes",
  "any_operator", "operator_with_argtypes_list", "operator_with_argtypes",
  "DoStmt", "dostmt_opt_list", "dostmt_opt_item", "CreateCastStmt",
  "cast_context", "DropCastStmt", "opt_if_exists", "CreateTransformStmt",
  "transform_element_list", "DropTransformStmt", "ReindexStmt",
  "reindex_target_relation", "reindex_target_all",
  "opt_reindex_option_list", "AlterTblSpcStmt", "RenameStmt", "opt_column",
  "opt_set_data", "AlterObjectDependsStmt", "opt_no",
  "AlterObjectSchemaStmt", "AlterOperatorStmt", "operator_def_list",
  "operator_def_elem", "operator_def_arg", "AlterTypeStmt",
  "AlterOwnerStmt", "CreatePublicationStmt", "PublicationObjSpec",
  "pub_obj_list", "AlterPublicationStmt", "CreateSubscriptionStmt",
  "AlterSubscriptionStmt", "DropSubscriptionStmt", "RuleStmt",
  "RuleActionList", "RuleActionMulti", "RuleActionStmt",
  "RuleActionStmtOrEmpty", "event", "opt_instead", "NotifyStmt",
  "notify_payload", "ListenStmt", "UnlistenStmt", "TransactionStmt",
  "TransactionStmtLegacy", "opt_transaction", "transaction_mode_item",
  "transaction_mode_list", "transaction_mode_list_or_empty",
  "opt_transaction_chain", "ViewStmt", "opt_check_option", "LoadStmt",
  "CreatedbStmt", "createdb_opt_list", "createdb_opt_items",
  "createdb_opt_item", "createdb_opt_name", "opt_equal",
  "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "drop_option_list", "drop_option", "AlterCollationStmt",
  "AlterSystemStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt", "any_with",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "AnalyzeStmt", "utility_option_list", "analyze_keyword",
  "utility_option_elem", "utility_option_name", "utility_option_arg",
  "opt_analyze", "opt_verbose", "opt_full", "opt_freeze", "opt_name_list",
  "vacuum_relation", "vacuum_relation_list", "opt_vacuum_relation_list",
  "ExplainStmt", "ExplainableStmt", "PrepareStmt", "prep_type_clause",
  "PreparableStmt", "ExecuteStmt", "execute_param_clause",
  "DeallocateStmt", "InsertStmt", "insert_target", "insert_rest",
  "override_kind", "insert_column_list", "insert_column_item",
  "opt_on_conflict", "opt_conf_expr", "returning_clause",
  "returning_with_clause", "returning_options", "returning_option",
  "returning_option_kind", "DeleteStmt", "using_clause", "LockStmt",
  "opt_lock", "lock_type", "opt_nowait", "opt_nowait_or_skip",
  "UpdateStmt", "set_clause_list", "set_clause", "set_target",
  "set_target_list", "MergeStmt", "merge_when_list", "merge_when_clause",
  "merge_when_tgt_matched", "merge_when_tgt_not_matched",
  "opt_merge_when_condition", "merge_update", "merge_delete",
  "merge_insert", "merge_values_clause", "DeclareCursorStmt",
  "cursor_name", "cursor_options", "opt_hold", "SelectStmt",
  "select_with_parens", "select_no_parens", "select_clause",
  "simple_select", "with_clause", "cte_list", "common_table_expr",
  "opt_materialized", "opt_search_clause", "opt_cycle_clause",
  "opt_with_clause", "into_clause", "OptTempTableName", "opt_table",
  "set_quantifier", "distinct_clause", "opt_all_clause",
  "opt_distinct_clause", "opt_sort_clause", "sort_clause", "sortby_list",
  "sortby", "select_limit", "opt_select_limit", "limit_clause",
  "offset_clause", "select_limit_value", "select_offset_value",
  "select_fetch_first_value", "I_or_F_const", "row_or_rows",
  "first_or_next", "group_clause", "group_by_list", "group_by_item",
  "empty_grouping_set", "rollup_clause", "cube_clause",
  "grouping_sets_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "opt_alias_clause_for_join_using",
  "func_alias_clause", "join_type", "opt_outer", "join_qual",
  "relation_expr", "extended_relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "tablesample_clause", "opt_repeatable_clause",
  "func_table", "rowsfrom_item", "rowsfrom_list", "opt_col_def_list",
  "opt_ordinality", "where_clause", "where_or_current_clause",
  "OptTableFuncElementList", "TableFuncElementList", "TableFuncElement",
  "xmltable", "xmltable_column_list", "xmltable_column_el",
  "xmltable_column_option_list", "xmltable_column_option_el",
  "xml_namespace_list", "xml_namespace_el", "json_table",
  "json_table_path_name_opt", "json_table_column_definition_list",
  "json_table_column_definition", "path_opt",
  "json_table_column_path_clause_opt", "Typename", "opt_array_bounds",
  "SimpleTypename", "ConstTypename", "GenericType", "opt_type_modifiers",
  "Numeric", "opt_float", "Bit", "ConstBit", "BitWithLength",
  "BitWithoutLength", "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "JsonType", "a_expr", "b_expr", "c_expr", "func_application",
  "func_expr", "func_expr_windowless", "func_expr_common_subexpr",
  "xml_root_version", "opt_xml_root_standalone", "xml_attributes",
  "xml_attribute_list", "xml_attribute_el", "document_or_content",
  "xml_indent_option", "xml_whitespace_option", "xmlexists_argument",
  "xml_passing_mech", "within_group_clause", "filter_clause",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "opt_window_exclusion_clause", "row", "explicit_row",
  "implicit_row", "sub_type", "all_Op", "MathOp", "qual_Op", "qual_all_Op",
  "subquery_Op", "expr_list", "func_arg_list", "func_arg_expr",
  "func_arg_list_opt", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "unicode_normal_form", "overlay_list",
  "position_list", "substr_list", "trim_list", "in_expr", "case_expr",
  "when_clause_list", "when_clause", "case_default", "case_arg",
  "columnref", "indirection_el", "opt_slice_bound", "indirection",
  "opt_indirection", "opt_asymmetric", "json_passing_clause_opt",
  "json_arguments", "json_argument", "json_wrapper_behavior",
  "json_behavior", "json_behavior_type", "json_behavior_clause_opt",
  "json_on_error_clause_opt", "json_value_expr", "json_format_clause",
  "json_format_clause_opt", "json_quotes_clause_opt",
  "json_returning_clause_opt", "json_predicate_type_constraint",
  "json_key_uniqueness_constraint_opt", "json_name_and_value_list",
  "json_name_and_value", "json_object_constructor_null_clause_opt",
  "json_array_constructor_null_clause_opt", "json_value_expr_list",
  "json_aggregate_func", "json_array_aggregate_order_by_clause_opt",
  "opt_target_list", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "attr_name", "file_name",
  "func_name", "AexprConst", "Iconst", "Sconst", "SignedIconst", "RoleId",
  "RoleSpec", "role_list", "PLpgSQL_Expr", "PLAssignStmt",
  "plassign_target", "plassign_equals", "ColId", "type_function_name",
  "NonReservedWord", "ColLabel", "BareColLabel", "unreserved_keyword",
  "col_name_keyword", "type_func_name_keyword", "reserved_keyword",
  "bare_label_keyword", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-5950)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-3012)

#define yytable_value_is_error(Yyn) \
  ((Yyn) == YYTABLE_NINF)

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const int yypact[] =
{
   18907,    57, 22319, -5950, -5950,    57, 71864, -5950, 81573,  1501,
     903,   105,   239, 21650, 82084, 92815,   591,   402,  9883,    57,
   92815,  1074, 62154, 77485,  1029, 92815,  1518,  1161, 62154, 92815,
   93326,  1410,  1637,  1377, 93837, 82595, 76463,   113, 92815,  1692,
     463, 94348, 83106,  1625, 83617,  1161, 57055,   213,  1567, 94859,
   92815,119814,   463, 84128, 84128, 84128,  2431,  2279,  1783, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950,  1537, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950,  2925, -5950,   212,
    3240,  1417,  1229,  1710, -5950, -5950,  2426, 71864, 92815, 92815,
   92815,  2196, 92815,  2105, 92815,   964, 71864, 68287, 84639,  2265,
    2110, 52851, 95370, -5950, 71864, 92815, 65732, 71864, 92815, 92815,
   95881, 92815, 96392, 92815,   139, 80040, 92815,  2251, 92815, 92815,
   66243, 96903,  2357,  1649,   273, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950,  2119,  2066, -5950,   285, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, 62665, 92815, 13260,  1518,  2426,
   -5950,  2431, 92815,  2390, 92815,  2136, 97414, 92815, -5950, 92815,
    2178, 97925,   976,    84, 68287,  1824, 53381,  2308, 92815, 92815,
   68287, 98436, 98947, 99458, 92815, 92815, -5950, -5950,  2294, 92815,
   -5950,  2415, 68798,  1855,  2437,  2627,  2511,  1493, -5950, 85150,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, 71353,   402,
   -5950, -5950,  2473, 72375,  2568, -5950, -5950, 99969,120311,  2323,
   -5950,   999, 72886, 69309,  2707,  2372, 53911,  2754, -5950, 73397,
   -5950, 69820, 73908, -5950, -5950, -5950, -5950, -5950,100480, -5950,
  100991,  2455,  2568, -5950,120808, 70331, -5950,  2636,101502,102013,
  102524,  2426,  2353,  1557,  2441, 47122, -5950, -5950, -5950,  2366,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,   457,
    1802,   319,   264,   332, -5950, -5950,   274,   277,   283,   457,
    2873,  2873, -5950, 92815, -5950, -5950,  1802,   106,  2474,  2397,
    2397,  2397,  2598,    22, -5950,  2397,  2503, -5950, -5950, -5950,
   -5950, 83617, -5950,  2387,  1518,  2401,  2883,  2465, 62665,  1189,
   92815, -5950, -5950,  2930,  2476,  2766,  2452, -5950, -5950, -5950,
    2709,  2711,   166,   782,  1518,   302, -5950,  2864, -5950,  2731,
   31907, 31907,  1518, 85661,103035,   340, 71353,  1518, 86172,  2534,
     276,  2735, -5950, -5950, -5950,   184, -5950,  3007,  2548,  2847,
    2452,  1649, 49190, -5950, -5950,  2566,  2066, 83617, -5950, -5950,
   -5950, 62665,  2898, 35081, 92815,  2560, -5950,  2580,  2560, -5950,
   -5950,  2647, -5950,  2647,  2647,  2625,  2625,  2798,  2644, -5950,
   -5950, -5950, -5950,  2061,  2647,  2625, -5950,121802, -5950,  2012,
    2017, -5950, -5950,  3147, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950,  2649, -5950,  1392, -5950,  2044, -5950, -5950, -5950,
   31907, -5950, -5950, -5950, -5950, -5950, -5950, -5950,  2661,  2681,
    1417, -5950,  8270, 62665, 83617,  1729,  1729,  3165,  1729,  2070,
    2082, -5950,  3333, -5950,  3050,  3010,  3014, 83617,  2752,   339,
   -5950,  1927,  2758,  2090,  2700,  1942,  3306, -5950,   745, 92815,
     295,  2765, 86683,  4056,  2759,  2066,  2776, -5950, -5950, -5950,
   -5950,  2875,   449, -5950, -5950, -5950, -5950,  3045,  3113,  5946,
     369, 87194, -5950, -5950, -5950, -5950, 92815, 92815, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950,  2790,  1560, -5950,
   -5950,  2799,  3124,  3032,  9757,  1077,  3148,  2981,  2085, 10312,
    3044,  1859,  3200, 15841,  1643,  3204,  1970,  2541, 87705, 92815,
    3174,  3230,  5628,  1963,   948,  3081,  1513,  3148,  3223,  3035,
    2085,  3247,  2746, 92815, -5950,  3155,  3292,   832, -5950,   358,
   -5950, 24556, 35081, 56544, -5950,  2066, -5950,  2072, -5950, -5950,
   61643, -5950,  2936,  3106,   131, 71864,  2882, 92815, 92815, -5950,
  119814, 71864, -5950,  3117, 54441, 71864, -5950, 71864, -5950, -5950,
    3249,119814, 92815, 92815, -5950, 92815, -5950, -5950,  2885, -5950,
   -5950, -5950, -5950, -5950,  2397, 92815,  3351,119814,  3131,   180,
    1827,  3388, 92815,  3134,  1827,  2931,103546, -5950, -5950,  1827,
   -5950, -5950, -5950, 92815, 92815,  2894,  2289,  3125,   928,  1827,
    3141,  3389,  3391,  3149,  2983,  3151,  2580, -5950,  3357,  3120,
     953,   247,  2205,  1827,  2965,104057,104568, 92815,  2977, 92815,
    3376, 71864,  3012, 71864, 71864, 92815,  3296, 92815, -5950,  3122,
   -5950, -5950,  1471, -5950, -5950, -5950, -5950, -5950,  3314, -5950,
     240,  3315,  2942,  3321,  1946,  3324,   241, -5950, -5950,  2990,
   -5950,  3335,   244, -5950,  3338, -5950,  2957,105079, -5950,105590,
  106101,  3340,   290, -5950, 68287,  3343,   244,  3344,  2957,  3346,
     244,  3348,  1007,  3350, -5950,  1028,  3337,  3352,   241,  3353,
    2250,  2957, -5950,  3354,   309, -5950,  3358,   390, -5950,  3360,
    3203, -5950, 35081, -5950,  3080, -5950,  1567,  2122,  2441,  1802,
   -5950, 92815,  1802, 92815,  1802, 92815,  1802, 92815,  1802, 92815,
   92815, 92815,  1802, -5950, -5950, -5950, 92815,  2984, 92815, -5950,
   92815, -5950, -5950, -5950, 78507, 68287, 79018, -5950, 92815, -5950,
     858,  1518, -5950, -5950,119814,  3484, 68287,  3376,  2123, -5950,
   -5950,  3376, -5950, -5950,  3376,  3376, -5950, -5950, -5950,  3271,
   92815,  3356, 78507, 68287,  3362, -5950,106612, -5950, 71353,  3216,
    2999, -5950, -5950, -5950, -5950, -5950,  2086,  3531,   292,  3532,
   35081,  3008,   292,   292,  3011,  3371, -5950, -5950, -5950,   300,
    3015,  3017, -5950,   303,   303, -5950,  3019,  3024, -5950,   308,
    3025,  3026,  3542,  3561,   321,   327,  3033,  3034,  3038,  3039,
    3042,  3046,  3047,  3049,  3053,  3055,  3059,  3060,  3064,  2061,
     292,  3065, 35081, -5950,  3067,   303,  3068,  3070,  3071,  3565,
    3072, -5950,  3575,  3073, -5950,   272,   315,  3074,  3075, -5950,
    3322, -5950,   328,  3085,  3087,  3090,  3091,  3093,  3094,  3095,
    3097, 35081, 35081, 35081, -5950, 29257,  2066,  1518, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950,   334, -5950, 51261, -5950,
    3140, -5950, -5950,  3323, -5950, -5950, 35081, -5950, -5950,  3470,
     860, -5950,   346, -5950, -5950, -5950,  2066,  3421,  3108, -5950,
   -5950,  1699,  3111, -5950,  1152, -5950, -5950, -5950, -5950, -5950,
   -5950, 70842,  3612, -5950,   380,  1518,   358,  1484,  3549, 60110,
   60621, -5950, -5950,  3402, -5950, 92815, -5950, -5950,  2066,   231,
    2130, -5950,  2366, 21127,  2143,  2560, 92815, 92815,  3617, -5950,
    3123, -5950, -5950, 35081, -5950, -5950, -5950,  2873, -5950,  2647,
    2647, -5950, -5950,  3619,  3214,  3217,  2873, -5950,  2873, -5950,
    3130,  3135,  2873,  3220,  3224,  3225, -5950,  3139,  3228,  2873,
   -5950, -5950, 63688,  2112, -5950,  3499,   375, -5950, -5950, -5950,
    2151, -5950,  3150, -5950,  2580, -5950, -5950,  1417,  1417, 35081,
    1417,   965,  1313, 32436, 35610,  3508,  3379,   307,  1601,  3515,
   -5950,  3384,  2070,  2082, 83617, 92815, 83617,107123,  3286, 35081,
   -5950,  3624,  3246,  3248,  3307, 59099, -5950,  3250,  3215,  3253,
    3312,  3168,  3255,  3259,  3318, -5950,  3458, -5950, -5950,  3265,
    3635,  3267,107634, -5950, -5950,   985, -5950, -5950, -5950,   985,
   -5950,  3195,  1334,  1441,  1390,  3275,   414,   255,  3632, -5950,
    1401, -5950, -5950,  3339, -5950, 22178, 92815,  3567,  6817,  3417,
     369,  3336, -5950, -5950, -5950,  3479,  3282, 92815,  3284,  3435,
     369,   992,108145, -5950, -5950, 92815, -5950, -5950, -5950, -5950,
    6180,  3606, 27732, -5950,  1951,  3288,  3263,  3299, 92815, 74930,
     440,  3407,  3429,  1660,  2236,   291,  3361, 92815,  1912,  3437,
   92815,  3206,  3295,  3297,  3553,  3213,  1166,  3658,  3211, -5950,
   -5950, -5950,  3626, -5950,  1530,  1897,  3433, -5950,  3562,  3597,
    7471,  3298,  3301,117826, -5950,  3320,   772, 54971, 92815, 92815,
    3327,  3329,108656,  6180,  3641, 79529, 79529,  3332,  3341, 48673,
    3656,   829,  3342, -5950, -5950, -5950,   829,  3345,  3349,109167,
    6180,  3644, 92815,  3359,  3363, 92815,121802,   369, -5950,  3722,
   -5950,   369,   369,  2260,  3723,  3364,   399,  3506,   636,  1827,
   -5950,  3211,  2453, -5950,  3372,  3375,  1024, -5950,  3471, 92815,
    3377,  3378,  1847,  3431,  1518, -5950,  3434, -5950,  3380,  3438,
    3382,    86,  2894, -5950, -5950,  1311,  3365, 83617,  3455,  3463,
    1912,   496,  1034,  3211, -5950,  3383,  3385,  3213,  3213, 92815,
   92815, 92815, 92815, 92815,   281,  3749,   326,  3386,   298,  1069,
    3260, -5950,   829, 66754,  3390, -5950,   829, 92815,   289,  1130,
    3211,  1870,  2095, -5950, -5950, -5950,  1649, -5950, 35081, 35081,
   35081,  3264, -5950,  2432, 21127,   112, -5950,   348, 17010,  3283,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, 92815, 62665, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, 92815, -5950, 92815,  3579,
  119814,  3580,  3496,  3583,  3602,   369, 92815, 92815,  3611,  3614,
    3616,119814,  3618,  3622,  3623,  3534,  3394,   219,  3393,  3313,
    3814,  3697, 92815, 63688, -5950,   985, -5950,119814,  3546,  3709,
   -5950, 92815,  3576,    98, -5950,  3748,  3397, -5950, -5950,   111,
   92815, 77996,  2894, -5950, -5950,  3713, 68287,  1737,  3714,  1518,
    3392,  3717,  3569,  1518, 68287,  3620, 92815, 92815, 92815, 92815,
     189, -5950, 66754,  3584, -5950, 92815,  3588,  2453,  3589,  3848,
     921,  2397,109678,  3715, -5950,110189,  3367, 92815,  3368,  3368,
    3851,119814,  1492,  3647, -5950, -5950,  2337, -5950,  3501, -5950,
   71864, -5950, -5950, 71864, -5950, -5950,119814, 92815,  3370,119814,
  119814, -5950, -5950, 71864, 71864, -5950, 68287, 68287,  3736,   309,
    3737,  3424,  3740,  3439, 54971, 54971, -5950,   394, 71864, -5950,
   68287, 71864, -5950, 92815, -5950, 92815, -5950, -5950, -5950, -5950,
  119814,119814, -5950, 68287, 66754,  3750, 92815, 92815, -5950, 92815,
   92815, -5950, 92815, 92815,  2157,110700,  2441, -5950, 92815, -5950,
   92815, -5950, 92815, -5950, 92815, -5950, 92815, -5950, -5950, -5950,
   92815, -5950, 92815,  2163, -5950, -5950,  2174,  1592, 92815, 92815,
    1095, 71864, 92815,  3605, 92815, 71864, 71864, 92815, 92815, 92815,
   92815, 92815,  3462,  3111,   893, -5950,   349,   977, 83617,  3621,
   -5950, -5950,  2175,  2431,    50, 92815, -5950, 92815, 92815, 92815,
   -5950, -5950, 77485,  3733,   446, 79018, 92815, -5950, -5950,  4223,
   35081,  2066, 31373, -5950, -5950, 21127,  3426, 35081, 35081,  3381,
    2873,  2873, -5950,  1003, 35081, 35081, 35081, 28728, 35081, 35081,
   32965, 35081, 35081, 35081, 35081, 35081, 35081,  2873,  2873,  3387,
   35081,  6186, 35081, 54971, 35081, 40900, 25626, 35081, 35081, 29786,
     314,  3019, 35081,  3639, 41952, 35081,  1484,  3642, 35081,  1484,
    6186,  3907,  3907,  2278,  8894,  3395,  2066, -5950,  2873,  1089,
   -5950,   545,119814, 35081, 35081, 35081, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, 35081, -5950, 63688, -5950, -5950, -5950, -5950, -5950, -5950,
     183, -5950, -5950, -5950, -5950, -5950, -5950,  3226, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, 92815, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, 30315,
   -5950, -5950, -5950, -5950,  3400, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950,  2890, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, 30844, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950,  3401, -5950, -5950,
   35081, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950,  3473, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950,   942, 35081, 35081, 35081, 35081, 35081,
   35081, 35081, 35081, 35081, -5950, 35081,   548, -5950, -5950,  3735,
    3470,   719,   627,  3403,  3604, 88216, 31907,  3499, 24556, -5950,
     293,  3499, -5950, -5950, -5950, 92815,  3612, -5950, -5950,  3476,
   -5950, -5950, -5950, -5950, -5950,   351, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950,  3406, -5950, -5950, -5950, -5950,  3406, -5950,
    3405,  3728,  3732,  1007, 83617,  2517, 35081,   183,   282, 92815,
   35081,  3400,  2890, 35081,  3401, 35081,  3473, -5950, 35081, -5950,
    2208,   245, 35081,  2228,  3410, -5950, -5950,  3396,  3135,  3416,
    3430,  3411,  3412,  2873,   262,  3414,  1434,   203,  3558,  2873,
    3678,  3418, -5950, 63688, -5950, 44020,  3466, -5950, -5950, -5950,
     463, 83617, 83617, -5950,  3741, -5950,  3427, -5950, 17325,  3741,
   -5950, -5950, 41426,  3551,  3720,  3653, -5950, -5950, -5950,  3432,
   21127, 36139, 36139, -5950,  2342, 21127,  2347, -5950, -5950, -5950,
   -5950, -5950, -5950,  1629, -5950, 92815,   848,  3508,  1601,  3485,
    1333,  3933,  3504, 92815, -5950, 49707,  2229, -5950, 68287, 92815,
   92815,  3655, -5950,  3919, -5950,121802, -5950,  3442, -5950,121305,
  116832, -5950, -5950,  1151, -5950,  1449, 68287, -5950, 92815, 92815,
   68287, 92815, 92815, -5950, 68287,  3497, 92815, 92815, -5950, -5950,
   -5950, -5950, -5950, 61132,  1099, 77485,  3590, 76974, -5950, -5950,
    3451, 92815,  3691, -5950, -5950,111211, -5950,  3692, 68287, 92815,
   92815, 35081,  3693, 92815, 92815, -5950,   411,  3545,  3547, -5950,
   92815,  3550, 71864,  3461,119814, 71864, 55501, 71864, 71864,  3822,
  119814, 92815, 92815,  1485, 83617,   514,  1165,  3211,  3702, -5950,
    1483, -5950, 68287, -5950, 92815,  3694, -5950, -5950, -5950, 88727,
    3953,  3591, -5950, -5950, -5950,111722, -5950, -5950,  3695, -5950,
    2243, -5950, 68287, 68287, 92815,  7629,  3472,112233, 92815,  1102,
    3761,  3716,  3712,  3766,  1142, -5950, -5950, -5950,119814, -5950,
   92815, 89238, 92815, 92815,  3759, 92815, 80551,112744,113255,  1564,
    1638,  3760, 92815, 81062,  3762, -5950,  3628, 92815, -5950, -5950,
   64199, 68287, 92815,   221, 63688, -5950,  3744, -5950, 92815, -5950,
     956, -5950, 92815,  8086,  3706, -5950, -5950,  3570,  3581, 92815,
     520,  1236,  3211,  3889, 92815, 92815,  3482,  2245, 68287, 92815,
   63688, -5950,  3718,   799, 68287, 92815, 88727, -5950,  3719, -5950,
   83617,  3821, -5950,  3486,  2397,  2566,  2079,  3486, 68287, 92815,
   -5950,  3486, 92815,103035, -5950, 68287,  1207, -5950, 68287, 92815,
   88727, -5950,  3726,  3657, 68287, 92815, 18461, -5950, -5950, -5950,
     369, -5950, -5950, -5950, -5950, -5950, 92815, 92815,   369, 92815,
   92815,   369,  1746, -5950, 68287, 92815, -5950, -5950, -5950,  3627,
   68287, 92815, 92815,   366, 92815, -5950, 92815, 68287,  3539, 92815,
   92815, -5950, -5950, 92815,  7036, 92815, 92815, 92815, 92815, 92815,
   92815, 68287, 92815, -5950, -5950,  2338,  1140,   830,  1162,   207,
   92815,  3828, 92815,113766,  1518, 68287, 92815, 92815,  1518, 92815,
   63688,  1794, -5950, -5950,  3633, -5950, 68287,  1207, -5950,  8066,
   92815, 92815, 92815,  3592,  3593,   278,  3670, -5950, -5950, -5950,
     935,   935,  3721, -5950, 35081, 35081, 33494,  3505, -5950, -5950,
   35081,  2936, -5950, -5950, -5950,  1075,  4005,  1075,114277,  1075,
    1075,  3820,  3573,  3587,  1075,  1075,  1075,  3809,  1075,  1075,
    1075, 92815,  3705, -5950, -5950,  3705,   865, 35081,119814, 92815,
   -5950,  2259, -5950,  3528, -5950, -5950, 63688, 92815,   234,   987,
    3903,  3758, 75441,  2288,  3892, 92815,  3582, 92815,  4027,  3630,
    1498, -5950,  2288, 92815, -5950,  3110, 77485, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, 92815, -5950, -5950,  3894, 92815, 44537,
    3724, -5950,  1518,  2894,  2894,  2894,  2894,  3533,  2894, 92815,
    3671,  3915,  2288,  3538,  3917, -5950,  2453,  3918,  2007, 92815,
    3774, 75441,  3608,  3586,  3789,  4045,  2397,  1518,  3791,  3775,
   -5950, 59599, -5950,  2894,  4060, 28230,  4657,  5328,  3778,  3845,
   -5950, -5950,  3790,   959, 92815,  3900,  3902,  3926, -5950,   240,
   -5950,  4061,  1946,  3928,   241, -5950,   244, -5950,  2957, -5950,
   92815, -5950, 92815, 92815, 92815, 92815,   290, -5950, -5950,   244,
    2957,   244,  1007, -5950,  3858,   241,  2957,  3704,  3934,   309,
   -5950,   390, -5950,  3795,  1007, -5950,  3815,  2397, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950,  2267, -5950, 92815, -5950,  3908,
    3910,  3911,  3913,  3914,  3577,  3596,  3640, 92815,  3601,  3577,
     369,  3603,  3585, -5950,  3601,  3601,  3577,  3111,  3111,  3577,
    3596, 67265,  4065, 63688, -5950, -5950,  3696,  3609,  3964,   878,
   -5950,   883,    87,  3872, -5950, -5950, -5950, -5950,119814, -5950,
   68287,  3659, -5950, -5950, -5950,  3839,  3610, 67265,  1007,   172,
   -5950, 71864, 92815,119814, 71864,  3854, 71864, 71864,119814, 92815,
   92815,  2277, -5950,   -13, -5950,  2019, 35081,   558, -5950, 18188,
    2281, 35081,  3625,  3629, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950,  3634,  3980, -5950,  2283,  2299, 18294,  2360,119814,  2518,
    3645, -5950,  3646,   261,  3844,  3651,  3743,  3683,  2322,  3650,
     301, -5950,  3743,  1114,  3660,  9087,  3788,  3663,  2328,  3661,
    3667, -5950,  7001,  7654,  3668, 18825,  3669,  3676,  3677,  3631,
   40900, 40900, 29257,  1119, -5950, 40900,  3679,  3847,  2332, 17083,
    3680,  3682, 19001, 34023, 35081, 34023, 34023, 19139,  3686,  3701,
   -5950,  4046, -5950,  2348, 63688,  3850, 19531,  2361, -5950, 35081,
   63688,  8492, 35081, -5950, 35081,  3708, -5950, -5950,  2928,  2928,
    2928,  6186, -5950, -5950,  3672, -5950, 40900, 40900, -5950,  1676,
   29257, -5950, -5950,  4006, -5950, -5950,   265, -5950, -5950, -5950,
   -5950, -5950,  3355, -5950, -5950, -5950,  3896,  2360,  3287, 54971,
    3648, 35081,   368, 35081,  3400, 35081,  3781,  2928,  2928,  2928,
     389,   389,   336,   336,   336,  2131,   627, -5950, -5950, -5950,
    3703,  3711,  3604,  3725, 35081, -5950,  3707, 50224, -5950,  2526,
    2654, 92815,  4741,  4878,  6450, -5950, -5950, -5950,  3466,   112,
    3466, -5950,  1649,  2873,  1089, 61643, -5950, -5950, -5950, -5950,
   -5950, -5950, 83617, 21127, -5950, -5950,  3929,  3727,  2362, -5950,
   -5950,  2873, -5950, -5950,  2181,  2181,  3673, -5950,  3729, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950,  3739, -5950, -5950, -5950,
    3730,  3742, 45054,  4063,  3746, 43503, 89749,  3710,  2684, -5950,
   89749, 90260, 89749, 89749, -5950,  3745, -5950, -5950,  2066, 35081,
    4055, -5950, -5950, -5950, 35081, -5950, -5950,  1828,  3763,  1056,
    1250,  2321,  2321,  2342,  1298, -5950, -5950,  3782, -5950, 35081,
    2364, -5950,  2371, -5950, -5950, -5950, -5950,  3111, -5950,  3990,
   -5950, -5950, -5950, 44020,  3767,  3777,    75, 48156,  3949, -5950,
   92815, 44020, -5950, 92815,   223, -5950,  3734, -5950, -5950, -5950,
   -5950, -5950, -5950,116832,  2044, -5950,121305, -5950,121305, -5950,
    2044,  4206, -5950,116832,  1939, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, 68287, 68287,
    3970, 92815,  3972,  3973, 35081,  1172, -5950,  4132,  1007, -5950,
   -5950,  3843, -5950, 21127, -5950, -5950, -5950, -5950, -5950, 68287,
   92815, -5950, 71353, -5950, -5950,119814, -5950, -5950, 92815, 92815,
   -5950, -5950, -5950,119814, -5950, -5950, -5950, 92815,   197,  3846,
    3852, 92815, -5950,  1338,  3471,  8116, 92815, 92815, 92815,  4077,
   -5950, -5950, -5950, -5950,  3995, -5950,  4134, -5950,116832, -5950,
    2957,   153,  3853,  3211, 35081,  4011, -5950,   925, 92815,  3770,
    3771,  4141, 92815,  1653,  4101,  3776, -5950,  3888,  4104,  3912,
    2107, -5950, -5950,  3922, -5950, -5950, -5950, -5950,  4156,  1007,
    4160,  1007, 92815, 92815, 92815, 92815,  3927, -5950, -5950, -5950,
   -5950,  3930,  4069, -5950, 63688, 63688, 63688,  2376, -5950, -5950,
    1518, -5950, -5950, -5950, -5950, -5950, -5950,  4116, -5950,  2381,
   -5950,   668, 90771, -5950, -5950, -5950, -5950, -5950,  4163, 68287,
   92815,  9411, 92815, 92815, 92815,  4016,  2068,  1155,119814, -5950,
  118323, -5950, -5950,  2386, -5950,  3801, 92815,  3880, 68287,  3856,
   -5950, -5950, -5950,  4169,  2397,  3941, 79529,  3842,  3842,  2109,
   -5950, -5950, -5950, -5950, -5950,  4079,  4002, -5950,  1080,  4003,
   68287,  3868, -5950, -5950, -5950, -5950,  4178,  3895, -5950, -5950,
    3898,  1349,  3211,  2453, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950,  3920, -5950, -5950, -5950, -5950, -5950, -5950,
    1700,  1700, -5950, -5950, -5950,  1700,  1239,   543,  1445,  3211,
   -5950,   371,  1487,  3899, -5950,  3904, -5950, -5950, -5950,  4084,
    4086,  4087,  3916,  3923,  3966,  3924,  3925,  3975, -5950,  3931,
    3976,  3932,  3977,  3937,  4235,  1007,119814,  4075,  1518,  3971,
    4218,  1007, -5950, -5950,  3938, -5950,  3939, -5950,  2391,  4330,
    4331, -5950, 92815, -5950,   550,  1854,  3211, -5950,  3940, -5950,
   68287, 92815, -5950, -5950, -5950, 35081,  3855,  3857,  3859, 21127,
   21127, 35081, -5950, -5950, 21127,  3860, -5950, -5950, -5950, -5950,
  119814, -5950, 92815,  4164, -5950, -5950,  1075, 92815, 92815, -5950,
   -5950, -5950, 92815, -5950, -5950, -5950,  4165, -5950,   533,   533,
   -5950, -5950,  4201,  9159,  3861,   355, -5950, 63688, 51791,  4522,
     202,  1827, -5950, 71353, 92815, 71353, -5950,   987,  4085, 92815,
   92815, 92815,  3863,  3862, -5950, -5950, -5950, -5950, 68287,   901,
   68287,  2873, -5950, -5950,  3943, -5950, 92815,  2397,  4401,  4233,
    3539, -5950,  4358,  3391,  1737,  1911,   529,  2983,  4294,  2580,
   35081,   362, -5950, -5950,  2066, 92815,  3586, -5950, -5950, -5950,
   -5950,  1518, -5950,  3871,  3869, -5950, 92815,  4238, 92815, 92815,
   92815, 92815,  3659,  3875, 92815,  3877,119814, 92815,  2640,  3213,
    4374,  4257,  2431,  3608,  3968,  4260, 83617,  3893,  2392, -5950,
   -5950,   959, -5950,  2412,   209, -5950,  1518, 71353,117329,  4250,
   -5950,   333,  5328, -5950, -5950,   333,  1026, 92815, -5950, -5950,
   -5950, -5950,  4119,  2232, -5950,  4236, -5950, -5950,  2431, -5950,
  119814,  3901, -5950,  2417, -5950, -5950, -5950,   309,  3958,  1007,
    3965,  1007, -5950, -5950, -5950, -5950, 92815, -5950, 92815, 66754,
   -5950, -5950, 92815, -5950,  4281, -5950, -5950,  4051,  4053,  4054,
    4057,  4058, 92815,  3577, -5950,  3905, 92815, 92815, 68287,  1785,
   -5950, -5950, 68287,   456, -5950,   206, -5950, 83617,  4049, -5950,
   -5950, -5950, -5950,  4290,  4296, -5950, -5950, -5950,   983, -5950,
   78507,   468, -5950, 68287,  4225,  4228,  4229,  4230,   369,  4231,
    4232,  4237,  4239,  4240, -5950, -5950, -5950,  3935, 19388, 35081,
   -5950,  4311,119814, -5950,  9689, -5950, -5950, -5950, 35081, -5950,
   -5950,  4234, -5950, -5950,  3994,  4000,  3936,  3645,  3788, -5950,
    4151,  4157, 35081,  3788,  4411,  1121, 35081, 35081, 35081, -5950,
   -5950,  4161,  4166, 35081,  2360,  2360, 35081, -5950,  3942, 35081,
   -5950, -5950, -5950, -5950,  2339, 35081, -5950, 35081, -5950, -5950,
   26161,  4461,  4461,  3945,119814, 40900, 40900, 40900, 40900,  1830,
    3068, 40900, 40900, 40900, 40900, 40900, 40900, 40900, 40900, 40900,
   40900,   488, -5950,  4153, 35081, 35081, 34552, -5950, -5950,119814,
    3946,  3686,  3950,  3951, 35081, -5950, -5950, -5950,  2419, 42469,
    3952, 63688, -5950, 35081, 18125,  2425,  3993, 19669,  2066, 10506,
    1518, 35081,  1251,  1731, 35081,  2434, 35081, -5950, -5950, -5950,
   -5950,  4300, -5950, -5950, -5950, -5950, -5950, -5950,  4188,  2360,
   -5950, -5950, 35081,  3955,  3520, 40900, 40900,  4869, -5950,  4983,
   35081, 29257, -5950,  3721, -5950, 26696,  3954, 35081,116321, -5950,
   -5950,  1161,  1161,  1161,  1161, -5950, 92815, 92815, 92815,  4055,
    3959,  4055,   358,  3960, -5950, -5950, -5950, -5950,  2431, -5950,
    3947, -5950, -5950, -5950, -5950, -5950, 35081, 89749, 90260, 89749,
   89749,  3962, 42986, 27214,  2684,  3963, 92815, -5950, -5950,  3967,
   44020,  4271,  4181, -5950, 44020,  4181,  1644,  4181,  4274,  4067,
   50741, -5950, -5950,  3969, -5950, -5950,  4189, -5950,  1951, 21127,
    4448,  4317, -5950,  3974, -5950,  3763,  1976, -5950, -5950, -5950,
    1303, -5950,  4064, -5950, -5950, -5950,  3710, 36668,  4136, -5950,
   -5950, -5950,  4035,  2435, -5950, -5950,  4424,  4136, -5950,  2313,
   -5950,  2439, 49707,  3767, 35081,  2066,  2458,  1985, -5950, -5950,
  116832, -5950,  4059,  2957,  2957,  2813,  3577,  4343,  2813, 10814,
   -5950,  1909, 92815, -5950, 92815, -5950, -5950, -5950,  4478,  4047,
    4048,  4275, -5950,  2700, -5950, -5950, 68287, 92815, -5950, -5950,
   -5950,   556,  1971,  3211, -5950,  4070, -5950, -5950,  4307, 92815,
   -5950,  4464,  4089, 92815, 10914,  4367,  4062, -5950, -5950, 45571,
   92815, 92815, -5950, 92815, -5950, 92815, 92815,  1909, 91282, -5950,
    4442, -5950,  1909,  4109,  4348,  1858,  3213,   399,  6846, -5950,
    1978, -5950, -5950,  4073, -5950, 92815, -5950, 92815, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950,  4137, -5950, -5950, -5950, -5950,
   64199, -5950, -5950, 92815, -5950, 63688, 51791, 63688, -5950, -5950,
   -5950, 92815, -5950,  1563,   559,  1972,  3211, -5950,  4088, -5950,
    4372,  4091,  4093,  4144,   252,  1380,  4094,  4095,  4147,  4008,
    4009,  4010, -5950, 63688, 52321,  4182, 92815,  2957,  4013,  4066,
   92815,  3842, 91793, -5950,  4015, -5950, -5950,  3842,   457,  1518,
   -5950, -5950,  1518,  2957,  1518, 92815, 92815, 92815, 92815,   366,
   -5950, -5950, -5950,  4493,  4115, 92815, 92815, 92815, 92815, -5950,
    4076, -5950, -5950, -5950, 92815, 92815,  4384,  1090,  2287, 68287,
   92815, 92815, 68287, 92815, 92815, 92815, 92815, 92815, 92815, 92815,
    4247, -5950,  4480,  4402,  2315,  4449,  4108, 92815, -5950, 92815,
    1518, -5950,  3471, 92815, 92815, 92815, 92815, -5950, -5950, -5950,
   -5950, -5950,  3721, -5950,  4030,  4344,  1075, -5950,  4345,  4346,
    4349,  1075, -5950, -5950,  1827, -5950,   552, 92815, -5950,  2678,
   92815, -5950, -5950, -5950,  3974,  1530,  1897, -5950, -5950, -5950,
   -5950, -5950, -5950,  4032, 92815, 92815, 40900, -5950, -5950,   477,
    1738,  1550, -5950,  4334, 92815,  3322, -5950, -5950, -5950,   267,
   92815, -5950, -5950, -5950, -5950,  4041, -5950,   779,  3875, -5950,
    4368, 75441,  2957, 68287, 68287,  2957, -5950,119814,  4043,  3586,
   -5950,   306,  4133, -5950, 68287,  1737,114788,  3392,  4090,  4272,
   11350, 44020, 44537,  1700, -5950,  4052,  4044, -5950, -5950, 92815,
    4085, 66754,  2460,  2453,  4550,  1411,  2353, -5950, 75952,  4259,
    3875,  4368, -5950,  3213,  4284,  4282, -5950,  2431, 92815,  3659,
    3586,  1518, 92815,  4062, 51791, -5950,  4593,  2273, -5950,116832,
   35081, 35081, -5950,  4068, -5950,  4071,  5328, -5950,  4139,  4078,
    4554, 35081, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
    4168,  4081, 92815, 92815,   959, 92815, -5950,  4072,  3928, -5950,
    3928, -5950, 92815, -5950, 92815, -5950,  1007, -5950,  4199,  1007,
   92815, 92815, 92815, 92815, 92815, 92815,  3577,   369,  3585, -5950,
   -5950,  4417, 67265,  4419, -5950, 63688, -5950, -5950, -5950, -5950,
   -5950,  2467, 92815, -5950, -5950, -5950,  4492,  4443,  1007,   446,
    1143,  1143,  1143,  1143,  4403,  1143,  1143,  1143,  1143,  1143,
   -5950, 35081, 21127, -5950,  4092, -5950, 21127,  4481,  4385,  4388,
   -5950, -5950,  4096,  4333,  4340, -5950,  4102, 35081,  3788, 19757,
   -5950, -5950,  4342,  4347, -5950,  3788,  3788, 19757, -5950, 19757,
    4111, 11371, 19915, -5950,  2468, 35081, -5950,  1275,  1275,  1275,
     710,  4463, -5950,  2377,  1275,  1275,  1275,   393,   393,   311,
     311,   311,  4461,   488, 20066, 20169, 20477,  4112, -5950, -5950,
   -5950,  3686, -5950, 37197,   101,  4595, 41952, -5950, -5950, -5950,
    4171,  4172,  4118, -5950, 35081, 37726,  4117,121802,  4338, -5950,
    1852, 35081, 35081,  4624, -5950,  6335, 35081, -5950, -5950,  4624,
     551, 35081,  1775,  2485, 35081, 35081,  5096, 11637,  4130, -5950,
    2489, 35081, 11692,  4321, -5950, 92815, 92815, 92815, 92815, -5950,
   -5950, -5950,  4317,  1518,  4317,  1518,  4131, -5950,  4135, -5950,
   -5950, -5950, -5950, 64710,  4120,  3850, 89749,  4138, 92815,  2684,
   44020, -5950, -5950,  1452, -5950, 44020,  4444, -5950, 44020, 71864,
   -5950, 92815,  4143, 92815, -5950,  1729, 35081,  4179, 54971, -5950,
   -5950, -5950, -5950,  4241, -5950,  4369, 21127,  4184, -5950,  2431,
    2446, 92815,  2066,   784, -5950, 35081,  4154, 92815, -5950,  4136,
   21127, -5950,  4226,  2491, -5950, -5950,  4380, -5950, -5950, -5950,
   -5950, -5950,  4242, 77485,  4507, -5950, -5950, -5950,  1818,  4479,
     902, -5950,  1007, -5950,119814, 92815, 92815, 92815,  3168, -5950,
   -5950, 92815, 92815, 92815, 92815, -5950, -5950, 68287, 92815, -5950,
   -5950, 92815, 35081,  2493, -5950,  4194,  4613,   412,  4158, -5950,
    1909,    10,  1909, -5950,    10, -5950, -5950, 92304, -5950,  4085,
     366,   477,  4497,  4498,  4398, -5950,   369, -5950,  4659,   477,
    4405,   366, -5950, -5950, -5950, -5950,  2238, -5950,119814,  1007,
    1007, -5950, -5950, -5950, -5950, -5950,  4174, -5950,  4647,  4269,
   92815, 92815, 92815, 92815, 92815, 68287, 92815, 92815,  2873,  2873,
  119814,  4173, -5950,  2873,  2873,  4175, -5950, 68287, 92815, 92815,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950,  4263, -5950, 35081,  4640, -5950, -5950, -5950, -5950, -5950,
   35081, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, 68287, 92815,  4266, -5950,  4270, -5950,   963, -5950, -5950,
   92815, 92815, 92815, 92815,  4559, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950,  4561, 92815, -5950, -5950,
    1518,  1518,119814,  1007,  1007, -5950, -5950, -5950,  4277, -5950,
   -5950,  4186,  4501,  1075, -5950,  1075,  1075,  1075, -5950,  4191,
   -5950,  1827,  4603, -5950,  1909,  2014,  4551, -5950, 35081, -5950,
    1536,   710, -5950,  4612,  4696, -5950, -5950, -5950, -5950,  4446,
    3539,  2397,  3539, -5950, -5950, 71864,   434, -5950,  4534,   234,
   63688,  4433, 75441,   371,  2065,  4202,  4350, -5950,  2957,  2957,
    4273, 92815,  4704, -5950, -5950, -5950, -5950, -5950, -5950, 68287,
    3856, -5950,  4450,  1422,  4570, 92815, 44537, -5950,  3710, -5950,
   -5950, -5950,  1518, -5950, -5950,  4351,  3586, -5950,  2172, 92815,
    4441, 75441,  3659,  2497, -5950, -5950, -5950,  4254,  4690,  3608,
   -5950,   371,  4259, -5950, -5950,  4668,  4315,  4261,  4718, -5950,
    4315,  4579,  4451,  4224, -5950,  3893, -5950, 92815, -5950, 21127,
   21127,  1518,122299,   333,119814,  4587, -5950, 21127, 92815,   991,
    4222,  4400, -5950,  4552,  1007,  2509, -5950,  1007,  1007, -5950,
   92815, -5950,  3577,  3577,  3577,  3577,  3577, -5950,  4452, -5950,
   -5950, -5950, -5950,  4543, -5950, 67265, -5950,  1007, -5950, -5950,
   -5950, -5950, -5950, -5950,  1143, -5950, -5950, -5950, -5950, -5950,
   21127, -5950, 92815, -5950, -5950, -5950, -5950, -5950, -5950,  3427,
    4244, 35081,  2312, -5950, -5950,  4246,  4251,  3788,  3788, -5950,
   -5950, 35081, -5950, 11767, 40900,  4590, -5950, 35081, 35081, 35081,
   -5950,  4248,  2536,  2544, -5950, -5950,   101, -5950,  4595, -5950,
   -5950, -5950, 12353,  4291, 21127,  4354,  4252,   271,  4624,  4624,
    6335,  4624, 35081, 35081,  4624,  4624, 35081, -5950, -5950, -5950,
   12456, -5950,  4713,  3721, -5950, -5950, -5950, -5950,  4179, -5950,
    4179, -5950,  4394, 35081, -5950,  2545,  4735, 39842,  4710, -5950,
   92815,  2546, -5950, 35081,  4256, -5950, -5950, 44020,  1452,  4264,
    2550, 92815,  2572,119814, 38255, 21127, 92815,  3721,  4265, -5950,
   92815,  4267, 31907, -5950,    75, -5950, -5950,  4685, 45571,  4660,
   20591, 35081, -5950, -5950, -5950, -5950, -5950, 67265,  4483, 67265,
    1909, -5950, -5950, -5950, -5950, -5950, -5950, -5950,  4280, -5950,
   -5950, -5950, -5950,  4353, -5950, -5950,    53,  3621,  1909, -5950,
   12712,  4594, 45571, 56031, 92815, -5950, 92815, -5950,115299,  4285,
    4482,  4287,  4288, -5950, -5950, -5950, -5950,  4768,  4649,  4650,
   -5950, -5950,  4293, -5950, -5950, -5950,  4480, -5950, -5950, 51791,
   68287, 92815, -5950,  4370, -5950, -5950, -5950, -5950, -5950, -5950,
   47639, 54971, -5950,   252,  4295,  4297,  1380, -5950, -5950, -5950,
   92815, 13556,  4299, 13702,  1058,  3621, 92815, 92815,  4302,  4308,
    4310,  1777,  1602,  1967,  3577,  4664, 92815, -5950, -5950, -5950,
    4480, -5950, -5950, 92815, -5950,  1075, -5950, -5950, -5950, -5950,
   63688, -5950,  3413,  4191,  1518, 71864,  4794,  4794, 14397,  4553,
   -5950, -5950,   173,  4639, -5950,  4376,  4588,  4376,  4318, 92815,
     267,  4319,  2583, -5950, 92815,  4320,  4458,  2314,  2314, 92815,
   92815, 92815,  2587,  2431,  2957,  4066,  1737,  4701, 75441,  4747,
    4085,   438, -5950, 92815,  4823, 92815,  3659,  3875, 92815,  4325,
   -5950, -5950, 75952,  4549,  4522, 92815,  2640,  4259,  3608,  1455,
   92815, -5950,  1929, -5950,  2431, -5950, 92815, 83617, 45571,  4686,
   -5950,121305, -5950,  2591, -5950, -5950, -5950,  4408, 21565,  3466,
    4457,  4459,  4336,   233,  4695, 92815,  1237, -5950, -5950, -5950,
   -5950, -5950, -5950, 92815,   468, -5950, -5950, -5950, -5950,  4335,
   -5950,  4838, 35081,   342, -5950, -5950, -5950, -5950, -5950,  4573,
   -5950,  4352, -5950, -5950,  2763,  2312, 20725, -5950,  3334, 40900,
   21127, 21127, 21127, 35081, -5950, 35081, -5950, -5950, -5950, -5950,
     851, -5950, -5950,  4674,  4355,  4624,  4624,  4624, -5950, 35081,
    1190, -5950, -5950,  1454,  4773, 21016,  3745, 64710,  4357, -5950,
   40900,  2604, -5950,  3088, 92815,  2605, -5950, 21127, 92815, -5950,
   -5950, 35081, -5950,  2610, -5950,  4359,    59,  4360, 25091,  4362,
   -5950, -5950, -5950, -5950, -5950, 21127,  4363, -5950,  4848,  1601,
   -5950, -5950,   919,  3108,  4410, 92815,  2611, -5950,   828,   933,
      89, -5950,  4855,  4855, 21127,  1785,  2813,   432, -5950, 92815,
    4453, -5950,  4613,  4364,  3539, -5950,  4375, -5950, -5950,   442,
    3213, 92815,  4542, -5950,  4594,  4594,  4522,  4715, -5950, -5950,
   35081,  4432, -5950,  1128,  3621, 92815,119814, -5950,   167,  4740,
   -5950,119814,119814, -5950, -5950, -5950, 35081, -5950,  4484, -5950,
   -5950, -5950, 35081, 35081, 74419, -5950, -5950, 92815, 92815, 92815,
   92815, 92815, -5950,  1007, -5950, -5950,  2615, -5950, 46605, -5950,
   -5950,  3388,  1518,  3388,  1931, -5950, -5950,  3388,  3388, -5950,
    3466, -5950,  4794,  1490, -5950, -5950,  4446,  4381, 35081, -5950,
    4711, -5950,   199,  4614, -5950,  4386, -5950, 71864,  4921, -5950,
   63688,  3875,  4368, 92815, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950, -5950, -5950, -5950,  2620,  4085,  4769,  3586,
    4261, -5950, 92815,  4438, -5950, 44020,  4085,  2431,  2353, -5950,
    4259,  3875,  4368, -5950, -5950,  4406,  4282,  3608,  2640,  4555,
   -5950,  4557, -5950,  4866,  4631,  4874,  3659, -5950,  4062,  2622,
   92815, -5950, -5950,  5328,122299,119814, -5950, -5950, -5950,  4409,
    4813,  4462,  4465, -5950, -5950, -5950,   233, -5950,   114,  4818,
    4471, -5950,  4477, 92815, -5950, -5950,  4085,  1007, 35081, 63688,
   21127, -5950, -5950,  4811, -5950,   259,   275,   248,  4653,  4427,
   35081,  3334,  2626,  2628,  4488, -5950, -5950, -5950,  3686, 38784,
   38784, 38784,  4430,  4799,  4801, 92815, -5950, 92815,  4642, -5950,
   -5950, 92815,   710,  4431, 39842, 63688,  2630, -5950,118820, -5950,
    2632,  2655, -5950, 35081,  4436, 35081, -5950, 38255, 92815,  4439,
    3508, -5950, -5950,  2659, -5950,  4940,  2431, -5950,  3466, 45571,
   -5950,  4576, -5950,  4714, -5950, -5950, 35081,  4537,  4538, -5950,
    4805, -5950, -5950, 92815, -5950, 92815,  4376, 54971,  3763,   442,
   -5950, 92815,  3539,  3539,  4381, 14596, 35081, -5950,  4547, -5950,
   -5950,  2668,  1711, -5950, -5950,  2670,  2675, 15151, 92815,  2676,
    2680, -5950,  2702,  2873,  3596,  1967,  3596, -5950,  3577, -5950,
   -5950, 63688, -5950, -5950, 67776, -5950, -5950, -5950,  1518, -5950,
    1518,  4688, 57566, 58077,  1518,  1518, -5950, -5950, -5950, -5950,
   -5950,  2453, -5950, 15198,  4556, -5950, -5950, -5950,   557, -5950,
    4679,  4680, -5950,  4455, -5950,  2715, -5950,   371,  4592,  4085,
   -5950, -5950, 92815,  4960,  4962, -5950,  1432, 92815,  3710, -5950,
    4261,  3659,  3608,   371,  4259,  4522, 46088,  4315,  2640,  4282,
   -5950, -5950,  4692, -5950,  4693, -5950,  4467,  4798, -5950,  2226,
     333, -5950, -5950, -5950,  1218,  4827,  4828, -5950, -5950, -5950,
    3388, -5950,  1948,  4473,  4853, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950,  4514,   294,   299, -5950,  4515, -5950,  4658,  4661,
    2312,  2395, -5950, 21127, -5950, -5950, -5950, 40371,  4629,  1344,
   17868,  4861, -5950,  4861,  4861, -5950,  4958,  4959,  1144, -5950,
    4938,  2717, 41952, -5950, -5950, -5950, 92815,  4706,  1813,  4989,
    4652,  2726, 38255,  2727, -5950, -5950, -5950, -5950, -5950,   919,
   92815, -5950, -5950, -5950, 49707,  4971, 21127,   939,  1634, 67265,
    3621,  2733,  3842,  4496, -5950,  3763,  4502,  4376,  4376, -5950,
   -5950, 21127, 92815, 71864,  4978, -5950, -5950, -5950, -5950,  3621,
    4591, -5950, -5950, 74419, -5950, 92815, -5950, -5950,  2738, -5950,
   -5950, -5950, 58588, -5950,  4222, -5950,  4222, -5950, -5950,  1436,
      65, 92815,  1203,  1203,  4917, -5950,  4575, -5950,  4511, -5950,
    5043,  4654, 92815, -5950, -5950,   252,  2431, 75441,  4085, -5950,
   -5950,  2640,  4259,  3608, 35081,  2740, -5950,  4613,   412, -5950,
    4282,  4315, -5950, -5950, 45571,  4517,  3322,  4914, -5950, -5950,
   -5950,  2708, 71864, 71864, 92815, -5950, -5950, -5950, 35081,   267,
   -5950,  4562, -5950,  4566, -5950, -5950,  4748,  4757,  4539,  2312,
   -5950,  5039, -5950, -5950, -5950, -5950, -5950,   998, -5950, -5950,
   -5950, 92815, 92815, 92815,  4541, -5950,  3850, -5950, -5950, 40900,
   40900,  4777, -5950, 40900,  1813, -5950, 92815, -5950,  4544, -5950,
   -5950,  2764, -5950, -5950, -5950,  1502,  1480, -5950,  4784,  4676,
   -5950, -5950,  4787,   222, -5950,   432, -5950, -5950, -5950, -5950,
   -5950, 92815,  4588, -5950, -5950,  3621, -5950, 92815, -5950,  4548,
   -5950, -5950, -5950, 67776, -5950,  4222, -5950, -5950, -5950, -5950,
   -5950, -5950,  5059, -5950,  1497, -5950, -5950, -5950, -5950, 92815,
    4085,  4173,  4261, -5950,  4282,  3608,  2640, 15863, -5950, 46088,
   92815, 92815,  4315, -5950,  2770, 45571,  3586,  4700, -5950,  3145,
   -5950, -5950, -5950, -5950, -5950, -5950, -5950,   966,  4546,  4558,
   -5950, -5950, 16222, 71864, -5950, -5950,  4699,  4702, -5950,  4780,
   39313,  4707, -5950,  4775, -5950,  1405,  1414,  1922,115810,  5013,
     710,   710, -5950,   710, -5950, -5950, 35081, -5950, -5950, -5950,
   -5950, -5950, 49707, -5950,  4616,    75,  4564, 92815, -5950, -5950,
    1909,  4158,  4614,  1909,  1909, -5950, -5950, 35081, -5950, -5950,
    2397,  2397,  4085, -5950, -5950,  4315,  2640,  4282,  4613, -5950,
   -5950, -5950, -5950,  4798, -5950,  2781,  4315,  4471,  2744, -5950,
   -5950,  2750,  2681,  4655,  4919, -5950,  4565,  4678,  4681,  4952,
   -5950, -5950, -5950, 92815, 92815, 65221, 92815,   361,  2794, -5950,
  119317, 92815, 16487,  4571, -5950,  4632, 35081,  2801,  4577, -5950,
    2819, -5950, -5950, -5950, -5950,  4282,  4315, 92815,  3322, -5950,
   45571,  3466,  4955, -5950,  3145,  4698,  4703, 63177, -5950, -5950,
   -5950, -5950, -5950,  5109,   354,  4996, -5950, -5950,  1518,  2312,
  115810,  4802,   279,  2826, -5950,  4644,  2831,  1198, -5950,  1909,
   -5950,  4315, -5950, -5950,  3586, -5950, -5950,   267, -5950,  4628,
    4633, -5950,  2833, -5950, -5950, -5950, -5950, 35081, 65221,  2118,
    4599, -5950, -5950,  4790,  1518,  2763,  4790, -5950, -5950, -5950,
      75, -5950, -5950,  4315, 71864,  4945,  4947, -5950, 63177,   935,
    4656, 92815,  4601, -5950,  2312, -5950,   248,  2763,  4662,  3466,
    4602, 71864, 71864, -5950,  4605, 92815,  5047,115810, -5950,  2312,
     248,  4644, -5950, 63177, -5950, -5950,  1518, -5950,  4607,  2835,
   -5950,  2312, -5950,  2837,115810, -5950, -5950, -5950,  2841, -5950
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
    1742,  1474,   679,  1563,  1562,  1474,     0,   269,     0,  1574,
       0,  1474,   438,  1131,     0,     0,     0,     0,   679,  1474,
       0,  1742,     0,     0,     0,     0,     0,  1755,     0,     0,
       0,     0,     0,  1271,     0,     0,     0,  1474,     0,     0,
    1762,     0,     0,     0,     0,  1755,     0,  1576,     0,     0,
       0,     0,  1762,     0,     0,     0,     0,     0,     2,     9,
      10,    45,    80,    81,    38,    37,    98,    63,    24,    71,
     133,   132,   134,    50,    46,    88,    33,    35,    47,    51,
      73,    75,    40,    53,    64,   110,    72,    31,    70,    76,
      96,    58,    19,    20,    59,    21,    60,    22,    61,   106,
      82,    99,    43,    69,    30,    52,    78,    79,    12,    54,
      86,    18,    65,    66,    68,    91,    92,    93,   116,    94,
     128,    49,   125,   103,   104,   122,   105,   123,    16,   107,
      62,    23,   119,   118,   120,    89,    55,    90,    77,    97,
     117,    34,   121,    25,    26,    28,    29,    27,    67,    36,
      74,    39,    95,   124,   114,   109,   129,   127,    11,   135,
     111,    83,    14,    15,   100,    13,    32,    57,    17,    42,
      41,    56,    48,   131,    44,  1574,   102,   115,   101,    84,
     108,    87,   112,   130,   113,    85,   126,  1706,  1705,  1766,
    1709,  1741,     0,  1721,  1473,  1472,  1487,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   678,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1484,  2470,  2487,  2488,  2489,  2490,  2491,
    2492,  2493,  2494,  2495,  2496,  2497,  2498,  2499,  2500,  2501,
    2503,  2502,  2504,  2505,  2880,  2506,  2507,  2508,  2817,  2818,
    2881,  2819,  2820,  2509,  2510,  2511,  2512,  2513,  2514,  2515,
    2516,  2517,  2821,  2822,  2518,  2519,  2520,  2521,  2522,  2823,
    2882,  2523,  2524,  2525,  2526,  2527,  2528,  2883,  2529,  2530,
    2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,  2884,  2539,
    2540,  2541,  2885,  2542,  2543,  2544,  2545,  2546,  2547,  2824,
    2825,  2548,  2549,  2550,  2551,  2552,  2553,  2554,  2555,  2556,
    2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,
    2567,  2568,  2569,  2570,  2571,  2572,  2573,  2574,  2575,  2576,
    2577,  2578,  2826,  2579,  2580,  2581,  2582,  2827,  2583,  2584,
    2585,  2586,  2828,  2587,  2588,  2589,  2590,  2886,  2887,  2591,
    2592,  2593,  2594,  2595,  2829,  2830,  2596,  2597,  2598,  2599,
    2600,  2601,  2602,  2888,  2603,  2604,  2605,  2606,  2607,  2608,
    2609,  2610,  2611,  2612,  2613,  2614,  2615,  2889,  2831,  2616,
    2617,  2618,  2619,  2832,  2833,  2834,  2620,  2890,  2891,  2621,
    2892,  2835,  2836,  2837,  2838,  2839,  2840,  2841,  2842,  2843,
    2844,  2845,  2622,  2623,  2624,  2625,  2626,  2627,  2628,  2629,
    2846,  2893,  2630,  2894,  2631,  2632,  2633,  2634,  2635,  2636,
    2637,  2638,  2639,  2640,  2641,  2642,  2643,  2847,  2644,  2645,
    2646,  2647,  2648,  2649,  2650,  2651,  2848,  2895,  2849,  2652,
    2653,  2654,  2655,  2656,  2657,  2658,  2659,  2850,  2851,  2660,
    2661,  2662,  2896,  2663,  2852,  2664,  2853,  2665,  2666,  2667,
    2668,  2669,  2670,  2671,  2672,  2673,  2674,  2675,  2676,  2854,
    2897,  2677,  2898,  2855,  2678,  2679,  2680,  2681,  2682,  2683,
    2684,  2685,  2686,  2687,  2688,  2689,  2690,  2691,  2692,  2856,
    2693,  2857,  2696,  2694,  2695,  2697,  2698,  2699,  2700,  2701,
    2702,  2703,  2704,  2705,  2706,  2707,  2858,  2708,  2709,  2710,
    2711,  2712,  2713,  2714,  2715,  2716,  2717,  2718,  2719,  2720,
    2721,  2722,  2723,  2724,  2725,  2899,  2726,  2727,  2728,  2729,
    2730,  2859,  2731,  2732,  2733,  2734,  2735,  2736,  2737,  2738,
    2739,  2740,  2741,  2742,  2743,  2744,  2745,  2746,  2747,  2860,
    2748,  2749,  2900,  2750,  2751,  2861,  2752,  2753,  2754,  2755,
    2756,  2757,  2758,  2759,  2760,  2761,  2762,  2763,  2764,  2765,
    2766,  2767,  2862,  2768,  2769,  2770,  2771,  2901,  2772,  2773,
    2774,  2775,  2776,  2777,  2778,  2863,  2864,  2779,  2780,  2865,
    2781,  2866,  2782,  2783,  2784,  2785,  2786,  2787,  2789,  2788,
    2790,  2791,  2792,  2793,  2794,  2795,  2796,  2797,  2798,  2799,
    2800,  2867,  2868,  2801,  2902,  2802,  2803,  2804,  2805,  2806,
    2807,  2808,  2809,  2810,  2811,  2812,  2813,  2869,  2870,  2871,
    2872,  2873,  2874,  2875,  2876,  2877,  2878,  2879,  2814,  2815,
    2816,   146,     0,     0,  2437,  2471,  2472,  2475,  2470,   408,
     407,  1695,  2434,  2471,  1573,     0,  1552,   679,     0,  1487,
     437,  1742,     0,     0,     0,     0,     0,     0,   898,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   138,     0,   140,     0,     0,   462,   461,     0,     0,
    1103,   467,     0,     0,     0,     0,     0,   669,  1615,  2694,
    1613,  1696,   270,   273,   274,   271,   272,  2453,     0,  1243,
    1244,  1246,     0,     0,  1256,   936,   937,     0,     0,     0,
     950,     0,     0,     0,   934,     0,     0,     0,   956,     0,
     953,     0,     0,   957,   954,   931,   955,   938,     0,   930,
       0,     0,  1256,   958,     0,     0,   932,     0,     0,     0,
       0,  1487,  1612,   468,  1742,     0,  1596,  1597,  1598,  1574,
    1586,  1599,  1591,  1593,  1592,  1594,  1595,  1590,  2452,  2489,
    1026,  1026,  1026,  1026,  1023,  1024,  1026,  1026,  1026,  2714,
       0,     0,  1005,     0,  1007,  2454,  1026,  1031,  2497,   555,
     555,   555,     0,  1030,  1035,   555,     0,  1455,  1496,  2436,
    1754,     0,  1006,  1454,  2779,  1602,     0,     0,     0,     0,
    2733,  1464,   254,  2745,  2863,  2779,   253,   248,   249,   222,
       0,     0,  1030,   555,     0,  1487,  1462,  1002,  1761,  1759,
       0,  2421,  2516,  2533,  2633,   245,  2726,  2735,  2745,  2863,
    2779,  2813,   201,   211,   206,     0,   263,  2745,  2863,  2779,
     259,  1484,     0,  1722,  1872,  1871,  2430,     0,  1457,  1456,
    1575,     0,  1578,     0,  2709,  1726,  1729,  1580,  1727,  2473,
    1965,  1994,  1972,  1994,  1994,  1961,  1961,  2563,  1974,  1962,
    1963,  1999,  2019,     0,  1994,  1961,  1966,     0,  1964,  2002,
    2002,  1989,     3,  1944,  1945,  1946,  1947,  1975,  1976,  1948,
    1981,  1982,  1986,  1949,  2016,  1952,  1961,  2474,  1763,  1764,
    2421,     4,  2467,     5,  2348,  2466,     6,     7,  1718,     0,
       0,     1,  1742,     0,  1585,  1758,  1758,     0,  1758,     0,
    1710,  1718,  1713,  1717,     0,     0,     0,     0,     0,     0,
    1458,     0,     0,     0,   961,     0,  1499,  1087,     0,     0,
       0,     0,     0,  1340,     0,  1140,  1139,  2476,  2459,  2460,
    2461,     0,  2457,  2458,  2477,  2478,  2479,     0,  2602,  1340,
       0,     0,  2264,  2275,  2276,  2277,  2520,  2583,  2272,  2273,
    2274,  2266,  2267,  2268,  2269,  2270,  2271,     0,     0,  1238,
    2265,     0,  2602,     0,  1340,     0,   173,     0,   150,  1340,
       0,     0,  2602,     0,     0,  2602,     0,     0,     0,     0,
       0,  2602,     0,     0,     0,     0,     0,   173,  2638,     0,
     150,  2602,     0,     0,  1478,     0,     0,     0,  1480,  1483,
    1470,     0,  2345,     0,  2346,  2438,  1567,     0,  1566,  1560,
    1570,  1565,  1555,     0,  2430,     0,     0,     0,     0,   944,
       0,     0,   934,     0,     0,     0,   945,     0,   946,   947,
       0,     0,     0,     0,   943,     0,  1468,  1460,     0,  1604,
    1606,  1605,  1607,  1603,   555,     0,     0,     0,  2602,     0,
     150,  1538,     0,  2602,   150,     0,     0,   466,   465,   150,
    2457,   464,   463,  2520,  2583,     0,  1130,     0,  1213,   150,
    2602,     0,   194,  2602,   738,  2602,  1580,   139,     0,   682,
       0,   852,  2638,   150,     0,     0,     0,     0,     0,     0,
     142,     0,     0,     0,     0,     0,     0,     0,   668,   679,
    1616,  1614,     0,  1247,   247,   246,  1245,   948,  2602,  1172,
     145,     0,     0,  2602,  1519,  2602,   145,   965,   949,     0,
     935,  2602,   145,  1136,  2602,  2462,   183,     0,   933,  2520,
    2583,  2602,   145,  1240,     0,  2602,   145,  2602,   179,  2602,
     145,  2602,   145,  2602,   683,     0,     0,  2602,   145,  2602,
    2638,   181,   952,  2602,   145,   959,  2602,   145,  2432,  2602,
       0,  1471,     0,  1608,     0,  1588,  2867,     0,  1742,  1026,
    1025,     0,  1026,     0,  1026,     0,  1026,     0,  1026,     0,
       0,     0,  1026,  2455,  2456,  1008,     0,  1032,     0,  1040,
       0,  1039,  1038,  1037,     0,     0,     0,  1041,     0,  1876,
    1650,     0,  1452,  1467,     0,     0,     0,   142,     0,  1269,
    1266,   142,  1268,  1267,   142,   142,  1463,   252,   250,     0,
       0,     0,     0,     0,     0,  1469,     0,  1461,     0,     0,
       0,  2440,  2442,  2443,  2278,  2348,     0,  2818,  2819,  2820,
    2337,     0,  2821,  2822,  2823,  2882,  2152,  2138,  2147,  2153,
    2139,  2141,  2148,  2824,  2825,  2087,  2826,  2827,  2450,  2828,
    2829,  2830,  2832,  2833,  2834,  2835,  2836,  2837,  2838,  2839,
    2840,  2841,  2842,  2843,  2845,  2846,  2143,  2145,  2847,  2848,
    2849,  2851,     0,  2451,  2852,  2853,  2672,  2855,  2856,  2858,
    2859,  2149,  2861,  2862,  2150,  2863,  2864,  2865,  2866,  2449,
     510,  2151,  2868,  2870,  2871,  2872,  2873,  2875,  2876,  2877,
    2878,     0,     0,     0,  2427,     0,  2116,     0,  1953,  1954,
    1977,  1978,  1955,  1983,  1984,  1956,     0,  1957,  2426,  2020,
    2223,  2115,  2133,     0,  2121,  2122,     0,  2114,  2110,  2225,
    1744,  2422,     0,  2111,  2439,  2441,  2338,  1744,  2420,   214,
     265,     0,   266,  2428,  2745,   202,   244,   216,   243,   217,
     215,     0,  2518,   203,     0,     0,   204,     0,     0,     0,
       0,   262,   260,     0,  1459,     0,  1874,  1873,  2431,   970,
       0,  1577,  1574,  2288,     0,  1728,     0,     0,     0,  1993,
    1980,  1988,  1987,     0,  1970,  1969,  1968,     0,  1967,  1994,
    1994,  1992,  1971,  1944,     0,     0,     0,  1998,     0,  1996,
    1940,  1936,     0,  2005,  2006,  2007,  2004,  2017,  2003,     0,
    1950,  2008,     0,  1961,  1958,  1829,     0,  1708,  1707,     8,
       0,  1582,  1584,  1558,  1580,  1756,  1757,     0,     0,     0,
       0,     0,     0,     0,     0,  1816,  1774,  1775,  1777,  1813,
    1817,  1825,     0,  1714,     0,     0,     0,  1878,     0,     0,
    1485,     0,     0,     0,     0,     0,  1171,     0,     0,     0,
       0,   962,     0,     0,     0,  1505,     0,  1507,  1508,  1509,
       0,     0,     0,  1510,  1511,  1499,   256,  1518,  1515,  1498,
    1500,  1513,     0,     0,     0,     0,     0,     0,     0,  1530,
       0,   187,   188,     0,   695,   679,     0,  2602,     0,     0,
       0,     0,  1181,  1188,  1339,     0,     0,     0,     0,     0,
       0,     0,     0,  1182,  1180,     0,  1183,   258,  1193,  1220,
    1223,     0,     0,  1138,  1141,     0,     0,     0,     0,     0,
    1330,     0,     0,     0,  1330,     0,     0,     0,  1339,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   281,   283,
     296,   363,     0,   660,     0,     0,     0,   663,     0,  2602,
    1340,     0,     0,     0,  1242,     0,     0,     0,     0,     0,
       0,     0,     0,  1223,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   148,   149,   154,     0,     0,     0,     0,
    1223,     0,     0,     0,     0,     0,     0,     0,   644,   659,
     647,     0,     0,     0,     0,     0,   655,     0,     0,   150,
     657,   286,   634,   640,     0,     0,     0,   745,   744,     0,
       0,     0,     0,     0,     0,  1428,     0,  1427,     0,     0,
       0,     0,     0,  1528,  1527,     0,     0,     0,     0,     0,
       0,  1330,     0,   275,   277,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     400,   401,     0,     0,     0,   154,     0,     0,  1330,     0,
     288,     0,     0,  1479,  1476,  1477,     0,  1482,     0,     0,
       0,     0,  2124,     0,  2292,  1766,  2290,  1156,  2344,     0,
    2480,  2903,  2904,  2905,  2906,  2907,  2908,  2909,  2910,  2911,
    2912,  2913,  2914,  2915,  2916,  2917,  2918,  2919,  2920,  2921,
    2922,  2923,  2924,  2925,  2926,  2927,  2928,  2929,  2930,  2931,
    2932,  2933,  2934,  2935,  2936,  2937,  2938,  2939,  2940,  2941,
    2942,  2943,  2944,  2945,  2946,  2947,  2948,  2949,  2950,  2951,
    2952,  2953,  2954,  2955,  2956,  2957,  2958,  2959,  2960,  2961,
    2962,  2963,  2964,  2965,  2966,  2967,  2968,  2969,  2970,  2971,
    2972,  2973,  2974,  2975,  2976,  2977,  2978,  2979,  2980,  2341,
    2340,  2435,  2481,  2482,  2483,  2484,  2347,  1550,     0,   233,
     234,   232,  1568,   235,  1569,  1564,     0,  1551,     0,     0,
       0,     0,     0,     0,     0,     0,  2520,  2583,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   860,  1499,  1537,     0,     0,     0,
     688,     0,  2602,     0,   152,   899,     0,   850,   467,     0,
       0,     0,     0,  1404,   152,     0,     0,   190,     0,     0,
     742,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   851,     0,     0,   152,     0,  2602,   637,  2602,     0,
     555,   555,     0,     0,   141,   138,     0,     0,     0,     0,
       0,     0,     0,     0,  1700,  1699,  1702,  1701,     0,  1698,
       0,   143,   144,     0,  1230,  1255,     0,     0,     0,     0,
       0,   926,   951,     0,     0,  1224,     0,     0,  2602,   145,
    2602,     0,  2602,     0,     0,     0,  1232,   145,     0,  1226,
       0,     0,  1228,     0,  1430,     0,   942,   940,   939,   941,
       0,     0,   924,     0,     0,     0,     0,     0,   919,     0,
       0,   921,     0,     0,     0,     0,  1742,  1587,     0,  1016,
       0,  1020,     0,  1011,     0,  1017,     0,  1012,  1009,  1010,
       0,  1015,     0,     0,   556,   562,     0,     0,  2545,  2562,
       0,  2591,  2626,  2627,  2682,  2700,  2729,  2735,  2741,     0,
    2772,  2784,     0,  1046,  1084,  1036,   754,     0,     0,  1660,
    1453,  2297,     0,  1742,     0,     0,  1270,     0,     0,   138,
     251,   223,     0,     0,  1084,     0,  2733,  1466,  1001,   679,
       0,  2112,     0,  2119,  2120,  2336,     0,     0,     0,     0,
       0,     0,  2118,     0,     0,     0,     0,  2393,     0,     0,
    2393,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2043,     0,     0,  2296,     0,     0,  2296,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2044,  2025,  2026,  2116,  2288,     0,  2117,  2446,     0,  2016,
    2485,  2278,     0,  2275,  2276,  2277,  2981,  2982,  2983,  2984,
    2985,  2986,  2987,  2988,  2989,  2990,  2991,  2992,  2993,  2994,
    2995,  2996,  2997,     0,  2998,  2999,  3000,  3001,  3002,  3004,
    3003,  3005,  3006,  3007,  3008,  3009,  3010,  2351,  3012,  3013,
    3014,  3015,  3016,  3017,  3018,  3019,  3020,  3021,  3022,  3023,
    3024,  3025,  3026,  3027,  3028,  3029,  3030,  3031,  3032,  3033,
    3034,  3035,  3036,  3037,  3038,  3039,  3040,  3041,  3042,  3043,
    3044,  3045,  3046,  3047,  3048,  3049,  3050,  3051,  3052,  3053,
    3054,  3055,  3056,  3057,  3058,  3059,  3060,  3061,  3062,  3063,
    3064,  3065,  3066,  3067,  3068,  3069,  3070,  3071,  3072,  3073,
    3074,  3075,  3076,  3077,  3078,  3079,  3080,  3081,  3082,  3083,
    3084,  3085,  3086,  3087,  3088,  3089,  3090,  3091,  3092,  3093,
    3094,  3095,  3096,  3097,  3098,  3099,  3100,  3101,  3102,  3103,
    3104,  3105,  3106,  3107,  3108,  3109,  3110,  3111,  3112,  3113,
    3114,  3115,  3116,  3117,  3118,  3119,  3120,  3121,  3122,  3123,
    3124,  3125,  3126,  3127,  3128,  3129,  3130,  3131,  3132,  3133,
    3134,  3135,  3136,  3137,  3138,  3139,  3140,  3141,  3142,  3143,
    3144,  3145,  3146,  3147,  3148,  3149,  3150,  3151,  3152,  3153,
    3154,  3155,  3156,  3157,  3158,  3159,  3160,  3161,  3162,  3163,
    3164,  3165,  3166,  3167,  3168,  3169,  2058,  3170,  3171,  3172,
    3173,  3174,  3175,  3176,  3177,  3178,  3179,  3180,  3181,  3182,
    3183,  3184,  3185,  3186,  3187,  3188,  3189,  3190,  3191,  3192,
    3193,  3194,  3195,  3196,  3197,  3198,  3199,  3200,  3201,  3202,
    3203,  3204,  3205,  3206,  3207,  3208,  3209,  3210,  3211,  3212,
    3213,  3214,  3215,  3216,  3217,  3218,  3219,  3220,  3221,  3222,
    3223,  3224,  3225,  3226,  3227,  3228,  3229,  3230,  3231,  3232,
    3233,  3234,  3235,  2060,  3236,  3237,  3238,  3239,  3240,  3241,
    3242,  3243,  3244,  3245,  3246,  3247,  3248,  3249,  3250,  3251,
    3252,  3253,  3254,  3255,  3256,  3257,  3258,  3259,  3260,  3261,
    3262,  3263,  3264,  3265,  3266,  3267,  3268,  3269,  3270,  3271,
    3272,  3273,  3274,  3275,  3278,  3276,  3277,  3279,  3280,  3281,
    3282,  3283,  3284,  3285,  3286,  3287,  3288,  3289,  3290,  3291,
    3292,  3293,  3294,  3295,  3296,  3297,  3298,  3299,  3300,  3301,
    3302,  3303,  3304,  3305,  3306,  3307,  3308,  3309,  3310,  3311,
    3312,  3313,  3314,  3315,  3316,  3317,  3318,  3319,  3320,  3321,
    3322,  3323,  3324,  3325,  3326,  3327,  3328,  3329,  3330,  3331,
    3332,  3333,  3334,  3336,  3335,  3337,  3338,  3339,  3340,  3341,
    3342,  3343,  3344,  3345,  3346,  3347,  3348,  3349,  3350,  3351,
    3352,  3353,  3354,  3355,  3356,  3357,  3358,  3359,  3360,  3361,
    3362,  3363,  3364,  3365,  3366,  3367,  3368,  3369,  3370,  3371,
    3372,  3373,  3374,  3375,  3376,  3377,  3378,  3379,  3380,  3381,
    3382,  3383,  3384,  3385,  3386,  3387,  3388,  3389,  3390,  3391,
    3393,  3392,  3394,  3395,  3396,  3397,  3398,  3399,  3400,  3401,
    3402,  3403,  3404,  3405,  3406,  3407,  3408,  3409,  3410,  3411,
    3412,  3413,  3414,  3415,  3416,  3417,  3418,  3419,  3420,  3421,
    3422,  3423,  3424,  3425,  3426,  3427,  3428,  3429,  3430,  3431,
    3432,  3433,  3434,  3435,     0,  2272,  2273,  2274,  2266,  2267,
    2268,  2269,  2270,  2271,  2282,     0,     0,  2425,  2486,     0,
    2225,     0,  2040,     0,  2233,     0,     0,  1829,     0,  2444,
    2339,  1829,   267,   268,   264,     0,     0,   219,   218,     0,
     237,   241,   242,   213,   240,     0,   236,   221,  2209,  2208,
     220,   212,   209,   207,   224,   226,   227,   210,   208,   261,
       0,     0,     0,   145,  1585,  1572,     0,     0,  2351,     0,
    2286,     0,     0,  2284,     0,     0,     0,  1826,     0,  1730,
       0,  1734,     0,     0,     0,  1991,  1990,  1941,  1937,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   963,     0,  1959,     0,  1894,  2468,  2469,  2349,
    1762,  1585,     0,  1581,  1725,  1724,  1767,  1768,  1122,  1723,
    1796,  1797,     0,     0,     0,     0,  1822,  1820,  1787,  1778,
    1786,     0,     0,  1784,     0,  1788,  2020,  1815,  1712,  1772,
    1773,  1776,  1711,     0,  1818,     0,  1663,  1816,  1777,  1647,
       0,  1618,     0,     0,  1879,     0,     0,  1486,     0,     0,
       0,  1151,  1153,     0,  1152,     0,  1155,     0,  1164,     0,
       0,  1150,  1169,     0,  1158,  1156,     0,  1526,     0,     0,
       0,     0,     0,  1506,     0,     0,     0,  2772,   255,  1509,
    1514,  1501,  1512,     0,     0,     0,     0,     0,  1086,  1085,
       0,     0,     0,  1533,   547,     0,   365,     0,     0,     0,
       0,     0,     0,     0,     0,   846,   843,     0,     0,   842,
       0,   693,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   718,     0,  1330,     0,   294,     0,  1190,
       0,  1189,     0,  1194,     0,     0,  1191,  1186,  1187,  2735,
    2745,  2779,   257,  1192,  1222,     0,  1221,  1217,     0,  1133,
       0,  1134,     0,     0,     0,     0,     0,     0,     0,  2575,
       0,  2602,     0,     0,   510,   302,   326,   537,     0,  1329,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   349,     0,     0,   352,   351,
       0,     0,     0,     0,     0,   357,     0,   335,     0,   336,
       0,   356,     0,     0,     0,   661,   662,     0,     0,     0,
    1330,     0,   290,     0,     0,     0,     0,     0,     0,     0,
       0,  1239,     0,   771,     0,     0,  2735,  1218,     0,  1413,
       0,  2771,  1414,  1417,   555,     0,   555,  1419,     0,     0,
    1416,  1418,     0,     0,   176,     0,   171,   175,     0,     0,
    2735,  1219,     0,     0,     0,     0,     0,   642,   643,   658,
       0,   648,   649,   645,   650,   651,     0,     0,     0,     0,
       0,     0,     0,   641,     0,     0,   740,   739,   743,     0,
       0,     0,     0,     0,     0,  1422,     0,     0,  1213,     0,
       0,  1421,  1429,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1273,  1272,     0,     0,     0,     0,  1340,
       0,   889,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   178,   758,     0,   757,     0,   172,   177,     0,
       0,     0,     0,     0,     0,     0,     0,   231,  1475,  1481,
    1766,  1766,  1766,  2130,     0,     0,     0,     0,  1765,  2342,
    2345,  1555,  1561,  1554,  1553,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   414,   411,   412,   414,     0,     0,     0,     0,
     862,     0,   865,   868,  1497,   494,     0,     0,   685,   718,
       0,     0,   470,   185,     0,     0,     0,     0,   773,     0,
    1213,  1212,   147,   138,   194,   468,     0,   193,   195,   197,
     198,   199,   196,   200,     0,   737,   741,     0,     0,     0,
       0,   681,     0,     0,     0,     0,     0,     0,     0,  1899,
       0,     0,   170,     0,     0,   632,   636,     0,     0,     0,
       0,   470,   598,   376,  2602,     0,   555,     0,  2602,     0,
     137,     0,   849,     0,     0,     0,  1175,  1175,     0,     0,
     787,   786,     0,     0,     0,     0,     0,     0,  1697,   145,
    1173,     0,  1520,     0,   145,   966,   145,  1137,   184,  2463,
       0,   928,     0,     0,     0,     0,   145,  1241,   916,   145,
     180,   145,   145,   684,     0,   145,   182,     0,     0,   145,
     960,   145,  2433,     0,   145,  1611,  2602,   555,  1589,  1013,
    1022,  1021,  1019,  1018,  1014,     0,  1033,     0,   554,     0,
       0,     0,     0,     0,  1054,  1055,     0,     0,  1051,  1056,
       0,  1058,  1042,  1044,  1052,  1053,  1059,  1048,  1047,  1060,
    1061,     0,     0,     0,  1073,   752,     0,     0,     0,     0,
    1657,     0,  1655,     0,  1877,  1659,  1648,  1601,     0,  1600,
       0,   625,  1264,  1263,  1265,     0,  1030,     0,   145,     0,
    1465,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2301,     0,  2302,     0,     0,  2335,  2331,     0,
       0,     0,     0,     0,  2305,  2308,  2309,  2310,  2307,  2311,
    2306,     0,     0,  2312,     0,     0,  2386,  2403,     0,  2116,
    2386,  2414,     0,  2413,  2419,     0,  2292,  2020,     0,     0,
    2410,  2404,     0,  2410,     0,     0,  2393,     0,     0,     0,
       0,  2193,     0,     0,     0,  2292,  2295,     0,     0,  2859,
       0,     0,     0,     0,  2088,     0,     0,  2259,     0,  2292,
       0,     0,     0,     0,     0,     0,     0,  2288,  2327,     0,
     508,     0,  2078,     0,     0,     0,  2207,     0,  2204,     0,
       0,     0,     0,  2348,     0,     0,  2447,  2021,  2036,  2037,
    2038,  2041,  2424,  2024,     0,  2350,     0,     0,  2022,  2049,
       0,  2328,  2074,     0,  2079,  2064,  2394,  2313,  2314,  2315,
    2316,  2081,     0,  2057,  2062,  2066,     0,  2403,  2045,     0,
    2042,     0,  2351,  2287,     0,  2285,     0,  2033,  2034,  2035,
    2027,  2028,  2029,  2030,  2031,  2032,  2039,  2263,  2261,  2262,
       0,     0,  2233,     0,     0,  2061,     0,     0,  2132,  2594,
    2633,     0,  1755,  1755,  1755,  1743,  1753,  2423,  1894,  1766,
    1894,  2429,     0,     0,  2016,     0,  1875,   968,   969,   967,
    1557,  1571,  1585,  2289,  1579,  1732,     0,     0,     0,  1960,
    1973,     0,  2000,  2001,  2002,  2002,     0,  1942,     0,  1985,
    2010,  2011,  2012,  2013,  2014,  2015,     0,  2009,  1951,   964,
    2835,  2844,     0,  2731,  2879,     0,  1855,  1828,  1830,  1840,
    1855,  1862,  1855,  1855,  2134,  1892,  2135,  2136,  2430,     0,
    1799,  2465,  1559,  1583,     0,  1120,  1121,     0,  1125,  2859,
    2731,     0,     0,     0,     0,  1789,  1823,     0,  1814,     0,
    2440,  1790,  2439,  1791,  1794,  1795,  1785,  1824,  1661,     0,
    1819,  1716,  1715,     0,  1897,     0,     0,     0,  1632,  1620,
       0,     0,  1880,     0,  1829,  1665,     0,  2348,  1827,  1380,
    1274,  1341,  1154,     0,  1961,  1165,     0,  1149,     0,  1148,
    1961,     0,  1166,     0,  1961,  1381,  1275,  1342,  1382,  1276,
    1343,  1383,  1517,  1277,  1516,  1504,  1503,  1502,     0,     0,
       0,     0,     0,     0,     0,     0,   825,  2602,   145,  1531,
    1384,     0,  1278,   364,  1532,  1344,  1536,   845,   844,     0,
       0,  1345,     0,   694,   699,     0,   701,   702,  2520,  2583,
     703,   706,   707,     0,   709,   698,   697,     0,     0,     0,
       0,     0,   715,   720,     0,     0,     0,     0,     0,     0,
    1184,  1185,  1385,  1281,     0,  1346,     0,  1132,     0,  1282,
     186,     0,     0,   282,     0,  2602,   304,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   825,   492,   825,     0,
    1332,   301,   333,     0,   348,   343,   344,   342,  2602,   145,
    2602,   145,     0,     0,     0,     0,     0,   345,   340,   341,
     337,     0,     0,   350,  2492,  2564,  2746,     0,   726,   728,
       0,   733,   353,  1302,   372,   371,   370,     0,   358,     0,
     377,   380,     0,   355,   334,   332,   329,   297,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1234,
       0,  1388,  1347,     0,  1369,  1373,     0,     0,     0,   765,
    1391,  1288,  1350,     0,   555,     0,     0,   574,   574,   555,
    1402,  1289,   174,  1319,   163,     0,     0,   159,     0,     0,
       0,     0,   153,  1392,  1290,  1351,     0,     0,  1393,  1291,
       0,     0,   287,   635,   646,   652,  1296,   656,   653,  1359,
     654,  1400,  1292,     0,  1396,  1322,  1354,   390,   618,   389,
    1213,  1213,  1403,  1423,  1293,  1213,     0,  1330,     0,   276,
     278,     0,   142,     0,  1294,     0,  1352,  1395,  1321,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1539,     0,
       0,     0,     0,     0,     0,   145,     0,     0,     0,  1332,
    2602,   145,   887,  1394,     0,  1327,     0,  1367,     0,     0,
       0,   402,     0,  1320,  1330,     0,   289,  1298,     0,  1361,
       0,     0,   229,   228,   230,     0,     0,     0,     0,  2293,
    2294,     0,  2291,  2125,  2344,     0,  1549,   990,   976,   989,
       0,   972,  2562,     0,   975,   977,     0,     0,     0,   978,
     982,   983,     0,   974,   971,   973,     0,   413,     0,     0,
     782,   783,     0,     0,     0,     0,   864,     0,     0,  1529,
       0,   150,   692,     0,     0,     0,   687,   717,   722,     0,
       0,     0,     0,   469,   473,   477,   478,   479,     0,     0,
       0,     0,   164,   151,     0,   905,     0,   555,     0,   775,
    1213,  1406,     0,   194,   189,     0,     0,   738,     0,  1580,
       0,     0,   613,   616,   615,     0,   376,   859,   857,   856,
     858,   880,   855,     0,  1898,  1900,     0,     0,     0,     0,
       0,     0,   625,   472,     0,     0,   562,     0,   601,     0,
       0,     0,     0,   598,     0,     0,     0,  2473,     0,   876,
     848,     0,  1143,     0,  1161,  1144,     0,     0,     0,     0,
    1198,  1205,  1174,  1199,  1176,  1205,     0,     0,   788,   792,
     791,   795,   793,     0,   789,   666,  1703,  1704,     0,  1231,
       0,     0,  1525,     0,  1523,   927,  1225,   145,     0,   145,
       0,   145,  1233,  1227,  1229,  1431,     0,   925,     0,     0,
     918,   920,     0,   922,     0,  1034,   557,     0,     0,     0,
       0,     0,     0,  1050,   664,  1057,     0,     0,     0,  1072,
    1067,  1069,     0,  1084,  1078,     0,   751,     0,     0,  1658,
    1651,  1653,  1652,     0,     0,  1649,  2298,   917,     0,   631,
       0,  1084,  1075,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1760,  2299,  2300,     0,     0,     0,
    2332,     0,     0,  2169,     0,  2140,  2142,  2155,     0,  2170,
    2123,     0,  2385,  2382,     0,     0,     0,  2386,  2393,  2189,
       0,     0,     0,  2393,     0,  2413,     0,     0,     0,  2184,
    2186,     0,     0,     0,  2403,  2403,     0,  2191,     0,     0,
    2171,  2144,  2146,  2156,     0,     0,  2279,     0,  2159,  2158,
       0,  2090,  2091,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2105,  2160,  2258,     0,     0,     0,  2162,  2161,     0,
       0,  2326,     0,     0,     0,  2167,   509,  2172,     0,     0,
       0,     0,  2178,     0,  2215,     0,     0,     0,  2113,  2289,
       0,     0,     0,     0,     0,     0,     0,  2396,  2397,  2398,
    2395,     0,  2080,  2065,  2083,  2059,  2063,  2067,     0,  2403,
    2082,  2085,     0,     0,  2053,     0,     0,  2051,  2075,  2047,
       0,     0,  2076,     0,  2131,     0,     0,     0,  2236,  2231,
    2232,  1755,  1755,  1755,  1755,  1752,     0,     0,     0,  1799,
       0,  1799,   205,     0,   238,   225,  1556,  1733,  1742,  1979,
       0,  1997,  1995,  1938,  1943,  2018,     0,  1855,  1862,  1855,
    1855,     0,     0,  1718,     0,  1840,     0,  1854,  1838,  1853,
       0,     0,  1868,  1866,     0,  1868,     0,  1868,     0,  1832,
       0,  1858,  1834,  1853,  1836,  1842,     0,  1884,  2431,  1893,
       0,  1812,  1769,     0,  2280,  1125,     0,  1771,  1793,  1792,
       0,  1782,     0,  1821,  1779,  1662,  1646,     0,  1637,  1624,
    1626,  1625,     0,     0,  1627,  2348,     0,  1637,  1619,     0,
    1670,     0,     0,  1897,     0,  1669,     0,  1961,  1146,  1147,
       0,  1170,     0,  1089,  1090,     0,  1088,     0,     0,     0,
     546,   549,     0,  1534,     0,  1401,  1318,   696,     0,     0,
       0,     0,   711,   670,   712,   714,     0,     0,   713,   716,
     719,  1330,     0,   295,  1304,     0,  1365,  1178,     0,     0,
    1135,     0,     0,     0,     0,     0,  1106,   536,  1105,     0,
       0,     0,   825,     0,   825,     0,     0,   541,     0,   491,
     488,   328,   327,     0,     0,     0,     0,   385,     0,   306,
     319,   383,   325,     0,   360,     0,   331,     0,   323,   346,
     338,   347,   339,   359,   361,     0,   730,   731,   729,   725,
       0,   732,   734,     0,   374,     0,     0,     0,   392,   354,
     391,     0,  1387,     0,  1330,     0,   291,  1300,     0,  1363,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1368,     0,     0,     0,     0,   770,     0,   767,
       0,   574,     0,  1415,     0,  1412,  1410,   574,     0,     0,
     156,   155,     0,   162,     0,     0,     0,     0,     0,     0,
    1424,  1425,  1426,     0,     0,     0,     0,     0,     0,   396,
       0,   298,   300,   299,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   403,   367,     0,   883,     0,     0,     0,   405,     0,
       0,  1379,     0,     0,     0,     0,     0,  1386,  1283,  2128,
    2129,  2126,  1766,  2343,     0,     0,     0,   987,     0,     0,
       0,     0,   416,   417,   150,   415,   440,     0,   825,     0,
       0,   861,   866,   874,  2672,  2266,  2267,   872,   867,   869,
     871,   873,   870,     0,     0,     0,     0,   516,   520,     0,
       0,     0,   500,     0,     0,   510,   493,   496,   497,     0,
       0,   688,   691,   689,   690,     0,   710,     0,   472,   525,
     588,     0,   166,     0,     0,   167,   165,     0,     0,   376,
     772,     0,   769,  1405,     0,   192,     0,   742,     0,     0,
       0,     0,     0,  1213,   680,     0,   879,   881,   853,     0,
     722,     0,     0,   637,     0,   555,  1612,   620,     0,   590,
     472,   588,   597,     0,     0,   605,   375,     0,     0,   625,
     376,     0,     0,  1106,     0,   875,     0,     0,  1142,     0,
       0,     0,  1195,  1200,  1196,     0,  1175,  1157,     0,  1197,
       0,     0,  1203,  1128,  1177,  1129,  1447,  1448,  1445,  1446,
       0,     0,     0,     0,     0,     0,  1694,     0,     0,  1521,
       0,   929,     0,   912,     0,   914,   145,   759,     0,   145,
       0,     0,     0,     0,     0,     0,  1049,     0,  1043,  1045,
    1070,     0,     0,  1084,  1083,     0,  1074,  1082,  1080,  1081,
    1079,     0,     0,  1656,  1654,   623,     0,     0,   145,  1084,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2303,     0,  2334,  2330,     0,  2137,  2304,  2384,  2400,  2402,
    2190,  2392,     0,     0,     0,  2415,     0,     0,  2393,  2353,
    2407,  2406,     0,     0,  2405,  2393,  2393,  2353,  2192,  2353,
       0,     0,     0,  2259,     0,     0,  2089,  2101,  2102,  2103,
    2319,     0,  2108,     0,  2098,  2099,  2100,  2092,  2093,  2094,
    2095,  2096,  2097,  2104,  2323,  2322,     0,     0,  2164,  2165,
    2166,  2325,  2173,     0,  2510,  2216,     0,  2177,  2206,  2205,
       0,     0,     0,  2180,     0,     0,  2202,     0,  2260,  2448,
    2023,     0,     0,  2050,  2329,  2068,     0,  2084,  2086,  2046,
    2279,     0,     0,     0,     0,     0,  2055,     0,     0,  2256,
       0,     0,     0,  2238,  2235,     0,     0,     0,     0,  1746,
    1745,  1751,  1812,  2125,  1812,     0,     0,  1939,     0,  1839,
    1835,  1837,  1843,     0,  2874,     0,  1844,  1851,     0,  1831,
       0,  1867,  1863,     0,  1864,     0,     0,  1865,     0,     0,
    1833,     0,  1851,     0,  1891,  1758,     0,  2227,     0,  1770,
    1123,  1124,  1780,     0,  1783,  2541,  1895,  1639,  1645,     0,
       0,     0,  1629,  1635,  1617,     0,     0,     0,  1666,  1637,
    1667,  1167,     0,     0,  1159,  1095,     0,  1096,  1099,  1097,
    1094,  1098,     0,     0,     0,   825,   828,   834,     0,     0,
       0,   826,   145,  1279,     0,     0,     0,     0,   671,  1399,
    1280,     0,     0,     0,     0,  1179,  1333,     0,     0,  1303,
     825,     0,     0,     0,   569,     0,  1119,  1119,   559,   303,
     539,   553,   543,   610,   553,   490,   489,     0,   487,   722,
       0,     0,   310,   320,     0,   315,     0,  1331,     0,     0,
       0,     0,   314,   317,   316,   387,     0,   384,     0,   145,
     145,   362,   727,   373,   378,   379,   382,  1338,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   906,   891,     0,     0,   907,   908,     0,     0,     0,
    1236,  1237,  1235,  1370,  1371,  1377,  1374,  1372,  1376,  1378,
    1375,     0,  1286,     0,     0,   763,  1334,  1407,  1409,  1408,
       0,  1411,   160,   157,   158,   161,  1335,  1316,  1297,  1360,
     619,     0,     0,     0,  1295,     0,  1353,     0,  1312,  1306,
       0,     0,     0,     0,     0,  1398,  1326,  1358,  1397,  1324,
    1356,  1323,  1355,  1325,  1357,  1317,     0,     0,  1902,   888,
       0,     0,     0,   145,   145,   886,   761,  1299,     0,  1362,
    1308,     0,     0,     0,   979,     0,     0,     0,   981,   421,
     441,   150,     0,   781,   847,     0,     0,   863,     0,   498,
       0,   504,   511,     0,     0,   518,   519,   517,   521,   551,
    1213,   555,  1213,   814,   815,     0,     0,   837,     0,   686,
       0,     0,   470,     0,   522,     0,     0,   474,   169,   168,
       0,     0,     0,   776,   780,   778,   777,   779,   774,     0,
     765,   194,  2602,     0,     0,     0,     0,   617,   611,   614,
    1420,   854,     0,  1901,   755,     0,   376,   633,     0,     0,
       0,   470,   625,     0,   475,   480,   481,   494,     0,   598,
     589,     0,   590,   599,   600,     0,   607,  1495,     0,   626,
     607,     0,     0,     0,   878,     0,   877,     0,  1145,  1162,
    1163,     0,     0,  1205,     0,     0,  1207,  1202,     0,     0,
     794,   797,   790,   673,   145,     0,  1524,   145,   145,  1262,
       0,   923,  1064,  1065,  1066,  1063,  1062,   665,     0,  1068,
    1027,  1077,   753,     0,   624,     0,  1028,   145,  1004,   996,
    1003,   992,   995,   997,     0,   999,  1000,   994,   991,   993,
    2333,  2154,     0,  2399,  2401,  2188,  2412,  2411,  2187,  2418,
       0,     0,  2381,  2409,  2408,     0,     0,  2393,  2393,  2157,
    2168,     0,  2258,  2289,     0,     0,  2109,     0,     0,     0,
    2163,  2869,     0,     0,  2220,  2221,     0,  2217,  2218,  2213,
    2214,  2179,     0,  2659,  2197,     0,     0,  2212,  2072,  2070,
    2069,  2054,     0,     0,  2052,  2048,     0,  2077,  2222,  2255,
    2289,  2224,     0,  1766,  1750,  1749,  1748,  1747,  2227,  2445,
    2227,   239,  1737,     0,  1887,     0,  1890,     0,     0,  1841,
       0,     0,  1845,     0,     0,  1847,  1849,     0,     0,     0,
       0,     0,     0,  2434,     0,  1811,     0,  1766,     0,  1781,
       0,     0,     0,  1621,     0,  1622,  1628,     0,     0,     0,
       0,     0,  1671,  1664,  1160,  1168,  1100,     0,     0,     0,
     548,   830,   829,   832,   827,   833,   831,  1535,     0,   704,
     705,   708,  1305,     0,  1366,  1314,     0,  1660,   538,   305,
       0,   564,     0,     0,     0,  1112,   140,  1111,     0,     0,
       0,     0,     0,   486,   485,   494,   313,     0,     0,     0,
     307,   386,     0,   388,   308,   312,   367,   330,   322,     0,
       0,     0,  1301,     0,  1364,  1310,  1337,  1389,  1284,  1348,
       0,     0,   897,     0,     0,     0,     0,  1390,  1285,  1349,
       0,     0,     0,     0,     0,  1660,     0,     0,     0,     0,
       0,     0,     0,     0,  1544,     0,     0,   366,   885,   884,
     367,   404,  1328,     0,  2127,     0,   980,   985,   986,   984,
       0,   410,   418,   421,     0,     0,  1253,  1253,     0,     0,
     495,   512,     0,     0,   499,   609,   568,   609,     0,     0,
       0,     0,     0,   723,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   768,   767,   191,     0,   470,     0,
     722,     0,   882,     0,     0,     0,   625,   472,     0,     0,
    1609,   471,     0,     0,   483,     0,   601,   590,   598,     0,
       0,   622,     0,  1488,     0,   628,     0,     0,     0,   824,
    1201,     0,  1215,     0,  1156,  1126,  1210,     0,  1742,  1894,
       0,     0,     0,     0,   807,     0,   677,  1254,  1522,   913,
     915,   760,  1071,     0,  1084,  1076,   998,  2383,  2417,  2352,
    2354,     0,     0,  2375,  2368,  2371,  2369,  2370,  2372,     0,
    2367,     0,  2185,  2416,  2365,  2379,  2318,  2260,  2106,     0,
    2321,  2320,  2324,     0,  2174,     0,  2175,  2219,  2181,  2198,
       0,  2182,  2210,     0,     0,  2073,  2071,  2056,  2257,     0,
    2242,  1720,  1719,     0,  1740,  1923,  1892,     0,     0,  1886,
       0,     0,  1917,     0,     0,     0,  1852,  1870,     0,  1848,
    1846,     0,  1859,     0,  1861,  2540,  2830,  2728,     0,  1798,
    1800,  1803,  1805,  1804,  1806,  1802,  2226,  2228,     0,  1777,
    2281,  1896,     0,  1636,     0,     0,     0,  1107,     0,     0,
    1637,  1673,  1685,  1685,  1668,  1072,     0,   145,   700,     0,
       0,   284,  1119,     0,  1213,   570,  2672,   571,  1118,  1122,
     139,  2689,     0,   552,   564,   564,   482,     0,   311,   321,
       0,   369,   381,     0,  1660,     0,     0,   895,   904,   904,
     892,     0,     0,   909,  1287,   764,     0,   573,     0,   279,
    1313,  1307,     0,     0,     0,  1546,  1547,     0,     0,     0,
       0,     0,  1336,   145,  1309,   988,     0,   443,   451,   422,
     426,  1538,     0,  1538,     0,   423,   427,  1538,  1538,   420,
    1894,   439,  1253,     0,  1250,  1249,   551,   639,     0,   550,
       0,   502,     0,   579,   501,     0,   838,     0,     0,   721,
       0,   472,   588,     0,   535,   526,   527,   528,   529,   531,
     530,   532,   533,   534,   524,   523,     0,   722,   901,   376,
    1495,   762,     0,     0,   735,     0,   722,     0,  1612,   621,
     590,   472,   588,   476,   494,     0,   605,   598,   601,     0,
     602,     0,   606,     0,     0,     0,   625,  1548,  1106,     0,
       0,   825,  1214,  1175,     0,     0,  1204,  1208,  1209,     0,
       0,     0,     0,  1257,   801,   802,   796,   798,     0,   809,
     813,   672,     0,     0,   676,   667,   722,   145,     0,     0,
    2366,  2373,  2374,     0,  2195,     0,     0,  2391,     0,     0,
       0,  2107,     0,     0,  2200,  2199,  2211,  2183,  2237,     0,
       0,     0,     0,     0,     0,     0,  1731,     0,  2353,  1885,
    1888,     0,  1920,     0,     0,     0,     0,  1905,     0,  1850,
       0,     0,  1860,     0,     0,     0,  1807,     0,     0,     0,
    1816,  1644,  1643,     0,  1640,     0,     0,  1634,  1894,     0,
    1631,     0,  1680,     0,  1672,  1674,     0,     0,     0,  1091,
       0,  1092,  1315,     0,  1113,     0,   609,     0,  1125,  1122,
     558,     0,  1213,  1213,   639,     0,     0,   324,     0,   292,
    1311,     0,     0,   893,   894,     0,     0,     0,     0,     0,
       0,   398,     0,     0,  1540,     0,  1541,  1542,  1545,   406,
     419,     0,   449,   448,     0,   446,   445,   447,     0,   436,
       0,     0,     0,     0,     0,     0,   409,  1248,  1252,  1251,
     503,     0,   505,     0,     0,   565,   566,   567,     0,   507,
     575,   576,   835,     0,   840,     0,   724,     0,     0,   722,
     587,   746,     0,     0,     0,  1489,     0,     0,   612,   756,
    1495,   625,   598,     0,   590,   484,     0,   607,   601,   605,
     603,   604,     0,  1492,     0,   627,     0,  1115,   823,     0,
    1205,  1216,  1211,  1206,  1451,     0,     0,   799,   804,   803,
    1538,   808,     0,     0,     0,   675,   674,   750,  1029,  2355,
    2356,  2380,     0,     0,     0,  2359,     0,  2357,     0,     0,
    2379,     0,  2196,  2317,  2203,  2176,  2201,  2817,  2541,  2787,
       0,  2254,  2243,  2254,  2254,  2234,     0,     0,     0,  1922,
       0,     0,     0,  1918,  1919,  1903,     0,     0,  1907,  1857,
    1883,     0,     0,     0,  1801,  2229,  2230,  2464,  1638,     0,
       0,  1623,  1633,  1108,     0,  1682,  1684,     0,     0,     0,
    1660,     0,   574,     0,  1109,  1125,   561,   609,   609,   318,
     309,   368,     0,     0,     0,   902,   911,   910,   766,  1660,
       0,   394,   393,     0,   397,     0,   444,   454,     0,   452,
     424,   429,     0,   435,   434,   431,   430,   425,   428,     0,
     515,     0,     0,     0,     0,   577,     0,   578,     0,   839,
       0,     0,     0,   748,   900,     0,     0,   470,   722,  1490,
    1610,   601,   590,   598,     0,     0,   592,  1119,  1119,   457,
     605,   607,  1493,  1494,     0,     0,   510,     0,  1127,  1450,
    1449,  1742,     0,     0,     0,   810,   811,   806,     0,     0,
    2360,     0,  2363,     0,  2364,  2358,  2388,  2390,     0,  2376,
    2377,     0,  2247,  2246,  2245,  2249,  2248,     0,  2241,  2239,
    2240,     0,     0,     0,     0,  1889,     0,  1906,  1909,     0,
       0,     0,  1915,     0,  1908,  1910,     0,  1869,     0,  1881,
    1809,     0,  1808,  1641,  1642,  1894,     0,  1687,     0,     0,
    1675,  1676,     0,     0,  1677,   145,   285,   563,   825,   572,
    1110,     0,   568,   825,   825,  1660,   896,     0,   280,     0,
     399,  1543,   450,     0,   433,   432,   638,   513,   514,   506,
     608,   584,     0,   583,     0,   581,   580,   836,   841,     0,
     722,   890,  1495,   736,   605,   598,   601,     0,   591,     0,
     140,   140,   607,   455,     0,     0,   376,     0,  1433,  1742,
    1432,  1434,  1442,  1439,  1441,  1440,  1438,     0,  1260,  1261,
     800,   805,     0,     0,  2361,  2362,     0,     0,  2194,     0,
       0,     0,  2251,     0,  2252,     0,     0,     0,     0,     0,
    1912,  1913,  1914,  1916,  1911,  1856,     0,  1810,  1630,  1681,
    1683,  1678,     0,  1679,     0,     0,     0,     0,  1688,  1093,
     544,   559,   579,   542,   540,   293,   903,     0,   453,   582,
     555,   555,   722,   747,  1491,   607,   601,   605,  1119,   593,
     595,   594,   459,  1115,  1116,     0,   607,   813,     0,  1443,
    1437,  1718,  1705,     0,     0,   812,     0,     0,     0,     0,
    2244,  2250,  2253,     0,     0,     0,     0,  2652,     0,  1924,
       0,     0,     0,  1686,  1692,     0,     0,     0,     0,   825,
       0,   586,   585,   749,   458,   605,   607,   140,   510,  1114,
       0,  1894,     0,  1435,  1742,     0,     0,   818,  2387,  2389,
    2378,  1736,  1735,  2835,     0,     0,  1739,  1932,     0,  2381,
       0,     0,  1935,     0,  1882,     0,     0,     0,   560,   545,
     395,   607,   456,   596,   376,  1117,  1101,     0,  1436,     0,
       0,   820,     0,   816,   819,   821,   822,     0,     0,     0,
       0,  1925,  1926,  1935,     0,  2365,  1935,  1904,  1689,  1693,
       0,  1690,   460,   607,     0,     0,     0,   784,     0,  1766,
       0,     0,     0,  1921,  2381,  1934,  2391,  2365,     0,  1894,
       0,     0,     0,   817,     0,     0,     0,     0,  1929,  2379,
    2391,     0,  1102,   818,  1258,  1259,     0,  1738,     0,     0,
    1927,  2379,  1691,     0,     0,  1930,  1928,   785,     0,  1931
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -5950, -5950, -5950,  4198,  -387, -1747, -5168, -1141,  -767, -5950,
   -5950,  -975,   561,  3443, -1136, -5950, -5950, -5950,  1356, -5950,
   -5950, -5950, -5950,  4185, -5950, -2962, -5950, -5950,   208,  4125,
   -1400,   168,  3752,  1712, -5950, -1016, -5950, -5950,  -656,     1,
   -5950,  4128,   498, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950,  -786,  2176, -5950,  2276,  1510, -3518, -5950, -5950, -1543,
   -3810, -5950,   758, -5950,   785, -4173, -5950, -4870,  -927, -5950,
   -5950, -5950,  2166, -5950, -5950, -5950,  2113,  1300,  -273, -5950,
   -5950, -5950, -5950, -5950, -5950,  -750, -5950, -5950, -1060,     4,
    -658, -2963, -4373, -5950, -5950,   604,  -315, -1520, -5950,   800,
   -5950,   801, -5950, -4892, -5950,   102, -2791, -2523, -5950, -5950,
   -5950, -5950,  -285, -1529,  1549, -5950,  1612,  -527,   257,  -733,
   -1157, -1128, -5950, -3096, -2867, -1027, -5950,  -166, -3621, -1125,
    -752,  -749,  -910, -4428, -4953, -5950, -5950, -1059, -3836, -5254,
   -5497, -4966, -5197,  1561, -5950,    81,   617, -5950,     6, -3687,
   -3817,     7,   593, -5950,     8,    11, -5950,   609,  -679,  -976,
   -1616, -5950,  -799, -5950, -5950, -5950, -3484, -5950, -5950, -5950,
     171, -5950, -5950, -5950, -5950,   653, -5950, -5950, -5950, -5950,
   -5950, -5950, -3237,  2147,  2149, -5950, -4371, -5950,  -957, -5950,
     819, -3538,  1546, -5950, -5950,  1306,  4210,   639, -5950, -5950,
   -5950, -5950, -5950, -5950, -1798, -5950, -5950, -5950, -5950,   108,
    -246, -5950, -5950, -5950, -5950, -5950, -5950, -5950,    13, -5950,
    1271,   583, -5950, -5950,  -556, -5950, -5950, -5950, -5950, -5950,
   -5950, -1108, -5253, -1238, -1212, -5950, -3488, -5950, -5950, -5950,
    -211, -5950, -5950, -5950, -5950, -5950,  -887, -5950,  1372, -4180,
   -5950, -5950,   624, -5950, -5950, -5950, -5950, -5950,  -869,  -146,
    3398, -5950,  -411, -5950, -5950, -5950,  -147, -5950, -5950, -5950,
   -5950, -5950,  -522, -1270,  5242,  4596, -1126, 16399,  -842,  -557,
   -5950, -5950, -5950, -2783, -5950, -5950, -4283, -5950,  5233,  2363,
    1642,    16, -5950,   -12,   103,  4028, -5950,  1242, -1173, -3155,
     587,  -370, -5950, -5950, -5950,   586, -5950, -1961, -5950, -5950,
   -5950, -5950, -4165,    20, -5950, -4438, -5258, -4669, -4210, -1071,
   -5950, -4508, -5233, -4143, -5950,  2189, -5950, -5950,  -553,  -192,
    3366, -5950, -1495,  2542, -1415, -5950, -2519,   647,  1728,  3373,
   -3300,  -113,  3369, -3043, -5950,  -691,  1312, -5950,  -235, -3844,
   -5950, -5950, -5950, -2804,  -498, -5950, -5950,  1582, -1110, -5950,
   -5950, -5950, -5950,  -643,  3374,  -209, -5950, -5950,  4569, -5950,
   -5054, -5950,  4540, -5950, -5950, -5950, -5950, -5950, -5950, -5950,
   -5950, -5950, -1503,  1481, -5950,  -792, -5950, -5950,  2296,   861,
   -5950, -5950, -5950, -5950,  1574,  -376, -5950, -5950, -5950, -5950,
   -5950, -5950, -5950,  -849, -1091, -5950, -5950, -5687, -5950, -5950,
   -5950, -5950, -5950,  2520,  -961,  -759,  4445,  -210,    27, -5466,
   -5950, -5950, -1161, -5950,  3780, -5950, -5950, -5950, -5950, -5950,
     646,   651, -5950, -5950, -5950, -5950, -4496, -5950, -5950, -5128,
   -5950, -5950,  2284, -5950, -5950,  1447,     5,  3489, -5950, -5950,
   -5950,    -9, -5950, -5950, -1023,  2637, -5950, -2394, -5950,  -582,
   -5950, -5950, -1915,    31, -4426, -5950,    60, -5950, -5950, -5123,
   -1010,   441, -5950, -5950, -4145, -5950, -5950,  -745, -5950,    61,
   -5950, -5950, -5950, -5950, -5110, -5950,    69, -5665,  1016, -3383,
   -5950,    15, -5950,  -310, -5950, -5950,  -312, -5950, -5950, -5950,
   -4166,    33,   122, -5950, -5950,    82,   382,   -46,   -30,   -26,
      21,   188,  3897, -5950, -5950, -5950, -5088,  3944, -5950,     9,
    -863,  5284,  5286, -5950,  -924,  -144,   600,  1835,  -680, -2638,
    3849,  3864, -5950,  1821,  2641, -2461, -2459, -5950,  -913,  -720,
    -523, -5950, -5950, -5950, -5950, -1502,  -669, -2641, -5950,  3865,
   -5950, -5950, -5950, -2366, -3421, -3251,  1860, -3335, -3172, -5950,
    1100,  1081,  -875,    32,    43, -1485,  -802,  1890, -5950, -5950,
    1867,  -245, -5950, -5950,  -242, -3332,  1038, -5950, -4621, -2848,
    1873, -1025,  -699, -5950,  -843, -5950,  -496,  1880, -5950, -4102,
   -1057, -5950, -3618, 10883,  3921,  -846, -5950, -5950,  -800,  8724,
   -5950, -5950, -5950, 10620, 10665, -5950, -5950, 10916, 12045, -5950,
    -528, 12518,  7144,  -801, -1950,   401, 13586, 18285, -1965,  2743,
     365, -5950, -2991, -1549, -5950, -5950, -5950,  -208,  1196,   804,
   -5950, -5950, -4684, -4485, -5950,  2771, -1894, -5950,  -495,  1953,
    -492, -5950, -5950, -5950, -3022, -5633, -3190,  2778, -5950, -5950,
   -5950,  -199, -5950, 18053, -3284, -5950,  -785, -1032, -1609,  3285,
   -3110, -1924, -5950, -5950, -5950, -3138, -5950, -5950, -5950,  -717,
    1979, -5950, -5950,  2108, -5950, -5950, -5950,  -982,  2344,  -737,
   -1196,  1984, -4533, -5950,  -431, -4545, -5058, -5950, -5574, -5218,
   -1897, -1034, -3042, -5949, -1935,  1997, -3135, -5950, -1948,  2077,
    1286, -5950,  1217, -5950,  4466,  -796,  2786,  -804, 16099,  -689,
   10414, -1299, -5950,  1178, -4921,  6287,  6555,    36,  -119,  6314,
    -608,  2703,  2820, -5950, -5950,    -6,  8160,  -662,  -876, -5950,
    4723, 14731, 15031, -3735, -5950
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    57,    58,    59,    60,  1111,  1116,  1915,  1934,    61,
      62,  1635,  3073,  2926,  3902,  3903,    63,    64,  1631,    65,
      66,    67,    68,  1545,    69,  1887,  3087,    70,  2758,   853,
     854,   855,  2623,  2624,  3018,  2625,  2613,  1397,  1833,  1567,
     827,   828,  1527,  1568,    72,    73,  1391,  2604,    74,    75,
      76,  1598,  1694,  1599,  1600,  1539,  5048,  5897,  3688,  2881,
    3950,  3689,  3690,  4380,  4381,  3768,  4409,  4471,  5911,  5912,
      77,  1710,  1711,    78,    79,  3055,  3868,  4524,  5441,  5442,
    5709,   672,  5071,  5072,  5696,  5697,  5926,  6098,  6099,  3088,
     703,  3945,  4609,  3893,  5143,  3894,  5144,  3895,  5145,  4938,
    4939,  4369,  4370,  3879,  4556,  4557,  2091,  5084,  6239,  4558,
    3896,  5104,  5744,  3897,  2847,  2773,  2774,  5454,  5371,  3122,
    2006,  5369,  6222,  2004,  5644,  5723,  4923,  4924,  4445,  5949,
    5950,  5951,  6245,  5106,  5149,  5150,  6135,  6136,  3948,  4615,
    5156,  5501,  5721,  3646,    81,  3921,  3922,    82,   766,  1909,
    4049,   767,  3125,   704,   768,  3089,    87,  3115,  5942,  3116,
    1663,  2940,  4537,  4025,    88,  1139,  4332,  5526,  5804,  5805,
     757,    89,  1895,    90,    91,  3068,  3886,    92,  2791,  3593,
      93,    94,  3612,  3613,  3614,    95,  4566,  5462,  1601,  3677,
    3678,  3679,  3680,  4401,    96,  1890,  3096,  3097,    97,    98,
      99,  3227,  3228,   100,  3004,   101,   102,   103,   104,  4439,
    5005,  5120,  3719,  3909,  4582,  5118,   105,  3872,  3090,  3143,
    3983,  3984,  5524,  5796,  5797,  5798,  6000,  6280,  5800,  6002,
    6157,  6004,  5095,  6432,  6433,  5781,  4321,  4901,   107,  5096,
    5097,  5955,   108,  2789,   109,   110,  1864,  3061,  3062,  4538,
    3132,  3958,  3959,  4595,  4596,   111,  3808,   112,  4981,  4982,
     705,  5963,  5903,   113,   114,  4985,  4986,   115,   116,   117,
     118,   119,   758,  1073,  1074,   760,  1194,  1195,  3554,  1156,
     120,  2633,   121,  3848,   122,  1269,  5209,   123,   792,  1210,
    1211,  3091,   125,   802,  3246,   804,  3211,  3212,  2022,  4029,
    4030,  4683,   126,   127,  4033,  4034,  4690,  3224,   128,  1532,
    2768,  2769,  4892,  3092,   706,  3639,  5626,  5365,  5627,  6146,
    6345,  5366,  3498,  4277,   130,   707,  1573,  2830,  1162,  1163,
    3136,  3963,  2738,  2739,  1733,  4636,  2741,  3965,  2742,  1506,
    2743,  1149,  1150,  3971,  3972,  3973,  3974,  4632,  4642,  4643,
    5518,  5789,  4639,  1883,  5512,  5513,   131,  1570,  2827,   132,
     133,   134,  1614,   997,  1172,  1173,   135,   719,   720,   136,
    5714,   137,  1152,   138,  5522,   139,   140,  1254,  1255,   819,
     141,   142,  2851,  4383,   143,  1571,   144,   145,  3713,  3714,
    4997,   146,   147,   148,  2912,  2913,   149,   150,   151,   152,
     153,  6270,  6348,  6349,  6350,  4650,  6151,   154,  1242,   155,
     156,   157,   158,   196,  1038,  1039,  1040,   950,  3093,  5503,
     160,   161,  1528,  1529,  1530,  1531,  2763,   162,   163,   164,
    3993,  3994,   165,   166,   167,   168,  1867,   169,   170,  5687,
     171,   172,  1837,   173,   174,  1047,  1048,  1049,  1050,  1835,
    3442,   666,   872,  1422,  1428,  1471,  1472,  1473,   176,   770,
     177,  1245,  1078,   771,  1203,   179,   772,  2720,  3528,  4292,
    4293,  4294,  4297,  5329,  4868,  5322,  5863,  5864,  5865,   773,
    3524,   182,  2029,  3233,  3236,  3520,   774,  3534,  3535,  3536,
    4301,   775,  5630,  5631,  5632,  5633,  5877,  6210,  6211,  6214,
    6318,   776,   794,  1142,  3147,   777,  1356,   188,   189,   190,
     930,   875,   876,  3447,  5584,  5836,   192,  2597,  3425,   811,
    1477,   918,   919,   920,   939,  3028,  2686,  2687,  2711,  2712,
    1486,  1487,  2699,  2703,  2704,  3511,  3504,  2692,  4271,  5609,
    5610,  5611,  5612,  5613,  5614,  4857,  2707,  2708,  1489,  1490,
    1491,  2716,   193,  2676,  3477,  3478,  3479,  4247,  4248,  6197,
    4262,  4258,  4842,  5305,  3480,   864,  1240,  1498,  4850,  6199,
    3481,  5294,  5295,  5589,  4267,  3490,  4288,  3933,  3934,  3935,
    3482,  5846,  5847,  6194,  6195,  5591,  5592,  3483,  5838,  6368,
    6369,  6408,  6445,  2744,  1451,   903,  1357,   904,  1464,  1358,
    1438,   906,  1359,  1360,  1361,   909,  1362,  1363,  1364,   912,
    1430,  1365,  1366,  1447,  1460,  1461,  1367,  1423,  5593,  1369,
    1370,  1371,  3485,  1372,  4786,  5266,  5252,  3347,  3348,  2620,
    5574,  4782,  4160,  4776,  2590,  2594,  5317,  5616,  5617,  3418,
    4209,  4813,  5283,  5832,  6031,  6032,  6178,  1373,  1374,  1375,
    3410,  2584,  1000,  1376,  4540,  2586,  3338,  3316,  1736,  3317,
    2032,  2054,  3265,  3281,  3282,  3386,  3318,  3326,  3331,  3339,
    3372,  1377,  3267,  3268,  4071,  2056,  1378,  1044,  1739,  1045,
    1466,  3367,  5232,  5539,  5540,  5817,  5818,  5550,  5819,  5551,
    5541,  4082,  4083,  6020,  3292,  3387,  4086,  3300,  3301,  4104,
    4093,  3293,  1379,  4095,  1387,  1388,  1381,  2023,   865,  5301,
    1198,  1820,   808,  1382,  1383,  1384,  1385,  1607,   971,  1165,
    1166,   921,   923,   924,  2680,   662,   654,   973,  3681,  2587,
     663,   656,   657,  1825,  2588
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     653,    71,   998,  1051,    80,   175,    83,    84,    85,  1735,
     929,    86,   999,   106,   963,   184,   124,   805,  1492,   807,
     129,   191,  1004,   813,   831,  1009,   769,   159,   821,   829,
     833,   178,   836,   185,  1832,   829,   829,  1662,   866,  1392,
     869,  1949,   191,  1105,  1380,   940,  2953,   925,   925,   925,
    2846,  1443,  2875,  3645,   867,  1715,  1145,  1667,   796,  2845,
     180,   181,  1143,  1826,   796,  1419,  1231,  1232,  1233,   183,
    1197,  2003,  1237,  1478,  1463,  1480,  3521,  2831,  1727,  2051,
    3522,  2858,   186,  3248,   951,  1434,  1435,   863,  1424,  2043,
    2740,  1406,  4051,  1892,  3975,  1442,  4219,  1007,  4221,  1449,
    1237,  4016,  4286,  1051,  3110,  1204,  2035,  4446,  3923,  3892,
    2037,  1029,  1511,  2038,  2039,  1865,  4594,  4620,  3239,  1870,
    3323,  3022,  3914,  3303,  1874,  4607,   803,  4338,  3264,  1418,
     660,  4645,  4859,  1178,  1884,  3299,  4396,   711,  4398,   832,
    2914,  2914,  3805,  4542,  2914,  1072,  4261,  1191,  1904,  4925,
    4300,  5298,  4874,  4894,  2983,  2984,  1051,  2740,  4367,  3356,
    4372,   942,  2822,  2672,  3773,   943,   934,  1821,  3129,  3287,
    3291,  3294,  3295,   232,  5549,  3304,  3177,  3306,  3307,  1938,
    5142,  1606,  1205,  5152,  1145,  5163,  1176,  1602,  2979,  1180,
    1399,   653,   954,   954,  5505,  5103,   954,  1188,  5649,  5498,
     965,  5624,   866,   826,  5237,  1001,  5238,  5727,   965,  1051,
     860,   965,  1624,  4275,   866,  3011,   954,  1641,  1877,   866,
    3547,  3549,  2822,   954,  4244,   866,  4965,  1661,  1574,  5134,
    5310,  3428,  5312,  5466,  1901,  3430,  1693,  5151,   878,  2822,
    3440,  3513,  5766,  4306,  4188,  3516,  1720,  5641,  4088,   852,
    5779,  1834,  4191,  4604,  3851,  5494,  3854,  3855,  5367,  1485,
    5724,  3859,  3860,  3861, -2586,  3863,  3864,  3865,  1022,  5977,
    1488,  1051,  1569,   778, -2628,  2802,  3911, -2654, -2002, -2473,
    4299,  5497,  4090, -2697,  5965,  1900,  5020,  3492, -2473, -2473,
    5257, -2474,  3244,   670,  5689,  5690,  6012,  3882, -1994, -2438,
   -2474, -2474,  4177,  1931,  1931,  5679, -2885,  1931,  4259, -1961,
    4264,  4265,  6016,  1569, -1974, -2885, -2885,  1418,  1569, -2506,
    1541, -2002,  4101,  2859,  4124,  3365,  2631, -1999,  2990,  4630,
     778,  6161, -2590, -2019, -1989,  5113,  6163,   949,  3107,  5902,
     717,  3684,  6314,   778,  1263,  2996,   717,  6013,  1212,  2112,
    4053,  1857,   717,  1931, -2437,  1431,  1432,   717,  1862,  4559,
     717,  1216,  1408,  3832,  2760,   935,  1441, -1933,  5717,  2849,
    4687,   651,  1931,  2993,  1603,  2781,  4339,   778,  5945,  5811,
     778,  2637,   187,  2610,  4640,  1603,   717,  4334,  1145,  1941,
    2677,   778,   870,  5715,  6171,  1945,  2914,  3053,  1034,  6205,
    3685,  2675,  2112,   187,  -150,  1956,  4124,  1500,   717,  1959,
    -150,  3365,  3883,  1962,  2639,  1964,  5888,  1984,  5211,  5212,
    5213,  1972,  5215,  5216,  5217,  5218,  5219,  1978,   937,  3071,
    1981,  5114,  4978,   936,  2637,  1542,  1826,  6443,   928,  2970,
    3363, -2434,   784,  3587,  5164,  1727,  6168,  5093,  1879,  3340,
     668,  2683,   784,  1931,  1227,   784,  5640,  1931,   834,  1077,
    1396,   784,  5254,  5854,  6272,  4867,   785,  2639,   778,  5459,
    1235,  3076,  4043,  1481,  1541,  3463,   785,  5572,  4351,   785,
    1034,  3495,  6141,  5656,  2679,   785,  3767,   999,  6018,  6237,
    5364,  4469,   838,  1434,  1435,  1931,  1554,   784,  3240,  5998,
    2611,  4124,  3225,  1035,  6129,  5370,  2779,   194,  4290,  5082,
     784,  1018,  3445,  2907,  5979,  3686,  5794,  6479, -2651,  4688,
    2849,   785,  4065,  5115,  1097,  1442,  1098,  2648,   937,  5946,
    2931,  6491,  2850,  4530,   785,  1449,  5083,   999,  3446,   717,
    4591,  5795,  1019,  4470,  5767,  3108,  6315,  4291,  2782,  5999,
    3197,  1201,  6238,   195,  5899,   194,  4352,  6019,  4044,  4091,
    5573,  1483,  1236,   194,  4979,  1099,  1957,  4178,  5375,  1036,
    2105,  1109,  3496,   941, -2264,  3803,  2849,  3407,  5629,  5255,
   -2283, -2264,  6272,  1123,  3408,  1035,  1821, -2283,  2977,  1542,
    1947,  5460,  1826,  1947,  2849,  2065,  3077,  1457,   839,  4102,
    2849,   195,   891,  3226,  2632,  2614,  1145,  3341,  5947,   195,
    2626,  2626,  2048,  6444,  1932,  1932,  5755,  5094,  1932,  2106,
     712,  1132,  1863,  2849,  3884,  1267,  1987,  2024,  1501,  3364,
    2849,  3222,  1409,  1037,  3072,  4465,  2849,  2612,  2034,  2849,
    2112,  3222,  1228,  6262,  5812,  2783,   718,  6373,  2653,  2600,
    4339,  1036,  3026,  3222,  4179,  2044,  6075,  6360,  5937,  2876,
    1054,  4689,  2860,  2674,  1932,  1042,   866,  3054,   954,  1043,
     954,  4542,  2637,   954,  4335,  4980,  2861,   938,  2862,  -442,
    1001,  2948,  6112,  1932,  2951,  1112,  1082,   954,  1405,  6072,
    5603,  4560,   191,   954,  3687,  6407,  3020,  3021,  1543,  5000,
    4069,  6316,  5116,  1613,  3064,  2639,  1236,  6272,  4641,  5718,
    1410,  2958,  1236,  3366,  2726,  1037,  1863,   653,  3885,   929,
    1274,  6014,  1260,  4124,  6140,  3109,   965,  4125,  4126,  4127,
    1001,  1079,  1080,   965,  5333,  4631,   965,  3010,  2650,  1145,
    1081,  3833,  2920,  4180,  2863,  2608,  2997,  1145,  1145,   871,
    1266,  2809,   954,  1083,  1431,  1432,  6015,  6335,  6317,  2991,
    1208,  2816,  2807,  4302,  1932,  3019,  1544,  5376,  1932,  5112,
    1533,  2028,  6017,  5567,  1429,   671,  2998,  5117,  5385,  3260,
    1933,  1940,  3588,  1863,  1944,   191,  6334,  6095, -2651,  1444,
    1445,  6162,  1441,  4081,  2971,  2972,  6164,  3457,  1493,  4195,
    2937,  4092,  5159, -2586,  2994,   866,  1932,  5972,  1446, -2473,
    5160,  3027,  2717, -2628,  1256,  1209, -2654,  1214,  2893,  1218,
    5007, -2474, -2697,  2718,  2892,  1222,  5011,  1042, -1994, -2438,
    1955,  1043,  1444,  1445,  1386,  1386, -2885,   866,   829,  1433,
    6386,  4103,   829,  4139,  1437,  3195,   790,   791,  2938,  1977,
    3179,  1448,  2941,  2942,  1239,  1848,   866, -1999, -2506,   790,
     791,   866,  2780,  2066, -1989,   999, -2651,  1386,  2583,  1844,
    2108, -2590,  5975,  1849,  4930,  1850,  4932,  6254, -2651,  2826,
    6223,  6224,  2598,  3205, -2437,  1534,  6264,  3433,  6421,  4542,
    6437,  1863,  1633,   790,   791,  3220,  1604,  1605,  1726,  2877,
     942,  2678,  4592,  4261,   943,  6490,  6283,  1604,  1605,  1042,
    1239,  2655,  2656,  1043,  1386,  1225,  1634,  6496,  2580,  2581,
    2582,  2583,  4136,  4137,  4138,  4139,  -150,  -150,   866,   713,
    1980,  5536,  2826,    71,  1947,  4129,    80,   175,    83,    84,
      85,   866,  1839,    86,  2978,   106,  1042,   184,   124,  2826,
    1043,  4585,   129,   191,  4522,  4523,   866,  1526, -2264,   159,
    6216,  3409,  3616,   178, -2283,   185,  4460,  4461,  3702,  4735,
    4736,  4462,  4682,  5884,  2901,   866,  4740,  1474,  4592,  6228,
     954,   954,  1137,  4604,   790,   791,  1947,  3063,  1515,   714,
    1497,  4466,   180,   181,  3392,  3081,  4685,  2836,  4503,  4839,
    3229,   183,  6337,  4843,  4911,  1548,  3274,  4970,  4682,   717,
    4883,  6139,   829,   829,   186,  4134,  4135,  4136,  4137,  4138,
    4139,  6133,  4130,  2801,  5344,  5070,  2950,  4308,  6113,  4309,
     717,   715,  3694,   716,  4039,  1386,  1386,  1699,  3298,  4041,
    5074,  3513,  1896,  5073,  4280,  4721,  3041,  3266,  4226,   653,
    5345,   954,  1395,   187,  4798,   965,  1403,  2876,  1001,   965,
    2027,   965,  1425,  6277,  6207,  4829,   954,  4831,  4832,  2679,
    1931,  1535,  3870,  4517,  2878,  6208,  1516,   961,  3222,  4356,
    1700,   717,  6385,  2595,  3979,  1897,   717,  6121,  4573,  1095,
     866,   944,  6340,  6341,  5327,  1264,  4695,   954,   954,  2840,
    1881,  6291,  1625,  6132,  3413,  2879,  4583,     3,     4,  5754,
    5101,  6289,  1159,  1536,  5760,  6325,  2817,  1966,  3275,   866,
     866,   866,  5870,   954,  1826,   653,  3486,   653,   653,  1274,
    1517,  2880,  4124,  3230,  2690,  4101,  4125,  4126,  4127,  3393,
    5824,  5418,  4090,  1724,  3394,  3518,   187,   928,  1537,   717,
    4998,  4646,  4925,  2876,  2578,  2579,  2580,  2581,  2582,  2583,
    1967,   954,  2899,   954,   954,  5419,  1051,  3717,  4303,  5520,
    5128,  5183,  2874,   763,  6454,  6263,  3980,  3607,  3123,  6255,
    4424,  6277,  3161,   945,   652,  6292,   826,  1685,  2876,  2876,
    3168,  6440,  6375,    15,  4406,  3395,  1386,  3276,  3799,  5872,
    1401,    35,  5861,   806,  1453,  5928,  4407,  5930,  3206,  5662,
    3734,  5934,  5935,   667,  3217,  3218,  2818,  1626,  2842,  6423,
    6041,  1538,  2005,  2606,  2005,  3119,  5873,  5862,   866,   191,
     805,    20,  2923,  3800,  4131,  4132,  4133,  4134,  4135,  4136,
    4137,  4138,  4139,  4647,  2770,  1518,  6478,  3718,  6149,  2691,
    2917,   937,  3120,  2921,  2041,  3414,   866,  3362,  3519,  2876,
    2047,  1274,  5031,  3695,  4124,  3261,  6241,  3263,  4125,  4126,
    4127,  2843,  4696,  3270,  1386,  3277,  3608,  1701,  3278,  3284,
    3285,  4574,  1898,  1454,  4040,  1274,  4791,  6293,  4124,  4042,
    3181,  3308, -3012, -3012, -3012,  4425,  6342,  2877,  3735,  5871,
    3871,  3328,  3617,  1249,  5958,  6040,  6277,  3343,  2900,   929,
    1923,  2759,   941,  5496,   187,  5102,  1386,  3636,  1230,  3204,
    5328,  4128,  2956,  3209,  3546,  5490,  5484,  6468,  3216,  5515,
    1725,  3219,  5971,  1989,  5974,  1991,  3912,  1993,  3158,  1995,
    5986,  1997,  1998,  1999,  4129,  1386,  1386,  1386,  2001,  1386,
    3396,  5549,  3170,  3736,   944,  4121,  4122,  1968,  5957,  4539,
    4141,  1455,  3231,  5825,  1456,  3176,  2106, -1794,  4926,  6384,
    1386,  4108,  2876,  3847,  3469,   952,  5961,  5346,  4450,  5829,
    6391,  1932,  3154,  3232,   964,  5969,  3223,  3703,  5973,  1702,
    3156,  2844,   964,  2877,  1899,   964,  1250,  3279,  2028,   962,
    2596,  4172,  4173,  1627,  3188,  3169,  5549,  5340,  3171,   866,
    6209,  1096,  4102,  2635,  3175,  3981,  3737,  3842,   999,  4091,
    6422,  1882,  4648,  1523,  2980,  2822,  1524,  1386,  2877,  2877,
    3982,  4130,  5358,  1947,  1160,  6007,  6150,   947,    32,  5521,
    3314,  5208,  2090,  6294,  6405,  1628,   945,  2684,  2685,  4637,
    2689,   943,   943,  3525,   943,  6452,  5420,  3121,  3208,  2999,
    5032,  5678,  3214,  3215,  3611,  2772,  3795,  3551,  2876,  1969,
      40,  5880,  2878,  1386,  1646,  3835,  4129,  1386,  1386,  3568,
    1629,  4426,  2775,  1457,  4224,  5874, -1961,  6469,   866,   866,
     866,  2724,  6242,  1386,  5332,  3207,  1647,  4649,   946,  2877,
    2953,  5299,  6299,  2879,  6154,  3080,  2764,  1453,  3796,    44,
    2776,  1924,  5833,  2770,  3280,  6173,   829,  6460,  2765,  3140,
    3012,  1131,  6450,  4427,   717,  1925,  5802,  3259,  3607,  2880,
    3801,  5898,  5938,  2771,  2785,  2885,  2766,  1497,  1704,  1497,
    3738,   778,  3141,  3797,  1705,  2786,  5830,  6183,  1648, -1794,
    3486,  2813,  4251,    48,  2693,  3618,   829,   764,  4428,   954,
    4983, -1795,  5463,  4130,  4463,  3802,  3429,    49,  2878, -1961,
    2874,  3569,   866,  2848,  1914,  3638,  5831,  6243,  2618,  1251,
    5769,   866,  1926,  5834,   954,  1132,  1454,  4130,  6123,  5302,
     187,    50,  4120,  5173,  5306,  5770,   810,  5308,  1947,  2879,
    1458,  3923,  2694,  2878,  2878,  3000,  6244,  3620,  4543,  4281,
     765,  1001,  2877,   866,  4862,  3644,   829,  6330,  1826,  2916,
    2916,  2619,  1252,  2916,  1253,  2880,  3704,  3608,  3460,  6260,
    6261,  4252,  1526,   829,  2879,  2879,   866,  1526, -1106,   866,
    3964,  1649,  4464,  4131,  4132,  4133,  4134,  4135,  4136,  4137,
    4138,  4139,  -717,  1706,  4542,  4472,  4546,  3526,  2053,  6063,
    2880,  2880,  5768,   954,  1455,  4253,  2874,  1456,  1947,  5759,
    2695,  3739,  5087,  1133,  2878,  3607,  1863,  6316,  2062,  3740,
    4254,   866,  3741,  2777,  3197,  6174,  2111,  1927,  3552,  2112,
    5939,  3553,  4984,   954,   954,   954,   954,   866,  5088,  1650,
     947,  2874,  2874,  4255,  1651,  2879,  3461,  3621,  2877,  1652,
    3142,   866,  2767,  1526,  5803,  5139,  2740,  1526,  4549,  2696,
    2740,  2637,  1386,  1386,  1386,  2952,  3119,  2787, -3012,    40,
    2974,  2880,  4256,  5064,  2772,   816,  5139,  2103,  5068,  4458,
     683,  1274,  5140, -1795,  4124,  6074,  3167,  3566,  4125,  4126,
    4127,  5133,  3157,  3120,  2639,   999,   999,  6253,  1475,  1409,
    1928,  1654,  5303,  5140,  5092, -1961,  4792,  1481,    44,  2788,
    6212,  1034,  2874,  3199,  3608,  4131,  4132,  4133,  4134,  4135,
    4136,  4137,  4138,  4139,  2697,  1274,  1457,  2878,  4124,  5130,
    3742,  4282,  4125,  4126,  4127,  6331,  4863,  1821,  5771, -3012,
   -3012, -3012,  4134,  4135,  4136,  4137,  4138,  4139,  6363,  1656,
    5272,  3609,    48,    40,   685,  3611,  6189,  6364,  2879,  3819,
    3150,   866,  2602,  4252,  -630,  1705,    49,  4174,  1457,  5449,
    6387,  4257,   866,  1657,  4552,  4468,  3085,  1410,   982,  1707,
     954,   954,  5296,  1134,  2880,   983,   984,   985,  5089,  1260,
      50,  6213,    44,  3610,  1659,  1483,   954,  4253,  2943,   941,
     941,  5085,   941,  1929,  1476,  2112,  3439,  3448,  5661,  3527,
    2693,  3742,  4845, -3012,   866,  2916,  1035,  2876, -3012,  6333,
    1135,  1708,  4553,  2878,   999,  2874,  1615,  4539,  4968,  1443,
     954,   954,   954,   954,  6309,  4255,    48,  2603,  4554,   866,
    6466,   952,  2886,  1458,   817,  1660,   866,  1484,   778,  3130,
     964,  3517,  5693,   818,  2879,  4996,  1709,   964,  2694,  6310,
     964,  3086,  6480,  3486,   653,  5304,  3486,   653,  1459, -3012,
    2639,  5978,  6220,  6190,  3820,   837,  5086,   965,   965,  5964,
    2880,  5341,  1036,  3200,  1136,  3197,  1137,  5141,  1001,  1001,
    1138,  3662,   965,    56,  3197,   965,  4129,  1591,  5478,  5985,
    3753,  6383,  3611,  1616,  3567,  4751,  4969,  4752,  6127,  1664,
     954,   954,  5688,  6236,  3486, -1961,  3201,   954,  2776,   866,
     784,  2874,  3486, -1961,   664,  1433, -1961,  1462,  2644, -1961,
    3202,  1882,  3489,  5773,  2876,  2876,  2005,   696,  3691,   697,
    4129,  5774,  4555,   954,   785,   965,  1037,   191,  3213,   965,
     965,  1665,   866,   866,  2944,   954,  5342,  3663,  4942,  2945,
     664,  3290,   866,  4257,  3715,  3664,   701,  6084,  3203,   866,
    3245,  4896,   866,  3130,  3997,  2696,   805,   665,  3726,   805,
    3250,  5801,  4302,  4130,  1386,  2854,  1386,  2855,  1082,  3633,
    5534,  1386,  1386,  4943,   191,  6344,  5599,  4897,  1386,  1386,
    1386,  1386,  1386,  1386,  1386,  1386,  1386,  1386,  1386,  1386,
    1386,  3234,  4686,   933,  1386,   861,  1386,  1001,  1386,  1386,
    1386,  1386,  1386,  1386, -3012,  2866,  1386,  4130,  1386,  1386,
    4698,  3665,  1386,  1079,  1080,  5685,  3836,  3837,  3838,  3798,
    2697,  1145,  1081,   873,  6085,  4539,  6191,  1386,  1386,  1386,
    3189,  6192,  3190,  2856,  3191,  1083,  3192,  2877,  3193,  5686,
    4898,  2867,  3194,  4753,  3715,  1386,  3644,  1666,  2740,  2924,
    1439,  1440,  4374,  4350,  2927,  3923,  6131,  2953,  2740,  5465,
    4273,  3754,  1980,  4710,  2112,  4860,  6148,  6193,  3249,  3757,
    3752,  4944,  3760,  4722,  6130,  4734,  6461,  4168,  4726,  5476,
    4747,  4748,  4749,  4750,  3941,   954,  4754,  4755,  4756,  4757,
    4758,  4759,  4760,  4761,  4762,  4763,  2637,  3991,  5489,  3729,
    6425,  3727,  5635,  3728,  5637,  1643,  5775,  5790,  3779,  4363,
    3880, -3012,  5956,  1882,  5445,  4725,  3013,  3804,  4899,  6462,
    4730,  4731,  4900,  2578,  2579,  2580,  2581,  2582,  2583,  2639,
    3002,  4668,  1207,  2740,  3008,  1124,  3927,  3928,  3929,  3930,
    5467,  3932,  4861,  3826,  5931,  3630,  3842,  1644,  5446,  5932,
    4802,  4803,  4512,   952,  2877,  2877,  1481,  2962,  3014,   964,
    1980,  2914,  1482,   964,  4505,   964,  3960,  4375, -1765,  6448,
     948,  6451,  1125,  1502, -1765,  4131,  4132,  4133,  4134,  4135,
    4136,  4137,  4138,  4139,  1101,  1248,  1102,  2963,  1512,  5468,
    5685,  1124,  4016,  1386,  4467,  3770,  1646,  3771,  4681,   931,
    5436,  3775,  5437,  5438,  5439,  5933,  5455,  1630,  5457,  1695,
    1126,  3734,  2878,  5989,  5686,  1503,  1670,  6256,  1647,  4131,
    4132,  4133,  4134,  4135,  4136,  4137,  4138,  4139,  1125,  1916,
    1513,  1918,  1919,  4826,  3898,  6492,  2849,  1980,  1420,  6006,
    1633,  4504,   932,  2879,  1483,  4682,  4278,  1386,  2857,  5485,
    1504,  1696,   778,  6155,  5968,  1697, -1765,  4926,  1671,  4828,
    1127,  4305,  5050,  5734,  1634,  1514,  4586,  4035,  4896,  2880,
    1648,  4377,   988,   989,   990,   991,   992,   993,   994,   995,
     996,  4913,  4972,  3789,  1636,  5051,  1698,  6156,   187,  3790,
    6365,  4926,  2943,  1672,  4897,  6489,  1484,  1902,  5936,  3735,
    1470,  4956,  3989,  1712,  1386,   793,  1716,  3995, -1765,  3996,
    2874,   793,  6498,  3953,  4421,  6366,  1127,  5735,  6147,  4002,
    5736,  1903,  4003,    40,  4004,  4005,  4616,  5737,  4007,  2878,
    2878,  4024,  4010,  4251,  4011,   187,  1507,  4013,  5377,  6336,
    4949,  1591,  1974,  1213,  1215,  1217,  5383,  3915,  1219,  1220,
    1221, -1718,  5542,  2866,  3736,  5738,  4422,  4898,  1226,  1633,
    2879,  2879,    44,  1649, -1718,  3082,  1975,  3024,  3025,  3289,
   -1718,  6218,  3015, -2457,  1508,  5543,  6346,  -173,  1509,  5033,
    5685,   949,  5544,  1634,  3016,  3112,  2880,  2880,  4158,  2867,
    4312,  4423,   683,  3342,  4165,  1433,  5545,  2673,  3791,  4376,
    4377,  4052,  -150,  5034,  5686,  1042,    48, -2438,  -173,  1043,
    3899,  1646,  4252,  1510,  3017,  1274,  5739,  3737,  4124, -1718,
      49,  1650,  4125,  4126,  4127,  4220,  1651,  2874,  2874,  5740,
    4378,  1652,  5245,  1647,  5246,  4899,  4882,  4926,  4023,  4900,
    5273,  1433,  5741,  2673,    50,   233,  4253,  2952,  2944,  1444,
    1445,   669, -1718,  2945,  1444,  1445,  6062,  4123,  6169,   761,
     763,  4254,  4653,    56,   957,  6170,   685,  4654,  1446,  4151,
       3,     4,  2106,  1448,  4066,  5890,  5901,   835,   959,  4067,
      15,  5905,  5906,  1654,  4255,  1648,  1673,   980,    40,  1386,
    1386,  1386,  1386,  1386,  1386,  1386,  1386,  1386,  1633,  1386,
    1433,  5081,  1462,  5167, -1718,  4175,  1623,  3600,  4654,   866,
    1386,  1640,  1386,  4256, -1718,   981,  5296,   999,    20,   866,
    1042,  1033,  1634,  3597,  1043,  3601,  3602,    44, -2430,  1827,
    5546,  1656,  1828,  1042,  6453,  1230,  4150,  1043,  4152,  4153,
    2052,  3738,    56,  4875,  3377,  3378,  3379,  3380,   866,  4206,
    1386,  1092,  1674,   954,  1386,  1657,  2626,  1386, -2431,  1386,
    3441,  4473,  1386,  1042,  1024,  1230,  1386,  1043,  1433,  -468,
    2673,    48,  5695,  4231,  4232,  1041,  1659,  4340,  1649,  1986,
    2036,  1085,  1828,  1828,  3792,    49,  3371,  2634,  3900,  3488,
    1828, -1718,  1087,  4222,  1675,   866,   866,  1474,  1106,  3594,
    2647,  1676,  -629,  2648, -1718,  1677,  1386,  1120,  2681,    50,
   -1718,  1828,  4257,  4382,  3185,  1386,  1386,  2648,  1444,  1445,
    3196,  3486,  4307,  3197,  1128,  3486,  3793,  1660,    56,   866,
    4129,  3198,  3237,  3629,  3197,  3238,  1650,  3532,  1130,  3537,
    3901,  1651,  5200,  1129,  1474,  1474,  1652,  3514,  3515,   696,
    6320,   697, -1789, -1789,  5742,  6323,  6324,  5743,  5207, -1718,
    5990,  3794,  2952, -1718,  1147,  3444,  4193,  1826,  1980, -1793,
   -1793,  4268,  3739,  3570,  2674,  3573, -1792, -1792,  1878,   805,
    3740,   805,  4955,  3741,  1151,  3449,  3538,  5547,  2648,  2648,
    5324,  1579, -1718,  1145,  -468,  1386,  1158,  1580,  1654,  5548,
    3627,  4602,  3709,  3628,  4251,  3710,   653,  5892,  5893,   965,
    1001,   965,   965,  5230,  1167,   954,  3876,  4130,   866,  3877,
    5235,  5236,  3529,  5135,  4015,    32,  3733,  3197,  6033,  6034,
    3486,  4323,  1042,  1174,  4064,  1467,  1043,  2648,  4073,   829,
    4079,  2648,  1582,  2648, -1718,  6464,  1656,    40,  6467,  4343,
    3145,  2848,  3146,  4945, -1718,  4952,  4080,    40,  4912,  2648,
    5886,  4929,    40,  6179,  6180,  3650,   866,  3615,  1185,   664,
    1657,  1988,  3661,  4084,  1990,  4085,  1992,  1168,  1994,  4099,
    1996,   866,  3835,  4252,  2000,  4110,    44,  1678,  2648,  4143,
    4539,  1659,  2648,  6308,   926,   927,    44,  4697,  4926,  1583,
    1192,    44,  4316,   866,   778,  4157,  1584,  3823,  2648,  1202,
    1585,  6419,  4386,  1238,  4388,  2740,  4589,  4253,  4162,  4229,
    3349,  4163,  2648,  3352,   866,  1679,  4561,  1229,  1234,  1680,
      48,  4971,  4254,  4399,  6215,  4416,  4400,   829,  4404,  1586,
      48,  4405,  1660,  4432,    49,    48,  4433,  1241,  4501,  4625,
    1145,  4433,  4626,  1230,    49,  4255,  4327,  1244,  2111,    49,
     954,  2112,  1246,   954,  1681, -3012, -3012, -3012,    50,  4628,
    1247,  1682,  4629,  3724,  4659,  1587,  4772,  4660,    50,  4773,
    4313,  4314,  4783,    50,  4256,  4784,  4211,    56,  4212,   866,
     866,  4794,  4870,  2637,  2648,  4871,  4876,    56,  1257,  4877,
    2638,  5860,    56, -1718,  3806,  6137,  3809,  3811,  4531,  1258,
    1260,  4441,  5782,  1259,  4885,  4881,  4447,  5136,  3553,  3769,
    3197,  3063,  6268,    29,  5202,  5242,  2639,  2028,  2648,  4131,
    4132,  4133,  4134,  4135,  4136,  4137,  4138,  4139,  1386,  1386,
    1386,  1262,  1261,  3371,  1386,  3373,  5279,  3374,  5335,  2648,
    5361,  3553,   954,  5362,  5491,  1690,  1268,  5492,  4491,  1589,
    3484,  1270,  3486,  3486,  4498,   954,  5528,  1404,  1407,  4660,
    1590,  1386,  1042,   954,  3375,  1411,  1043,  3476,  4886,  6426,
    1591,  1412,  4057,  4257,  4059,  4060,  2848,  3462,  3464,  3465,
    5153,   866,  1592,  5564,  1413,  1421,  5565,  3913, -1718,  5146,
     805,  5566,  5586,  5596,  2648,  5587,  1980,  5602,  6077,  6078,
    4599, -1718,   954,  3924,  4213,  1417,  4214, -1718,  1274,  4872,
    1426,  4124,   187,  3806,    40,  4125,  4126,  4127,   952,  5604,
    4437,   952,  4599,   954,  1718,  3946,  1427,  1594,  1595,  3376,
    5729,   964,   964,  5730,  5749,  2640,  5845,  3197,  5783,  1429,
    2641,  5784,  4453,  4613,  3964,  4614,   964,  6482,  4054,   964,
    1436,  5843,  5849,    44,  5844,  1980, -1718,  5852,  5868,  1719,
    4599,  5869,  5920,  4926,   954,  5921,   954,  5960,   954,  5987,
    2605,  1433,  5869,  6024,  5489,  6025,  4163,  6045,  2648,  6049,
    6046,  5075,  1980,  5076,  4579,  3377,  3378,  3379,  3380, -1718,
    1437,  2643,  3381,  3382,  1450,  1452,  2679,    48,  3383,   964,
     999,  2005,  6050,   964,   964,  2648,  6058,  4887,  1467,  6059,
    3942,    49, -1131,  4928,  4888,  6083,  4931,  6086,  3238,  4934,
    3238,  4889,  6087,  6090,  2740,  3238,  2648,  6091,  1468,  6057,
    2648,  1145,  1597,  1145,  1479,    50, -3011,  4562,  1494,  4564,
    4661, -1718,  4663,  1495,  4665,  4691,  4593,  1496,  1462,  6092,
    2644, -1718,  6093,  1575,  6269,   653,   954,  1577,   965,  4890,
     965,   965,  6119,   954,  6185,  6120,  5815,  4599,  5816,  4704,
    1386,  1727,  1546,  6200,  6202,  1386,  2648,  2648,  6137,  3365,
    6217,  1578,  4891,  3197,  4926,  6232,   929,  6258,  6233,  5558,
    6259,  6393,  1618,  6394,  3486,  4778,  1826,  1467,  1499, -1706,
    4572,  3486,  4575,   683,  1505,  1572,  3486,  2111,  4274,  3486,
    2112,  6307,  5554,  5555,  5857,  1145,  4822,  6343,  4824,  1515,
    5869,  4634, -2475,  4129,  1386,  1386,  1386, -1104,  6389,  1386,
    5288,  6390,  5290,  2679,   929, -3011,  1613,  1386,  1386,  1386,
    1386,  6409,  2637,  4676,  6410,  4744,  2646,  1617,  6417, -3012,
    4955,  4871,  1619,  1386,  1274,  3384,  1386,  4124,  1386,  1632,
    1630,  4125,  4126,  4127,  1642,  6266,  6420,  3385,  1645,  2648,
    1386,  1386,  1669,  6447,  1386,  2639,  6046,   685,  6449,  4771,
    6457,  2648,  6495,  6458,  6497,  6410,  1686,  6458,  6499, -3011,
    4844,  6410,  4847,  1001,  2719,  1386,  2722,  1386,  1687,  1386,
   -1718,  1703, -3011, -1717,  5581,  1713,  5582,  1516, -3011,  4926,
    4130,  5359,  4946,  1714, -3011,  1717, -1717,  1722,  1386,  1836,
   -3011,  4210, -1717, -3011,  1723,   866,  1838, -3011,  1840,  1845,
    4810,  1851,  1856,  1859,  1861,   687,  1866,  1869,  1871,   929,
    1863,  4216,  4217,  4218,  1885,  1880,   866,  1886,  4192,  -137,
      29,  1889,  1888,  2574,  1891,  4699,  1894, -3011,  1893, -3011,
    1905,  1517, -3012, -3012, -3012,  2578,  2579,  2580,  2581,  2582,
    2583, -1717,  1912,  1914,  3484,  1917,   653,  5699,  1921,  3488,
    4249,   213,  1930,  1935,  4249,  4263,  4249,  4249,  1936,  1937,
   -3011,   929,  1939,  1386, -3012,  1474,   935,  1942,  1386, -3012,
    4181,  4908,  4182,  1943, -1717,  5180,  1946,  1947,  1954, -1766,
     187,  1958,  1960,  1386,  1961, -1766,  1963,  2674,  1965,  1970,
    1971,  1973,  1976,  1983,  5700,  1985,  1979,  3488,  1982,  4183,
    2002,  4295,  2033,  2040,  4298,  3488,  2049,  3537,  2042,  3691,
    2111,  4966, -3011,  2112,  2045,  2050, -3011, -1965, -1972,  5701,
   -3012,    40, -3011,  2059,  2057,  5056, -1717,  2058, -1962,  5069,
     696,  2060,   697,  2061,   936,    56, -1717,  3715,  5702, -3012,
    2063,  2064,  2065, -1131,  5703,  2637,  1518, -1963,  1386,  2067,
    2068, -1966, -3012,  5807,  2069,  2070,   700,  3486,  2071,  1878,
      44, -1964,  2072,  2073,  3376,  2074,  5704, -1766,  5061,  2075,
    5705,  2076,   954,   954,  5821,  2077,  2078,  6424,  2639,  2644,
    2079,  2080, -3011,  2082,  2083,  5706,  2084,  2085,  2086,  2087,
    2088,  2089,  4131,  4132,  4133,  4134,  4135,  4136,  4137,  4138,
    4139,  2092,  2090,  2093,    48,  5842,  2094,  2095,  1386,  2096,
    2097,  2098,  1519,  2099,  2589,  4995,  4362,  2593,    49, -1766,
    3377,  3378,  3379,  3380,  2595,  2591,  4130,  4184,  2596,   937,
    2609,  2605,  2621,  4185,  2629,  2651,  2657,  3366,  2111,  2652,
    2659,  2112,    50,  2660,  2663,  2113,  2114,  2115,  2666,  2664,
    1520,  4801,  2667,  2668,  1521,  2669,  2670,  2675,    35,  4274,
    1482,    56, -1444,  2636, -1444,  1484,  4410,  2713,  2715,  2725,
    2682, -3011,  2727,  2637,  2728, -3012,  2729,  2730,  2746,  2747,
    2638,  2748,  2749,  2750,  2103, -1717,  2673,  2751,  2752,  1522,
     866,  5707,  2753,  2754,  2755,  2756, -3011, -3012, -3011, -3011,
    2916,  2762, -3012,  2778,  2784,  2804,  2639,  2808,  2811,  2790,
    2812,  2810,  2814,  2815,  2828,  2833,  2832,  2834,  2852,  2853,
   -3011,  2868,  2870,  2871,  1523,  2872,  2864,  1524,  2873,  2874,
    2882,  2883,  2103,  2111,  2884,  2889,  2112,  5511,  3486,  2887,
    2113,  2114,  2115, -3011,  2888, -3011, -3011,  5708,  2898,  2908,
    2922,  2894,  2932, -3012,  2895,  2904,  3371,  2905,  2636,  3486,
    2918,  2939,  2946,  2949,  2964,  1591,  2975,  2966,  2637,  2919,
    2925,  2968,  4202,  2928,  2976,  2638,  2992,  2929,   938,  1525,
    3001,  3023, -3012,  2973,  3035,  3037,  3038,  2934,  3039,  4035,
    4186,  2935,  2947,  3486,  2578,  2579,  2580,  2581,  2582,  2583,
    2954,  2639,  4187,  2955,  3030,  2960,  2961,  3040,  2967,  1386,
    2969,  2981,  2644,  2982,  2995,  1386,  3044,  3484,  3006,  3045,
    3484,  3046,  3052,  3048,  3051,  2640,   954,  3049,  3050,  3057,
    2641,  3056,  3058,   652,  4237,  3059,  3066,  4243,  4131,  4132,
    4133,  4134,  4135,  4136,  4137,  4138,  4139,  3067,   678,  3070,
    3075,  3083,  3094,  2642,  2306,  3098,  1666,  3111,  5197,  3099,
    3102,  3114,  3117,   866,   866,   866,  3118,  3127,  3484,  3138,
    2679,  3144,  3487,  3148,  3160,  3162,  3484,  3163,  3164,  5189,
     866,  2643,  5191,  3131,  3135,  3476,  3153,  3210,  3178,   928,
    3221,  3247,  3165,  3476,  1386,  3266,  3344,  3271,  3235,  3350,
    2112,  3391,  3411,  3437,  3311,  3417,  3432,  3438, -3012,  3452,
    3451,  5206,  2005,   866,   866,  3354,  3370,  3389,   866,  3416,
    2640,  5267,  3436,  3453,  2373,  2641,  3435,  3450,  3454,  3455,
     866,  3459,  1457,  3467,  5472,  3468,  3489,  3506,  3523,  3486,
    2644,  3507,   936,  5146,  3508,  5108,  5109,  3494,  2642,  2306,
     952,  3530,  3509,   964,  3542,   964,   964,  3531,  3543,  3545,
    3571,  3562,  5192,  5193,  5194,  5195,  5196,  3574,  5253,  3576,
    3579,  3584,  5314,  3589,  3603,  3590,  2643,  3595,  3592,  4623,
    3619,  1401,  3640,  1405,  3624,  3626,   954,  3643,  3634,  3641,
    3642,  3653,  3666,  3672,  3671,  3692,  3698,  3705,  3699,  3700,
    3213,  4679,  3708,  3725,  3807,  3747,  3726,  3834,  3716,  3723,
    3763,   866,  1882,  3822,  4619, -3012,  3746,   937,  3486,  2373,
    3830,  3831,  3843,  3850,   866,  3856,  3857,  2578,  2579,  2580,
    2581,  2582,  2583,  3862,  3878,  2644,  2646,  3867,  2645,  4808,
    3858,  3889,  3890,  1386,  3904,  3908,  3910,  3906,  3918,  3931,
    4656,  3936,  1386,  3937,  3938,  3939,  3940,  3925,  3944,  3949,
    1239,  3947,  3951,  3952,  3955,  3956,  1386,  3961,  3976,  3977,
    1386,  1386,  1386,  3986,  3978,  3987,  5443,  1386,  3988,  3990,
    1386,  3992,  4006,  1386,  4008,  4012,  4009,  5889,  4014,  1386,
    4017,  1386,  4018,  4019,  1386,  4020,  4021,  1980,  1549,  1386,
    1386,  1386,  1386,  4027,  4032,  1386,  1386,  1386,  1386,  1386,
    1386,  1386,  1386,  1386,  1386,  5347,  1977,  4022,  1386,  1386,
    1386,  1944,  4038,  4026,  4036,  4037,  4045,  5381,  1386,  4050,
    1236,  2646,  4048,  1386,  1550,   929,  4058,  1386,  4078,  4081,
    4094,  4098,  4075,  2574,  3288,  1386,  4076,  4120,  1386, -2256,
    1386,  4077,  2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,
    2583,  4156,  4159,  4089,  4176,  4171,  1386,  4100,  4190,  1386,
    1386,  4096,  5387,  5388,  1386,  1386,  4227,  4207,  4111,  1386,
    4106,  1386,  4814,  4109,  4112,  4116,  3486,  4274,  4233,  3835,
     866,   866,   866,  4118,  4119,  5318,  4142,  4147,  1551,  4148,
    4815,  4816,  4817,  4818,  6300,  6301,  2648,  2706,  6303,  4200,
    1386,  4249,  4263,  4249,  4249,  4274,  1386,  4249,  4155,  4201,
    4837,  4241,  4270,  1082,  3488,  4170,   722,  4203,  3488,   191,
    4250,  3251,  4285,  4283,  4852,  1552,  4289,  4287,  2574,  4296,
    4304,  4205,  4266,  4228,  4234,  4310,  2066,  2575,  2576,  2577,
    2578,  2579,  2580,  2581,  2582,  2583,  4235,   652,  4236,  4276,
    4315,  1386,  4242,  4318,  4097,  4317,  5431,  5432,  1079,  1080,
    4322,  4324,  4347,  4348,  4336,  4349,  3537,  1081,  1386,  4361,
    4337,  4353,   725,  3252,  4355,  1553,  4359,  4360,  4365,  5356,
    1083,  4368,  4366,  4371,  4385,  4373,  3487,  4384,  4387,   726,
    3486,  4395,  4393,  4403,  4411,  4394,  4420,  4434,  4436,  4438,
    4440,  4442,  4444,  4448,   187,  4449,  4452,  1059,  4454,  4455,
    4459,  5421,  5422,  4456,  5424,  1554,  4457,  4474,  4476,  1555,
    4477,  4478,  4475,  4927,  2005,  2848,  4481,  2005,  5456,  5580,
    2005,  3253,  4936,  4490,  4479,  4484,  4486,  4488,  4493,  5511,
     187,  4480,  4482,  4483,  4495,   729,  4497,  2990,  2993,  4485,
    4487,  4960,  1556,  1557,   730,  4489,  4499,  4500,  4506,  4516,
    4521,  4527,  4509,  5619,  4510,  4513,  4511,   731,  4529,  4565,
    4570,  4577,  4571,  3254,  4580,  4581,  4584,  4588,  4598,  4599,
    4601,  4608,  4617,  5414,  4611,  4618,  4621,  5527,  4622,  4624,
    5529,  5530,  4638,  4652,  1558,  4274,  4655,  3486,    35,   952,
    1062,  4662,   964,  1559,   964,   964,  5009,  4658,  4664,  4670,
    5535,  4671,  1560,  4672,  4673,  4677,  4693,  4674,  4675,  4692,
    4700,  1561,  4694,  4701,  4702,  4703,  4705,  4706,  4713,  1562,
    4718,  4723,  4707,  4717,  4708,  4709,  4719,  4724,  3255,  2052,
    4727,  4732,  1563,  4720,  4124, -2255,  4733,  4785,  4796,  4738,
    4797,  1564,  4827,  4768,  5012,  4745,  1565,  4769,  4770,  4777,
     735,  5053,  4800,  2953,  4811,  3769,  4823,  4825,  4833,  4840,
    4836,  4841,  4848,  4838,  4849,  4853,  4854,  4855,  4856,  4864,
    4858,  5474,  4867,  4869,  4873,  4893,  4904,  4884,  4914,  4907,
    4905,  4906,  4915,  4917,   954,  4921,  5623,  4918,  4937,  4940,
    4941,  4958,  4961,  4974,  4977,  3638,  4973,  4989,   954,  4975,
    1386,  4976,  4987,  4988,  1566,  4990,  4991,  4992,   866,  5003,
    5001,  5010,  5021,  5022,  5098,  5027,  5030,  5046,  5047,  5004,
    5049,  5914,  4947,  5916,  5698,  2848,  5052,  5062,  5078,  5063,
    5065,  5066,   213,  3256,  5067,  5090,   740,  5100,  5105,  5111,
     866,  5119,  5126,  2103,  5132,  3488,  3924,  5125,  5138,  5131,
    5148,  5154,  5155,  3806,  4543,  3486,  5165,  5174,  5176,  5190,
    4544,  5198,  5147,  1066,  3222,  5204,  3257,  5172,  5171,  5184,
     187,  5595,   866,   744,  4545,  3484,  5178,  5179,  5175,  3484,
     745,  5205,  5595,   746,  1386,  1386,  5222,  5223,  5214,  5221,
    5224,  5226,  3476,  5225,  2111,  1386,  3476,  2112,  5227,  5228,
    5233,  5244,  4546,   747,  4547,  5234,  2005,   866,  5239,  5250,
     652,  1068,  5282,   652,  5256,  5261,  5297,  5265,   749,   999,
   -2257,  1069,  5259,  5260,   866,  5746,   751,  5278,  5292,  2637,
    4548,  5316,  5307,  5320,  5300,  5293, -3012,  5321,  6038,  5311,
    5331,  3258,  5925,  5336,  5334,  5339,  5319,  5363,  5343,  3487,
    5337,  5364,  3487,  5378,  5379,  3966,  5380,  5382,  5368,  5157,
    5389,   652,  2639,  5384,  4549,  1386,  5390,  5391,   756,   652,
    3486,  5410,  5412,  5403,  5416,  5406,  3486,  5425,  5417,  1549,
    5647,  1386,  5426,  5434,  3484,  5433,  5435,  5440,  6071,   655,
    5444,  5447,  5451,  4550,  5452,  5453,  5461,  5464,  5469,  1386,
    3487, -2774,  5473,  5477,  5479,  5488,  5471,  5493,  3487,  5495,
    5470,  5483,  5499,  5500,  5502,  1550,  5504,  5506,  5668,  5517,
    5508,  5507,  3197,  5523,  5525,  5532,  5533,  1386,  5559,  5569,
    1386,  5570,  5579,  5588,   917,  6104,  6106,  5625,  1386,  1386,
    5823,  5538,  5663,  5552,  5563,  1386,  1386,  5583,  5553,  5571,
    1386,  5594,  5598,  5636,  5828,  1386,  5628,  5643,  1386,  1386,
    5601,  5639,  5620,  5622,  5653,  1386,  5657,  5658,  5659,   866,
     866,   866,   866,  3297,  3297,  4551,  5851,  5638,  5665,  1551,
    4552, -3012,  5652,  2105,  5654,  5655, -3012,   653,  3324,  5660,
    4249,  5671,  5713,  5672,  3488,  5676,  5691,  3345,  5682,  3488,
   -2774,  3486,  3488,   653,  5683,  3806,  5684,  5313,  5719,  5720,
    1386,  5089,  1001,  5722,  5725,  5728,  1552,  5732,  5733,  5752,
    5753,  5757,  5762,  5764,  5780,  4295,  5785,  5799,  4553,  1386,
    5881,  3537,  5791,  5793,  5792,  5808,  5809, -3012, -2776,  2111,
    5826,  5338,  2112,  5813,  4554,  5835,  5859,   805,  5866,  5814,
    5876,  5883,  5827,  5841, -2774,  5853,  5855,  5909,  5910,  5927,
    5885,  3967,  5857,  5858,  5891,  5896,  1553, -2774,  6097,  5850,
    5894,  5887,  5902, -2774,  2637,  2848,  1386,  5941,  5944, -2774,
     655, -3012,  5908,  5952,  5948, -2774,  5919,  5954, -2774,   655,
     974,  5374, -2774,  6010,  5962,  5967,  2644,   655,  5982,   974,
     655,  5980,  5976,  5981,  5983,  6235,  5984,  2639,  5993,  5994,
    1555,  5323,  5325,   974,  6005,  5995,  3484,  3484,  5996,  6001,
    6003,  6011, -2774,  6021,  6022,  6109,  6026,  6035,  6036,  6044,
    6037,  6042,  6052,  3476,  5231,  4208,  3769, -2776,  6060,  6064,
    6065,  6067,  6068,  6069,  1557,  6082,  6102,  3769,  4555,  6114,
    6116,  6118,  6122,  2111,  6111, -2774,  2112,  1386,  6125,   187,
    6126,  6145,  5918,  6144,  1386,  6142,  6143,  6152,  6153,  6158,
    6159,  6160,  6165,  6166,  6172,  6177,  6167,  6181,  6182,  6184,
    4804,  6198,  5913,  6188,  6295,  6296,   954,  6196,  2637,    35,
    6206, -2776, -3012,  6219,  3968, -3012,  1145,  6227,  6221,  6229,
    6008,   954,  6112,  1560, -2776,  5698,  6113, -2774,  6247,  6248,
   -2776, -2774,  1561,  6265,  6249,  6267, -2776, -2774,  6286,  6284,
    2825,  2639, -2776,  6285,  6321, -2776, -3012,  6287,  6051, -2776,
    6053, -3012,  1386,  1563,  6290,  6302,  6288,  6298,  6311,  6312,
    6306,  6313,  1564,  6329,  6327,  6347,  6353,  1565,  6357,   653,
    6359,  6358,  6361,  6362,  6371,  6374,  2848,  6396,  6354, -2776,
    6376,  6397,  6400,  6395,  6398,  2005,  2111,  6399,  3969,  2112,
    6415,  4302,  6427,  6429,  6418, -2019,  6438, -2774,  6430,  6442,
    3924,  6455, -3012,  6316,  6444,  6471,  6456,  6472,  6488,  6475,
    1469,  5787, -2776,   954,  4805,  3946,  6463,  6477,  6483, -3012,
    6481,  2637,  6486,  6494,  1684,  1566,  1683,  4225, -3012,  3970,
    3780,  2578,  2579,  2580,  2581,  2582,  2583,  1576,  3007,  3697,
    4379,   866,  2628,  4964,   999,  4957,  6230,  3821,  3869,  4526,
    5710,  6096,   866,  6328,  2639,  5107,   810,  5763,  4953,  4954,
   -3012,  2644,  5450,  5745, -2776, -3012,  4357,  4320, -2776,  5940,
    4274,  5372,  5669,  6378, -2776,  6322,  5645,  6379,  3484,  6117,
    6339,  6115,   999,  6246,  4364,  3484, -2774,  5481,  5667,  5129,
    3484,  5158,  5137,  3484,  5099,  6079,  3887,  6097,  3888,  4962,
    5486,  4397,  3476,  4587,  1668,  1386,  5124,  3476,  5475,  5751,
    3476, -2774,  4627, -2774, -2774,  1386, -3012,  5182,  1386,  6392,
    5997,  1386,  1386,  1386,  6073,  6493,  6473,  5276,  5726,  4532,
    5166,   187,   187,  5712, -2776, -2774,  6251,  5670,  5904,  5673,
     759,   812,  1145,  1075,  2025,  5879,  1386,  1386,  4678,  5199,
    1386,  5201,  6388,  3074,  3916, -2774,  5168, -3012, -2774, -2774,
   -2774,  4311,  3548,  5788,  4644,  3137,  5991,  1386,  1146,  3133,
    4496,  1386,  1186, -3012,  4993,  2644,  3818,  1386, -3012,  3149,
    4443,  3488,  6271,  6428,  5185,  5313,  1414,  6377,  1386,  2761,
    5618,  5186,  5326,   810,  6203,  3846,  1386,  3032,  4878,  3493,
    5875,  5878,  4927,  2649,   840,  1386,   841,  5229,  3166,  4272,
    4284,  2601,  6201,  3503,  6054,  4245,  2710,  4846,  4830,  4238,
    5600,  4879,  5840, -2776,  5839,  4239,  6413,  6187,  6043, -3012,
    2709,  6304,  4240,  6441,  2714,  5822,  4927,  1001,   954,  4779,
     954,  3412,  2005,  6055,  2658,  4204,  3966,  6056, -2776,  3415,
   -2776, -2776,  3330,  4198,  3845,  4070,  4196,  6009,  6446,  4189,
    4105,  4728,  3427,  3491, -3012,     0,  1465,     0,   974,     0,
    1549, -3012, -2776,     0,   965,  1001,  2578,  2579,  2580,  2581,
    2582,  2583,     0,     0,     0,  6459,     0,   974,  2644,     0,
       0,     0, -2776,   974,     0, -2776, -2776, -2776,     0,     0,
       0,     0,     0,     0,     0,   974,  1550,     0,   652,     0,
       0,  5913,   652,     0,     0,  3505,     0,     0,     0,   965,
       0,   974,  5621,     0,     0,     0,   655,     0,  6319,     0,
       0,   917,     0,  5098,     0,   655,   974,     0,   866,     0,
       0,     0,   655,   866,   974,   655,     0,  3487,     0,     0,
       0,  3487,  2848,     0,     0,     0,     0,   917,   974,     0,
       0,     0,   866,     0,     0,     0,  5147,     0,   974,  5765,
    1551,  3484,     0,     0,     0,     0,     0,     0, -3012,     0,
     954,   866,  4927,     0, -3012,     0,     0,     0,     0,     0,
    2578,  2579,  2580,  2581,  2582,  2583,     0,     0,     0,    71,
     187,  6436,    80,   175,    83,    84,    85,  1552,     0,    86,
       0,   106,     0,   184,   124,  6474,  1386,   652,   129,   191,
       0,   974,  6380,     0,     0,   159,     0,     0,     0,   178,
    5778,   185,     0,  1386,     0,  5750,     0,  1386,     0,  1386,
       0,     0,   929,   655,   655,     0,     0,     0,     0,   974,
       0,  1145,  3967,  1386,     0,     0,  3487,  1553,   180,   181,
       0,   653,  6436,     0,  1386,     0,  5776,   183,  5848,     0,
       0,  6416,     0,     0,   974,  1386,   655,  6381,  6382,     0,
     186,     0,  1386,     0,     0,     0,     0,  6436,     0,     0,
       0, -3012,     0,     0,     0,     0,     0,     0,     0,     0,
     917,  1555,     0,  2578,  2579,  2580,  2581,  2582,  2583,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   655,     0,  2005,     0,     0,     0,     0,
       0,     0,     0,  1579,  1386,  1557,   974,     0,     0,  1580,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1386,     0,  3484,     0,  1688,     0,  1386,  1386,     0,     0,
       0,   954,   954,   954,   954,     0,     0,     0,   999,  3476,
       0,     0,     0,  3484,     0,     0,     0,     0,     0,     0,
      35,     0,     0,     0,  1582,  1559,     0,     0,     0,     0,
       0,     0,  1386,     0,  1560,     0,     0,     0,     0,     0,
       0,   653,     0,  1561,     0,     0,     0,  3484,     0,     0,
       0,  2825,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1563,     0,   866,     0,     0,  3488,
       0,     0,     0,  1564,     0,     0,     0,     0,  1565,  1689,
       0,  1583,     0,     0,   655,   655,  1822,     0,  1584,   652,
     652,     0,  1585,   974,   866,     0,     0,     0,   655,  3969,
       0,     0,     0,   917,   655,     0,     0,     0,   655,     0,
     655,     0,     0,     0,   917,     0,     0,     0,     0,     0,
       0,  1586,  1386,     0,     0,     0,     0,     0,  3487,  3487,
     917,     0,     0,     0,  1386,     0,  1566,     0,     0,     0,
    3970,     0,     0,  1386,  1386,  1386,     0,     0,     0,  2005,
       0,     0,     0,     0,     0,  3806,     0,  1587,  1386,  5970,
       0,     0,     0,     0,     0,     0,     0,  1386,     0,  1386,
       0,  1386,  5618,     0,   655,   187,   655,   655,     0,     0,
       0,     0,     0,  4927,     0,     0,     0,     0,     0,     0,
    1386,     0,     0,  3484,     0,     0,     0,     0,     0,  2005,
       0,  1001,     0,     0,     0,   866,   187,     0,     0,     0,
    1386,  6226,     0,     0,     0,     0,     0,   974,     0,     0,
     187,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1690,     0,     0,
       0,  1589,     0,     0,     0,   655,  2005,  2005,     0,     0,
       0,     0,  1590,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1591,     0,     0,     0,     0,     0,  6061,     0,
       0,     0,  3484,     0,  1592,     0,   954,     0,   974,     0,
    6278,  6279,     0,     0,     0,     0,     0,   917,     0,   974,
    6138,  1579,     0,     0,     0,     0,     0,  1580,     0,     0,
       0,     0,     0,     0,     0,     0,   974,     0,     0,     0,
    2103,   974,  1581,     0,     0,     0,  1691,     0,     0,  1594,
    1595,     0,     0,   655,     0,     0,     0,     0,     0,     0,
       0,   652,     0,     0,     0,     0,     0,     0,   652,     0,
       0,  1386,  1582,   652,     0,     0,   652,  5309,     0,     0,
       0,  1692,     0,     0,     0,     0,  1386,     0,     0,     0,
    5848,     0,     0,     0,     0,   655,  1386,     0,     0,     0,
    3487,     0,     0,     0,  6204,     0,     0,  3487,  3537,     0,
       0,     0,  3487,  3324,  3324,  3487,     0,     0,  3324,     0,
       0,     0,     0,     0,   655,   655,   655,   965,   655,  1583,
       0,     0,     0,     0,     0,     0,  1584,     0,     0,   954,
    1585,     0,     0,     0,     0,     0,  2005,     0,     0,   655,
       0,     0,     0,     0,  1597,     0,     0,     0,     0,  3324,
    3324,     0,     0,     0,     0,     0,     0,     0,     0,  1586,
    3484,  2848,     0,     0,   974,     0,     0,     0,  1386,     0,
       0,     0,   974,   974,     0,     0,     0,  3476,  4927,   187,
       0,     0,     0,     0,     0,     0,   965,   965,  6281,     0,
       0,     0,  1386,     0,     0,  1587,   655,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   191,     0,     0,  2005,  2005,  6297,     0,     0,
       0,     0,     0,  1386,  1386,  1822,     0,  1386,     0,     0,
    6305,     0,     0,     0,     0,     0,  2111,     0,     0,  2112,
       0,     0,   655,  2113,  2114,  2115,   655,   655,  6252,     0,
       0,  6273,  6274,     0,     0,  2005,     0,     0,     0,     0,
    6275,   954,   655,  6352,     0,     0,     0,     0,   917,     0,
       0,  2637,     0,  6276,  3484,  1588,     0,     0,  2638,  1589,
       0,     0,  1549,     0,     0,     0,     0,     0,   187,     0,
    1590,     0,     0,  6138,   954,   954,     0,     0,     0,  4927,
    1591,     0,     0,     0,  2639,     0,     0,     0,     0,     0,
       0,     0,  1592,  5458,     0,     0,     0,   653,  1550,  6484,
    6485,     0,     0,     0,  1386,     0,     0,     0,     0,     0,
     191,     0,  6370,     0,     0,   917,     0,     0,     0,     0,
    1386,     0,     0,     0,   652,     0,  3537,     0,     0,   795,
       0,  4295,     0,     0,  1593,   795,     0,  1594,  1595,     0,
       0,  1386,     0,     0,     0,     0,     0,     0,     0,  6273,
    6274,     0,     0,     0,     0,     0,   917,     0,  6275,     0,
       0,  3484,  1551,  3487,     0,  2111,     0,     0,  2112,  1596,
       0,  6276,  2113,  2114,  2115,     0,     0,  6401,  6402,   653,
    6406,     0,     0,     0,     0,  5848,     0,     0,     0,   917,
    1386,     0,     0,     0,     0,     0,     0,     0,     0,  1552,
    2637,   954,     0,  2640,  4927,     0,     0,  2638,  2641,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6370,     0,     0,     0,     0,     0,
       0,  2642,  2306,  2639,     0,   191,     0,     0,     0,     0,
       0,     0,  1597,     0,     0,     0,     0,     0,     0,  1553,
       0,  1386,   653,     0,     0,     0,   974,     0,     0,  2643,
       0,     0,     0,     0,     0,     0,     0,     0,   653,     0,
   -2793,   655,   655,   655,  6273,  6274,     0,     0,     0,     0,
       0,     0,     0,  6275,     0,   965,   965,     0,     0,  6487,
       0,  6370,     0,  1555,     0,     0,  6276,     0,     0,     0,
       0,     0,  2373,     0,     0,   652,     0,     0,  6370,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2644,     0,
       0,     0,     0,     0,     0,     0,   652,  1557,   187,  3484,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   972,     0,     0,  3487,     0,     0,     0,     0,     0,
    1008,     0,  2640,   187,     0,     0,     0,  2641,     0,     0,
     652,     0,     0,     0,  1030,  3487,     0,     0,     0, -2793,
       0,   974,    35,     0,  2824,     0,     0,  1559,     0,     0,
   -3012, -3012,     0,   917,     0,     0,  1560,     0,     0,     0,
       0,     0,   721,     0,   917,  1561,     0,     0,   964,  3487,
       0,   809,     0,  2825,     0,     0,  1822,     0,  2643,     0,
     917,     0,     0,     0,  2646,     0,  1563,     0,     0,     0,
       0,     0,     0, -2793,     0,  1564,     0,     0,     0,   974,
    1565,     0,     0,     0,     0,     0, -2793,   974,     0,     0,
       0,     0, -2793,   964,  3484,   974,     0,     0, -2793,     0,
    3484, -3012,     0,     0, -2793,     0,     0, -2793,     0,     0,
       0, -2793,     0,     0,   917,     0,     0,  2644,     0,     0,
       0,  6351,     0,   655,     0,     0,   655,     0,     0,   917,
       0,     0,   917,   917,     0,     0,   655,   655,  1566,   974,
     974, -2793,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   655,     0,   974,   655,     0,   652,     0,     0,     0,
       0,     0,     0,   917,   917,     0,   974,   974,     0,     0,
       0,  2574,     0,     0, -2793,     0,     0,     0,     0,     0,
    2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,     0,
       0,     0,     0,     0,     0,  3487,     0,     0,     0,     0,
       0,     0,     0,     0,   655,     0,     0,     0,   655,   655,
       0,     0,     0,  2646,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3484, -2793,     0,     0,     0,
   -2793,     0,     0,     0,     0,   652, -2793,     0,     0,     0,
       0,     0,     0,   655,     0,   655,   187,     0,     0,     0,
     655,   655,     0,     0,     0,     0,     0,   655,   655,   655,
     655,   655,   655,   655,   655,   655,   655,   655,   655,   655,
       0,     0,     0,   655,  3487,   655,     0,   655,   655,   655,
     655,   655,   655,     0,     0,   655,     0,   655,   655,     0,
       0,   655,     0,     0,     0,     0, -2793,     0,     0,     0,
       0,     0,     0,     0,     0,   917,   655,   655,   655,     0,
       0,     0,  1579,     0,     0,     0,  3297,     0,  1580,     0,
    2574,     0,     0,     0,   655,     0,  1822,     0,     0,  2575,
    2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,  3324,  3324,
    3324,  3324,     0,     0,  3324,  3324,  3324,  3324,  3324,  3324,
    3324,  3324,  3324,  3324,  1646,   810,     0,     0,     0,     0,
       0,     0,     0,  1582,     0,     0,     0,     0,     0,     0,
       0,     0,  4775,     0,     0,  5953,  1647,     0,     0,     0,
       0,     0,     0,     0,     0, -2793,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4937,   652,     0,     0,     0,     0,  3324,  3324,
   -2793,     0, -2793, -2793,     0,     0,     0,     0,     0,     0,
    1583,     0,     0,     0,     0,     0,     0,  1584,  1648,  4947,
       0,  1585,     0,     0, -2793,     0,  2781,     0,     0,     0,
       0,     0,  3487,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0, -2793,  4835,     0, -2793, -2793, -2793,
    1586,     0,     0,     0,     0,     0,     0,     0,  1100,     0,
       0,     0,   655,     0,  1100,     0,  4948,     0,     0,     0,
       0,  2111,     0,     0,  2112,     0,  1100,     0,  2113,  2114,
    2115,     0,     0,     0,     0,     0,  1587,     0,  4949,     0,
       0,     0,     0,     0,     0,     0,  2636,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2637,   652,     0,     0,
       0,  1649,     0,  2638,     0,     0,   655,     0,     0,     0,
       0,  1579,     0,     0,     0,     0,   795,  1580,   795,     0,
     795,     0,     0,     0,     0,     0,   795,  1223,  1224,  2639,
       0,     0,  1688,     0,     0,     0,  3487,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1690,     0,     0,  1650,
    1589,     0,  1582,   655,  1651,     0,     0,     0,     0,  1652,
       0,  1590,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1591,     0,     0,     0,  2952,     0,     0,     0,  4950,
       0,     0,     0,  1592,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   652,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1689,     0,  1583,
       0,  1654,     0,     0,     0,     0,  1584,     0,     0,     0,
    1585,     0,     0,     0,     0,  2805,     0,     0,  1594,  1595,
       0,     0,     0,  3487,     0,   914,     0,     0,  2640,     0,
       0,     0,     0,  2641,     0,     0,     0,     0,     0,  1586,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1656,
    2806,     0,     0,  1076,     0,     0,  2642,  2306,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1657,     0,  1587,     0,     0,     0,     0,
       0,     0,     0,     0,  2643,     0,     0,     0,     0,     0,
       0,   964,     0,     0,  1659,     0,  4951,   795,     0,  4368,
       0,     0,     0,  1144,   721,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3324,
       0,     0,     0,  1597,     0,     0,     0,  2373,   655,   655,
     655,   655,   655,   655,   655,   655,   655,     0,   655,     0,
       0,     0,     0,  2644,     0,  1660,  2645,     0,     0,   655,
       0,   655,   652,     0,     0,  1690,     0,     0,     0,  1589,
     964,   964,     0,     0,     0,     0,     0,   795,     0,     0,
    1590,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1591,     0,     0,     0,     0,     0,     0,     0,     0,   655,
       0,  3487,  1592,   655,     0,     0,   655,     0,   655,  1243,
       0,   655,     0,     0,     0,   655,     0,     0,     0,     0,
       0,     0,  2874,     0,     0,     0,     0,     0,     0,  1265,
       0,     0,     0,     0,     0,     0,  1822,  1389,   655,     0,
    1398,  1144,  1400,     0,  3777,     0,     0,  1594,  1595,  2646,
       0,     0,     0,     0,     0,   655,     0,     0,     0,     0,
       0,     0,     0,     0,   655,   655,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   652,     0,  3778,
       0,     0,     0,   652,     0,     0,     0,     0,     0,     0,
       0,   974,     0,     0,     0,     0,     0,     0,   917,     0,
       0,  6356,   917,   917,     0,     0,     0,     0,     0,   974,
       0,     0,     0,   974,     0,     0,  3487,   974,     0,     0,
       0,     0,  3487,     0,     0,     0,   974,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1579,     0,     0,     0,
       0,   974,  1580,     0,   655,     0,     0,     0,     0,     0,
       0,     0,  1597,     0,     0,   655,  2574,   917,   655,  5258,
     655,   655,     0,   917,     0,  2575,  2576,  2577,  2578,  2579,
    2580,  2581,  2582,  2583,     0,   974,     0,     0,  4113,     0,
       0,  4114,     0,  6404,     0,     0,     0,  1582,     0,     0,
       0,     0,     0,     0,     0,   974,   974,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   652,     0,
       0,   917,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1822,   974,     0,     0,  1822,     0,     0,
       0,     0,     0,     0,  1583,  1144,     0,  3487,     0,     0,
       0,  1584,     0,     0,     0,  1585,  6404,     0,     0,     0,
       0,   974,     0,  1822,     0,     0,     0,   974,     0,     0,
       0,     0,  6470,     0,     0,     0,     0,     0,     0,     0,
       0,   974,     0,     0,  1586,     0,     0,     0,   974,   964,
     964,   974,     0,     0,  1579,     0,     0,   974,     0,     0,
    1580,     0,     0,     0,  2111,     0,     0,  2112,     0,     0,
       0,  2113,  2114,  2115,     0,     0,     0,   974,     0,     0,
    1587,     0,     0,   974,     0,     0,     0,     0,     0,  2636,
     974,   795,     0,     0,     0,     0,   795,   795,     0,  2637,
       0,     0,     0,     0,   974,  1582,  2638,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   974,     0,
       0,     0,     0,  1822,  2654,     0,     0,     0,     0,   974,
       0,     0,  2639,  2661,     0,  2662,     0,     0,     0,  2665,
       0,     0,     0,     0,     0,     0,  2671,   655,   655,   655,
       0,     0,     0,   655,     0,     0,     0,     0,     0,     0,
    1588,     0,  1583,     0,  1589,     0,     0,     0,     0,  1584,
       0,     0,     0,  1585,     0,  1590,     0,     0,     0,     0,
     655,   917,     0,     0,     0,  1591,     0,     0,     0,  1822,
       0,     0,     0,     0,     0,     0,  2030,  1592,     0,     0,
       0,     0,  1586,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   655,  1144,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   795,  1587,  2890,
       0,     0,  1594,  1595,     0,     0,     0,   795,     0,     0,
       0,  2640,     0,     0,   917,     0,  2641,     0,   917,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   914,     0,  2891,     0,     0,     0,     0,  2642,
    2306,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1223,  1224,     0,     0,     0,     0,     0,   914,     0,
       0,     0,     0,     0,     0,     0,     0,  2643,     0,     0,
       0,     0,  2107,     0,     0,     0,     0,     0,  1690,     0,
       0,  2109,  1589,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1590,   795,     0,     0,  2599,   795,   795,
       0,     0,     0,  1591,   974,     0,  1822,  1597,     0,     0,
    2373,     0,     0,     0,     0,  1592,  1144,     0,     0,  2616,
    2617,   917,     0,   974,  1144,  1144,  2644,     0,     0,  2645,
     974,     0,     0,     0,   655,     0,   917,   655,     0,   655,
     655,   917,     0,     0,     0,     0,     0,  3324,     0,   655,
       0,     0,     0,     0,   655,     0,     0,  3632,     0,     0,
    1594,  1595,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   917,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3005,     0,     0,
       0,     0,  1596,     0,     0,     0,     0,     0,     0,     0,
    3324,   914,     0,   655,   655,   655,     0,     0,   655,     0,
       0,     0,     0,     0,     0,     0,   655,   655,   655,   655,
       0,     0,  2646,     0,     0,     0,     0,  1822,     0,     0,
       0,     0,   655,  1822,     0,   655,     0,   655,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   655,
     655,  1579,     0,   655,     0,     0,     0,  1580,     0,     0,
       0,     0,     0,     0,     0,  1597,     0,     0,     0,     0,
       0,  1579,     0,     0,   655,     0,   655,  1580,   655,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   795,     0,     0,     0,     0,   655,     0,     0,
       0,  1579,  1582,     0,     0,     0,     0,  1580,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   974,     0,
       0,     0,  1582,     0,     0,     0,     0,     0,     0,  2574,
       0,     0,     0,     0,     0,     0,     0,     0,  2575,  2576,
    2577,  2578,  2579,  2580,  2581,  2582,  2583,     0,     0,     0,
       0,     0,  1582,     0,  4115,   655,     0,     0,   655,  1583,
    3084,     0,     0,     0,   914,     0,  1584,     0,  3101,     0,
    1585,   916,   655,     0,     0,   914,  3005,   655,     0,  1583,
       0,  2957,     0,     0,     0,     0,  1584,     0,     0,  2965,
    1585,   914,   655,     0,     0,     0,     0,     0,     0,  1586,
       0,     0,     0,     0,     0,     0,   655,     0,     0,  1583,
       0,     0,     0,     0,   655,     0,  1584,     0,     0,  1586,
    1585,  3159,     0,     0,     0,     0,   917,     0,     0,   917,
    -136,   917,     0,     0,     0,  1587,   917,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3005,  1586,
       1,   974,   974,     0,     0,  1587,     0,   655,     0,     0,
       0,     2,  3324,     3,     4,     0,     0,     0,     0,     0,
       0,     0,   974,     0,     0,   974,     0,     0,   917,     0,
       0,     5,     0,     0,     0,  1587,   917,     0,     0,     0,
       0,     6,     0,  3324,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     7,     0,     8,     9,  3272,  3273,     0,
       0,   917,    10,     0,    11,  1690,     0,   655,     0,  1589,
       0,     0,     0,     0,  3309,  3310,     0,    12,     0,    13,
    1590,     0,     0,     0,     0,  1690,     0,     0,     0,  1589,
    1591,     0,     0,     0,     0,     0,    14,     0,   914,    15,
    1590,     0,  1592,     0,     0,  3355,     0,  1822,  1822,  1822,
    1591,     0,     0,     0,    16,  1690,    17,     0,     0,  1589,
      18,     0,  1592,     0,     0,     0,     0,    19,     0,     0,
    1590,     0,   974,     0,     0,     0,     0,    20,     0,    21,
    1591,   917,     0,   917,  3824,     0,    22,  1594,  1595,     0,
       0,   974,  1592,     0,  3095,     0,     0,     0,  3100,     0,
       0,     0,     0,     0,    23,     0,     0,  1594,  1595,     0,
       0,     0,     0,   974,     0,     0,     0,     0,     0,  3825,
       0,    24,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4341,     0,     0,  1594,  1595,  1596,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2111,     0,     0,  2112,     0,     0,     0,  2113,
    2114,  2115,     0,     0,     0,     0,     0,     0,     0,  4342,
       0,     0,     0,     0,     0,    25,    26,  2636,     0,   917,
       0,    27,     0,     0,     0,     0,     0,  2637,     0,     0,
       0,     0,  1597,     0,  2638,     0,    28,     0,  2615,     0,
       0,     0,     0,   974,     0,     0,     0,     0,   655,     0,
       0,     0,  1597,     0,   655,    29,     0,     0,     0,     0,
    2639,     0,     0,   917,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3324,     0,     0,
       0,     0,  1597,     0,     0,     0,     0,     0,     0,     0,
    1822,   917,     0,     0,     0,     0,   974,     0,   974,     0,
       0,     0,     0,     0,    30,     0,     0,     0,  3283,     0,
       0,   974,     0,   974,     0,     0,     0,     0,     0,    31,
       0,     0,     0,     0,    32,    33,     0,    34,     0,     0,
       0,     0,    35,   655,     0,     0,     0,     0,    36,   914,
       0,    37,     0,     0,     0,     0,     0,     0,    38,     0,
       0,     0,     0,     0,     0,    39,    40,     0,     0,   917,
       0,     0,     0,    41,     0,     0,     0,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    43,  2640,
     974,   917,     0,     0,  2641,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    44,     0,     0,     0,     0,
       0,     0,     0,   917,     0,     0,   914,  2642,  2306,     0,
       0,     0,     0,     0,     0,     0,    45,     0,     0,     0,
       0,     0,   974,     0,     0,     0,     0,     0,    46,     0,
       0,     0,     0,     0,    47,  2643,     0,     0,     0,    48,
       0,   974,     0,     0,     0,   974,     0,   914,     0,     0,
       0,     0,     0,    49,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   905,   974,     0,     0,     0,
       0,     0,     0,     0,     0,  6186,     0,    50,  2373,     0,
     914,     0,   655,     0,     0,   917,     0,     0,     0,     0,
       0,   655,     0,     0,  2644,     0,    56,  2645,     0,  -136,
       0,     0,     0,     0,     0,   655,     0,     0,     0,   655,
     655,   655,     0,     0,     0,     0,   655,     0,     0,   655,
       0,     0,   655,     0,     0,     0,     0,     0,   655,     0,
     655,     0,     0,   655,     0,     0,     0,   917,   655,   655,
     655,   655,     0,     0,   655,   655,   655,   655,   655,   655,
     655,   655,   655,   655,     0,     0,     0,   655,   655,   655,
       0,     0,   917,     0,     0,     0,     0,   655,     0,     0,
       0,     0,   655,     0,  1822,     0,   655,     0,   916,     0,
       0,     0,     0,     0,   655,     0,     0,   655,     0,   655,
    2646,     0,     0,     0,  2111,     0,     0,  2112,     0,     0,
       0,  2113,  2114,  2115,   916,   655,     0,     0,   655,   655,
       0,     0,     0,   655,   655,     0,     0,     0,   655,  2636,
     655,     0,  3324,  3324,     0,     0,  3324,     0,     0,  2637,
       0,     0,     0,     0,     0,     0,  2638,     0,     0,     0,
    3456,  3458,     0,     0,     0,     0,  3466,     0,     0,   655,
       0,     0,     0,     0,     0,   655,     0,     0,     0,     0,
       0,     0,  2639,   655,     0,     0,     0,   655,     0,     0,
       0,     0,     0,     0,   914,     0,     0,     0,  3512,  3512,
       0,     0,     0,     0,     0,   914,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2574,     0,     0,
     655,   914,     0,     0,     0,     0,  2575,  2576,  2577,  2578,
    2579,  2580,  2581,  2582,  2583,     0,     0,   655,     0,     0,
       0,     0,  4166,   917,     0,     0,     0,     0,     0,     0,
       0,     0,  3539,     0,     0,     0,     0,     0,     0,     0,
     795,     0,     0,     0,     0,     0,     0,   916,     0,   974,
    3555,     0,     0,     0,  3558,   914,     0,     0,  3561,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     914,     0,   655,   914,   914,     0,     0,     0,     0,     0,
       0,  2640,  3580,     0,     0,     0,  2641,  2111,     0,     0,
    2112,     0,     0,     0,  2113,  2114,  2115,     0,     0,     0,
       0,     0,     0,     0,   914,   914,     0,     0,     0,  2642,
    2306,     0,  2636,  1822,     0,     0,  3622,     0,  1822,   917,
    1822,     0,  2637,     0,     0,     0,     0,     0,  3649,  2638,
       0,     0,     0,     0,     0,     0,  1100,  2643,     0,     0,
       0,     0,     0,     0,     0,     0,  1822,   917,     0,     0,
       0,     0,     0,     0,     0,  2639,     0,     0,     0,  2111,
    3434,     0,  2112,     0,     0,     0,  2113,  2114,  2115,     0,
       0,     0,     0,     0,     0,  3682,     0,     0,     0,     0,
    2373,     0,     0,     0,  2636,     0,     0,     0,     0,     0,
       0,  1737,   974,     0,  2637,   974,  2644,     0,     0,  2645,
       0,  2638,  3711,     0,     0,     0,     0,     0,  3720,     0,
     916,     0,     0,     0,     0,     0,     0,   795,     0,     0,
       0,   916,  3730,     0,     0,   795,     0,  2639,   795,  1100,
       0,     0,  3743,     0,     0,     0,     0,   916,  3748,     0,
     795,     0,     0,     0,     0,     0,   914,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3761,   655,
       0,     0,     0,     0,  3764,     0,     0,     0,     0,     0,
       0,  3772,     0,     0,  2640,     0,     0,     0,     0,  2641,
       0,     0,     0,     0,     0,  3787,   974,   974,     0,     0,
     917,     0,  2646,     0,     0,     0,     0,   974,     0,  3813,
       0,     0,  2642,  2306,   655,   655,     0,     0,  1144,     0,
    1100,     0,     0,     0,   974,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2643,     0,     0,     0,     0,     0,     0,   917,     0,     0,
       0,     0,   917,   655,   655,     0,  2640,     0,     0,     0,
       0,  2641,     0,     0,   655,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1400,     0,     0,     0,     0,     0,
       0,     0,     0,  2373,  2642,  2306,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2644,
       0,     0,  2645,     0,   916,   974,     0,     0,  1822,  2574,
       0,     0,  2643,     0,     0,     0,     0,     0,  2575,  2576,
    2577,  2578,  2579,  2580,  2581,  2582,  2583,     0,     0,     0,
       0,  3353,     0,     0,   655,     0,  1579,     0,     0,     0,
       0,     0,  1580,     0,     0,     0,     0,     0,     0,     0,
     655,     0,   905,     0,     0,  2373,     0,     0,     0,     0,
       0,  1400,     0,     0,     0,     0,     0,     0,   655,     0,
       0,  2644,     0,     0,  2645,     0,     0,     0,   905,     0,
       0,     0,     0,     0,     0,  1400,     0,  1582,     0,     0,
       0,     0,     0,     0,     0,  2646,   655,   795,     0,   655,
       0,     0,     0,     0,     0,     0,     0,   655,   655,     0,
     917,     0,     0,     0,   655,   655,     0,     0,     0,   655,
       0,     0,     0,     0,   655,     0,     0,   655,   655,     0,
       0,     0,     0,     0,   655,  4031,     0,     0,     0,     0,
       0,     0,     0,     0,  1583,     0,     0,     0,     0,  3812,
       0,  1584,     0,  3816,  4047,  1585,   655,     0,     0,     0,
       0,  4031,     0,   655,     0,     0,     0,  2646,   655,     0,
       0,   655,   655,     0,     0,     0,     0,     0,     0,   655,
       0,     0,     0,     0,  1586,     0,     0,     0,     0,     0,
    3849,     0,  3849,     0,  3849,  3849,     0,     0,   655,  3849,
    3849,  3849,  2574,  3849,  3849,  3849,     0,     0,     0,     0,
       0,  2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,
    1587,   905,     0,     0,  4107,     0,     0,   917,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     974,     0,     0,     0,     0,   655,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3926,     0,     0,
       0,     0,     0,     0,     0,  2745,     0,     0,     0,     0,
       0,     0,     0,     0,  2574,     0,     0,     0,     0,     0,
       0,   917,  3954,  2575,  2576,  2577,  2578,  2579,  2580,  2581,
    2582,  2583,     0,     0,     0,     0,  4528,     0,   974,  2111,
    1690,     0,  2112,   917,  1589,     0,  2113,  2114,  2115,     0,
     974,     0,     0,     0,     0,  1590,     0,     0,     0,     0,
    4223,     0,   795,     0,  2636,  1591,   655,     0,     0,     0,
       0,     0,  2745,   655,  2637,     0,     0,  1592,  4230,     0,
       0,  2638,     0,     0,   974,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2639,     0,     0,
       0,     0,     0,   916,     0,   917,     0,     0,     0,  4414,
       0,     0,  1594,  1595,   905,     0,     0,     0,  4279,  4279,
       0,     0,     0,     0,     0,   905,     0,     0,     0,     0,
       0,   655,     0,     0,     0,     0,   916,     0,     0,     0,
       0,   905,     0,     0,  4415,     0,     0,     0,   655,  1549,
       0,     0,     0,  1822,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   974,     0,     0,     0,     0,     0,     0,   655,
       0,     0,     0,     0,     0,  1550,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   914,
       0,     0,     0,   914,   914,     0,  2640,  1597,  1737,  1737,
    1737,  2641,     0,     0,     0,   917,     0,   917,     0,     0,
       0,     0,     0,  4325,     0,     0,   722,     0,     0,     0,
       0,   723,     0,     0,  2642,  2306,     0,     0,     0,  1551,
       0,     0,     0,     0,     0,     0,     0,     0,   974,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   914,     0,
       0,     0,  2643,     0,   914,     0,     0,     0,     0,   724,
       0,     0,     0,     0,   655,     0,  1552,     0,     0,     0,
       0,     0,   725,     0,   655,     0,     0,   655,   905,     0,
     655,   655,   655,     0,     0,     0,     0,     0,     0,   726,
       0,     0,     0,     0,     0,  2373,     0,     0,     0,     0,
    1144,     0,   914,     0,     0,   655,   655,   727,     0,   655,
     916,  2644,     0,     0,  2645,     0,  1553,     0,     0,     0,
       0,   916,     0,  4412,     0,     0,   655,     0,     0,     0,
     655,   728,     0,     0,     0,     0,   655,   916,     0,     0,
     655,     0,     0,     0,     0,   729,   917,   655,     0,     0,
       0,     0,     0,     0,   730,   655,  1554,     0,     0,     0,
    1555,   655,     0,     0,   655,     0,     0,   731,     0,     0,
     974,     0,   974,   732,     0,     0,     0,     0,     0,     0,
     733,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   916,     0,  1620,  1557,   655,     0,     0,     0,     0,
     734,     0,     0,     0,     0,     0,   916,  2646,     0,   916,
     916,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   917,   974,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   655,     0,  1621,     0,     0,     0,    35,
     916,   916,     0,     0,  1559,     0,     0,     0,     0,     0,
       0,     0,     0,  1560,  4507,     0,     0,  1144,     0,     0,
     735,     0,  1561,     0,     0,     0,     0,     0,     0,     0,
    1622,     0,     0,  1822,     0,   795,     0,     0,   655,     0,
       0,     0,     0,  1563,     0,     0,     0,     0,     0,     0,
       0,     0,  1564,     0,     0,     0,     0,  1565,  4576,     0,
       0,     0,     0,     0,     0,   736,     0,     0,     0,     0,
       0,     0,   914,     0,  2574,     0,     0,     0,   737,     0,
       0,     0,     0,  2575,  2576,  2577,  2578,  2579,  2580,  2581,
    2582,  2583,   738,     0,     0,     0,  4715,     0,     0,   905,
    1737,   655,   213,   739,   917,  4402,   740,     0,     0,     0,
       0,     0,     0,     0,  1737,  1566,     0,  1737,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   741,     0,   655,   742,     0,     0,     0,
     743,     0,   916,   744,     0,   914,     0,     0,     0,   914,
     745,     0,   655,   746,     0,     0,   655,     0,   655,     0,
       0,     0,     0,  4451,     0,     0,   905,     0,     0,     0,
       0,     0,   655,   747,     0,     0,     0,     0,     0,     0,
     655,   748,     0,   655,     0,     0,     0,     0,   749,     0,
       0,   750,     0,  3005,   655,     0,   751,     0,     0,     0,
       0,   655,     0,     0,   752,     0,   753,   905,     0,     0,
       0,   754,  4680,     0,     0,   795,  4684,     0,     0,     0,
       0,     0,     0,     0,     0,   755,     0,     0,     0,     0,
       0,     0,     0,  4494,     0,     0,     0,     0,   756,     0,
     905,     0,     0,     0,  1549,     0,     0,     0,     0,     0,
       0,     0,   914,   655,     0,     0,     0,     0,     0,   917,
       0,     0,     0,     0,   917,   917,     0,   914,     0,   655,
       0,     0,   914,     0,     0,   655,   655,   974,     0,     0,
    1550,  3849,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   974,   661,  4525,  4525,     0,     0,     0,   710,   661,
       0,     0,   914,  4541,   762,     0,   661,     0,  1144,     0,
    1144,   655,   661,     0,   815,     0,     0,     0,     0,     0,
     655,     0,     0,  1822,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   877,   877,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1551,     0,     0,     0,   655,     0,
       0,     0,     0,     0,     0,     0,  4597,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   917,   917,     0,
       0,  1552,     0,     0,     0,     0,  2111,     0,     0,  2112,
       0,  4633,  1144,  2113,  2114,  2115,     0,     0,     0,     0,
       0,   655,  1822,     0,     0,     0,     0,     0,     0,     0,
       0,  2636,     0,   655,     0,     0,     0,     0,     0,     0,
       0,  2637,   655,   655,   655,     0,     0,     0,  2638,     0,
       0,  1553,     0,     0,   905,     0,     0,   655,  1822,     0,
       0,   917,     0,     0,     0,   905,   655,     0,   655,     0,
     655,     0,     0,     0,  2639,     0,     0,     0,     0,     0,
       0,   905,   655,     0,     0,     0,     0,     0,     0,   655,
       0,  1554,     0,     0,     0,  1555,     0,     0,     0,     0,
       0,     0,     0,     0,   956,     0,     0,     0,   960,   655,
       0,     0,     0,     0,     0,     0,  1003,     0,     0,  1005,
       0,     0,  1010,  1011,     0,  1014,     0,  1017,  1637,  1557,
    1023,     0,  1025,     0,  1822,   905,     0,   974,     0,     0,
    4909,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     905,     0,     0,   905,   905,     0,     0,     0,     0,     0,
       0,   907,     0,     0,     0,     0,     0,     0,     0,     0,
    1638,     0,     0,     0,    35,     0,     0,   914,     0,  1559,
     914,     0,   914,   795,   905,   905,     0,   914,  1560,   655,
       0,     0,     0,  2640,     0,     0,     0,  1561,  2641,     0,
       0,     0,     0,     0,     0,  1639,   908,     0,     0,     0,
       0,   795,     0,     0,     0,  4789,     0,     0,  1563,     0,
       0,  2642,  2306,     0,     0,   795,     0,  1564,     0,   914,
       0,     0,  1565,     0,     0,     0,   795,   914,     0,     0,
     655,     0,     0,     0,     0,     0,     0,     0,  1737,  2643,
       0,     0,     0,     0,     0,   655,     0,     0,     0,     0,
       0,     0,   914,     0,     0,   655,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   974,  5035,     0,     0,  5038,     0,     0,     0,
    1566,     0,  2373,     0,     0,     0,   655,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   974,     0,  2644,     0,
       0,  2645,  1223,  1224,  2111,     0,     0,  2112,     0,     0,
       0,  2113,  2114,  2115,     0,     0,   905,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2636,
       0,     0,   914,     0,   914,     0,     0,   655,     0,  2637,
       0,     0,     0,     0,     0,     0,  2638,   655,     0,     0,
       0,     0,     0,     0,     0,   655,   655,     0,     0,     0,
       0,   655,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2639,     0,     0,  3544,     0,     0,  5121,  2745,
    3550,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   795,   655,   655,  2646,  3005,   655,     0,     0,     0,
       0,     0,     0,     0,  2111,     0,     0,  2112,     0,     0,
       0,  2113,  2114,  2115,   902,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2636,
     914,     0,     0,     0,   916,     0,   974,     0,     0,  2637,
     916,  4541,     0,     0,   795,     0,  2638,   910,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   655,     0,     0,     0,     0,     0,   655,  4999,
       0,     0,  2639,     0,   914,     0,  4031,     0,     0,     0,
       0,     0,     0,     0,  5013,     0,   655,  5014,   916,  5015,
       0,  2640,     0,   655,     0,     0,  2641,     0,     0,     0,
       0,  2574,   914,     0,     0,     0,     0,     0,     0,   655,
    2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,  2642,
    2306,     0,     0,  4788,     0,     0,     0,     0,     0,     0,
     655,     0,     0,     0,     0,  5055,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2643,     0,     0,
       0,  3849,     0,     0,     0,     0,  3849,     0,     0,     0,
    1053,     0,     0,     0,     0,     0,     0,     0,   655,     0,
     914,  1090,     0,   917,     0,  1094,     0,     0,     0,   655,
       0,     0,  1107,  1108,     0,     0,  1114,     0,  1118,  1119,
    2373,  2640,   914,   655,     0,     0,  2641,     0,     0,     0,
    1822,     0,     0,  1141,     0,     0,  2644,     0,     0,  2645,
       0,     0,     0,     0,   914,     0,     0,     0,     0,  2642,
    2306,  1154,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     655,   655,  1182,     0,  1184,     0,     0,  2643,     0,     0,
       0,     0,     0,     0,  1200,     0,  5161,   655,     0,  4541,
       0,  1822,     0,     0,     0,     0,  1737,     0,     0,     0,
       0,     0,     0,     0,   655,   655,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1822,   661,     0,     0,
    2373,     0,     0,     0,     0,     0,   914,     0,   916,     0,
       0,     0,  2646,     0,     0,     0,  2644,   795,     0,  2645,
       0,     0,     0,   795,     0,     0,     0,     0,   795,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5210,  5210,  5210,  5210,     0,
    5210,  5210,  5210,  5210,  5210,  5400,  5401,     0,   914,     0,
    5404,  5405,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   877,  5397,
       0,  2745,     0,   914,     0,  2745,     0,     0,     0,     0,
       0,  5407,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2646,     0,     0,     0,     0,     0,     0,  2574,
       0,     0,     0,     0,     0,     0,     0,     0,  2575,  2576,
    2577,  2578,  2579,  2580,  2581,  2582,  2583,     0,   907,     0,
       0,  4895,     0,     0,     0,     0,     0,     0,     0,     0,
    2111,     0,     0,  2112,     0,     0,     0,  2113,  2114,  2115,
       0,     0,     0,  1540,   907,     0,     0,     0,  5289,     0,
    5291,  2111,     0,     0,  2112,  2636,     0,     0,  2113,  2114,
    2115,     0,     0,   908,     0,  2637,     0,     0,   916,     0,
       0,     0,  2638,     0,     0,     0,  2636,     0,     0,     0,
       0,     0,     0,   916,     0,     0,  2637,     0,   916,   908,
       0,     0,     0,  2638,     0,     0,     0,     0,  2639,  2574,
       0,     0,     0,     0,     0,     0,     0,     0,  2575,  2576,
    2577,  2578,  2579,  2580,  2581,  2582,  2583,  1721,   916,  2639,
       0,  4920,     0,     0,   914,     0,     0,     0,     0,   905,
       0,     0,     0,   905,   905,     0,     0,     0,     0,     0,
       0,     0,  1842,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1854,     0,  1855,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1858,
       0,     0,     0,     0,     0,     0,  1868,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   907,   905,  4031,
       0,     0,     0,     0,   905,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2640,     0,  1920,
     914,  1922,  2641,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   908,     0,     0,     0,     0,     0,  2640,     0,
       0,     0,   905,  2641,     0,  2642,  2306,     0,   914,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2642,  2306,     0,     0,
       0,     0,     0,  2643,     0,  5428,  5429,     0,     0,     0,
       0,  1157,     0,     0,     0,     0,     0,     0,  3849,     0,
    3849,  3849,  3849,     0,  2643,   661,     0,   661,     0,   661,
       0,   661,     0,   661,   661,   661,     0,  1157,     0,     0,
     661,     0,     0,     0,   910,     0,  2373,  2111,     0,     0,
    2112,  4031,  2026,  4031,  2113,  2114,  2115,     0,     0,     0,
       0,     0,  2644,     0,     0,  2645,     0,  2373,     0,     0,
     910,     0,  2636,     0,     0,     0,   795,     0,     0,     0,
     907,     0,  2637,  2644,     0,     0,  2645,  5482,     0,  2638,
       0,   907,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2111,  2745,     0,  2112,  3550,   907,  3550,  2113,
    2114,  2115,     0,  2745,     0,  2639,     0,     0,     0,     0,
       0,   914,     0,     0,     0,   908,  5510,  2636,     0,     0,
       0,     0,     0,     0,     0,     0,   908,  2637,     0,     0,
       0,     0,     0,     0,  2638,     0,     0,     0,     0,     0,
       0,     0,   908,     0,     0,   916,     0,     0,  2646,     0,
       0,     0,     0,   916,     0,     0,     0,     0,   914,  5210,
    2639,     0,     0,   914,     0,     0,     0,  2111,     0,  2646,
    2112,     0,   905,     0,  2113,  2114,  2115,     0,  2745,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2636,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2637,   910,     0,     0,     0,     0,     0,  2638,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2640,     0,     0,     0,     0,  2641,
     877,     0,     0,     0,     0,  2639,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   905,     0,     0,     0,   905,
       0,     0,  2642,  2306,   907,  2574,     0,     0,   916,     0,
     916,     0,     0,     0,  2575,  2576,  2577,  2578,  2579,  2580,
    2581,  2582,  2583,     0,     0,     0,  2574,  5127,     0,  2640,
    2643,     0,     0,     0,  2641,  2575,  2576,  2577,  2578,  2579,
    2580,  2581,  2582,  2583,     0,     0,     0,     0,  5240,   908,
       0,     0,     0,     0,     0,     0,     0,  2642,  2306,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   914,     0,  2373,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1843,  4541,  2643,     0,     0,     0,  2644,
       0,     0,  2645,     0,  1852,     0,     0,     0,     0,     0,
    2803,     0,   905,     0,  2640,     0,   916,     0,     0,  2641,
    1860,     0,     0,     0,     0,     0,   910,   905,     0,     0,
       0,     0,   905,     0,     0,   795,     0,   910,  2373,     0,
    3849,     0,  2642,  2306,     0,  1737,     0,     0,     0,  5711,
       0,  1737,     0,   910,  2644,     0,     0,  2645,     0,     0,
     916,     0,   905,     0,     0,     0,     0,     0,     0,     0,
    2643,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2902,     0,     0,     0,     0,     0,  3550,     0,
       0,     0,     0,     0,     0,  2646,     0,     0,   914,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2373,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2644,
       0,     0,  2645,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   911,     0,     0,     0,
    2646,     0,   914,     0,     0,     0,   916,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   914,   907,     0,  2031,  3550,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     916,     0,  2574,     0,     0,     0,     0,     0,     0,     0,
     910,  2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,
     908,     0,     0,     0,  5277,  2646,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   907,     0,     0,     0,   914,     0,     0,     0,
    6094,     0,     0,     0,     0,     0,     0,  2574,     0,     0,
       0,     0,     0,     0,     0,     0,  2575,  2576,  2577,  2578,
    2579,  2580,  2581,  2582,  2583,     0,     0,     0,     0,  5281,
       0,     0,   916,   907,     0,     0,     0,   908,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3033,     0,     0,  1144,     0,     0,     0,  5929,     0,     0,
       0,     0,     0,     0,     0,     0,   907,   905,     0,     0,
     905,     0,   905,     0,     0,     0,     0,   905,   908,     0,
       0,     0,  2574,     0,   916,  3069,     0,     0,     0,     0,
       0,  2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,
       0,     0,     0,     0,  5557,     0,     0,     0,     0,   916,
       0,   908,     0,     0,     0,     0,     0,     0,   914,   905,
       0,     0,     0,     0,     0,     0,     0,   905,     0,     0,
       0,  3134,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3152,   905,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2111,     0,     0,  2112,     0,     0,     0,
    2113,  2114,  2115,     0,     0,     0,     0,  3172,     0,  3173,
       0,     0,     0,  4031,     0,     0,     0,     0,  2636,     0,
       0,     0,     0,     0,  3182,     0,  3183,     0,  2637,     0,
       0,     0,   661,     0,   661,  2638,   661,     0,   661,     0,
     661,     0,     0,     0,   661,     0,     0,     0,     0,     0,
       0,   910,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2639,   905,     0,   905,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3242,     0,     0,     0,     0,     0,   914,     0,     0,
     907,     0,     0,     0,     0,     0,  2111,     0,     0,  2112,
    2745,   907,     0,  2113,  2114,  2115,     0,     0,     0,  1144,
       0,     0,     0,  6100,     0,  6101,     0,   907,   910,  6107,
    6108,  2636,     0,     0,     0,     0,  2897,     0,     0,     0,
       0,  2637,     0,     0,     0,   908,     0,     0,  2638,     0,
       0,     0,     0,     0,     0,     0,   908,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   910,
     905,     0,   908,   914,  2639,     0,     0,     0,     0,     0,
       0,   907,     0,     0,     0,     0,     0,     0,     0,     0,
    2640,     0,     0,     0,     0,  2641,   907,     0,     0,   907,
     907,     0,   910,     0,     0,     0,  3550,     0,     0,   913,
       0,     0,     0,     0,   905,     0,     0,     0,  2642,  2306,
       0,     0,     0,     0,     0,     0,   908,     0,     0,     0,
     907,   907,     0,     0,  3550,     0,     0,     0,     0,     0,
       0,   908,   905,     0,   908,   908,  2643,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   908,   908,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2373,
       0,     0,     0,  2640,     0,   914,     0,     0,  2641,     0,
       0,     0,     0,     0,     0,  2644,     0,     0,  2645,     0,
     905,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2642,  2306,     0,  6434,     0,     0,     0,     0,     0,
       0,     0,   905,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2643,
       0,     0,     0,     0,   905,     0,     0,     0,     0,     0,
       0,     0,  2111,  3036,     0,  2112,     0,     0,     0,  2113,
    2114,  2115,   907,     0,  3047,     0,     0,   916,     0,     0,
       0,     0,     0,     0,     0,  6434,     0,  2636,     0,     0,
    3065,     0,  2373,     0,     0,     0,   910,  2637,     0,     0,
       0,  2646,     0,     0,  2638,     0,     0,   910,  2644,     0,
    6434,  2645,     0,   911,     0,     0,     0,   908,     0,     0,
       0,     0,     0,   910,  3550,     0,     0,     0,  1144,  2745,
    2639,     0,     0,     0,     0,     0,   905,     0,     0,   911,
       0,     0,     0,     0,  3139,     0,     0,     0,     0,     0,
     914,     0,     0,     0,     0,   914,   914,     0,     0,  3151,
       0,     0,  1157,  3155,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   910,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   905,     0,
       0,     0,   910,  3174,  1157,   910,   910,     0,     0,     0,
       0,     0,     0,     0,  2646,     0,     0,     0,  2574,     0,
       0,     0,     0,   905,     0,     0,     0,  2575,  2576,  2577,
    2578,  2579,  2580,  2581,  2582,  2583,   910,   910,     0,     0,
    5568,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2640,
       0,     0,     0,     0,  2641,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   914,
       0,     0,     0,     0,     0,     0,     0,  2642,  2306,     0,
       0,     0,   911,     0,     0,     0,     0,   916,     0,     0,
       0,     0,  6435,     0,     0,     0,     0,     0,     0,  2599,
       0,     0,     0,  6439,     0,  2643,     0,     0,     0,     0,
       0,  2574,     0,     0,     0,     0,     0,     0,     0,     0,
    2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,     0,
       0,     0,   914,  5578,     0,  3357,     0,     0,     0,  6465,
       0,     0,     0,     0,     0,     0,     0,     0,  2373,     0,
       0,     0,     0,  6435,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2644,     0,     0,  2645,   910,     0,
       0,     0,     0,     0,   905,     0,     0,     0,  6435,     0,
       0,  5289,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   916,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   911,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   911,     0,   916,     0,
    2646,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     905,     0,   911,     0,     0,     0,     0,     0,     0,     0,
     916,     0,     0,  3540,  3541,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   905,     0,
       0,     0,  3556,  3557,     0,  3559,  3560,     0,     0,     0,
    3563,  3564,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3575,     0,     0,     0,  3578,
       0,     0,     0,  3581,  3582,     0,     0,  3585,  3586,     0,
       0,     0,     0,     0,  3591,     0,     0,     0,     0,     0,
       0,     0,   916,     0,     0,     0,  3606,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2574,  3623,     0,
       0,     0,     0,  3625,     0,     0,  2575,  2576,  2577,  2578,
    2579,  2580,  2581,  2582,  2583,     0,   913,     0,  3631,  5642,
       0,     0,  3637,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3648,     0,     0,  3652,     0,  3654,
    3657,  3659,   913,     0,     0,     0,  3667,  3670,     0,     0,
       0,     0,     0,   722,     0,     0,  3683,     0,  1055,   911,
       0,     0,  3693,     0,     0,     0,  3696,     0,     0,     0,
       0,   905,     0,     0,     0,     0,     0,     0,  3706,  3707,
       0,     0,     0,  3712,     0,     0,     0,     0,     0,  3721,
    3722,     0,     0,     0,     0,     0,  1056,     0,     0,     0,
       0,     0,  5514,  3731,   916,     0,  3732,     0,     0,   725,
    1057,     0,     0,  3744,  3745,     0,     0,     0,   905,  3749,
       0,     0,  1058,   905,     0,   907,   726,     0,     0,   907,
     907,  3756,     0,     0,  3759,     0,     0,     0,     0,  3762,
       0,     0,     0,     0,  1059,  3765,  3766,     0,     0,     0,
       0,     0,     0,  3774,     0,     0,     0,  3776,     0,     0,
       0,  3783,  3784,  3785,  3786,     0,  3788,     0,  1060,     0,
     908,     0,     0,     0,   908,   908,     0,     0,     0,     0,
    3814,  3815,   729,  3817,   907,   913,     0,     0,     0,     0,
     907,   730,     0,     0,  3827,  3828,  3829,     0,     0,     0,
       0,     0,     0,     0,   731,     0,     0,     0,     0,     0,
    1061,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   908,
       0,     0,     0,     0,     0,   908,     0,  1062,   907,     0,
       0,     0,     0,   916,     0,     0,     0,     0,     0,     0,
       0,  3881,     0,     0,     0,     0,     0,     0,     0,  3905,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1063,     0,     0,  3917,     0,
       0,   905,     0,   908,   914,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   735,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3550,
     911,     0,     0,     0,     0,     0,     0,     0,  3985,     0,
       0,     0,     0,     0,     0,     0,  2111,     0,     0,  2112,
       0,     0,  1064,  2113,  2114,  2115,     0,  3999,   913,  4001,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   913,
       0,  2636,     0,     0,     0,     0,     0,     0,     0,   738,
       0,  2637,     0,     0,     0,   913,     0,     0,  2638,   213,
    1065,     0,     0,   740,     0,     0,     0,   911,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   905,     0,
       0,     0,     0,     0,  2639,     0,     0,   915,     0,     0,
    1066,     0,     0,  1067,     0,     0,     0,   743,     0,     0,
     744,   910,     0,     0,     0,   910,   910,   745,   911,     0,
     746,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3550,     0,     0,  4063,     0,     0,  3596,   907,     0,
     747,     0,   905,  3604,     0,     0,     0,     0,  1068,     0,
       0,   911,     0,     0,     0,   749,     0,     0,  1069,     0,
       0,     0,     0,   751,   905,     0,     0,     0,     0,     0,
     910,  1070,  2111,   753,     0,  2112,   910,     0,  1071,  2113,
    2114,  2115,     0,   908,     0,     0,     0,     0,     0,     0,
       0,  3647,     0,     0,     0,     0,     0,  2636,     0,     0,
       0,     0,     0,     0,     0,   756,     0,  2637,     0,     0,
       0,   907,     0,  2640,  2638,   907,     0,     0,  2641,     0,
       0,     0,   913,     0,   910,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   905,     0,     0,     0,
    2639,  2642,  2306,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   908,     0,     0,     0,
     908,     0,     0,     0,     0,     0,     0,     0,     0,  2643,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   916,     0,     0,     0,
       0,   916,   916,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2373,     0,     0,     0,     0,     0,   907,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2644,     0,
       0,  2645,     0,   907,     0,     0,     0,     0,   907,     0,
       0,     0,     0,     0,     0,   911,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   911,     0,   905,  2640,
       0,     0,     0,   908,  2641,     0,     0,     0,   907,     0,
       0,     0,   911,     0,     0,     0,     0,     0,   908,     0,
       0,     0,     0,   908,     0,     0,     0,  2642,  2306,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3874,     0,     0,  5514,   916,     0,     0,     0,     0,
       0,     0,     0,   908,     0,  2643,     0,     0,     0,     0,
       0,     0,     0,     0,  2646,     0,   911,     0,     0,     0,
       0,     0,     0,     0,   910,     0,     0,     0,     0,     0,
       0,   911,     0,     0,   911,   911,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2373,     0,
       0,     0,     0,     0,  4326,     0,     0,     0,   916,     0,
       0,     0,     0,     0,  2644,   911,   911,  2645,     0,     0,
       0,  4333,     0,   913,     0,  4333,     0,     0,     0,     0,
    4344,  4345,  4346,     0,     0,     0,     0,   905,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   910,     0,     0,
       0,   910,  4358,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2574,     0,     0,     0,     0,  4389,  4390,  4391,  4392,
    2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,     0,
     913,     0,     0,  5675,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2646,     0,     0,   905,  4413,     0,  4417,  4418,  4419,     0,
       0,  4046,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   913,     0,     0,     0,     0,  4056,     0,     0,     0,
       0,  4061,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   910,     0,     0,   911,     0,     0,
       0,     0,     0,   907,   913,     0,   907,     0,   907,   910,
       0,  4087,     0,   907,   910,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   910,     0,     0,     0,   908,     0,
       0,   908,     0,   908,     0,   907,     0,  2574,   908,     0,
       0,     0,     0,   907,     0,     0,  2575,  2576,  2577,  2578,
    2579,  2580,  2581,  2582,  2583,   905,  4502,     0,     0,  5677,
       0,     0,     0,     0,     0,  4508,     0,     0,   907,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     908,     0,     0,     0,     0,     0,     0,     0,   908,     0,
       0,  4518,  4519,     0,     0,     0,  4520,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   908,     0,     0,     0,     0,  4563,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   915,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   907,     0,
     907,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     915,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4600,     0,     0,     0,     0,  4606,     0,     0,   913,     0,
       0,  4612,     0,     0,     0,     0,     0,     0,     0,   913,
       0,     0,     0,   908,     0,   908,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   913,     0,     0,     0,     0,
     905,  4651,     0,     0,     0,   905,   905,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2111,     0,     0,
    2112,     0,     0,     0,  2113,  2114,  2115,     0,     0,     0,
    4666,     0,  4667,     0,     0,     0,   907,     0,     0,     0,
       0,     0,  2636,     0,     0,     0,     0,     0,     0,   913,
       0,     0,  2637,     0,     0,     0,     0,     0,     0,  2638,
       0,     0,     0,     0,   913,     0,     0,   913,   913,   910,
       0,     0,   910,     0,   910,     0,     0,     0,     0,   910,
     907,   908,     0,     0,     0,  2639,     0,     0,  4328,     0,
       0,     0,     0,   915,     0,     0,  4331,     0,   913,   913,
       0,     0,     0,     0,     0,     0,     0,     0,   907,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   905,
       0,   910,     0,     0,     0,   908,     0,     0,     0,   910,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     916,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   908,   910,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   907,     0,     0,     0,
       0,     0,   905,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   907,     0,
       0,  4429,     0,  4431,  2640,     0,     0,  1737,     0,  2641,
       0,     0,     0,     0,     0,     0,  2111,     0,     0,  2112,
     907,   908,     0,  2113,  2114,  2115,     0,     0,     0,     0,
       0,     0,  2642,  2306,   910,     0,   910,     0,     0,     0,
     913,  2636,     0,   908,     0,     0,     0,     0,     0,     0,
       0,  2637,     0,     0,     0,     0,   915,     0,  2638,     0,
    2643,     0,     0,     0,     0,   908,     0,   915,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   915,  2639,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4492,
       0,     0,   907,  2373,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2644,
       0,     0,  2645,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   910,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4514,     0,     0,  4902,   908,  4903,     0,
       0,     0,     0,     0,   907,     0,     0,     0,     0,     0,
       0,  4910,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4916,     0,     0,   910,  4919,     0,   907,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4933,
     911,     0,     0,     0,   911,   911,     0,     0,     0,   908,
       0,     0,     0,  2640,   910,     0,     0,     0,  2641,  4959,
       0,     0,     0,     0,     0,  2646,     0,     0,     0,     0,
       0,     0,     0,     0,   908,     0,     0,  4963,     0,     0,
       0,  2642,  2306,     0,     0,  4967,     0,     0,     0,  3647,
     915,     0,     0,     0,     0,     0,     0,     0,     0,   911,
       0,     0,     0,     0,     0,   911,     0,     0,     0,  2643,
    5002,     0,     0,     0,  5006,     0,     0,     0,     0,     0,
       0,     0,   910,     0,     0,     0,     0,     0,     0,  5016,
    5017,  5018,  5019,  4657,     0,     0,     0,     0,     0,  5023,
    5024,  5025,  5026,     0,   910,     0,     0,     0,  5028,  5029,
       0,     0,  2373,   911,  5036,  5037,     0,  5039,  5040,  5041,
    5042,  5043,  5044,  5045,     0,     0,   910,     0,  2644,     0,
       0,  2645,  2574,  5054,     0,     0,     0,  5057,  5058,  5059,
    5060,  2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,
     907,     0,     0,     0,  5716,     0,     0,     0,   975,     0,
       0,  4333,     0,     0,     0,     0,     0,   975,     0,     0,
       0,     0,     0,     0,     0,  4714,     0,     0,     0,  5080,
       0,   975,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   908,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   910,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2646,     0,     0,  4746,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   907,     0,     0,     0,
       0,     0,  4767,     0,     0,     0,  5162,     0,     0,     0,
     910,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   907,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   910,     0,     0,     0,  4333,
       0,   908,     0,     0,     0,     0,  5187,     0,  5188,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   915,     0,     0,   905,     0,     0,     0,     0,   908,
       0,     0,     0,   911,     0,     0,  5203,     0,     0,     0,
       0,  2574,     0,     0,     0,     0,     0,     0,     0,     0,
    2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,     0,
       0,     0,     0,  6080,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   915,     0,
       0,  2111,     0,     0,  2112,     0,     0,     0,  2113,  2114,
    2115,     0,     0,     0,     0,     0,   911,     0,     0,     0,
     911,     0,     0,     0,     0,     0,  2636,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2637,   907,     0,   915,
       0,     0,     0,  2638,     0,     0,     0,     0,  2111,     0,
       0,  2112,     0,     0,     0,  2113,  2114,  2115,     0,     0,
       0,     0,     0,     0,     0,     0,   910,     0,     0,  2639,
       0,     0,   915,  2636,     0,     0,     0,   966,   976,     0,
       0,     0,   908,  2637,   907,   966,     0,   976,   966,   907,
    2638,     0,     0,   913,     0,     0,     0,   913,   913,     0,
       0,   976,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2639,     0,     0,     0,
       0,     0,     0,   911,     0,     0,     0,     0,     0,   908,
       0,     0,     0,     0,   908,     0,     0,     0,   911,     0,
       0,     0,     0,   911,     0,     0,     0,     0,     0,     0,
       0,     0,   913,     0,     0,     0,     0,     0,   913,  5349,
    5350,  5351,   910,     0,     0,  5352,  5353,  5354,  5355,     0,
       0,     0,  5357,   911,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2640,     0,
     910,     0,     0,  2641,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   913,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2642,  2306,     0,     0,
       0,     0,     0,     0,  5392,  5393,  5394,  5395,  5396,     0,
    5398,  5399,     0,     0,     0,  2640,   975,     0,     0,     0,
    2641,     0,  5408,  5409,  2643,     0,     0,   907,     0,     0,
       0,     0,     0,     0,     0,   975,     0,     0,     0,     0,
       0,   975,     0,  2642,  2306,     0,   915,     0,     0,     0,
       0,     0,     0,   975,     0,     0,  5415,   915,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2373,     0,   975,
       0,  2643,   908,   915,     0,     0,     0,     0,     0,     0,
    5110,     0,     0,  2644,   975,     0,  2645,     0,     0,     0,
       0,     0,   975,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   975,     0,     0,     0,
       0,     0,     0,   910,  2373,     0,   975,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   915,     0,     0,
    2644,     0,     0,  2645,     0,     0,     0,     0,     0,     0,
       0,     0,   915,     0,   907,   915,   915,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5480,
     910,     0,     0,     0,     0,   910,     0,     0,     0,   975,
       0,     0,     0,     0,     0,     0,   915,   915,     0,  2646,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   908,
       0,     0,     0,     0,     0,     0,   913,   975,   907,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   911,     0,
       0,   911,     0,   911,     0,     0,     0,     0,   911,     0,
     907,     0,   975,     0,  5531,     0,  2646,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   908,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5537,     0,     0,     0,
     911,     0,     0,     0,     0,   908,     0,     0,   911,   913,
       0,     0,     0,   913,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   975,     0,  2574,     0,     0,     0,
       0,     0,   907,   911,     0,  2575,  2576,  2577,  2578,  2579,
    2580,  2581,  2582,  2583,     0,     0,     0,     0,  6088,     0,
       0,     0,     0,     0,     0,     0,   976,     0,   915,     0,
       0,     0,     0,   910,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2574,     0,   976,     0,   908,     0,     0,
       0,   976,  2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,
    2583,     0,     0,   976,   661,  6110,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   976,
       0,     0,     0,   911,     0,   911,   913,     0,     0,     0,
       0,     0,     0,   966,   976,     0,     0,     0,     0,     0,
     966,   913,   976,   966,  1823,     0,   913,     0,     0,     0,
       0,   975,     0,     0,     0,     0,   976,  5348,     0,     0,
       0,     0,     0,     0,   907,     0,   976,     0,     0,     0,
       0,     0,     0,     0,     0,  5664,   913,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     910,     0,     0,     0,  5674,     0,     0,     0,     0,     0,
    5680,  5681,     0,     0,     0,     0,     0,     0,     0,   908,
    5692,  5386,     0,     0,     0,     0,     0,  5694,     0,   976,
       0,   911,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5402,     0,     0,  1579,     0,     0,     0,
       0,     0,  1580,  2111,   910,     0,  2112,   976,     0,  1646,
    2113,  2114,  2115,     0,  5747,  5748,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   911,   910,  5756,  2636,  5758,
       0,  1647,   976,     0,     0,   975,     0,     0,  2637,     0,
       0,     0,     0,     0,  5772,  2638,     0,  1582,     0,     0,
       0,     0,     0,   911,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   907,     0,  5430,     0,     0,     0,  4333,
       0,  2639,     0,     0,     0,     0,     0,  5806,     0,     0,
       0,     0,     0,  1648,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   976,     0,   975,     0,   910,     0,
       0,     0,     0,     0,  1583,     0,     0,   975,   908,     0,
       0,  1584,     0,     0,     0,  1585,     0,     0,     0,     0,
       0,   911,     0,     0,   975,     0,     0,     0,     0,   975,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   907,
       0,     0,     0,   911,  1586,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   911,     0,     0,     0,  5867,
       0,     0,     0,     0,     0,     0,  1649,     0,     0,     0,
    1587,     0,     0,  5882,   908,     0,     0,  5516,     0,     0,
    2640,   913,     0,     0,   913,  2641,   913,     0,     0,     0,
       0,   913,     0,     0,  1824,     0,     0,     0,     0,  5900,
       0,   976,     0,     0,     0,     0,     0,     0,  2642,  2306,
     910,     0,   966,     0,     0,     0,   966,     0,   966,     0,
       0,     0,     0,     0,  1650,     0,     0,     0,     0,  1651,
       0,     0,     0,   913,  1652,     0,  2643,   911,     0,     0,
       0,   913,     0,     0,     0,     0,     0,     0,     0,     0,
    1653,   907,   975,     0,  1589,     0,     0,     0,     0,     0,
     975,   975,     0,     0,     0,  1590,   913,  5959,     0,     0,
       0,     0,     0,     0,     0,  1591,     0,     0,     0,  2373,
       0,     0,     0,     0,     0,     0,  1654,  1592,     0,   911,
       0,     0,     0,     0,     0,  2644,   908,     0,  2645,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1823,   911,     0,  4492,     0,     0,     0,
       0,     0,     0,     0,     0,   976,     0,     0,     0,  1655,
       0,     0,  1594,  1595,  1656,     0,     0,  4333,     0,     0,
       0,     0,     0,     0,     0,     0,   913,     0,   913,   910,
       0,     0,  2111,     0,     0,  2112,     0,     0,  1657,  2113,
    2114,  2115,     0,     0,  1658,     0,     0,     0,     0,     0,
       0,  6039,     0,     0,     0,     0,     0,  2636,     0,  1659,
       0,     0,     0,     0,     0,     0,   976,  2637,     0,     0,
       0,  2646,     0,     0,  2638,     0,     0,   976,     0,     0,
       0,     0,     0,     0,     0,     0,   907,     0,     0,     0,
       0,   907,   907,     0,   976,     0,     0,  6070,     0,   976,
    2639,     0,     0,     0,     0,   910,     0,   979,     0,     0,
    1660,     0,     0,     0,     0,     0,     0,  1597,     0,  1013,
       0,   915,  6089,     0,   913,   915,   915,     0,     0,     0,
    1032,   908,     0,     0,     0,     0,   908,   908,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   911,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   913,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2574,     0,
     915,  6128,     0,     0,     0,     0,   915,  2575,  2576,  2577,
    2578,  2579,  2580,  2581,  2582,  2583,   913,     0,     0,     0,
    6338,     0,     0,     0,     0,   907,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2640,
       0,     0,     0,     0,  2641,     0,     0,   910,     0,     0,
       0,     0,   976,     0,   915,     0,     0,     0,     0,     0,
     976,   976,     0,     0,   975,     0,     0,  2642,  2306,     0,
     908,   911,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   913,     0,     0,     0,   907,     0,
       0,     0,     0,     0,     0,  2643,     0,     0,     0,   911,
       0,     0,     0,     0,     0,     0,   913,     0,     0,     0,
       0,     0,     0,  1824,     0,     0,  6225,  2111,     0,     0,
    2112,     0,     0,     0,  2113,  2114,  2115,     0,   913,     0,
       0,     0,     0,   908,     0,     0,     0,     0,  2373,     0,
       0,     0,  2636,     0,     0,  6240,     0,     0,     0,     0,
       0,     0,  2637,     0,  2644,     0,  6250,  2645,     0,  2638,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2031,
       0,     0,     0,     0,  2031,  2031,     0,     0,     0,   975,
       0,     0,     0,     0,     0,  2639,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   910,     0,     0,     0,     0,   910,   910,     0,
     913,     0,     0,     0,  1823,     0,     0,   953,   955,     0,
       0,   958,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   975,     0,     0,
       0,  1016,   911,     0,     0,   975,     0,     0,  1026,     0,
    2646,     0,     0,   975,     0,     0,     0,     0,     0,     0,
       0,     0,   913,     0,   915,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  6332,     0,     0,     0,   913,  5992,   911,
       0,     0,     0,     0,   911,     0,     0,   975,   975,     0,
       0,     0,     0,     0,  2640,     0,     0,     0,     0,  2641,
       0,   975,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   910,     0,     0,   975,   975,     0,     0,     0,     0,
       0,     0,  2642,  2306,     0,     0,     0,   915,     0,     0,
       0,   915,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6048,     0,     0,     0,     0,     0,  2574,     0,     0,
    2643,     0,     0,     0,   976,     0,  2575,  2576,  2577,  2578,
    2579,  2580,  2581,  2582,  2583,     0,     0,     0,     0,  6355,
       0,     0,     0,     0,   910,  1052,     0,     0,     0,     0,
       0,  1084,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2373,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2644,
       0,     0,  2645,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   915,     0,     0,     0,   913,     0,
       0,     0,   911,     0,     0,     0,     0,     0,     0,   915,
       0,     0,     0,     0,   915,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   976,
       0,     0,     0,     0,  1823,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   915,  6476,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1824,  2646,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   976,     0,     0,
       0,     0,     0,     0,   913,   976,     0,     0,     0,     0,
       0,     0,     0,   976,     0,     0,     0,     0,     0,     0,
       0,     0,  1393,     0,     0,     0,     0,     0,     0,   911,
       0,     0,   913,     0,     0,     0,     0,     0,     0,     0,
       0,  1416,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   966,   966,     0,   976,   976,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   966,
     907,   976,   966,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2574,   911,   976,   976,     0,     0,     0,     0,
       0,  2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,
    2111,     0,     0,  2112,  6414,   911,     0,  2113,  2114,  2115,
       0,     0,     0,     0,     0,   908,     0,     0,     0,     0,
       0,     0,   966,     0,     0,  2636,   966,   966,     0,     0,
       0,     0,     0,     0,     0,  2637,     0,     0,     0,     0,
       0,     0,  2638,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1086,     0,  1089,     0,     0,  1091,     0,
    1610,     0,     0,     0,     0,     0,     0,     0,  2639,     0,
       0,     0,  1117,  2111,     0,   913,  2112,   911,  1121,     0,
    2113,  2114,  2115,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2636,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2637,   915,
       0,     0,   915,     0,   915,  2638,     0,     0,     0,   915,
       0,     0,   913,     0,     0,     0,     0,   913,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2639,     0,     0,  1824,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   915,     0,     0,     0,     0,     0,     0,     0,   915,
       0,     0,     0,     0,     0,  1873,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2640,     0,     0,
       0,     0,  2641,     0,   915,     0,     0,     0,     0,   911,
       0,     0,     0,     0,  1907,  1910,  1911,     0,     0,     0,
       0,     0,     0,     0,     0,  2642,  2306,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  6412,     0,  4144,     0,     0,     0,     0,
       0,  4145,     0,  2643,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2640,     0,     0,     0,     0,  2641,   910,     0,     0,     0,
       0,     0,     0,     0,   915,     0,   915,     0,     0,     0,
       0,     0,     0,     0,     0,   913,  2373,     0,  2642,  2306,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2644,     0,     0,  2645,     0,     0,     0,     0,
       0,     0,     0,  1393,     0,  2111,  2643,     0,  2112,     0,
       0,     0,  2113,  2114,  2115,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   911,     0,
    2636,  1393,     0,     0,  3495,     0,     0,     0,     0,     0,
    2637,     0,     0,     0,     0,     0,     0,  2638,     0,  2373,
       0,     0,     0,     0,     0,  1611,  1612,     0,     0,     0,
       0,     0,   915,     0,     0,  2644,     0,     0,  2645,     0,
       0,     0,     0,  2639,  1823,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2646,     0,
       0,     0,   913,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   911,     0,   915,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3496,  1841,     0,     0,   975,
       0,     0,     0,     0,   915,     0,     0,     0,     0,     0,
       0,  1853,     0,     0,     0,     0,   913,   975,     0,     0,
       0,   975,     0,     0,     0,   975,     0,     0,     0,     0,
       0,  4146,     0,     0,   975,     0,     0,     0,   913,     0,
       0,     0,  1875,  1876,     0,     0,     0,     0,     0,   975,
       0,     0,     0,     0,  2630,     0,     0,     0,     0,     0,
       0,     0,  2640,     0,     0,  2574,     0,  2641,  1913,     0,
       0,     0,   915,     0,  2575,  2576,  2577,  2578,  2579,  2580,
    2581,  2582,  2583,   975,     0,  3029,     0,     0,     0,     0,
    2642,  2306,     0,     0,   915,     0,   911,     0,     0,     0,
       0,     0,     0,   975,   975,     0,     0,     0,  1951,  1953,
     913,     0,     0,     0,     0,     0,   915,     0,  2643,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2721,     0,     0,     0,  2574,     0,
       0,  1823,   975,     0,     0,  1823,     0,  2575,  2576,  2577,
    2578,  2579,  2580,  2581,  2582,  2583,     0,     0,     0,     0,
       0,  2373,     0,     0,     0,     0,     0,     0,     0,   975,
       0,  1823,     0,     0,     0,   975,     0,  2644,     0,     0,
    2645,     0,     0,     0,     0,     0,     0,     0,     0,   975,
       0,     0,     0,     0,     0,     0,   975,     0,   915,   975,
       0,     0,     0,     0,     0,   975,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2835,     0,     0,
       0,     0,     0,     0,     0,   975,  2865,     0,     0,     0,
       0,   975,   913,     0,     0,     0,     0,     0,   975,     0,
       0,     0,     0,     0,  1824,     0,     0,     0,     0,     0,
     915,   911,   975,     0,     0,     0,   911,   911,  2903,     0,
       0,     0,     0,     0,  2915,  2915,   975,     0,  2915,     0,
       0,  1823,     0,  2646,     0,   915,     0,   975,     0,     0,
       0,  2933,     0,     0,  2936,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   976,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   976,     0,     0,
       0,   976,     0,     0,     0,   976,     0,     0,     0,     0,
       0,     0,     0,     0,   976,     0,     0,  1823,  3497,     0,
       0,     0,  2989,     0,     0,     0,     0,     0,     0,   976,
       0,     0,     0,     0,     0,     0,  3009,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   966,     0,   966,   966,
     911,   913,     0,     0,     0,     0,     0,     0,     0,     0,
    2574,     0,     0,   976,     0,     0,     0,     0,     0,  2575,
    2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,     0,     0,
       0,     0,     0,   976,   976,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2111,     0,
       0,  2112,     0,     0,     0,  2113,  2114,  2115,     0,     0,
       0,     0,     0,   911,     0,     0,   915,     0,     0,     0,
       0,  1824,   976,  2636,     0,  1824,     0,   913,     0,     0,
       0,     0,     0,  2637,     0,     0,     0,     0,     0,     0,
    2638,     0,     0,     0,     0,     0,  3031,     0,     0,   976,
       0,  1824,     0,     0,     0,   976,     0,  3034,     0,     0,
       0,     0,     0,     0,     0,     0,  2639,     0,     0,   976,
       0,     0,   975,     0,  1823,     0,   976,     0,     0,   976,
       0,     0,     0,     0,  2823,   976,     0,     0,     0,     0,
       0,   975,     0,     0,     0,     0,     0,     0,   975,  3078,
    2915,     0,     0,     0,     0,   976,     0,     0,     0,  2869,
       0,   976,   915,     0,     0,     0,     0,     0,   976,     0,
       0,     0,     0,     0,  3113,     0,     0,     0,     0,     0,
       0,  3126,   976,     0,     0,     0,     0,     0,     0,     0,
     915,     0,     0,     0,     0,     0,   976,     0,     0,   913,
       0,  1824,     0,     0,     0,     0,     0,   976,     0,  6175,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2640,     0,     0,  2959,     0,
    2641,     0,     0,     0,     0,  1823,     0,     0,     0,     0,
       0,  1823,     0,     0,  3187,     0,     0,     0,     0,     0,
       0,     0,     0,  2642,  2306,     0,     0,  1824,  2985,  2986,
    2987,  2988,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1393,  1393,     0,
       0,  2643,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3241,  2111,     0,  3243,  2112,     0,
       0,     0,  2113,  2114,  2115,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2636,     0,     0,   915,  2373,     0,   975,     0,     0,     0,
    2637,     0,     0,     0,     0,     0,     0,  2638,     0,     0,
    2644,     0,     0,  2645,   913,     0,     0,     0,     0,   913,
     913,     0,     0,     0,     0,     0,     0,     0,  2111,     0,
       0,  2112,     0,  2639,     0,  2113,  2114,  2115,     0,  6176,
     915,     0,     0,     0,     0,   915,     0,     0,     0,     0,
       0,     0,     0,  2636,     0,     0,  4072,     0,     0,     0,
       0,     0,     0,  2637,     0,     0,     0,     0,     0,     0,
    2638,     0,     0,     0,     0,  3042,  3043,     0,     0,     0,
       0,     0,   976,     0,  1824,     0,     0,     0,     0,     0,
       0,  3060,     0,     0,     0,     0,  2639,     0,     0,     0,
       0,   976,     0,     0,     0,     0,  2646,     0,   976,     0,
       0,     0,     0,     0,     0,   966,     0,   966,   966,     0,
       0,     0,     0,     0,     0,  3103,  3104,  3105,  3106,   975,
     975,     0,     0,   913,  2111,     0,     0,  2112,     0,     0,
       0,  2113,  2114,  2115,     0,     0,     0,     0,     0,     0,
     975,     0,  2640,   975,     0,     0,     0,  2641,     0,  2636,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2637,
       0,     0,     0,     0,     0,     0,  2638,     0,     0,     0,
    2642,  2306,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   913,     0,     0,     0,
       0,     0,  2639,   915,     0,  1824,  3180,     0,  2643,     0,
       0,  1824,  3184,  2574,     0,  2640,     0,     0,     0,     0,
    2641,     0,  2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,
    2583,     0,     0,     0,     0,  1823,  1823,  1823,     0,     0,
       0,     0,     0,  2642,  2306,   911,     0,     0,     0,     0,
       0,  2373,     0,     0,     0,     0,     0,     0,     0,     0,
     975,     0,     0,     0,     0,     0,     0,  2644,     0,     0,
    2645,  2643,     0,     0,     0,     0,     0,     0,     0,   975,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   976,     0,  4780,     0,
       0,   975,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2373,     0,  1579,     0,     0,     0,
     915,  2640,  1580,     0,     0,     0,  2641,     0,     0,  1646,
    2644,     0,     0,  2645,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2642,
    2306,  1647,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2646,     0,     0,     0,  1582,     0,     0,
       0,     0,     0,     0,   915,     0,     0,  2643,     0,     0,
       0,     0,  4781,     0,     0,     0,     0,     0,     0,     0,
       0,   975,     0,     0,     0,     0,   915,     0,     0,     0,
    3368,     0,     0,  1648,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2373,     0,     0,     0,  1583,     0,  2646,     0,     0,   976,
     976,  1584,     0,     0,     0,  1585,  2644,     0,  1823,  2645,
       0,     0,     0,     0,   975,     0,   975,     0,     0,     0,
     976,     0,     0,   976,     0,     0,     0,     0,     0,   975,
       0,   975,     0,     0,  1586,     0,     0,     0,   915,     0,
    2574,     0,     0,     0,     0,     0,     0,     0,     0,  2575,
    2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,     0,     0,
       0,     0,     0,     0,     0,     0,  1649,     0,     0,     0,
    1587,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3426,     0,     0,     0,   975,     0,
       0,     0,  2646,  2574,  3431,  1824,  1824,  1824,     0,     0,
       0,     0,  2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,
    2583,     0,     0,     0,  1650,     0,     0,     0,     0,  1651,
     976,     0,     0,     0,  1652,     0,     0,     0,     0,     0,
     975,     0,     0,     0,     0,     0,     0,     0,     0,   976,
    1653,     0,     0,     0,  1589,     0,     0,     0,     0,   975,
     915,     0,     0,   975,     0,  1590,     0,     0,     0,     0,
       0,   976,     0,     0,     0,  1591,     0,     0,     0,     0,
       0,     0,     0,     0,   975,     0,  1654,  1592,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4081,  2574,
       0,     0,     0,     0,  1393,     0,     0,     0,  2575,  2576,
    2577,  2578,  2579,  2580,  2581,  2582,  2583,     0,     0,  3750,
       0,     0,  1594,  1595,  1656,  2111,     0,     0,  2112,     0,
       0,     0,  2113,  2114,  2115,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1657,     0,
    2636,   976,     0,     0,  3751,     0,     0,     0,     0,     0,
    2637,     0,     0,     0,     0,     0,     0,  2638,     0,  1659,
       0,     0,     0,     0,     0,     0,     0,     0,   913,     0,
       0,     0,  1823,     0,     0,     0,     0,     0,     0,   915,
       0,     0,     0,  2639,     0,     0,     0,  -136,  1824,     0,
       0,     0,     0,     0,   976,     0,   976,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     1,     0,   976,
    1660,   976,     0,     0,     0,     0,     0,  1597,     2,     0,
       3,     4,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3651,     0,     0,     0,     0,     0,     0,     5,     0,
       0,     0,     0,     0,     0,     0,  3673,     0,     6,     0,
       0,     0,     0,     0,     0,   915,     0,     0,     0,     0,
       7,     0,     8,     9,     0,     0,     0,     0,  3701,    10,
       0,    11,     0,     0,     0,     0,     0,     0,   976,     0,
       0,     0,     0,     0,    12,     0,    13,     0,     0,     0,
       0,  2111,     0,     0,  2112,     0,     0,     0,  2113,  2114,
    2115,     0,  2640,    14,     0,     0,    15,  2641,     0,     0,
       0,     0,     0,     0,     0,     0,  2636,     0,  3368,  4149,
     976,    16,     0,    17,     0,     0,  2637,    18,     0,     0,
    2642,  2306,     0,  2638,    19,     0,     0,     0,     0,   976,
       0,     0,     0,   976,    20,     0,    21,   975,     0,     0,
       0,     0,     0,    22,  3781,  3782,     0,     0,  2643,  2639,
       0,     0,     0,     0,   976,     0,     0,     0,     0,     0,
       0,    23,     0,     0,     0,     0,     0,   915,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    24,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2373,     0,     0,     0,  1368,  1368,     0,     0,     0,
       0,  1823,     0,     0,     0,     0,  1823,  2644,  1823,     0,
    2645,     0,     0,     0,     0,     0,     0,     0,     0,  2111,
       0,     0,  2112,     0,     0,     0,  2113,  2114,  2115,     0,
       0,  4117,    25,    26,  1823,     0,     0,     0,    27,     0,
       0,     0,     0,     0,  2636,     0,  3907,     0,     0,     0,
       0,     0,     0,    28,  2637,     0,     0,     0,     0,     0,
       0,  2638,  1824,     0,     0,     0,     0,     0,  2640,     0,
    3605,     0,    29,  2641,     0,  1368,     0,     0,     0,     0,
     975,     0,     0,   975,     0,     0,     0,  2639,     0,     0,
       0,     0,     0,     0,     0,     0,  2642,  2306,     0,     0,
       0,     0,     0,  2646,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    30,   915,     0,  2643,     0,     0,   915,   915,     0,
       0,     0,     0,     0,     0,     0,    31,     0,     0,     0,
       0,    32,    33,     0,    34,     0,     0,     0,     0,    35,
       0,     0,     0,     0,     0,    36,     0,     0,    37,     0,
       0,     0,     0,     0,     0,    38,     0,  2373,     0,     0,
       0,     0,    39,    40,   975,   975,     0,     0,     0,     0,
      41,     0,     0,  2644,    42,   975,  2645,  4154,     0,     0,
       0,     0,     0,     0,     0,    43,  1734,  1738,     0,     0,
       0,     0,   975,     0,     0,     0,  2640,     0,     0,     0,
    2574,  2641,    44,     0,     0,  3755,     0,     0,  3758,  2575,
    2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,     0,     0,
       0,     0,     0,    45,  2642,  2306,     0,   976,     0,     0,
       0,   915,     0,     0,     0,    46,     0,     0,     0,     0,
       0,    47,     0,     0,     0,     0,    48,     0,     0,     0,
       0,     0,  2643,     0,     0,     0,     0,     0,  2111,     0,
      49,  2112,     0,     0,     0,  2113,  2114,  2115,     0,  2646,
       0,     0,     0,   975,     0,     0,  1823,     0,     0,     0,
       0,  2585,     0,  2636,    50,     0,    51,    52,    53,    54,
      55,  1824,     0,  2637,   915,  2373,  1824,  3853,  1824,     0,
    2638,     0,     0,    56,     0,     0,  -136,     0,     0,     0,
    3866,  2644,     0,     0,  2645,     0,     0,     0,  3875,     0,
       0,     0,     0,     0,  1824,     0,  2639,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2585,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3919,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     976,     0,     0,   976,     0,     0,  2574,     0,  3943,     0,
    4215,     0,     0,     0,     0,  2575,  2576,  2577,  2578,  2579,
    2580,  2581,  2582,  2583,     0,     0,     0,     0,     0,     0,
       0,  2111,     0,     0,  2112,     0,     0,  2646,  2113,  2114,
    2115,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3998,     0,  4000,     0,  2055,  2636,     0,     0,  4161,
       0,     0,     0,     0,     0,     0,  2637,     0,     0,     0,
       0,     0,     0,  2638,     0,  2640,     0,     0,     0,     0,
    2641,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   976,   976,     0,  2081,     0,  2639,
       0,     0,     0,  2642,  2306,   976,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   976,     0,     0,     0,  2100,  2101,  2102,     0,
    2104,  2643,     0,     0,     0,     0,     0,     0,   975,     0,
       0,  4055,     0,     0,  2574,     0,     0,     0,  4062,     0,
       0,  2592,     0,  2575,  2576,  2577,  2578,  2579,  2580,  2581,
    2582,  2583,     0,     0,     0,     0,     0,     0,     0,  2111,
       0,     0,  2112,     0,  2373,     0,  2113,  2114,  2115,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2644,     0,     0,  2645,  2636,     0,   975,  4787,     0,     0,
       0,     0,     0,   976,  2637,     0,  1824,     0,   975,     0,
       0,  2638,     0,     0,     0,     0,     0,     0,  2640,     0,
       0,     0,     0,  2641,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2639,     0,     0,
       0,     0,   975,     0,     0,     0,  2642,  2306,     0,     0,
       0,     0,     0,     0,  2688,     0,     0,  2111,  2700,  2705,
    2112,     0,     0,     0,  2113,  2114,  2115,     0,     0,     0,
       0,     0,     0,     0,  2643,     0,     0,  2585,     0,     0,
       0,  2585,  2636,     0,     0,     0,  2646,     0,     0,     0,
       0,     0,  2637,     0,     0,     0,     0,     0,     0,  2638,
       0,     0,     0,     0,     0,  4435,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2915,     0,  2373,     0,     0,
       0,  1823,  4711,     0,     0,  2639,     0,     0,     0,     0,
       0,     0,     0,  2644,     0,     0,  2645,     0,     0,     0,
     975,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2640,     0,     0,     0,
       0,  2641,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2642,  2306,     0,     0,     0,     0,
       0,     0,     0,  2574,     0,     0,     0,     0,     0,     0,
       0,     0,  2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,
    2583,     0,  2643,     0,     0,  2111,     0,     0,  2112,     0,
       0,     0,  2113,  2114,  2115,     0,   975,     0,     0,  2646,
       0,     0,     0,     0,     0,     0,     0,     0,   976,     0,
    2636,     0,     0,     0,  2640,     0,   915,     0,     0,  2641,
    2637,     0,     0,     0,     0,  2373,     0,  2638,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2644,  2642,  2306,  2645,     0,     0,     0,  4567,  4568,
    4569,     0,     0,  2639,     0,     0,     0,  4329,  4330,     0,
       0,     0,     0,     0,     0,  4578,   976,     0,     0,     0,
    2643,     0,     0,  1734,  1734,  1734,     0,     0,   976,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4603,  4605,
       0,     0,     0,  4610,     0,     0,  2574,     0,     0,     0,
       0,     0,   976,  2373,     0,  2575,  2576,  2577,  2578,  2579,
    2580,  2581,  2582,  2583,     0,     0,     0,     0,   975,  2644,
     975,     0,  2645,     0,     0,     0,  2111,  2646,     0,  2112,
       0,     0,     0,  2113,  2114,  2115,     0,     0,     0,  5231,
       0,     0,     0,  5241,     0,     0,     0,     0,     0,     0,
       0,  2636,     0,     0,     0,     0,     0,     0,  2585,     0,
       0,  2637,  2640,     0,     0,     0,     0,  2641,  2638,     0,
       0,   975,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1824,     0,     0,  2585,     0,     0,     0,  3325,     0,
    2642,  2306,     0,     0,  2639,     0,     0,     0,     0,  1393,
     976,     0,     0,  2585,  2585,  2585,     0,  2585,     0,     0,
       0,     0,     0,     0,     0,  2646,     0,     0,  2643,     0,
       0,  1823,     0,     0,     0,     0,     0,     0,     0,  2111,
       0,     0,  2112,     0,  2574,     0,  2113,  2114,  2115,     0,
       0,     0,     0,  2575,  2576,  2577,  2578,  2579,  2580,  2581,
    2582,  2583,     0,     0,  2636,     0,     0,     0,     0,     0,
       0,  2373,     0,     0,  2637,     0,     0,     0,     0,     0,
       0,  2638,     0,     0,     0,     0,     0,  2644,     0,     0,
    2645,     0,     0,     0,     0,     0,   976,     0,     0,     0,
       0,     0,     0,     0,  5247,     0,     0,  2639,     0,     0,
       0,  4515,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2640,     0,     0,     0,     0,  2641,     0,
       0,     0,  2574,     0,     0,     0,     0,     0,     0,     0,
       0,  2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,
       0,  2642,  2306,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4819,  4820,  4821,     0,  2643,
       0,     0,     0,  2646,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5248,  3269,     0,     0,     0,     0,     0,     0,     0,
       0,  3286,  3286,  3286,  3286,  3296,  3302,  3286,  3305,  3286,
    3286,     0,  2373,     0,     0,  3312,  2640,  3313,   976,  3315,
     976,  2641,  3329,  3332,  3337,     0,     0,     0,  2644,     0,
    3346,  2645,     0,  3351,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2642,  2306,     0,     0,  3358,  3359,
    3360,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4669,     0,     0,     0,   975,  3361,     0,     0,     0,
       0,   976,  2643,     0,     0,     0,     0,     0,     0,   975,
    2574,   966,     0,     0,     0,     0,     0,     0,     0,  2575,
    2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1823,     0,     0,     0,  2373,     0,     0,     0,     0,
       0,  1824,     0,     0,  2646,     0,   966,     0,     0,     0,
       0,  2644,     0,     0,  2645,     0,     0,  2111,     0,     0,
    2112,     0,     0,     0,  2113,  2114,  2115,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2636,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2637,     0,     0,     0,     0,     0,     0,  2638,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1823,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2639,     0,     0,     0,     0,
       0,     0,     0,     0,  3369,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1823,  2646,     0,     0,
       0,  2574,     0,     0,     0,     0,     0,     0,     0,     0,
    2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,     0,
       0,  2111,     0,     0,  2112,     0,     0,     0,  2113,  2114,
    2115,     0,     0,     0,     0,     0,     0,     0,  3388,     0,
       0,     0,     0,     0,     0,     0,  2636,     0,  5249,     0,
       0,     0,     0,     0,     0,     0,  2637,     0,     0,     0,
       0,     0,     0,  2638,     0,  2585,     0,     0,     0,     0,
       0,     0,  1823,  5091,     0,   975,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2639,
       0,     0,     0,     0,  2640,  3390,     0,     0,     0,  2641,
       0,     0,     0,     0,  2574,  5123,     0,     0,     0,     0,
       0,     0,     0,  2575,  2576,  2577,  2578,  2579,  2580,  2581,
    2582,  2583,  2642,  2306,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   976,     0,  3126,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   976,
    2643,     0,     0,     0,     0,  2111,     0,     0,  2112,     0,
       0,  2585,  2113,  2114,  2115,     0,     0,     0,     0,     0,
       0,     0,  5181,  2585,     0,     0,     0,     0,  2585,     0,
    2636,  1824,     0,     0,     0,     0,     0,     0,     0,  3187,
    2637,     0,     0,  2373,     0,     0,     0,  2638,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2640,  2644,
       0,     0,  2645,  2641,     0,     0,     0,     0,     0,     0,
     975,     0,     0,  2639,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2642,  2306,     0,     0,
       0,     0,     0,     0,   975,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1824,     0,     0,     0,  2643,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3397,  3398,  3399,  3400,  3401,  3402,  3403,  3404,  3405,     0,
    3406,     0,     0,     0,     0,     0,  1824,     0,     0,     0,
       0,  1368,     0,  1734,     0,  2646,     0,  2373,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5820,     0,     0,
       0,     0,     0,  2644,     0,     0,  2645,     0,     0,     0,
       0,     0,     0,     0,  5284,  5285,  5286,  5287,     0,     0,
       0,  3361,  2640,     0,     0,  3369,     0,  2641,  3388,  5077,
    3390,     0,     0,  3443,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5079,     0,     0,     0,     0,     0,     0,
    2642,  2306,  1824,     0,     0,   976,     0,     0,     0,     0,
       0,     0,     0,     0,   975,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2643,     0,
       0,     0,     0,     0,     0,     0,  2101,  2102,     0,     0,
       0,     0,  2574,     0,     0,     0,     0,     0,     0,  2646,
       0,  2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2373,     0,     0,     0,     0,  2111,     0,     0,  2112,
       0,     0,     0,  2113,  2114,  2115,     0,  2644,     0,     0,
    2645,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2636,     0,     0,  5837,     0,     0,     0,     0,     0,
       0,  2637,     0,     0,     0,     0,  3583,     0,  2638,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5629,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2639,     0,     0,     0,     0,     0,
     976,     0,     0,     0,     0,     0,  2574,     0,     0,     0,
       0,     0,     0,     0,   966,  2575,  2576,  2577,  2578,  2579,
    2580,  2581,  2582,  2583,   976,     0,     0,     0,  1823,     0,
       0,     0,     0,  2646,     0,     0,     0,  2111,     0,     0,
    2112,     0,     0,     0,  2113,  2114,  2115,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2636,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2637,     0,     0,     0,     0,     0,     0,  2638,
       0,     0,     0,   966,   966,     0,     0,     0,     0,  1823,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2639,     0,     0,     0,     0,
       0,     0,     0,  2640,  1823,     0,     0,     0,  2641,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2574,  2642,  2306,     0,     0,     0,     0,     0,     0,  2575,
    2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,     0,     0,
       0,     0,     0,     0,   976,     0,  5509,     0,     0,  2643,
       0,     0,     0,     0,     0,     0,     0,  5519,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3839,
    3840,  1734,  2373,     0,     0,  3844,     0,     0,     0,     0,
       0,     0,  2585,     0,  2640,     0,     0,     0,  2644,  2641,
       0,  2645,     0,     0,     0,     0,     0,     0,     0,  2585,
       0,     0,  3873,     0,     0,     0,     0,     0,     0,  2585,
       0,     0,  2642,  2306,     0,  2585,     0,     0,  2585,     0,
       0,     0,     0,     0,     0,  2585,  2585,     0,  2585,     0,
       0,     0,     0,  3325,  3325,     0,  4140,     0,  3325,     0,
    2643,     0,  2585,     0,     0,  2585,     0,     0,     0,     0,
    2585,     0,     0,     0,     0,     0,     0,     0,     0,  2585,
       0,     0,     0,     0,  2585,     0,     0,     0,     0,     0,
       0,  2585,  2585,  2585,  2585,     0,     0,     0,     0,  3325,
    3325,     0,  2585,  2373,  2646,     0,     0,     0,  1824,     0,
       0,  5423,     0,     0,     0,     0,     0,     0,     0,  2644,
       0,  2585,  2645,  2585,     0,     0,  5427,     0,     0,     0,
    2585,  2585,  2585,  2585,  2585,  2585,  2585,  2585,  2585,  2585,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1824,
       0,     0,     0,     0,     0,     0,  2585,     0,     0,     0,
       0,     0,   966,   966,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1824,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2574,     0,     0,     0,  2646,     0,     0,  5487,     0,
    2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,     0,
       0,  4068,     0,     0,     0,     0,  4074,     0,     0,     0,
       0,     0,     0,  5731,     0,     0,     0,     0,  1393,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     1,     0,  5761,     0,     0,
       0,     0,     0,     0,     0,     0,     2,     0,     3,     4,
       0,     0,     0,     0,     0,     0,     0,  2104,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3337,     0,
    3337,  3337,     0,     0,     0,     0,     6,     0,     0,     0,
       0,     0,     0,     0,  4164,     0,  2585,  4167,     7,  4169,
       8,     9,  2574,     0,     0,     0,     0,    10,     0,    11,
       0,  2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,
       0,     0,    12,     0,    13,     0,     0,     0,     0,     0,
       0,     0,     0,   673,     0,     0,  4194,     0,  4197,     0,
    4199,    14,     0,     0,    15,     0,     0,     0,     0,     0,
       0,   674,     0,     0,     0,     0,     0,     0,     0,    16,
       0,    17,     0,     0,     0,    18,     0,     0,     0,     0,
       0,     0,  5786,     0,     0,     0,   675,     0,     0,     0,
       0,     0,    20,     0,    21,     0,     0,     0,     0,   676,
       0,    22,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  -899,     0,     0,    23,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5648,   677,  5650,    24,     0,     0,     0,
     678,     0,     0,     0,  4269,     0,     0,     0,     0,  2688,
       0,     0,     0,     0,     0,     0,     0,     0,   679,     0,
       0,     0,     0,     0,  2705,     0,     0,     0,     0,     0,
       0,     0,   680,     0,     0,     0,     0,     0,     0,     0,
       0,   681,     0,     0,     0,     0,     0,     0,     0,     0,
      25,    26,     0,     0,   682,     0,    27,     0,     0,     0,
       0,     0,     0,   683,     0,     0,     0,   684,     0,     0,
       0,    28,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5966,     0,     0,     0,     0,     0, -1104,     0,  4319,
      29,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5988,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2585,  2585,     0,     0,     0,  2585,     0,     0,
       0,     0,     0,     0,     0,  5777,     0,   685,     0,    30,
       0,     0,     0,     0,     0,     0,     0,  -630,     0,  4354,
       0,     0,     0,     0,    31,     0,  2585,     0,     0,    32,
      33,     0,    34,     0,     0,     0,     0,    35,     0,     0,
    4641,     0,     0,    36,     0,     0,    37,     0,     0,     0,
       0,     0,     0,    38,     0,     0,     0,     0,     0,     0,
      39,    40,   686,     0,     0,   687,     0,     0,    41,     0,
       0,     0,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    43,     0,     0,     0,     0,     0,   688,
    6076,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      44,     0,     0,   689,     0,     0,     0,     0,     0,     0,
    -468,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,     0,     0,     0,     0,     0,     0,     0,     0,
     690,     0,     0,    46,     0,     0,     0,     0,     0,    47,
     691,     0,     0,     0,    48,     0,     0,  -468,     0,     0,
     692,     0,     0,     0,     0,     0,     0,     0,    49,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     693,     0,     0,     0,     0,     0,     0,     0,   694,     0,
       0,     0,    50,     0,     0,  -468,     0,  5915,   695,  5917,
     696,     0,   697,   698,     0,     0,     0,     0,     0,     0,
       0,    56,     0,     0,  -136,     0,     0,     0,   699,     0,
       0,     0,     0,     0,     0,     0,   700,     0,     0,   701,
    1734,  2585,   702,     0,     0,     0,  1734,  2585,     0,     0,
       0,     0,     0,     0,     0,  -468,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4140,  4140,     0,     0,  3325,  3325,
    3325,  3325,     0,     0,  3325,  3325,  3325,  3325,  3325,  3325,
    3325,  3325,  3325,  3325,  4140,     0,     0,     0,     0,     0,
       0,   722,     0,     0,     0,  4590,  2792,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2585,     0,     0,
    2585,     0,  2585,     0,     0,  4140,  4140,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2793,     0,     0,  2585,  3325,  3325,
    2585,     0,  2585,     0,     0,     0,     0,   725,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   726,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1059,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2794,     0,     0,     0,
       0,     0,  2585,     0,     0,     0,     0,     0,     0,     0,
     729,     0,     0,     0,     0,     0,     0,     0,     0,   730,
       0,     0,     0,     0,     0,     0,     0,   197,     0,     0,
       0,     0,   731,     0,  4712,     0,     0,     0,  2795,     0,
       0,  6124,     0,  4716,     0,     0,     0,     0,     0,     0,
       0,     0,  2585,     0,     0,     0,     0,  3286,     0,     0,
       0,  4729,  3286,  3286,     0,  1062,     0,     0,  3302,     0,
       0,  4737,     0,     0,  4739,     0,     0,     0,   198,     0,
    4741,     0,  4742,     0,     0,     0,     0,  2585,     0,     0,
       0,     0,     0,     0,     0,   199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4764,
    4765,  4766,     0,   200,     0,     0,     0,     0,     0,   201,
       0,     0,     0,     0,     0,   735,     0,     0,  3346,     0,
       0,     0,     0,     0,     0,     0,  4790,   202,     0,  4793,
       0,  4795,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   203,     0,     0,     0,     0,     0,  4799,     0,     0,
     204,     0,     0,     0,     0,  4806,  4807,     0,     0,     0,
    2796,     0,  4812,   205,  6231,     0,     0,     0,     0,   206,
       0,     0,     0,     0,     0,     0,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3286,     0,     0,     0,     0,   208,   213,  2797,     0,
       0,   740,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1066,     0,
       0,  2798,     0,     0,   209,     0,     0,     0,   744,     0,
       0,     0,  4866,     0,     0,   745,     0,     0,   746,     0,
       0,     0,     0,     0,     0,     0,   210,     0,     0,  4880,
       0,     0,     0,     0,     0,     0,     0,     0,   747,  3325,
       0,     0,     0,     0,     0,     0,  1068,     0,     0,     0,
       0,     0,     0,   749,     0,     0,  1069,     0,     0,     0,
       0,   751,     0,     0,     0,     0,  6326,     0,     0,  2799,
       0,   211,     0,     0,     0,     0,  2800,     0,     0,     0,
       0,     0,     0,  2585,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   212,  1117,
    1117,     0,     0,   756,     0,     0,     0,     0,   213,   214,
       0,     0,   215,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   216,
       0,     0,   217,     0,     0,     0,   218,     0,     0,   219,
       0,     0,     0,     0,     0,     0,   220,     0,     0,   221,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   222,
       0,     0,     0,     0,     0,     0,     0,   223,     0,     0,
       0,     0,   224,     0,   225,     0,     0,   226,     0,     0,
       0,     0,   227,     0,     0,  2585,     0,     0,     0,  2585,
       0,     0,   228,     0,     0,     0,     0,   229,     0,     0,
       0,     0,  2585,     0,     0,     0,  1117,     0,     0,     0,
    2585,   230,  2585,     0,  2585,  2585,     0,     0,     0,     0,
    4140,  4140,  4140,  4140,   231,     0,     0,  4140,  4140,  4140,
    4140,  4140,  4140,  4140,  4140,  4140,  4140,  2585,  2585,  2585,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2585,     0,     0,  2585,     0,  2585,     0,
       0,     0,  2585,     0,     0,  4140,  4140,     0,     0,  2585,
    2585,     0,     0,     0,     0,  2585,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5169,  5170,     0,     0,  2585,
       0,     0,     0,     0,     0,     0,  5177,     0,     0,     0,
       0,     0,     0,  2585,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5220,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2688,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5243,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5262,
    5264,     0,     0,     0,     0,     0,  5268,  5269,     0,     0,
       0,  5270,     0,     0,     0,     0,  5271,     0,     0,  5274,
    5275,     0,     0,     0,     0,     0,  5280,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4140,     0,     0,     0,     0,     0,
       0,  5315,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5330,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5360,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2585,  2585,     0,     0,     0,     0,     0,     0,
    2585,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2585,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5411,     0,
       0,     0,     0,     0,     0,  5413,  2585,  3325,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2585,     0,  2585,     0,     0,
       0,  2585,  2585,  2585,  2585,     0,     0,  2585,  2585,     0,
       0,     0,     0,  2585,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3325,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5448,     0,     0,     0,     0,  2585,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2585,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2585,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2585,     0,  2585,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2585,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3286,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5556,     0,     0,     0,
       0,     0,  5560,  5561,  5562,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5575,  5576,     0,
       0,  5577,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5585,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5597,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5615,
       0,     0,     0,     0,     0,     0,     0,  1368,     0,  2585,
       0,  4140,  3325,  2585,  2585,  2585,  5634,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2585,  2585,
    2585,     0,     0,     0,     0,     0,     0,     0,  2585,     0,
       0,     0,     0,  3325,     0,     0,  4140,     0,     0,     0,
    2585,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2585,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2585,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5810,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3346,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2585,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4140,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2104,     0,  4140,     0,  3325,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5895,     0,     0,  2585,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2585,  5907,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2585,     0,     0,     0,
       0,     0,     0,  5943,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2585,     0,     0,     0,
       0,     0,     0,  2585,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3286,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  6023,     0,     0,     0,     0,
       0,     0,     0,     0,  6030,  6030,  6030,     0,     0,  2585,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2585,     0,     0,     0,     0,     0,
       0,     0,  5615,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6066,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6081,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3325,  3325,     0,     0,  3325,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2585,     0,  6030,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2585,     0,  5615,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4140,  4140,     0,  4140,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6257,
       0,     0,     0,     0,     0,  2585,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  6282,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   234,
       0,  1271,   717,     0,  1272,  1273,  1274,   778,  1275,     0,
       0,     0,     0,     0,     0,  6030,   235,   236,   237,   238,
     239,   240,   241,   242,   243,  1728,   244,   245,   246,     0,
       0,  6372,     0,  1276,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1277,
     260,  1278,  1279,     0,   263,   264,   265,   266,   267,   268,
     269,  1280,  1281,   270,   271,  1282,  1283,   274,     0,   275,
     276,   277,   278,  1284,     0,  1285,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
    1286,  1287,  1288,  1289,  1290,  1291,  1292,   303,   304,   305,
     306,   307,   308,  1293,  1294,   311,  1295,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,  1729,     0,   324,   325,   887,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,   337,     0,
     338,   339,   340,   341,  1296,   343,   344,   345,   346,  1297,
    1298,   348,  1734,   349,   350,   351,  1299,   353,     0,   354,
       0,   355,   356,   357,     0,   358,   359,   360,   361,   362,
       0,   363,  1300,     0,  1301,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,  1302,  1303,     0,  1304,     0,
     396,   397,   398,   399,   400,  1305,  1306,  1307,  1308,  1309,
    1310,  1311,  1312,  1313,   410,  1314,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,  1315,   421,   422,   423,
       0,   424,   425,   426,  1316,  1317,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,  1318,   438,   439,   440,
     441,   442,   443,   444,   445,  1319,   447,  1320,   449,   450,
     451,   452,   453,   454,   455,   456,   457,  1321,   459,  1322,
     460,   461,   462,   463,  1323,  1324,   465,  1325,   467,   468,
     469,   470,     0,   471,   472,   473,     0,     0,  1326,   475,
     476,     0,     0,   477,   478,   479,   480,   481,   482,  1327,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,   496,   497,   498,  1328,   500,   501,   502,
     503,   504,     0,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,  1329,   517,   518,   519,     0,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,     0,   533,   534,   535,   536,   537,   538,   539,
     540,  1330,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,  1331,   557,
     558,   559,   560,   561,   562,   563,   564,  1332,   566,     0,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,  1333,   583,     0,   584,   585,
    1334,     0,   586,   587,   588,   589,   590,   591,   592,   593,
       0,   594,  1335,  1336,     0,     0,   597,   598,  1337,   600,
    1338,  1339,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,  1340,   611,   612,   613,   614,   615,  1341,     0,
     616,   617,   618,   619,   620,   621,  1342,  1730,   623,   624,
     625,   626,   627,   628,   629,     0,     0,   630,     0,     0,
     631,   632,   633,   634,   635,   636,   637,  1343,  1344,  1345,
    1346,   642,  1347,  1348,  1349,  1350,   647,   648,   649,   650,
       0,  1351,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1352,  1353,  1731,     0,     0,     0,     0,
       0,     0,  1355,  1732,   234,     0,  1271,   717,     0,  1272,
    1273,  1274,   778,  1275,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,  1276,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1277,   260,  1278,  1279,     0,   263,
     264,   265,   266,   267,   268,   269,  1280,  1281,   270,   271,
    1282,  1283,   274,     0,   275,   276,   277,   278,  1284,     0,
    1285,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,  1286,  1287,  1288,  1289,  1290,
    1291,  1292,   303,   304,   305,   306,   307,   308,  1293,  1294,
     311,  1295,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     887,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,  1296,
     343,   344,   345,   346,  1297,  1298,   348,     0,   349,   350,
     351,  1299,   353,     0,   354,     0,   355,   356,   357,     0,
     358,   359,   360,   361,   362,     0,   363,  1300,     0,  1301,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
    1302,  1303,     0,  1304,     0,   396,   397,   398,   399,   400,
    1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,  1313,   410,
    1314,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,  1315,   421,   422,   423,     0,   424,   425,   426,  1316,
    1317,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,  1318,   438,   439,   440,   441,   442,   443,   444,   445,
    1319,   447,  1320,   449,   450,   451,   452,   453,   454,   455,
     456,   457,  1321,   459,  1322,   460,   461,   462,   463,  1323,
    1324,   465,  1325,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,  1326,   475,   476,     0,     0,   477,   478,
     479,   480,   481,   482,  1327,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,  1328,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,  1329,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
     535,   536,   537,   538,   539,   540,  1330,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,    40,   552,   553,
     554,   555,   556,  1331,   557,   558,   559,   560,   561,   562,
     563,   564,  1332,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
    1333,   583,     0,   584,   585,  1334,    44,   586,   587,   588,
     589,   590,   591,   592,   593,     0,   594,  1335,  1336,     0,
       0,   597,   598,  1337,   600,  1338,  1339,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,  1340,   611,   612,
     613,   614,   615,  1341,     0,   616,   617,   618,   619,   620,
    1206,  1342,     0,   623,   624,   625,   626,   627,   628,   629,
       0,     0,   630,     0,    49,   631,   632,   633,   634,   635,
     636,   637,  1343,  1344,  1345,  1346,   642,  1347,  1348,  1349,
    1350,   647,   648,   649,   650,     0,  1351,     0,    50,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1352,  1353,
       0,     0,     0,     0,     0,     0,     0,  1355,  5856,   234,
       0,  1271,   717,     0,  1272,  1273,  1274,   778,  1275,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,  1276,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1277,
     260,  1278,  1279,     0,   263,   264,   265,   266,   267,   268,
     269,  1280,  1281,   270,   271,  1282,  1283,   274,     0,   275,
     276,   277,   278,  1284,     0,  1285,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
    1286,  1287,  1288,  1289,  1290,  1291,  1292,   303,   304,   305,
     306,   307,   308,  1293,  1294,   311,  1295,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   887,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,   337,     0,
     338,   339,   340,   341,  1296,   343,   344,   345,   346,  1297,
    1298,   348,     0,   349,   350,   351,  1299,   353,     0,   354,
       0,   355,   356,   357,     0,   358,   359,   360,   361,   362,
       0,   363,  1300,     0,  1301,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,  1302,  1303,     0,  1304,     0,
     396,   397,   398,   399,   400,  1305,  1306,  1307,  1308,  1309,
    1310,  1311,  1312,  1313,   410,  1314,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,  1315,   421,   422,   423,
       0,   424,   425,   426,  1316,  1317,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,  1318,   438,   439,   440,
     441,   442,   443,   444,   445,  1319,   447,  1320,   449,   450,
     451,   452,   453,   454,   455,   456,   457,  1321,   459,  1322,
     460,   461,   462,   463,  1323,  1324,   465,  1325,   467,   468,
     469,   470,     0,   471,   472,   473,     0,     0,  1326,   475,
     476,     0,     0,   477,   478,   479,   480,   481,   482,  1327,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,   496,   497,   498,  1328,   500,   501,   502,
     503,   504,     0,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,  1329,   517,   518,   519,     0,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,     0,   533,   534,   535,   536,   537,   538,   539,
     540,  1330,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,  1331,   557,
     558,   559,   560,   561,   562,   563,   564,  1332,   566,     0,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,  1333,   583,     0,   584,   585,
    1334,     0,   586,   587,   588,   589,   590,   591,   592,   593,
       0,   594,  1335,  1336,     0,     0,   597,   598,  1337,   600,
    1338,  1339,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,  1340,   611,   612,   613,   614,   615,  1341,     0,
     616,   617,   618,   619,   620,   621,  1342,     0,   623,   624,
     625,   626,   627,   628,   629,     0,     0,   630,     0,     0,
     631,   632,   633,   634,   635,   636,   637,  1343,  1344,  1345,
    1346,   642,  1347,  1348,  1349,  1350,   647,   648,   649,   650,
       0,  1351,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1352,  1353,     0,     0,     0,     0,     0,
       0,     0,  1355,  3327,   234,     0,  1271,   717,     0,  1272,
    1273,  1274,   778,  1275,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,  1276,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1277,   260,  1278,  1279,     0,   263,
     264,   265,   266,   267,   268,   269,  1280,  1281,   270,   271,
    1282,  1283,   274,     0,   275,   276,   277,   278,  1284,     0,
    1285,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,  1286,  1287,  1288,  1289,  1290,
    1291,  1292,   303,   304,   305,   306,   307,   308,  1293,  1294,
     311,  1295,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     887,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,  1296,
     343,   344,   345,   346,  1297,  1298,   348,     0,   349,   350,
     351,  1299,   353,     0,   354,     0,   355,   356,   357,     0,
     358,   359,   360,   361,   362,     0,   363,  1300,     0,  1301,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
    1302,  1303,     0,  1304,     0,   396,   397,   398,   399,   400,
    1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,  1313,   410,
    1314,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,  1315,   421,   422,   423,     0,   424,   425,   426,  1316,
    1317,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,  1318,   438,   439,   440,   441,   442,   443,   444,   445,
    1319,   447,  1320,   449,   450,   451,   452,   453,   454,   455,
     456,   457,  1321,   459,  1322,   460,   461,   462,   463,  1323,
    1324,   465,  1325,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,  1326,   475,   476,     0,     0,   477,   478,
     479,   480,   481,   482,  1327,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,  1328,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,  1329,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
     535,   536,   537,   538,   539,   540,  1330,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,  1331,   557,   558,   559,   560,   561,   562,
     563,   564,  1332,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
    1333,   583,     0,   584,   585,  1334,     0,   586,   587,   588,
     589,   590,   591,   592,   593,     0,   594,  1335,  1336,     0,
       0,   597,   598,  1337,   600,  1338,  1339,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,  1340,   611,   612,
     613,   614,   615,  1341,     0,   616,   617,   618,   619,   620,
     621,  1342,     0,   623,   624,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,  1343,  1344,  1345,  1346,   642,  1347,  1348,  1349,
    1350,   647,   648,   649,   650,     0,  1351,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1352,  1353,
       0,     0,     0,     0,     0,     0,     0,  1355,  4743,   234,
       0,  1271,   717,     0,  1272,  1273,  1274,   778,  1275,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,  1276,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1277,
     260,  1278,  1279,     0,   263,   264,   265,   266,   267,   268,
     269,  1280,  1281,   270,   271,  1282,  1283,   274,     0,   275,
     276,   277,   278,  1284,     0,  1285,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
    1286,  1287,  1288,  1289,  1290,  1291,  1292,   303,   304,   305,
     306,   307,   308,  1293,  1294,   311,  1295,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   887,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,   337,     0,
     338,   339,   340,   341,  1296,   343,   344,   345,   346,  1297,
    1298,   348,     0,   349,   350,   351,  1299,   353,     0,   354,
       0,   355,   356,   357,     0,   358,   359,   360,   361,   362,
       0,   363,  1300,     0,  1301,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,  1302,  1303,     0,  1304,     0,
     396,   397,   398,   399,   400,  1305,  1306,  1307,  1308,  1309,
    1310,  1311,  1312,  1313,   410,  1314,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,  1315,   421,   422,   423,
       0,   424,   425,   426,  1316,  1317,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,  1318,   438,   439,   440,
     441,   442,   443,   444,   445,  1319,   447,  1320,   449,   450,
     451,   452,   453,   454,   455,   456,   457,  1321,   459,  1322,
     460,   461,   462,   463,  1323,  1324,   465,  1325,   467,   468,
     469,   470,     0,   471,   472,   473,     0,     0,  1326,   475,
     476,     0,     0,   477,   478,   479,   480,   481,   482,  1327,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,   496,   497,   498,  1328,   500,   501,   502,
     503,   504,     0,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,  1329,   517,   518,   519,     0,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,     0,   533,   534,   535,   536,   537,   538,   539,
     540,  1330,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,  1331,   557,
     558,   559,   560,   561,   562,   563,   564,  1332,   566,     0,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,  1333,   583,     0,   584,   585,
    1334,     0,   586,   587,   588,   589,   590,   591,   592,   593,
       0,   594,  1335,  1336,     0,     0,   597,   598,  1337,   600,
    1338,  1339,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,  1340,   611,   612,   613,   614,   615,  1341,     0,
     616,   617,   618,   619,   620,   621,  1342,     0,   623,   624,
     625,   626,   627,   628,   629,     0,     0,   630,     0,     0,
     631,   632,   633,   634,   635,   636,   637,  1343,  1344,  1345,
    1346,   642,  1347,  1348,  1349,  1350,   647,   648,   649,   650,
       0,  1351,     0,     0,     0,     0,     0,   658,     0,     0,
       0,     0,     0,  1352,  1353,     0,     0,     0,     0,     0,
       0,     0,  1355,  4809,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,  4246,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0, -1855,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0, -1855,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386, -1855,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399, -1855,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420, -1855,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446, -1855,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,   470,
       0,   471,   472,   473,     0,     0,   474,   475,   476,     0,
       0,   477,   478,   479,     0,   481,     0,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
       0,   496,   497,   498,   499,   500,   501,   502,   503,   504,
       0,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,     0,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
       0,   533,   534, -1855,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,     0,   563,   564,   565,   566,     0,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,     0,   584,   585,     0,     0,
     586,     0,   588,   589,   590,   591,   592,   593,     0,   594,
     595,   596,     0,     0,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
       0,   611,   612,   613,   614,   615,     0,     0,   616,   617,
     618,   619,   620,   621,   622,     0,   623,     0,   625,   626,
     627,   628,   629,     0,     0,   630,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,     0,     0,
       0,     0,     0,     0,     0,   879,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1467,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,     0,   880,   260,   881,   882,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   883,   884,   274,     0,   275,   276,   277,   278,     0,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,     0,     0,     0,   302,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   885,
     886,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   887,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,   337,     0,   338,   339,   340,   341,
       0,   343,   344,   345,   346,     0,     0,   348,     0,   349,
     350,   351,   888,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,     0,     0,
       0,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,  2731,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,  2732,   389,   390,   391,
     392,   889,   890,     0,   891,     0,   396,   397,   398,   399,
     400,   892,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,     0,   421,   422,   423,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   438,   439,   440,   441,   442,   443,   444,
     445,   893,   447,   894,   449,   450,   451,   452,   453,   454,
     455,   456,     0,     0,   459,     0,   460,   461,   462,   463,
       0,     0,   465,   895,   467,   468,   469,   470,     0,   471,
     472,   473,     0,     0,   474,   475,   476,     0,     0,   477,
     478,  2734,   480,   481,   482,     0,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   500,     0,   502,   503,   504,     0,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     896,   517,   518,   519,     0,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,     0,   533,
     534,   535,   536,   537,   538,   539,   540,     0,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,  2735,   560,   561,
     562,   563,   564,   898,   566,     0,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,     0,   583,     0,   584,   585,     0,     0,   586,   587,
     588,   589,   590,   591,   592,   593,     0,   594,   899,   900,
       0,     0,   597,   598,     0,   600,     0,     0,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,     0,   611,
     612,   613,   614,   615,     0,     0,   616,   617,   618,   619,
     620,     0,   901,  2736,   623,   624,   625,   626,   627,   628,
     629,     0,     0,   630,     0,     0,   631,   632,   633,   634,
     635,   636,     0,   879,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   648,   649,   650,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,  2829,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,     0,   880,   260,   881,   882,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   883,
     884,   274,     0,   275,   276,   277,   278,     0,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,     0,     0,     0,   302,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   885,   886,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   887,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,   337,     0,   338,   339,   340,   341,     0,   343,
     344,   345,   346,     0,     0,   348,     0,   349,   350,   351,
     888,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,     0,     0,     0,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,  2731,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,  2732,   389,   390,   391,   392,   889,
     890,     0,   891,     0,   396,   397,   398,   399,   400,   892,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
       0,   421,   422,   423,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   893,
     447,   894,   449,   450,   451,   452,   453,   454,   455,   456,
       0,     0,   459,     0,   460,   461,   462,   463,     0,     0,
     465,   895,   467,   468,   469,   470,     0,   471,   472,   473,
       0,     0,   474,   475,   476,     0,     0,   477,   478,  2734,
     480,   481,   482,     0,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   500,     0,   502,   503,   504,     0,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   896,   517,
     518,   519,     0,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,     0,   533,   534,   535,
     536,   537,   538,   539,   540,     0,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,  2735,   560,   561,   562,   563,
     564,   898,   566,     0,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,     0,
     583,     0,   584,   585,     0,     0,   586,   587,   588,   589,
     590,   591,   592,   593,     0,   594,   899,   900,     0,     0,
     597,   598,     0,   600,     0,     0,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,     0,   611,   612,   613,
     614,   615,     0,     0,   616,   617,   618,   619,   620,     0,
     901,  2736,   623,   624,   625,   626,   627,   628,   629,     0,
       0,   630,     0,     0,   631,   632,   633,   634,   635,   636,
       0,   234,     0,  1271,   717,     0,  1272,  1273,  1274,   778,
    1275,   648,   649,   650,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,  1276,     0,  3962,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1277,   260,  1278,  1279,     0,   263,   264,   265,   266,
     267,   268,   269,  1280,  1281,   270,   271,  1282,  1283,   274,
       0,   275,   276,   277,   278,  1284,     0,  1285,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,  1286,  1287,  1288,  1289,  1290,  1291,  1292,   303,
     304,   305,   306,   307,   308,  1293,  1294,   311,  1295,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   887,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
     337,     0,   338,   339,   340,   341,  1296,   343,   344,   345,
     346,  1297,  1298,   348,     0,   349,   350,   351,  1299,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,  1300,     0,  1301,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,   388,   389,   390,   391,   392,  1302,  1303,     0,
    1304,     0,   396,   397,   398,   399,   400,  1305,  1306,  1307,
    1308,  1309,  1310,  1311,  1312,  1313,   410,  1314,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,  1315,   421,
     422,   423,     0,   424,   425,   426,  1316,  1317,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,  1318,   438,
     439,   440,   441,   442,   443,   444,   445,  1319,   447,  1320,
     449,   450,   451,   452,   453,   454,   455,   456,   457,  1321,
     459,  1322,   460,   461,   462,   463,  1323,  1324,   465,  1325,
     467,   468,   469,   470,     0,   471,   472,   473,     0,     0,
    1326,   475,   476,     0,     0,   477,   478,   479,   480,   481,
     482,  1327,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,     0,   496,   497,   498,  1328,   500,
     501,   502,   503,   504,     0,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,  1329,   517,   518,   519,
       0,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,  3288,   533,   534,   535,   536,   537,
     538,   539,   540,  1330,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,    40,   552,   553,   554,   555,   556,
    1331,   557,   558,   559,   560,   561,   562,   563,   564,  1332,
     566,     0,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,  1333,   583,     0,
     584,   585,  1334,    44,   586,   587,   588,   589,   590,   591,
     592,   593,     0,   594,  1335,  1336,     0,     0,   597,   598,
    1337,   600,  1338,  1339,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,  1340,   611,   612,   613,   614,   615,
    1341,     0,   616,   617,   618,   619,   620,  1206,  1342,     0,
     623,   624,   625,   626,   627,   628,   629,     0,     0,   630,
       0,    49,   631,   632,   633,   634,   635,   636,   637,  1343,
    1344,  1345,  1346,   642,  1347,  1348,  1349,  1350,   647,   648,
     649,   650,     0,  1351,     0,    50,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1352,  1353,     0,     0,     0,
     234,     0,  1271,   717,  1355,  1272,  1273,  1274,   778,  1275,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1276,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1277,   260,  1278,  1279,     0,   263,   264,   265,   266,   267,
     268,   269,  1280,  1281,   270,   271,  1282,  1283,   274,     0,
     275,   276,   277,   278,  1284,     0,  1285,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,  1286,  1287,  1288,  1289,  1290,  1291,  1292,   303,   304,
     305,   306,   307,   308,  1293,  1294,   311,  1295,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   887,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,   337,
       0,   338,   339,   340,   341,  1296,   343,   344,   345,   346,
    1297,  1298,   348,     0,   349,   350,   351,  1299,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,  1300,     0,  1301,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,  1302,  1303,     0,  1304,
       0,   396,   397,   398,   399,   400,  1305,  1306,  1307,  1308,
    1309,  1310,  1311,  1312,  1313,   410,  1314,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,  1315,   421,   422,
     423,     0,   424,   425,   426,  1316,  1317,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,  1318,   438,   439,
     440,   441,   442,   443,   444,   445,  1319,   447,  1320,   449,
     450,   451,   452,   453,   454,   455,   456,   457,  1321,   459,
    1322,   460,   461,   462,   463,  1323,  1324,   465,  1325,   467,
     468,   469,   470,     0,   471,   472,   473,     0,     0,  1326,
     475,   476,     0,     0,   477,   478,   479,   480,   481,   482,
    1327,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,     0,   496,   497,   498,  1328,   500,   501,
     502,   503,   504,     0,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,  1329,   517,   518,   519,     0,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,     0,   533,   534,   535,   536,   537,   538,
     539,   540,  1330,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,    40,   552,   553,   554,   555,   556,  1331,
     557,   558,   559,   560,   561,   562,   563,   564,  1332,   566,
       0,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,  1333,   583,     0,   584,
     585,  1334,    44,   586,   587,   588,   589,   590,   591,   592,
     593,     0,   594,  1335,  1336,     0,     0,   597,   598,  1337,
     600,  1338,  1339,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,  1340,   611,   612,   613,   614,   615,  1341,
       0,   616,   617,   618,   619,   620,  1206,  1342,     0,   623,
     624,   625,   626,   627,   628,   629,     0,     0,   630,     0,
      49,   631,   632,   633,   634,   635,   636,   637,  1343,  1344,
    1345,  1346,   642,  1347,  1348,  1349,  1350,   647,   648,   649,
     650,     0,  1351,     0,    50,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1352,  1353,     0,     0,     0,   234,
       0,  1271,   717,  1355,  1272,  1273,  1274,   778,  1275,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,  1276,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1277,
     260,  1278,  1279,  3333,   263,   264,   265,   266,   267,   268,
     269,  1280,  1281,   270,   271,  1282,  1283,   274,     0,   275,
     276,   277,   278,  1284,     0,  1285,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
    1286,  1287,  1288,  1289,  1290,  1291,  1292,   303,   304,   305,
     306,   307,   308,  1293,  1294,   311,  1295,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   887,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,   337,     0,
     338,   339,   340,   341,  1296,   343,   344,   345,   346,  1297,
    1298,   348,     0,   349,   350,   351,  1299,   353,     0,   354,
       0,   355,   356,   357,  3334,   358,   359,   360,   361,   362,
       0,   363,  1300,     0,  1301,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,  1302,  1303,     0,  1304,     0,
     396,   397,   398,   399,   400,  1305,  1306,  1307,  1308,  1309,
    1310,  1311,  1312,  1313,   410,  1314,   412,   413,   414,   415,
     416,   417,   418,     0,  3335,   419,  1315,   421,   422,   423,
       0,   424,   425,   426,  1316,  1317,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,  1318,   438,   439,   440,
     441,   442,   443,   444,   445,  1319,   447,  1320,   449,   450,
     451,   452,   453,   454,   455,   456,   457,  1321,   459,  1322,
     460,   461,   462,   463,  1323,  1324,   465,  1325,   467,   468,
     469,   470,     0,   471,   472,   473,     0,     0,  1326,   475,
     476,     0,     0,   477,   478,   479,   480,   481,   482,  1327,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,   496,   497,   498,  1328,   500,   501,   502,
     503,   504,     0,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,  1329,   517,   518,   519,     0,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,     0,   533,   534,   535,   536,   537,   538,   539,
     540,  1330,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,  1331,   557,
     558,   559,   560,   561,   562,   563,   564,  1332,   566,     0,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,  1333,   583,     0,   584,   585,
    1334,     0,   586,   587,   588,   589,   590,   591,   592,   593,
       0,   594,  1335,  1336,     0,  3336,   597,   598,  1337,   600,
    1338,  1339,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,  1340,   611,   612,   613,   614,   615,  1341,     0,
     616,   617,   618,   619,   620,   621,  1342,     0,   623,   624,
     625,   626,   627,   628,   629,     0,     0,   630,     0,     0,
     631,   632,   633,   634,   635,   636,   637,  1343,  1344,  1345,
    1346,   642,  1347,  1348,  1349,  1350,   647,   648,   649,   650,
       0,  1351,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1352,  1353,     0,     0,     0,   234,     0,
    1271,   717,  1355,  1272,  1273,  1274,   778,  1275,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243, -2286,   244,   245,   246,     0,     0,
       0, -2286,  1276,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1277,   260,
    1278,  1279,     0,   263,   264,   265,   266,   267,   268,   269,
    1280,  1281,   270,   271,  1282,  1283,   274,     0,   275,   276,
     277,   278,  1284,     0,  1285,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,  1286,
    1287,  1288,  1289,  1290,  1291,  1292,   303,   304,   305,   306,
     307,   308,  1293,  1294,   311,  1295,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   887,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,   337,     0,   338,
     339,   340,   341,  1296,   343,   344,   345,   346,  1297,  1298,
     348,     0,   349,   350,   351,  1299,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,  1300,     0,  1301,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,  1302,  1303,     0,  1304,     0,   396,
     397,   398,   399,   400,  1305,  1306,  1307,  1308,  1309,  1310,
    1311,  1312,  1313,   410,  1314,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,  1315,   421,   422,   423,     0,
     424,   425,   426,  1316,  1317,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,  1318,   438,   439,   440,   441,
     442,   443,   444,   445,  1319,   447,  1320,   449,   450,   451,
     452,   453,   454,   455,   456,   457,  1321,   459,  1322,   460,
     461,   462,   463,  1323,  1324,   465,  1325,   467,   468,   469,
     470,     0,   471,   472,   473,     0,     0,  1326,   475,   476,
       0,     0,   477,   478,   479,   480,   481,   482,  1327,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,   496,   497,   498,  1328,   500,   501,   502,   503,
     504,     0,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,  1329,   517,   518,   519,     0,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,     0,   533,   534,   535,   536,   537,   538,   539,   540,
    1330,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,  1331,   557,   558,
     559,   560,   561,   562,   563,   564,  1332,   566, -2286,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,  1333,   583,     0,   584,   585,  1334,
       0,   586,   587,   588,   589,   590,   591,   592,   593,     0,
     594,  1335,  1336,     0,     0,   597,   598,  1337,   600,  1338,
    1339,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,  1340,   611,   612,   613,   614,   615,  1341,     0,   616,
     617,   618,   619,   620,   621,  1342,     0,   623,   624,   625,
     626,   627,   628,   629,     0,     0,   630,     0,     0,   631,
     632,   633,   634,   635,   636,   637,  1343,  1344,  1345,  1346,
     642,  1347,  1348,  1349,  1350,   647,   648,   649,   650,     0,
    1351,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1352,  1353,     0,     0,     0,   234,     0,  1271,
     717,  1355,  1272,  1273,  1274,   778,  1275,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243, -2284,   244,   245,   246,     0,     0,     0,
   -2284,  1276,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1277,   260,  1278,
    1279,     0,   263,   264,   265,   266,   267,   268,   269,  1280,
    1281,   270,   271,  1282,  1283,   274,     0,   275,   276,   277,
     278,  1284,     0,  1285,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,   301,  1286,  1287,
    1288,  1289,  1290,  1291,  1292,   303,   304,   305,   306,   307,
     308,  1293,  1294,   311,  1295,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   887,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,   337,     0,   338,   339,
     340,   341,  1296,   343,   344,   345,   346,  1297,  1298,   348,
       0,   349,   350,   351,  1299,   353,     0,   354,     0,   355,
     356,   357,     0,   358,   359,   360,   361,   362,     0,   363,
    1300,     0,  1301,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,   387,   388,   389,
     390,   391,   392,  1302,  1303,     0,  1304,     0,   396,   397,
     398,   399,   400,  1305,  1306,  1307,  1308,  1309,  1310,  1311,
    1312,  1313,   410,  1314,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,  1315,   421,   422,   423,     0,   424,
     425,   426,  1316,  1317,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,  1318,   438,   439,   440,   441,   442,
     443,   444,   445,  1319,   447,  1320,   449,   450,   451,   452,
     453,   454,   455,   456,   457,  1321,   459,  1322,   460,   461,
     462,   463,  1323,  1324,   465,  1325,   467,   468,   469,   470,
       0,   471,   472,   473,     0,     0,  1326,   475,   476,     0,
       0,   477,   478,   479,   480,   481,   482,  1327,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
       0,   496,   497,   498,  1328,   500,   501,   502,   503,   504,
       0,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,  1329,   517,   518,   519,     0,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
       0,   533,   534,   535,   536,   537,   538,   539,   540,  1330,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,  1331,   557,   558,   559,
     560,   561,   562,   563,   564,  1332,   566, -2284,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,  1333,   583,     0,   584,   585,  1334,     0,
     586,   587,   588,   589,   590,   591,   592,   593,     0,   594,
    1335,  1336,     0,     0,   597,   598,  1337,   600,  1338,  1339,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
    1340,   611,   612,   613,   614,   615,  1341,     0,   616,   617,
     618,   619,   620,   621,  1342,     0,   623,   624,   625,   626,
     627,   628,   629,     0,     0,   630,     0,     0,   631,   632,
     633,   634,   635,   636,   637,  1343,  1344,  1345,  1346,   642,
    1347,  1348,  1349,  1350,   647,   648,   649,   650,     0,  1351,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1352,  1353,     0,     0,     0,   234,     0,  1271,   717,
    1355,  1272,  1273,  1274,   778,  1275,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
    1276,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1277,   260,  1278,  1279,
       0,   263,   264,   265,   266,   267,   268,   269,  1280,  1281,
     270,   271,  1282,  1283,   274,     0,   275,   276,   277,   278,
    1284,     0,  1285,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,  1286,  1287,  1288,
    1289,  1290,  1291,  1292,   303,   304,   305,   306,   307,   308,
    1293,  1294,   311,  1295,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   887,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,   337,     0,   338,   339,   340,
     341,  1296,   343,   344,   345,   346,  1297,  1298,   348,     0,
     349,   350,   351,  1299,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,  1300,
       0,  1301,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,  1302,  1303,     0,  1304,     0,   396,   397,   398,
     399,   400,  1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,
    1313,   410,  1314,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,  1315,   421,   422,   423,     0,   424,   425,
     426,  1316,  1317,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,  1318,   438,   439,   440,   441,   442,   443,
     444,   445,  1319,   447,  1320,   449,   450,   451,   452,   453,
     454,   455,   456,   457,  1321,   459,  1322,   460,   461,   462,
     463,  1323,  1324,   465,  1325,   467,   468,   469,   470,     0,
     471,   472,   473,     0,     0,  1326,   475,   476,     0,     0,
     477,   478,   479,   480,   481,   482,  1327,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,     0,
     496,   497,   498,  1328,   500,   501,   502,   503,   504,     0,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,  1329,   517,   518,   519,     0,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,     0,
     533,   534,   535,   536,   537,   538,   539,   540,  1330,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,  1331,   557,   558,   559,   560,
     561,   562,   563,   564,  1332,   566,     0,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,  1333,   583,     0,   584,   585,  1334,     0,   586,
     587,   588,   589,   590,   591,   592,   593,     0,   594,  1335,
    1336,     0,     0,   597,   598,  1337,   600,  1338,  1339,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,  1340,
     611,   612,   613,   614,   615,  1341,     0,   616,   617,   618,
     619,   620,   621,  1342,     0,   623,   624,   625,   626,   627,
     628,   629,     0,     0,   630,     0,     0,   631,   632,   633,
     634,   635,   636,   637,  1343,  1344,  1345,  1346,   642,  1347,
    1348,  1349,  1350,   647,   648,   649,   650,     0,  1351,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1352,  1353,     0,     0,     0,     0,     0,  2052,  3262,  1355,
     234,     0,  1271,   717,     0,  1272,  1273,  1274,   778,  1275,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1276,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1277,   260,  1278,  1279,     0,   263,   264,   265,   266,   267,
     268,   269,  1280,  1281,   270,   271,  1282,  1283,   274,     0,
     275,   276,   277,   278,  1284,     0,  1285,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,  1286,  1287,  1288,  1289,  1290,  1291,  1292,   303,   304,
     305,   306,   307,   308,  1293,  1294,   311,  1295,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   887,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,   337,
       0,   338,   339,   340,   341,  1296,   343,   344,   345,   346,
    1297,  1298,   348,     0,   349,   350,   351,  1299,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,  1300,     0,  1301,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,  1302,  1303,     0,  1304,
       0,   396,   397,   398,   399,   400,  1305,  1306,  1307,  1308,
    1309,  1310,  1311,  1312,  1313,   410,  1314,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,  1315,   421,   422,
     423,     0,   424,   425,   426,  1316,  1317,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,  1318,   438,   439,
     440,   441,   442,   443,   444,   445,  1319,   447,  1320,   449,
     450,   451,   452,   453,   454,   455,   456,   457,  1321,   459,
    1322,   460,   461,   462,   463,  1323,  1324,   465,  1325,   467,
     468,   469,   470,     0,   471,   472,   473,     0,     0,  1326,
     475,   476,     0,     0,   477,   478,   479,   480,   481,   482,
    1327,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,     0,   496,   497,   498,  1328,   500,   501,
     502,   503,   504,     0,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,  1329,   517,   518,   519,     0,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,     0,   533,   534,   535,   536,   537,   538,
     539,   540,  1330,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,  1331,
     557,   558,   559,   560,   561,   562,   563,   564,  1332,   566,
       0,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,  1333,   583,     0,   584,
     585,  1334,     0,   586,   587,   588,   589,   590,   591,   592,
     593,     0,   594,  1335,  1336,     0,     0,   597,   598,  1337,
     600,  1338,  1339,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,  1340,   611,   612,   613,   614,   615,  1341,
       0,   616,   617,   618,   619,   620,   621,  1342,     0,   623,
     624,   625,   626,   627,   628,   629,     0,     0,   630,     0,
       0,   631,   632,   633,   634,   635,   636,   637,  1343,  1344,
    1345,  1346,   642,  1347,  1348,  1349,  1350,   647,   648,   649,
     650,     0,  1351,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1352,  1353,  1354,     0,     0,   234,
       0,  1271,   717,  1355,  1272,  1273,  1274,   778,  1275,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,  2698,   244,   245,   246,     0,
       0,     0,     0,  1276,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1277,
     260,  1278,  1279,     0,   263,   264,   265,   266,   267,   268,
     269,  1280,  1281,   270,   271,  1282,  1283,   274,     0,   275,
     276,   277,   278,  1284,     0,  1285,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
    1286,  1287,  1288,  1289,  1290,  1291,  1292,   303,   304,   305,
     306,   307,   308,  1293,  1294,   311,  1295,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   887,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,   337,     0,
     338,   339,   340,   341,  1296,   343,   344,   345,   346,  1297,
    1298,   348,     0,   349,   350,   351,  1299,   353,     0,   354,
       0,   355,   356,   357,     0,   358,   359,   360,   361,   362,
       0,   363,  1300,     0,  1301,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,  1302,  1303,     0,  1304,     0,
     396,   397,   398,   399,   400,  1305,  1306,  1307,  1308,  1309,
    1310,  1311,  1312,  1313,   410,  1314,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,  1315,   421,   422,   423,
       0,   424,   425,   426,  1316,  1317,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,  1318,   438,   439,   440,
     441,   442,   443,   444,   445,  1319,   447,  1320,   449,   450,
     451,   452,   453,   454,   455,   456,   457,  1321,   459,  1322,
     460,   461,   462,   463,  1323,  1324,   465,  1325,   467,   468,
     469,   470,     0,   471,   472,   473,     0,     0,  1326,   475,
     476,     0,     0,   477,   478,   479,   480,   481,   482,  1327,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,   496,   497,   498,  1328,   500,   501,   502,
     503,   504,     0,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,  1329,   517,   518,   519,     0,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,     0,   533,   534,   535,   536,   537,   538,   539,
     540,  1330,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,  1331,   557,
     558,   559,   560,   561,   562,   563,   564,  1332,   566,     0,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,  1333,   583,     0,   584,   585,
    1334,     0,   586,   587,   588,   589,   590,   591,   592,   593,
       0,   594,  1335,  1336,     0,     0,   597,   598,  1337,   600,
    1338,  1339,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,  1340,   611,   612,   613,   614,   615,  1341,     0,
     616,   617,   618,   619,   620,   621,  1342,     0,   623,   624,
     625,   626,   627,   628,   629,     0,     0,   630,     0,     0,
     631,   632,   633,   634,   635,   636,   637,  1343,  1344,  1345,
    1346,   642,  1347,  1348,  1349,  1350,   647,   648,   649,   650,
       0,  1351,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1352,  1353,     0,     0,     0,   234,     0,
    1271,   717,  1355,  1272,  1273,  1274,   778,  1275,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,  1276,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1277,   260,
    1278,  1279,     0,   263,   264,   265,   266,   267,   268,   269,
    1280,  1281,   270,   271,  1282,  1283,   274,     0,   275,   276,
     277,   278,  1284,     0,  1285,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,  1286,
    1287,  1288,  1289,  1290,  1291,  1292,   303,   304,   305,   306,
     307,   308,  1293,  1294,   311,  1295,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   887,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,   337,     0,   338,
     339,   340,   341,  1296,   343,   344,   345,   346,  1297,  1298,
     348,     0,   349,   350,   351,  1299,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,  1300,     0,  1301,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,  1302,  1303,     0,  1304,     0,   396,
     397,   398,   399,   400,  1305,  1306,  1307,  1308,  1309,  1310,
    1311,  1312,  1313,   410,  1314,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,  1315,   421,   422,   423,     0,
     424,   425,   426,  1316,  1317,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,  1318,   438,   439,   440,   441,
     442,   443,   444,   445,  1319,   447,  1320,   449,   450,   451,
     452,   453,   454,   455,   456,   457,  1321,   459,  1322,   460,
     461,   462,   463,  1323,  1324,   465,  1325,   467,   468,   469,
     470,     0,   471,   472,   473,     0,     0,  1326,   475,   476,
       0,     0,   477,   478,   479,   480,   481,   482,  1327,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,   496,   497,   498,  1328,   500,   501,   502,   503,
     504,     0,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,  1329,   517,   518,   519,     0,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,  3288,   533,   534,   535,   536,   537,   538,   539,   540,
    1330,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,  1331,   557,   558,
     559,   560,   561,   562,   563,   564,  1332,   566,     0,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,  1333,   583,     0,   584,   585,  1334,
       0,   586,   587,   588,   589,   590,   591,   592,   593,     0,
     594,  1335,  1336,     0,     0,   597,   598,  1337,   600,  1338,
    1339,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,  1340,   611,   612,   613,   614,   615,  1341,     0,   616,
     617,   618,   619,   620,   621,  1342,     0,   623,   624,   625,
     626,   627,   628,   629,     0,     0,   630,     0,     0,   631,
     632,   633,   634,   635,   636,   637,  1343,  1344,  1345,  1346,
     642,  1347,  1348,  1349,  1350,   647,   648,   649,   650,     0,
    1351,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1352,  1353,     0,     0,     0,   234,     0,  1271,
     717,  1355,  1272,  1273,  1274,   778,  1275,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,  1276,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1277,   260,  1278,
    1279,     0,   263,   264,   265,   266,   267,   268,   269,  1280,
    1281,   270,   271,  1282,  1283,   274,     0,   275,   276,   277,
     278,  1284,     0,  1285,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,   301,  1286,  1287,
    1288,  1289,  1290,  1291,  1292,   303,   304,   305,   306,   307,
     308,  1293,  1294,   311,  1295,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   887,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,   337,     0,   338,   339,
     340,   341,  1296,   343,   344,   345,   346,  1297,  1298,   348,
       0,   349,   350,   351,  1299,   353,     0,   354,     0,   355,
     356,   357,     0,   358,   359,   360,   361,   362,     0,   363,
    1300,     0,  1301,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,   387,   388,   389,
     390,   391,   392,  1302,  1303,     0,  1304,     0,   396,   397,
     398,   399,   400,  1305,  1306,  1307,  1308,  1309,  1310,  1311,
    1312,  1313,   410,  1314,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,  1315,   421,   422,   423,     0,   424,
     425,   426,  1316,  1317,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,  1318,   438,   439,   440,   441,   442,
     443,   444,   445,  1319,   447,  1320,   449,   450,   451,   452,
     453,   454,   455,   456,   457,  1321,   459,  1322,   460,   461,
     462,   463,  1323,  1324,   465,  1325,   467,   468,   469,   470,
       0,   471,   472,   473,     0,     0,  1326,   475,   476,     0,
       0,   477,   478,   479,   480,   481,   482,  1327,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
       0,   496,   497,   498,  1328,   500,   501,   502,   503,   504,
       0,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,  1329,   517,   518,   519,     0,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
       0,   533,   534,   535,   536,   537,   538,   539,   540,  1330,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,  1331,   557,   558,   559,
     560,   561,   562,   563,   564,  1332,   566,     0,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,  1333,   583,     0,   584,   585,  1334,     0,
     586,   587,   588,   589,   590,   591,   592,   593,     0,   594,
    1335,  1336,     0,     0,   597,   598,  1337,   600,  1338,  1339,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
    1340,   611,   612,   613,   614,   615,  1341,     0,   616,   617,
     618,   619,   620,   621,  1342,  3841,   623,   624,   625,   626,
     627,   628,   629,     0,     0,   630,     0,     0,   631,   632,
     633,   634,   635,   636,   637,  1343,  1344,  1345,  1346,   642,
    1347,  1348,  1349,  1350,   647,   648,   649,   650,     0,  1351,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1352,  1353,     0,     0,     0,   234,     0,  1271,   717,
    1355,  1272,  1273,  1274,   778,  1275,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
    1276,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1277,   260,  1278,  1279,
       0,   263,   264,   265,   266,   267,   268,   269,  1280,  1281,
     270,   271,  1282,  1283,   274,     0,   275,   276,   277,   278,
    1284,     0,  1285,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,  1286,  1287,  1288,
    1289,  1290,  1291,  1292,   303,   304,   305,   306,   307,   308,
    1293,  1294,   311,  1295,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   887,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,   337,     0,   338,   339,   340,
     341,  1296,   343,   344,   345,   346,  1297,  1298,   348,     0,
     349,   350,   351,  1299,   353,     0,   354,     0,   355,   356,
     357,  3334,   358,   359,   360,   361,   362,     0,   363,  1300,
       0,  1301,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,  1302,  1303,     0,  1304,     0,   396,   397,   398,
     399,   400,  1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,
    1313,   410,  1314,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,  1315,   421,   422,   423,     0,   424,   425,
     426,  1316,  1317,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,  1318,   438,   439,   440,   441,   442,   443,
     444,   445,  1319,   447,  1320,   449,   450,   451,   452,   453,
     454,   455,   456,   457,  1321,   459,  1322,   460,   461,   462,
     463,  1323,  1324,   465,  1325,   467,   468,   469,   470,     0,
     471,   472,   473,     0,     0,  1326,   475,   476,     0,     0,
     477,   478,   479,   480,   481,   482,  1327,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,     0,
     496,   497,   498,  1328,   500,   501,   502,   503,   504,     0,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,  1329,   517,   518,   519,     0,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,     0,
     533,   534,   535,   536,   537,   538,   539,   540,  1330,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,  1331,   557,   558,   559,   560,
     561,   562,   563,   564,  1332,   566,     0,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,  1333,   583,     0,   584,   585,  1334,     0,   586,
     587,   588,   589,   590,   591,   592,   593,     0,   594,  1335,
    1336,     0,     0,   597,   598,  1337,   600,  1338,  1339,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,  1340,
     611,   612,   613,   614,   615,  1341,     0,   616,   617,   618,
     619,   620,   621,  1342,     0,   623,   624,   625,   626,   627,
     628,   629,     0,     0,   630,     0,     0,   631,   632,   633,
     634,   635,   636,   637,  1343,  1344,  1345,  1346,   642,  1347,
    1348,  1349,  1350,   647,   648,   649,   650,     0,  1351,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1352,  1353,     0,     0,     0,   234,     0,  1271,   717,  1355,
    1272,  1273,  1274,   778,  1275,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,  1276,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1277,   260,  1278,  1279,     0,
     263,   264,   265,   266,   267,   268,   269,  1280,  1281,   270,
     271,  1282,  1283,   274,     0,   275,   276,   277,   278,  1284,
       0,  1285,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,  1286,  1287,  1288,  1289,
    1290,  1291,  1292,   303,   304,   305,   306,   307,   308,  1293,
    1294,   311,  1295,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   887,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,   337,     0,   338,   339,   340,   341,
    1296,   343,   344,   345,   346,  1297,  1298,   348,     0,   349,
     350,   351,  1299,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,  1300,     0,
    1301,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,  1302,  1303,     0,  1304,     0,   396,   397,   398,   399,
     400,  1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,  1313,
     410,  1314,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,  1315,   421,   422,   423,     0,   424,   425,   426,
    1316,  1317,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,  1318,   438,   439,   440,   441,   442,   443,   444,
     445,  1319,   447,  1320,   449,   450,   451,   452,   453,   454,
     455,   456,   457,  1321,   459,  1322,   460,   461,   462,   463,
    1323,  1324,   465,  1325,   467,   468,   469,   470,     0,   471,
     472,   473,     0,     0,  1326,   475,   476,     0,     0,   477,
     478,   479,   480,   481,   482,  1327,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,     0,   496,
     497,   498,  1328,   500,   501,   502,   503,   504,     0,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
    1329,   517,   518,   519,     0,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,     0,   533,
     534,   535,   536,   537,   538,   539,   540,  1330,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,  1331,   557,   558,   559,   560,   561,
     562,   563,   564,  1332,   566,     0,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,  1333,   583,     0,   584,   585,  1334,     0,   586,   587,
     588,   589,   590,   591,   592,   593,     0,   594,  1335,  1336,
    3391,     0,   597,   598,  1337,   600,  1338,  1339,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,  1340,   611,
     612,   613,   614,   615,  1341,     0,   616,   617,   618,   619,
     620,   621,  1342,     0,   623,   624,   625,   626,   627,   628,
     629,     0,     0,   630,     0,     0,   631,   632,   633,   634,
     635,   636,   637,  1343,  1344,  1345,  1346,   642,  1347,  1348,
    1349,  1350,   647,   648,   649,   650,     0,  1351,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1352,
    1353,     0,     0,     0,   234,     0,  1271,   717,  1355,  1272,
    1273,  1274,   778,  1275,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,  1276,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1277,   260,  1278,  1279,     0,   263,
     264,   265,   266,   267,   268,   269,  1280,  1281,   270,   271,
    1282,  1283,   274,     0,   275,   276,   277,   278,  1284,     0,
    1285,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,  1286,  1287,  1288,  1289,  1290,
    1291,  1292,   303,   304,   305,   306,   307,   308,  1293,  1294,
     311,  1295,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     887,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,  1296,
     343,   344,   345,   346,  1297,  1298,   348,     0,   349,   350,
     351,  1299,   353,     0,   354,     0,   355,   356,   357,     0,
     358,   359,   360,   361,   362,     0,   363,  1300,     0,  1301,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
    1302,  1303,     0,  1304,     0,   396,   397,   398,   399,   400,
    1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,  1313,   410,
    1314,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,  1315,   421,   422,   423,     0,   424,   425,   426,  1316,
    1317,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,  1318,   438,   439,   440,   441,   442,   443,   444,   445,
    1319,   447,  1320,   449,   450,   451,   452,   453,   454,   455,
     456,   457,  1321,   459,  1322,   460,   461,   462,   463,  1323,
    1324,   465,  1325,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,  1326,   475,   476,     0,     0,   477,   478,
     479,   480,   481,   482,  1327,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,  1328,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,  1329,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
     535,   536,   537,   538,   539,   540,  1330,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,  1331,   557,   558,   559,   560,   561,   562,
     563,   564,  1332,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
    1333,   583,     0,   584,   585,  1334,     0,   586,   587,   588,
     589,   590,   591,   592,   593,     0,   594,  1335,  1336,     0,
       0,   597,   598,  1337,   600,  1338,  1339,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,  1340,   611,   612,
     613,   614,   615,  1341,     0,   616,   617,   618,   619,   620,
     621,  1342,     0,   623,   624,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,  1343,  1344,  1345,  1346,   642,  1347,  1348,  1349,
    1350,   647,   648,   649,   650,     0,  1351,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1352,  1353,
       0,     0,     0,   234,     0,  1271,   717,  1355,  1272,  1273,
    1274,   778,  1275,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1276,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1277,   260,  1278,  1279,     0,   263,   264,
     265,   266,   267,   268,   269,  1280,  1281,   270,   271,  1282,
    1283,   274,     0,   275,   276,   277,   278,  1284,     0,  1285,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,  1286,  1287,  1288,  1289,  1290,  1291,
    1292,   303,   304,   305,   306,   307,   308,  1293,  1294,   311,
    1295,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   887,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,   337,     0,   338,   339,   340,   341,  1296,   343,
     344,   345,   346,  1297,  1298,   348,     0,   349,   350,   351,
    1299,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,  1300,     0,  1301,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,  1302,
    1303,     0,  1304,     0,   396,   397,   398,   399,   400,  1305,
    1306,  1307,  1308,  1309,  1310,  1311,  1312,  1313,   410,  1314,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
    1315,   421,   422,   423,     0,   424,   425,   426,  1316,  1317,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
    1318,   438,   439,   440,   441,   442,   443,   444,   445,  1319,
     447,  1320,   449,   450,   451,   452,   453,   454,   455,   456,
     457,  1321,   459,  1322,   460,   461,   462,   463,  1323,  1324,
     465,  1325,   467,   468,   469,   470,     0,   471,   472,   473,
       0,     0,  1326,   475,   476,     0,     0,   477,   478,   479,
     480,   481,   482,  1327,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,   496,   497,   498,
    1328,   500,   501,   502,   503,   504,     0,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,  1329,   517,
     518,   519,     0,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,     0,   533,   534,   535,
     536,   537,   538,   539,   540,  1330,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,  1331,   557,   558,   559,   560,   561,   562,   563,
     564,  1332,   566,     0,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,  1333,
     583,     0,   584,   585,  1334,     0,   586,   587,   588,   589,
     590,   591,   592,   593,     0,   594,  1335,  1336,     0,     0,
     597,   598,  1337,   600,  1338,  1339,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,  1340,   611,   612,   613,
     614,   615,  1341,     0,   616,   617,   618,   619,   620,   621,
    1342,     0,   623,   624,   625,   626,   627,   628,   629,     0,
       0,   630,     0,     0,   631,   632,   633,   634,   635,   636,
     637,  1343,  1344,  1345,  1346,   642,  1347,  1348,  1349,  1350,
     647,   648,   649,   650,     0,  1351,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2701,  2702,     0,
       0,     0,   234,     0,  3510,   717,  1355,  1272,  1273,  1274,
     778,  1275,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,  1276,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1277,   260,  1278,  1279,     0,   263,   264,   265,
     266,   267,   268,   269,  1280,  1281,   270,   271,  1282,  1283,
     274,     0,   275,   276,   277,   278,  1284,     0,  1285,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,  1286,  1287,  1288,  1289,  1290,  1291,  1292,
     303,   304,   305,   306,   307,   308,  1293,  1294,   311,  1295,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   887,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,   337,     0,   338,   339,   340,   341,  1296,   343,   344,
     345,   346,  1297,  1298,   348,     0,   349,   350,   351,  1299,
     353,     0,   354,     0,   355,   356,   357,     0,   358,   359,
     360,   361,   362,     0,   363,  1300,     0,  1301,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,  1302,  1303,
       0,  1304,     0,   396,   397,   398,   399,   400,  1305,  1306,
    1307,  1308,  1309,  1310,  1311,  1312,  1313,   410,  1314,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,  1315,
     421,   422,   423,     0,   424,   425,   426,  1316,  1317,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,  1318,
     438,   439,   440,   441,   442,   443,   444,   445,  1319,   447,
    1320,   449,   450,   451,   452,   453,   454,   455,   456,   457,
    1321,   459,  1322,   460,   461,   462,   463,  1323,  1324,   465,
    1325,   467,   468,   469,   470,     0,   471,   472,   473,     0,
       0,  1326,   475,   476,     0,     0,   477,   478,   479,   480,
     481,   482,  1327,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,     0,   496,   497,   498,  1328,
     500,   501,   502,   503,   504,     0,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,  1329,   517,   518,
     519,     0,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,     0,   533,   534,   535,   536,
     537,   538,   539,   540,  1330,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,  1331,   557,   558,   559,   560,   561,   562,   563,   564,
    1332,   566,     0,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,  1333,   583,
       0,   584,   585,  1334,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,  1335,  1336,     0,     0,   597,
     598,  1337,   600,  1338,  1339,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,  1340,   611,   612,   613,   614,
     615,  1341,     0,   616,   617,   618,   619,   620,   621,  1342,
       0,   623,   624,   625,   626,   627,   628,   629,     0,     0,
     630,     0,     0,   631,   632,   633,   634,   635,   636,   637,
    1343,  1344,  1345,  1346,   642,  1347,  1348,  1349,  1350,   647,
     648,   649,   650,     0,  1351,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1352,  1353,     0,     0,
       0,   234,     0,  1271,   717,  1355,  1272,  1273,  1274,   778,
    1275,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,  1276,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1277,   260,  1278,  1279,     0,   263,   264,   265,   266,
     267,   268,   269,  1280,  1281,   270,   271,  1282,  1283,   274,
       0,   275,   276,   277,   278,  1284,     0,  1285,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,  4865,  1286,  1287,  1288,  1289,  1290,  1291,  1292,   303,
     304,   305,   306,   307,   308,  1293,  1294,   311,  1295,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   887,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
     337,     0,   338,   339,   340,   341,  1296,   343,   344,   345,
     346,  1297,  1298,   348,     0,   349,   350,   351,  1299,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,  1300,     0,  1301,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,   388,   389,   390,   391,   392,  1302,  1303,     0,
    1304,     0,   396,   397,   398,   399,   400,  1305,  1306,  1307,
    1308,  1309,  1310,  1311,  1312,  1313,   410,  1314,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,  1315,   421,
     422,   423,     0,   424,   425,   426,  1316,  1317,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,  1318,   438,
     439,   440,   441,   442,   443,   444,   445,  1319,   447,  1320,
     449,   450,   451,   452,   453,   454,   455,   456,   457,  1321,
     459,  1322,   460,   461,   462,   463,  1323,  1324,   465,  1325,
     467,   468,   469,   470,     0,   471,   472,   473,     0,     0,
    1326,   475,   476,     0,     0,   477,   478,   479,   480,   481,
     482,  1327,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,     0,   496,   497,   498,  1328,   500,
     501,   502,   503,   504,     0,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,  1329,   517,   518,   519,
       0,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     0,   533,   534,   535,   536,   537,
     538,   539,   540,  1330,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
    1331,   557,   558,   559,   560,   561,   562,   563,   564,  1332,
     566,     0,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,  1333,   583,     0,
     584,   585,  1334,     0,   586,   587,   588,   589,   590,   591,
     592,   593,     0,   594,  1335,  1336,     0,     0,   597,   598,
    1337,   600,  1338,  1339,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,  1340,   611,   612,   613,   614,   615,
    1341,     0,   616,   617,   618,   619,   620,   621,  1342,     0,
     623,   624,   625,   626,   627,   628,   629,     0,     0,   630,
       0,     0,   631,   632,   633,   634,   635,   636,   637,  1343,
    1344,  1345,  1346,   642,  1347,  1348,  1349,  1350,   647,   648,
     649,   650,     0,  1351,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1352,  1353,     0,     0,     0,
     234,     0,  1271,   717,  1355,  1272,  1273,  1274,   778,  1275,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1276,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1277,   260,  1278,  1279,     0,   263,   264,   265,   266,   267,
     268,   269,  1280,  1281,   270,   271,  1282,  1283,   274,     0,
     275,   276,   277,   278,  1284,     0,  1285,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,  1286,  1287,  1288,  1289,  1290,  1291,  1292,   303,   304,
     305,   306,   307,   308,  1293,  1294,   311,  1295,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   887,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,   337,
       0,   338,   339,   340,   341,  1296,   343,   344,   345,   346,
    1297,  1298,   348,     0,   349,   350,   351,  1299,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,  1300,     0,  1301,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,  1302,  1303,     0,  1304,
       0,   396,   397,   398,   399,   400,  1305,  1306,  1307,  1308,
    1309,  1310,  1311,  1312,  1313,   410,  1314,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,  1315,   421,   422,
     423,     0,   424,   425,   426,  1316,  1317,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,  1318,   438,   439,
     440,   441,   442,   443,   444,   445,  1319,   447,  1320,   449,
     450,   451,   452,   453,   454,   455,   456,   457,  1321,   459,
    1322,   460,   461,   462,   463,  1323,  1324,   465,  1325,   467,
     468,   469,   470,     0,   471,   472,   473,     0,     0,  1326,
     475,   476,     0,     0,   477,   478,   479,   480,   481,   482,
    1327,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,     0,   496,   497,   498,  1328,   500,   501,
     502,   503,   504,     0,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,  1329,   517,   518,   519,     0,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,     0,   533,   534,   535,   536,   537,   538,
     539,   540,  1330,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,  1331,
     557,   558,   559,   560,   561,   562,   563,   564,  1332,   566,
       0,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,  1333,   583,     0,   584,
     585,  1334,     0,   586,   587,   588,   589,   590,   591,   592,
     593,     0,   594,  1335,  1336,     0,     0,   597,   598,  1337,
     600,  1338,  1339,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,  1340,   611,   612,   613,   614,   615,  1341,
       0,   616,   617,   618,   619,   620,   621,  1342,     0,   623,
     624,   625,   626,   627,   628,   629,     0,     0,   630,     0,
       0,   631,   632,   633,   634,   635,   636,  5251,  1343,  1344,
    1345,  1346,   642,  1347,  1348,  1349,  1350,   647,   648,   649,
     650,     0,  1351,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1352,  1353,     0,     0,     0,   234,
       0,  1271,   717,  1355,  1272,  1273,  1274,   778,  1275,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,  1276,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1277,
     260,  1278,  1279,     0,   263,   264,   265,   266,   267,   268,
     269,  1280,  1281,   270,   271,  1282,  1283,   274,     0,   275,
     276,   277,   278,  1284,     0,  1285,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
    1286,  1287,  1288,  1289,  1290,  1291,  1292,   303,   304,   305,
     306,   307,   308,  1293,  1294,   311,  1295,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   887,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,   337,     0,
     338,   339,   340,   341,  1296,   343,   344,   345,   346,  1297,
    1298,   348,     0,   349,   350,   351,  1299,   353,     0,   354,
       0,   355,   356,   357,     0,   358,   359,   360,   361,   362,
       0,   363,  1300,     0,  1301,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,  1302,  1303,     0,  1304,     0,
     396,   397,   398,   399,   400,  1305,  1306,  1307,  1308,  1309,
    1310,  1311,  1312,  1313,   410,  1314,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,  1315,   421,   422,   423,
       0,   424,   425,   426,  1316,  1317,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,  1318,   438,   439,   440,
     441,   442,   443,   444,   445,  1319,   447,  1320,   449,   450,
     451,   452,   453,   454,   455,  5263,   457,  1321,   459,  1322,
     460,   461,   462,   463,  1323,  1324,   465,  1325,   467,   468,
     469,   470,     0,   471,   472,   473,     0,     0,  1326,   475,
     476,     0,     0,   477,   478,   479,   480,   481,   482,  1327,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,   496,   497,   498,  1328,   500,   501,   502,
     503,   504,     0,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,  1329,   517,   518,   519,     0,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,     0,   533,   534,   535,   536,   537,   538,   539,
     540,  1330,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,  1331,   557,
     558,   559,   560,   561,   562,   563,   564,  1332,   566,     0,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,  1333,   583,     0,   584,   585,
    1334,     0,   586,   587,   588,   589,   590,   591,   592,   593,
       0,   594,  1335,  1336,     0,     0,   597,   598,  1337,   600,
    1338,  1339,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,  1340,   611,   612,   613,   614,   615,  1341,     0,
     616,   617,   618,   619,   620,   621,  1342,     0,   623,   624,
     625,   626,   627,   628,   629,     0,     0,   630,     0,     0,
     631,   632,   633,   634,   635,   636,   637,  1343,  1344,  1345,
    1346,   642,  1347,  1348,  1349,  1350,   647,   648,   649,   650,
       0,  1351,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1352,  1353,     0,     0,     0,   234,     0,
    1271,   717,  1355,  1272,  1273,  1274,   778,  1275,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,  1276,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1277,   260,
    1278,  1279,     0,   263,   264,   265,   266,   267,   268,   269,
    1280,  1281,   270,   271,  1282,  1283,   274,     0,   275,   276,
     277,   278,  1284,     0,  1285,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,  5605,   301,  1286,
    1287,  1288,  1289,  1290,  1291,  1292,   303,   304,   305,   306,
     307,   308,  1293,  1294,   311,  1295,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   887,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,   337,     0,   338,
     339,   340,   341,  1296,   343,   344,   345,   346,  1297,  1298,
     348,     0,   349,   350,   351,  1299,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,  1300,     0,  5606,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,  1302,  1303,     0,  1304,     0,   396,
     397,   398,   399,   400,  1305,  1306,  1307,  1308,  1309,  1310,
    1311,  1312,  1313,   410,  1314,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,  1315,   421,   422,   423,     0,
     424,   425,   426,  1316,  1317,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,  1318,   438,   439,   440,   441,
     442,   443,   444,   445,  1319,   447,  1320,   449,   450,   451,
     452,   453,   454,   455,   456,   457,  1321,   459,  1322,   460,
     461,   462,   463,  1323,  1324,   465,  1325,   467,   468,   469,
     470,     0,   471,   472,   473,     0,     0,  1326,   475,   476,
       0,     0,   477,   478,   479,   480,   481,   482,  1327,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,   496,   497,   498,  1328,   500,   501,   502,   503,
     504,     0,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,  1329,   517,   518,   519,     0,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,     0,   533,   534,   535,   536,   537,  5607,   539,   540,
    1330,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,  1331,   557,   558,
     559,   560,   561,   562,   563,   564,  1332,   566,     0,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,  1333,   583,     0,   584,   585,  1334,
       0,   586,   587,   588,   589,   590,   591,   592,   593,     0,
     594,  1335,  1336,     0,     0,   597,   598,  1337,   600,  1338,
    1339,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,  1340,   611,   612,   613,   614,   615,  1341,     0,   616,
     617,   618,   619,   620,   621,  1342,     0,   623,   624,   625,
     626,   627,   628,   629,     0,     0,   630,     0,     0,   631,
     632,   633,   634,   635,   636,   637,  1343,  1344,  1345,  1346,
     642,  1347,  1348,  1349,  1350,   647,   648,   649,   650,     0,
    1351,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1352,  1353,     0,     0,     0,   234,     0,  1271,
     717,  5608,  1272,  1273,  1274,   778,  1275,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,  1276,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,  6027,  1277,   260,  1278,
    1279,     0,   263,   264,   265,   266,   267,   268,   269,  1280,
    1281,   270,   271,  1282,  1283,   274,     0,   275,   276,   277,
     278,  1284,     0,  1285,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,  6028,  1286,  1287,
    1288,  1289,  1290,  1291,  1292,   303,   304,   305,   306,   307,
     308,  1293,  1294,   311,  1295,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   887,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,   337,     0,   338,   339,
     340,   341,  1296,   343,   344,   345,   346,  1297,  1298,   348,
       0,   349,   350,   351,  1299,   353,     0,   354,     0,   355,
     356,   357,     0,   358,   359,   360,   361,   362,     0,   363,
    1300,     0,  1301,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,   387,   388,   389,
     390,   391,   392,  1302,  1303,     0,  1304,     0,   396,   397,
     398,   399,   400,  1305,  1306,  1307,  1308,  1309,  1310,  1311,
    1312,  1313,   410,  1314,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,  1315,   421,   422,   423,     0,   424,
     425,   426,  1316,  1317,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,  1318,   438,   439,   440,   441,   442,
     443,   444,   445,  1319,   447,  1320,   449,   450,   451,   452,
     453,   454,   455,   456,   457,  1321,   459,  1322,   460,   461,
     462,   463,  1323,  1324,   465,  1325,   467,   468,   469,   470,
       0,   471,   472,   473,     0,     0,  1326,   475,   476,     0,
       0,   477,   478,   479,   480,   481,   482,  1327,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
       0,   496,   497,   498,  1328,   500,   501,   502,   503,   504,
       0,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,  1329,   517,   518,   519,     0,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
       0,   533,   534,   535,   536,   537,   538,   539,   540,  1330,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,  1331,   557,   558,   559,
     560,   561,   562,   563,   564,  1332,   566,     0,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,  1333,   583,     0,   584,   585,  1334,     0,
     586,   587,   588,   589,   590,   591,   592,   593,     0,   594,
    1335,  1336,     0,     0,   597,   598,  1337,   600,  1338,  1339,
     602,   603,   604,   605,   606,  6029,   608,   609,   610,     0,
    1340,   611,   612,   613,   614,   615,  1341,     0,   616,   617,
     618,   619,   620,   621,  1342,     0,   623,   624,   625,   626,
     627,   628,   629,     0,     0,   630,     0,     0,   631,   632,
     633,   634,   635,   636,   637,  1343,  1344,  1345,  1346,   642,
    1347,  1348,  1349,  1350,   647,   648,   649,   650,     0,  1351,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1352,  1353,     0,     0,     0,   234,     0,  1271,   717,
    1355,  1272,  1273,  1274,   778,  1275,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
    1276,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1277,   260,  1278,  1279,
       0,   263,   264,   265,   266,   267,   268,   269,  1280,  1281,
     270,   271,  1282,  1283,   274,     0,   275,   276,   277,   278,
    1284,     0,  1285,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,  6028,  1286,  1287,  1288,
    1289,  1290,  1291,  1292,   303,   304,   305,   306,   307,   308,
    1293,  1294,   311,  1295,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   887,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,   337,     0,   338,   339,   340,
     341,  1296,   343,   344,   345,   346,  1297,  1298,   348,     0,
     349,   350,   351,  1299,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,  1300,
       0,  1301,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,  1302,  1303,     0,  1304,     0,   396,   397,   398,
     399,   400,  1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,
    1313,   410,  1314,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,  1315,   421,   422,   423,     0,   424,   425,
     426,  1316,  1317,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,  1318,   438,   439,   440,   441,   442,   443,
     444,   445,  1319,   447,  1320,   449,   450,   451,   452,   453,
     454,   455,   456,   457,  1321,   459,  1322,   460,   461,   462,
     463,  1323,  1324,   465,  1325,   467,   468,   469,   470,     0,
     471,   472,   473,     0,     0,  1326,   475,   476,     0,     0,
     477,   478,   479,   480,   481,   482,  1327,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,     0,
     496,   497,   498,  1328,   500,   501,   502,   503,   504,     0,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,  1329,   517,   518,   519,     0,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,     0,
     533,   534,   535,   536,   537,   538,   539,   540,  1330,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,  1331,   557,   558,   559,   560,
     561,   562,   563,   564,  1332,   566,     0,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,  1333,   583,     0,   584,   585,  1334,     0,   586,
     587,   588,   589,   590,   591,   592,   593,     0,   594,  1335,
    1336,     0,     0,   597,   598,  1337,   600,  1338,  1339,   602,
     603,   604,   605,   606,  6029,   608,   609,   610,     0,  1340,
     611,   612,   613,   614,   615,  1341,     0,   616,   617,   618,
     619,   620,   621,  1342,     0,   623,   624,   625,   626,   627,
     628,   629,     0,     0,   630,     0,     0,   631,   632,   633,
     634,   635,   636,   637,  1343,  1344,  1345,  1346,   642,  1347,
    1348,  1349,  1350,   647,   648,   649,   650,     0,  1351,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1352,  1353,     0,     0,     0,   234,     0,  1271,   717,  1355,
    1272,  1273,  1274,   778,  1275,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,  1276,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1277,   260,  1278,  1279,     0,
     263,   264,   265,   266,   267,   268,   269,  1280,  1281,   270,
     271,  1282,  1283,   274,     0,   275,   276,   277,   278,  1284,
       0,  1285,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,  1286,  1287,  1288,  1289,
    1290,  1291,  1292,   303,   304,   305,   306,   307,   308,  1293,
    1294,   311,  5590,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   887,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,   337,     0,   338,   339,   340,   341,
    1296,   343,   344,   345,   346,  1297,  1298,   348,     0,   349,
     350,   351,  1299,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,  1300,     0,
    1301,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,  1302,  1303,     0,  1304,     0,   396,   397,   398,   399,
     400,  1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,  1313,
     410,  1314,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,  1315,   421,   422,   423,     0,   424,   425,   426,
    1316,  1317,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,  1318,   438,   439,   440,   441,   442,   443,   444,
     445,  1319,   447,  1320,   449,   450,   451,   452,   453,   454,
     455,   456,   457,  1321,   459,     0,   460,   461,   462,   463,
    1323,  1324,   465,  1325,   467,   468,   469,   470,     0,   471,
     472,   473,     0,     0,  1326,   475,   476,     0,     0,   477,
     478,   479,   480,   481,   482,  1327,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,     0,   496,
     497,   498,  1328,   500,   501,   502,   503,   504,     0,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
    1329,   517,   518,   519,     0,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,     0,   533,
     534,   535,   536,   537,   538,   539,   540,  3319,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,  1331,   557,   558,   559,   560,   561,
     562,   563,   564,  1332,   566,     0,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,  1333,   583,     0,   584,   585,  1334,     0,   586,   587,
     588,   589,   590,   591,   592,   593,     0,   594,  1335,  1336,
       0,     0,   597,   598,  1337,   600,  1338,  1339,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,     0,   611,
     612,   613,   614,   615,  1341,     0,   616,   617,   618,   619,
     620,   621,  1342,     0,   623,   624,   625,   626,   627,   628,
     629,     0,     0,   630,     0,     0,   631,   632,   633,   634,
     635,   636,   637,  1343,  1344,  1345,  1346,   642,  1347,  1348,
    1349,  1350,   647,   648,   649,   650,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3320,
    3321,     0,     0,     0,   234,     0,  1271,   717,  3322,  1272,
    1273,  1274,   778,  1275,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,  1276,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257, -3012,  1277,   260,  1278,  1279,     0,   263,
     264,   265,   266,   267,   268,   269,  1280,  1281,   270,   271,
    1282,  1283,   274,     0,   275,   276,   277,   278,  1284,     0,
    1285,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,  6028,  1286,  1287,  1288,  1289,  1290,
    1291,  1292,   303,   304,   305,   306,   307,   308,  1293,  1294,
     311,  1295,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     887,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,  1296,
     343,   344,   345,   346,  1297,  1298,   348,     0,   349,   350,
     351,  1299,   353,     0,   354,     0,   355,   356,   357,     0,
     358,   359,   360,   361,   362,     0,   363,  1300,     0,  1301,
     366,   367,     0,   368,   369,   370,   371,   372, -3012,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
    1302,  1303,     0,  1304,     0,   396,     0,     0,   399,   400,
    1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,  1313,   410,
    1314,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,  1315,   421,   422, -3012,     0,   424,   425,   426,  1316,
    1317,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,  1318,   438,   439,   440,   441,   442,   443,   444,   445,
    1319,   447,  1320,   449,   450,   451,   452,   453,   454,   455,
     456,   457,  1321,   459,  1322,   460,   461,     0,   463,  1323,
    1324,   465,  1325,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,  1326,   475,   476,     0,     0,   477,   478,
     479,   480,   481,   482,  1327,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,  1328,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,  1329,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
     535,   536,   537,   538,   539,   540,  1330,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,  1331,   557,   558,   559,   560,   561, -3012,
     563,   564,  1332,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
    1333,   583,     0,   584,   585,  1334,     0,   586,   587,   588,
     589,   590,   591,   592,   593,     0,   594,  1335,  1336,     0,
       0,   597,   598,  1337,   600,  1338,  1339,   602,   603,   604,
     605,   606,  6029,   608,   609,   610,     0,  1340,   611,   612,
     613,   614,   615,  1341,     0,   616,   617,   618,   619,   620,
     621,  1342,     0,   623,   624,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,  1343,  1344,  1345,  1346,   642,  1347,  1348,  1349,
    1350,   647,   648,   649,   650,     0, -3012,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1352,  1353,
       0,     0,     0,   234,     0,  1271,   717,  1355,  1272,  1273,
    1274,   778,  1275,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1276,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1277,   260,  1278,  1279,     0,   263,   264,
     265,   266,   267,   268,   269,  1280,  1281,   270,   271,  1282,
    1283,   274,     0,   275,   276,   277,   278,  1284,     0,  1285,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,  1286,  1287,  1288,  1289,  1290,  1291,
    1292,   303,   304,   305,   306,   307,   308,  1293,  1294,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   887,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,   337,     0,   338,   339,   340,   341,  1296,   343,
     344,   345,   346,  1297,  1298,   348,     0,   349,   350,   351,
    1299,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,  1300,     0,  1301,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,  1302,
    1303,     0,  1304,     0,   396,   397,   398,   399,   400,  1305,
    1306,  1307,  1308,  1309,  1310,  1311,  1312,  1313,   410,  1314,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
    1315,   421,   422,   423,     0,   424,   425,   426,  1316,  1317,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
    1318,   438,   439,   440,   441,   442,   443,   444,   445,  1319,
     447,  1320,   449,   450,   451,   452,   453,   454,   455,   456,
     457,  1321,   459,     0,   460,   461,   462,   463,  1323,  1324,
     465,  1325,   467,   468,   469,   470,     0,   471,   472,   473,
       0,     0,  1326,   475,   476,     0,     0,   477,   478,   479,
     480,   481,   482,  1327,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,   496,   497,   498,
    1328,   500,   501,   502,   503,   504,     0,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,  1329,   517,
     518,   519,     0,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,     0,   533,   534,   535,
     536,   537,   538,   539,   540,  3319,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,  1331,   557,   558,   559,   560,   561,   562,   563,
     564,  1332,   566,     0,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,  1333,
     583,     0,   584,   585,  1334,     0,   586,   587,   588,   589,
     590,   591,   592,   593,     0,   594,  1335,  1336,     0,     0,
     597,   598,  1337,   600,  1338,  1339,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,     0,   611,   612,   613,
     614,   615,  1341,     0,   616,   617,   618,   619,   620,   621,
    1342,     0,   623,   624,   625,   626,   627,   628,   629,     0,
       0,   630,     0,     0,   631,   632,   633,   634,   635,   636,
     637,  1343,  1344,  1345,  1346,   642,  1347,  1348,  1349,  1350,
     647,   648,   649,   650,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3320,  3321,   234,
       0,  1271,   717,     0,  1272,  1273,  3322,   778,  1275,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,  1276,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1277,
     260,  1278,  1279,     0,   263,   264,   265,   266,   267,   268,
     269,  1280,  1281,   270,   271,  1282,  1283,   274,     0,   275,
     276,   277,   278,  1284,     0,  1285,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
    1286,  1287,  1288,  1289,  1290,  1291,  1292,   303,   304,   305,
     306,   307,   308,  1293,  1294,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   887,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,   337,     0,
     338,   339,   340,   341,  1296,   343,   344,   345,   346,  1297,
    1298,   348,     0,   349,   350,   351,  1299,   353,     0,   354,
       0,   355,   356,   357,     0,   358,   359,   360,   361,   362,
       0,   363,  1300,     0,  1301,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,  1302,  1303,     0,  1304,     0,
     396,   397,   398,   399,   400,  1305,  1306,  1307,  1308,  1309,
    1310,  1311,  1312,  1313,   410,  1314,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,  1315,   421,   422,   423,
       0,   424,   425,   426,  1316,  1317,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,  1318,   438,   439,   440,
     441,   442,   443,   444,   445,  1319,   447,  1320,   449,   450,
     451,   452,   453,   454,   455,   456,   457,  1321,   459,     0,
     460,   461,   462,   463,  1323,  1324,   465,  1325,   467,   468,
     469,   470,     0,   471,   472,   473,     0,     0,   474,   475,
     476,     0,     0,   477,   478,   479,   480,   481,   482,  1327,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,   496,   497,   498,  1328,   500,   501,   502,
     503,   504,     0,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,  1329,   517,   518,   519,     0,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,     0,   533,   534,   535,   536,   537,   538,   539,
     540,  3499,  3500,   543,   544,   545,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,  1331,   557,
     558,   559,   560,   561,   562,   563,   564,  1332,   566,     0,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,  1333,   583,     0,   584,   585,
    1334,     0,   586,   587,   588,   589,   590,   591,   592,   593,
       0,   594,  1335,  1336,     0,     0,   597,   598,  1337,   600,
    1338,  1339,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,     0,   611,   612,   613,   614,   615,  1341,     0,
     616,   617,   618,   619,   620,   621,  1342,     0,   623,   624,
     625,   626,   627,   628,   629,     0,     0,   630,     0,     0,
     631,   632,   633,   634,   635,   636,   637,  1343,  1344,  1345,
    1346,   642,  1347,  1348,  1349,  1350,   647,   648,   649,   650,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3501,  3502,   234,     0,  1271,   717,     0,
    1272,  1273,  3322,   778,  1275,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,  1276,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1277,   260,  1278,  1279,     0,
     263,   264,   265,   266,   267,   268,   269,  1280,  1281,   270,
     271,  1282,  1283,   274,     0,   275,   276,   277,   278,  1284,
       0,  1285,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,  1286,  1287,  1288,  1289,
    1290,  1291,  1292,   303,   304,   305,   306,   307,   308,  1293,
    1294,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   887,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,   337,     0,   338,   339,   340,   341,
    1296,   343,   344,   345,   346,  1297,  1298,   348,     0,   349,
     350,   351,  1299,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,  1300,     0,
    1301,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,  1302,  1303,     0,  1304,     0,   396,   397,   398,   399,
     400,  1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,  1313,
     410,  1314,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,  1315,   421,   422,   423,     0,   424,   425,   426,
    1316,  1317,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,  1318,   438,   439,   440,   441,   442,   443,   444,
     445,  1319,   447,  1320,   449,   450,   451,   452,   453,   454,
     455,   456,   457,  1321,   459,     0,   460,   461,   462,   463,
    1323,  1324,   465,  1325,   467,   468,   469,   470,     0,   471,
     472,   473,     0,     0,   474,   475,   476,     0,     0,   477,
     478,   479,   480,   481,   482,  1327,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,     0,   496,
     497,   498,  1328,   500,   501,   502,   503,   504,     0,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
    1329,   517,   518,   519,     0,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,     0,   533,
     534,   535,   536,   537,   538,   539,   540,  3319,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,  1331,   557,   558,   559,   560,   561,
     562,   563,   564,  1332,   566,     0,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,  1333,   583,     0,   584,   585,  1334,     0,   586,   587,
     588,   589,   590,   591,   592,   593,     0,   594,  1335,  1336,
       0,     0,   597,   598,  1337,   600,  1338,  1339,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,     0,   611,
     612,   613,   614,   615,  1341,     0,   616,   617,   618,   619,
     620,   621,  1342,     0,   623,   624,   625,   626,   627,   628,
     629,     0,     0,   630,     0,     0,   631,   632,   633,   634,
     635,   636,   637,  1343,  1344,  1345,  1346,   642,  1347,  1348,
    1349,  1350,   647,   648,   649,   650,     0,     0,     0,     0,
       0,     0,   234,     0,  1271,   717,     0,  1272,  1273,     0,
     778,  1275,     0,     0,     0,     0,     0,     0,  3322,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,  1276,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1277,   260,  1278,  1279,     0,   263,  4774,   265,
     266,   267,   268,   269,  1280,  1281,   270,   271,  1282,  1283,
     274,     0,   275,   276,   277,   278,  1284,     0,  1285,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,  1286,  1287,  1288,  1289,  1290,  1291,  1292,
     303,   304,   305,   306,   307,   308,  1293,  1294,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   887,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,   337,     0,   338,   339,   340,   341,  1296,   343,   344,
     345,   346,  1297,  1298,   348,     0,   349,   350,   351,  1299,
     353,     0,   354,     0,   355,   356,   357,     0,   358,   359,
     360,   361,   362,     0,   363,  1300,     0,  1301,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,  1302,  1303,
       0,  1304,     0,   396,   397,   398,   399,   400,  1305,  1306,
    1307,  1308,  1309,  1310,  1311,  1312,  1313,   410,  1314,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,  1315,
     421,   422,   423,     0,   424,   425,   426,  1316,  1317,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,  1318,
     438,   439,   440,   441,   442,   443,   444,   445,  1319,   447,
    1320,   449,   450,   451,   452,   453,   454,   455,   456,   457,
    1321,   459,     0,   460,   461,   462,   463,  1323,  1324,   465,
    1325,   467,   468,   469,   470,     0,   471,   472,   473,     0,
       0,   474,   475,   476,     0,     0,   477,   478,   479,   480,
     481,   482,  1327,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,     0,   496,   497,   498,  1328,
     500,   501,   502,   503,   504,     0,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,  1329,   517,   518,
     519,     0,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,     0,   533,   534,   535,   536,
     537,   538,   539,   540,  3319,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,  1331,   557,   558,   559,   560,   561,   562,   563,   564,
    1332,   566,     0,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,  1333,   583,
       0,   584,   585,  1334,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,  1335,  1336,     0,     0,   597,
     598,  1337,   600,  1338,  1339,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,  1341,     0,   616,   617,   618,   619,   620,   621,  1342,
       0,   623,   624,   625,   626,   627,   628,   629,     0,     0,
     630,     0,     0,   631,   632,   633,   634,   635,   636,   637,
    1343,  1344,  1345,  1346,   642,  1347,  1348,  1349,  1350,   647,
     648,   649,   650,     0,     0,     0,     0,     0,     0,   234,
       0,  1271,   717,     0,  1272,  1273,     0,   778,  1275,     0,
       0,     0,     0,     0,     0,  3322,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,  1276,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1277,
     260,  1278,  1279,     0,   263,   264,   265,   266,   267,   268,
     269,  1280,  1281,   270,   271,  1282,  1283,   274,     0,   275,
     276,   277,   278,  1284,     0,  1285,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
    1286,  1287,  1288,  1289,  1290,  1291,  1292,   303,   304,   305,
     306,   307,   308,  1293,  1294,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   887,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,   337,     0,
     338,   339,   340,   341,  1296,   343,   344,   345,   346,  1297,
    1298,   348,     0,   349,   350,   351,  1299,   353,     0,   354,
       0,   355,   356,   357,     0,   358,   359,   360,   361,   362,
       0,   363,  1300,     0,  1301,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,  1302,  1303,     0,  1304,     0,
     396,   397,   398,   399,   400,  1305,  1306,  1307,  1308,  1309,
    1310,  1311,  1312,  1313,   410,  1314,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,  1315,   421,   422,   423,
       0,   424,   425,   426,  1316,  1317,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,  1318,   438,   439,   440,
     441,   442,   443,   444,   445,  1319,   447,  1320,   449,   450,
     451,   452,   453,   454,   455,   456,   457,  1321,   459,     0,
     460,   461,   462,   463,  1323,  1324,   465,  1325,   467,   468,
     469,   470,     0,   471,   472,   473,     0,     0,   474,   475,
     476,     0,     0,   477,   478,   479,   480,   481,   482,  1327,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,   496,   497,   498,  1328,   500,   501,   502,
     503,   504,     0,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,  1329,   517,   518,   519,     0,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,     0,   533,   534,   535,   536,   537,   538,   539,
     540,  3319,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,  1331,   557,
     558,   559,   560,   561,   562,   563,   564,  1332,   566,     0,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,  1333,   583,     0,   584,   585,
    1334,     0,   586,   587,   588,   589,   590,   591,   592,   593,
       0,   594,  1335,  1336,     0,     0,   597,   598,  1337,   600,
    1338,  1339,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,     0,   611,   612,   613,   614,   615,  1341,     0,
     616,   617,   618,   619,   620,   621,  1342,     0,   623,   624,
     625,   626,   627,   628,   629,     0,     0,   630,     0,     0,
     631,   632,   633,   634,   635,   636,   637,  1343,  1344,  1345,
    1346,  4834,  1347,  1348,  1349,  1350,   647,   648,   649,   650,
       0,     0,     0,     0,     0,     0,   234,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3322,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,  1281,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
    1284,     0,  1285,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,  1286,  1287,  1288,
    1289,  1290,  1291,  1292,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,  1297,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,  1300,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,   397,   398,
     399,   400,  3470,  1306,  1307,  1308,  1309,  1310,  1311,  1312,
    1313,  3471,  1314,   412,   413,   414,   415,   416,   417,   418,
    3472,     0,   419,  1315,   421,   422,   423,     0,   424,   425,
     426,  1316,  1317,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,  1318,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,  1321,   459,     0,   460,   461,   462,
     463,     0,  1324,   465,   466,   467,   468,   469,   470,     0,
     471,   472,   473,     0,   862,   474,   475,   476,     0,     0,
     477,   478,   479,   480,   481,   482,  1327,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,     0,
     496,   497,   498,  1328,   500,   501,   502,   503,   504,     0,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,     0,
     533,   534,   535,   536,   537,   538,   539,   540,   541,  3473,
     543,   544,   545,   546,   547,   548,   549,   550,   551,    40,
     552,   553,   554,   555,   556,  1331,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,     0,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,  1333,   583,     0,   584,   585,  1334,    44,   586,
     587,   588,   589,   590,   591,   592,   593,     0,   594,   595,
     596,     0,     0,   597,   598,  1337,   600,  1338,     0,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,     0,
     611,   612,   613,   614,   615,  1341,     0,   616,   617,   618,
     619,   620,  1206,   622,     0,   623,   624,   625,   626,   627,
     628,   629,     0,     0,   630,     0,    49,   631,   632,   633,
     634,   635,   636,   637,  1343,  1344,  1345,  1346,   642,  1347,
    1348,  1349,  1350,  3474,   648,   649,   650,     0,     0,     0,
      50,     0,     0,   234,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3475,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,  1281,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,  1284,     0,  1285,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,  1286,  1287,  1288,  1289,  1290,  1291,
    1292,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,  1297,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,  1300,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,   397,   398,   399,   400,  3470,
    1306,  1307,  1308,  1309,  1310,  1311,  1312,  1313,  3471,  1314,
     412,   413,   414,   415,   416,   417,   418,  3472,     0,   419,
    1315,   421,   422,   423,     0,   424,   425,   426,  1316,  1317,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
    1318,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,  1321,   459,     0,   460,   461,   462,   463,     0,  1324,
     465,   466,   467,   468,   469,   470,     0,   471,   472,   473,
       0,   862,   474,   475,   476,     0,     0,   477,   478,   479,
     480,   481,   482,  1327,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,   496,   497,   498,
    1328,   500,   501,   502,   503,   504,     0,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,     0,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,     0,   533,   534,   535,
     536,   537,   538,   539,   540,   541,  3473,   543,   544,   545,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,  1331,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,     0,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,  1333,
     583,     0,   584,   585,  1334,     0,   586,   587,   588,   589,
     590,   591,   592,   593,     0,   594,   595,   596,     0,     0,
     597,   598,  1337,   600,  1338,     0,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,     0,   611,   612,   613,
     614,   615,  1341,     0,   616,   617,   618,   619,   620,   621,
     622,     0,   623,   624,   625,   626,   627,   628,   629,     0,
       0,   630,     0,     0,   631,   632,   633,   634,   635,   636,
     637,  1343,  1344,  1345,  1346,   642,  1347,  1348,  1349,  1350,
    3474,   648,   649,   650,     0,     0,     0,     0,     0,     0,
     234,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3475,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,  1281,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,  1284,     0,  1285,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,  1286,  1287,  1288,  1289,  1290,  1291,  1292,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
    1297,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,  1300,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,   397,   398,   399,   400,  3470,  1306,  1307,  1308,
    1309,  1310,  1311,  1312,  1313,   410,  1314,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,  1315,   421,   422,
     423,     0,   424,   425,   426,  1316,  1317,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,  1318,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,  1321,   459,
       0,   460,   461,   462,   463,     0,  1324,   465,   466,   467,
     468,   469,   470,     0,   471,   472,   473,     0,     0,   474,
     475,   476,     0,     0,   477,   478,   479,   480,   481,   482,
    1327,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,     0,   496,   497,   498,  1328,   500,   501,
     502,   503,   504,     0,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,     0,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,     0,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,  1331,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
       0,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,  1333,   583,     0,   584,
     585,  1334,     0,   586,   587,   588,   589,   590,   591,   592,
     593,     0,   594,   595,   596,     0,     0,   597,   598,  1337,
     600,  1338,     0,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,     0,   611,   612,   613,   614,   615,  1341,
       0,   616,   617,   618,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,     0,     0,   630,     0,
       0,   631,   632,   633,   634,   635,   636,   637,  1343,  1344,
    1345,  1346,   642,  1347,  1348,  1349,  1350,   647,   648,   649,
     650,     0,     0,     0,     0,     0,     0,   234,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3920,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
    1281,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,  1284,     0,  1285,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,   301,  1286,  1287,
    1288,  1289,  1290,  1291,  1292,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,  1297,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,   357,     0,   358,   359,   360,   361,   362,     0,   363,
    1300,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,   397,
     398,   399,   400,  3470,  1306,  1307,  1308,  1309,  1310,  1311,
    1312,  1313,  3471,  1314,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,  1315,   421,   422,   423,     0,   424,
     425,   426,  1316,  1317,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,  1318,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,  1321,   459,     0,   460,   461,
     462,   463,     0,  1324,   465,   466,   467,   468,   469,   470,
       0,   471,   472,   473,     0,     0,   474,   475,   476,     0,
       0,   477,   478,   479,   480,   481,   482,  1327,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
       0,   496,   497,   498,  1328,   500,   501,   502,   503,   504,
       0,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,     0,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
       0,   533,   534,   535,   536,   537,   538,   539,   540,   541,
    3473,   543,   544,   545,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,  1331,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,     0,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,  1333,   583,     0,   584,   585,  1334,     0,
     586,   587,   588,   589,   590,   591,   592,   593,     0,   594,
     595,   596,     0,     0,   597,   598,  1337,   600,  1338,     0,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
       0,   611,   612,   613,   614,   615,  1341,     0,   616,   617,
     618,   619,   620,   621,   622,     0,   623,   624,   625,   626,
     627,   628,   629,     0,     0,   630,     0,     0,   631,   632,
     633,   634,   635,   636,   637,  1343,  1344,  1345,  1346,   642,
    1347,  1348,  1349,  1350,  3474,   648,   649,   650,     0,     0,
       0,     0,     0,     0,   234,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      56,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,  1281,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,  1284,     0,
    1285,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,  1286,  1287,  1288,  1289,  1290,
    1291,  1292,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,  1297,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,   357,     0,
     358,   359,   360,   361,   362,     0,   363,  1300,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,   397,   398,   399,   400,
    3470,  1306,  1307,  1308,  1309,  1310,  1311,  1312,  1313,   410,
    1314,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,  1315,   421,   422,   423,     0,   424,   425,   426,  1316,
    1317,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,  1318,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,  1321,   459,     0,   460,   461,   462,   463,     0,
    1324,   465,   466,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,   474,   475,   476,     0,     0,   477,   478,
     479,   480,   481,   482,  1327,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,  1328,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,  1331,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
    1333,   583,     0,   584,   585,  1334,     0,   586,   587,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,  1337,   600,  1338,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,  1341,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,  1343,  1344,  1345,  1346,   642,  1347,  1348,  1349,
    1350,   647,   648,   649,   650,     0,     0,     0,     0,     0,
       0,   234,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4922,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,  1281,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,  1284,     0,  1285,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,  1286,  1287,  1288,  1289,  1290,  1291,  1292,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,  1297,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,  1300,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,   397,   398,   399,   400,  3470,  1306,  1307,
    1308,  1309,  1310,  1311,  1312,  1313,   410,  1314,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,  1315,   421,
     422,   423,     0,   424,   425,   426,  1316,  1317,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,  1318,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,  1321,
     459,     0,   460,   461,   462,   463,     0,  1324,   465,   466,
     467,   468,   469,   470,     0,   471,   472,   473,     0,     0,
     474,   475,   476,     0,     0,   477,   478,   479,   480,   481,
     482,  1327,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,     0,   496,   497,   498,  1328,   500,
     501,   502,   503,   504,     0,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     0,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
    1331,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,     0,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,  1333,   583,     0,
     584,   585,  1334,     0,   586,   587,   588,   589,   590,   591,
     592,   593,     0,   594,   595,   596,     0,     0,   597,   598,
    1337,   600,  1338,     0,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,     0,   611,   612,   613,   614,   615,
    1341,     0,   616,   617,   618,   619,   620,   621,   622,     0,
     623,   624,   625,   626,   627,   628,   629,     0,     0,   630,
       0,     0,   631,   632,   633,   634,   635,   636,   637,  1343,
    1344,  1345,  1346,   642,  1347,  1348,  1349,  1350,   647,   648,
     649,   650,     0,     0,     0,     0,     0,     0,   967,     0,
    1603,   717,     0,     0,     0,     0,   778,     0,     0,     0,
       0,     0,     0,     0,  6134,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,     0,
       0,     0,   302,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,  5922,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,  1829,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,   423,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,     0,   471,   472,   473,  1830,     0,   474,   475,   476,
       0,     0,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,   496,   497,   498,   499,   500,   501,   502,   503,
     504,     0,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,     0,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,     0,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,     0,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,     0,   584,   585,     0,
       0,   586,   587,   588,   589,   590,   591,   592,   593,     0,
     594,   595,   596,     0,     0,   597,   598,   599,   600,   601,
    1831,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,     0,     0,   616,
     617,   618,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,     0,     0,   630,     0,     0,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,     0,
       0,     0,     0,     0,     0,   967,     0,     0,     0,     0,
       0,     0,  1604,  1605,  5923,     0,     0,     0,     0,     0,
       0,  5924,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     3,     4,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,     0,     0,     0,   302,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,   421,   422,   423,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,     0,   471,
     472,   473,     0,     0,   474,   475,   476,     0,     0,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,     0,   496,
     497,   498,   499,   500,   501,   502,   503,   504,     0,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,     0,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,     0,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,    40,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,     0,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,     0,   584,   585,     0,    44,   586,   587,
     588,   589,   590,   591,   592,   593,     0,   594,   595,   596,
       0,     0,   597,   598,   599,   600,   601,     0,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,     0,   611,
     612,   613,   614,   615,     0,     0,   616,   617,   618,   619,
     620,  1206,   622,     0,   623,   624,   625,   626,   627,   628,
     629,     0,     0,   630,     0,    49,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,  1046,     0,     0,    50,
       0,     0,   234,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    56,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,   357,     0,   358,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
     421,   422,   423,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,     0,   471,   472,   473,     0,
       0,   474,   475,   476,     0,     0,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,     0,   496,   497,   498,   499,
     500,   501,   502,   503,   504,     0,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,     0,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,     0,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,     0,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,     0,     0,
     630,     0,     0,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,     0,     0,     0,     0,     0,     0,   658,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5666,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,   470,     0,   471,   472,   473,     0,     0,   474,   475,
     476,     0,     0,   477,   478,   479,     0,   481,     0,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,   496,   497,   498,   499,   500,   501,   502,
     503,   504,     0,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,     0,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,     0,   533,   534,     0,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,    40,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,     0,   563,   564,   565,   566,     0,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,     0,   584,   585,
       0,    44,   586,     0,   588,   589,   590,   591,   592,   593,
       0,   594,   595,   596,     0,     0,   597,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,     0,   611,   612,   613,   614,   615,     0,     0,
     616,   617,   618,   619,   620,  1206,   622,     0,   623,     0,
     625,   626,   627,   628,   629,     0,     0,   630,     0,    49,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
       0,     0,     0,    50,     0,     0,   658,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    56,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
    2909,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,   470,     0,
     471,   472,   473,     0,   862,   474,   475,   476,     0,     0,
     477,   478,   479,     0,   481,     0,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,     0,
     496,   497,   498,   499,   500,   501,   502,   503,   504,     0,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,     0,
     533,   534,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,     0,   557,   558,   559,   560,
     561,     0,   563,   564,   565,   566,     0,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,     0,   584,   585,     0,  2910,  2911,
       0,   588,   589,   590,   591,   592,   593,     0,   594,   595,
     596,     0,     0,   597,   598,   599,   600,   601,     0,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,     0,
     611,   612,   613,   614,   615,     0,     0,   616,   617,   618,
     619,   620,   621,   622,     0,   623,     0,   625,   626,   627,
     628,   629,     0,     0,   630,     0,     0,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,     0,     0,     0,
       0,     0,     0,   658,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1863,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,   470,     0,   471,   472,   473,
       0,     0,   474,   475,   476,     0,     0,   477,   478,   479,
       0,   481,     0,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,   496,   497,   498,
     499,   500,   501,   502,   503,   504,     0,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,     0,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,     0,   533,   534,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,     0,   563,
     564,   565,   566,     0,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,     0,   584,   585,     0,     0,   586,     0,   588,   589,
     590,   591,   592,   593,     0,   594,   595,   596,     0,     0,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,     0,   611,   612,   613,
     614,   615,     0,     0,   616,   617,   618,   619,   620,   621,
     622,     0,   623,     0,   625,   626,   627,   628,   629,     0,
       0,   630,     0,     0,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,     0,     0,     0,     0,     0,     0,
     658,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1415,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,   470,     0,   471,   472,   473,     0,     0,   474,
     475,   476,     0,     0,   477,   478,   479,     0,   481,     0,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,     0,   496,   497,   498,   499,   500,   501,
     502,   503,   504,     0,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,     0,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,     0,   533,   534,     0,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,     0,
     557,   558,   559,   560,   561,     0,   563,   564,   565,   566,
       0,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,     0,   584,
     585,     0,     0,   586,     0,   588,   589,   590,   591,   592,
     593,     0,   594,   595,   596,     0,     0,   597,   598,   599,
     600,   601,     0,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,     0,   611,   612,   613,   614,   615,     0,
       0,   616,   617,   618,   619,   620,   621,   622,     0,   623,
       0,   625,   626,   627,   628,   629,     0,     0,   630,     0,
       0,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,     0,     0,     0,     0,     0,     0,   658,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3533,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,   470,
       0,   471,   472,   473,     0,     0,   474,   475,   476,     0,
       0,   477,   478,   479,     0,   481,     0,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
       0,   496,   497,   498,   499,   500,   501,   502,   503,   504,
       0,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,     0,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
       0,   533,   534,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,     0,   563,   564,   565,   566,     0,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,     0,   584,   585,     0,     0,
     586,     0,   588,   589,   590,   591,   592,   593,     0,   594,
     595,   596,     0,     0,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
       0,   611,   612,   613,   614,   615,     0,     0,   616,   617,
     618,   619,   620,   621,   622,     0,   623,     0,   625,   626,
     627,   628,   629,     0,     0,   630,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,     0,     0,
       0,     0,     0,     0,   658,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4208,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,   474,   475,   476,     0,     0,   477,   478,
     479,     0,   481,     0,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,   499,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,     0,
     563,   564,   565,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,     0,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,     0,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2110,     0,     0,     0,     0,     0,
       0,  2111,     0,     0,  2112,     0,     0,  4851,  2113,  2114,
    2115,  2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,  2124,
    2125,  2126,  2127,  2128,  2129,  2130,  2131,  2132,     0,  2133,
    2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,
    2144,  2145,  2146,  2147,  2148,  2149,  2150,  2151,  2152,  2153,
    2154,  2155,  2156,  2157,  2158,  2159,  2160,  2161,  2162,  2163,
       0,     0,  2164,  2165,  2166,  2167,  2168,  2169,  2170,  2171,
    2172,  2173,  2174,  2175,  2176,  2177,  2178,  2179,  2180,  2181,
    2182,  2183,  2184,  2185,  2186,  2187,  2188,  2189,  2190,  2191,
       0,  2192,  2193,  2194,  2195,  2196,  2197,  2198,  2199,  2200,
    2201,  2202,  2203,  2204,  2205,  2206,     0,  2207,  2208,  2209,
    2210,  2211,  2212,  2213,  2214,  2215,  2216,  2217,  2218,  2219,
    2220,  2221,  2222,  2223,  2224,  2225,  2226,  2227,  2228,  2229,
    2230,  2231,  2232,  2233,  2234,  2235,  2236,  2237,  2238,  2239,
    2240,  2241,  2242,  2243,     0,  2244,  2245,  2246,  2247,  2248,
    2249,  2250,  2251,  2252,  2253,  2254,  2255,     0,     0,  2256,
    2257,  2258,  2259,     0,  2260,  2261,  2262,  2263,  2264,     0,
    2265,  2266,  2267,  2268,  2269,     0,  2270,  2271,     0,  2272,
    2273,  2274,     0,  2275,  2276,     0,  2277,  2278,  2279,  2280,
    2281,  2282,  2283,  2284,  2285,  2286,  2287,  2288,  2289,  2290,
    2291,  2292,  2293,  2294,  2295,  2296,  2297,  2298,  2299,  2300,
    2301,  2302,     0,  2303,     0,  2304,  2305,  2306,  2307,  2308,
    2309,  2310,  2311,  2312,  2313,  2314,  2315,  2316,  2317,  2318,
    2319,  2320,  2321,  2322,  2323,  2324,  2325,  2326,  2327,  2328,
    2329,  2330,  2331,  2332,  2333,     0,  2334,  2335,  2336,  2337,
    2338,  2339,  2340,  2341,  2342,  2343,  2344,  2345,  2346,  2347,
    2348,  2349,  2350,     0,  2351,  2352,     0,  2353,  2354,  2355,
    2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,  2365,
    2366,  2367,  2368,  2369,  2370,  2371,  2372,  2373,  2374,  2375,
    2376,  2377,  2378,  2379,  2380,  2381,  2382,     0,  2383,  2384,
    2385,     0,  2386,  2387,  2388,  2389,  2390,     0,  2391,  2392,
    2393,  2394,     0,     0,  2395,  2396,  2397,  2398,  2399,  2400,
    2401,  2402,  2403,  2404,  2405,  2406,  2407,  2408,  2409,  2410,
    2411,  2412,  2413,     0,  2414,  2415,  2416,  2417,  2418,  2419,
    2420,  2421,  2422,  2423,  2424,  2425,  2426,  2427,  2428,  2429,
    2430,  2431,  2432,  2433,  2434,  2435,  2436,  2437,  2438,  2439,
    2440,  2441,  2442,  2443,  2444,  2445,  2446,     0,  2447,  2448,
    2449,  2450,  2451,  2452,  2453,  2454,  2455,  2456,  2457,  2458,
    2459,  2460,  2461,  2462,  2463,     0,  2464,  2465,  2466,  2467,
    2468,  2469,  2470,  2471,  2472,  2473,  2474,  2475,  2476,  2477,
    2478,  2479,  2480,  2481,  2482,  2483,  2484,  2485,  2486,  2487,
    2488,  2489,  2490,  2491,  2492,  2493,  2494,  2495,  2496,  2497,
    2498,  2499,  2500,  2501,  2502,  2503,  2504,  2505,  2506,  2507,
    2508,  2509,  2510,  2511,  2512,  2513,  2514,  2515,  2516,     0,
    2517,  2518,  2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,
    2527,  2528,  2529,  2530,  2531,  2532,     0,  2533,  2534,  2535,
    2536,  2537,  2538,  2539,  2540,  2541,  2542,  2543,  2544,  2545,
    2546,  2547,  2548,     0,  2549,  2550,  2551,  2552,  2553,  2554,
    2555,     0,  2556,     0,     0,     0,     0,  2557,  2558,  2559,
    2560,  2561,  2562,  2563,  2564,  2565,  2566,  2567,  2568,  2569,
    2570,  2571,     0,  2572,  2573,     0,  2574,     0,     0,     0,
       0,     0,     0,     0,     0,  2575,  2576,  2577,  2578,  2579,
    2580,  2581,  2582,  2583,   879,     0,  1603,   717,     0,     0,
       0,   982,   778,     0,     0,     0,     0,     0,   983,   984,
     985,   235,   236,   237,   238,   239,   240,   241,   242,   243,
    1741,   244,   245,   246,  1742,  1743,  1744,  1745,  1746,  1747,
    1748,   247,   248,   249,  1749,   250,   251,   252,   253,   254,
     255,   256,   257,     0,   880,   260,   881,   882,  1750,   263,
     264,   265,   266,   267,   268,   269,  1751,  1752,   270,   271,
     883,   884,   274,  1753,   275,   276,   277,   278,     0,  1754,
     280,  1755,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,  1756,   292,   293,   294,   295,   296,   297,
    1757,   298,   299,   300,   301,  1758,  1759,  1760,   302,  1761,
    1762,  1763,   303,   304,   305,   306,   307,   308,   885,   886,
     311,  1764,   312,  1765,   313,   314,   315,   316,   317,   318,
     319,  1766,   320,   321,   322,   323,  1767,  1768,   324,   325,
     887,   327,   328,  1769,   329,   330,   331,   332,  1770,   333,
     334,   335,   336,   337,  1771,   338,   339,   340,   341,     0,
     343,   344,   345,   346,     0,  1772,   348,  1773,   349,   350,
     351,   888,   353,  1774,   354,  1775,   355,   356,   357,  1776,
     358,   359,   360,   361,   362,  1777,   363,     0,  1778,     0,
     366,   367,  1779,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,  1780,   378,   379,   380,   381,   382,   383,
     384,   385,  1781,   386,   387,     0,   389,   390,   391,   392,
     889,   890,  1782,   891,  1783,   396,   397,   398,   399,   400,
     892,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   412,   413,   414,   415,   416,   417,   418,  1784,  1785,
     419,     0,   421,   422,   423,  1786,   424,   425,   426,  1787,
    1788,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   438,   439,   440,   441,   442,   443,   444,   445,
     893,   447,   894,   449,   450,   451,   452,   453,   454,   455,
     456,  4533,     0,   459,  1789,   460,   461,   462,   463,  1790,
       0,   465,   895,   467,   468,   469,   470,  1791,   471,   472,
     473,  1792,  1793,  4534,   475,   476,  1794,  1795,   477,   478,
       0,   480,   481,   482,     0,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,  1796,   496,   497,
     498,     0,   500,     0,   502,   503,   504,  1797,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   896,
     517,   518,   519,  1798,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,  1799,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,  1800,   552,   553,
     554,   555,   556,  1801,   557,   558,  2735,   560,   561,   562,
     563,   564,   898,   566,  1802,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
       0,   583,  1803,   584,   585,  1804,  1805,   586,   587,   588,
     589,   590,   591,   592,   593,  1806,   594,   899,   900,  1807,
    1808,   597,   598,     0,   600,     0,  1809,   602,   603,   604,
     605,   606,   607,   608,   609,   610,  1810,  1811,   611,   612,
     613,   614,   615,  1812,  1813,   616,   617,   618,   619,   620,
       0,   901,  1814,   623,   624,   625,   626,   627,   628,   629,
    1815,  1816,   630,  1817,  1818,   631,   632,   633,   634,   635,
     636,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   648,   649,   650,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   988,   989,   990,  4535,  4536,
     993,   994,   995,   996,   879,     0,  1603,   717,     0,     0,
       0,   982,   778,     0,     0,     0,     0,     0,   983,   984,
     985,   235,   236,   237,   238,   239,   240,   241,   242,   243,
    1741,   244,   245,   246,  1742,  1743,  1744,  1745,  1746,  1747,
    1748,   247,   248,   249,  1749,   250,   251,   252,   253,   254,
     255,   256,   257,     0,   880,   260,   881,   882,  1750,   263,
     264,   265,   266,   267,   268,   269,  1751,  1752,   270,   271,
     883,   884,   274,  1753,   275,   276,   277,   278,     0,  1754,
     280,  1755,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,  1756,   292,   293,   294,   295,   296,   297,
    1757,   298,   299,   300,   301,  1758,  1759,  1760,   302,  1761,
    1762,  1763,   303,   304,   305,   306,   307,   308,   885,   886,
     311,  1764,   312,  1765,   313,   314,   315,   316,   317,   318,
     319,  1766,   320,   321,   322,   323,  1767,  1768,   324,   325,
     887,   327,   328,  1769,   329,   330,   331,   332,  1770,   333,
     334,   335,   336,   337,  1771,   338,   339,   340,   341,     0,
     343,   344,   345,   346,     0,  1772,   348,  1773,   349,   350,
     351,   888,   353,  1774,   354,  1775,   355,   356,   357,  1776,
     358,   359,   360,   361,   362,  1777,   363,     0,  1778,     0,
     366,   367,  1779,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,  1780,   378,   379,   380,   381,   382,   383,
     384,   385,  1781,   386,   387,     0,   389,   390,   391,   392,
     889,   890,  1782,   891,  1783,   396,   397,   398,   399,   400,
     892,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   412,   413,   414,   415,   416,   417,   418,  1784,  1785,
     419,     0,   421,   422,   423,  1786,   424,   425,   426,  1787,
    1788,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   438,   439,   440,   441,   442,   443,   444,   445,
     893,   447,   894,   449,   450,   451,   452,   453,   454,   455,
     456,  4994,     0,   459,  1789,   460,   461,   462,   463,  1790,
       0,   465,   895,   467,   468,   469,   470,  1791,   471,   472,
     473,  1792,  1793,  4534,   475,   476,  1794,  1795,   477,   478,
       0,   480,   481,   482,     0,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,  1796,   496,   497,
     498,     0,   500,     0,   502,   503,   504,  1797,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   896,
     517,   518,   519,  1798,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,  1799,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,  1800,   552,   553,
     554,   555,   556,  1801,   557,   558,  2735,   560,   561,   562,
     563,   564,   898,   566,  1802,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
       0,   583,  1803,   584,   585,  1804,  1805,   586,   587,   588,
     589,   590,   591,   592,   593,  1806,   594,   899,   900,  1807,
    1808,   597,   598,     0,   600,     0,  1809,   602,   603,   604,
     605,   606,   607,   608,   609,   610,  1810,  1811,   611,   612,
     613,   614,   615,  1812,  1813,   616,   617,   618,   619,   620,
       0,   901,  1814,   623,   624,   625,   626,   627,   628,   629,
    1815,  1816,   630,  1817,  1818,   631,   632,   633,   634,   635,
     636,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   648,   649,   650,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   988,   989,   990,  4535,  4536,
     993,   994,   995,   996,   658,     0,     0,     0,     0,     0,
       0,   982,     0,     0,     0,     0,     0,     0,   983,   984,
     985,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   986,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   987,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,   474,   475,   476,     0,     0,   477,   478,
     479,     0,   481,     0,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,   499,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,     0,
     563,   564,   565,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,     0,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,     0,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   658,     0,     0,     0,     0,     0,
       0,   982,     0,     0,     0,     0,     0,     0,   983,   984,
     985,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,  1103,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,  1104,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,   474,   475,   476,     0,     0,   477,   478,
     479,     0,   481,     0,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,   499,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,     0,
     563,   564,   565,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,     0,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,     0,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   658,     0,     0,     0,     0,     0,
       0,   982,     0,     0,     0,     0,     0,     0,   983,   984,
     985,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,  1169,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,  1170,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,  1171,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,   474,   475,   476,     0,     0,   477,   478,
     479,     0,   481,     0,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,   499,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,     0,
     563,   564,   565,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,     0,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,     0,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   658,     0,     0,     0,     0,     0,
       0,   982,     0,     0,     0,     0,     0,     0,   983,   984,
     985,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,  1846,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,  1847,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,   474,   475,   476,     0,     0,   477,   478,
     479,     0,   481,     0,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,   499,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,     0,
     563,   564,   565,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,     0,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,     0,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   658,     0,     0,     0,     0,     0,
       0,   982,     0,     0,     0,     0,     0,     0,   983,   984,
     985,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,   474,   475,   476,     0,     0,   477,   478,
     479,     0,   481,     0,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,   499,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,     0,
     563,   564,   565,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,     0,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,     0,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   658,     0,     0,     0,     0,     0,
       0,   982,     0,     0,     0,     0,     0,     0,   983,   984,
     985,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,  3598,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,  3599,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,   474,   475,   476,     0,     0,   477,   478,
     479,     0,   481,     0,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,   499,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,     0,
     563,   564,   565,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,     0,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,     0,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   658,     0,     0,     0,     0,     0,
       0,   982,     0,     0,     0,     0,     0,     0,   983,   984,
     985,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,  5646,   475,   476,     0,     0,   477,   478,
     479,     0,   481,     0,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,   499,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,     0,
     563,   564,   565,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,     0,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,     0,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,     0,     0,  1740,     0,     0,
       0,     0,     0,     0,     0,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   235,   236,   237,   238,   239,   240,
     241,   242,   243,  1741,   244,   245,   246,  1742,  1743,  1744,
    1745,  1746,  1747,  1748,   247,   248,   249,  1749,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,  1750,   263,   264,   265,   266,   267,   268,   269,  1751,
    1752,   270,   271,   272,   273,   274,  1753,   275,   276,   277,
     278,   279,  1754,   280,  1755,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,  1756,   292,   293,   294,
     295,   296,   297,  1757,   298,   299,   300,   301,  1758,  1759,
    1760,   302,  1761,  1762,  1763,   303,   304,   305,   306,   307,
     308,   309,   310,   311,  1764,   312,  1765,   313,   314,   315,
     316,   317,   318,   319,  1766,   320,   321,   322,   323,  1767,
    1768,   324,   325,   326,   327,   328,  1769,   329,   330,   331,
     332,  1770,   333,   334,   335,   336,   337,  1771,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,  1772,   348,
    1773,   349,   350,   351,   352,   353,  1774,   354,  1775,   355,
     356,   357,  1776,   358,   359,   360,   361,   362,  1777,   363,
     364,  1778,   365,   366,   367,  1779,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,  1780,   378,   379,   380,
     381,   382,   383,   384,   385,  1781,   386,   387,   388,   389,
     390,   391,   392,   393,   394,  1782,   395,  1783,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,  1784,  1785,   419,   420,   421,   422,   423,  1786,   424,
     425,   426,  1787,  1788,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,  1789,   460,   461,
     462,   463,  1790,   464,   465,   466,   467,   468,   469,   470,
    1791,   471,   472,   473,  1792,  1793,   474,   475,   476,  1794,
    1795,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
    1796,   496,   497,   498,   499,   500,   501,   502,   503,   504,
    1797,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,  1798,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
    1799,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
    1800,   552,   553,   554,   555,   556,  1801,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,  1802,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,  1803,   584,   585,  1804,  1805,
     586,   587,   588,   589,   590,   591,   592,   593,  1806,   594,
     595,   596,  1807,  1808,   597,   598,   599,   600,   601,  1809,
     602,   603,   604,   605,   606,   607,   608,   609,   610,  1810,
    1811,   611,   612,   613,   614,   615,  1812,  1813,   616,   617,
     618,   619,   620,   621,   622,  1814,   623,   624,   625,   626,
     627,   628,   629,  1815,  1816,   630,  1817,  1818,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   658,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1819,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
     470,     0,   471,   472,   473,     0,     0,   474,   475,   476,
       0,     0,   477,   478,   479,     0,   481,     0,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,   496,   497,   498,   499,   500,   501,   502,   503,
     504,     0,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,     0,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,     0,   533,   534,     0,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,     0,   557,   558,
     559,   560,   561,     0,   563,   564,   565,   566,     0,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,     0,   584,   585,     0,
       0,   586,     0,   588,   589,   590,   591,   592,   593,     0,
     594,   595,   596,     0,     0,   597,   598,   599,   600,   601,
       0,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,     0,     0,   616,
     617,   618,   619,   620,   621,   622,     0,   623,     0,   625,
     626,   627,   628,   629,     0,     0,   630,     0,     0,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   658,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   868,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,   470,     0,   471,   472,   473,     0,     0,   474,   475,
     476,     0,     0,   477,   478,   479,     0,   481,     0,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,   496,   497,   498,   499,   500,   501,   502,
     503,   504,     0,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,     0,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,     0,   533,   534,     0,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,     0,   563,   564,   565,   566,     0,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,     0,   584,   585,
       0,     0,   586,     0,   588,   589,   590,   591,   592,   593,
       0,   594,   595,   596,     0,     0,   597,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,     0,   611,   612,   613,   614,   615,     0,     0,
     616,   617,   618,   619,   620,   621,   622,     0,   623,     0,
     625,   626,   627,   628,   629,     0,     0,   630,     0,     0,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     658,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  6103,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,   470,     0,   471,   472,   473,     0,     0,   474,
     475,   476,     0,     0,   477,   478,   479,     0,   481,     0,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,     0,   496,   497,   498,   499,   500,   501,
     502,   503,   504,     0,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,     0,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,     0,   533,   534,     0,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,     0,
     557,   558,   559,   560,   561,     0,   563,   564,   565,   566,
       0,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,     0,   584,
     585,     0,     0,   586,     0,   588,   589,   590,   591,   592,
     593,     0,   594,   595,   596,     0,     0,   597,   598,   599,
     600,   601,     0,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,     0,   611,   612,   613,   614,   615,     0,
       0,   616,   617,   618,   619,   620,   621,   622,     0,   623,
       0,   625,   626,   627,   628,   629,     0,     0,   630,     0,
       0,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   658,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  6105,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,   470,     0,   471,   472,   473,     0,     0,
     474,   475,   476,     0,     0,   477,   478,   479,     0,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,     0,   496,   497,   498,   499,   500,
     501,   502,   503,   504,     0,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     0,   533,   534,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,     0,   563,   564,   565,
     566,     0,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,     0,
     584,   585,     0,     0,   586,     0,   588,   589,   590,   591,
     592,   593,     0,   594,   595,   596,     0,     0,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,     0,   611,   612,   613,   614,   615,
       0,     0,   616,   617,   618,   619,   620,   621,   622,     0,
     623,     0,   625,   626,   627,   628,   629,     0,     0,   630,
       0,     0,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   879,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6234,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,     0,   880,   260,   881,   882,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   883,   884,
     274,     0,   275,   276,   277,   278,     0,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   885,   886,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   887,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,   337,     0,   338,   339,   340,   341,     0,   343,   344,
     345,   346,     0,     0,   348,     0,   349,   350,   351,   888,
     353,     0,   354,     0,   355,   356,   357,     0,   358,   359,
     360,   361,   362,     0,   363,     0,     0,     0,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,  2731,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,  2732,   389,   390,   391,   392,   889,   890,
       0,   891,     0,   396,   397,   398,   399,   400,   892,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,     0,
     421,   422,   423,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     0,
     438,   439,   440,   441,   442,   443,   444,   445,   893,   447,
     894,   449,   450,   451,   452,   453,   454,   455,   456,     0,
       0,   459,     0,   460,   461,   462,   463,     0,     0,   465,
     895,   467,   468,   469,   470,     0,   471,   472,   473,     0,
       0,   474,   475,   476,     0,  2733,   477,   478,  2734,   480,
     481,   482,     0,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,     0,   496,   497,   498,     0,
     500,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   896,   517,   518,
     519,     0,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,     0,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,     0,   557,   558,  2735,   560,   561,   562,   563,   564,
     898,   566,     0,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,     0,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   899,   900,     0,     0,   597,
     598,     0,   600,     0,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,     0,   901,
    2736,   623,   624,   625,   626,   627,   628,   629,     0,     0,
     630,     0,     0,   631,   632,   633,   634,   635,   636,     0,
       0,     0,  3957,     0,     0,     0,     0,     0,     0,     0,
     648,   649,   650,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,  2737,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,     0,   880,   260,   881,   882,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   883,   884,
     274,     0,   275,   276,   277,   278,     0,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   885,   886,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   887,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,   337,     0,   338,   339,   340,   341,     0,   343,   344,
     345,   346,     0,     0,   348,     0,   349,   350,   351,   888,
     353,     0,   354,     0,   355,   356,   357,     0,   358,   359,
     360,   361,   362,     0,   363,     0,     0,     0,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,  2731,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,  2732,   389,   390,   391,   392,   889,   890,
       0,   891,     0,   396,   397,   398,   399,   400,   892,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,     0,
     421,   422,   423,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     0,
     438,   439,   440,   441,   442,   443,   444,   445,   893,   447,
     894,   449,   450,   451,   452,   453,   454,   455,   456,     0,
       0,   459,     0,   460,   461,   462,   463,     0,     0,   465,
     895,   467,   468,   469,   470,     0,   471,   472,   473,     0,
       0,   474,   475,   476,     0,  2733,   477,   478,  2734,   480,
     481,   482,     0,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,     0,   496,   497,   498,     0,
     500,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   896,   517,   518,
     519,     0,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,     0,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,     0,   557,   558,  2735,   560,   561,   562,   563,   564,
     898,   566,     0,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,     0,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   899,   900,     0,     0,   597,
     598,     0,   600,     0,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,     0,   901,
    2736,   623,   624,   625,   626,   627,   628,   629,     0,     0,
     630,     0,     0,   631,   632,   633,   634,   635,   636,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     648,   649,   650,   967,     0,  1603,   717,     0,     0,     0,
       0,   778,     0,     0,     0,     0,     0,     0,  2737,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,     0,     0,     0,   302,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
    2622,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,  1829,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,   421,   422,   423,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,     0,   471,   472,   473,
    1830,     0,   474,   475,   476,     0,     0,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,   496,   497,   498,
     499,   500,   501,   502,   503,   504,     0,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,     0,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,     0,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,     0,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,     0,   584,   585,     0,     0,   586,   587,   588,   589,
     590,   591,   592,   593,     0,   594,   595,   596,     0,     0,
     597,   598,   599,   600,   601,  1831,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,     0,   611,   612,   613,
     614,   615,     0,     0,   616,   617,   618,   619,   620,   621,
     622,     0,   623,   624,   625,   626,   627,   628,   629,     0,
       0,   630,     0,     0,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   967,     0,  1603,   717,     0,     0,
       0,     0,   778,     0,     0,     0,     0,  1604,  1605,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,     0,     0,     0,   302,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,  2627,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,  1829,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,   357,     0,
     358,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,   423,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,     0,   471,   472,
     473,  1830,     0,   474,   475,   476,     0,     0,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,   499,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,   587,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,   599,   600,   601,  1831,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   967,     0,  1603,   717,     0,
       0,     0,     0,   778,     0,     0,     0,     0,  1604,  1605,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,     0,     0,     0,   302,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,  3565,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,  1829,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,   421,   422,   423,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,     0,   471,
     472,   473,  1830,     0,   474,   475,   476,     0,     0,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,     0,   496,
     497,   498,   499,   500,   501,   502,   503,   504,     0,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,     0,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,     0,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,     0,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,     0,   584,   585,     0,     0,   586,   587,
     588,   589,   590,   591,   592,   593,     0,   594,   595,   596,
       0,     0,   597,   598,   599,   600,   601,  1831,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,     0,   611,
     612,   613,   614,   615,     0,     0,   616,   617,   618,   619,
     620,   621,   622,     0,   623,   624,   625,   626,   627,   628,
     629,     0,     0,   630,     0,     0,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   967,     0,  1603,   717,
       0,     0,     0,     0,   778,     0,     0,     0,     0,  1604,
    1605,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,     0,     0,     0,
     302,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,  1829,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,   421,   422,   423,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,     0,
     471,   472,   473,  1830,     0,   474,   475,   476,     0,     0,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,     0,
     496,   497,   498,   499,   500,   501,   502,   503,   504,     0,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,     0,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,     0,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,     0,   584,   585,     0,     0,   586,
     587,   588,   589,   590,   591,   592,   593,     0,   594,   595,
     596,     0,     0,   597,   598,   599,   600,   601,  1831,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,     0,
     611,   612,   613,   614,   615,     0,     0,   616,   617,   618,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,     0,     0,   630,     0,     0,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   658,     0,     0,
       0,     0,     0,     0,     0,   778,     0,     0,     0,     0,
    1604,  1605,     0,     0,   235,   236,   779,   238,   239,   240,
     241,   242,   243,   780,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   781,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   782,   352,   353,     0,   354,     0,   355,
     783,     0,   784,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,     0,   374,   375,   376,   377,   785,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     786,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   787,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,   470,
       0,   471,   472,   473,     0,     0,   474,   475,   476,     0,
       0,   477,   478,   479,     0,   481,     0,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
       0,   496,   497,   498,   499,   500,   501,   502,   503,   504,
       0,   788,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,     0,   520,   521,   522,
     789,   524,   525,   526,   527,   528,   529,   530,   531,   532,
       0,   533,   534,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,     0,   563,   564,   565,   566,     0,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,     0,   584,   585,     0,     0,
     586,     0,   588,   589,   590,   591,   592,   593,     0,   594,
     595,   596,     0,     0,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
       0,   611,   612,   613,   614,   615,     0,     0,   616,   617,
     618,   619,   620,   621,   622,     0,   623,     0,   625,   626,
     627,   628,   629,     0,     0,   630,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   967,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   790,   791,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     3,     4,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,     0,
       0,     0,   302,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,   423,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,     0,   471,   472,   473,     0,     0,   474,   475,   476,
       0,     0,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,   496,   497,   498,   499,   500,   501,   502,   503,
     504,     0,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,     0,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,     0,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,     0,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,     0,   584,   585,     0,
       0,   586,   587,   588,   589,   590,   591,   592,   593,     0,
     594,   595,   596,     0,     0,   597,   598,   599,   600,   601,
       0,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,     0,     0,   616,
     617,   618,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,     0,     0,   630,     0,     0,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,  1046,
    1740,     0,  6431,   717,     0,     0,     0,     0,   778,     0,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,  1741,   244,   245,   246,
    1742,  1743,  1744,  1745,  1746,  1747,  1748,   247,   248,   249,
    1749,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,  1750,   263,   264,   265,   266,   267,
     268,   269,  1751,  1752,   270,   271,   272,   273,   274,  1753,
     275,   276,   277,   278,   279,  1754,   280,  1755,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,  1756,
     292,   293,   294,   295,   296,   297,  1757,   298,   299,   300,
     301,  1758,  1759,  1760,   302,  1761,  1762,  1763,   303,   304,
     305,   306,   307,   308,   309,   310,   311,  1764,   312,  1765,
     313,   314,   315,   316,   317,   318,   319,  1766,   320,   321,
     322,   323,  1767,  1768,   324,   325,   326,   327,   328,  1769,
     329,   330,   331,   332,  1770,   333,   334,   335,   336,   337,
    1771,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,  1772,   348,  1773,   349,   350,   351,   352,   353,  1774,
     354,  1775,   355,   356,   357,  1776,   358,   359,   360,   361,
     362,  1777,   363,   364,  1778,   365,   366,   367,  1779,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,  1780,
     378,   379,   380,   381,   382,   383,   384,   385,  1781,   386,
     387,   388,   389,   390,   391,   392,   393,   394,  1782,   395,
    1783,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,  1784,  1785,   419,   420,   421,   422,
     423,  1786,   424,   425,   426,  1787,  1788,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
    1789,   460,   461,   462,   463,  1790,   464,   465,   466,   467,
     468,   469,   470,  1791,   471,   472,   473,  1792,  1793,   474,
     475,   476,  1794,  1795,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,  1796,   496,   497,   498,   499,   500,   501,
     502,   503,   504,  1797,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,  1798,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,  1799,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,  1800,   552,   553,   554,   555,   556,  1801,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
    1802,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,  1803,   584,
     585,  1804,  1805,   586,   587,   588,   589,   590,   591,   592,
     593,  1806,   594,   595,   596,  1807,  1808,   597,   598,   599,
     600,   601,  1809,   602,   603,   604,   605,   606,   607,   608,
     609,   610,  1810,  1811,   611,   612,   613,   614,   615,  1812,
    1813,   616,   617,   618,   619,   620,   621,   622,  1814,   623,
     624,   625,   626,   627,   628,   629,  1815,  1816,   630,  1817,
    1818,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,  1740,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,  1741,   244,   245,
     246,  1742,  1743,  1744,  1745,  1746,  1747,  1748,   247,   248,
     249,  1749,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,  1750,   263,   264,   265,   266,
     267,   268,   269,  1751,  1752,   270,   271,   272,   273,   274,
    1753,   275,   276,   277,   278,   279,  1754,   280,  1755,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
    1756,   292,   293,   294,   295,   296,   297,  1757,   298,   299,
     300,   301,  1758,  1759,  1760,   302,  1761,  1762,  1763,   303,
     304,   305,   306,   307,   308,   309,   310,   311,  1764,   312,
    1765,   313,   314,   315,   316,   317,   318,   319,  1766,   320,
     321,   322,   323,  1767,  1768,   324,   325,   326,   327,   328,
    1769,   329,   330,   331,   332,  1770,   333,   334,   335,   336,
     337,  1771,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,  1772,   348,  1773,   349,   350,   351,   352,   353,
    1774,   354,  1775,   355,   356,   357,  1776,   358,   359,   360,
     361,   362,  1777,   363,   364,  1778,   365,   366,   367,  1779,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1780,   378,   379,   380,   381,   382,   383,   384,   385,  1781,
     386,   387,   388,   389,   390,   391,   392,   393,   394,  1782,
     395,  1783,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,  1784,  1785,   419,   420,   421,
     422,   423,  1786,   424,   425,   426,  1787,  1788,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,  1789,   460,   461,   462,   463,  1790,   464,   465,   466,
     467,   468,   469,   470,  1791,   471,   472,   473,  1792,  1793,
     474,   475,   476,  1794,  1795,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,  1796,   496,   497,   498,   499,   500,
     501,   502,   503,   504,  1797,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
    1798,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,  1799,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,  1800,   552,   553,   554,   555,   556,
    1801,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,  1802,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,  1803,
     584,   585,  1804,  1805,   586,   587,   588,   589,   590,   591,
     592,   593,  1806,   594,   595,   596,  1807,  1808,   597,   598,
     599,   600,   601,  1809,   602,   603,   604,   605,   606,   607,
     608,   609,   610,  1810,  1811,   611,   612,   613,   614,   615,
    1812,  1813,   616,   617,   618,   619,   620,   621,   622,  1814,
     623,   624,   625,   626,   627,   628,   629,  1815,  1816,   630,
    1817,  1818,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,  1740,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,  3674,   241,   242,   243,  1741,   244,
     245,   246,  1742,  1743,  1744,  1745,  1746,  1747,  1748,   247,
     248,   249,  1749,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,  1750,   263,   264,   265,
     266,   267,   268,   269,  1751,  1752,   270,   271,   272,   273,
     274,  1753,   275,   276,   277,   278,   279,  1754,   280,  1755,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,  1756,   292,   293,   294,   295,   296,   297,  1757,   298,
     299,   300,   301,  1758,  1759,  1760,   302,  1761,  1762,  1763,
     303,   304,   305,   306,   307,   308,   309,   310,   311,  1764,
     312,  1765,   313,   314,   315,   316,   317,   318,   319,  1766,
     320,   321,   322,   323,  1767,  1768,   324,   325,   326,  3675,
     328,  1769,   329,   330,   331,   332,  1770,   333,   334,   335,
     336,   337,  1771,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,  1772,   348,  1773,   349,   350,   351,   352,
     353,  1774,   354,  1775,   355,   356,   357,  1776,   358,   359,
     360,   361,   362,  1777,   363,   364,  1778,   365,   366,   367,
    1779,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,  1780,   378,   379,   380,   381,   382,   383,   384,   385,
    1781,   386,   387,   388,   389,   390,   391,   392,   393,   394,
    1782,   395,  1783,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,  1784,  1785,   419,   420,
     421,   422,   423,  1786,   424,   425,   426,  1787,  1788,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,  1789,   460,   461,   462,   463,  1790,   464,   465,
     466,   467,   468,   469,   470,  1791,   471,   472,   473,  1792,
    1793,   474,   475,   476,  1794,  1795,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,  1796,   496,   497,   498,   499,
     500,   501,   502,   503,   504,  1797,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,  1798,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,  1799,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,  1800,   552,   553,   554,   555,
     556,  1801,  3676,   558,   559,   560,   561,   562,   563,   564,
     565,   566,  1802,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
    1803,   584,   585,  1804,  1805,   586,   587,   588,   589,   590,
     591,   592,   593,  1806,   594,   595,   596,  1807,  1808,   597,
     598,   599,   600,   601,  1809,   602,   603,   604,   605,   606,
     607,   608,   609,   610,  1810,  1811,   611,   612,   613,   614,
     615,  1812,  1813,   616,   617,   618,   619,   620,   621,   622,
    1814,   623,   624,   625,   626,   627,   628,   629,  1815,  1816,
     630,  1817,  1818,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   234,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,  1281,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,  1284,     0,  1285,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,  1286,  1287,  1288,  1289,  1290,  1291,
    1292,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,  1297,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,  1300,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,   397,   398,   399,   400,  3470,
    1306,  1307,  1308,  1309,  1310,  1311,  1312,  1313,   410,  1314,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
    1315,   421,   422,   423,     0,   424,   425,   426,  1316,  1317,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
    1318,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,  1321,   459,     0,   460,   461,   462,   463,     0,  1324,
     465,   466,   467,   468,   469,   470,     0,   471,   472,   473,
       0,     0,   474,   475,   476,     0,     0,   477,   478,   479,
     480,   481,   482,  1327,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,   496,   497,   498,
    1328,   500,   501,   502,   503,   504,     0,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,     0,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,     0,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,  1331,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,     0,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,  1333,
     583,     0,   584,   585,  1334,     0,   586,   587,   588,   589,
     590,   591,   592,   593,     0,   594,   595,   596,     0,     0,
     597,   598,  1337,   600,  1338,     0,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,     0,   611,   612,   613,
     614,   615,  1341,     0,   616,   617,   618,   619,   620,   621,
     622,     0,   623,   624,   625,   626,   627,   628,   629,     0,
       0,   630,     0,     0,   631,   632,   633,   634,   635,   636,
     637,  1343,  1344,  1345,  1346,   642,  1347,  1348,  1349,  1350,
     647,   648,   649,   650,   234,     0,  1271,   717,     0,  1272,
    1273,     0,   778,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1277,   260,  1278,  1279,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
    1282,  1283,   274,     0,   275,   276,   277,   278,   279,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,     0,     0,     0,   302,     0,
       0,     0,   303,   304,   305,   306,   307,   308,  1293,  1294,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     887,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,  1298,   348,     0,   349,   350,
     351,  1299,   353,     0,   354,     0,   355,   356,   357,     0,
     358,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
    1302,  1303,     0,  1304,     0,   396,   397,   398,   399,   400,
    6403,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,   423,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
    1319,   447,  1320,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,   462,   463,  1323,
     464,   465,  1325,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,   474,   475,   476,     0,     0,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,   499,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,  1329,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,   564,  1332,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,   587,   588,
     589,   590,   591,   592,   593,     0,   594,  1335,  1336,     0,
       0,   597,   598,   599,   600,   601,  1339,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
     621,  1342,     0,   623,   624,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   967,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,  1006,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,     0,     0,   968,   302,
       0,     0,   969,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,   421,   422,   423,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,     0,   471,
     472,   473,     0,     0,   474,   475,   476,     0,     0,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,     0,   496,
     497,   498,   499,   500,   501,   502,   503,   504,     0,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,     0,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,     0,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,   970,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,     0,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,     0,   584,   585,     0,     0,   586,   587,
     588,   589,   590,   591,   592,   593,     0,   594,   595,   596,
       0,     0,   597,   598,   599,   600,   601,     0,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,     0,   611,
     612,   613,   614,   615,     0,     0,   616,   617,   618,   619,
     620,   621,   622,     0,   623,   624,   625,   626,   627,   628,
     629,     0,     0,   630,     0,     0,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   967,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,  1027,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,     0,     0,   968,
     302,     0,     0,   969,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,   421,   422,   423,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,  1028,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,     0,
     471,   472,   473,     0,     0,   474,   475,   476,     0,     0,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,     0,
     496,   497,   498,   499,   500,   501,   502,   503,   504,     0,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,     0,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,   970,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,     0,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,     0,   584,   585,     0,     0,   586,
     587,   588,   589,   590,   591,   592,   593,     0,   594,   595,
     596,     0,     0,   597,   598,   599,   600,   601,     0,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,     0,
     611,   612,   613,   614,   615,     0,     0,   616,   617,   618,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,     0,     0,   630,     0,     0,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   967,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,   301,     0,     0,
     968,   302,     0,     0,   969,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,   357,     0,   358,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,   421,   422,   423,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
       0,   471,   472,   473,     0,     0,   474,   475,   476,     0,
       0,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
       0,   496,   497,   498,   499,   500,   501,   502,   503,   504,
       0,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,     0,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
       0,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,   970,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,     0,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,     0,   584,   585,     0,     0,
     586,   587,   588,   589,   590,   591,   592,   593,     0,   594,
     595,   596,     0,     0,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
       0,   611,   612,   613,   614,   615,  3003,     0,   616,   617,
     618,   619,   620,   621,   622,     0,   623,   624,   625,   626,
     627,   628,   629,     0,     0,   630,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   967,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,     0,
       0,   968,   302,     0,     0,   969,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,   364,  4028,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,   423,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,     0,   471,   472,   473,     0,     0,   474,   475,   476,
       0,     0,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,   496,   497,   498,   499,   500,   501,   502,   503,
     504,     0,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,     0,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,     0,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,   970,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,     0,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,     0,   584,   585,     0,
       0,   586,   587,   588,   589,   590,   591,   592,   593,     0,
     594,   595,   596,     0,     0,   597,   598,   599,   600,   601,
       0,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,     0,     0,   616,
     617,   618,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,     0,     0,   630,     0,     0,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   967,
       0,     0,   717,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
       0,     0,     0,   302,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
    1829,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,   357,     0,   358,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,   421,   422,   423,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,     0,   471,   472,   473,  1830,     0,   474,   475,
     476,     0,     0,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,   496,   497,   498,   499,   500,   501,   502,
     503,   504,     0,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,     0,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,     0,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,     0,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,     0,   584,   585,
       0,     0,   586,   587,   588,   589,   590,   591,   592,   593,
       0,   594,   595,   596,     0,     0,   597,   598,   599,   600,
     601,  1831,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,     0,   611,   612,   613,   614,   615,     0,     0,
     616,   617,   618,   619,   620,   621,   622,     0,   623,   624,
     625,   626,   627,   628,   629,     0,     0,   630,     0,     0,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     967,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,     0,     0,   968,   302,     0,     0,   969,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,   421,   422,
     423,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,     0,   471,   472,   473,     0,     0,   474,
     475,   476,     0,     0,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,     0,   496,   497,   498,   499,   500,   501,
     502,   503,   504,     0,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,     0,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,     0,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,   970,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
       0,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,     0,   584,
     585,     0,     0,   586,   587,   588,   589,   590,   591,   592,
     593,     0,   594,   595,   596,     0,     0,   597,   598,   599,
     600,   601,     0,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,     0,   611,   612,   613,   614,   615,     0,
       0,   616,   617,   618,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,     0,     0,   630,     0,
       0,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   967,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,     0,     0,   968,   302,     0,     0,   969,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,   421,
     422,   423,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,  1122,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,     0,   471,   472,   473,     0,     0,
     474,   475,   476,     0,     0,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,     0,   496,   497,   498,   499,   500,
     501,   502,   503,   504,     0,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     0,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
     970,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,     0,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,     0,
     584,   585,     0,     0,   586,   587,   588,   589,   590,   591,
     592,   593,     0,   594,   595,   596,     0,     0,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,     0,   611,   612,   613,   614,   615,
       0,     0,   616,   617,   618,   619,   620,   621,   622,     0,
     623,   624,   625,   626,   627,   628,   629,     0,     0,   630,
       0,     0,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   967,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,   968,   302,     0,     0,   969,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,   357,     0,   358,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,  1164,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
     421,   422,   423,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,     0,   471,   472,   473,     0,
       0,   474,   475,   476,     0,     0,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,     0,   496,   497,   498,   499,
     500,   501,   502,   503,   504,     0,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,     0,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,     0,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,   970,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,     0,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,     0,     0,
     630,     0,     0,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   967,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,     0,     0,   968,   302,     0,     0,
     969,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,  1177,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,   421,   422,   423,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,     0,   471,   472,   473,
       0,     0,   474,   475,   476,     0,     0,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,   496,   497,   498,
     499,   500,   501,   502,   503,   504,     0,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,     0,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,     0,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,   970,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,     0,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,     0,   584,   585,     0,     0,   586,   587,   588,   589,
     590,   591,   592,   593,     0,   594,   595,   596,     0,     0,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,     0,   611,   612,   613,
     614,   615,     0,     0,   616,   617,   618,   619,   620,   621,
     622,     0,   623,   624,   625,   626,   627,   628,   629,     0,
       0,   630,     0,     0,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   967,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,     0,     0,   968,   302,     0,
       0,   969,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,   357,     0,
     358,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,  1189,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,   423,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,  1190,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,   474,   475,   476,     0,     0,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,   499,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,   970,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,   587,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   967,     0,     0,   717,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,     0,     0,     0,   302,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,  2607,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,   421,   422,   423,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,     0,   471,
     472,   473,     0,     0,   474,   475,   476,     0,     0,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,     0,   496,
     497,   498,   499,   500,   501,   502,   503,   504,     0,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,     0,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,     0,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,     0,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,     0,   584,   585,     0,     0,   586,   587,
     588,   589,   590,   591,   592,   593,     0,   594,   595,   596,
       0,     0,   597,   598,   599,   600,   601,     0,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,     0,   611,
     612,   613,   614,   615,     0,     0,   616,   617,   618,   619,
     620,   621,   622,     0,   623,   624,   625,   626,   627,   628,
     629,     0,     0,   630,     0,     0,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   967,     0,     0,   717,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,     0,     0,     0,
     302,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,   421,   422,   423,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,     0,
     471,   472,   473,     0,     0,   474,   475,   476,     0,     0,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,     0,
     496,   497,   498,   499,   500,   501,   502,   503,   504,     0,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,     0,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,     0,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,     0,   584,   585,     0,     0,   586,
     587,   588,   589,   590,   591,   592,   593,     0,   594,   595,
     596,     0,     0,   597,   598,   599,   600,   601,     0,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,     0,
     611,   612,   613,   614,   615,     0,     0,   616,   617,   618,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,     0,     0,   630,     0,     0,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   234,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,   301,     0,     0,
       0,   302,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,   357,     0,   358,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,   421,   422,   423,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
       0,   471,   472,   473,     0,     0,   474,   475,   476,     0,
       0,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
       0,   496,   497,   498,   499,   500,   501,   502,   503,   504,
       0,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,     0,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
       0,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,     0,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,     0,   584,   585,     0,     0,
     586,   587,   588,   589,   590,   591,   592,   593,     0,   594,
     595,   596,     0,     0,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
       0,   611,   612,   613,   614,   615,     0,     0,   616,   617,
     618,   619,   620,   621,   622,     0,   623,   624,   625,   626,
     627,   628,   629,     0,     0,   630,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   234,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,     0,
       0,     0,   302,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,  1148,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,   423,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,     0,   471,   472,   473,     0,     0,   474,   475,   476,
       0,     0,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,   496,   497,   498,   499,   500,   501,   502,   503,
     504,     0,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,     0,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,     0,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,     0,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,     0,   584,   585,     0,
       0,   586,   587,   588,   589,   590,   591,   592,   593,     0,
     594,   595,   596,     0,     0,   597,   598,   599,   600,   601,
       0,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,     0,     0,   616,
     617,   618,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,     0,     0,   630,     0,     0,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   234,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
       0,     0,     0,   302,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,   357,     0,   358,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,  1161,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,   421,   422,   423,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,     0,   471,   472,   473,     0,     0,   474,   475,
     476,     0,     0,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,   496,   497,   498,   499,   500,   501,   502,
     503,   504,     0,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,     0,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,     0,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,     0,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,     0,   584,   585,
       0,     0,   586,   587,   588,   589,   590,   591,   592,   593,
       0,   594,   595,   596,     0,     0,   597,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,     0,   611,   612,   613,   614,   615,     0,     0,
     616,   617,   618,   619,   620,   621,   622,     0,   623,   624,
     625,   626,   627,   628,   629,     0,     0,   630,     0,     0,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     234,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,     0,     0,     0,   302,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,  1175,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,   421,   422,
     423,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,     0,   471,   472,   473,     0,     0,   474,
     475,   476,     0,     0,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,     0,   496,   497,   498,   499,   500,   501,
     502,   503,   504,     0,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,     0,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,     0,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
       0,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,     0,   584,
     585,     0,     0,   586,   587,   588,   589,   590,   591,   592,
     593,     0,   594,   595,   596,     0,     0,   597,   598,   599,
     600,   601,     0,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,     0,   611,   612,   613,   614,   615,     0,
       0,   616,   617,   618,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,     0,     0,   630,     0,
       0,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   234,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,     0,     0,     0,   302,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,  1179,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,   421,
     422,   423,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,     0,   471,   472,   473,     0,     0,
     474,   475,   476,     0,     0,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,     0,   496,   497,   498,   499,   500,
     501,   502,   503,   504,     0,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     0,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,     0,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,     0,
     584,   585,     0,     0,   586,   587,   588,   589,   590,   591,
     592,   593,     0,   594,   595,   596,     0,     0,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,     0,   611,   612,   613,   614,   615,
       0,     0,   616,   617,   618,   619,   620,   621,   622,     0,
     623,   624,   625,   626,   627,   628,   629,     0,     0,   630,
       0,     0,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   967,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,   357,     0,   358,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
     421,   422,   423,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,     0,   471,   472,   473,     0,
       0,   474,   475,   476,     0,     0,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,     0,   496,   497,   498,   499,
     500,   501,   502,   503,   504,     0,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,     0,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,     0,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,     0,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,     0,     0,
     630,     0,     0,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   658,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,  2836,   275,   276,   277,   278,   279,     0,     0,
    2837,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,   291,  2838,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,   337,     0,  2839,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,  2840,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,  2841,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,  2842,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,   470,     0,   471,   472,   473,
       0,     0,   474,   475,   476,     0,     0,   477,   478,   479,
       0,   481,     0,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,   496,   497,   498,
     499,   500,   501,   502,   503,   504,  2843,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,     0,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,     0,   533,   534,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,     0,   563,
     564,   565,   566,     0,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,     0,   584,   585,     0,     0,   586,     0,   588,   589,
     590,   591,   592,   593,     0,   594,   595,   596,     0,     0,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,  2844,   611,   612,   613,
     614,   615,     0,     0,   616,   617,   618,   619,   620,   621,
     622,     0,   623,     0,   625,   626,   627,   628,   629,     0,
       0,   630,     0,     0,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   658,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,  2836,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,  2838,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,  2839,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,  2840,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,  3891,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,  2842,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,   474,   475,   476,     0,     0,   477,   478,
     479,     0,   481,     0,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,   499,   500,   501,   502,   503,   504,  2843,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,     0,
     563,   564,   565,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,     0,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,  2844,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,     0,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   658,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,  2836,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,   291,  2838,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,   337,     0,  2839,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,  2840,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,  2842,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,   470,     0,   471,
     472,   473,     0,     0,   474,   475,   476,     0,     0,   477,
     478,   479,     0,   481,     0,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,     0,   496,
     497,   498,   499,   500,   501,   502,   503,   504,  2843,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,     0,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,     0,   533,
     534,     0,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
       0,   563,   564,   565,   566,     0,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,     0,   584,   585,     0,     0,   586,     0,
     588,   589,   590,   591,   592,   593,     0,   594,   595,   596,
       0,     0,   597,   598,   599,   600,   601,     0,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,  2844,   611,
     612,   613,   614,   615,     0,     0,   616,   617,   618,   619,
     620,   621,   622,     0,   623,     0,   625,   626,   627,   628,
     629,     0,     0,   630,     0,     0,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   658,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   797,   244,   798,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   799,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,   830,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,   470,     0,
     471,   472,   473,     0,     0,   474,   475,   476,     0,     0,
     477,   478,   479,     0,   481,     0,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,     0,
     496,   497,   498,   499,   500,   501,   502,   503,   504,     0,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   800,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,     0,
     533,   534,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   801,
     552,   553,   554,   555,   556,     0,   557,   558,   559,   560,
     561,     0,   563,   564,   565,   566,     0,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,     0,   584,   585,     0,     0,   586,
       0,   588,   589,   590,   591,   592,   593,     0,   594,   595,
     596,     0,     0,   597,   598,   599,   600,   601,     0,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,     0,
     611,   612,   613,   614,   615,     0,     0,   616,   617,   618,
     619,   620,   621,   622,     0,   623,     0,   625,   626,   627,
     628,   629,     0,     0,   630,     0,     0,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   658,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   797,   244,   798,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,   799,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,  3572,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,   470,
       0,   471,   472,   473,     0,     0,   474,   475,   476,     0,
       0,   477,   478,   479,     0,   481,     0,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
       0,   496,   497,   498,   499,   500,   501,   502,   503,   504,
       0,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   800,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
       0,   533,   534,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     801,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,     0,   563,   564,   565,   566,     0,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,     0,   584,   585,     0,     0,
     586,     0,   588,   589,   590,   591,   592,   593,     0,   594,
     595,   596,     0,     0,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
       0,   611,   612,   613,   614,   615,     0,     0,   616,   617,
     618,   619,   620,   621,   622,     0,   623,     0,   625,   626,
     627,   628,   629,     0,     0,   630,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   658,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   797,   244,   798,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   799,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
     470,     0,   471,   472,   473,     0,     0,   474,   475,   476,
       0,     0,   477,   478,   479,     0,   481,     0,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,   496,   497,   498,   499,   500,   501,   502,   503,
     504,     0,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   800,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,     0,   533,   534,     0,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   801,   552,   553,   554,   555,   556,     0,   557,   558,
     559,   560,   561,     0,   563,   564,   565,   566,     0,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,     0,   584,   585,     0,
       0,   586,     0,   588,   589,   590,   591,   592,   593,     0,
     594,   595,   596,     0,     0,   597,   598,   599,   600,   601,
       0,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,     0,     0,   616,
     617,   618,   619,   620,   621,   622,     0,   623,     0,   625,
     626,   627,   628,   629,     0,     0,   630,     0,     0,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   658,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,  3079,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,  2909,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,   470,     0,   471,   472,   473,     0,   862,   474,   475,
     476,     0,     0,   477,   478,   479,     0,   481,     0,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,   496,   497,   498,   499,   500,   501,   502,
     503,   504,     0,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,     0,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,     0,   533,   534,     0,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,     0,   563,   564,   565,   566,     0,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,     0,   584,   585,
       0,  2910,  2911,     0,   588,   589,   590,   591,   592,   593,
       0,   594,   595,   596,     0,     0,   597,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,     0,   611,   612,   613,   614,   615,     0,     0,
     616,   617,   618,   619,   620,   621,   622,     0,   623,     0,
     625,   626,   627,   628,   629,     0,     0,   630,     0,     0,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     658,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,  2007,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,  2008,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,  2009,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,  2010,   355,   356,     0,     0,     0,  2011,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,  2012,  2013,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,   470,     0,   471,   472,   473,     0,     0,   474,
     475,   476,     0,     0,   477,   478,   479,     0,   481,     0,
     483,   484,   485,   486,   487,  2014,   489,   490,   491,   492,
     493,   494,   495,     0,   496,   497,   498,   499,   500,   501,
     502,   503,   504,     0,   505,   506,   507,  2015,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,     0,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,     0,   533,   534,     0,   536,   537,   538,
    2016,   540,   541,   542,   543,   544,   545,  2017,   547,   548,
     549,   550,   551,     0,  2018,   553,   554,   555,   556,     0,
     557,   558,   559,   560,   561,     0,   563,   564,   565,   566,
       0,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,     0,   584,
     585,     0,  2019,   586,     0,  2020,   589,   590,   591,   592,
     593,     0,   594,   595,   596,     0,     0,   597,   598,   599,
     600,   601,     0,   602,   603,  2021,   605,   606,   607,   608,
     609,   610,     0,     0,   611,   612,   613,   614,   615,     0,
       0,   616,   617,   618,   619,   620,   621,   622,     0,   623,
       0,   625,   626,   627,   628,   629,     0,     0,   630,     0,
       0,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   658,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   798,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,   799,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,   470,     0,   471,   472,   473,     0,     0,
     474,   475,   476,     0,     0,   477,   478,   479,     0,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,     0,   496,   497,   498,   499,   500,
     501,   502,   503,   504,     0,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     800,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     0,   533,   534,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   801,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,     0,   563,   564,   565,
     566,     0,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,     0,
     584,   585,     0,     0,   586,     0,   588,   589,   590,   591,
     592,   593,     0,   594,   595,   596,     0,     0,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,     0,   611,   612,   613,   614,   615,
       0,     0,   616,   617,   618,   619,   620,   621,   622,     0,
     623,     0,   625,   626,   627,   628,   629,     0,     0,   630,
       0,     0,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   658,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,  2909,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,   470,     0,   471,   472,   473,     0,
     862,   474,   475,   476,     0,     0,   477,   478,   479,     0,
     481,     0,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,     0,   496,   497,   498,   499,
     500,   501,   502,   503,   504,     0,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,     0,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,     0,   533,   534,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,     0,   557,   558,   559,   560,   561,     0,   563,   564,
     565,   566,     0,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,  2910,  2911,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,   629,     0,     0,
     630,     0,     0,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   658,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,  1020,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,  1021,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,   470,     0,   471,   472,   473,
       0,   862,   474,   475,   476,     0,     0,   477,   478,   479,
       0,   481,     0,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,   496,   497,   498,
     499,   500,   501,   502,   503,   504,     0,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,     0,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,     0,   533,   534,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,     0,   563,
     564,   565,   566,     0,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,     0,   584,   585,     0,     0,   586,     0,   588,   589,
     590,   591,   592,   593,     0,   594,   595,   596,     0,     0,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,     0,   611,   612,   613,
     614,   615,     0,     0,   616,   617,   618,   619,   620,   621,
     622,     0,   623,     0,   625,   626,   627,   628,   629,     0,
       0,   630,     0,     0,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   658,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
    3655,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,   474,   475,   476,     0,     0,   477,   478,
     479,     0,   481,     0,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,   499,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,     0,
     563,   564,   565,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,     0,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,  3656,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,     0,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   658,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,  3668,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,   470,     0,   471,
     472,   473,     0,     0,   474,   475,   476,     0,     0,   477,
     478,   479,     0,   481,     0,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,     0,   496,
     497,   498,   499,   500,   501,   502,   503,   504,     0,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,     0,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,     0,   533,
     534,     0,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
       0,   563,   564,   565,   566,     0,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,     0,   584,   585,     0,     0,   586,     0,
     588,   589,   590,   591,   592,   593,     0,   594,   595,   596,
       0,     0,   597,   598,   599,   600,   601,     0,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,     0,   611,
     612,   613,   614,   615,  3669,     0,   616,   617,   618,   619,
     620,   621,   622,     0,   623,     0,   625,   626,   627,   628,
     629,     0,     0,   630,     0,     0,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   658,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   659,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,   470,     0,
     471,   472,   473,     0,     0,   474,   475,   476,     0,     0,
     477,   478,   479,     0,   481,     0,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,     0,
     496,   497,   498,   499,   500,   501,   502,   503,   504,     0,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,     0,
     533,   534,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,     0,   557,   558,   559,   560,
     561,     0,   563,   564,   565,   566,     0,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,     0,   584,   585,     0,     0,   586,
       0,   588,   589,   590,   591,   592,   593,     0,   594,   595,
     596,     0,     0,   597,   598,   599,   600,   601,     0,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,     0,
     611,   612,   613,   614,   615,     0,     0,   616,   617,   618,
     619,   620,   621,   622,     0,   623,     0,   625,   626,   627,
     628,   629,     0,     0,   630,     0,     0,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   658,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   708,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,   470,
       0,   471,   472,   473,     0,     0,   474,   475,   476,     0,
       0,   477,   478,   479,     0,   481,     0,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
       0,   496,   497,   498,   499,   500,   501,   502,   709,   504,
       0,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,     0,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
       0,   533,   534,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,     0,   563,   564,   565,   566,     0,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,     0,   584,   585,     0,     0,
     586,     0,   588,   589,   590,   591,   592,   593,     0,   594,
     595,   596,     0,     0,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
       0,   611,   612,   613,   614,   615,     0,     0,   616,   617,
     618,   619,   620,   621,   622,     0,   623,     0,   625,   626,
     627,   628,   629,     0,     0,   630,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   658,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   822,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
     470,     0,   471,   472,   473,     0,     0,   474,   475,   476,
       0,     0,   477,   478,   479,     0,   481,     0,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,   496,   497,   498,   499,   500,   501,   502,   503,
     504,     0,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,     0,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,     0,   533,   534,     0,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   823,     0,   557,   558,
     559,   560,   561,     0,   563,   564,   565,   566,     0,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,     0,   584,   585,     0,
       0,   586,     0,   588,   589,   590,   591,   592,   593,     0,
     594,   824,   596,     0,     0,   825,   598,   599,   600,   601,
       0,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,     0,     0,   616,
     617,   618,   619,   620,   621,   622,     0,   623,     0,   625,
     626,   627,   628,   629,     0,     0,   630,     0,     0,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   658,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   856,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,   470,     0,   471,   472,   473,     0,     0,   474,   475,
     476,     0,     0,   477,   478,   479,     0,   481,     0,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,   496,   497,   498,   499,   500,   501,   502,
     503,   504,     0,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,     0,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,     0,   533,   534,     0,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   857,     0,   557,
     558,   559,   560,   561,     0,   563,   564,   565,   566,     0,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,     0,   584,   585,
       0,     0,   586,     0,   588,   589,   590,   591,   592,   593,
       0,   594,   858,   596,     0,     0,   859,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,     0,   611,   612,   613,   614,   615,     0,     0,
     616,   617,   618,   619,   620,   621,   622,     0,   623,     0,
     625,   626,   627,   628,   629,     0,     0,   630,     0,     0,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     658,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,   470,     0,   471,   472,   473,     0,   862,   474,
     475,   476,     0,     0,   477,   478,   479,     0,   481,     0,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,     0,   496,   497,   498,   499,   500,   501,
     502,   503,   504,     0,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,     0,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,     0,   533,   534,     0,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,     0,
     557,   558,   559,   560,   561,     0,   563,   564,   565,   566,
       0,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,     0,   584,
     585,     0,     0,   586,     0,   588,   589,   590,   591,   592,
     593,     0,   594,   595,   596,     0,     0,   597,   598,   599,
     600,   601,     0,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,     0,   611,   612,   613,   614,   615,     0,
       0,   616,   617,   618,   619,   620,   621,   622,     0,   623,
       0,   625,   626,   627,   628,   629,     0,     0,   630,     0,
       0,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   658,     0,     0,     0,     0,     0,     0,     0,     0,
     922,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,   470,     0,   471,   472,   473,     0,     0,
     474,   475,   476,     0,     0,   477,   478,   479,     0,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,     0,   496,   497,   498,   499,   500,
     501,   502,   503,   504,     0,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     0,   533,   534,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,     0,   563,   564,   565,
     566,     0,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,     0,
     584,   585,     0,     0,   586,     0,   588,   589,   590,   591,
     592,   593,     0,   594,   595,   596,     0,     0,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,     0,   611,   612,   613,   614,   615,
       0,     0,   616,   617,   618,   619,   620,   621,   622,     0,
     623,     0,   625,   626,   627,   628,   629,     0,     0,   630,
       0,     0,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   658,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   977,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   978,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,   470,     0,   471,   472,   473,     0,
       0,   474,   475,   476,     0,     0,   477,   478,   479,     0,
     481,     0,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,     0,   496,   497,   498,   499,
     500,   501,   502,   503,   504,     0,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,     0,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,     0,   533,   534,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,     0,   557,   558,   559,   560,   561,     0,   563,   564,
     565,   566,     0,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,   629,     0,     0,
     630,     0,     0,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   658,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,  1140,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,   470,     0,   471,   472,   473,
       0,     0,   474,   475,   476,     0,     0,   477,   478,   479,
       0,   481,     0,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,   496,   497,   498,
     499,   500,   501,   502,   503,   504,     0,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,     0,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,     0,   533,   534,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,     0,   563,
     564,   565,   566,     0,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,     0,   584,   585,     0,     0,   586,     0,   588,   589,
     590,   591,   592,   593,     0,   594,   595,   596,     0,     0,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,     0,   611,   612,   613,
     614,   615,     0,     0,   616,   617,   618,   619,   620,   621,
     622,     0,   623,     0,   625,   626,   627,   628,   629,     0,
       0,   630,     0,     0,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   658,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
    1390,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,   474,   475,   476,     0,     0,   477,   478,
     479,     0,   481,     0,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,   499,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,     0,
     563,   564,   565,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,     0,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,     0,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   658,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
    1401,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   842,
     271,   272,   273,  1402,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     845,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,   470,     0,   471,
     472,   473,     0,     0,   474,   475,   476,     0,     0,   477,
     478,   479,     0,   481,     0,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,     0,   496,
     497,   498,   499,   500,   501,   502,   503,   504,     0,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,     0,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,     0,   533,
     534,     0,   846,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   847,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,  1394,     0,   557,   558,   559,   560,   561,
       0,   563,   564,   565,   566,     0,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,     0,   584,   585,     0,     0,   586,     0,
     588,   589,   590,   591,   592,   593,     0,   594,   849,   596,
       0,     0,   850,   598,   599,   600,   601,     0,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,     0,   611,
     612,   613,   614,   615,     0,     0,   616,   617,   618,   619,
     620,   621,   622,     0,   623,     0,   625,   626,   627,   628,
     629,     0,     0,   630,     0,     0,   631,   632,   633,   634,
     635,   851,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   658,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,  1547,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,   470,     0,
     471,   472,   473,     0,   862,   474,   475,   476,     0,     0,
     477,   478,   479,     0,   481,     0,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,     0,
     496,   497,   498,   499,   500,   501,   502,   503,   504,     0,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,     0,
     533,   534,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,     0,   557,   558,   559,   560,
     561,     0,   563,   564,   565,   566,     0,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,     0,   584,   585,     0,     0,   586,
       0,   588,   589,   590,   591,   592,   593,     0,   594,   595,
     596,     0,     0,   597,   598,   599,   600,   601,     0,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,     0,
     611,   612,   613,   614,   615,     0,     0,   616,   617,   618,
     619,   620,   621,   622,     0,   623,     0,   625,   626,   627,
     628,   629,     0,     0,   630,     0,     0,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   658,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,  1608,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
    1609,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,   470,
       0,   471,   472,   473,     0,     0,   474,   475,   476,     0,
       0,   477,   478,   479,     0,   481,     0,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
       0,   496,   497,   498,   499,   500,   501,   502,   503,   504,
       0,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,     0,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
       0,   533,   534,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,     0,   563,   564,   565,   566,     0,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,     0,   584,   585,     0,     0,
     586,     0,   588,   589,   590,   591,   592,   593,     0,   594,
     595,   596,     0,     0,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
       0,   611,   612,   613,   614,   615,     0,     0,   616,   617,
     618,   619,   620,   621,   622,     0,   623,     0,   625,   626,
     627,   628,   629,     0,     0,   630,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   658,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   822,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
     470,     0,   471,   472,   473,     0,     0,   474,   475,   476,
       0,     0,   477,   478,   479,     0,   481,     0,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,   496,   497,   498,   499,   500,   501,   502,   503,
     504,     0,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,     0,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,     0,   533,   534,     0,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,     0,   557,   558,
     559,   560,   561,     0,   563,   564,   565,   566,     0,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,     0,   584,   585,     0,
       0,   586,     0,   588,   589,   590,   591,   592,   593,     0,
     594,   595,   596,     0,     0,   597,   598,   599,   600,   601,
       0,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,     0,     0,   616,
     617,   618,   619,   620,   621,   622,     0,   623,     0,   625,
     626,   627,   628,   629,     0,     0,   630,     0,     0,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   658,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,  3419,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,  3420,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,   470,     0,   471,   472,   473,     0,     0,   474,   475,
     476,     0,     0,   477,   478,   479,     0,   481,     0,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,   496,   497,   498,   499,   500,   501,   502,
     503,   504,     0,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,     0,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,     0,   533,   534,     0,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,     0,   563,   564,   565,   566,     0,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,     0,   584,   585,
       0,  3421,   586,     0,   588,   589,  3422,   591,  3423,   593,
       0,   594,   595,   596,     0,     0,   597,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,     0,   611,   612,  3424,   614,   615,     0,     0,
     616,   617,   618,   619,   620,   621,   622,     0,   623,     0,
     625,   626,   627,   628,   629,     0,     0,   630,     0,     0,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     658,     0,     0,   717,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,   470,     0,   471,   472,   473,     0,     0,   474,
     475,   476,     0,     0,   477,   478,   479,     0,   481,     0,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,     0,   496,   497,   498,   499,   500,   501,
     502,   503,   504,     0,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,     0,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,     0,   533,   534,     0,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,     0,
     557,   558,   559,   560,   561,     0,   563,   564,   565,   566,
       0,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,     0,   584,
     585,     0,     0,   586,     0,   588,   589,   590,   591,   592,
     593,     0,   594,   595,   596,     0,     0,   597,   598,   599,
     600,   601,     0,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,     0,   611,   612,   613,   614,   615,     0,
       0,   616,   617,   618,   619,   620,   621,   622,     0,   623,
       0,   625,   626,   627,   628,   629,     0,     0,   630,     0,
       0,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   658,     0,     0,     0,     0,     0,     0,     0,   778,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,   470,     0,   471,   472,   473,     0,     0,
     474,   475,   476,     0,     0,   477,   478,   479,     0,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,     0,   496,   497,   498,   499,   500,
     501,   502,   503,   504,     0,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     0,   533,   534,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,     0,   563,   564,   565,
     566,     0,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,     0,
     584,   585,     0,     0,   586,     0,   588,   589,   590,   591,
     592,   593,     0,   594,   595,   596,     0,     0,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,     0,   611,   612,   613,   614,   615,
       0,     0,   616,   617,   618,   619,   620,   621,   622,     0,
     623,     0,   625,   626,   627,   628,   629,     0,     0,   630,
       0,     0,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   658,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,  4246,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,   470,     0,   471,   472,   473,     0,
       0,   474,   475,   476,     0,     0,   477,   478,   479,     0,
     481,     0,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,     0,   496,   497,   498,   499,
     500,   501,   502,   503,   504,     0,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,     0,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,     0,   533,   534,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,     0,   557,   558,   559,   560,   561,     0,   563,   564,
     565,   566,     0,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,   629,     0,     0,
     630,     0,     0,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   658,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,  4260,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,   470,     0,   471,   472,   473,
       0,     0,   474,   475,   476,     0,     0,   477,   478,   479,
       0,   481,     0,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,   496,   497,   498,
     499,   500,   501,   502,   503,   504,     0,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,     0,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,     0,   533,   534,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,     0,   563,
     564,   565,   566,     0,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,     0,   584,   585,     0,     0,   586,     0,   588,   589,
     590,   591,   592,   593,     0,   594,   595,   596,     0,     0,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,     0,   611,   612,   613,
     614,   615,     0,     0,   616,   617,   618,   619,   620,   621,
     622,     0,   623,     0,   625,   626,   627,   628,   629,     0,
       0,   630,     0,     0,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   658,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,  4408,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,   474,   475,   476,     0,     0,   477,   478,
     479,     0,   481,     0,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,   499,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,     0,
     563,   564,   565,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,     0,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,     0,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   658,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,  4935,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,   470,     0,   471,
     472,   473,     0,     0,   474,   475,   476,     0,     0,   477,
     478,   479,     0,   481,     0,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,     0,   496,
     497,   498,   499,   500,   501,   502,   503,   504,     0,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,     0,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,     0,   533,
     534,     0,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
       0,   563,   564,   565,   566,     0,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,     0,   584,   585,     0,     0,   586,     0,
     588,   589,   590,   591,   592,   593,     0,   594,   595,   596,
       0,     0,   597,   598,   599,   600,   601,     0,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,     0,   611,
     612,   613,   614,   615,     0,     0,   616,   617,   618,   619,
     620,   621,   622,     0,   623,     0,   625,   626,   627,   628,
     629,     0,     0,   630,     0,     0,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   658,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
    5008,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,   470,     0,
     471,   472,   473,     0,     0,   474,   475,   476,     0,     0,
     477,   478,   479,     0,   481,     0,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,     0,
     496,   497,   498,   499,   500,   501,   502,   503,   504,     0,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,     0,
     533,   534,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,     0,   557,   558,   559,   560,
     561,     0,   563,   564,   565,   566,     0,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,     0,   584,   585,     0,     0,   586,
       0,   588,   589,   590,   591,   592,   593,     0,   594,   595,
     596,     0,     0,   597,   598,   599,   600,   601,     0,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,     0,
     611,   612,   613,   614,   615,     0,     0,   616,   617,   618,
     619,   620,   621,   622,     0,   623,     0,   625,   626,   627,
     628,   629,     0,     0,   630,     0,     0,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   658,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,  5373,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,   470,
       0,   471,   472,   473,     0,     0,   474,   475,   476,     0,
       0,   477,   478,   479,     0,   481,     0,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
       0,   496,   497,   498,   499,   500,   501,   502,   503,   504,
       0,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,     0,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
       0,   533,   534,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,     0,   563,   564,   565,   566,     0,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,     0,   584,   585,     0,     0,
     586,     0,   588,   589,   590,   591,   592,   593,     0,   594,
     595,   596,     0,     0,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
       0,   611,   612,   613,   614,   615,     0,     0,   616,   617,
     618,   619,   620,   621,   622,     0,   623,     0,   625,   626,
     627,   628,   629,     0,     0,   630,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   658,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
     470,     0,   471,   472,   473,     0,     0,   474,   475,   476,
       0,     0,   477,   478,   479,     0,   481,     0,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,   496,   497,   498,   499,   500,   501,   502,   503,
     504,     0,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,     0,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,     0,   533,   534,     0,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,     0,   557,   558,
     559,   560,   561,     0,   563,   564,   565,   566,     0,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,     0,   584,   585,     0,
       0,   586,     0,   588,   589,   590,   591,   592,   593,     0,
     594,   595,   596,     0,     0,   597,   598,   599,   600,   601,
       0,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,     0,     0,   616,
     617,   618,   619,   620,   621,   622,     0,   623,     0,   625,
     626,   627,   628,   629,     0,     0,   630,     0,     0,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   658,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,   470,     0,   471,   472,   473,     0,     0,   474,   475,
     476,     0,     0,   477,   478,   479,     0,   481,     0,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,   496,   497,   498,   499,   500,   501,   502,
     503,   504,     0,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,     0,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,     0,   533,   534,     0,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,     0,   563,   564,   565,   566,     0,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,     0,   584,   585,
       0,     0,   586,     0,   588,   589,   590,   591,   592,   593,
       0,   594,   595,   596,     0,     0,   814,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,     0,   611,   612,   613,   614,   615,     0,     0,
     616,   617,   618,   619,   620,   621,   622,     0,   623,     0,
     625,   626,   627,   628,   629,     0,     0,   630,     0,     0,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     658,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,   470,     0,   471,   472,   473,     0,     0,   474,
     475,   476,     0,     0,   477,   478,   479,     0,   481,     0,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,     0,   496,   497,   498,   499,   500,   501,
     502,   503,   504,     0,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,     0,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,     0,   533,   534,     0,   536,   537,   538,
     539,   540,   541,   542,   543,   820,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,     0,
     557,   558,   559,   560,   561,     0,   563,   564,   565,   566,
       0,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,     0,   584,
     585,     0,     0,   586,     0,   588,   589,   590,   591,   592,
     593,     0,   594,   595,   596,     0,     0,   597,   598,   599,
     600,   601,     0,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,     0,   611,   612,   613,   614,   615,     0,
       0,   616,   617,   618,   619,   620,   621,   622,     0,   623,
       0,   625,   626,   627,   628,   629,     0,     0,   630,     0,
       0,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   658,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   842,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,   291,
       0,   843,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   844,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   845,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,   470,     0,   471,   472,   473,     0,     0,
     474,   475,   476,     0,     0,   477,   478,   479,     0,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,     0,   496,   497,   498,   499,   500,
     501,   502,   503,   504,     0,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     0,   533,   534,     0,   846,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   847,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   848,
       0,   557,   558,   559,   560,   561,     0,   563,   564,   565,
     566,     0,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,     0,
     584,   585,     0,     0,   586,     0,   588,   589,   590,   591,
     592,   593,     0,   594,   849,   596,     0,     0,   850,   598,
     599,   600,   601,     0,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,     0,   611,   612,   613,   614,   615,
       0,     0,   616,   617,   618,   619,   620,   621,   622,     0,
     623,     0,   625,   626,   627,   628,   629,     0,     0,   630,
       0,     0,   631,   632,   633,   634,   635,   851,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   658,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,   470,     0,   471,   472,   473,     0,
       0,   474,   475,   476,     0,     0,   477,   478,   479,     0,
     481,     0,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,     0,   496,   497,   498,   499,
     500,   501,   502,   503,   504,     0,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   874,
     519,     0,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,     0,   533,   534,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,     0,   557,   558,   559,   560,   561,     0,   563,   564,
     565,   566,     0,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,   629,     0,     0,
     630,     0,     0,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   658,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,  1002,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,   470,     0,   471,   472,   473,
       0,     0,   474,   475,   476,     0,     0,   477,   478,   479,
       0,   481,     0,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,   496,   497,   498,
     499,   500,   501,   502,   503,   504,     0,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,     0,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,     0,   533,   534,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,     0,   563,
     564,   565,   566,     0,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,     0,   584,   585,     0,     0,   586,     0,   588,   589,
     590,   591,   592,   593,     0,   594,   595,   596,     0,     0,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,     0,   611,   612,   613,
     614,   615,     0,     0,   616,   617,   618,   619,   620,   621,
     622,     0,   623,     0,   625,   626,   627,   628,   629,     0,
       0,   630,     0,     0,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   658,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,  1012,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,   474,   475,   476,     0,     0,   477,   478,
     479,     0,   481,     0,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,   499,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,     0,
     563,   564,   565,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,     0,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,     0,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   658,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,  1015,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,   470,     0,   471,
     472,   473,     0,     0,   474,   475,   476,     0,     0,   477,
     478,   479,     0,   481,     0,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,     0,   496,
     497,   498,   499,   500,   501,   502,   503,   504,     0,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,     0,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,     0,   533,
     534,     0,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
       0,   563,   564,   565,   566,     0,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,     0,   584,   585,     0,     0,   586,     0,
     588,   589,   590,   591,   592,   593,     0,   594,   595,   596,
       0,     0,   597,   598,   599,   600,   601,     0,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,     0,   611,
     612,   613,   614,   615,     0,     0,   616,   617,   618,   619,
     620,   621,   622,     0,   623,     0,   625,   626,   627,   628,
     629,     0,     0,   630,     0,     0,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   658,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,  1031,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,   470,     0,
     471,   472,   473,     0,     0,   474,   475,   476,     0,     0,
     477,   478,   479,     0,   481,     0,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,     0,
     496,   497,   498,   499,   500,   501,   502,   503,   504,     0,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,     0,
     533,   534,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,     0,   557,   558,   559,   560,
     561,     0,   563,   564,   565,   566,     0,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,     0,   584,   585,     0,     0,   586,
       0,   588,   589,   590,   591,   592,   593,     0,   594,   595,
     596,     0,     0,   597,   598,   599,   600,   601,     0,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,     0,
     611,   612,   613,   614,   615,     0,     0,   616,   617,   618,
     619,   620,   621,   622,     0,   623,     0,   625,   626,   627,
     628,   629,     0,     0,   630,     0,     0,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   658,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
    1088,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,   470,
       0,   471,   472,   473,     0,     0,   474,   475,   476,     0,
       0,   477,   478,   479,     0,   481,     0,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
       0,   496,   497,   498,   499,   500,   501,   502,   503,   504,
       0,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,     0,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
       0,   533,   534,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,     0,   563,   564,   565,   566,     0,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,     0,   584,   585,     0,     0,
     586,     0,   588,   589,   590,   591,   592,   593,     0,   594,
     595,   596,     0,     0,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
       0,   611,   612,   613,   614,   615,     0,     0,   616,   617,
     618,   619,   620,   621,   622,     0,   623,     0,   625,   626,
     627,   628,   629,     0,     0,   630,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   658,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,  1093,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
     470,     0,   471,   472,   473,     0,     0,   474,   475,   476,
       0,     0,   477,   478,   479,     0,   481,     0,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,   496,   497,   498,   499,   500,   501,   502,   503,
     504,     0,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,     0,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,     0,   533,   534,     0,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,     0,   557,   558,
     559,   560,   561,     0,   563,   564,   565,   566,     0,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,     0,   584,   585,     0,
       0,   586,     0,   588,   589,   590,   591,   592,   593,     0,
     594,   595,   596,     0,     0,   597,   598,   599,   600,   601,
       0,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,     0,     0,   616,
     617,   618,   619,   620,   621,   622,     0,   623,     0,   625,
     626,   627,   628,   629,     0,     0,   630,     0,     0,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   658,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,  1110,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,   470,     0,   471,   472,   473,     0,     0,   474,   475,
     476,     0,     0,   477,   478,   479,     0,   481,     0,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,   496,   497,   498,   499,   500,   501,   502,
     503,   504,     0,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,     0,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,     0,   533,   534,     0,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,     0,   563,   564,   565,   566,     0,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,     0,   584,   585,
       0,     0,   586,     0,   588,   589,   590,   591,   592,   593,
       0,   594,   595,   596,     0,     0,   597,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,     0,   611,   612,   613,   614,   615,     0,     0,
     616,   617,   618,   619,   620,   621,   622,     0,   623,     0,
     625,   626,   627,   628,   629,     0,     0,   630,     0,     0,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     658,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,  1113,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,   470,     0,   471,   472,   473,     0,     0,   474,
     475,   476,     0,     0,   477,   478,   479,     0,   481,     0,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,     0,   496,   497,   498,   499,   500,   501,
     502,   503,   504,     0,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,     0,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,     0,   533,   534,     0,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,     0,
     557,   558,   559,   560,   561,     0,   563,   564,   565,   566,
       0,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,     0,   584,
     585,     0,     0,   586,     0,   588,   589,   590,   591,   592,
     593,     0,   594,   595,   596,     0,     0,   597,   598,   599,
     600,   601,     0,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,     0,   611,   612,   613,   614,   615,     0,
       0,   616,   617,   618,   619,   620,   621,   622,     0,   623,
       0,   625,   626,   627,   628,   629,     0,     0,   630,     0,
       0,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   658,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,  1115,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,   470,     0,   471,   472,   473,     0,     0,
     474,   475,   476,     0,     0,   477,   478,   479,     0,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,     0,   496,   497,   498,   499,   500,
     501,   502,   503,   504,     0,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     0,   533,   534,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,     0,   563,   564,   565,
     566,     0,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,     0,
     584,   585,     0,     0,   586,     0,   588,   589,   590,   591,
     592,   593,     0,   594,   595,   596,     0,     0,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,     0,   611,   612,   613,   614,   615,
       0,     0,   616,   617,   618,   619,   620,   621,   622,     0,
     623,     0,   625,   626,   627,   628,   629,     0,     0,   630,
       0,     0,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   658,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,  1153,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,   470,     0,   471,   472,   473,     0,
       0,   474,   475,   476,     0,     0,   477,   478,   479,     0,
     481,     0,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,     0,   496,   497,   498,   499,
     500,   501,   502,   503,   504,     0,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,     0,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,     0,   533,   534,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,     0,   557,   558,   559,   560,   561,     0,   563,   564,
     565,   566,     0,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,   629,     0,     0,
     630,     0,     0,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   658,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,  1181,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,   470,     0,   471,   472,   473,
       0,     0,   474,   475,   476,     0,     0,   477,   478,   479,
       0,   481,     0,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,   496,   497,   498,
     499,   500,   501,   502,   503,   504,     0,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,     0,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,     0,   533,   534,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,     0,   563,
     564,   565,   566,     0,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,     0,   584,   585,     0,     0,   586,     0,   588,   589,
     590,   591,   592,   593,     0,   594,   595,   596,     0,     0,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,     0,   611,   612,   613,
     614,   615,     0,     0,   616,   617,   618,   619,   620,   621,
     622,     0,   623,     0,   625,   626,   627,   628,   629,     0,
       0,   630,     0,     0,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   658,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,  1183,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,   474,   475,   476,     0,     0,   477,   478,
     479,     0,   481,     0,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,   499,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,     0,
     563,   564,   565,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,     0,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,     0,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   658,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,  1193,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,   470,     0,   471,
     472,   473,     0,     0,   474,   475,   476,     0,     0,   477,
     478,   479,     0,   481,     0,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,     0,   496,
     497,   498,   499,   500,   501,   502,   503,   504,     0,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,     0,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,     0,   533,
     534,     0,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
       0,   563,   564,   565,   566,     0,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,     0,   584,   585,     0,     0,   586,     0,
     588,   589,   590,   591,   592,   593,     0,   594,   595,   596,
       0,     0,   597,   598,   599,   600,   601,     0,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,     0,   611,
     612,   613,   614,   615,     0,     0,   616,   617,   618,   619,
     620,   621,   622,     0,   623,     0,   625,   626,   627,   628,
     629,     0,     0,   630,     0,     0,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   658,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,  1196,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,   470,     0,
     471,   472,   473,     0,     0,   474,   475,   476,     0,     0,
     477,   478,   479,     0,   481,     0,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,     0,
     496,   497,   498,   499,   500,   501,   502,   503,   504,     0,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,     0,
     533,   534,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,     0,   557,   558,   559,   560,
     561,     0,   563,   564,   565,   566,     0,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,     0,   584,   585,     0,     0,   586,
       0,   588,   589,   590,   591,   592,   593,     0,   594,   595,
     596,     0,     0,   597,   598,   599,   600,   601,     0,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,     0,
     611,   612,   613,   614,   615,     0,     0,   616,   617,   618,
     619,   620,   621,   622,     0,   623,     0,   625,   626,   627,
     628,   629,     0,     0,   630,     0,     0,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   658,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
    1199,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,   470,
       0,   471,   472,   473,     0,     0,   474,   475,   476,     0,
       0,   477,   478,   479,     0,   481,     0,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
       0,   496,   497,   498,   499,   500,   501,   502,   503,   504,
       0,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,     0,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
       0,   533,   534,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,     0,   563,   564,   565,   566,     0,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,     0,   584,   585,     0,     0,
     586,     0,   588,   589,   590,   591,   592,   593,     0,   594,
     595,   596,     0,     0,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
       0,   611,   612,   613,   614,   615,     0,     0,   616,   617,
     618,   619,   620,   621,   622,     0,   623,     0,   625,   626,
     627,   628,   629,     0,     0,   630,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   658,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   842,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   845,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
     470,     0,   471,   472,   473,     0,     0,   474,   475,   476,
       0,     0,   477,   478,   479,     0,   481,     0,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,   496,   497,   498,   499,   500,   501,   502,   503,
     504,     0,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,     0,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,     0,   533,   534,     0,   846,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   847,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,  1394,     0,   557,   558,
     559,   560,   561,     0,   563,   564,   565,   566,     0,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,     0,   584,   585,     0,
       0,   586,     0,   588,   589,   590,   591,   592,   593,     0,
     594,   849,   596,     0,     0,   850,   598,   599,   600,   601,
       0,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,     0,     0,   616,
     617,   618,   619,   620,   621,   622,     0,   623,     0,   625,
     626,   627,   628,   629,     0,     0,   630,     0,     0,   631,
     632,   633,   634,   635,   851,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   658,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,  1872,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,   470,     0,   471,   472,   473,     0,     0,   474,   475,
     476,     0,     0,   477,   478,   479,     0,   481,     0,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,   496,   497,   498,   499,   500,   501,   502,
     503,   504,     0,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,     0,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,     0,   533,   534,     0,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,     0,   563,   564,   565,   566,     0,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,     0,   584,   585,
       0,     0,   586,     0,   588,   589,   590,   591,   592,   593,
       0,   594,   595,   596,     0,     0,   597,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,     0,   611,   612,   613,   614,   615,     0,     0,
     616,   617,   618,   619,   620,   621,   622,     0,   623,     0,
     625,   626,   627,   628,   629,     0,     0,   630,     0,     0,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     658,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,  1906,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,   470,     0,   471,   472,   473,     0,     0,   474,
     475,   476,     0,     0,   477,   478,   479,     0,   481,     0,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,     0,   496,   497,   498,   499,   500,   501,
     502,   503,   504,     0,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,     0,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,     0,   533,   534,     0,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,     0,
     557,   558,   559,   560,   561,     0,   563,   564,   565,   566,
       0,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,     0,   584,
     585,     0,     0,   586,     0,   588,   589,   590,   591,   592,
     593,     0,   594,   595,   596,     0,     0,   597,   598,   599,
     600,   601,     0,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,     0,   611,   612,   613,   614,   615,     0,
       0,   616,   617,   618,   619,   620,   621,   622,     0,   623,
       0,   625,   626,   627,   628,   629,     0,     0,   630,     0,
       0,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   658,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,  1908,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,   470,     0,   471,   472,   473,     0,     0,
     474,   475,   476,     0,     0,   477,   478,   479,     0,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,     0,   496,   497,   498,   499,   500,
     501,   502,   503,   504,     0,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     0,   533,   534,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,     0,   563,   564,   565,
     566,     0,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,     0,
     584,   585,     0,     0,   586,     0,   588,   589,   590,   591,
     592,   593,     0,   594,   595,   596,     0,     0,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,     0,   611,   612,   613,   614,   615,
       0,     0,   616,   617,   618,   619,   620,   621,   622,     0,
     623,     0,   625,   626,   627,   628,   629,     0,     0,   630,
       0,     0,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   658,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,  1948,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,   470,     0,   471,   472,   473,     0,
       0,   474,   475,   476,     0,     0,   477,   478,   479,     0,
     481,     0,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,     0,   496,   497,   498,   499,
     500,   501,   502,   503,   504,     0,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,     0,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,     0,   533,   534,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,     0,   557,   558,   559,   560,   561,     0,   563,   564,
     565,   566,     0,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,   629,     0,     0,
     630,     0,     0,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   658,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,  1950,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,   470,     0,   471,   472,   473,
       0,     0,   474,   475,   476,     0,     0,   477,   478,   479,
       0,   481,     0,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,   496,   497,   498,
     499,   500,   501,   502,   503,   504,     0,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,     0,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,     0,   533,   534,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,     0,   563,
     564,   565,   566,     0,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,     0,   584,   585,     0,     0,   586,     0,   588,   589,
     590,   591,   592,   593,     0,   594,   595,   596,     0,     0,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,     0,   611,   612,   613,
     614,   615,     0,     0,   616,   617,   618,   619,   620,   621,
     622,     0,   623,     0,   625,   626,   627,   628,   629,     0,
       0,   630,     0,     0,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   658,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,  1952,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,   474,   475,   476,     0,     0,   477,   478,
     479,     0,   481,     0,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,   499,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,     0,
     563,   564,   565,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,     0,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,     0,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   658,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,   470,     0,   471,
     472,   473,     0,     0,   474,   475,   476,     0,     0,   477,
     478,   479,     0,   481,     0,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,     0,   496,
     497,   498,   499,   500,   501,   502,   503,   504,     0,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,     0,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,     0,   533,
     534,     0,   536,   537,   538,   539,   540,   541,   542,   543,
    2046,   545,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
       0,   563,   564,   565,   566,     0,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,     0,   584,   585,     0,     0,   586,     0,
     588,   589,   590,   591,   592,   593,     0,   594,   595,   596,
       0,     0,   597,   598,   599,   600,   601,     0,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,     0,   611,
     612,   613,   614,   615,     0,     0,   616,   617,   618,   619,
     620,   621,   622,     0,   623,     0,   625,   626,   627,   628,
     629,     0,     0,   630,     0,     0,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   658,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,  2723,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,   470,     0,
     471,   472,   473,     0,     0,   474,   475,   476,     0,     0,
     477,   478,   479,     0,   481,     0,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,     0,
     496,   497,   498,   499,   500,   501,   502,   503,   504,     0,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,     0,
     533,   534,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,     0,     0,   558,   559,   560,
     561,     0,   563,   564,   565,   566,     0,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,     0,   584,   585,     0,     0,   586,
       0,   588,   589,   590,   591,   592,   593,     0,   594,   595,
     596,     0,     0,   597,   598,   599,   600,   601,     0,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,     0,
     611,   612,   613,   614,   615,     0,     0,   616,   617,   618,
     619,   620,   621,   622,     0,   623,     0,   625,   626,   627,
     628,   629,     0,     0,   630,     0,     0,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   658,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   842,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   845,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,   470,
       0,   471,   472,   473,     0,     0,   474,   475,   476,     0,
       0,   477,   478,   479,     0,   481,     0,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
       0,   496,   497,   498,   499,   500,   501,   502,   503,   504,
       0,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,     0,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
       0,   533,   534,     0,   846,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   847,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,  1394,     0,   557,   558,   559,
     560,   561,     0,   563,   564,   565,   566,     0,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,     0,   584,   585,     0,     0,
     586,     0,  2757,   589,   590,   591,   592,   593,     0,   594,
     849,   596,     0,     0,   850,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
       0,   611,   612,   613,   614,   615,     0,     0,   616,   617,
     618,   619,   620,   621,   622,     0,   623,     0,   625,   626,
     627,   628,   629,     0,     0,   630,     0,     0,   631,   632,
     633,   634,   635,   851,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   658,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   842,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   845,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
     470,     0,   471,   472,   473,     0,     0,   474,   475,   476,
       0,     0,   477,   478,   479,     0,   481,     0,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,   496,   497,   498,   499,   500,   501,   502,   503,
     504,     0,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,     0,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,     0,   533,   534,     0,   846,   537,   538,   539,   540,
     541,   542,   543,   544,   545,  2819,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,  2820,     0,   557,   558,
     559,   560,   561,     0,   563,   564,   565,   566,     0,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,     0,   584,   585,     0,
       0,   586,     0,   588,   589,   590,   591,   592,   593,     0,
     594,   849,   596,     0,     0,  2821,   598,   599,   600,   601,
       0,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,     0,     0,   616,
     617,   618,   619,   620,   621,   622,     0,   623,     0,   625,
     626,   627,   628,   629,     0,     0,   630,     0,     0,   631,
     632,   633,   634,   635,   851,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   658,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   842,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   845,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,   470,     0,   471,   472,   473,     0,     0,   474,   475,
     476,     0,     0,   477,   478,   479,     0,   481,     0,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,   496,   497,   498,   499,   500,   501,   502,
     503,   504,     0,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,     0,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,     0,   533,   534,     0,   846,   537,   538,   539,
     540,   541,   542,   543,   544,   545,  2906,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,  2820,     0,   557,
     558,   559,   560,   561,     0,   563,   564,   565,   566,     0,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,     0,   584,   585,
       0,     0,   586,     0,   588,   589,   590,   591,   592,   593,
       0,   594,   849,   596,     0,     0,  2821,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,     0,   611,   612,   613,   614,   615,     0,     0,
     616,   617,   618,   619,   620,   621,   622,     0,   623,     0,
     625,   626,   627,   628,   629,     0,     0,   630,     0,     0,
     631,   632,   633,   634,   635,   851,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     658,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   842,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   845,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,   470,     0,   471,   472,   473,     0,     0,   474,
     475,   476,     0,     0,   477,   478,   479,     0,   481,     0,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,     0,   496,   497,   498,   499,   500,   501,
     502,   503,   504,     0,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,     0,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,     0,   533,   534,     0,   846,   537,   538,
     539,   540,   541,   542,   543,   544,   545,  2930,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,  2820,     0,
     557,   558,   559,   560,   561,     0,   563,   564,   565,   566,
       0,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,     0,   584,
     585,     0,     0,   586,     0,   588,   589,   590,   591,   592,
     593,     0,   594,   849,   596,     0,     0,  2821,   598,   599,
     600,   601,     0,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,     0,   611,   612,   613,   614,   615,     0,
       0,   616,   617,   618,   619,   620,   621,   622,     0,   623,
       0,   625,   626,   627,   628,   629,     0,     0,   630,     0,
       0,   631,   632,   633,   634,   635,   851,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   658,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,  3124,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,   470,     0,   471,   472,   473,     0,     0,
     474,   475,   476,     0,     0,   477,   478,   479,     0,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,     0,   496,   497,   498,   499,   500,
     501,   502,   503,   504,     0,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     0,   533,   534,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,     0,   563,   564,   565,
     566,     0,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,     0,
     584,   585,     0,     0,   586,     0,   588,   589,   590,   591,
     592,   593,     0,   594,   595,   596,     0,     0,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,     0,   611,   612,   613,   614,   615,
       0,     0,   616,   617,   618,   619,   620,   621,   622,     0,
     623,     0,   625,   626,   627,   628,   629,     0,     0,   630,
       0,     0,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   658,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,  3128,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,   470,     0,   471,   472,   473,     0,
       0,   474,   475,   476,     0,     0,   477,   478,   479,     0,
     481,     0,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,     0,   496,   497,   498,   499,
     500,   501,   502,   503,   504,     0,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,     0,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,     0,   533,   534,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,     0,   557,   558,   559,   560,   561,     0,   563,   564,
     565,   566,     0,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,   629,     0,     0,
     630,     0,     0,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   658,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,  3186,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,   470,     0,   471,   472,   473,
       0,     0,   474,   475,   476,     0,     0,   477,   478,   479,
       0,   481,     0,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,   496,   497,   498,
     499,   500,   501,   502,   503,   504,     0,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,     0,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,     0,   533,   534,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,     0,   563,
     564,   565,   566,     0,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,     0,   584,   585,     0,     0,   586,     0,   588,   589,
     590,   591,   592,   593,     0,   594,   595,   596,     0,     0,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,     0,   611,   612,   613,
     614,   615,     0,     0,   616,   617,   618,   619,   620,   621,
     622,     0,   623,     0,   625,   626,   627,   628,   629,     0,
       0,   630,     0,     0,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   658,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,  3577,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,   474,   475,   476,     0,     0,   477,   478,
     479,     0,   481,     0,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,   499,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,     0,
     563,   564,   565,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,     0,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,     0,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   658,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   842,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     845,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,   470,     0,   471,
     472,   473,     0,     0,   474,   475,   476,     0,     0,   477,
     478,   479,     0,   481,     0,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,     0,   496,
     497,   498,   499,   500,   501,   502,   503,   504,     0,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,     0,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,     0,   533,
     534,     0,   846,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   847,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,  2820,     0,   557,   558,   559,   560,   561,
       0,   563,   564,   565,   566,     0,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,     0,   584,   585,     0,     0,   586,     0,
     588,   589,   590,   591,   592,   593,     0,   594,   849,   596,
       0,     0,  2821,   598,   599,   600,   601,     0,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,     0,   611,
     612,   613,   614,   615,     0,     0,   616,   617,   618,   619,
     620,   621,   622,     0,   623,     0,   625,   626,   627,   628,
     629,     0,     0,   630,     0,     0,   631,   632,   633,   634,
     635,   851,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   658,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,  3635,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,   470,     0,
     471,   472,   473,     0,     0,   474,   475,   476,     0,     0,
     477,   478,   479,     0,   481,     0,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,     0,
     496,   497,   498,   499,   500,   501,   502,   503,   504,     0,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,     0,
     533,   534,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,     0,   557,   558,   559,   560,
     561,     0,   563,   564,   565,   566,     0,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,     0,   584,   585,     0,     0,   586,
       0,   588,   589,   590,   591,   592,   593,     0,   594,   595,
     596,     0,     0,   597,   598,   599,   600,   601,     0,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,     0,
     611,   612,   613,   614,   615,     0,     0,   616,   617,   618,
     619,   620,   621,   622,     0,   623,     0,   625,   626,   627,
     628,   629,     0,     0,   630,     0,     0,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   658,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
    3658,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,   470,
       0,   471,   472,   473,     0,     0,   474,   475,   476,     0,
       0,   477,   478,   479,     0,   481,     0,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
       0,   496,   497,   498,   499,   500,   501,   502,   503,   504,
       0,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,     0,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
       0,   533,   534,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,     0,   563,   564,   565,   566,     0,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,     0,   584,   585,     0,     0,
     586,     0,   588,   589,   590,   591,   592,   593,     0,   594,
     595,   596,     0,     0,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
       0,   611,   612,   613,   614,   615,     0,     0,   616,   617,
     618,   619,   620,   621,   622,     0,   623,     0,   625,   626,
     627,   628,   629,     0,     0,   630,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   658,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,  3660,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
     470,     0,   471,   472,   473,     0,     0,   474,   475,   476,
       0,     0,   477,   478,   479,     0,   481,     0,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,   496,   497,   498,   499,   500,   501,   502,   503,
     504,     0,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,     0,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,     0,   533,   534,     0,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,     0,   557,   558,
     559,   560,   561,     0,   563,   564,   565,   566,     0,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,     0,   584,   585,     0,
       0,   586,     0,   588,   589,   590,   591,   592,   593,     0,
     594,   595,   596,     0,     0,   597,   598,   599,   600,   601,
       0,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,     0,     0,   616,
     617,   618,   619,   620,   621,   622,     0,   623,     0,   625,
     626,   627,   628,   629,     0,     0,   630,     0,     0,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   658,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,  3810,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,   470,     0,   471,   472,   473,     0,     0,   474,   475,
     476,     0,     0,   477,   478,   479,     0,   481,     0,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,   496,   497,   498,   499,   500,   501,   502,
     503,   504,     0,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,     0,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,     0,   533,   534,     0,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,     0,   563,   564,   565,   566,     0,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,     0,   584,   585,
       0,     0,   586,     0,   588,   589,   590,   591,   592,   593,
       0,   594,   595,   596,     0,     0,   597,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,     0,   611,   612,   613,   614,   615,     0,     0,
     616,   617,   618,   619,   620,   621,   622,     0,   623,     0,
     625,   626,   627,   628,   629,     0,     0,   630,     0,     0,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     658,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,  3852,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,   470,     0,   471,   472,   473,     0,     0,   474,
     475,   476,     0,     0,   477,   478,   479,     0,   481,     0,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,     0,   496,   497,   498,   499,   500,   501,
     502,   503,   504,     0,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,     0,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,     0,   533,   534,     0,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,     0,
     557,   558,   559,   560,   561,     0,   563,   564,   565,   566,
       0,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,     0,   584,
     585,     0,     0,   586,     0,   588,   589,   590,   591,   592,
     593,     0,   594,   595,   596,     0,     0,   597,   598,   599,
     600,   601,     0,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,     0,   611,   612,   613,   614,   615,     0,
       0,   616,   617,   618,   619,   620,   621,   622,     0,   623,
       0,   625,   626,   627,   628,   629,     0,     0,   630,     0,
       0,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   658,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,  5122,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,   470,     0,   471,   472,   473,     0,     0,
     474,   475,   476,     0,     0,   477,   478,   479,     0,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,     0,   496,   497,   498,   499,   500,
     501,   502,   503,   504,     0,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     0,   533,   534,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,     0,   563,   564,   565,
     566,     0,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,     0,
     584,   585,     0,     0,   586,     0,   588,   589,   590,   591,
     592,   593,     0,   594,   595,   596,     0,     0,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,     0,   611,   612,   613,   614,   615,
       0,     0,   616,   617,   618,   619,   620,   621,   622,     0,
     623,     0,   625,   626,   627,   628,   629,     0,     0,   630,
       0,     0,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   658,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,   470,     0,   471,   472,   473,     0,
       0,   474,   475,   476,     0,     0,   477,   478,   479,     0,
     481,     0,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,  5651,     0,   496,   497,   498,   499,
     500,   501,   502,   503,   504,     0,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,     0,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,     0,   533,   534,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,     0,   557,   558,   559,   560,   561,     0,   563,   564,
     565,   566,     0,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,   629,     0,     0,
     630,     0,     0,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   658,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,  6367,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,   470,     0,   471,   472,   473,
       0,     0,   474,   475,   476,     0,     0,   477,   478,   479,
       0,   481,     0,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,   496,   497,   498,
     499,   500,   501,   502,   503,   504,     0,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,     0,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,     0,   533,   534,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,     0,   563,
     564,   565,   566,     0,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,     0,   584,   585,     0,     0,   586,     0,   588,   589,
     590,   591,   592,   593,     0,   594,   595,   596,     0,     0,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,     0,   611,   612,   613,
     614,   615,     0,     0,   616,   617,   618,   619,   620,   621,
     622,     0,   623,     0,   625,   626,   627,   628,   629,     0,
       0,   630,     0,     0,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   658,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
       0,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,   474,   475,   476,     0,     0,   477,   478,
     479,     0,   481,     0,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   492,   493,   494,   495,     0,   496,   497,
     498,   499,   500,   501,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,     0,   515,   516,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
       0,   536,   537,   538,   539,   540,   541,     0,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,     0,
     563,   564,   565,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,     0,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,     0,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   879,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,     0,   880,   260,   881,   882,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   883,   884,   274,     0,   275,   276,   277,   278,     0,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,     0,     0,     0,   302,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   885,
     886,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   887,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,   337,     0,   338,   339,   340,   341,
       0,   343,   344,   345,   346,     0,     0,   348,     0,   349,
     350,   351,   888,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,     0,     0,
       0,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,  2731,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,  2732,   389,   390,   391,
     392,   889,   890,     0,   891,     0,   396,   397,   398,   399,
     400,   892,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,     0,   421,   422,   423,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   438,   439,   440,   441,   442,   443,   444,
     445,   893,   447,   894,   449,   450,   451,   452,   453,   454,
     455,   456,     0,     0,   459,     0,   460,   461,   462,   463,
       0,     0,   465,   895,   467,   468,   469,   470,     0,   471,
     472,   473,     0,     0,   474,   475,   476,     0,     0,   477,
     478,  2734,   480,   481,   482,     0,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   500,     0,   502,   503,   504,     0,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     896,   517,   518,   519,     0,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,     0,   533,
     534,   535,   536,   537,   538,   539,   540,     0,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,  2735,   560,   561,
     562,   563,   564,   898,   566,     0,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,     0,   583,     0,   584,   585,     0,     0,   586,   587,
     588,   589,   590,   591,   592,   593,     0,   594,   899,   900,
       0,     0,   597,   598,     0,   600,     0,     0,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,     0,   611,
     612,   613,   614,   615,     0,     0,   616,   617,   618,   619,
     620,     0,   901,  2736,   623,   624,   625,   626,   627,   628,
     629,     0,     0,   630,     0,     0,   631,   632,   633,   634,
     635,   636,   879,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   648,   649,   650,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,     0,   880,   260,   881,   882,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   883,   884,
     274,     0,   275,   276,   277,   278,     0,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   885,   886,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   887,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,   337,     0,   338,   339,   340,   341,     0,   343,   344,
     345,   346,     0,     0,   348,     0,   349,   350,   351,   888,
     353,     0,   354,     0,   355,   356,   357,     0,   358,   359,
     360,   361,   362,     0,   363,     0,     0,     0,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,     0,   389,   390,   391,   392,   889,   890,
       0,   891,     0,   396,   397,   398,   399,   400,   892,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,     0,
     421,   422,   423,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     0,
     438,   439,   440,   441,   442,   443,   444,   445,   893,   447,
     894,   449,   450,   451,   452,   453,   454,   455,   456,     0,
       0,   459,     0,   460,   461,   462,   463,  2815,     0,   465,
     895,   467,   468,   469,   470,     0,   471,   472,   473,     0,
       0,   474,   475,   476,     0,     0,   477,   478,     0,   480,
     481,   482,     0,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,     0,   496,   497,   498,     0,
     500,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   896,   517,   518,
     519,     0,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,     0,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,     0,   557,   558,  2735,   560,   561,   562,   563,   564,
     898,   566,     0,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,     0,   583,
       0,   584,   585,     0,  4635,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   899,   900,     0,     0,   597,
     598,     0,   600,     0,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,     0,   901,
       0,   623,   624,   625,   626,   627,   628,   629,     0,     0,
     630,     0,     0,   631,   632,   633,   634,   635,   636,   879,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     648,   649,   650,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,     0,   880,
     260,   881,   882,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   883,   884,   274,     0,   275,
     276,   277,   278,     0,     0,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
       0,     0,     0,   302,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   885,   886,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   887,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,   337,     0,
     338,   339,   340,   341,     0,   343,   344,   345,   346,     0,
       0,   348,     0,   349,   350,   351,   888,   353,     0,   354,
       0,   355,   356,   357,     0,   358,   359,   360,   361,   362,
       0,   363,     0,     0,     0,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
       0,   389,   390,   391,   392,   889,   890,     0,   891,     0,
     396,   397,   398,   399,   400,   892,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,     0,   421,   422,   423,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   438,   439,   440,
     441,   442,   443,   444,   445,   893,   447,   894,   449,   450,
     451,   452,   453,   454,   455,   456,  2896,     0,   459,     0,
     460,   461,   462,   463,     0,     0,   465,   895,   467,   468,
     469,   470,     0,   471,   472,   473,     0,     0,   474,   475,
     476,     0,     0,   477,   478,     0,   480,   481,   482,     0,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   500,     0,   502,
     503,   504,     0,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   896,   517,   518,   519,     0,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,     0,   533,   534,   535,   536,   537,   538,   539,
     540,     0,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   897,   560,   561,   562,   563,   564,   898,   566,     0,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,     0,   583,     0,   584,   585,
       0,     0,   586,   587,   588,   589,   590,   591,   592,   593,
       0,   594,   899,   900,     0,     0,   597,   598,     0,   600,
       0,     0,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,     0,   611,   612,   613,   614,   615,     0,     0,
     616,   617,   618,   619,   620,     0,   901,     0,   623,   624,
     625,   626,   627,   628,   629,     0,     0,   630,     0,     0,
     631,   632,   633,   634,   635,   636,   879,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   648,   649,   650,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,     0,   880,   260,   881,   882,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   883,   884,   274,     0,   275,   276,   277,   278,
       0,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,     0,     0,     0,
     302,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     885,   886,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   887,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,   337,     0,   338,   339,   340,
     341,     0,   343,   344,   345,   346,     0,     0,   348,     0,
     349,   350,   351,   888,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,     0,
       0,     0,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,     0,   389,   390,
     391,   392,   889,   890,     0,   891,     0,   396,   397,   398,
     399,   400,   892,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,     0,   421,   422,   423,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   893,   447,   894,   449,   450,   451,   452,   453,
     454,   455,   456,  4430,     0,   459,     0,   460,   461,   462,
     463,     0,     0,   465,   895,   467,   468,   469,   470,     0,
     471,   472,   473,     0,     0,   474,   475,   476,     0,     0,
     477,   478,     0,   480,   481,   482,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,     0,
     496,   497,   498,     0,   500,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   896,   517,   518,   519,     0,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,     0,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,     0,   557,   558,   897,   560,
     561,   562,   563,   564,   898,   566,     0,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,     0,   583,     0,   584,   585,     0,     0,   586,
     587,   588,   589,   590,   591,   592,   593,     0,   594,   899,
     900,     0,     0,   597,   598,     0,   600,     0,     0,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,     0,
     611,   612,   613,   614,   615,     0,     0,   616,   617,   618,
     619,   620,     0,   901,     0,   623,   624,   625,   626,   627,
     628,   629,     0,     0,   630,     0,     0,   631,   632,   633,
     634,   635,   636,   879,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   648,   649,   650,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,     0,   880,   260,   881,   882,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   883,
     884,   274,     0,   275,   276,   277,   278,     0,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,     0,     0,     0,   302,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   885,   886,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   887,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,   337,     0,   338,   339,   340,   341,     0,   343,
     344,   345,   346,     0,     0,   348,     0,   349,   350,   351,
     888,   353,  6047,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,     0,     0,     0,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,     0,   389,   390,   391,   392,   889,
     890,     0,   891,     0,   396,   397,   398,   399,   400,   892,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
       0,   421,   422,   423,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   893,
     447,   894,   449,   450,   451,   452,   453,   454,   455,   456,
       0,     0,   459,     0,   460,   461,   462,   463,     0,     0,
     465,   895,   467,   468,   469,   470,     0,   471,   472,   473,
       0,     0,   474,   475,   476,     0,     0,   477,   478,     0,
     480,   481,   482,     0,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   500,     0,   502,   503,   504,     0,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   896,   517,
     518,   519,     0,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,     0,   533,   534,   535,
     536,   537,   538,   539,   540,     0,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   897,   560,   561,   562,   563,
     564,   898,   566,     0,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,     0,
     583,     0,   584,   585,     0,     0,   586,   587,   588,   589,
     590,   591,   592,   593,     0,   594,   899,   900,     0,     0,
     597,   598,     0,   600,     0,     0,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,     0,   611,   612,   613,
     614,   615,     0,     0,   616,   617,   618,   619,   620,     0,
     901,     0,   623,   624,   625,   626,   627,   628,   629,     0,
       0,   630,     0,     0,   631,   632,   633,   634,   635,   636,
     879,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   648,   649,   650,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,     0,
     880,   260,   881,   882,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   883,   884,   274,     0,
     275,   276,   277,   278,     0,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,     0,     0,     0,   302,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   885,   886,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   887,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,   337,
       0,   338,   339,   340,   341,     0,   343,   344,   345,   346,
       0,     0,   348,     0,   349,   350,   351,   888,   353,  6411,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,     0,     0,     0,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,     0,   389,   390,   391,   392,   889,   890,     0,   891,
       0,   396,   397,   398,   399,   400,   892,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,     0,   421,   422,
     423,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     0,   438,   439,
     440,   441,   442,   443,   444,   445,   893,   447,   894,   449,
     450,   451,   452,   453,   454,   455,   456,     0,     0,   459,
       0,   460,   461,   462,   463,     0,     0,   465,   895,   467,
     468,   469,   470,     0,   471,   472,   473,     0,     0,   474,
     475,   476,     0,     0,   477,   478,     0,   480,   481,   482,
       0,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,     0,   496,   497,   498,     0,   500,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   896,   517,   518,   519,     0,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,     0,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,     0,
     557,   558,   897,   560,   561,   562,   563,   564,   898,   566,
       0,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,     0,   583,     0,   584,
     585,     0,     0,   586,   587,   588,   589,   590,   591,   592,
     593,     0,   594,   899,   900,     0,     0,   597,   598,     0,
     600,     0,     0,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,     0,   611,   612,   613,   614,   615,     0,
       0,   616,   617,   618,   619,   620,     0,   901,     0,   623,
     624,   625,   626,   627,   628,   629,     0,     0,   630,     0,
       0,   631,   632,   633,   634,   635,   636,   879,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   648,   649,
     650,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,     0,   880,   260,   881,
     882,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   883,   884,   274,     0,   275,   276,   277,
     278,     0,     0,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,   301,     0,     0,
       0,   302,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   885,   886,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   887,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,   337,     0,   338,   339,
     340,   341,     0,   343,   344,   345,   346,     0,     0,   348,
       0,   349,   350,   351,   888,   353,     0,   354,     0,   355,
     356,   357,     0,   358,   359,   360,   361,   362,     0,   363,
       0,     0,     0,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,   387,     0,   389,
     390,   391,   392,   889,   890,     0,   891,     0,   396,   397,
     398,   399,   400,   892,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,     0,   421,   422,   423,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   438,   439,   440,   441,   442,
     443,   444,   445,   893,   447,   894,   449,   450,   451,   452,
     453,   454,   455,   456,     0,     0,   459,     0,   460,   461,
     462,   463,     0,     0,   465,   895,   467,   468,   469,   470,
       0,   471,   472,   473,     0,     0,   474,   475,   476,     0,
       0,   477,   478,     0,   480,   481,   482,     0,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
       0,   496,   497,   498,     0,   500,     0,   502,   503,   504,
       0,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   896,   517,   518,   519,     0,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
       0,   533,   534,   535,   536,   537,   538,   539,   540,     0,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   897,
     560,   561,   562,   563,   564,   898,   566,     0,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,     0,   583,     0,   584,   585,     0,     0,
     586,   587,   588,   589,   590,   591,   592,   593,     0,   594,
     899,   900,     0,     0,   597,   598,     0,   600,     0,     0,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
       0,   611,   612,   613,   614,   615,     0,     0,   616,   617,
     618,   619,   620,     0,   901,     0,   623,   624,   625,   626,
     627,   628,   629,     0,     0,   630,     0,     0,   631,   632,
     633,   634,   635,   636,   879,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   648,   649,   650,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,     0,   880,   260,   881,   882,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     883,   884,   274,     0,   275,   276,   277,   278,     0,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,     0,     0,     0,   302,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   885,   886,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     887,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,   337,     0,   338,   339,   340,   341,     0,
     343,   344,   345,   346,     0,     0,   348,     0,   349,   350,
     351,   888,   353,     0,   354,     0,   355,   356,   357,     0,
     358,   359,   360,   361,   362,     0,   363,     0,     0,     0,
     366,   367,     0,   368,   369,   370,   371,  1155,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,     0,   389,   390,   391,   392,
     889,   890,     0,   891,     0,   396,   397,   398,   399,   400,
     892,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,     0,   421,   422,   423,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   438,   439,   440,   441,   442,   443,   444,   445,
     893,   447,   894,   449,   450,   451,   452,   453,   454,   455,
     456,     0,     0,   459,     0,   460,   461,   462,   463,     0,
       0,   465,   895,   467,   468,   469,   470,     0,   471,   472,
     473,     0,     0,   474,   475,   476,     0,     0,   477,   478,
       0,   480,   481,   482,     0,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,   496,   497,
     498,     0,   500,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   896,
     517,   518,   519,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   897,   560,   561,   562,
     563,   564,   898,   566,     0,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
       0,   583,     0,   584,   585,     0,     0,   586,   587,   588,
     589,   590,   591,   592,   593,     0,   594,   899,   900,     0,
       0,   597,   598,     0,   600,     0,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
       0,   901,     0,   623,   624,   625,   626,   627,   628,   629,
       0,     0,   630,     0,     0,   631,   632,   633,   634,   635,
     636,   879,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   648,   649,   650,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
       0,   880,   260,   881,   882,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   883,   884,   274,
       0,   275,   276,   277,   278,     0,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,     0,     0,     0,   302,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   885,   886,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   887,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
     337,     0,   338,   339,   340,   341,     0,   343,   344,   345,
     346,     0,     0,   348,     0,   349,   350,   351,   888,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,     0,     0,     0,   366,   367,     0,
     368,   369,   370,   371,  1187,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,     0,   389,   390,   391,   392,   889,   890,     0,
     891,     0,   396,   397,   398,   399,   400,   892,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,     0,   421,
     422,   423,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   438,
     439,   440,   441,   442,   443,   444,   445,   893,   447,   894,
     449,   450,   451,   452,   453,   454,   455,   456,     0,     0,
     459,     0,   460,   461,   462,   463,     0,     0,   465,   895,
     467,   468,   469,   470,     0,   471,   472,   473,     0,     0,
     474,   475,   476,     0,     0,   477,   478,     0,   480,   481,
     482,     0,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   500,
       0,   502,   503,   504,     0,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   896,   517,   518,   519,
       0,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     0,   533,   534,   535,   536,   537,
     538,   539,   540,     0,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   897,   560,   561,   562,   563,   564,   898,
     566,     0,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,     0,   583,     0,
     584,   585,     0,     0,   586,   587,   588,   589,   590,   591,
     592,   593,     0,   594,   899,   900,     0,     0,   597,   598,
       0,   600,     0,     0,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,     0,   611,   612,   613,   614,   615,
       0,     0,   616,   617,   618,   619,   620,     0,   901,     0,
     623,   624,   625,   626,   627,   628,   629,     0,     0,   630,
       0,     0,   631,   632,   633,   634,   635,   636,   879,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   648,
     649,   650,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,     0,   880,   260,
     881,   882,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   883,   884,   274,     0,   275,   276,
     277,   278,     0,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,     0,
       0,     0,   302,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   885,   886,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   887,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,   337,     0,   338,
     339,   340,   341,     0,   343,   344,   345,   346,     0,     0,
     348,     0,   349,   350,   351,   888,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,     0,     0,     0,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,     0,
     389,   390,   391,   392,   889,   890,     0,   891,     0,   396,
     397,   398,   399,   400,   892,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,     0,   421,   422,   423,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     0,   438,   439,   440,   441,
     442,   443,   444,   445,   893,   447,   894,   449,   450,   451,
     452,   453,   454,   455,   456,     0,     0,   459,     0,   460,
     461,   462,   463,     0,     0,   465,   895,   467,   468,   469,
     470,     0,   471,   472,   473,     0,     0,   474,   475,   476,
       0,     0,   477,   478,     0,   480,   481,   482,     0,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,   496,   497,   498,     0,   500,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   896,   517,   518,   519,     0,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,     0,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,     0,   557,   558,
    2735,   560,   561,   562,   563,   564,   898,   566,     0,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,     0,   583,     0,   584,   585,     0,
       0,   586,   587,   588,   589,   590,   591,   592,   593,     0,
     594,   899,   900,     0,     0,   597,   598,     0,   600,     0,
       0,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,     0,     0,   616,
     617,   618,   619,   620,     0,   901,     0,   623,   624,   625,
     626,   627,   628,   629,     0,     0,   630,     0,     0,   631,
     632,   633,   634,   635,   636,   879,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   648,   649,   650,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,     0,   880,   260,   881,   882,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   883,   884,   274,     0,   275,   276,   277,   278,     0,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,     0,     0,     0,   302,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   885,
     886,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   887,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,   337,     0,   338,   339,   340,   341,
       0,   343,   344,   345,   346,     0,     0,   348,     0,   349,
     350,   351,   888,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,     0,     0,
       0,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,     0,   389,   390,   391,
     392,   889,   890,     0,   891,     0,   396,   397,   398,   399,
     400,   892,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,     0,   421,   422,   423,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   438,   439,   440,   441,   442,   443,   444,
     445,   893,   447,   894,   449,   450,   451,   452,   453,   454,
     455,   456,     0,     0,   459,     0,   460,   461,   462,   463,
       0,     0,   465,   895,   467,   468,   469,   470,     0,   471,
     472,   473,     0,     0,   474,   475,   476,     0,     0,   477,
     478,     0,   480,   481,   482,     0,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   500,     0,   502,   503,   504,     0,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     896,   517,   518,   519,     0,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,     0,   533,
     534,   535,   536,   537,   538,   539,   540,     0,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,     0,   560,   561,
     562,   563,   564,   898,   566,     0,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,     0,   583,     0,   584,   585,     0,     0,   586,   587,
     588,   589,   590,   591,   592,   593,     0,   594,   899,   900,
       0,     0,   597,   598,     0,   600,     0,     0,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,     0,   611,
     612,   613,   614,   615,     0,     0,   616,   617,   618,   619,
     620,     0,   901,     0,   623,   624,   625,   626,   627,   628,
     629,     0,     0,   630,     0,     0,   631,   632,   633,   634,
     635,   636,   879,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   648,   649,   650,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,     0,     0,   260,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,     0,     0,
     274,     0,   275,   276,   277,   278,     0,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,     0,     0,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,   337,     0,   338,   339,   340,   341,     0,   343,   344,
     345,   346,     0,     0,   348,     0,   349,   350,   351,     0,
     353,     0,   354,     0,   355,   356,   357,     0,   358,   359,
     360,   361,   362,     0,   363,     0,     0,     0,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,     0,   389,   390,   391,   392,     0,     0,
       0,     0,     0,   396,   397,   398,   399,   400,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,     0,
     421,   422,   423,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     0,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
       0,   449,   450,   451,   452,   453,   454,   455,   456,     0,
       0,   459,     0,   460,   461,   462,   463,     0,     0,   465,
       0,   467,   468,   469,   470,     0,   471,   472,   473,     0,
       0,   474,   475,   476,     0,     0,   477,   478,     0,   480,
     481,   482,     0,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,     0,   496,   497,   498,     0,
     500,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   517,   518,
     519,     0,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,     0,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,     0,   557,   558,     0,   560,   561,   562,   563,   564,
       0,   566,     0,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,     0,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,     0,     0,     0,     0,   597,
     598,     0,   600,     0,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,     0,     0,
       0,   623,   624,   625,   626,   627,   628,   629,     0,     0,
     630,     0,     0,   631,   632,   633,   634,   635,   636,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     648,   649,   650
};

static const yytype_int16 yycheck[] =
{
       6,     0,   211,   665,     0,     0,     0,     0,     0,  1041,
      56,     0,   211,     0,   206,     0,     0,    23,   942,    25,
       0,     0,   214,    29,    36,   217,    21,     0,    34,    35,
      36,     0,    38,     0,  1050,    41,    42,  1013,    44,   843,
      46,  1167,    21,   686,   840,   189,  1662,    53,    54,    55,
    1579,   897,  1595,  2844,    45,  1030,   718,  1014,    22,  1579,
       0,     0,   718,  1045,    28,   867,   799,   800,   801,     0,
     759,  1228,   805,   936,   916,   938,  2717,  1572,  1039,  1275,
    2718,  1584,     0,  2044,   197,   885,   886,    44,   873,  1262,
    1505,   850,  3247,  1116,  3137,   895,  3428,   216,  3430,   900,
     833,  3197,  3523,   765,  1902,   763,  1247,  3728,  3099,  3072,
    1251,   230,   954,  1254,  1255,  1090,  3926,  3953,  2033,  1094,
    2085,  1730,  3084,  2071,  1099,  3942,    23,  3611,  2052,   866,
       8,  3975,  4275,   741,  1109,  2070,  3674,    15,  3676,    36,
    1625,  1626,  2990,  3878,  1629,   667,  3481,   755,  1123,  4359,
    3533,  4835,  4297,  4318,  1697,  1698,   818,  1572,  3646,  2109,
    3648,   191,  1562,  1462,  2968,   191,   175,  1043,  1915,  2066,
    2067,  2068,  2069,     2,  5232,  2072,  1974,  2074,  2075,  1154,
    4606,   980,   764,  4611,   846,  4623,   739,   979,  1691,   742,
     846,   197,   198,   199,  5160,  4568,   202,   754,  5366,  5152,
     206,  5324,   208,    35,  4737,   211,  4739,  5460,   214,   871,
      42,   217,  1004,  3497,   220,  1718,   222,  1009,  1105,   225,
    2739,  2740,  1622,   229,  3475,   231,  4406,  1013,   965,  4600,
    4851,  2597,  4853,  5103,  1121,  2601,  1022,  4610,    50,  1639,
    2634,  2702,  5496,  3543,  3382,  2704,  1032,  5357,  3290,    41,
    5508,  1050,  3387,  3940,  3037,  5147,  3039,  3040,  4927,   939,
    5457,  3044,  3045,  3046,     0,  3048,  3049,  3050,   225,  5766,
     939,   933,   963,    11,     0,  1545,  3080,     0,     6,     6,
    3531,  5151,    21,     0,  5750,    38,  4459,  2681,    15,    16,
    4775,     6,  2039,    54,  5422,  5423,    37,    63,     6,     6,
      15,    16,    37,    63,    63,  5415,     6,    63,  3480,     6,
    3482,  3483,    37,  1004,     6,    15,    16,  1054,  1009,     0,
      25,     6,    21,    32,    13,    43,    95,     6,    47,   120,
      11,    37,     0,     6,     6,    29,    37,    35,   149,   172,
       6,   120,   120,    11,   178,    47,     6,    88,    29,    13,
     178,  1084,     6,    63,     6,   883,   884,     6,   178,   157,
       6,    29,   178,    85,  1525,   153,   894,     6,   195,    80,
     164,     6,    63,    47,     5,   120,  3613,    11,   179,    37,
      11,    45,     0,     3,    51,     5,     6,   190,  1050,  1156,
      15,    11,   179,  5447,  6027,  1162,  1881,   178,   122,  6064,
     179,   178,    13,    21,     5,  1172,    13,    68,     6,  1176,
      11,    43,   178,  1180,    78,  1182,  5649,  1202,  4701,  4702,
    4703,  1188,  4705,  4706,  4707,  4708,  4709,  1194,   316,   331,
    1197,   125,   180,   221,    45,   140,  1418,   158,    56,   353,
     257,   310,   178,    32,  4624,  1406,  6020,   180,  1106,   135,
     345,  1474,   178,    63,   348,   178,   403,    63,   345,   669,
     120,   178,   361,   404,  6151,   376,   202,    78,    11,    35,
     448,   360,   385,   166,    25,   272,   202,   206,   325,   202,
     122,    39,  5979,  5375,  1466,   202,   120,   686,   240,   424,
      78,   120,    29,  1293,  1294,    63,   289,   178,   448,   385,
     120,    13,   153,   227,  5970,   495,    92,   450,   433,    32,
     178,   372,   267,  1623,  5768,   294,   283,  6466,   178,   313,
      80,   202,   535,   217,   440,  1325,   442,   540,   316,   330,
    1640,  6480,    92,   178,   202,  1336,    59,   736,   293,     6,
     178,   308,   403,   172,  5497,   356,   324,   472,   293,   435,
     540,   761,   487,   496,  5664,   450,   403,   309,   471,   298,
     289,   254,   540,   450,   312,   684,  1174,   302,  4939,   293,
    1355,   690,   130,   191,    29,   368,    80,    29,   489,   478,
      29,    36,  6269,   702,    36,   227,  1462,    36,    92,   140,
     540,   157,  1574,   540,    80,   536,   485,   394,   135,   298,
      80,   496,   222,   254,   373,  1404,  1268,   293,   409,   496,
    1409,  1410,  1268,   334,   374,   374,   178,   350,   374,  1356,
      29,    92,   536,    80,   390,   835,  1208,  1235,   289,   446,
      80,   185,   448,   357,   536,    92,    80,   257,  1246,    80,
      13,   185,   536,  6140,   302,   390,   244,  6312,  1433,  1386,
    3887,   293,   540,   185,   389,  1263,  5889,  6290,  5712,    23,
     666,   455,   371,  1463,   374,   534,   672,   448,   674,   538,
     676,  4406,    45,   679,   477,   423,   385,   465,   387,   127,
     686,  1656,   125,   374,  1659,   691,   671,   693,   412,  5886,
    5311,   489,   671,   699,   473,   334,  1728,  1729,   403,  4434,
     142,   479,   396,   536,  1865,    78,   540,  6394,   375,   536,
     526,  1668,   540,   431,  1499,   357,   536,   723,   484,   765,
      10,   462,   538,    13,  5978,   536,   732,    17,    18,    19,
     736,   671,   671,   739,  4879,   526,   742,   448,  1427,  1401,
     671,   463,  1629,   478,   453,  1401,   448,  1409,  1410,   536,
     448,  1550,   758,   671,  1282,  1283,   497,  6254,   536,   478,
     769,  1560,  1548,   540,   374,  1726,   471,  4940,   374,  4579,
      25,   540,   497,  5258,   482,   536,   478,   471,  4951,  2049,
     540,   540,   371,   536,   540,   764,  6252,  5915,   448,   517,
     518,   497,  1320,   514,  1681,  1682,   497,   535,   942,   431,
    1646,   540,  4619,   539,   478,   811,   374,  5760,   536,   536,
    4620,  1735,  1492,   539,   820,   779,   539,   781,  1610,   783,
    4441,   536,   539,  1492,  1610,   789,  4447,   534,   536,   536,
     540,   538,   517,   518,   840,   841,   536,   843,   844,   536,
    6337,   540,   848,   532,   536,  2002,   527,   528,  1647,   540,
    1976,   536,  1651,  1652,   811,  1064,   862,   536,   539,   527,
     528,   867,   448,   536,   536,  1064,   526,   873,   532,  1061,
     536,   539,  5764,  1065,  4362,  1067,  4364,  6131,   538,  1570,
    6077,  6078,   536,  2009,   536,   140,  6144,   536,  6385,  4624,
     536,   536,   493,   527,   528,  2021,   527,   528,   540,   263,
     930,   526,   540,  4238,   930,  6479,  6159,   527,   528,   534,
     867,  1439,  1440,   538,   920,   793,   517,  6491,   529,   530,
     531,   532,   529,   530,   531,   532,   527,   528,   934,   338,
     540,  5214,  1623,   932,   540,   225,   932,   932,   932,   932,
     932,   947,  1055,   932,   448,   932,   534,   932,   932,  1640,
     538,  3913,   932,   932,   421,   422,   962,   956,   413,   932,
    6070,   413,   448,   932,   413,   932,  3770,  3771,   448,  4104,
    4105,  3775,   540,  5642,  1617,   981,  4114,   934,   540,  6089,
     986,   987,   453,  4670,   527,   528,   540,  1863,     3,   398,
     947,   448,   932,   932,    52,  1882,   540,    72,   448,  4250,
      23,   932,  6256,  4254,   448,   962,     3,   448,   540,     6,
    4310,  5977,  1018,  1019,   932,   527,   528,   529,   530,   531,
     532,  5974,   312,  1545,   122,   473,   390,  3546,   471,  3548,
       6,   440,    76,   442,   156,  1041,  1042,    89,  2070,   156,
    4528,  3502,    89,  4527,  3503,  4087,  1845,   489,  3442,  1055,
     148,  1057,   844,   671,  4189,  1061,   848,    23,  1064,  1065,
     202,  1067,   874,  6151,   125,  4237,  1072,  4239,  4240,  2051,
      63,   326,   207,  3856,   438,   136,    91,   113,   185,   154,
     132,     6,  6336,   223,   125,   132,     6,  5957,   187,   113,
    1096,   125,  6260,  6261,   310,   313,   113,  1103,  1104,   174,
     172,   103,    25,  5973,   385,   469,  3910,    33,    34,  5480,
     331,  6169,   113,   368,  5487,  6225,   124,    89,   115,  1125,
    1126,  1127,   294,  1129,  2106,  1131,  2675,  1133,  1134,    10,
     145,   495,    13,   156,   169,    21,    17,    18,    19,   197,
     289,   178,    21,   311,   202,   297,   764,   765,   403,     6,
    4434,   125,  5362,    23,   527,   528,   529,   530,   531,   532,
     132,  1167,   390,  1169,  1170,   202,  1828,   368,  3534,   178,
    4591,  4655,   536,    99,  6427,  6141,   217,   190,  1911,  6132,
      25,  6269,  1949,   217,     6,   187,  1018,  1019,    23,    23,
    1957,  6409,  6315,   119,   526,   253,  1202,   194,   368,   266,
      48,   372,   283,   174,   115,  5701,   538,  5703,   113,  5389,
       3,  5707,  5708,   310,  2018,  2019,   224,   140,   293,  6387,
    5841,   476,  1228,    71,  1230,   304,   293,   308,  1234,  1208,
    1236,   157,   403,   403,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   217,    72,   260,  6464,   448,    30,   284,
    1626,   316,   331,  1629,  1260,   536,  1262,  2133,   410,    23,
    1266,    10,   172,   307,    13,  2050,    63,  2052,    17,    18,
      19,   346,   289,  2058,  1280,   272,   289,   329,   275,  2064,
    2065,   380,   329,   194,   406,    10,    35,   289,    13,   406,
    1979,  2076,    17,    18,    19,   140,  6262,   263,    91,   471,
     435,  2086,  2805,   114,  5732,  5838,  6394,  2092,   536,  1355,
    1139,   326,   930,  5149,   932,   536,  1322,  2837,   536,  2008,
     536,   202,   298,  2012,  2739,  5142,  5136,  6450,  2017,  5173,
     498,  2020,  5758,  1211,  5762,  1213,  3083,  1215,  1946,  1217,
    5778,  1219,  1220,  1221,   225,  1351,  1352,  1353,  1226,  1355,
     408,  6409,  1960,   146,   125,  3320,  3321,   329,  5731,  3878,
    3325,   272,   385,   512,   275,  1973,  2103,   311,  4359,  6335,
    1376,  3306,    23,   298,  2673,   197,  5747,   475,   298,   189,
    6346,   374,  1939,   406,   206,  5756,   493,  2890,  5761,   441,
    1943,   466,   214,   263,   441,   217,   207,   394,   540,   435,
     540,  3366,  3367,   326,  1986,  1958,  6464,  4895,  1961,  1415,
     471,   435,   298,  1422,  1971,   456,   209,  3026,  1617,   298,
    6386,   493,   396,   438,   390,  2825,   441,  1433,   263,   263,
     471,   312,  4920,   540,   435,  5806,   218,   471,   364,   448,
    2083,   298,   300,   445,  6365,   368,   217,  1477,  1478,  3968,
    1480,  1477,  1478,   120,  1480,  6421,   493,   536,  2011,   390,
     370,   403,  2015,  2016,   477,   293,   326,   316,    23,   441,
     396,  5636,   438,  1479,    38,   540,   225,  1483,  1484,   380,
     403,   326,    92,   394,  3434,  5630,    37,  6453,  1494,  1495,
    1496,  1497,   289,  1499,  4877,   400,    60,   471,   269,   263,
    3116,  4836,  6186,   469,  6000,  1881,   172,   115,   368,   435,
     120,    40,    58,    72,   511,   171,  1522,  6438,   184,    27,
     390,    28,   324,   368,     6,    54,   289,  2049,   190,   495,
     368,   403,    42,    92,   133,     5,   202,  1494,    25,  1496,
     333,    11,    50,   403,    31,   144,   356,   403,   112,   493,
    3099,  1557,   100,   479,   241,   390,  1562,   483,   403,  1565,
     180,   311,  5100,   312,   325,   403,  2598,   493,   438,   120,
     536,   472,  1578,  1579,    87,   473,   386,   374,    94,   390,
     125,  1587,   111,   129,  1590,    92,   194,   312,  5959,  4840,
    1208,   517,   536,  4636,  4845,   140,   435,  4848,   540,   469,
     511,  4592,   289,   438,   438,   536,   403,   124,    72,   311,
     536,  1617,   263,  1619,   311,   473,  1622,   120,  2600,  1625,
    1626,   137,   433,  1629,   435,   495,   390,   289,   194,  6137,
    6138,   179,  1631,  1639,   469,   469,  1642,  1636,   536,  1645,
    3135,   205,   403,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   314,   140,  5389,   168,   120,   324,  1276,  5869,
     495,   495,  5498,  1669,   272,   213,   536,   275,   540,  5486,
     357,   464,   122,   180,   438,   190,   536,   479,  1296,   472,
     228,  1687,   475,   293,   540,   341,    10,   216,   537,    13,
     200,   540,   312,  1699,  1700,  1701,  1702,  1703,   148,   263,
     471,   536,   536,   251,   268,   469,   272,   224,   263,   273,
     218,  1717,   378,  1712,   477,   304,  3131,  1716,   182,   406,
    3135,    45,  1728,  1729,  1730,   289,   304,   326,    52,   396,
    1687,   495,   280,  4516,   293,   325,   304,  1355,  4521,   390,
     183,    10,   331,   493,    13,  5888,  1955,  2763,    17,    18,
      19,  4599,  1944,   331,    78,  1954,  1955,  6128,    29,   448,
     289,   325,   310,   331,  4555,   316,    35,   166,   435,   368,
     136,   122,   536,   181,   289,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   471,    10,   394,   438,    13,  4593,
    2926,   493,    17,    18,    19,   298,   493,  2673,   343,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   403,   373,
      35,   326,   479,   396,   257,   477,     3,   403,   469,    25,
    1933,  1827,   123,   179,   267,    31,   493,   151,   394,   293,
    6338,   379,  1838,   397,   298,   390,    99,   526,    10,   326,
    1846,  1847,  4833,   350,   495,    17,    18,    19,   298,   538,
     517,   217,   435,   368,   418,   254,  1862,   213,   112,  1477,
    1478,   123,  1480,   392,   135,    13,  2633,  2652,  5386,   536,
     241,  3007,   228,   197,  1880,  1881,   227,    23,   202,  6250,
     387,   368,   346,   438,  2083,   536,   326,  4406,   325,  2735,
    1896,  1897,  1898,  1899,   414,   251,   479,   198,   362,  1905,
    6445,   723,     5,   511,   267,   469,  1912,   306,    11,  1915,
     732,  2715,  5430,   536,   469,  4434,   403,   739,   289,   439,
     742,   184,  6467,  3472,  1930,   473,  3475,  1933,   536,   253,
      78,  5767,  6075,   120,   140,   243,   198,  1943,  1944,  5749,
     495,   123,   293,   351,   451,   540,   453,   536,  1954,  1955,
     457,   387,  1958,   536,   540,  1961,   225,   314,   536,  5776,
    2936,  6332,   477,   403,  2763,   135,   403,   137,   536,   326,
    1976,  1977,   370,   537,  3523,   526,   384,  1983,   120,  1985,
     178,   536,  3531,   534,   483,   536,   537,   538,   312,   540,
     398,   493,   490,    64,    23,    23,  2002,   440,  2874,   442,
     225,    72,   466,  2009,   202,  2011,   357,  1986,  2014,  2015,
    2016,   368,  2018,  2019,   268,  2021,   198,   453,   160,   273,
     483,  2067,  2028,   379,  2900,   387,   469,   316,   436,  2035,
    2042,   122,  2038,  2039,  3160,   406,  2042,   536,   540,  2045,
    2046,  5525,   540,   312,  2050,   385,  2052,   387,  2033,  2835,
    5205,  2057,  2058,   195,  2033,  6265,  5307,   148,  2064,  2065,
    2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,
    2076,  2028,  4033,   536,  2080,   450,  2082,  2083,  2084,  2085,
    2086,  2087,  2088,  2089,   408,   173,  2092,   312,  2094,  2095,
    4051,   453,  2098,  2033,  2033,   493,  3020,  3021,  3022,  2986,
     471,  2763,  2033,   536,   393,  4624,   293,  2113,  2114,  2115,
    1988,   298,  1990,   453,  1992,  2033,  1994,   263,  1996,   517,
     211,   209,  2000,   293,  3000,  2131,   473,   484,  3543,  1631,
      69,    70,    25,  3628,  1636,  5126,  5972,  3753,  3553,  5102,
     312,  2940,   540,  4067,    13,   169,  5990,   334,  2045,  2948,
    2936,   293,  2951,  4088,  5971,  4103,    38,  3353,  4093,  5121,
    4125,  4126,  4127,  4128,   157,  2171,  4131,  4132,  4133,  4134,
    4135,  4136,  4137,  4138,  4139,  4140,    45,  3152,  5141,  2916,
    6390,  2914,  5337,  2916,  5339,   326,   257,  5519,  2974,   536,
    3066,   515,  5730,   493,   180,  4092,   326,  2989,   289,    81,
    4097,  4098,   293,   527,   528,   529,   530,   531,   532,    78,
    1712,  4009,   765,  3628,  1716,   360,  3103,  3104,  3105,  3106,
     155,  3108,   246,  3009,   293,  2833,  3835,   368,   214,   298,
    4195,  4196,  3841,  1055,   263,   263,   166,   390,   368,  1061,
     540,  3726,   172,  1065,   390,  1067,  3133,   140,   166,  6415,
     540,  6417,   397,   326,   172,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   440,   818,   442,   420,   326,   204,
     493,   360,  5368,  2279,  3777,  2964,    38,  2966,   493,     0,
    5063,  2970,  5065,  5066,  5067,   354,  5090,   202,  5092,   326,
     435,     3,   438,  5781,   517,   368,   326,  6133,    60,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   397,  1131,
     368,  1133,  1134,  4228,    26,  6481,    80,   540,   871,  5803,
     493,  3824,   539,   469,   254,   540,     5,  2333,    92,   157,
     403,   368,    11,   385,  5755,   372,   254,  5328,   368,  4236,
     485,  3537,    27,    29,   517,   403,   435,  3223,   122,   495,
     112,   373,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   390,   390,    25,  1008,    50,   403,   419,  1986,    31,
     448,  5362,   112,   403,   148,  6477,   306,   172,  5710,    91,
     933,   403,  3149,  1027,  2390,    22,  1030,  3154,   306,  3156,
     536,    28,  6494,  3126,   326,   473,   485,    83,   172,  3166,
      86,   196,  3169,   396,  3171,  3172,  3949,    93,  3175,   438,
     438,  3210,  3179,   100,  3181,  2033,   326,  3184,  4941,  6255,
     182,   314,   172,   781,   782,   783,  4949,  3085,   786,   787,
     788,   153,   120,   173,   146,   121,   368,   211,   796,   493,
     469,   469,   435,   205,   166,  1884,   196,    15,    16,  2067,
     172,  6072,   357,   368,   364,   143,  6266,   372,   368,   172,
     493,    35,   150,   517,   369,  1904,   495,   495,  3344,   209,
     531,   403,   183,  2091,  3350,   536,   164,   538,   140,   372,
     373,  3248,   536,   196,   517,   534,   479,   536,   403,   538,
     202,    38,   179,   403,   399,    10,   182,   209,    13,   221,
     493,   263,    17,    18,    19,  3429,   268,   536,   536,   195,
     403,   273,   135,    60,   137,   289,   531,  5508,  3207,   293,
      35,   536,   208,   538,   517,     5,   213,   289,   268,   517,
     518,    11,   254,   273,   517,   518,  5868,  3322,   143,    19,
      99,   228,   310,   536,   348,   150,   257,   315,   536,  3334,
      33,    34,  3289,   536,   535,  5651,  5666,    37,   453,   540,
     119,  5671,  5672,   325,   251,   112,    25,   302,   396,  2575,
    2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,   493,  2585,
     536,  4546,   538,   310,   306,  3370,  1004,  2796,   315,  2595,
    2596,  1009,  2598,   280,   316,   485,  5587,  2796,   157,  2605,
     534,   244,   517,  2795,   538,  2797,  2798,   435,   529,   537,
     298,   373,   540,   534,  6424,   536,  3333,   538,  3335,  3336,
     534,   333,   536,   310,   285,   286,   287,   288,  2634,  3414,
    2636,   453,    91,  2639,  2640,   397,  3435,  2643,   529,  2645,
    2635,  3782,  2648,   534,   393,   536,  2652,   538,   536,   360,
     538,   479,  5435,  3454,  3455,   536,   418,  3614,   205,   537,
     537,   271,   540,   540,   326,   493,  2284,   537,   380,  2675,
     540,   153,   536,  3432,   133,  2681,  2682,  2634,   370,  2792,
     537,   140,   267,   540,   166,   144,  2692,   393,   537,   517,
     172,   540,   379,  3650,   537,  2701,  2702,   540,   517,   518,
     537,  4250,  3544,   540,   267,  4254,   368,   469,   536,  2715,
     225,   537,   537,  2832,   540,   540,   263,  2723,   207,  2725,
     432,   268,  4683,    96,  2681,  2682,   273,   385,   386,   440,
    6218,   442,   385,   386,   420,  6223,  6224,   423,  4699,   221,
    5783,   403,   289,   465,   271,   537,  3389,  3729,   540,   385,
     386,  3488,   464,  2765,  3554,  2767,   385,   386,   469,  2765,
     472,  2767,  4378,   475,   196,   537,   537,   455,   540,   540,
     324,    25,   254,  3435,   485,  2781,   453,    31,   325,   467,
     537,  3938,   537,   540,   100,   540,  2792,  5654,  5655,  2795,
    2796,  2797,  2798,  4728,    87,  2801,   537,   312,  2804,   540,
    4735,  4736,  2720,  4601,   537,   364,  2925,   540,  5830,  5831,
    4359,  3578,   534,    59,   537,   537,   538,   540,   537,  2825,
     537,   540,    76,   540,   306,  6443,   373,   396,  6446,  3615,
     493,  2837,   495,  4376,   316,  4378,   537,   396,  4341,   540,
    5644,  4361,   396,  6033,  6034,  2851,  2852,  2804,   393,   483,
     397,  1209,  2858,   493,  1212,   495,  1214,   485,  1216,   537,
    1218,  2867,   540,   179,  1222,   537,   435,   326,   540,   537,
    5389,   418,   540,  6205,    54,    55,   435,  4050,  5869,   133,
     244,   435,  3571,  2889,    11,   537,   140,  3006,   540,   536,
     144,  6379,  3659,   390,  3661,  4310,  3919,   213,   537,   537,
    2096,   540,   540,  2099,  2910,   364,  3881,   433,   310,   368,
     479,  4414,   228,   537,  6069,  3701,   540,  2923,   537,   173,
     479,   540,   469,   537,   493,   479,   540,   540,   537,   537,
    3592,   540,   540,   536,   493,   251,  3592,   536,    10,   493,
    2946,    13,    59,  2949,   403,    17,    18,    19,   517,   537,
     485,   410,   540,  2910,   537,   209,   537,   540,   517,   540,
    3568,  3569,   537,   517,   280,   540,   440,   536,   442,  2975,
    2976,   537,   537,    45,   540,   540,   537,   536,    48,   540,
      52,  5619,   536,   465,  2990,  5976,  2992,  2993,  3875,   513,
     538,  3724,  5511,   227,   181,   537,  3729,   537,   540,  2963,
     540,  3877,   294,   295,   537,   537,    78,   540,   540,   524,
     525,   526,   527,   528,   529,   530,   531,   532,  3024,  3025,
    3026,   310,   313,  2641,  3030,   135,   537,   137,   537,   540,
     537,   540,  3038,   540,   537,   289,   172,   540,  3805,   293,
    2675,   310,  4591,  4592,  3811,  3051,   537,   513,   313,   540,
     304,  3057,   534,  3059,   164,    48,   538,  2675,   245,  6391,
     314,   513,  3254,   379,  3256,  3257,  3072,  2666,  2667,  2668,
    4613,  3077,   326,   537,   227,   177,   540,  3083,   153,  4608,
    3086,   537,   537,   537,   540,   540,   540,   537,  5892,  5893,
     540,   166,  3098,  3099,   440,   529,   442,   172,    10,  4295,
     540,    13,  2720,  3109,   396,    17,    18,    19,  1930,   537,
    3718,  1933,   540,  3119,   368,  3121,   536,   371,   372,   229,
     537,  1943,  1944,   540,   537,   197,    38,   540,   537,   482,
     202,   540,  3740,   493,  4629,   495,  1958,  6469,  3251,  1961,
     342,   537,   537,   435,   540,   540,   221,   537,   537,   403,
     540,   540,   537,  6144,  3160,   540,  3162,   537,  3164,   537,
     540,   536,   540,   537,  6127,   537,   540,   537,   540,   537,
     540,   493,   540,   495,  3907,   285,   286,   287,   288,   254,
     536,   253,   292,   293,    37,   536,  4168,   479,   298,  2011,
    3389,  3197,   537,  2015,  2016,   540,   537,   384,   537,   540,
    3118,   493,    92,  4360,   391,   537,  4363,   537,   540,  4366,
     540,   398,   537,   537,  4629,   540,   540,   537,   537,  5860,
     540,  3883,   476,  3885,    59,   517,     0,  3883,   178,  3885,
    3997,   306,  3999,   223,  4001,  4037,  3925,   223,   538,   537,
     312,   316,   540,   368,   536,  3251,  3252,   202,  3254,   436,
    3256,  3257,   537,  3259,   537,   540,   493,   540,   495,  4058,
    3266,  4222,   497,   537,   537,  3271,   540,   540,  6259,    43,
     537,   158,   459,   540,  6265,   537,  3322,   537,   540,  5244,
     540,   537,   158,   539,  4833,  4161,  4268,   537,   536,   539,
    3898,  4840,  3900,   183,   536,   536,  4845,    10,  3497,  4848,
      13,   537,  5237,  5238,   540,  3967,  4219,   537,  4221,     3,
     540,  3967,   536,   225,  3320,  3321,  3322,   207,   537,  3325,
    4822,   540,  4824,  4305,  3370,    99,   536,  3333,  3334,  3335,
    3336,   537,    45,  4022,   540,  4120,   408,   538,   537,    52,
    4956,   540,   310,  3349,    10,   455,  3352,    13,  3354,   368,
     202,    17,    18,    19,   310,  6146,   537,   467,   158,   540,
    3366,  3367,   158,   537,  3370,    78,   540,   257,   537,  4154,
     537,   540,   537,   540,   537,   540,   202,   540,   537,   153,
    4255,   540,  4257,  3389,  1494,  3391,  1496,  3393,   158,  3395,
     465,   310,   166,   153,  5288,   172,  5290,    91,   172,  6390,
     312,  4921,  4377,   368,   178,   158,   166,   252,  3414,   473,
     184,  3417,   172,   187,   122,  3421,   310,   191,   536,   302,
    4205,   172,   537,    72,   293,   315,    38,   293,   497,  3475,
     536,  3422,  3423,  3424,   293,   310,  3442,    48,   151,    48,
     295,   458,   293,   515,   293,  4053,   326,   221,    91,   223,
     485,   145,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   221,   485,    87,  3099,   453,  3472,    54,   172,  3475,
    3476,   349,   158,   158,  3480,  3481,  3482,  3483,   536,   158,
     254,  3527,   158,  3489,   197,  3442,   153,   497,  3494,   202,
     135,  4333,   137,   158,   254,  4652,   158,   540,   158,   166,
    3118,   158,   158,  3509,   158,   172,   158,  4307,   158,   172,
     158,   158,   158,   310,   101,   435,   158,  3523,   158,   164,
     536,  3527,    38,   252,  3530,  3531,   310,  3533,   172,  4405,
      10,  4407,   306,    13,   172,   536,   310,     6,     6,   126,
     253,   396,   316,   172,   536,  4502,   306,   536,     6,  4524,
     440,   536,   442,   536,   221,   536,   316,  4433,   145,   225,
     536,   536,   536,   453,   151,    45,   260,     6,  3574,   536,
     536,     6,    52,  5534,   536,   536,   466,  5126,   536,   469,
     435,     6,   536,   536,   229,   536,   173,   254,  4512,   536,
     177,   536,  3598,  3599,  5559,   536,   536,  6388,    78,   312,
     536,   536,   376,   536,   536,   192,   536,   536,   536,   536,
     536,   536,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   536,   300,   536,   479,  5590,   536,   536,  3634,   536,
     536,   536,   326,   536,   494,  4434,  3642,   167,   493,   306,
     285,   286,   287,   288,   223,   322,   312,   292,   540,   316,
      38,   540,   103,   298,   252,    38,    37,   431,    10,   536,
     446,    13,   517,   446,   534,    17,    18,    19,   448,   534,
     364,   151,   448,   448,   368,   536,   448,   178,   372,  3878,
     172,   536,   537,    35,   539,   306,  3692,   172,   304,   403,
     540,   465,    68,    45,   448,   408,   448,   390,   448,   484,
      52,   448,   390,   448,  3322,   465,   538,   448,   390,   403,
    3716,   298,   254,   448,    79,   448,   490,   197,   492,   493,
    3726,   526,   202,   448,    92,   158,    78,   310,   249,   390,
     448,   395,   448,   298,   128,   472,   448,   438,   331,   310,
     514,   304,   536,   448,   438,   448,   385,   441,   195,   536,
      92,   540,  3370,    10,   128,   158,    13,  5172,  5307,   326,
      17,    18,    19,   537,   202,   539,   540,   354,   448,   128,
     114,   473,   128,   253,   473,   448,  3394,   448,    35,  5328,
     448,    59,    59,   277,   353,   314,   331,   353,    45,   448,
     448,   353,  3410,   448,   331,    52,    47,   448,   465,   493,
     540,   537,   515,   438,   225,   225,   310,   448,   225,  4685,
     455,   448,   448,  5362,   527,   528,   529,   530,   531,   532,
     448,    78,   467,   448,   541,   448,   448,   225,   448,  3835,
     448,   448,   312,   448,   448,  3841,   225,  3472,   448,   225,
    3475,   225,   448,   225,   310,   197,  3852,   225,   225,   536,
     202,   458,    38,  2675,  3472,   158,   310,  3475,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   158,   120,   293,
     473,   158,   158,   225,   226,   158,   484,   293,  4677,   310,
     260,   293,   293,  3889,  3890,  3891,    38,   172,  3523,    38,
    4872,   244,  2675,   392,   158,   158,  3531,   473,   158,  4666,
    3906,   253,  4669,   536,   536,  3523,   536,   302,   158,  3527,
     448,   178,   473,  3531,  3920,   489,   277,   536,   297,   277,
      13,   448,   187,   195,   537,   321,   450,   195,   408,   513,
     534,  4698,  3938,  3939,  3940,   540,   536,   536,  3944,   536,
     197,  4787,   537,   513,   296,   202,   540,   537,   537,   537,
    3956,   537,   394,   275,  5111,   537,   490,   406,   473,  5508,
     312,   241,   221,  5492,   311,  4573,  4574,   540,   225,   226,
    2792,    38,   540,  2795,   319,  2797,  2798,   473,    59,   537,
     390,   484,  4671,  4672,  4673,  4674,  4675,   536,  4773,   298,
     298,   298,  4855,   448,   172,   448,   253,   536,   448,  3956,
     298,    48,   241,   412,   310,   310,  4012,   241,   536,   293,
     298,   252,   252,   385,   252,   271,   310,   128,   448,   438,
    4026,  4027,   540,   202,   196,   368,   540,   357,   310,   310,
     403,  4037,   493,   400,  3952,   515,   310,   316,  5587,   296,
     448,   448,   537,    38,  4050,   225,   473,   527,   528,   529,
     530,   531,   532,   244,   526,   312,   408,   352,   315,  4203,
     473,   158,   304,  4069,   172,    38,   436,   485,   174,   536,
    3988,   400,  4078,   158,   536,   158,   158,   353,   304,   493,
    4037,   473,   293,    38,   293,   310,  4092,    27,   310,   244,
    4096,  4097,  4098,   193,   304,   193,  5071,  4103,   172,    38,
    4106,   173,   244,  4109,   400,   310,   172,  5650,   293,  4115,
     202,  4117,   202,   202,  4120,   202,   202,   540,    62,  4125,
    4126,  4127,  4128,   538,    59,  4131,  4132,  4133,  4134,  4135,
    4136,  4137,  4138,  4139,  4140,  4902,   540,   497,  4144,  4145,
    4146,   540,   178,   540,   448,   536,   274,  4946,  4154,   310,
     540,   408,   493,  4159,    98,  4201,   302,  4163,   178,   514,
     316,   478,   537,   515,   376,  4171,   537,   536,  4174,   322,
    4176,   537,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   135,   332,   537,   178,   513,  4192,   537,   292,  4195,
    4196,   540,  4959,  4960,  4200,  4201,   267,   490,   537,  4205,
     540,  4207,  4208,   540,   537,   537,  5755,  4406,   535,   540,
    4216,  4217,  4218,   537,   537,  4858,   537,   537,   162,   537,
    4211,  4212,  4213,  4214,  6189,  6190,   540,  1484,  6193,   448,
    4236,  4237,  4238,  4239,  4240,  4434,  4242,  4243,   537,   536,
    4246,   178,   187,  4228,  4250,   537,    23,   536,  4254,  4228,
     540,    28,   262,   471,  4260,   199,   479,   490,   515,   310,
     526,   536,   517,   536,   535,    59,   536,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   537,  3099,   536,   516,
     310,  4287,   536,   310,   541,   313,  5053,  5054,  4228,  4228,
     158,   448,   215,   298,   448,   161,  4302,  4228,  4304,   158,
     448,   448,    79,    80,   293,   249,   536,   536,   207,  4917,
    4228,   423,   536,   209,   158,   403,  3099,   395,   158,    96,
    5869,   252,   395,   207,   161,   395,   310,   526,   448,   473,
     161,   390,   490,   254,  3952,   333,   333,   114,   470,   161,
     420,  5030,  5031,   448,  5033,   289,   448,   448,   264,   293,
     264,   264,   448,  4359,  4360,  4361,   390,  4363,  5091,  5283,
    4366,   138,  4368,   128,   448,   390,   390,   390,   293,  5784,
    3988,   448,   448,   448,   403,   152,   158,    47,    47,   448,
     448,  4387,   326,   327,   161,   448,   448,   448,   448,   225,
     225,   190,   537,  5317,   537,   535,   537,   174,   537,   314,
     537,   458,   540,   180,     3,   172,    48,   113,   537,   540,
     172,   536,    38,  5021,   537,   158,   448,  5184,   158,   526,
    5187,  5188,   172,   304,   368,  4624,   190,  5976,   372,  3251,
     207,   473,  3254,   377,  3256,  3257,  4442,   536,   473,   158,
    5207,   390,   386,   390,   390,   540,   156,   390,   390,   400,
     225,   395,   156,   225,   225,   225,   225,   225,   147,   403,
     466,   310,   225,   229,   225,   225,   466,   310,   245,   534,
      59,   310,   416,   537,    13,   322,   310,   484,   178,   537,
     292,   425,   535,   537,  4448,   540,   430,   537,   537,   537,
     267,  4497,   537,  6109,   540,  4459,   537,   537,   536,   228,
     537,   320,   228,   536,   437,   536,   317,    59,   191,   445,
     536,  5119,   376,   478,    90,   172,    38,   458,   448,   244,
     473,   473,   215,    59,  4530,   158,  5322,   438,    86,   420,
     182,   458,   395,   161,   390,   473,   448,   390,  4544,   448,
    4546,   448,   448,   448,   488,   537,   537,   537,  4554,   536,
     368,   536,    59,   438,  4560,   479,   172,   310,    78,   493,
     158,  5687,   113,  5689,  5440,  4571,   458,   537,   536,   225,
     225,   225,   349,   350,   225,   241,   353,   536,   210,   536,
    4586,   448,   310,  4201,   540,  4591,  4592,   497,    38,   537,
     331,   307,   310,  4599,    72,  6144,     3,   458,    44,   400,
      78,   184,  4608,   380,   185,   113,   383,   536,   540,   537,
    4228,  5300,  4618,   390,    92,  4250,   448,   536,   540,  4254,
     397,   178,  5311,   400,  4630,  4631,   145,   242,   225,   537,
     242,   298,  4250,   537,    10,  4641,  4254,    13,   298,   537,
     298,   178,   120,   420,   122,   298,  4652,  4653,   537,   537,
    3472,   428,   331,  3475,    59,   537,   536,   540,   435,  4858,
     322,   438,   491,   491,  4670,  5469,   443,   537,   537,    45,
     148,   492,   228,   304,   536,   540,    52,   493,  5835,   536,
     526,   458,  5698,   303,   458,   178,   445,   493,   209,  3472,
     448,    78,  3475,   196,   196,    38,   298,    38,   540,  4617,
     526,  3523,    78,   298,   182,  4711,    59,   438,   485,  3531,
    6259,   448,    72,   540,   448,   540,  6265,   158,   448,    62,
    5363,  4727,   161,   537,  4359,   448,   225,   536,  5885,     6,
     127,   180,   120,   211,    38,   289,   202,   304,   536,  4745,
    3523,     0,    38,   293,   174,   304,   473,   493,  3531,    59,
     400,   400,    84,   438,   493,    98,    38,   178,  5401,   172,
     536,   310,   540,   363,   212,   313,   223,  4773,   178,   478,
    4776,   417,    59,    38,    51,  5932,  5933,    92,  4784,  4785,
    5565,   537,  5390,   537,   536,  4791,  4792,   393,   537,   537,
    4796,    81,   536,   310,  5579,  4801,   136,   203,  4804,  4805,
     536,   448,   537,   536,   322,  4811,    38,   158,   158,  4815,
    4816,  4817,  4818,  2070,  2071,   293,  5601,   537,   448,   162,
     298,   197,   537,  5608,   537,   537,   202,  4833,  2085,   536,
    4836,   536,    38,   536,  4840,   536,   172,  2094,   536,  4845,
      99,  6390,  4848,  4849,   536,  4851,   536,  4853,   209,   473,
    4856,   298,  4858,   265,   536,   536,   199,   537,   400,   158,
     113,    38,   537,   314,   178,  4871,   458,   172,   346,  4875,
    5637,  4877,   415,   537,   415,   540,    38,   253,     0,    10,
     206,  4893,    13,   310,   362,   112,    38,  4893,   478,   537,
      35,   438,   537,   536,   153,   536,   536,  5682,  5683,  5698,
     536,   244,   540,   540,   362,   473,   249,   166,  5924,  5598,
     195,   536,   172,   172,    45,  4921,  4922,   536,   207,   178,
     197,    52,   438,   537,   310,   184,  5693,     6,   187,   206,
     207,  4937,   191,  5809,   165,   497,   312,   214,    72,   216,
     217,   386,   536,   386,   313,  6102,    72,    78,   539,   136,
     293,  4869,  4870,   230,   477,   493,  4591,  4592,   493,   141,
     489,   150,   221,   310,   537,  5941,   478,   537,   169,  5845,
     169,   540,   536,  4591,   332,   536,  4940,    99,    38,   403,
     266,   444,   444,   178,   327,   438,   298,  4951,   466,   310,
     310,   536,   400,    10,   438,   254,    13,  5003,    38,  4617,
      38,   203,  5691,   536,  5010,   313,   313,   180,   180,   536,
     157,   497,   497,   355,   385,   154,   355,    59,    59,    81,
     151,   369,  5684,   317,  6181,  6182,  5032,    38,    45,   372,
      59,   153,   408,   537,   377,    52,  5698,    59,   536,   448,
    5807,  5047,   125,   386,   166,  5921,   471,   306,   537,     6,
     172,   310,   395,   536,   400,   141,   178,   316,   310,   497,
     403,    78,   184,   497,  6221,   187,   197,   310,  5853,   191,
    5855,   202,  5078,   416,    35,   298,   537,   536,   294,   403,
     536,   294,   425,    24,   536,   385,   540,   430,   389,  5095,
     310,   389,   385,   318,    81,   479,  5102,   178,   540,   221,
     536,   536,   150,   448,   426,  5111,    10,   426,   451,    13,
     478,   540,   157,   415,   537,     6,   120,   376,   415,   317,
    5126,   493,   253,   479,   334,   180,   493,   180,    81,   473,
     932,  5518,   254,  5139,   151,  5141,   537,   536,   536,   515,
     478,    45,   537,   536,  1019,   488,  1018,  3435,    52,   492,
    2974,   527,   528,   529,   530,   531,   532,   972,  1715,  2883,
    3650,  5167,  1410,  4405,  5363,  4380,  6093,  3001,  3055,  3869,
    5443,  5921,  5178,  6233,    78,  4571,   435,  5492,  4378,  4378,
     197,   312,  5080,  5468,   306,   202,  3637,  3575,   310,  5716,
    5389,  4934,  5401,  6321,   316,  6222,  5362,  6322,  4833,  5951,
    6259,  5950,  5401,  6113,  3643,  4840,   465,  5126,  5400,  4592,
    4845,  4618,  4603,  4848,  4561,  5894,  3069,  6233,  3069,  4400,
    5138,  3675,  4840,  3917,  1014,  5231,  4587,  4845,  5120,  5475,
    4848,   490,  3961,   492,   493,  5241,   253,  4654,  5244,  6347,
    5796,  5247,  5248,  5249,  5887,  6483,  6458,   151,  5459,  3877,
    4626,  4869,  4870,  5445,   376,   514,  6125,  5403,  5669,  5406,
      18,    28,  5924,   667,  1236,  5635,  5272,  5273,  4026,  4682,
    5276,  4685,  6343,  1875,  3085,   534,  4629,   408,   537,   538,
     539,  3553,  2740,  5518,  3972,  1919,  5784,  5293,   719,  1916,
    3809,  5297,   752,   197,  4433,   312,  3000,  5303,   202,  1930,
    3726,  5307,  6151,  6394,  4658,  5311,   861,  6317,  5314,  1529,
    5316,  4660,  4871,   435,  6059,  3031,  5322,  1828,  4302,  2682,
    5630,  5633,  5328,  1426,    40,  5331,    40,  4727,  1954,  3494,
    3509,  1387,  6052,  2692,  5857,  3475,  1487,  4256,  4238,  3472,
    5308,  4303,  5587,   465,  5586,  3472,  6371,  6046,  5844,   253,
    1486,  6194,  3472,  6410,  1489,  5563,  5362,  5363,  5364,  4163,
    5366,  2590,  5368,  5858,  1443,  3412,    38,  5859,   490,  2591,
     492,   493,  2087,  3394,  3030,  3267,  3392,  5808,  6412,  3382,
    3303,  4095,  2596,  2680,   515,    -1,   920,    -1,   665,    -1,
      62,   408,   514,    -1,  5400,  5401,   527,   528,   529,   530,
     531,   532,    -1,    -1,    -1,  6437,    -1,   684,   312,    -1,
      -1,    -1,   534,   690,    -1,   537,   538,   539,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   702,    98,    -1,  4250,    -1,
      -1,  6093,  4254,    -1,    -1,  2692,    -1,    -1,    -1,  5445,
      -1,   718,  5320,    -1,    -1,    -1,   723,    -1,  6215,    -1,
      -1,   728,    -1,  5459,    -1,   732,   733,    -1,  5464,    -1,
      -1,    -1,   739,  5469,   741,   742,    -1,  4250,    -1,    -1,
      -1,  4254,  5478,    -1,    -1,    -1,    -1,   754,   755,    -1,
      -1,    -1,  5488,    -1,    -1,    -1,  5492,    -1,   765,  5495,
     162,  5126,    -1,    -1,    -1,    -1,    -1,    -1,   515,    -1,
    5506,  5507,  5508,    -1,   408,    -1,    -1,    -1,    -1,    -1,
     527,   528,   529,   530,   531,   532,    -1,    -1,    -1,  5518,
    5138,  6397,  5518,  5518,  5518,  5518,  5518,   199,    -1,  5518,
      -1,  5518,    -1,  5518,  5518,  6459,  5542,  4359,  5518,  5518,
      -1,   818,  6327,    -1,    -1,  5518,    -1,    -1,    -1,  5518,
    5507,  5518,    -1,  5559,    -1,  5473,    -1,  5563,    -1,  5565,
      -1,    -1,  5608,   840,   841,    -1,    -1,    -1,    -1,   846,
      -1,  6233,   244,  5579,    -1,    -1,  4359,   249,  5518,  5518,
      -1,  5587,  6458,    -1,  5590,    -1,  5504,  5518,  5594,    -1,
      -1,  6376,    -1,    -1,   871,  5601,   873,  6330,  6331,    -1,
    5518,    -1,  5608,    -1,    -1,    -1,    -1,  6483,    -1,    -1,
      -1,   515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     897,   293,    -1,   527,   528,   529,   530,   531,   532,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   920,    -1,  5651,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    25,  5660,   327,   933,    -1,    -1,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5676,    -1,  5307,    -1,    46,    -1,  5682,  5683,    -1,    -1,
      -1,  5687,  5688,  5689,  5690,    -1,    -1,    -1,  5887,  5307,
      -1,    -1,    -1,  5328,    -1,    -1,    -1,    -1,    -1,    -1,
     372,    -1,    -1,    -1,    76,   377,    -1,    -1,    -1,    -1,
      -1,    -1,  5718,    -1,   386,    -1,    -1,    -1,    -1,    -1,
      -1,  5727,    -1,   395,    -1,    -1,    -1,  5362,    -1,    -1,
      -1,   403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   416,    -1,  5752,    -1,    -1,  5755,
      -1,    -1,    -1,   425,    -1,    -1,    -1,    -1,   430,   131,
      -1,   133,    -1,    -1,  1041,  1042,  1043,    -1,   140,  4591,
    4592,    -1,   144,  1050,  5780,    -1,    -1,    -1,  1055,   451,
      -1,    -1,    -1,  1060,  1061,    -1,    -1,    -1,  1065,    -1,
    1067,    -1,    -1,    -1,  1071,    -1,    -1,    -1,    -1,    -1,
      -1,   173,  5808,    -1,    -1,    -1,    -1,    -1,  4591,  4592,
    1087,    -1,    -1,    -1,  5820,    -1,   488,    -1,    -1,    -1,
     492,    -1,    -1,  5829,  5830,  5831,    -1,    -1,    -1,  5835,
      -1,    -1,    -1,    -1,    -1,  5841,    -1,   209,  5844,  5757,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5853,    -1,  5855,
      -1,  5857,  5858,    -1,  1131,  5473,  1133,  1134,    -1,    -1,
      -1,    -1,    -1,  5869,    -1,    -1,    -1,    -1,    -1,    -1,
    5876,    -1,    -1,  5508,    -1,    -1,    -1,    -1,    -1,  5885,
      -1,  5887,    -1,    -1,    -1,  5891,  5504,    -1,    -1,    -1,
    5896,  6083,    -1,    -1,    -1,    -1,    -1,  1174,    -1,    -1,
    5518,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   289,    -1,    -1,
      -1,   293,    -1,    -1,    -1,  1202,  5932,  5933,    -1,    -1,
      -1,    -1,   304,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   314,    -1,    -1,    -1,    -1,    -1,  5866,    -1,
      -1,    -1,  5587,    -1,   326,    -1,  5962,    -1,  1235,    -1,
    6152,  6153,    -1,    -1,    -1,    -1,    -1,  1244,    -1,  1246,
    5976,    25,    -1,    -1,    -1,    -1,    -1,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1263,    -1,    -1,    -1,
    5608,  1268,    46,    -1,    -1,    -1,   368,    -1,    -1,   371,
     372,    -1,    -1,  1280,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4833,    -1,    -1,    -1,    -1,    -1,    -1,  4840,    -1,
      -1,  6027,    76,  4845,    -1,    -1,  4848,  4849,    -1,    -1,
      -1,   403,    -1,    -1,    -1,    -1,  6042,    -1,    -1,    -1,
    6046,    -1,    -1,    -1,    -1,  1322,  6052,    -1,    -1,    -1,
    4833,    -1,    -1,    -1,  6060,    -1,    -1,  4840,  6064,    -1,
      -1,    -1,  4845,  3320,  3321,  4848,    -1,    -1,  3325,    -1,
      -1,    -1,    -1,    -1,  1351,  1352,  1353,  6083,  1355,   133,
      -1,    -1,    -1,    -1,    -1,    -1,   140,    -1,    -1,  6095,
     144,    -1,    -1,    -1,    -1,    -1,  6102,    -1,    -1,  1376,
      -1,    -1,    -1,    -1,   476,    -1,    -1,    -1,    -1,  3366,
    3367,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   173,
    5755,  6127,    -1,    -1,  1401,    -1,    -1,    -1,  6134,    -1,
      -1,    -1,  1409,  1410,    -1,    -1,    -1,  5755,  6144,  5757,
      -1,    -1,    -1,    -1,    -1,    -1,  6152,  6153,  6154,    -1,
      -1,    -1,  6158,    -1,    -1,   209,  1433,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6151,    -1,    -1,  6181,  6182,  6183,    -1,    -1,
      -1,    -1,    -1,  6189,  6190,  1462,    -1,  6193,    -1,    -1,
    6196,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,  1479,    17,    18,    19,  1483,  1484,  6126,    -1,
      -1,  6151,  6151,    -1,    -1,  6221,    -1,    -1,    -1,    -1,
    6151,  6227,  1499,  6269,    -1,    -1,    -1,    -1,  1505,    -1,
      -1,    45,    -1,  6151,  5869,   289,    -1,    -1,    52,   293,
      -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,  5866,    -1,
     304,    -1,    -1,  6259,  6260,  6261,    -1,    -1,    -1,  6265,
     314,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   326,  5095,    -1,    -1,    -1,  6283,    98,  6471,
    6472,    -1,    -1,    -1,  6290,    -1,    -1,    -1,    -1,    -1,
    6269,    -1,  6298,    -1,    -1,  1572,    -1,    -1,    -1,    -1,
    6306,    -1,    -1,    -1,  5126,    -1,  6312,    -1,    -1,    22,
      -1,  6317,    -1,    -1,   368,    28,    -1,   371,   372,    -1,
      -1,  6327,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6269,
    6269,    -1,    -1,    -1,    -1,    -1,  1613,    -1,  6269,    -1,
      -1,  5976,   162,  5126,    -1,    10,    -1,    -1,    13,   403,
      -1,  6269,    17,    18,    19,    -1,    -1,  6363,  6364,  6365,
    6366,    -1,    -1,    -1,    -1,  6371,    -1,    -1,    -1,  1646,
    6376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   199,
      45,  6387,    -1,   197,  6390,    -1,    -1,    52,   202,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6410,    -1,    -1,    -1,    -1,    -1,
      -1,   225,   226,    78,    -1,  6394,    -1,    -1,    -1,    -1,
      -1,    -1,   476,    -1,    -1,    -1,    -1,    -1,    -1,   249,
      -1,  6437,  6438,    -1,    -1,    -1,  1713,    -1,    -1,   253,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6454,    -1,
       0,  1728,  1729,  1730,  6394,  6394,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6394,    -1,  6471,  6472,    -1,    -1,  6475,
      -1,  6477,    -1,   293,    -1,    -1,  6394,    -1,    -1,    -1,
      -1,    -1,   296,    -1,    -1,  5307,    -1,    -1,  6494,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5328,   327,  6126,  6144,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   207,    -1,    -1,  5307,    -1,    -1,    -1,    -1,    -1,
     216,    -1,   197,  6151,    -1,    -1,    -1,   202,    -1,    -1,
    5362,    -1,    -1,    -1,   230,  5328,    -1,    -1,    -1,    99,
      -1,  1828,   372,    -1,   374,    -1,    -1,   377,    -1,    -1,
     225,   226,    -1,  1840,    -1,    -1,   386,    -1,    -1,    -1,
      -1,    -1,    17,    -1,  1851,   395,    -1,    -1,  5400,  5362,
      -1,    26,    -1,   403,    -1,    -1,  1863,    -1,   253,    -1,
    1867,    -1,    -1,    -1,   408,    -1,   416,    -1,    -1,    -1,
      -1,    -1,    -1,   153,    -1,   425,    -1,    -1,    -1,  1886,
     430,    -1,    -1,    -1,    -1,    -1,   166,  1894,    -1,    -1,
      -1,    -1,   172,  5445,  6259,  1902,    -1,    -1,   178,    -1,
    6265,   296,    -1,    -1,   184,    -1,    -1,   187,    -1,    -1,
      -1,   191,    -1,    -1,  1921,    -1,    -1,   312,    -1,    -1,
      -1,  6269,    -1,  1930,    -1,    -1,  1933,    -1,    -1,  1936,
      -1,    -1,  1939,  1940,    -1,    -1,  1943,  1944,   488,  1946,
    1947,   221,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1958,    -1,  1960,  1961,    -1,  5508,    -1,    -1,    -1,
      -1,    -1,    -1,  1970,  1971,    -1,  1973,  1974,    -1,    -1,
      -1,   515,    -1,    -1,   254,    -1,    -1,    -1,    -1,    -1,
     524,   525,   526,   527,   528,   529,   530,   531,   532,    -1,
      -1,    -1,    -1,    -1,    -1,  5508,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2011,    -1,    -1,    -1,  2015,  2016,
      -1,    -1,    -1,   408,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6390,   306,    -1,    -1,    -1,
     310,    -1,    -1,    -1,    -1,  5587,   316,    -1,    -1,    -1,
      -1,    -1,    -1,  2050,    -1,  2052,  6394,    -1,    -1,    -1,
    2057,  2058,    -1,    -1,    -1,    -1,    -1,  2064,  2065,  2066,
    2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,  2076,
      -1,    -1,    -1,  2080,  5587,  2082,    -1,  2084,  2085,  2086,
    2087,  2088,  2089,    -1,    -1,  2092,    -1,  2094,  2095,    -1,
      -1,  2098,    -1,    -1,    -1,    -1,   376,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2112,  2113,  2114,  2115,    -1,
      -1,    -1,    25,    -1,    -1,    -1,  4103,    -1,    31,    -1,
     515,    -1,    -1,    -1,  2131,    -1,  2133,    -1,    -1,   524,
     525,   526,   527,   528,   529,   530,   531,   532,  4125,  4126,
    4127,  4128,    -1,    -1,  4131,  4132,  4133,  4134,  4135,  4136,
    4137,  4138,  4139,  4140,    38,   435,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4159,    -1,    -1,  5727,    60,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   465,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    86,  5755,    -1,    -1,    -1,    -1,  4195,  4196,
     490,    -1,   492,   493,    -1,    -1,    -1,    -1,    -1,    -1,
     133,    -1,    -1,    -1,    -1,    -1,    -1,   140,   112,   113,
      -1,   144,    -1,    -1,   514,    -1,   120,    -1,    -1,    -1,
      -1,    -1,  5755,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   534,  4242,    -1,   537,   538,   539,
     173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   684,    -1,
      -1,    -1,  2279,    -1,   690,    -1,   160,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,   702,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,   209,    -1,   182,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    45,  5869,    -1,    -1,
      -1,   205,    -1,    52,    -1,    -1,  2333,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    -1,    -1,   779,    31,   781,    -1,
     783,    -1,    -1,    -1,    -1,    -1,   789,   790,   791,    78,
      -1,    -1,    46,    -1,    -1,    -1,  5869,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   289,    -1,    -1,   263,
     293,    -1,    76,  2390,   268,    -1,    -1,    -1,    -1,   273,
      -1,   304,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   314,    -1,    -1,    -1,   289,    -1,    -1,    -1,   293,
      -1,    -1,    -1,   326,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5976,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,    -1,   133,
      -1,   325,    -1,    -1,    -1,    -1,   140,    -1,    -1,    -1,
     144,    -1,    -1,    -1,    -1,   368,    -1,    -1,   371,   372,
      -1,    -1,    -1,  5976,    -1,    51,    -1,    -1,   197,    -1,
      -1,    -1,    -1,   202,    -1,    -1,    -1,    -1,    -1,   173,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   373,
     403,    -1,    -1,   668,    -1,    -1,   225,   226,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   397,    -1,   209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   253,    -1,    -1,    -1,    -1,    -1,
      -1,  6083,    -1,    -1,   418,    -1,   420,   980,    -1,   423,
      -1,    -1,    -1,   718,   719,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4546,
      -1,    -1,    -1,   476,    -1,    -1,    -1,   296,  2575,  2576,
    2577,  2578,  2579,  2580,  2581,  2582,  2583,    -1,  2585,    -1,
      -1,    -1,    -1,   312,    -1,   469,   315,    -1,    -1,  2596,
      -1,  2598,  6144,    -1,    -1,   289,    -1,    -1,    -1,   293,
    6152,  6153,    -1,    -1,    -1,    -1,    -1,  1050,    -1,    -1,
     304,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     314,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2636,
      -1,  6144,   326,  2640,    -1,    -1,  2643,    -1,  2645,   814,
      -1,  2648,    -1,    -1,    -1,  2652,    -1,    -1,    -1,    -1,
      -1,    -1,   536,    -1,    -1,    -1,    -1,    -1,    -1,   834,
      -1,    -1,    -1,    -1,    -1,    -1,  2673,   842,  2675,    -1,
     845,   846,   847,    -1,   368,    -1,    -1,   371,   372,   408,
      -1,    -1,    -1,    -1,    -1,  2692,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2701,  2702,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6259,    -1,   403,
      -1,    -1,    -1,  6265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2728,    -1,    -1,    -1,    -1,    -1,    -1,  2735,    -1,
      -1,  6283,  2739,  2740,    -1,    -1,    -1,    -1,    -1,  2746,
      -1,    -1,    -1,  2750,    -1,    -1,  6259,  2754,    -1,    -1,
      -1,    -1,  6265,    -1,    -1,    -1,  2763,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,
      -1,  2778,    31,    -1,  2781,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   476,    -1,    -1,  2792,   515,  2794,  2795,  4776,
    2797,  2798,    -1,  2800,    -1,   524,   525,   526,   527,   528,
     529,   530,   531,   532,    -1,  2812,    -1,    -1,   537,    -1,
      -1,   540,    -1,  6365,    -1,    -1,    -1,    76,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2832,  2833,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6390,    -1,
      -1,  2848,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2870,  2871,    -1,    -1,  2874,    -1,    -1,
      -1,    -1,    -1,    -1,   133,  1050,    -1,  6390,    -1,    -1,
      -1,   140,    -1,    -1,    -1,   144,  6438,    -1,    -1,    -1,
      -1,  2898,    -1,  2900,    -1,    -1,    -1,  2904,    -1,    -1,
      -1,    -1,  6454,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2918,    -1,    -1,   173,    -1,    -1,    -1,  2925,  6471,
    6472,  2928,    -1,    -1,    25,    -1,    -1,  2934,    -1,    -1,
      31,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,  2954,    -1,    -1,
     209,    -1,    -1,  2960,    -1,    -1,    -1,    -1,    -1,    35,
    2967,  1404,    -1,    -1,    -1,    -1,  1409,  1410,    -1,    45,
      -1,    -1,    -1,    -1,  2981,    76,    52,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2995,    -1,
      -1,    -1,    -1,  3000,  1437,    -1,    -1,    -1,    -1,  3006,
      -1,    -1,    78,  1446,    -1,  1448,    -1,    -1,    -1,  1452,
      -1,    -1,    -1,    -1,    -1,    -1,  1459,  3024,  3025,  3026,
      -1,    -1,    -1,  3030,    -1,    -1,    -1,    -1,    -1,    -1,
     289,    -1,   133,    -1,   293,    -1,    -1,    -1,    -1,   140,
      -1,    -1,    -1,   144,    -1,   304,    -1,    -1,    -1,    -1,
    3057,  3058,    -1,    -1,    -1,   314,    -1,    -1,    -1,  3066,
      -1,    -1,    -1,    -1,    -1,    -1,  1241,   326,    -1,    -1,
      -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3099,  1268,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1550,   209,   368,
      -1,    -1,   371,   372,    -1,    -1,    -1,  1560,    -1,    -1,
      -1,   197,    -1,    -1,  3131,    -1,   202,    -1,  3135,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   728,    -1,   403,    -1,    -1,    -1,    -1,   225,
     226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1604,  1605,    -1,    -1,    -1,    -1,    -1,   754,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   253,    -1,    -1,
      -1,    -1,  1357,    -1,    -1,    -1,    -1,    -1,   289,    -1,
      -1,  1366,   293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   304,  1647,    -1,    -1,  1382,  1651,  1652,
      -1,    -1,    -1,   314,  3221,    -1,  3223,   476,    -1,    -1,
     296,    -1,    -1,    -1,    -1,   326,  1401,    -1,    -1,  1404,
    1405,  3238,    -1,  3240,  1409,  1410,   312,    -1,    -1,   315,
    3247,    -1,    -1,    -1,  3251,    -1,  3253,  3254,    -1,  3256,
    3257,  3258,    -1,    -1,    -1,    -1,    -1,  5244,    -1,  3266,
      -1,    -1,    -1,    -1,  3271,    -1,    -1,   368,    -1,    -1,
     371,   372,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1713,    -1,    -1,
      -1,    -1,   403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5297,   897,    -1,  3320,  3321,  3322,    -1,    -1,  3325,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3333,  3334,  3335,  3336,
      -1,    -1,   408,    -1,    -1,    -1,    -1,  3344,    -1,    -1,
      -1,    -1,  3349,  3350,    -1,  3352,    -1,  3354,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3366,
    3367,    25,    -1,  3370,    -1,    -1,    -1,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   476,    -1,    -1,    -1,    -1,
      -1,    25,    -1,    -1,  3391,    -1,  3393,    31,  3395,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1845,    -1,    -1,    -1,    -1,  3414,    -1,    -1,
      -1,    25,    76,    -1,    -1,    -1,    -1,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3435,    -1,
      -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,   515,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   524,   525,
     526,   527,   528,   529,   530,   531,   532,    -1,    -1,    -1,
      -1,    -1,    76,    -1,   540,  3472,    -1,    -1,  3475,   133,
    1886,    -1,    -1,    -1,  1060,    -1,   140,    -1,  1894,    -1,
     144,    51,  3489,    -1,    -1,  1071,  1902,  3494,    -1,   133,
      -1,  1666,    -1,    -1,    -1,    -1,   140,    -1,    -1,  1674,
     144,  1087,  3509,    -1,    -1,    -1,    -1,    -1,    -1,   173,
      -1,    -1,    -1,    -1,    -1,    -1,  3523,    -1,    -1,   133,
      -1,    -1,    -1,    -1,  3531,    -1,   140,    -1,    -1,   173,
     144,  1947,    -1,    -1,    -1,    -1,  3543,    -1,    -1,  3546,
       0,  3548,    -1,    -1,    -1,   209,  3553,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1974,   173,
      20,  3568,  3569,    -1,    -1,   209,    -1,  3574,    -1,    -1,
      -1,    31,  5559,    33,    34,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3589,    -1,    -1,  3592,    -1,    -1,  3595,    -1,
      -1,    51,    -1,    -1,    -1,   209,  3603,    -1,    -1,    -1,
      -1,    61,    -1,  5590,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    73,    -1,    75,    76,  2060,  2061,    -1,
      -1,  3628,    82,    -1,    84,   289,    -1,  3634,    -1,   293,
      -1,    -1,    -1,    -1,  2077,  2078,    -1,    97,    -1,    99,
     304,    -1,    -1,    -1,    -1,   289,    -1,    -1,    -1,   293,
     314,    -1,    -1,    -1,    -1,    -1,   116,    -1,  1244,   119,
     304,    -1,   326,    -1,    -1,  2108,    -1,  3674,  3675,  3676,
     314,    -1,    -1,    -1,   134,   289,   136,    -1,    -1,   293,
     140,    -1,   326,    -1,    -1,    -1,    -1,   147,    -1,    -1,
     304,    -1,  3699,    -1,    -1,    -1,    -1,   157,    -1,   159,
     314,  3708,    -1,  3710,   368,    -1,   166,   371,   372,    -1,
      -1,  3718,   326,    -1,  1889,    -1,    -1,    -1,  1893,    -1,
      -1,    -1,    -1,    -1,   184,    -1,    -1,   371,   372,    -1,
      -1,    -1,    -1,  3740,    -1,    -1,    -1,    -1,    -1,   403,
      -1,   201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   368,    -1,    -1,   371,   372,   403,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   403,
      -1,    -1,    -1,    -1,    -1,   255,   256,    35,    -1,  3806,
      -1,   261,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,
      -1,    -1,   476,    -1,    52,    -1,   276,    -1,  1404,    -1,
      -1,    -1,    -1,  3830,    -1,    -1,    -1,    -1,  3835,    -1,
      -1,    -1,   476,    -1,  3841,   295,    -1,    -1,    -1,    -1,
      78,    -1,    -1,  3850,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5844,    -1,    -1,
      -1,    -1,   476,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3877,  3878,    -1,    -1,    -1,    -1,  3883,    -1,  3885,    -1,
      -1,    -1,    -1,    -1,   344,    -1,    -1,    -1,  2063,    -1,
      -1,  3898,    -1,  3900,    -1,    -1,    -1,    -1,    -1,   359,
      -1,    -1,    -1,    -1,   364,   365,    -1,   367,    -1,    -1,
      -1,    -1,   372,  3920,    -1,    -1,    -1,    -1,   378,  1505,
      -1,   381,    -1,    -1,    -1,    -1,    -1,    -1,   388,    -1,
      -1,    -1,    -1,    -1,    -1,   395,   396,    -1,    -1,  3946,
      -1,    -1,    -1,   403,    -1,    -1,    -1,   407,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   418,   197,
    3967,  3968,    -1,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   435,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3990,    -1,    -1,  1572,   225,   226,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   456,    -1,    -1,    -1,
      -1,    -1,  4009,    -1,    -1,    -1,    -1,    -1,   468,    -1,
      -1,    -1,    -1,    -1,   474,   253,    -1,    -1,    -1,   479,
      -1,  4028,    -1,    -1,    -1,  4032,    -1,  1613,    -1,    -1,
      -1,    -1,    -1,   493,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    51,  4053,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6042,    -1,   517,   296,    -1,
    1646,    -1,  4069,    -1,    -1,  4072,    -1,    -1,    -1,    -1,
      -1,  4078,    -1,    -1,   312,    -1,   536,   315,    -1,   539,
      -1,    -1,    -1,    -1,    -1,  4092,    -1,    -1,    -1,  4096,
    4097,  4098,    -1,    -1,    -1,    -1,  4103,    -1,    -1,  4106,
      -1,    -1,  4109,    -1,    -1,    -1,    -1,    -1,  4115,    -1,
    4117,    -1,    -1,  4120,    -1,    -1,    -1,  4124,  4125,  4126,
    4127,  4128,    -1,    -1,  4131,  4132,  4133,  4134,  4135,  4136,
    4137,  4138,  4139,  4140,    -1,    -1,    -1,  4144,  4145,  4146,
      -1,    -1,  4149,    -1,    -1,    -1,    -1,  4154,    -1,    -1,
      -1,    -1,  4159,    -1,  4161,    -1,  4163,    -1,   728,    -1,
      -1,    -1,    -1,    -1,  4171,    -1,    -1,  4174,    -1,  4176,
     408,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,   754,  4192,    -1,    -1,  4195,  4196,
      -1,    -1,    -1,  4200,  4201,    -1,    -1,    -1,  4205,    35,
    4207,    -1,  6189,  6190,    -1,    -1,  6193,    -1,    -1,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,
    2663,  2664,    -1,    -1,    -1,    -1,  2669,    -1,    -1,  4236,
      -1,    -1,    -1,    -1,    -1,  4242,    -1,    -1,    -1,    -1,
      -1,    -1,    78,  4250,    -1,    -1,    -1,  4254,    -1,    -1,
      -1,    -1,    -1,    -1,  1840,    -1,    -1,    -1,  2701,  2702,
      -1,    -1,    -1,    -1,    -1,  1851,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   515,    -1,    -1,
    4287,  1867,    -1,    -1,    -1,    -1,   524,   525,   526,   527,
     528,   529,   530,   531,   532,    -1,    -1,  4304,    -1,    -1,
      -1,    -1,   540,  4310,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2728,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2763,    -1,    -1,    -1,    -1,    -1,    -1,   897,    -1,  4336,
    2746,    -1,    -1,    -1,  2750,  1921,    -1,    -1,  2754,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1936,    -1,  4359,  1939,  1940,    -1,    -1,    -1,    -1,    -1,
      -1,   197,  2778,    -1,    -1,    -1,   202,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1970,  1971,    -1,    -1,    -1,   225,
     226,    -1,    35,  4400,    -1,    -1,  2812,    -1,  4405,  4406,
    4407,    -1,    45,    -1,    -1,    -1,    -1,    -1,  2851,    52,
      -1,    -1,    -1,    -1,    -1,    -1,  2832,   253,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4433,  4434,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    10,
    2615,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,  2871,    -1,    -1,    -1,    -1,
     296,    -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,
      -1,  1041,  4479,    -1,    45,  4482,   312,    -1,    -1,   315,
      -1,    52,  2898,    -1,    -1,    -1,    -1,    -1,  2904,    -1,
    1060,    -1,    -1,    -1,    -1,    -1,    -1,  2940,    -1,    -1,
      -1,  1071,  2918,    -1,    -1,  2948,    -1,    78,  2951,  2925,
      -1,    -1,  2928,    -1,    -1,    -1,    -1,  1087,  2934,    -1,
    2963,    -1,    -1,    -1,    -1,    -1,  2112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2954,  4546,
      -1,    -1,    -1,    -1,  2960,    -1,    -1,    -1,    -1,    -1,
      -1,  2967,    -1,    -1,   197,    -1,    -1,    -1,    -1,   202,
      -1,    -1,    -1,    -1,    -1,  2981,  4573,  4574,    -1,    -1,
    4577,    -1,   408,    -1,    -1,    -1,    -1,  4584,    -1,  2995,
      -1,    -1,   225,   226,  4591,  4592,    -1,    -1,  2763,    -1,
    3006,    -1,    -1,    -1,  4601,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     253,    -1,    -1,    -1,    -1,    -1,    -1,  4624,    -1,    -1,
      -1,    -1,  4629,  4630,  4631,    -1,   197,    -1,    -1,    -1,
      -1,   202,    -1,    -1,  4641,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2819,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   296,   225,   226,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,
      -1,    -1,   315,    -1,  1244,  4682,    -1,    -1,  4685,   515,
      -1,    -1,   253,    -1,    -1,    -1,    -1,    -1,   524,   525,
     526,   527,   528,   529,   530,   531,   532,    -1,    -1,    -1,
      -1,   537,    -1,    -1,  4711,    -1,    25,    -1,    -1,    -1,
      -1,    -1,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4727,    -1,   728,    -1,    -1,   296,    -1,    -1,    -1,    -1,
      -1,  2906,    -1,    -1,    -1,    -1,    -1,    -1,  4745,    -1,
      -1,   312,    -1,    -1,   315,    -1,    -1,    -1,   754,    -1,
      -1,    -1,    -1,    -1,    -1,  2930,    -1,    76,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   408,  4773,  3210,    -1,  4776,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4784,  4785,    -1,
    4787,    -1,    -1,    -1,  4791,  4792,    -1,    -1,    -1,  4796,
      -1,    -1,    -1,    -1,  4801,    -1,    -1,  4804,  4805,    -1,
      -1,    -1,    -1,    -1,  4811,  3221,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   133,    -1,    -1,    -1,    -1,  2994,
      -1,   140,    -1,  2998,  3240,   144,  4833,    -1,    -1,    -1,
      -1,  3247,    -1,  4840,    -1,    -1,    -1,   408,  4845,    -1,
      -1,  4848,  4849,    -1,    -1,    -1,    -1,    -1,    -1,  4856,
      -1,    -1,    -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,
    3035,    -1,  3037,    -1,  3039,  3040,    -1,    -1,  4875,  3044,
    3045,  3046,   515,  3048,  3049,  3050,    -1,    -1,    -1,    -1,
      -1,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     209,   897,    -1,    -1,   537,    -1,    -1,  4904,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4917,    -1,    -1,    -1,    -1,  4922,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1505,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   515,    -1,    -1,    -1,    -1,    -1,
      -1,  4958,  3127,   524,   525,   526,   527,   528,   529,   530,
     531,   532,    -1,    -1,    -1,    -1,   537,    -1,  4975,    10,
     289,    -1,    13,  4980,   293,    -1,    17,    18,    19,    -1,
    4987,    -1,    -1,    -1,    -1,   304,    -1,    -1,    -1,    -1,
    3433,    -1,  3435,    -1,    35,   314,  5003,    -1,    -1,    -1,
      -1,    -1,  1572,  5010,    45,    -1,    -1,   326,  3451,    -1,
      -1,    52,    -1,    -1,  5021,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,
      -1,    -1,    -1,  1613,    -1,  5052,    -1,    -1,    -1,   368,
      -1,    -1,   371,   372,  1060,    -1,    -1,    -1,  3501,  3502,
      -1,    -1,    -1,    -1,    -1,  1071,    -1,    -1,    -1,    -1,
      -1,  5078,    -1,    -1,    -1,    -1,  1646,    -1,    -1,    -1,
      -1,  1087,    -1,    -1,   403,    -1,    -1,    -1,  5095,    62,
      -1,    -1,    -1,  5100,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5119,    -1,    -1,    -1,    -1,    -1,    -1,  5126,
      -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2735,
      -1,    -1,    -1,  2739,  2740,    -1,   197,   476,  1728,  1729,
    1730,   202,    -1,    -1,    -1,  5172,    -1,  5174,    -1,    -1,
      -1,    -1,    -1,  3589,    -1,    -1,    23,    -1,    -1,    -1,
      -1,    28,    -1,    -1,   225,   226,    -1,    -1,    -1,   162,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5205,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2794,    -1,
      -1,    -1,   253,    -1,  2800,    -1,    -1,    -1,    -1,    66,
      -1,    -1,    -1,    -1,  5231,    -1,   199,    -1,    -1,    -1,
      -1,    -1,    79,    -1,  5241,    -1,    -1,  5244,  1244,    -1,
    5247,  5248,  5249,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      -1,    -1,    -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,
    3435,    -1,  2848,    -1,    -1,  5272,  5273,   114,    -1,  5276,
    1840,   312,    -1,    -1,   315,    -1,   249,    -1,    -1,    -1,
      -1,  1851,    -1,  3699,    -1,    -1,  5293,    -1,    -1,    -1,
    5297,   138,    -1,    -1,    -1,    -1,  5303,  1867,    -1,    -1,
    5307,    -1,    -1,    -1,    -1,   152,  5313,  5314,    -1,    -1,
      -1,    -1,    -1,    -1,   161,  5322,   289,    -1,    -1,    -1,
     293,  5328,    -1,    -1,  5331,    -1,    -1,   174,    -1,    -1,
    5337,    -1,  5339,   180,    -1,    -1,    -1,    -1,    -1,    -1,
     187,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1921,    -1,   326,   327,  5362,    -1,    -1,    -1,    -1,
     207,    -1,    -1,    -1,    -1,    -1,  1936,   408,    -1,  1939,
    1940,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5389,  5390,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5400,    -1,   368,    -1,    -1,    -1,   372,
    1970,  1971,    -1,    -1,   377,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   386,  3830,    -1,    -1,  3592,    -1,    -1,
     267,    -1,   395,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     403,    -1,    -1,  5440,    -1,  3878,    -1,    -1,  5445,    -1,
      -1,    -1,    -1,   416,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   425,    -1,    -1,    -1,    -1,   430,  3901,    -1,
      -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,    -1,
      -1,    -1,  3058,    -1,   515,    -1,    -1,    -1,   325,    -1,
      -1,    -1,    -1,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   339,    -1,    -1,    -1,   537,    -1,    -1,  1505,
    2070,  5508,   349,   350,  5511,  3680,   353,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2084,   488,    -1,  2087,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   380,    -1,  5542,   383,    -1,    -1,    -1,
     387,    -1,  2112,   390,    -1,  3131,    -1,    -1,    -1,  3135,
     397,    -1,  5559,   400,    -1,    -1,  5563,    -1,  5565,    -1,
      -1,    -1,    -1,  3738,    -1,    -1,  1572,    -1,    -1,    -1,
      -1,    -1,  5579,   420,    -1,    -1,    -1,    -1,    -1,    -1,
    5587,   428,    -1,  5590,    -1,    -1,    -1,    -1,   435,    -1,
      -1,   438,    -1,  4009,  5601,    -1,   443,    -1,    -1,    -1,
      -1,  5608,    -1,    -1,   451,    -1,   453,  1613,    -1,    -1,
      -1,   458,  4028,    -1,    -1,  4058,  4032,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   472,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3808,    -1,    -1,    -1,    -1,   485,    -1,
    1646,    -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3238,  5660,    -1,    -1,    -1,    -1,    -1,  5666,
      -1,    -1,    -1,    -1,  5671,  5672,    -1,  3253,    -1,  5676,
      -1,    -1,  3258,    -1,    -1,  5682,  5683,  5684,    -1,    -1,
      98,  3856,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5698,     8,  3868,  3869,    -1,    -1,    -1,    14,    15,
      -1,    -1,  3288,  3878,    20,    -1,    22,    -1,  3883,    -1,
    3885,  5718,    28,    -1,    30,    -1,    -1,    -1,    -1,    -1,
    5727,    -1,    -1,  5730,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   162,    -1,    -1,    -1,  5755,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3931,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5784,  5785,    -1,
      -1,   199,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
      -1,  3966,  3967,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,  5808,  5809,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    35,    -1,  5820,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    45,  5829,  5830,  5831,    -1,    -1,    -1,    52,    -1,
      -1,   249,    -1,    -1,  1840,    -1,    -1,  5844,  5845,    -1,
      -1,  5848,    -1,    -1,    -1,  1851,  5853,    -1,  5855,    -1,
    5857,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,
      -1,  1867,  5869,    -1,    -1,    -1,    -1,    -1,    -1,  5876,
      -1,   289,    -1,    -1,    -1,   293,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   200,    -1,    -1,    -1,   204,  5896,
      -1,    -1,    -1,    -1,    -1,    -1,   212,    -1,    -1,   215,
      -1,    -1,   218,   219,    -1,   221,    -1,   223,   326,   327,
     226,    -1,   228,    -1,  5921,  1921,    -1,  5924,    -1,    -1,
    4336,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1936,    -1,    -1,  1939,  1940,    -1,    -1,    -1,    -1,    -1,
      -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     368,    -1,    -1,    -1,   372,    -1,    -1,  3543,    -1,   377,
    3546,    -1,  3548,  4406,  1970,  1971,    -1,  3553,   386,  5976,
      -1,    -1,    -1,   197,    -1,    -1,    -1,   395,   202,    -1,
      -1,    -1,    -1,    -1,    -1,   403,    51,    -1,    -1,    -1,
      -1,  4434,    -1,    -1,    -1,  4170,    -1,    -1,   416,    -1,
      -1,   225,   226,    -1,    -1,  4448,    -1,   425,    -1,  3595,
      -1,    -1,   430,    -1,    -1,    -1,  4459,  3603,    -1,    -1,
    6027,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2598,   253,
      -1,    -1,    -1,    -1,    -1,  6042,    -1,    -1,    -1,    -1,
      -1,    -1,  3628,    -1,    -1,  6052,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6069,  4479,    -1,    -1,  4482,    -1,    -1,    -1,
     488,    -1,   296,    -1,    -1,    -1,  6083,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6093,    -1,   312,    -1,
      -1,   315,  4535,  4536,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,    -1,  2112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
      -1,    -1,  3708,    -1,  3710,    -1,    -1,  6134,    -1,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    52,  6144,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6152,  6153,    -1,    -1,    -1,
      -1,  6158,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    -1,    -1,  2735,    -1,    -1,  4584,  2739,
    2740,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4624,  6189,  6190,   408,  4601,  6193,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    51,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
    3806,    -1,    -1,    -1,  2794,    -1,  6233,    -1,    -1,    45,
    2800,  4406,    -1,    -1,  4677,    -1,    52,    51,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6259,    -1,    -1,    -1,    -1,    -1,  6265,  4434,
      -1,    -1,    78,    -1,  3850,    -1,  4682,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4449,    -1,  6283,  4452,  2848,  4454,
      -1,   197,    -1,  6290,    -1,    -1,   202,    -1,    -1,    -1,
      -1,   515,  3878,    -1,    -1,    -1,    -1,    -1,    -1,  6306,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   225,
     226,    -1,    -1,   537,    -1,    -1,    -1,    -1,    -1,    -1,
    6327,    -1,    -1,    -1,    -1,  4500,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   253,    -1,    -1,
      -1,  4516,    -1,    -1,    -1,    -1,  4521,    -1,    -1,    -1,
     666,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6365,    -1,
    3946,   677,    -1,  6370,    -1,   681,    -1,    -1,    -1,  6376,
      -1,    -1,   688,   689,    -1,    -1,   692,    -1,   694,   695,
     296,   197,  3968,  6390,    -1,    -1,   202,    -1,    -1,    -1,
    6397,    -1,    -1,   709,    -1,    -1,   312,    -1,    -1,   315,
      -1,    -1,    -1,    -1,  3990,    -1,    -1,    -1,    -1,   225,
     226,   727,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6437,  6438,   748,    -1,   750,    -1,    -1,   253,    -1,    -1,
      -1,    -1,    -1,    -1,   760,    -1,  4621,  6454,    -1,  4624,
      -1,  6458,    -1,    -1,    -1,    -1,  3026,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6471,  6472,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6483,   793,    -1,    -1,
     296,    -1,    -1,    -1,    -1,    -1,  4072,    -1,  3058,    -1,
      -1,    -1,   408,    -1,    -1,    -1,   312,  4940,    -1,   315,
      -1,    -1,    -1,  4946,    -1,    -1,    -1,    -1,  4951,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4700,  4701,  4702,  4703,    -1,
    4705,  4706,  4707,  4708,  4709,  4978,  4979,    -1,  4124,    -1,
    4983,  4984,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   874,  4975,
      -1,  3131,    -1,  4149,    -1,  3135,    -1,    -1,    -1,    -1,
      -1,  4987,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   408,    -1,    -1,    -1,    -1,    -1,    -1,   515,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   524,   525,
     526,   527,   528,   529,   530,   531,   532,    -1,   728,    -1,
      -1,   537,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,   959,   754,    -1,    -1,    -1,  4823,    -1,
    4825,    10,    -1,    -1,    13,    35,    -1,    -1,    17,    18,
      19,    -1,    -1,   728,    -1,    45,    -1,    -1,  3238,    -1,
      -1,    -1,    52,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      -1,    -1,    -1,  3253,    -1,    -1,    45,    -1,  3258,   754,
      -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,    78,   515,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   524,   525,
     526,   527,   528,   529,   530,   531,   532,  1033,  3288,    78,
      -1,   537,    -1,    -1,  4310,    -1,    -1,    -1,    -1,  2735,
      -1,    -1,    -1,  2739,  2740,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1058,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1073,    -1,  1075,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1085,
      -1,    -1,    -1,    -1,    -1,    -1,  1092,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   897,  2794,  5205,
      -1,    -1,    -1,    -1,  2800,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   197,    -1,  1135,
    4406,  1137,   202,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   897,    -1,    -1,    -1,    -1,    -1,   197,    -1,
      -1,    -1,  2848,   202,    -1,   225,   226,    -1,  4434,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   225,   226,    -1,    -1,
      -1,    -1,    -1,   253,    -1,  5050,  5051,    -1,    -1,    -1,
      -1,   728,    -1,    -1,    -1,    -1,    -1,    -1,  5063,    -1,
    5065,  5066,  5067,    -1,   253,  1211,    -1,  1213,    -1,  1215,
      -1,  1217,    -1,  1219,  1220,  1221,    -1,   754,    -1,    -1,
    1226,    -1,    -1,    -1,   728,    -1,   296,    10,    -1,    -1,
      13,  5337,  1238,  5339,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,   312,    -1,    -1,   315,    -1,   296,    -1,    -1,
     754,    -1,    35,    -1,    -1,    -1,  5389,    -1,    -1,    -1,
    1060,    -1,    45,   312,    -1,    -1,   315,  5132,    -1,    52,
      -1,  1071,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    10,  3543,    -1,    13,  3546,  1087,  3548,    17,
      18,    19,    -1,  3553,    -1,    78,    -1,    -1,    -1,    -1,
      -1,  4577,    -1,    -1,    -1,  1060,  5171,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1071,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1087,    -1,    -1,  3595,    -1,    -1,   408,    -1,
      -1,    -1,    -1,  3603,    -1,    -1,    -1,    -1,  4624,  5214,
      78,    -1,    -1,  4629,    -1,    -1,    -1,    10,    -1,   408,
      13,    -1,  3058,    -1,    17,    18,    19,    -1,  3628,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    45,   897,    -1,    -1,    -1,    -1,    -1,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   197,    -1,    -1,    -1,    -1,   202,
    1426,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3131,    -1,    -1,    -1,  3135,
      -1,    -1,   225,   226,  1244,   515,    -1,    -1,  3708,    -1,
    3710,    -1,    -1,    -1,   524,   525,   526,   527,   528,   529,
     530,   531,   532,    -1,    -1,    -1,   515,   537,    -1,   197,
     253,    -1,    -1,    -1,   202,   524,   525,   526,   527,   528,
     529,   530,   531,   532,    -1,    -1,    -1,    -1,   537,  1244,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   225,   226,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4787,    -1,   296,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1060,  5389,   253,    -1,    -1,    -1,   312,
      -1,    -1,   315,    -1,  1071,    -1,    -1,    -1,    -1,    -1,
    1546,    -1,  3238,    -1,   197,    -1,  3806,    -1,    -1,   202,
    1087,    -1,    -1,    -1,    -1,    -1,  1060,  3253,    -1,    -1,
      -1,    -1,  3258,    -1,    -1,  5698,    -1,  1071,   296,    -1,
    5435,    -1,   225,   226,    -1,  3835,    -1,    -1,    -1,  5444,
      -1,  3841,    -1,  1087,   312,    -1,    -1,   315,    -1,    -1,
    3850,    -1,  3288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     253,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1618,    -1,    -1,    -1,    -1,    -1,  3878,    -1,
      -1,    -1,    -1,    -1,    -1,   408,    -1,    -1,  4904,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,
      -1,    -1,   315,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,
     408,    -1,  4958,    -1,    -1,    -1,  3946,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4980,  1505,    -1,  1244,  3968,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3990,    -1,   515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1244,   524,   525,   526,   527,   528,   529,   530,   531,   532,
    1505,    -1,    -1,    -1,   537,   408,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1572,    -1,    -1,    -1,  5052,    -1,    -1,    -1,
    5913,    -1,    -1,    -1,    -1,    -1,    -1,   515,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   524,   525,   526,   527,
     528,   529,   530,   531,   532,    -1,    -1,    -1,    -1,   537,
      -1,    -1,  4072,  1613,    -1,    -1,    -1,  1572,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1836,    -1,    -1,  5698,    -1,    -1,    -1,  5702,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1646,  3543,    -1,    -1,
    3546,    -1,  3548,    -1,    -1,    -1,    -1,  3553,  1613,    -1,
      -1,    -1,   515,    -1,  4124,  1871,    -1,    -1,    -1,    -1,
      -1,   524,   525,   526,   527,   528,   529,   530,   531,   532,
      -1,    -1,    -1,    -1,   537,    -1,    -1,    -1,    -1,  4149,
      -1,  1646,    -1,    -1,    -1,    -1,    -1,    -1,  5174,  3595,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3603,    -1,    -1,
      -1,  1917,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1937,  3628,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,  1963,    -1,  1965,
      -1,    -1,    -1,  6069,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    -1,    -1,  1980,    -1,  1982,    -1,    45,    -1,
      -1,    -1,  1988,    -1,  1990,    52,  1992,    -1,  1994,    -1,
    1996,    -1,    -1,    -1,  2000,    -1,    -1,    -1,    -1,    -1,
      -1,  1505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,  3708,    -1,  3710,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2037,    -1,    -1,    -1,    -1,    -1,  5313,    -1,    -1,
    1840,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
    4310,  1851,    -1,    17,    18,    19,    -1,    -1,    -1,  5924,
      -1,    -1,    -1,  5928,    -1,  5930,    -1,  1867,  1572,  5934,
    5935,    35,    -1,    -1,    -1,    -1,  1613,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    -1,  1840,    -1,    -1,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1851,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1613,
    3806,    -1,  1867,  5389,    78,    -1,    -1,    -1,    -1,    -1,
      -1,  1921,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     197,    -1,    -1,    -1,    -1,   202,  1936,    -1,    -1,  1939,
    1940,    -1,  1646,    -1,    -1,    -1,  4406,    -1,    -1,    51,
      -1,    -1,    -1,    -1,  3850,    -1,    -1,    -1,   225,   226,
      -1,    -1,    -1,    -1,    -1,    -1,  1921,    -1,    -1,    -1,
    1970,  1971,    -1,    -1,  4434,    -1,    -1,    -1,    -1,    -1,
      -1,  1936,  3878,    -1,  1939,  1940,   253,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1970,  1971,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,
      -1,    -1,    -1,   197,    -1,  5511,    -1,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,   315,    -1,
    3946,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   225,   226,    -1,  6397,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3968,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   253,
      -1,    -1,    -1,    -1,  3990,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    10,  1840,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,  2112,    -1,  1851,    -1,    -1,  4577,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6458,    -1,    35,    -1,    -1,
    1867,    -1,   296,    -1,    -1,    -1,  1840,    45,    -1,    -1,
      -1,   408,    -1,    -1,    52,    -1,    -1,  1851,   312,    -1,
    6483,   315,    -1,   728,    -1,    -1,    -1,  2112,    -1,    -1,
      -1,    -1,    -1,  1867,  4624,    -1,    -1,    -1,  6233,  4629,
      78,    -1,    -1,    -1,    -1,    -1,  4072,    -1,    -1,   754,
      -1,    -1,    -1,    -1,  1921,    -1,    -1,    -1,    -1,    -1,
    5666,    -1,    -1,    -1,    -1,  5671,  5672,    -1,    -1,  1936,
      -1,    -1,  1939,  1940,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1921,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4124,    -1,
      -1,    -1,  1936,  1970,  1971,  1939,  1940,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   408,    -1,    -1,    -1,   515,    -1,
      -1,    -1,    -1,  4149,    -1,    -1,    -1,   524,   525,   526,
     527,   528,   529,   530,   531,   532,  1970,  1971,    -1,    -1,
     537,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   197,
      -1,    -1,    -1,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5785,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   225,   226,    -1,
      -1,    -1,   897,    -1,    -1,    -1,    -1,  4787,    -1,    -1,
      -1,    -1,  6397,    -1,    -1,    -1,    -1,    -1,    -1,  6404,
      -1,    -1,    -1,  6408,    -1,   253,    -1,    -1,    -1,    -1,
      -1,   515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     524,   525,   526,   527,   528,   529,   530,   531,   532,    -1,
      -1,    -1,  5848,   537,    -1,  2112,    -1,    -1,    -1,  6444,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,
      -1,    -1,    -1,  6458,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   312,    -1,    -1,   315,  2112,    -1,
      -1,    -1,    -1,    -1,  4310,    -1,    -1,    -1,  6483,    -1,
      -1,  6486,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4904,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1060,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1071,    -1,  4958,    -1,
     408,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4406,    -1,  1087,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4980,    -1,    -1,  2729,  2730,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4434,    -1,
      -1,    -1,  2748,  2749,    -1,  2751,  2752,    -1,    -1,    -1,
    2756,  2757,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2771,    -1,    -1,    -1,  2775,
      -1,    -1,    -1,  2779,  2780,    -1,    -1,  2783,  2784,    -1,
      -1,    -1,    -1,    -1,  2790,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5052,    -1,    -1,    -1,  2802,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   515,  2814,    -1,
      -1,    -1,    -1,  2819,    -1,    -1,   524,   525,   526,   527,
     528,   529,   530,   531,   532,    -1,   728,    -1,  2834,   537,
      -1,    -1,  2838,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2850,    -1,    -1,  2853,    -1,  2855,
    2856,  2857,   754,    -1,    -1,    -1,  2862,  2863,    -1,    -1,
      -1,    -1,    -1,    23,    -1,    -1,  2872,    -1,    28,  1244,
      -1,    -1,  2878,    -1,    -1,    -1,  2882,    -1,    -1,    -1,
      -1,  4577,    -1,    -1,    -1,    -1,    -1,    -1,  2894,  2895,
      -1,    -1,    -1,  2899,    -1,    -1,    -1,    -1,    -1,  2905,
    2906,    -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,
      -1,    -1,  5172,  2919,  5174,    -1,  2922,    -1,    -1,    79,
      80,    -1,    -1,  2929,  2930,    -1,    -1,    -1,  4624,  2935,
      -1,    -1,    92,  4629,    -1,  2735,    96,    -1,    -1,  2739,
    2740,  2947,    -1,    -1,  2950,    -1,    -1,    -1,    -1,  2955,
      -1,    -1,    -1,    -1,   114,  2961,  2962,    -1,    -1,    -1,
      -1,    -1,    -1,  2969,    -1,    -1,    -1,  2973,    -1,    -1,
      -1,  2977,  2978,  2979,  2980,    -1,  2982,    -1,   138,    -1,
    2735,    -1,    -1,    -1,  2739,  2740,    -1,    -1,    -1,    -1,
    2996,  2997,   152,  2999,  2794,   897,    -1,    -1,    -1,    -1,
    2800,   161,    -1,    -1,  3010,  3011,  3012,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,
     180,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2794,
      -1,    -1,    -1,    -1,    -1,  2800,    -1,   207,  2848,    -1,
      -1,    -1,    -1,  5313,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3067,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3075,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   245,    -1,    -1,  3094,    -1,
      -1,  4787,    -1,  2848,  6370,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   267,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5389,
    1505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3144,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,   312,    17,    18,    19,    -1,  3163,  1060,  3165,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1071,
      -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,
      -1,    45,    -1,    -1,    -1,  1087,    -1,    -1,    52,   349,
     350,    -1,    -1,   353,    -1,    -1,    -1,  1572,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4904,    -1,
      -1,    -1,    -1,    -1,    78,    -1,    -1,    51,    -1,    -1,
     380,    -1,    -1,   383,    -1,    -1,    -1,   387,    -1,    -1,
     390,  2735,    -1,    -1,    -1,  2739,  2740,   397,  1613,    -1,
     400,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5511,    -1,    -1,  3260,    -1,    -1,  2794,  3058,    -1,
     420,    -1,  4958,  2800,    -1,    -1,    -1,    -1,   428,    -1,
      -1,  1646,    -1,    -1,    -1,   435,    -1,    -1,   438,    -1,
      -1,    -1,    -1,   443,  4980,    -1,    -1,    -1,    -1,    -1,
    2794,   451,    10,   453,    -1,    13,  2800,    -1,   458,    17,
      18,    19,    -1,  3058,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2848,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   485,    -1,    45,    -1,    -1,
      -1,  3131,    -1,   197,    52,  3135,    -1,    -1,   202,    -1,
      -1,    -1,  1244,    -1,  2848,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5052,    -1,    -1,    -1,
      78,   225,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3131,    -1,    -1,    -1,
    3135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   253,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5666,    -1,    -1,    -1,
      -1,  5671,  5672,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   296,    -1,    -1,    -1,    -1,    -1,  3238,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,
      -1,   315,    -1,  3253,    -1,    -1,    -1,    -1,  3258,    -1,
      -1,    -1,    -1,    -1,    -1,  1840,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1851,    -1,  5174,   197,
      -1,    -1,    -1,  3238,   202,    -1,    -1,    -1,  3288,    -1,
      -1,    -1,  1867,    -1,    -1,    -1,    -1,    -1,  3253,    -1,
      -1,    -1,    -1,  3258,    -1,    -1,    -1,   225,   226,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3058,    -1,    -1,  5784,  5785,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3288,    -1,   253,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   408,    -1,  1921,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3058,    -1,    -1,    -1,    -1,    -1,
      -1,  1936,    -1,    -1,  1939,  1940,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,
      -1,    -1,    -1,    -1,  3590,    -1,    -1,    -1,  5848,    -1,
      -1,    -1,    -1,    -1,   312,  1970,  1971,   315,    -1,    -1,
      -1,  3607,    -1,  1505,    -1,  3611,    -1,    -1,    -1,    -1,
    3616,  3617,  3618,    -1,    -1,    -1,    -1,  5313,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3131,    -1,    -1,
      -1,  3135,  3638,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   515,    -1,    -1,    -1,    -1,  3662,  3663,  3664,  3665,
     524,   525,   526,   527,   528,   529,   530,   531,   532,    -1,
    1572,    -1,    -1,   537,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     408,    -1,    -1,  5389,  3700,    -1,  3702,  3703,  3704,    -1,
      -1,  3238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1613,    -1,    -1,    -1,    -1,  3253,    -1,    -1,    -1,
      -1,  3258,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3238,    -1,    -1,  2112,    -1,    -1,
      -1,    -1,    -1,  3543,  1646,    -1,  3546,    -1,  3548,  3253,
      -1,  3288,    -1,  3553,  3258,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3288,    -1,    -1,    -1,  3543,    -1,
      -1,  3546,    -1,  3548,    -1,  3595,    -1,   515,  3553,    -1,
      -1,    -1,    -1,  3603,    -1,    -1,   524,   525,   526,   527,
     528,   529,   530,   531,   532,  5511,  3822,    -1,    -1,   537,
      -1,    -1,    -1,    -1,    -1,  3831,    -1,    -1,  3628,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3595,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3603,    -1,
      -1,  3857,  3858,    -1,    -1,    -1,  3862,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3628,    -1,    -1,    -1,    -1,  3884,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   728,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3708,    -1,
    3710,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     754,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3936,    -1,    -1,    -1,    -1,  3941,    -1,    -1,  1840,    -1,
      -1,  3947,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1851,
      -1,    -1,    -1,  3708,    -1,  3710,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1867,    -1,    -1,    -1,    -1,
    5666,  3977,    -1,    -1,    -1,  5671,  5672,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
    4006,    -1,  4008,    -1,    -1,    -1,  3806,    -1,    -1,    -1,
      -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,  1921,
      -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    52,
      -1,    -1,    -1,    -1,  1936,    -1,    -1,  1939,  1940,  3543,
      -1,    -1,  3546,    -1,  3548,    -1,    -1,    -1,    -1,  3553,
    3850,  3806,    -1,    -1,    -1,    78,    -1,    -1,  3595,    -1,
      -1,    -1,    -1,   897,    -1,    -1,  3603,    -1,  1970,  1971,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3878,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5785,
      -1,  3595,    -1,    -1,    -1,  3850,    -1,    -1,    -1,  3603,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6370,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3878,  3628,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3946,    -1,    -1,    -1,
      -1,    -1,  5848,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3968,    -1,
      -1,  3708,    -1,  3710,   197,    -1,    -1,  6437,    -1,   202,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
    3990,  3946,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,   225,   226,  3708,    -1,  3710,    -1,    -1,    -1,
    2112,    35,    -1,  3968,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    -1,  1060,    -1,    52,    -1,
     253,    -1,    -1,    -1,    -1,  3990,    -1,  1071,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1087,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3806,
      -1,    -1,  4072,   296,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,
      -1,    -1,   315,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3806,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3850,    -1,    -1,  4322,  4072,  4324,    -1,
      -1,    -1,    -1,    -1,  4124,    -1,    -1,    -1,    -1,    -1,
      -1,  4337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4349,    -1,    -1,  3850,  4353,    -1,  4149,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4365,
    2735,    -1,    -1,    -1,  2739,  2740,    -1,    -1,    -1,  4124,
      -1,    -1,    -1,   197,  3878,    -1,    -1,    -1,   202,  4385,
      -1,    -1,    -1,    -1,    -1,   408,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4149,    -1,    -1,  4403,    -1,    -1,
      -1,   225,   226,    -1,    -1,  4411,    -1,    -1,    -1,  3946,
    1244,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2794,
      -1,    -1,    -1,    -1,    -1,  2800,    -1,    -1,    -1,   253,
    4436,    -1,    -1,    -1,  4440,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3946,    -1,    -1,    -1,    -1,    -1,    -1,  4455,
    4456,  4457,  4458,  3990,    -1,    -1,    -1,    -1,    -1,  4465,
    4466,  4467,  4468,    -1,  3968,    -1,    -1,    -1,  4474,  4475,
      -1,    -1,   296,  2848,  4480,  4481,    -1,  4483,  4484,  4485,
    4486,  4487,  4488,  4489,    -1,    -1,  3990,    -1,   312,    -1,
      -1,   315,   515,  4499,    -1,    -1,    -1,  4503,  4504,  4505,
    4506,   524,   525,   526,   527,   528,   529,   530,   531,   532,
    4310,    -1,    -1,    -1,   537,    -1,    -1,    -1,   207,    -1,
      -1,  4527,    -1,    -1,    -1,    -1,    -1,   216,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4072,    -1,    -1,    -1,  4545,
      -1,   230,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4310,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4072,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   408,    -1,    -1,  4124,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4406,    -1,    -1,    -1,
      -1,    -1,  4149,    -1,    -1,    -1,  4622,    -1,    -1,    -1,
    4124,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4434,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4149,    -1,    -1,    -1,  4655,
      -1,  4406,    -1,    -1,    -1,    -1,  4662,    -1,  4664,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1505,    -1,    -1,  6370,    -1,    -1,    -1,    -1,  4434,
      -1,    -1,    -1,  3058,    -1,    -1,  4692,    -1,    -1,    -1,
      -1,   515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     524,   525,   526,   527,   528,   529,   530,   531,   532,    -1,
      -1,    -1,    -1,   537,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1572,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,  3131,    -1,    -1,    -1,
    3135,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    45,  4577,    -1,  1613,
      -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4310,    -1,    -1,    78,
      -1,    -1,  1646,    35,    -1,    -1,    -1,   206,   207,    -1,
      -1,    -1,  4577,    45,  4624,   214,    -1,   216,   217,  4629,
      52,    -1,    -1,  2735,    -1,    -1,    -1,  2739,  2740,    -1,
      -1,   230,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,
      -1,    -1,    -1,  3238,    -1,    -1,    -1,    -1,    -1,  4624,
      -1,    -1,    -1,    -1,  4629,    -1,    -1,    -1,  3253,    -1,
      -1,    -1,    -1,  3258,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2794,    -1,    -1,    -1,    -1,    -1,  2800,  4905,
    4906,  4907,  4406,    -1,    -1,  4911,  4912,  4913,  4914,    -1,
      -1,    -1,  4918,  3288,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   197,    -1,
    4434,    -1,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2848,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   225,   226,    -1,    -1,
      -1,    -1,    -1,    -1,  4970,  4971,  4972,  4973,  4974,    -1,
    4976,  4977,    -1,    -1,    -1,   197,   665,    -1,    -1,    -1,
     202,    -1,  4988,  4989,   253,    -1,    -1,  4787,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   684,    -1,    -1,    -1,    -1,
      -1,   690,    -1,   225,   226,    -1,  1840,    -1,    -1,    -1,
      -1,    -1,    -1,   702,    -1,    -1,  5022,  1851,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,   718,
      -1,   253,  4787,  1867,    -1,    -1,    -1,    -1,    -1,    -1,
    4577,    -1,    -1,   312,   733,    -1,   315,    -1,    -1,    -1,
      -1,    -1,   741,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   755,    -1,    -1,    -1,
      -1,    -1,    -1,  4577,   296,    -1,   765,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1921,    -1,    -1,
     312,    -1,    -1,   315,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1936,    -1,  4904,  1939,  1940,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5125,
    4624,    -1,    -1,    -1,    -1,  4629,    -1,    -1,    -1,   818,
      -1,    -1,    -1,    -1,    -1,    -1,  1970,  1971,    -1,   408,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4904,
      -1,    -1,    -1,    -1,    -1,    -1,  3058,   846,  4958,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3543,    -1,
      -1,  3546,    -1,  3548,    -1,    -1,    -1,    -1,  3553,    -1,
    4980,    -1,   871,    -1,  5190,    -1,   408,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4958,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5222,    -1,    -1,    -1,
    3595,    -1,    -1,    -1,    -1,  4980,    -1,    -1,  3603,  3131,
      -1,    -1,    -1,  3135,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   933,    -1,   515,    -1,    -1,    -1,
      -1,    -1,  5052,  3628,    -1,   524,   525,   526,   527,   528,
     529,   530,   531,   532,    -1,    -1,    -1,    -1,   537,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   665,    -1,  2112,    -1,
      -1,    -1,    -1,  4787,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   515,    -1,   684,    -1,  5052,    -1,    -1,
      -1,   690,   524,   525,   526,   527,   528,   529,   530,   531,
     532,    -1,    -1,   702,  5320,   537,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   718,
      -1,    -1,    -1,  3708,    -1,  3710,  3238,    -1,    -1,    -1,
      -1,    -1,    -1,   732,   733,    -1,    -1,    -1,    -1,    -1,
     739,  3253,   741,   742,  1043,    -1,  3258,    -1,    -1,    -1,
      -1,  1050,    -1,    -1,    -1,    -1,   755,  4904,    -1,    -1,
      -1,    -1,    -1,    -1,  5174,    -1,   765,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5391,  3288,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4904,    -1,    -1,    -1,  5410,    -1,    -1,    -1,    -1,    -1,
    5416,  5417,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5174,
    5426,  4958,    -1,    -1,    -1,    -1,    -1,  5433,    -1,   818,
      -1,  3806,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4980,    -1,    -1,    25,    -1,    -1,    -1,
      -1,    -1,    31,    10,  4958,    -1,    13,   846,    -1,    38,
      17,    18,    19,    -1,  5470,  5471,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3850,  4980,  5483,    35,  5485,
      -1,    60,   871,    -1,    -1,  1174,    -1,    -1,    45,    -1,
      -1,    -1,    -1,    -1,  5500,    52,    -1,    76,    -1,    -1,
      -1,    -1,    -1,  3878,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5313,    -1,  5052,    -1,    -1,    -1,  5525,
      -1,    78,    -1,    -1,    -1,    -1,    -1,  5533,    -1,    -1,
      -1,    -1,    -1,   112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   933,    -1,  1235,    -1,  5052,    -1,
      -1,    -1,    -1,    -1,   133,    -1,    -1,  1246,  5313,    -1,
      -1,   140,    -1,    -1,    -1,   144,    -1,    -1,    -1,    -1,
      -1,  3946,    -1,    -1,  1263,    -1,    -1,    -1,    -1,  1268,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5389,
      -1,    -1,    -1,  3968,   173,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3990,    -1,    -1,    -1,  5625,
      -1,    -1,    -1,    -1,    -1,    -1,   205,    -1,    -1,    -1,
     209,    -1,    -1,  5639,  5389,    -1,    -1,  5174,    -1,    -1,
     197,  3543,    -1,    -1,  3546,   202,  3548,    -1,    -1,    -1,
      -1,  3553,    -1,    -1,  1043,    -1,    -1,    -1,    -1,  5665,
      -1,  1050,    -1,    -1,    -1,    -1,    -1,    -1,   225,   226,
    5174,    -1,  1061,    -1,    -1,    -1,  1065,    -1,  1067,    -1,
      -1,    -1,    -1,    -1,   263,    -1,    -1,    -1,    -1,   268,
      -1,    -1,    -1,  3595,   273,    -1,   253,  4072,    -1,    -1,
      -1,  3603,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     289,  5511,  1401,    -1,   293,    -1,    -1,    -1,    -1,    -1,
    1409,  1410,    -1,    -1,    -1,   304,  3628,  5733,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   314,    -1,    -1,    -1,   296,
      -1,    -1,    -1,    -1,    -1,    -1,   325,   326,    -1,  4124,
      -1,    -1,    -1,    -1,    -1,   312,  5511,    -1,   315,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1462,  4149,    -1,  5313,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1174,    -1,    -1,    -1,   368,
      -1,    -1,   371,   372,   373,    -1,    -1,  5803,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3708,    -1,  3710,  5313,
      -1,    -1,    10,    -1,    -1,    13,    -1,    -1,   397,    17,
      18,    19,    -1,    -1,   403,    -1,    -1,    -1,    -1,    -1,
      -1,  5837,    -1,    -1,    -1,    -1,    -1,    35,    -1,   418,
      -1,    -1,    -1,    -1,    -1,    -1,  1235,    45,    -1,    -1,
      -1,   408,    -1,    -1,    52,    -1,    -1,  1246,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5666,    -1,    -1,    -1,
      -1,  5671,  5672,    -1,  1263,    -1,    -1,  5883,    -1,  1268,
      78,    -1,    -1,    -1,    -1,  5389,    -1,   208,    -1,    -1,
     469,    -1,    -1,    -1,    -1,    -1,    -1,   476,    -1,   220,
      -1,  2735,  5908,    -1,  3806,  2739,  2740,    -1,    -1,    -1,
     231,  5666,    -1,    -1,    -1,    -1,  5671,  5672,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4310,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3850,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   515,    -1,
    2794,  5967,    -1,    -1,    -1,    -1,  2800,   524,   525,   526,
     527,   528,   529,   530,   531,   532,  3878,    -1,    -1,    -1,
     537,    -1,    -1,    -1,    -1,  5785,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   197,
      -1,    -1,    -1,    -1,   202,    -1,    -1,  5511,    -1,    -1,
      -1,    -1,  1401,    -1,  2848,    -1,    -1,    -1,    -1,    -1,
    1409,  1410,    -1,    -1,  1713,    -1,    -1,   225,   226,    -1,
    5785,  4406,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3946,    -1,    -1,    -1,  5848,    -1,
      -1,    -1,    -1,    -1,    -1,   253,    -1,    -1,    -1,  4434,
      -1,    -1,    -1,    -1,    -1,    -1,  3968,    -1,    -1,    -1,
      -1,    -1,    -1,  1462,    -1,    -1,  6082,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,  3990,    -1,
      -1,    -1,    -1,  5848,    -1,    -1,    -1,    -1,   296,    -1,
      -1,    -1,    35,    -1,    -1,  6111,    -1,    -1,    -1,    -1,
      -1,    -1,    45,    -1,   312,    -1,  6122,   315,    -1,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5666,
      -1,    -1,    -1,    -1,  5671,  5672,    -1,    -1,    -1,  1828,
      -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5666,    -1,    -1,    -1,    -1,  5671,  5672,    -1,
    4072,    -1,    -1,    -1,  1863,    -1,    -1,   198,   199,    -1,
      -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1886,    -1,    -1,
      -1,   222,  4577,    -1,    -1,  1894,    -1,    -1,   229,    -1,
     408,    -1,    -1,  1902,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4124,    -1,  3058,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6249,    -1,    -1,    -1,  4149,  5785,  4624,
      -1,    -1,    -1,    -1,  4629,    -1,    -1,  1946,  1947,    -1,
      -1,    -1,    -1,    -1,   197,    -1,    -1,    -1,    -1,   202,
      -1,  1960,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5785,    -1,    -1,  1973,  1974,    -1,    -1,    -1,    -1,
      -1,    -1,   225,   226,    -1,    -1,    -1,  3131,    -1,    -1,
      -1,  3135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5848,    -1,    -1,    -1,    -1,    -1,   515,    -1,    -1,
     253,    -1,    -1,    -1,  1713,    -1,   524,   525,   526,   527,
     528,   529,   530,   531,   532,    -1,    -1,    -1,    -1,   537,
      -1,    -1,    -1,    -1,  5848,   666,    -1,    -1,    -1,    -1,
      -1,   672,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,
      -1,    -1,   315,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3238,    -1,    -1,    -1,  4310,    -1,
      -1,    -1,  4787,    -1,    -1,    -1,    -1,    -1,    -1,  3253,
      -1,    -1,    -1,    -1,  3258,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1828,
      -1,    -1,    -1,    -1,  2133,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3288,  6461,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1863,   408,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1886,    -1,    -1,
      -1,    -1,    -1,    -1,  4406,  1894,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1902,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   843,    -1,    -1,    -1,    -1,    -1,    -1,  4904,
      -1,    -1,  4434,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   862,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1943,  1944,    -1,  1946,  1947,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1958,
    6370,  1960,  1961,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   515,  4958,  1973,  1974,    -1,    -1,    -1,    -1,
      -1,   524,   525,   526,   527,   528,   529,   530,   531,   532,
      10,    -1,    -1,    13,   537,  4980,    -1,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,  6370,    -1,    -1,    -1,    -1,
      -1,    -1,  2011,    -1,    -1,    35,  2015,  2016,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   674,    -1,   676,    -1,    -1,   679,    -1,
     981,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,
      -1,    -1,   693,    10,    -1,  4577,    13,  5052,   699,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,  3543,
      -1,    -1,  3546,    -1,  3548,    52,    -1,    -1,    -1,  3553,
      -1,    -1,  4624,    -1,    -1,    -1,    -1,  4629,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    -1,    -1,  2133,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3595,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3603,
      -1,    -1,    -1,    -1,    -1,  1096,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   197,    -1,    -1,
      -1,    -1,   202,    -1,  3628,    -1,    -1,    -1,    -1,  5174,
      -1,    -1,    -1,    -1,  1125,  1126,  1127,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   225,   226,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6370,    -1,   172,    -1,    -1,    -1,    -1,
      -1,   178,    -1,   253,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     197,    -1,    -1,    -1,    -1,   202,  6370,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3708,    -1,  3710,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4787,   296,    -1,   225,   226,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   312,    -1,    -1,   315,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1234,    -1,    10,   253,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5313,    -1,
      35,  1262,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,   296,
      -1,    -1,    -1,    -1,    -1,   986,   987,    -1,    -1,    -1,
      -1,    -1,  3806,    -1,    -1,   312,    -1,    -1,   315,    -1,
      -1,    -1,    -1,    78,  2673,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   408,    -1,
      -1,    -1,  4904,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5389,    -1,  3850,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   130,  1057,    -1,    -1,  2728,
      -1,    -1,    -1,    -1,  3878,    -1,    -1,    -1,    -1,    -1,
      -1,  1072,    -1,    -1,    -1,    -1,  4958,  2746,    -1,    -1,
      -1,  2750,    -1,    -1,    -1,  2754,    -1,    -1,    -1,    -1,
      -1,   408,    -1,    -1,  2763,    -1,    -1,    -1,  4980,    -1,
      -1,    -1,  1103,  1104,    -1,    -1,    -1,    -1,    -1,  2778,
      -1,    -1,    -1,    -1,  1415,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   197,    -1,    -1,   515,    -1,   202,  1129,    -1,
      -1,    -1,  3946,    -1,   524,   525,   526,   527,   528,   529,
     530,   531,   532,  2812,    -1,   535,    -1,    -1,    -1,    -1,
     225,   226,    -1,    -1,  3968,    -1,  5511,    -1,    -1,    -1,
      -1,    -1,    -1,  2832,  2833,    -1,    -1,    -1,  1169,  1170,
    5052,    -1,    -1,    -1,    -1,    -1,  3990,    -1,   253,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1495,    -1,    -1,    -1,   515,    -1,
      -1,  2870,  2871,    -1,    -1,  2874,    -1,   524,   525,   526,
     527,   528,   529,   530,   531,   532,    -1,    -1,    -1,    -1,
      -1,   296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2898,
      -1,  2900,    -1,    -1,    -1,  2904,    -1,   312,    -1,    -1,
     315,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2918,
      -1,    -1,    -1,    -1,    -1,    -1,  2925,    -1,  4072,  2928,
      -1,    -1,    -1,    -1,    -1,  2934,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1578,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2954,  1587,    -1,    -1,    -1,
      -1,  2960,  5174,    -1,    -1,    -1,    -1,    -1,  2967,    -1,
      -1,    -1,    -1,    -1,  2673,    -1,    -1,    -1,    -1,    -1,
    4124,  5666,  2981,    -1,    -1,    -1,  5671,  5672,  1619,    -1,
      -1,    -1,    -1,    -1,  1625,  1626,  2995,    -1,  1629,    -1,
      -1,  3000,    -1,   408,    -1,  4149,    -1,  3006,    -1,    -1,
      -1,  1642,    -1,    -1,  1645,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2728,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2746,    -1,    -1,
      -1,  2750,    -1,    -1,    -1,  2754,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2763,    -1,    -1,  3066,   473,    -1,
      -1,    -1,  1703,    -1,    -1,    -1,    -1,    -1,    -1,  2778,
      -1,    -1,    -1,    -1,    -1,    -1,  1717,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2795,    -1,  2797,  2798,
    5785,  5313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     515,    -1,    -1,  2812,    -1,    -1,    -1,    -1,    -1,   524,
     525,   526,   527,   528,   529,   530,   531,   532,    -1,    -1,
      -1,    -1,    -1,  2832,  2833,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,  5848,    -1,    -1,  4310,    -1,    -1,    -1,
      -1,  2870,  2871,    35,    -1,  2874,    -1,  5389,    -1,    -1,
      -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      52,    -1,    -1,    -1,    -1,    -1,  1827,    -1,    -1,  2898,
      -1,  2900,    -1,    -1,    -1,  2904,    -1,  1838,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,  2918,
      -1,    -1,  3221,    -1,  3223,    -1,  2925,    -1,    -1,  2928,
      -1,    -1,    -1,    -1,  1565,  2934,    -1,    -1,    -1,    -1,
      -1,  3240,    -1,    -1,    -1,    -1,    -1,    -1,  3247,  1880,
    1881,    -1,    -1,    -1,    -1,  2954,    -1,    -1,    -1,  1590,
      -1,  2960,  4406,    -1,    -1,    -1,    -1,    -1,  2967,    -1,
      -1,    -1,    -1,    -1,  1905,    -1,    -1,    -1,    -1,    -1,
      -1,  1912,  2981,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4434,    -1,    -1,    -1,    -1,    -1,  2995,    -1,    -1,  5511,
      -1,  3000,    -1,    -1,    -1,    -1,    -1,  3006,    -1,   171,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   197,    -1,    -1,  1669,    -1,
     202,    -1,    -1,    -1,    -1,  3344,    -1,    -1,    -1,    -1,
      -1,  3350,    -1,    -1,  1985,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   225,   226,    -1,    -1,  3066,  1699,  1700,
    1701,  1702,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2018,  2019,    -1,
      -1,   253,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2035,    10,    -1,  2038,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      35,    -1,    -1,  4577,   296,    -1,  3435,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,
     312,    -1,    -1,   315,  5666,    -1,    -1,    -1,    -1,  5671,
    5672,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    13,    -1,    78,    -1,    17,    18,    19,    -1,   341,
    4624,    -1,    -1,    -1,    -1,  4629,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    35,    -1,    -1,    38,    -1,    -1,    -1,
      -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      52,    -1,    -1,    -1,    -1,  1846,  1847,    -1,    -1,    -1,
      -1,    -1,  3221,    -1,  3223,    -1,    -1,    -1,    -1,    -1,
      -1,  1862,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,
      -1,  3240,    -1,    -1,    -1,    -1,   408,    -1,  3247,    -1,
      -1,    -1,    -1,    -1,    -1,  3254,    -1,  3256,  3257,    -1,
      -1,    -1,    -1,    -1,    -1,  1896,  1897,  1898,  1899,  3568,
    3569,    -1,    -1,  5785,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,
    3589,    -1,   197,  3592,    -1,    -1,    -1,   202,    -1,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,
     225,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5848,    -1,    -1,    -1,
      -1,    -1,    78,  4787,    -1,  3344,  1977,    -1,   253,    -1,
      -1,  3350,  1983,   515,    -1,   197,    -1,    -1,    -1,    -1,
     202,    -1,   524,   525,   526,   527,   528,   529,   530,   531,
     532,    -1,    -1,    -1,    -1,  3674,  3675,  3676,    -1,    -1,
      -1,    -1,    -1,   225,   226,  6370,    -1,    -1,    -1,    -1,
      -1,   296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3699,    -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,
     315,   253,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3718,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3435,    -1,   343,    -1,
      -1,  3740,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   296,    -1,    25,    -1,    -1,    -1,
    4904,   197,    31,    -1,    -1,    -1,   202,    -1,    -1,    38,
     312,    -1,    -1,   315,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   225,
     226,    60,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   408,    -1,    -1,    -1,    76,    -1,    -1,
      -1,    -1,    -1,    -1,  4958,    -1,    -1,   253,    -1,    -1,
      -1,    -1,   427,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3830,    -1,    -1,    -1,    -1,  4980,    -1,    -1,    -1,
    2171,    -1,    -1,   112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     296,    -1,    -1,    -1,   133,    -1,   408,    -1,    -1,  3568,
    3569,   140,    -1,    -1,    -1,   144,   312,    -1,  3877,   315,
      -1,    -1,    -1,    -1,  3883,    -1,  3885,    -1,    -1,    -1,
    3589,    -1,    -1,  3592,    -1,    -1,    -1,    -1,    -1,  3898,
      -1,  3900,    -1,    -1,   173,    -1,    -1,    -1,  5052,    -1,
     515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   524,
     525,   526,   527,   528,   529,   530,   531,   532,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   205,    -1,    -1,    -1,
     209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2595,    -1,    -1,    -1,  3967,    -1,
      -1,    -1,   408,   515,  2605,  3674,  3675,  3676,    -1,    -1,
      -1,    -1,   524,   525,   526,   527,   528,   529,   530,   531,
     532,    -1,    -1,    -1,   263,    -1,    -1,    -1,    -1,   268,
    3699,    -1,    -1,    -1,   273,    -1,    -1,    -1,    -1,    -1,
    4009,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3718,
     289,    -1,    -1,    -1,   293,    -1,    -1,    -1,    -1,  4028,
    5174,    -1,    -1,  4032,    -1,   304,    -1,    -1,    -1,    -1,
      -1,  3740,    -1,    -1,    -1,   314,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4053,    -1,   325,   326,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   514,   515,
      -1,    -1,    -1,    -1,  2715,    -1,    -1,    -1,   524,   525,
     526,   527,   528,   529,   530,   531,   532,    -1,    -1,   368,
      -1,    -1,   371,   372,   373,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   397,    -1,
      35,  3830,    -1,    -1,   403,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,   418,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6370,    -1,
      -1,    -1,  4161,    -1,    -1,    -1,    -1,    -1,    -1,  5313,
      -1,    -1,    -1,    78,    -1,    -1,    -1,     0,  3877,    -1,
      -1,    -1,    -1,    -1,  3883,    -1,  3885,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    -1,  3898,
     469,  3900,    -1,    -1,    -1,    -1,    -1,   476,    31,    -1,
      33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2852,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2867,    -1,    61,    -1,
      -1,    -1,    -1,    -1,    -1,  5389,    -1,    -1,    -1,    -1,
      73,    -1,    75,    76,    -1,    -1,    -1,    -1,  2889,    82,
      -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,  3967,    -1,
      -1,    -1,    -1,    -1,    97,    -1,    99,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,   197,   116,    -1,    -1,   119,   202,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,  2639,    38,
    4009,   134,    -1,   136,    -1,    -1,    45,   140,    -1,    -1,
     225,   226,    -1,    52,   147,    -1,    -1,    -1,    -1,  4028,
      -1,    -1,    -1,  4032,   157,    -1,   159,  4336,    -1,    -1,
      -1,    -1,    -1,   166,  2975,  2976,    -1,    -1,   253,    78,
      -1,    -1,    -1,    -1,  4053,    -1,    -1,    -1,    -1,    -1,
      -1,   184,    -1,    -1,    -1,    -1,    -1,  5511,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   296,    -1,    -1,    -1,   840,   841,    -1,    -1,    -1,
      -1,  4400,    -1,    -1,    -1,    -1,  4405,   312,  4407,    -1,
     315,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
      -1,   336,   255,   256,  4433,    -1,    -1,    -1,   261,    -1,
      -1,    -1,    -1,    -1,    35,    -1,  3077,    -1,    -1,    -1,
      -1,    -1,    -1,   276,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    52,  4161,    -1,    -1,    -1,    -1,    -1,   197,    -1,
    2801,    -1,   295,   202,    -1,   920,    -1,    -1,    -1,    -1,
    4479,    -1,    -1,  4482,    -1,    -1,    -1,    78,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   225,   226,    -1,    -1,
      -1,    -1,    -1,   408,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   344,  5666,    -1,   253,    -1,    -1,  5671,  5672,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   359,    -1,    -1,    -1,
      -1,   364,   365,    -1,   367,    -1,    -1,    -1,    -1,   372,
      -1,    -1,    -1,    -1,    -1,   378,    -1,    -1,   381,    -1,
      -1,    -1,    -1,    -1,    -1,   388,    -1,   296,    -1,    -1,
      -1,    -1,   395,   396,  4573,  4574,    -1,    -1,    -1,    -1,
     403,    -1,    -1,   312,   407,  4584,   315,   178,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   418,  1041,  1042,    -1,    -1,
      -1,    -1,  4601,    -1,    -1,    -1,   197,    -1,    -1,    -1,
     515,   202,   435,    -1,    -1,  2946,    -1,    -1,  2949,   524,
     525,   526,   527,   528,   529,   530,   531,   532,    -1,    -1,
      -1,    -1,    -1,   456,   225,   226,    -1,  4336,    -1,    -1,
      -1,  5785,    -1,    -1,    -1,   468,    -1,    -1,    -1,    -1,
      -1,   474,    -1,    -1,    -1,    -1,   479,    -1,    -1,    -1,
      -1,    -1,   253,    -1,    -1,    -1,    -1,    -1,    10,    -1,
     493,    13,    -1,    -1,    -1,    17,    18,    19,    -1,   408,
      -1,    -1,    -1,  4682,    -1,    -1,  4685,    -1,    -1,    -1,
      -1,  1368,    -1,    35,   517,    -1,   519,   520,   521,   522,
     523,  4400,    -1,    45,  5848,   296,  4405,  3038,  4407,    -1,
      52,    -1,    -1,   536,    -1,    -1,   539,    -1,    -1,    -1,
    3051,   312,    -1,    -1,   315,    -1,    -1,    -1,  3059,    -1,
      -1,    -1,    -1,    -1,  4433,    -1,    78,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1423,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3098,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4479,    -1,    -1,  4482,    -1,    -1,   515,    -1,  3119,    -1,
    3421,    -1,    -1,    -1,    -1,   524,   525,   526,   527,   528,
     529,   530,   531,   532,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,   408,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3162,    -1,  3164,    -1,  1280,    35,    -1,    -1,    38,
      -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    52,    -1,   197,    -1,    -1,    -1,    -1,
     202,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4573,  4574,    -1,  1322,    -1,    78,
      -1,    -1,    -1,   225,   226,  4584,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4601,    -1,    -1,    -1,  1351,  1352,  1353,    -1,
    1355,   253,    -1,    -1,    -1,    -1,    -1,    -1,  4917,    -1,
      -1,  3252,    -1,    -1,   515,    -1,    -1,    -1,  3259,    -1,
      -1,  1376,    -1,   524,   525,   526,   527,   528,   529,   530,
     531,   532,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,   296,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     312,    -1,    -1,   315,    35,    -1,  4975,    38,    -1,    -1,
      -1,    -1,    -1,  4682,    45,    -1,  4685,    -1,  4987,    -1,
      -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,   197,    -1,
      -1,    -1,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,
      -1,    -1,  5021,    -1,    -1,    -1,   225,   226,    -1,    -1,
      -1,    -1,    -1,    -1,  1479,    -1,    -1,    10,  1483,  1484,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   253,    -1,    -1,  1734,    -1,    -1,
      -1,  1738,    35,    -1,    -1,    -1,   408,    -1,    -1,    -1,
      -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    52,
      -1,    -1,    -1,    -1,    -1,  3716,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3726,    -1,   296,    -1,    -1,
      -1,  5100,   444,    -1,    -1,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   312,    -1,    -1,   315,    -1,    -1,    -1,
    5119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   197,    -1,    -1,    -1,
      -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   225,   226,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   515,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   524,   525,   526,   527,   528,   529,   530,   531,
     532,    -1,   253,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,  5205,    -1,    -1,   408,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4917,    -1,
      35,    -1,    -1,    -1,   197,    -1,  6370,    -1,    -1,   202,
      45,    -1,    -1,    -1,    -1,   296,    -1,    52,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   312,   225,   226,   315,    -1,    -1,    -1,  3889,  3890,
    3891,    -1,    -1,    78,    -1,    -1,    -1,  3598,  3599,    -1,
      -1,    -1,    -1,    -1,    -1,  3906,  4975,    -1,    -1,    -1,
     253,    -1,    -1,  1728,  1729,  1730,    -1,    -1,  4987,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3939,  3940,
      -1,    -1,    -1,  3944,    -1,    -1,   515,    -1,    -1,    -1,
      -1,    -1,  5021,   296,    -1,   524,   525,   526,   527,   528,
     529,   530,   531,   532,    -1,    -1,    -1,    -1,  5337,   312,
    5339,    -1,   315,    -1,    -1,    -1,    10,   408,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,   332,
      -1,    -1,    -1,   178,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,  2055,    -1,
      -1,    45,   197,    -1,    -1,    -1,    -1,   202,    52,    -1,
      -1,  5390,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5100,    -1,    -1,  2081,    -1,    -1,    -1,  2085,    -1,
     225,   226,    -1,    -1,    78,    -1,    -1,    -1,    -1,  4050,
    5119,    -1,    -1,  2100,  2101,  2102,    -1,  2104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   408,    -1,    -1,   253,    -1,
      -1,  5440,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,   515,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,   524,   525,   526,   527,   528,   529,   530,
     531,   532,    -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,
      -1,   296,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    52,    -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,
     315,    -1,    -1,    -1,    -1,    -1,  5205,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   178,    -1,    -1,    78,    -1,    -1,
      -1,  3852,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   197,    -1,    -1,    -1,    -1,   202,    -1,
      -1,    -1,   515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   524,   525,   526,   527,   528,   529,   530,   531,   532,
      -1,   225,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4216,  4217,  4218,    -1,   253,
      -1,    -1,    -1,   408,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   172,  2057,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,
    2075,    -1,   296,    -1,    -1,  2080,   197,  2082,  5337,  2084,
    5339,   202,  2087,  2088,  2089,    -1,    -1,    -1,   312,    -1,
    2095,   315,    -1,  2098,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   225,   226,    -1,    -1,  2113,  2114,
    2115,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4012,    -1,    -1,    -1,  5684,  2131,    -1,    -1,    -1,
      -1,  5390,   253,    -1,    -1,    -1,    -1,    -1,    -1,  5698,
     515,  5400,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   524,
     525,   526,   527,   528,   529,   530,   531,   532,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5730,    -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,
      -1,  5440,    -1,    -1,   408,    -1,  5445,    -1,    -1,    -1,
      -1,   312,    -1,    -1,   315,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5809,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2279,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5845,   408,    -1,    -1,
      -1,   515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     524,   525,   526,   527,   528,   529,   530,   531,   532,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2333,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,   151,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    52,    -1,  2592,    -1,    -1,    -1,    -1,
      -1,    -1,  5921,  4554,    -1,  5924,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      -1,    -1,    -1,    -1,   197,  2390,    -1,    -1,    -1,   202,
      -1,    -1,    -1,    -1,   515,  4586,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   225,   226,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5684,    -1,  4618,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5698,
     253,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,  2688,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4653,  2700,    -1,    -1,    -1,    -1,  2705,    -1,
      35,  5730,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4670,
      45,    -1,    -1,   296,    -1,    -1,    -1,    52,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   197,   312,
      -1,    -1,   315,   202,    -1,    -1,    -1,    -1,    -1,    -1,
    6069,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   225,   226,    -1,    -1,
      -1,    -1,    -1,    -1,  6093,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5809,    -1,    -1,    -1,   253,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,    -1,
    2585,    -1,    -1,    -1,    -1,    -1,  5845,    -1,    -1,    -1,
      -1,  2596,    -1,  2598,    -1,   408,    -1,   296,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,    -1,    -1,
      -1,    -1,    -1,   312,    -1,    -1,   315,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4815,  4816,  4817,  4818,    -1,    -1,
      -1,  2636,   197,    -1,    -1,  2640,    -1,   202,  2643,  4530,
    2645,    -1,    -1,  2648,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4544,    -1,    -1,    -1,    -1,    -1,    -1,
     225,   226,  5921,    -1,    -1,  5924,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6233,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   253,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2701,  2702,    -1,    -1,
      -1,    -1,   515,    -1,    -1,    -1,    -1,    -1,    -1,   408,
      -1,   524,   525,   526,   527,   528,   529,   530,   531,   532,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   296,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,   312,    -1,    -1,
     315,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    35,    -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    -1,  2781,    -1,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,
    6069,    -1,    -1,    -1,    -1,    -1,   515,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6083,   524,   525,   526,   527,   528,
     529,   530,   531,   532,  6093,    -1,    -1,    -1,  6397,    -1,
      -1,    -1,    -1,   408,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    52,
      -1,    -1,    -1,  6152,  6153,    -1,    -1,    -1,    -1,  6458,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   197,  6483,    -1,    -1,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     515,   225,   226,    -1,    -1,    -1,    -1,    -1,    -1,   524,
     525,   526,   527,   528,   529,   530,   531,   532,    -1,    -1,
      -1,    -1,    -1,    -1,  6233,    -1,  5167,    -1,    -1,   253,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5178,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3024,
    3025,  3026,   296,    -1,    -1,  3030,    -1,    -1,    -1,    -1,
      -1,    -1,  3269,    -1,   197,    -1,    -1,    -1,   312,   202,
      -1,   315,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3286,
      -1,    -1,  3057,    -1,    -1,    -1,    -1,    -1,    -1,  3296,
      -1,    -1,   225,   226,    -1,  3302,    -1,    -1,  3305,    -1,
      -1,    -1,    -1,    -1,    -1,  3312,  3313,    -1,  3315,    -1,
      -1,    -1,    -1,  3320,  3321,    -1,  3323,    -1,  3325,    -1,
     253,    -1,  3329,    -1,    -1,  3332,    -1,    -1,    -1,    -1,
    3337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3346,
      -1,    -1,    -1,    -1,  3351,    -1,    -1,    -1,    -1,    -1,
      -1,  3358,  3359,  3360,  3361,    -1,    -1,    -1,    -1,  3366,
    3367,    -1,  3369,   296,   408,    -1,    -1,    -1,  6397,    -1,
      -1,  5032,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,
      -1,  3388,   315,  3390,    -1,    -1,  5047,    -1,    -1,    -1,
    3397,  3398,  3399,  3400,  3401,  3402,  3403,  3404,  3405,  3406,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6458,
      -1,    -1,    -1,    -1,    -1,    -1,  3443,    -1,    -1,    -1,
      -1,    -1,  6471,  6472,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6483,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   515,    -1,    -1,    -1,   408,    -1,    -1,  5139,    -1,
     524,   525,   526,   527,   528,   529,   530,   531,   532,    -1,
      -1,  3266,    -1,    -1,    -1,    -1,  3271,    -1,    -1,    -1,
      -1,    -1,    -1,  5464,    -1,    -1,    -1,    -1,  5469,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    -1,  5488,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    31,    -1,    33,    34,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3322,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3333,    -1,
    3335,  3336,    -1,    -1,    -1,    -1,    61,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3349,    -1,  3583,  3352,    73,  3354,
      75,    76,   515,    -1,    -1,    -1,    -1,    82,    -1,    84,
      -1,   524,   525,   526,   527,   528,   529,   530,   531,   532,
      -1,    -1,    97,    -1,    99,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    23,    -1,    -1,  3391,    -1,  3393,    -1,
    3395,   116,    -1,    -1,   119,    -1,    -1,    -1,    -1,    -1,
      -1,    41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   134,
      -1,   136,    -1,    -1,    -1,   140,    -1,    -1,    -1,    -1,
      -1,    -1,   147,    -1,    -1,    -1,    66,    -1,    -1,    -1,
      -1,    -1,   157,    -1,   159,    -1,    -1,    -1,    -1,    79,
      -1,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,   184,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5364,   114,  5366,   201,    -1,    -1,    -1,
     120,    -1,    -1,    -1,  3489,    -1,    -1,    -1,    -1,  3494,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,
      -1,    -1,    -1,    -1,  3509,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   152,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   161,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     255,   256,    -1,    -1,   174,    -1,   261,    -1,    -1,    -1,
      -1,    -1,    -1,   183,    -1,    -1,    -1,   187,    -1,    -1,
      -1,   276,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5752,    -1,    -1,    -1,    -1,    -1,   207,    -1,  3574,
     295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5780,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3839,  3840,    -1,    -1,    -1,  3844,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5506,    -1,   257,    -1,   344,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   267,    -1,  3634,
      -1,    -1,    -1,    -1,   359,    -1,  3873,    -1,    -1,   364,
     365,    -1,   367,    -1,    -1,    -1,    -1,   372,    -1,    -1,
     375,    -1,    -1,   378,    -1,    -1,   381,    -1,    -1,    -1,
      -1,    -1,    -1,   388,    -1,    -1,    -1,    -1,    -1,    -1,
     395,   396,   312,    -1,    -1,   315,    -1,    -1,   403,    -1,
      -1,    -1,   407,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   418,    -1,    -1,    -1,    -1,    -1,   339,
    5891,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     435,    -1,    -1,   353,    -1,    -1,    -1,    -1,    -1,    -1,
     360,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   456,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     380,    -1,    -1,   468,    -1,    -1,    -1,    -1,    -1,   474,
     390,    -1,    -1,    -1,   479,    -1,    -1,   397,    -1,    -1,
     400,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     420,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   428,    -1,
      -1,    -1,   517,    -1,    -1,   435,    -1,  5688,   438,  5690,
     440,    -1,   442,   443,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   536,    -1,    -1,   539,    -1,    -1,    -1,   458,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   466,    -1,    -1,   469,
    3835,  4068,   472,    -1,    -1,    -1,  3841,  4074,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   485,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4121,  4122,    -1,    -1,  4125,  4126,
    4127,  4128,    -1,    -1,  4131,  4132,  4133,  4134,  4135,  4136,
    4137,  4138,  4139,  4140,  4141,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    -1,    -1,    -1,  3920,    28,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4164,    -1,    -1,
    4167,    -1,  4169,    -1,    -1,  4172,  4173,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    66,    -1,    -1,  4194,  4195,  4196,
    4197,    -1,  4199,    -1,    -1,    -1,    -1,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,    -1,    -1,
      -1,    -1,  4269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     152,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   161,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,
      -1,    -1,   174,    -1,  4069,    -1,    -1,    -1,   180,    -1,
      -1,  5962,    -1,  4078,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4319,    -1,    -1,    -1,    -1,  4092,    -1,    -1,
      -1,  4096,  4097,  4098,    -1,   207,    -1,    -1,  4103,    -1,
      -1,  4106,    -1,    -1,  4109,    -1,    -1,    -1,    79,    -1,
    4115,    -1,  4117,    -1,    -1,    -1,    -1,  4354,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4144,
    4145,  4146,    -1,   114,    -1,    -1,    -1,    -1,    -1,   120,
      -1,    -1,    -1,    -1,    -1,   267,    -1,    -1,  4163,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4171,   138,    -1,  4174,
      -1,  4176,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   152,    -1,    -1,    -1,    -1,    -1,  4192,    -1,    -1,
     161,    -1,    -1,    -1,    -1,  4200,  4201,    -1,    -1,    -1,
     312,    -1,  4207,   174,  6095,    -1,    -1,    -1,    -1,   180,
      -1,    -1,    -1,    -1,    -1,    -1,   187,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4236,    -1,    -1,    -1,    -1,   207,   349,   350,    -1,
      -1,   353,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   380,    -1,
      -1,   383,    -1,    -1,   245,    -1,    -1,    -1,   390,    -1,
      -1,    -1,  4287,    -1,    -1,   397,    -1,    -1,   400,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   267,    -1,    -1,  4304,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   420,  4546,
      -1,    -1,    -1,    -1,    -1,    -1,   428,    -1,    -1,    -1,
      -1,    -1,    -1,   435,    -1,    -1,   438,    -1,    -1,    -1,
      -1,   443,    -1,    -1,    -1,    -1,  6227,    -1,    -1,   451,
      -1,   312,    -1,    -1,    -1,    -1,   458,    -1,    -1,    -1,
      -1,    -1,    -1,  4590,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,  6260,
    6261,    -1,    -1,   485,    -1,    -1,    -1,    -1,   349,   350,
      -1,    -1,   353,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   380,
      -1,    -1,   383,    -1,    -1,    -1,   387,    -1,    -1,   390,
      -1,    -1,    -1,    -1,    -1,    -1,   397,    -1,    -1,   400,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   420,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   428,    -1,    -1,
      -1,    -1,   433,    -1,   435,    -1,    -1,   438,    -1,    -1,
      -1,    -1,   443,    -1,    -1,  4712,    -1,    -1,    -1,  4716,
      -1,    -1,   453,    -1,    -1,    -1,    -1,   458,    -1,    -1,
      -1,    -1,  4729,    -1,    -1,    -1,  6387,    -1,    -1,    -1,
    4737,   472,  4739,    -1,  4741,  4742,    -1,    -1,    -1,    -1,
    4747,  4748,  4749,  4750,   485,    -1,    -1,  4754,  4755,  4756,
    4757,  4758,  4759,  4760,  4761,  4762,  4763,  4764,  4765,  4766,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4790,    -1,    -1,  4793,    -1,  4795,    -1,
      -1,    -1,  4799,    -1,    -1,  4802,  4803,    -1,    -1,  4806,
    4807,    -1,    -1,    -1,    -1,  4812,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4630,  4631,    -1,    -1,  4866,
      -1,    -1,    -1,    -1,    -1,    -1,  4641,    -1,    -1,    -1,
      -1,    -1,    -1,  4880,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4711,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4727,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4745,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4784,
    4785,    -1,    -1,    -1,    -1,    -1,  4791,  4792,    -1,    -1,
      -1,  4796,    -1,    -1,    -1,    -1,  4801,    -1,    -1,  4804,
    4805,    -1,    -1,    -1,    -1,    -1,  4811,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5081,    -1,    -1,    -1,    -1,    -1,
      -1,  4856,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4875,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4922,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5169,  5170,    -1,    -1,    -1,    -1,    -1,    -1,
    5177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5220,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5003,    -1,
      -1,    -1,    -1,    -1,    -1,  5010,  5243,  5244,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5262,    -1,  5264,    -1,    -1,
      -1,  5268,  5269,  5270,  5271,    -1,    -1,  5274,  5275,    -1,
      -1,    -1,    -1,  5280,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5297,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5078,    -1,    -1,    -1,    -1,  5315,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5330,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5360,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5411,    -1,  5413,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5448,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5231,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5241,    -1,    -1,    -1,
      -1,    -1,  5247,  5248,  5249,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5272,  5273,    -1,
      -1,  5276,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5293,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5303,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5314,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5322,    -1,  5556,
      -1,  5558,  5559,  5560,  5561,  5562,  5331,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5575,  5576,
    5577,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5585,    -1,
      -1,    -1,    -1,  5590,    -1,    -1,  5593,    -1,    -1,    -1,
    5597,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5615,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5634,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5542,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5563,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5810,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5821,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5608,    -1,  5842,    -1,  5844,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5660,    -1,    -1,  5895,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5907,  5676,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5943,    -1,    -1,    -1,
      -1,    -1,    -1,  5718,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6023,    -1,    -1,    -1,
      -1,    -1,    -1,  6030,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5808,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5820,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5829,  5830,  5831,    -1,    -1,  6066,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6081,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5857,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5876,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5896,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6189,  6190,    -1,    -1,  6193,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6257,    -1,  6027,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6282,    -1,  6052,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6300,  6301,    -1,  6303,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6134,
      -1,    -1,    -1,    -1,    -1,  6372,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6158,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,     5,     6,    -1,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,  6290,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,  6306,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,  6437,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,    -1,   222,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
      -1,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,    -1,    -1,   312,   313,
     314,    -1,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
      -1,   515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   527,   528,   529,    -1,    -1,    -1,    -1,
      -1,    -1,   536,   537,     3,    -1,     5,     6,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,    -1,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,   466,   467,   468,
     469,   470,   471,   472,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,   483,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,    -1,   515,    -1,   517,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   527,   528,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   536,   537,     3,
      -1,     5,     6,    -1,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,    -1,   222,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
      -1,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,    -1,    -1,   312,   313,
     314,    -1,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,   483,
     484,   485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
      -1,   515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   527,   528,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   536,   537,     3,    -1,     5,     6,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,    -1,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,   434,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,   466,   467,   468,
     469,   470,   471,   472,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,   483,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,    -1,   515,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   527,   528,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   536,   537,     3,
      -1,     5,     6,    -1,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,    -1,   222,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
      -1,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,    -1,    -1,   312,   313,
     314,    -1,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,   483,
     484,   485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
      -1,   515,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,   527,   528,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   536,   537,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,    -1,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,    -1,    -1,   179,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,   222,    -1,   224,    -1,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,    -1,    -1,   255,
     256,   257,    -1,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
      -1,   307,   308,   309,    -1,    -1,   312,   313,   314,    -1,
      -1,   317,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,    -1,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,    -1,    -1,
     436,    -1,   438,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,    -1,    -1,   450,   451,   452,   453,   454,    -1,
     456,   457,   458,   459,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,    -1,    -1,   474,   475,
     476,   477,   478,   479,   480,    -1,   482,    -1,   484,   485,
     486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   537,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    -1,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
      -1,   159,   160,   161,   162,    -1,    -1,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,    -1,   185,    -1,    -1,
      -1,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,    -1,   222,    -1,   224,   225,   226,   227,
     228,   229,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,    -1,
      -1,   249,    -1,   251,   252,   253,    -1,   255,   256,   257,
      -1,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,    -1,   292,    -1,   294,   295,   296,   297,
      -1,    -1,   300,   301,   302,   303,   304,   305,    -1,   307,
     308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,    -1,   341,    -1,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
      -1,    -1,   450,   451,    -1,   453,    -1,    -1,   456,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,    -1,    -1,   474,   475,   476,   477,
     478,    -1,   480,   481,   482,   483,   484,   485,   486,   487,
     488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,
     498,   499,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   511,   512,   513,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,   537,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    -1,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,   161,   162,    -1,    -1,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,    -1,   185,    -1,    -1,    -1,   189,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,    -1,   222,    -1,   224,   225,   226,   227,   228,   229,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,    -1,    -1,   249,
      -1,   251,   252,   253,    -1,   255,   256,   257,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,    -1,   292,    -1,   294,   295,   296,   297,    -1,    -1,
     300,   301,   302,   303,   304,   305,    -1,   307,   308,   309,
      -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
      -1,   341,    -1,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,    -1,    -1,
     450,   451,    -1,   453,    -1,    -1,   456,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,    -1,    -1,   474,   475,   476,   477,   478,    -1,
     480,   481,   482,   483,   484,   485,   486,   487,   488,    -1,
      -1,   491,    -1,    -1,   494,   495,   496,   497,   498,   499,
      -1,     3,    -1,     5,     6,    -1,     8,     9,    10,    11,
      12,   511,   512,   513,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,   537,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,   176,   177,    -1,   179,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,    -1,
     222,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,    -1,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,    -1,   307,   308,   309,    -1,    -1,
     312,   313,   314,    -1,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,   483,   484,   485,   486,   487,   488,    -1,    -1,   491,
      -1,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,    -1,   515,    -1,   517,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   527,   528,    -1,    -1,    -1,
       3,    -1,     5,     6,   536,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,    -1,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,    -1,   185,   186,    -1,   188,   189,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,   219,   220,    -1,   222,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,    -1,   249,   250,   251,   252,
     253,    -1,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,    -1,   307,   308,   309,    -1,    -1,   312,
     313,   314,    -1,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
      -1,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,   466,   467,   468,   469,   470,   471,   472,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
     483,   484,   485,   486,   487,   488,    -1,    -1,   491,    -1,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,    -1,   515,    -1,   517,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   527,   528,    -1,    -1,    -1,     3,
      -1,     5,     6,   536,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,    -1,   222,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,    -1,    -1,   312,   313,
     314,    -1,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,   483,
     484,   485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
      -1,   515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   527,   528,    -1,    -1,    -1,     3,    -1,
       5,     6,   536,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    36,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,    -1,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,    -1,
     185,   186,    -1,   188,   189,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,   222,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,    -1,   249,   250,   251,   252,   253,    -1,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,    -1,   307,   308,   309,    -1,    -1,   312,   313,   314,
      -1,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,   466,   467,   468,   469,   470,   471,   472,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,   483,   484,
     485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,    -1,
     515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   527,   528,    -1,    -1,    -1,     3,    -1,     5,
       6,   536,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      36,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,   222,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,    -1,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
      -1,   307,   308,   309,    -1,    -1,   312,   313,   314,    -1,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,    -1,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,    -1,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,    -1,   482,   483,   484,   485,
     486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,    -1,   515,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   527,   528,    -1,    -1,    -1,     3,    -1,     5,     6,
     536,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,    -1,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,    -1,   185,   186,
      -1,   188,   189,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,   219,   220,    -1,   222,    -1,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,    -1,   249,   250,   251,   252,   253,    -1,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,    -1,
     307,   308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,   434,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,   466,
     467,   468,   469,   470,   471,   472,    -1,   474,   475,   476,
     477,   478,   479,   480,    -1,   482,   483,   484,   485,   486,
     487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,    -1,   515,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     527,   528,    -1,    -1,    -1,    -1,    -1,   534,   535,   536,
       3,    -1,     5,     6,    -1,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,    -1,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,    -1,   185,   186,    -1,   188,   189,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,   219,   220,    -1,   222,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,    -1,   249,   250,   251,   252,
     253,    -1,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,    -1,   307,   308,   309,    -1,    -1,   312,
     313,   314,    -1,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
      -1,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,   434,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,   466,   467,   468,   469,   470,   471,   472,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
     483,   484,   485,   486,   487,   488,    -1,    -1,   491,    -1,
      -1,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,    -1,   515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   527,   528,   529,    -1,    -1,     3,
      -1,     5,     6,   536,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,    -1,   222,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
      -1,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,    -1,    -1,   312,   313,
     314,    -1,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,   483,
     484,   485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
      -1,   515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   527,   528,    -1,    -1,    -1,     3,    -1,
       5,     6,   536,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,    -1,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,    -1,
     185,   186,    -1,   188,   189,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,   222,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,    -1,   249,   250,   251,   252,   253,    -1,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,    -1,   307,   308,   309,    -1,    -1,   312,   313,   314,
      -1,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,    -1,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,   466,   467,   468,   469,   470,   471,   472,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,   483,   484,
     485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,    -1,
     515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   527,   528,    -1,    -1,    -1,     3,    -1,     5,
       6,   536,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,   222,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,    -1,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
      -1,   307,   308,   309,    -1,    -1,   312,   313,   314,    -1,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,    -1,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,    -1,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,    -1,   515,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   527,   528,    -1,    -1,    -1,     3,    -1,     5,     6,
     536,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,    -1,   175,   176,
     177,   178,   179,   180,   181,   182,   183,    -1,   185,   186,
      -1,   188,   189,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,   219,   220,    -1,   222,    -1,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,    -1,   249,   250,   251,   252,   253,    -1,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,    -1,
     307,   308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,   434,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,   466,
     467,   468,   469,   470,   471,   472,    -1,   474,   475,   476,
     477,   478,   479,   480,    -1,   482,   483,   484,   485,   486,
     487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,    -1,   515,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     527,   528,    -1,    -1,    -1,     3,    -1,     5,     6,   536,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,    -1,   222,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,    -1,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,    -1,   307,
     308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,   434,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,    -1,   482,   483,   484,   485,   486,   487,
     488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,    -1,   515,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   527,
     528,    -1,    -1,    -1,     3,    -1,     5,     6,   536,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,    -1,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,   434,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,   466,   467,   468,
     469,   470,   471,   472,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,   483,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,    -1,   515,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   527,   528,
      -1,    -1,    -1,     3,    -1,     5,     6,   536,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,    -1,   222,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,    -1,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,    -1,   307,   308,   309,
      -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,   434,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,    -1,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,    -1,   482,   483,   484,   485,   486,   487,   488,    -1,
      -1,   491,    -1,    -1,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,    -1,   515,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   527,   528,    -1,
      -1,    -1,     3,    -1,     5,     6,   536,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,    -1,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,   222,    -1,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,    -1,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,    -1,   307,   308,   309,    -1,
      -1,   312,   313,   314,    -1,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,    -1,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,   466,   467,   468,   469,   470,
     471,   472,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,   488,    -1,    -1,
     491,    -1,    -1,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,    -1,   515,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   527,   528,    -1,    -1,
      -1,     3,    -1,     5,     6,   536,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,   176,   177,    -1,   179,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,    -1,
     222,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,    -1,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,    -1,   307,   308,   309,    -1,    -1,
     312,   313,   314,    -1,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,   434,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,   483,   484,   485,   486,   487,   488,    -1,    -1,   491,
      -1,    -1,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,    -1,   515,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   527,   528,    -1,    -1,    -1,
       3,    -1,     5,     6,   536,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,    -1,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,    -1,   185,   186,    -1,   188,   189,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,   219,   220,    -1,   222,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,    -1,   249,   250,   251,   252,
     253,    -1,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,    -1,   307,   308,   309,    -1,    -1,   312,
     313,   314,    -1,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
      -1,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,   434,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,   466,   467,   468,   469,   470,   471,   472,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
     483,   484,   485,   486,   487,   488,    -1,    -1,   491,    -1,
      -1,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,    -1,   515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   527,   528,    -1,    -1,    -1,     3,
      -1,     5,     6,   536,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,    -1,   222,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
      -1,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,    -1,    -1,   312,   313,
     314,    -1,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,   483,
     484,   485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
      -1,   515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   527,   528,    -1,    -1,    -1,     3,    -1,
       5,     6,   536,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,    -1,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,    -1,
     185,   186,    -1,   188,   189,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,   222,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,    -1,   249,   250,   251,   252,   253,    -1,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,    -1,   307,   308,   309,    -1,    -1,   312,   313,   314,
      -1,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,    -1,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,   466,   467,   468,   469,   470,   471,   472,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,   483,   484,
     485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,    -1,
     515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   527,   528,    -1,    -1,    -1,     3,    -1,     5,
       6,   536,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,   222,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,    -1,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
      -1,   307,   308,   309,    -1,    -1,   312,   313,   314,    -1,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,    -1,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,    -1,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,    -1,   482,   483,   484,   485,
     486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,    -1,   515,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   527,   528,    -1,    -1,    -1,     3,    -1,     5,     6,
     536,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,    -1,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,    -1,   185,   186,
      -1,   188,   189,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,   219,   220,    -1,   222,    -1,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,    -1,   249,   250,   251,   252,   253,    -1,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,    -1,
     307,   308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,   434,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,   466,
     467,   468,   469,   470,   471,   472,    -1,   474,   475,   476,
     477,   478,   479,   480,    -1,   482,   483,   484,   485,   486,
     487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,    -1,   515,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     527,   528,    -1,    -1,    -1,     3,    -1,     5,     6,   536,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,    -1,   222,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,    -1,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,    -1,   307,
     308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,   434,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
      -1,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,    -1,   482,   483,   484,   485,   486,   487,
     488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   527,
     528,    -1,    -1,    -1,     3,    -1,     5,     6,   536,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,    -1,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,   434,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,   466,   467,   468,
     469,   470,   471,   472,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,   483,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,    -1,   515,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   527,   528,
      -1,    -1,    -1,     3,    -1,     5,     6,   536,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,    -1,   222,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,    -1,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,    -1,   307,   308,   309,
      -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,   434,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,    -1,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,    -1,   482,   483,   484,   485,   486,   487,   488,    -1,
      -1,   491,    -1,    -1,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   527,   528,     3,
      -1,     5,     6,    -1,     8,     9,   536,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,    -1,   222,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
      -1,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,    -1,    -1,   312,   313,
     314,    -1,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,   483,
     484,   485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   527,   528,     3,    -1,     5,     6,    -1,
       8,     9,   536,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,    -1,   222,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,    -1,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,    -1,   307,
     308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,   434,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
      -1,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,    -1,   482,   483,   484,   485,   486,   487,
     488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,     5,     6,    -1,     8,     9,    -1,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,   536,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,    -1,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,   222,    -1,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,    -1,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,    -1,   307,   308,   309,    -1,
      -1,   312,   313,   314,    -1,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,    -1,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,   472,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,   488,    -1,    -1,
     491,    -1,    -1,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,     5,     6,    -1,     8,     9,    -1,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,   536,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,    -1,   222,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
      -1,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,    -1,    -1,   312,   313,
     314,    -1,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,   483,
     484,   485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   536,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,    -1,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,    -1,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,    -1,   185,   186,
      -1,   188,   189,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,   219,   220,    -1,   222,    -1,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,    -1,   249,   250,   251,   252,   253,    -1,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,    -1,   299,   300,   301,   302,   303,   304,   305,    -1,
     307,   308,   309,    -1,   311,   312,   313,   314,    -1,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,   472,    -1,   474,   475,   476,
     477,   478,   479,   480,    -1,   482,   483,   484,   485,   486,
     487,   488,    -1,    -1,   491,    -1,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,    -1,    -1,    -1,
     517,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   536,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,    -1,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,    -1,   222,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,    -1,   249,
     250,   251,   252,   253,    -1,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,    -1,   307,   308,   309,
      -1,   311,   312,   313,   314,    -1,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,   434,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,    -1,    -1,
     450,   451,   452,   453,   454,    -1,   456,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,    -1,   482,   483,   484,   485,   486,   487,   488,    -1,
      -1,   491,    -1,    -1,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   536,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,    -1,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,    -1,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,    -1,   185,   186,    -1,   188,   189,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,   219,   220,    -1,   222,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,    -1,   249,   250,   251,   252,
     253,    -1,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,    -1,   307,   308,   309,    -1,    -1,   312,
     313,   314,    -1,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
      -1,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,   434,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,   472,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
     483,   484,   485,   486,   487,   488,    -1,    -1,   491,    -1,
      -1,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   536,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,    -1,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,   222,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,    -1,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
      -1,   307,   308,   309,    -1,    -1,   312,   313,   314,    -1,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,    -1,    -1,   450,   451,   452,   453,   454,    -1,
     456,   457,   458,   459,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,    -1,   482,   483,   484,   485,
     486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     536,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,    -1,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,    -1,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,   434,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,   472,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,   483,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   536,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,    -1,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,   176,   177,    -1,   179,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,    -1,
     222,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,    -1,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,    -1,   307,   308,   309,    -1,    -1,
     312,   313,   314,    -1,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,   434,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,   483,   484,   485,   486,   487,   488,    -1,    -1,   491,
      -1,    -1,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,
       5,     6,    -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   536,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,    -1,
      -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,    -1,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,    -1,
     185,   186,    -1,   188,   189,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,   222,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,    -1,   249,   250,   251,   252,   253,    -1,
     255,   256,   257,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,    -1,   299,   300,   301,   302,   303,   304,
     305,    -1,   307,   308,   309,   310,    -1,   312,   313,   314,
      -1,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,    -1,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,    -1,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,   483,   484,
     485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,   527,   528,   529,    -1,    -1,    -1,    -1,    -1,
      -1,   536,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    33,    34,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,    -1,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,    -1,   222,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,    -1,   255,   256,   257,
      -1,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,    -1,   307,
     308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
      -1,    -1,   450,   451,   452,   453,   454,    -1,   456,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,    -1,    -1,   474,   475,   476,   477,
     478,   479,   480,    -1,   482,   483,   484,   485,   486,   487,
     488,    -1,    -1,   491,    -1,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   536,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,    -1,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,    -1,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,   222,    -1,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,    -1,   255,   256,   257,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,    -1,   299,   300,
     301,   302,   303,   304,   305,    -1,   307,   308,   309,    -1,
      -1,   312,   313,   314,    -1,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,    -1,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,   488,    -1,    -1,
     491,    -1,    -1,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   536,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
      -1,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,    -1,   222,    -1,
     224,    -1,    -1,   227,    -1,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,    -1,   249,   250,    -1,   252,    -1,
      -1,   255,   256,   257,    -1,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,    -1,    -1,   312,   313,
     314,    -1,    -1,   317,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
      -1,   435,   436,    -1,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,   452,   453,
     454,    -1,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,    -1,
     484,   485,   486,   487,   488,    -1,    -1,   491,    -1,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
      -1,    -1,    -1,   517,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   536,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
     107,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,    -1,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,    -1,   175,   176,
      -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,   186,
      -1,   188,   189,   190,    -1,   192,   193,   194,   195,   196,
      -1,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,    -1,   222,    -1,   224,    -1,    -1,
     227,    -1,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,    -1,   249,   250,    -1,   252,    -1,    -1,   255,   256,
     257,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,    -1,
     297,    -1,   299,   300,   301,   302,   303,   304,   305,    -1,
     307,   308,   309,    -1,   311,   312,   313,   314,    -1,    -1,
     317,   318,   319,    -1,   321,    -1,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,    -1,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,    -1,   435,   436,
      -1,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,    -1,   482,    -1,   484,   485,   486,
     487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   536,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,    -1,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,    -1,   249,
     250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,    -1,   307,   308,   309,
      -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,    -1,   403,   404,   405,   406,   407,    -1,   409,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,    -1,    -1,
     450,   451,   452,   453,   454,    -1,   456,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,    -1,   482,    -1,   484,   485,   486,   487,   488,    -1,
      -1,   491,    -1,    -1,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   536,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,    -1,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,    -1,   175,   176,    -1,    -1,    -1,   180,   181,   182,
     183,    -1,   185,   186,    -1,   188,   189,   190,    -1,   192,
     193,   194,   195,   196,    -1,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,    -1,   222,
      -1,   224,    -1,    -1,   227,    -1,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,    -1,   249,   250,    -1,   252,
      -1,    -1,   255,   256,   257,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,    -1,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,    -1,   307,   308,   309,    -1,    -1,   312,
     313,   314,    -1,    -1,   317,   318,   319,    -1,   321,    -1,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,    -1,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
      -1,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,    -1,    -1,   436,    -1,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,    -1,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,    -1,    -1,   491,    -1,
      -1,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   536,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,    -1,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,    -1,   222,    -1,   224,    -1,
      -1,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,    -1,   249,   250,    -1,   252,    -1,    -1,   255,
     256,   257,    -1,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
      -1,   307,   308,   309,    -1,    -1,   312,   313,   314,    -1,
      -1,   317,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,    -1,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,    -1,    -1,
     436,    -1,   438,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,    -1,    -1,   450,   451,   452,   453,   454,    -1,
     456,   457,   458,   459,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,    -1,    -1,   474,   475,
     476,   477,   478,   479,   480,    -1,   482,    -1,   484,   485,
     486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     536,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,    -1,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,
      -1,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,    -1,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,    -1,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,    -1,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,    -1,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,   536,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    -1,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      -1,    -1,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,    -1,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    -1,    -1,   168,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,    -1,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,    -1,   273,   274,    -1,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,    -1,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,    -1,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,    -1,   483,   484,   485,   486,   487,   488,
     489,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,    -1,   512,   513,    -1,   515,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     3,    -1,     5,     6,    -1,    -1,
      -1,    10,    11,    -1,    -1,    -1,    -1,    -1,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,    -1,
     159,   160,   161,   162,    -1,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,    -1,   187,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,    -1,   292,   293,   294,   295,   296,   297,   298,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,    -1,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,    -1,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,    -1,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
      -1,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   511,   512,   513,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     3,    -1,     5,     6,    -1,    -1,
      -1,    10,    11,    -1,    -1,    -1,    -1,    -1,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,    -1,
     159,   160,   161,   162,    -1,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,    -1,   187,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,    -1,   292,   293,   294,   295,   296,   297,   298,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,    -1,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,    -1,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,    -1,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
      -1,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   511,   512,   513,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,    -1,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,
      -1,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,    -1,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,    -1,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,    -1,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,    -1,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,    -1,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,
      -1,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,    -1,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,    -1,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,    -1,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,    -1,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,    -1,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,
      -1,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,    -1,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,    -1,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,    -1,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,    -1,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,    -1,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,
      -1,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,    -1,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,    -1,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,    -1,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,    -1,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,    -1,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,
      -1,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,    -1,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,    -1,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,    -1,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,    -1,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,    -1,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,
      -1,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,    -1,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,    -1,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,    -1,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,    -1,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   524,   525,   526,   527,   528,
     529,   530,   531,   532,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,    -1,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,
      -1,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,    -1,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,    -1,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,    -1,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,    -1,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   524,   525,   526,   527,   528,
     529,   530,   531,   532,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   529,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,    -1,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,    -1,
     175,   176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,
     185,   186,    -1,   188,   189,   190,    -1,   192,   193,   194,
     195,   196,    -1,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,    -1,   222,    -1,   224,
      -1,    -1,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,    -1,   249,   250,    -1,   252,    -1,    -1,
     255,   256,   257,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,    -1,   297,    -1,   299,   300,   301,   302,   303,   304,
     305,    -1,   307,   308,   309,    -1,    -1,   312,   313,   314,
      -1,    -1,   317,   318,   319,    -1,   321,    -1,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,    -1,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,    -1,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,    -1,
      -1,   436,    -1,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,    -1,   484,
     485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   529,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
      -1,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,    -1,   222,    -1,
     224,    -1,    -1,   227,    -1,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,    -1,   249,   250,    -1,   252,    -1,
      -1,   255,   256,   257,    -1,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,    -1,    -1,   312,   313,
     314,    -1,    -1,   317,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,    -1,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
      -1,    -1,   436,    -1,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,   452,   453,
     454,    -1,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,    -1,
     484,   485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   529,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,    -1,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,    -1,   175,   176,    -1,    -1,    -1,   180,   181,   182,
     183,    -1,   185,   186,    -1,   188,   189,   190,    -1,   192,
     193,   194,   195,   196,    -1,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,    -1,   222,
      -1,   224,    -1,    -1,   227,    -1,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,    -1,   249,   250,    -1,   252,
      -1,    -1,   255,   256,   257,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,    -1,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,    -1,   307,   308,   309,    -1,    -1,   312,
     313,   314,    -1,    -1,   317,   318,   319,    -1,   321,    -1,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,    -1,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
      -1,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,    -1,    -1,   436,    -1,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,    -1,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,    -1,    -1,   491,    -1,
      -1,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   529,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,    -1,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,    -1,
     222,    -1,   224,    -1,    -1,   227,    -1,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,    -1,   249,   250,    -1,
     252,    -1,    -1,   255,   256,   257,    -1,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,    -1,   307,   308,   309,    -1,    -1,
     312,   313,   314,    -1,    -1,   317,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
      -1,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,    -1,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,    -1,    -1,   436,    -1,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,    -1,   484,   485,   486,   487,   488,    -1,    -1,   491,
      -1,    -1,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   529,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,   157,    -1,   159,   160,
     161,   162,    -1,    -1,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,    -1,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,    -1,    -1,    -1,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,   222,    -1,   224,   225,   226,   227,   228,   229,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,    -1,    -1,   249,    -1,
     251,   252,   253,    -1,   255,   256,   257,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
      -1,   292,    -1,   294,   295,   296,   297,    -1,    -1,   300,
     301,   302,   303,   304,   305,    -1,   307,   308,   309,    -1,
      -1,   312,   313,   314,    -1,   316,   317,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,   339,    -1,
     341,    -1,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,    -1,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,    -1,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,    -1,   480,
     481,   482,   483,   484,   485,   486,   487,   488,    -1,    -1,
     491,    -1,    -1,   494,   495,   496,   497,   498,   499,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     511,   512,   513,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,   529,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,   157,    -1,   159,   160,
     161,   162,    -1,    -1,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,    -1,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,    -1,    -1,    -1,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,   222,    -1,   224,   225,   226,   227,   228,   229,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,    -1,    -1,   249,    -1,
     251,   252,   253,    -1,   255,   256,   257,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
      -1,   292,    -1,   294,   295,   296,   297,    -1,    -1,   300,
     301,   302,   303,   304,   305,    -1,   307,   308,   309,    -1,
      -1,   312,   313,   314,    -1,   316,   317,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,   339,    -1,
     341,    -1,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,    -1,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,    -1,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,    -1,   480,
     481,   482,   483,   484,   485,   486,   487,   488,    -1,    -1,
     491,    -1,    -1,   494,   495,   496,   497,   498,   499,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     511,   512,   513,     3,    -1,     5,     6,    -1,    -1,    -1,
      -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,   529,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,    -1,   222,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,    -1,   255,   256,   257,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,    -1,   307,   308,   309,
     310,    -1,   312,   313,   314,    -1,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,    -1,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,    -1,   482,   483,   484,   485,   486,   487,   488,    -1,
      -1,   491,    -1,    -1,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,     3,    -1,     5,     6,    -1,    -1,
      -1,    -1,    11,    -1,    -1,    -1,    -1,   527,   528,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,    -1,   255,   256,   257,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,   310,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,   483,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,     3,    -1,     5,     6,    -1,
      -1,    -1,    -1,    11,    -1,    -1,    -1,    -1,   527,   528,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,    -1,   222,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,    -1,   255,   256,   257,
      -1,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,    -1,   307,
     308,   309,   310,    -1,   312,   313,   314,    -1,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
      -1,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,    -1,    -1,   474,   475,   476,   477,
     478,   479,   480,    -1,   482,   483,   484,   485,   486,   487,
     488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,     3,    -1,     5,     6,
      -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,    -1,   527,
     528,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,
     107,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,    -1,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,    -1,   185,   186,
      -1,   188,   189,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,   219,   220,    -1,   222,    -1,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,    -1,   249,   250,   251,   252,   253,    -1,   255,   256,
     257,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,    -1,   299,   300,   301,   302,   303,   304,   305,    -1,
     307,   308,   309,   310,    -1,   312,   313,   314,    -1,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,    -1,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,    -1,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,    -1,   482,   483,   484,   485,   486,
     487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,    -1,
     527,   528,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,    -1,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,    -1,   222,    -1,   224,    -1,
      -1,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,    -1,   249,   250,    -1,   252,    -1,    -1,   255,
     256,   257,    -1,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
      -1,   307,   308,   309,    -1,    -1,   312,   313,   314,    -1,
      -1,   317,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,    -1,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,    -1,    -1,
     436,    -1,   438,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,    -1,    -1,   450,   451,   452,   453,   454,    -1,
     456,   457,   458,   459,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,    -1,    -1,   474,   475,
     476,   477,   478,   479,   480,    -1,   482,    -1,   484,   485,
     486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   527,   528,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    33,    34,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,    -1,
      -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,    -1,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,    -1,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,    -1,
     185,   186,    -1,   188,   189,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,   222,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,    -1,   249,   250,   251,   252,   253,    -1,
     255,   256,   257,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,    -1,   299,   300,   301,   302,   303,   304,
     305,    -1,   307,   308,   309,    -1,    -1,   312,   313,   314,
      -1,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,    -1,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,    -1,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,   483,   484,
     485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       3,    -1,     5,     6,    -1,    -1,    -1,    -1,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,    -1,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,    -1,   222,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,    -1,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,    -1,   307,   308,   309,
      -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,   434,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,    -1,    -1,
     450,   451,   452,   453,   454,    -1,   456,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,    -1,   482,   483,   484,   485,   486,   487,   488,    -1,
      -1,   491,    -1,    -1,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,     3,    -1,     5,     6,    -1,     8,
       9,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,    -1,   255,   256,   257,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,   483,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,    -1,    -1,   106,   107,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,    -1,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,    -1,   222,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,    -1,   255,   256,   257,
      -1,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,    -1,   307,
     308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
      -1,    -1,   450,   451,   452,   453,   454,    -1,   456,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,    -1,    -1,   474,   475,   476,   477,
     478,   479,   480,    -1,   482,   483,   484,   485,   486,   487,
     488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,    -1,    -1,   106,
     107,    -1,    -1,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,    -1,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,    -1,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,    -1,   185,   186,
      -1,   188,   189,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,   219,   220,    -1,   222,    -1,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,    -1,   249,   250,   251,   252,   253,    -1,   255,   256,
     257,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,    -1,   299,   300,   301,   302,   303,   304,   305,    -1,
     307,   308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,    -1,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,    -1,   482,   483,   484,   485,   486,
     487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
     106,   107,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,    -1,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,   222,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,    -1,   255,
     256,   257,    -1,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
      -1,   307,   308,   309,    -1,    -1,   312,   313,   314,    -1,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,    -1,    -1,   450,   451,   452,   453,   454,    -1,
     456,   457,   458,   459,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,    -1,   482,   483,   484,   485,
     486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,    -1,
      -1,   106,   107,    -1,    -1,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,    -1,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,    -1,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,    -1,
     185,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,   222,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,    -1,   249,   250,   251,   252,   253,    -1,
     255,   256,   257,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,    -1,   299,   300,   301,   302,   303,   304,
     305,    -1,   307,   308,   309,    -1,    -1,   312,   313,   314,
      -1,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,    -1,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,    -1,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,   483,   484,
     485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,     3,
      -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
      -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,    -1,   222,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
      -1,   255,   256,   257,    -1,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,   310,    -1,   312,   313,
     314,    -1,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,    -1,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,   483,
     484,   485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,    -1,    -1,   106,   107,    -1,    -1,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,    -1,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,    -1,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,    -1,   185,   186,    -1,   188,   189,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,   219,   220,    -1,   222,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,    -1,   249,   250,   251,   252,
     253,    -1,   255,   256,   257,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,    -1,   307,   308,   309,    -1,    -1,   312,
     313,   314,    -1,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
      -1,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,    -1,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,    -1,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
     483,   484,   485,   486,   487,   488,    -1,    -1,   491,    -1,
      -1,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,    -1,    -1,   106,   107,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,    -1,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,   176,   177,    -1,   179,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,    -1,
     222,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,    -1,   255,   256,   257,    -1,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,    -1,   307,   308,   309,    -1,    -1,
     312,   313,   314,    -1,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,   483,   484,   485,   486,   487,   488,    -1,    -1,   491,
      -1,    -1,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,   106,   107,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,    -1,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,    -1,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,   222,    -1,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,    -1,   255,   256,   257,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,    -1,   299,   300,
     301,   302,   303,   304,   305,    -1,   307,   308,   309,    -1,
      -1,   312,   313,   314,    -1,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,    -1,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,   488,    -1,    -1,
     491,    -1,    -1,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,    -1,    -1,   106,   107,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,    -1,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,    -1,   222,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,    -1,   255,   256,   257,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,    -1,   307,   308,   309,
      -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,    -1,    -1,
     450,   451,   452,   453,   454,    -1,   456,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,    -1,   482,   483,   484,   485,   486,   487,   488,    -1,
      -1,   491,    -1,    -1,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,    -1,    -1,   106,   107,    -1,
      -1,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,    -1,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,    -1,   255,   256,   257,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,   483,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,     3,    -1,    -1,     6,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,    -1,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,    -1,   222,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,    -1,   255,   256,   257,
      -1,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,    -1,   307,
     308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
      -1,    -1,   450,   451,   452,   453,   454,    -1,   456,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,    -1,    -1,   474,   475,   476,   477,
     478,   479,   480,    -1,   482,   483,   484,   485,   486,   487,
     488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,     3,    -1,    -1,     6,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,
     107,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,    -1,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,    -1,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,    -1,   185,   186,
      -1,   188,   189,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,   219,   220,    -1,   222,    -1,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,    -1,   249,   250,   251,   252,   253,    -1,   255,   256,
     257,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,    -1,   299,   300,   301,   302,   303,   304,   305,    -1,
     307,   308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,    -1,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,    -1,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,    -1,   482,   483,   484,   485,   486,
     487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,    -1,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,   222,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,    -1,   255,
     256,   257,    -1,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
      -1,   307,   308,   309,    -1,    -1,   312,   313,   314,    -1,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,    -1,    -1,   450,   451,   452,   453,   454,    -1,
     456,   457,   458,   459,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,    -1,    -1,   474,   475,
     476,   477,   478,   479,   480,    -1,   482,   483,   484,   485,
     486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,    -1,
      -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,    -1,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,    -1,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,    -1,
     185,   186,    -1,   188,   189,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,   222,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,    -1,   249,   250,   251,   252,   253,    -1,
     255,   256,   257,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,    -1,   299,   300,   301,   302,   303,   304,
     305,    -1,   307,   308,   309,    -1,    -1,   312,   313,   314,
      -1,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,    -1,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,    -1,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,   483,   484,
     485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
      -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
      -1,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,    -1,   222,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
      -1,   255,   256,   257,    -1,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,    -1,    -1,   312,   313,
     314,    -1,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,    -1,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,   452,   453,
     454,    -1,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,   483,
     484,   485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,    -1,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,    -1,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,    -1,   185,   186,    -1,   188,   189,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,   219,   220,    -1,   222,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,    -1,   249,   250,   251,   252,
     253,    -1,   255,   256,   257,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,    -1,   307,   308,   309,    -1,    -1,   312,
     313,   314,    -1,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,    -1,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
      -1,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,    -1,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,    -1,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
     483,   484,   485,   486,   487,   488,    -1,    -1,   491,    -1,
      -1,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,    -1,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,   176,   177,    -1,   179,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,    -1,
     222,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,    -1,   255,   256,   257,    -1,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,    -1,   307,   308,   309,    -1,    -1,
     312,   313,   314,    -1,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
      -1,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,   483,   484,   485,   486,   487,   488,    -1,    -1,   491,
      -1,    -1,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,    -1,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,    -1,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,   222,    -1,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,    -1,   255,   256,   257,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,    -1,   299,   300,
     301,   302,   303,   304,   305,    -1,   307,   308,   309,    -1,
      -1,   312,   313,   314,    -1,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,    -1,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,   488,    -1,    -1,
     491,    -1,    -1,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    -1,    -1,
      80,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,    -1,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,   174,   175,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,    -1,   249,
     250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,    -1,   307,   308,   309,
      -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,    -1,   403,   404,   405,   406,   407,    -1,   409,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,    -1,    -1,
     450,   451,   452,   453,   454,    -1,   456,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,   466,   467,   468,   469,
     470,   471,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,    -1,   482,    -1,   484,   485,   486,   487,   488,    -1,
      -1,   491,    -1,    -1,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,    -1,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,   174,   175,   176,    -1,    -1,
      -1,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,    -1,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,    -1,   252,   253,    -1,   255,   256,   257,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,    -1,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,   466,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,    -1,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,    -1,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,   174,   175,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,
      -1,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
      -1,   249,   250,    -1,   252,    -1,    -1,   255,   256,   257,
      -1,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,    -1,   307,
     308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
      -1,    -1,   450,   451,   452,   453,   454,    -1,   456,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,   466,   467,
     468,   469,   470,   471,    -1,    -1,   474,   475,   476,   477,
     478,   479,   480,    -1,   482,    -1,   484,   485,   486,   487,
     488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    99,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,    -1,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,    -1,   175,   176,
      -1,    -1,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,   189,   190,    -1,   192,   193,   194,   195,   196,
      -1,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,    -1,   222,    -1,   224,    -1,    -1,
     227,    -1,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,    -1,   249,   250,    -1,   252,    -1,    -1,   255,   256,
     257,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,    -1,
     297,    -1,   299,   300,   301,   302,   303,   304,   305,    -1,
     307,   308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,
     317,   318,   319,    -1,   321,    -1,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,    -1,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,    -1,    -1,   436,
      -1,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,    -1,   482,    -1,   484,   485,   486,
     487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,    -1,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,    -1,    -1,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,    -1,   222,    -1,   224,    -1,
      -1,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,    -1,   249,   250,    -1,   252,    -1,    -1,   255,
     256,   257,    -1,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
      -1,   307,   308,   309,    -1,    -1,   312,   313,   314,    -1,
      -1,   317,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,    -1,    -1,
     436,    -1,   438,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,    -1,    -1,   450,   451,   452,   453,   454,    -1,
     456,   457,   458,   459,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,    -1,    -1,   474,   475,
     476,   477,   478,   479,   480,    -1,   482,    -1,   484,   485,
     486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    99,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,    -1,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,    -1,
     175,   176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,
     185,   186,    -1,   188,   189,   190,    -1,   192,   193,   194,
     195,   196,    -1,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,    -1,   222,    -1,   224,
      -1,    -1,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,    -1,   249,   250,    -1,   252,    -1,    -1,
     255,   256,   257,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,    -1,   297,    -1,   299,   300,   301,   302,   303,   304,
     305,    -1,   307,   308,   309,    -1,    -1,   312,   313,   314,
      -1,    -1,   317,   318,   319,    -1,   321,    -1,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,    -1,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,    -1,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,    -1,
      -1,   436,    -1,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,    -1,   484,
     485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
      -1,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,    -1,   222,    -1,
     224,    -1,    -1,   227,    -1,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,    -1,   249,   250,    -1,   252,    -1,
      -1,   255,   256,   257,    -1,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,    -1,   311,   312,   313,
     314,    -1,    -1,   317,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,    -1,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
      -1,   435,   436,    -1,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,   452,   453,
     454,    -1,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,    -1,
     484,   485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,    -1,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,   174,   175,   176,    -1,    -1,    -1,   180,   181,   182,
     183,    -1,   185,   186,    -1,   188,   189,   190,    -1,   192,
     193,   194,   195,   196,    -1,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,    -1,   222,
      -1,   224,    -1,    -1,   227,    -1,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,    -1,   249,   250,    -1,   252,
      -1,    -1,   255,   256,   257,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,    -1,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,    -1,   307,   308,   309,    -1,    -1,   312,
     313,   314,    -1,    -1,   317,   318,   319,    -1,   321,    -1,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,    -1,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
      -1,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,    -1,   435,   436,    -1,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,    -1,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,    -1,    -1,   491,    -1,
      -1,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,    -1,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,    -1,
     222,    -1,   224,    -1,    -1,   227,    -1,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,    -1,   249,   250,    -1,
     252,    -1,    -1,   255,   256,   257,    -1,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,    -1,   307,   308,   309,    -1,    -1,
     312,   313,   314,    -1,    -1,   317,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,    -1,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,    -1,    -1,   436,    -1,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,    -1,   484,   485,   486,   487,   488,    -1,    -1,   491,
      -1,    -1,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,    -1,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,    -1,   175,   176,    -1,    -1,    -1,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,    -1,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
      -1,   222,    -1,   224,    -1,    -1,   227,    -1,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,    -1,   249,   250,
      -1,   252,    -1,    -1,   255,   256,   257,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,    -1,   297,    -1,   299,   300,
     301,   302,   303,   304,   305,    -1,   307,   308,   309,    -1,
     311,   312,   313,   314,    -1,    -1,   317,   318,   319,    -1,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,    -1,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,    -1,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,   435,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,   488,    -1,    -1,
     491,    -1,    -1,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,    -1,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,    -1,   249,
     250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,    -1,   307,   308,   309,
      -1,   311,   312,   313,   314,    -1,    -1,   317,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,    -1,   403,   404,   405,   406,   407,    -1,   409,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,    -1,    -1,
     450,   451,   452,   453,   454,    -1,   456,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,    -1,   482,    -1,   484,   485,   486,   487,   488,    -1,
      -1,   491,    -1,    -1,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,    -1,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,
      -1,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,    -1,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,    -1,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,    -1,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,   472,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,    -1,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,    -1,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,
      -1,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
      -1,   249,   250,    -1,   252,    -1,    -1,   255,   256,   257,
      -1,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,    -1,   307,
     308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
      -1,    -1,   450,   451,   452,   453,   454,    -1,   456,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,    -1,   482,    -1,   484,   485,   486,   487,
     488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,    -1,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,    -1,   175,   176,
      -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,   186,
      -1,   188,   189,   190,    -1,   192,   193,   194,   195,   196,
      -1,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,    -1,   222,    -1,   224,    -1,    -1,
     227,    -1,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,    -1,   249,   250,    -1,   252,    -1,    -1,   255,   256,
     257,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,    -1,
     297,    -1,   299,   300,   301,   302,   303,   304,   305,    -1,
     307,   308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,
     317,   318,   319,    -1,   321,    -1,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,    -1,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,    -1,    -1,   436,
      -1,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,    -1,   482,    -1,   484,   485,   486,
     487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,    -1,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,    -1,   222,    -1,   224,    -1,
      -1,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,    -1,   249,   250,    -1,   252,    -1,    -1,   255,
     256,   257,    -1,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
      -1,   307,   308,   309,    -1,    -1,   312,   313,   314,    -1,
      -1,   317,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,    -1,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,    -1,    -1,
     436,    -1,   438,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,    -1,    -1,   450,   451,   452,   453,   454,    -1,
     456,   457,   458,   459,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,    -1,    -1,   474,   475,
     476,   477,   478,   479,   480,    -1,   482,    -1,   484,   485,
     486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,    -1,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,    -1,
     175,   176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,
     185,   186,    -1,   188,   189,   190,    -1,   192,   193,   194,
     195,   196,    -1,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,    -1,   222,    -1,   224,
      -1,    -1,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,    -1,   249,   250,    -1,   252,    -1,    -1,
     255,   256,   257,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,    -1,   297,    -1,   299,   300,   301,   302,   303,   304,
     305,    -1,   307,   308,   309,    -1,    -1,   312,   313,   314,
      -1,    -1,   317,   318,   319,    -1,   321,    -1,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,    -1,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,    -1,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,    -1,
      -1,   436,    -1,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,    -1,   484,
     485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
      -1,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,    -1,   222,    -1,
     224,    -1,    -1,   227,    -1,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,    -1,   249,   250,    -1,   252,    -1,
      -1,   255,   256,   257,    -1,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,    -1,    -1,   312,   313,
     314,    -1,    -1,   317,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,    -1,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
      -1,    -1,   436,    -1,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,   452,   453,
     454,    -1,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,    -1,
     484,   485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,    -1,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,    -1,   175,   176,    -1,    -1,    -1,   180,   181,   182,
     183,    -1,   185,   186,    -1,   188,   189,   190,    -1,   192,
     193,   194,   195,   196,    -1,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,    -1,   222,
      -1,   224,    -1,    -1,   227,    -1,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,    -1,   249,   250,    -1,   252,
      -1,    -1,   255,   256,   257,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,    -1,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,    -1,   307,   308,   309,    -1,   311,   312,
     313,   314,    -1,    -1,   317,   318,   319,    -1,   321,    -1,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,    -1,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
      -1,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,    -1,    -1,   436,    -1,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,    -1,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,    -1,    -1,   491,    -1,
      -1,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,    -1,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,    -1,
     222,    -1,   224,    -1,    -1,   227,    -1,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,    -1,   249,   250,    -1,
     252,    -1,    -1,   255,   256,   257,    -1,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,    -1,   307,   308,   309,    -1,    -1,
     312,   313,   314,    -1,    -1,   317,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
      -1,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,    -1,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,    -1,    -1,   436,    -1,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,    -1,   484,   485,   486,   487,   488,    -1,    -1,   491,
      -1,    -1,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,    -1,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,    -1,   175,   176,    -1,    -1,    -1,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,    -1,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
      -1,   222,    -1,   224,    -1,    -1,   227,    -1,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,    -1,   249,   250,
      -1,   252,    -1,    -1,   255,   256,   257,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,    -1,   297,    -1,   299,   300,
     301,   302,   303,   304,   305,    -1,   307,   308,   309,    -1,
      -1,   312,   313,   314,    -1,    -1,   317,   318,   319,    -1,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,    -1,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,    -1,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,   488,    -1,    -1,
     491,    -1,    -1,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,    -1,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,    -1,   249,
     250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,    -1,   307,   308,   309,
      -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,    -1,   403,   404,   405,   406,   407,    -1,   409,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,    -1,    -1,
     450,   451,   452,   453,   454,    -1,   456,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,    -1,   482,    -1,   484,   485,   486,   487,   488,    -1,
      -1,   491,    -1,    -1,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,    -1,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,
      -1,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,    -1,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,    -1,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,    -1,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,    -1,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,    -1,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,
      -1,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
      -1,   249,   250,    -1,   252,    -1,    -1,   255,   256,   257,
      -1,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,    -1,   307,
     308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
      -1,    -1,   450,   451,   452,   453,   454,    -1,   456,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,    -1,    -1,   474,   475,   476,   477,
     478,   479,   480,    -1,   482,    -1,   484,   485,   486,   487,
     488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,    -1,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,    -1,   175,   176,
      -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,   186,
      -1,   188,   189,   190,    -1,   192,   193,   194,   195,   196,
      -1,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,    -1,   222,    -1,   224,    -1,    -1,
     227,    -1,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,    -1,   249,   250,    -1,   252,    -1,    -1,   255,   256,
     257,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,    -1,
     297,    -1,   299,   300,   301,   302,   303,   304,   305,    -1,
     307,   308,   309,    -1,   311,   312,   313,   314,    -1,    -1,
     317,   318,   319,    -1,   321,    -1,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,    -1,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,    -1,    -1,   436,
      -1,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,    -1,   482,    -1,   484,   485,   486,
     487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,    -1,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,    -1,   222,    -1,   224,    -1,
      -1,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,    -1,   249,   250,    -1,   252,    -1,    -1,   255,
     256,   257,    -1,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
      -1,   307,   308,   309,    -1,    -1,   312,   313,   314,    -1,
      -1,   317,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,    -1,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,    -1,    -1,
     436,    -1,   438,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,    -1,    -1,   450,   451,   452,   453,   454,    -1,
     456,   457,   458,   459,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,    -1,    -1,   474,   475,
     476,   477,   478,   479,   480,    -1,   482,    -1,   484,   485,
     486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,    -1,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,    -1,
     175,   176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,
     185,   186,    -1,   188,   189,   190,    -1,   192,   193,   194,
     195,   196,    -1,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,    -1,   222,    -1,   224,
      -1,    -1,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,    -1,   249,   250,    -1,   252,    -1,    -1,
     255,   256,   257,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,    -1,   297,    -1,   299,   300,   301,   302,   303,   304,
     305,    -1,   307,   308,   309,    -1,    -1,   312,   313,   314,
      -1,    -1,   317,   318,   319,    -1,   321,    -1,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,    -1,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,    -1,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,    -1,
      -1,   436,    -1,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,    -1,   484,
     485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
      -1,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,    -1,   222,    -1,
     224,    -1,    -1,   227,    -1,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,    -1,   249,   250,    -1,   252,    -1,
      -1,   255,   256,   257,    -1,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,    -1,    -1,   312,   313,
     314,    -1,    -1,   317,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,    -1,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
      -1,   435,   436,    -1,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,   452,   453,
     454,    -1,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,    -1,
     484,   485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
       3,    -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,    -1,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,    -1,   175,   176,    -1,    -1,    -1,   180,   181,   182,
     183,    -1,   185,   186,    -1,   188,   189,   190,    -1,   192,
     193,   194,   195,   196,    -1,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,    -1,   222,
      -1,   224,    -1,    -1,   227,    -1,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,    -1,   249,   250,    -1,   252,
      -1,    -1,   255,   256,   257,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,    -1,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,    -1,   307,   308,   309,    -1,    -1,   312,
     313,   314,    -1,    -1,   317,   318,   319,    -1,   321,    -1,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,    -1,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
      -1,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,    -1,    -1,   436,    -1,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,    -1,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,    -1,    -1,   491,    -1,
      -1,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    11,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,    -1,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,    -1,
     222,    -1,   224,    -1,    -1,   227,    -1,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,    -1,   249,   250,    -1,
     252,    -1,    -1,   255,   256,   257,    -1,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,    -1,   307,   308,   309,    -1,    -1,
     312,   313,   314,    -1,    -1,   317,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
      -1,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,    -1,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,    -1,    -1,   436,    -1,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,    -1,   484,   485,   486,   487,   488,    -1,    -1,   491,
      -1,    -1,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,    -1,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,    -1,   175,   176,    -1,    -1,    -1,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,    -1,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
      -1,   222,    -1,   224,    -1,    -1,   227,    -1,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,    -1,   249,   250,
      -1,   252,    -1,    -1,   255,   256,   257,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,    -1,   297,    -1,   299,   300,
     301,   302,   303,   304,   305,    -1,   307,   308,   309,    -1,
      -1,   312,   313,   314,    -1,    -1,   317,   318,   319,    -1,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,    -1,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,    -1,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,   488,    -1,    -1,
     491,    -1,    -1,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,    -1,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,    -1,   249,
     250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,    -1,   307,   308,   309,
      -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,    -1,   403,   404,   405,   406,   407,    -1,   409,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,    -1,    -1,
     450,   451,   452,   453,   454,    -1,   456,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,    -1,   482,    -1,   484,   485,   486,   487,   488,    -1,
      -1,   491,    -1,    -1,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,    -1,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,
      -1,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,    -1,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,    -1,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,    -1,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,    -1,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,    -1,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,
      -1,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
      -1,   249,   250,    -1,   252,    -1,    -1,   255,   256,   257,
      -1,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,    -1,   307,
     308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
      -1,    -1,   450,   451,   452,   453,   454,    -1,   456,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,    -1,    -1,   474,   475,   476,   477,
     478,   479,   480,    -1,   482,    -1,   484,   485,   486,   487,
     488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
     107,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,    -1,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,    -1,   175,   176,
      -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,   186,
      -1,   188,   189,   190,    -1,   192,   193,   194,   195,   196,
      -1,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,    -1,   222,    -1,   224,    -1,    -1,
     227,    -1,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,    -1,   249,   250,    -1,   252,    -1,    -1,   255,   256,
     257,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,    -1,
     297,    -1,   299,   300,   301,   302,   303,   304,   305,    -1,
     307,   308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,
     317,   318,   319,    -1,   321,    -1,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,    -1,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,    -1,    -1,   436,
      -1,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,    -1,   482,    -1,   484,   485,   486,
     487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,    -1,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,    -1,   222,    -1,   224,    -1,
      -1,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,    -1,   249,   250,    -1,   252,    -1,    -1,   255,
     256,   257,    -1,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
      -1,   307,   308,   309,    -1,    -1,   312,   313,   314,    -1,
      -1,   317,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,    -1,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,    -1,    -1,
     436,    -1,   438,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,    -1,    -1,   450,   451,   452,   453,   454,    -1,
     456,   457,   458,   459,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,    -1,    -1,   474,   475,
     476,   477,   478,   479,   480,    -1,   482,    -1,   484,   485,
     486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,    -1,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,    -1,
     175,   176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,
     185,   186,    -1,   188,   189,   190,    -1,   192,   193,   194,
     195,   196,    -1,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,    -1,   222,    -1,   224,
      -1,    -1,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,    -1,   249,   250,    -1,   252,    -1,    -1,
     255,   256,   257,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,    -1,   297,    -1,   299,   300,   301,   302,   303,   304,
     305,    -1,   307,   308,   309,    -1,    -1,   312,   313,   314,
      -1,    -1,   317,   318,   319,    -1,   321,    -1,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,    -1,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,    -1,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,    -1,
      -1,   436,    -1,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,    -1,   484,
     485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
      -1,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,    -1,   222,    -1,
     224,    -1,    -1,   227,    -1,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,    -1,   249,   250,    -1,   252,    -1,
      -1,   255,   256,   257,    -1,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,    -1,    -1,   312,   313,
     314,    -1,    -1,   317,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,    -1,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
      -1,    -1,   436,    -1,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,   452,   453,
     454,    -1,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,    -1,
     484,   485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,    -1,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,    -1,   175,   176,    -1,    -1,    -1,   180,   181,   182,
     183,    -1,   185,   186,    -1,   188,   189,   190,    -1,   192,
     193,   194,   195,   196,    -1,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,    -1,   222,
      -1,   224,    -1,    -1,   227,    -1,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,    -1,   249,   250,    -1,   252,
      -1,    -1,   255,   256,   257,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,    -1,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,    -1,   307,   308,   309,    -1,    -1,   312,
     313,   314,    -1,    -1,   317,   318,   319,    -1,   321,    -1,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,    -1,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
      -1,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,    -1,    -1,   436,    -1,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,    -1,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,    -1,    -1,   491,    -1,
      -1,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,    -1,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,    -1,
     222,    -1,   224,    -1,    -1,   227,    -1,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,    -1,   249,   250,    -1,
     252,    -1,    -1,   255,   256,   257,    -1,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,    -1,   307,   308,   309,    -1,    -1,
     312,   313,   314,    -1,    -1,   317,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
      -1,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,    -1,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,    -1,    -1,   436,    -1,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,    -1,   484,   485,   486,   487,   488,    -1,    -1,   491,
      -1,    -1,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,    -1,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,    -1,   175,   176,    -1,    -1,    -1,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,    -1,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
      -1,   222,    -1,   224,    -1,    -1,   227,    -1,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,    -1,   249,   250,
      -1,   252,    -1,    -1,   255,   256,   257,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,    -1,   297,    -1,   299,   300,
     301,   302,   303,   304,   305,    -1,   307,   308,   309,    -1,
      -1,   312,   313,   314,    -1,    -1,   317,   318,   319,    -1,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,    -1,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,    -1,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,   488,    -1,    -1,
     491,    -1,    -1,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,    -1,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,    -1,   249,
     250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,    -1,   307,   308,   309,
      -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,    -1,   403,   404,   405,   406,   407,    -1,   409,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,    -1,    -1,
     450,   451,   452,   453,   454,    -1,   456,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,    -1,   482,    -1,   484,   485,   486,   487,   488,    -1,
      -1,   491,    -1,    -1,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,    -1,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,
      -1,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,    -1,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,    -1,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,    -1,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,    -1,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,    -1,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,
      -1,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
      -1,   249,   250,    -1,   252,    -1,    -1,   255,   256,   257,
      -1,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,    -1,   307,
     308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
      -1,    -1,   450,   451,   452,   453,   454,    -1,   456,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,    -1,    -1,   474,   475,   476,   477,
     478,   479,   480,    -1,   482,    -1,   484,   485,   486,   487,
     488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,    -1,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,    -1,   175,   176,
      -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,   186,
      -1,   188,   189,   190,    -1,   192,   193,   194,   195,   196,
      -1,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,    -1,   222,    -1,   224,    -1,    -1,
     227,    -1,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,    -1,   249,   250,    -1,   252,    -1,    -1,   255,   256,
     257,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,    -1,
     297,    -1,   299,   300,   301,   302,   303,   304,   305,    -1,
     307,   308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,
     317,   318,   319,    -1,   321,    -1,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,    -1,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,    -1,    -1,   436,
      -1,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,    -1,   482,    -1,   484,   485,   486,
     487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,    -1,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,    -1,   222,    -1,   224,    -1,
      -1,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,    -1,   249,   250,    -1,   252,    -1,    -1,   255,
     256,   257,    -1,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
      -1,   307,   308,   309,    -1,    -1,   312,   313,   314,    -1,
      -1,   317,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,    -1,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,    -1,    -1,
     436,    -1,   438,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,    -1,    -1,   450,   451,   452,   453,   454,    -1,
     456,   457,   458,   459,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,    -1,    -1,   474,   475,
     476,   477,   478,   479,   480,    -1,   482,    -1,   484,   485,
     486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,    -1,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,    -1,
     175,   176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,
     185,   186,    -1,   188,   189,   190,    -1,   192,   193,   194,
     195,   196,    -1,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,    -1,   222,    -1,   224,
      -1,    -1,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,    -1,   249,   250,    -1,   252,    -1,    -1,
     255,   256,   257,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,    -1,   297,    -1,   299,   300,   301,   302,   303,   304,
     305,    -1,   307,   308,   309,    -1,    -1,   312,   313,   314,
      -1,    -1,   317,   318,   319,    -1,   321,    -1,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,    -1,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,    -1,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,    -1,
      -1,   436,    -1,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,    -1,   484,
     485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
      -1,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,    -1,   222,    -1,
     224,    -1,    -1,   227,    -1,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,    -1,   249,   250,    -1,   252,    -1,
      -1,   255,   256,   257,    -1,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,    -1,    -1,   312,   313,
     314,    -1,    -1,   317,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,    -1,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
      -1,    -1,   436,    -1,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,   452,   453,
     454,    -1,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,    -1,
     484,   485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,    -1,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,    -1,   175,   176,    -1,    -1,    -1,   180,   181,   182,
     183,    -1,   185,   186,    -1,   188,   189,   190,    -1,   192,
     193,   194,   195,   196,    -1,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,    -1,   222,
      -1,   224,    -1,    -1,   227,    -1,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,    -1,   249,   250,    -1,   252,
      -1,    -1,   255,   256,   257,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,    -1,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,    -1,   307,   308,   309,    -1,    -1,   312,
     313,   314,    -1,    -1,   317,   318,   319,    -1,   321,    -1,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,    -1,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
      -1,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,    -1,    -1,   436,    -1,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,    -1,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,    -1,    -1,   491,    -1,
      -1,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,    -1,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,    -1,
     222,    -1,   224,    -1,    -1,   227,    -1,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,    -1,   249,   250,    -1,
     252,    -1,    -1,   255,   256,   257,    -1,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,    -1,   307,   308,   309,    -1,    -1,
     312,   313,   314,    -1,    -1,   317,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
      -1,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,    -1,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,    -1,    -1,   436,    -1,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,    -1,   484,   485,   486,   487,   488,    -1,    -1,   491,
      -1,    -1,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,    -1,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,    -1,   175,   176,    -1,    -1,    -1,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,    -1,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
      -1,   222,    -1,   224,    -1,    -1,   227,    -1,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,    -1,   249,   250,
      -1,   252,    -1,    -1,   255,   256,   257,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,    -1,   297,    -1,   299,   300,
     301,   302,   303,   304,   305,    -1,   307,   308,   309,    -1,
      -1,   312,   313,   314,    -1,    -1,   317,   318,   319,    -1,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,    -1,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,    -1,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,   488,    -1,    -1,
     491,    -1,    -1,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,    -1,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,    -1,   249,
     250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,    -1,   307,   308,   309,
      -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,    -1,   403,   404,   405,   406,   407,    -1,   409,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,    -1,    -1,
     450,   451,   452,   453,   454,    -1,   456,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,    -1,   482,    -1,   484,   485,   486,   487,   488,    -1,
      -1,   491,    -1,    -1,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,    -1,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,
      -1,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,    -1,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,    -1,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,    -1,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,    -1,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,    -1,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,
      -1,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
      -1,   249,   250,    -1,   252,    -1,    -1,   255,   256,   257,
      -1,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,    -1,   307,
     308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
      -1,    -1,   450,   451,   452,   453,   454,    -1,   456,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,    -1,    -1,   474,   475,   476,   477,
     478,   479,   480,    -1,   482,    -1,   484,   485,   486,   487,
     488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,    -1,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,    -1,   175,   176,
      -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,   186,
      -1,   188,   189,   190,    -1,   192,   193,   194,   195,   196,
      -1,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,    -1,   222,    -1,   224,    -1,    -1,
     227,    -1,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,    -1,   249,   250,    -1,   252,    -1,    -1,   255,   256,
     257,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,    -1,
     297,    -1,   299,   300,   301,   302,   303,   304,   305,    -1,
     307,   308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,
     317,   318,   319,    -1,   321,    -1,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,    -1,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,    -1,    -1,   436,
      -1,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,    -1,   482,    -1,   484,   485,   486,
     487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,    -1,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,    -1,   222,    -1,   224,    -1,
      -1,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,    -1,   249,   250,    -1,   252,    -1,    -1,   255,
     256,   257,    -1,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
      -1,   307,   308,   309,    -1,    -1,   312,   313,   314,    -1,
      -1,   317,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,    -1,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,    -1,    -1,
     436,    -1,   438,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,    -1,    -1,   450,   451,   452,   453,   454,    -1,
     456,   457,   458,   459,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,    -1,    -1,   474,   475,
     476,   477,   478,   479,   480,    -1,   482,    -1,   484,   485,
     486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,    -1,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,    -1,
     175,   176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,
     185,   186,    -1,   188,   189,   190,    -1,   192,   193,   194,
     195,   196,    -1,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,    -1,   222,    -1,   224,
      -1,    -1,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,    -1,   249,   250,    -1,   252,    -1,    -1,
     255,   256,   257,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,    -1,   297,    -1,   299,   300,   301,   302,   303,   304,
     305,    -1,   307,   308,   309,    -1,    -1,   312,   313,   314,
      -1,    -1,   317,   318,   319,    -1,   321,    -1,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,    -1,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,    -1,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,    -1,
      -1,   436,    -1,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,    -1,   484,
     485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
      -1,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,    -1,   222,    -1,
     224,    -1,    -1,   227,    -1,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,    -1,   249,   250,    -1,   252,    -1,
      -1,   255,   256,   257,    -1,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,    -1,    -1,   312,   313,
     314,    -1,    -1,   317,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,    -1,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
      -1,    -1,   436,    -1,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,   452,   453,
     454,    -1,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,    -1,
     484,   485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,    -1,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,    -1,   175,   176,    -1,    -1,    -1,   180,   181,   182,
     183,    -1,   185,   186,    -1,   188,   189,   190,    -1,   192,
     193,   194,   195,   196,    -1,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,    -1,   222,
      -1,   224,    -1,    -1,   227,    -1,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,    -1,   249,   250,    -1,   252,
      -1,    -1,   255,   256,   257,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,    -1,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,    -1,   307,   308,   309,    -1,    -1,   312,
     313,   314,    -1,    -1,   317,   318,   319,    -1,   321,    -1,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,    -1,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
      -1,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,    -1,    -1,   436,    -1,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,    -1,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,    -1,    -1,   491,    -1,
      -1,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,    -1,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,    -1,
     222,    -1,   224,    -1,    -1,   227,    -1,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,    -1,   249,   250,    -1,
     252,    -1,    -1,   255,   256,   257,    -1,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,    -1,   307,   308,   309,    -1,    -1,
     312,   313,   314,    -1,    -1,   317,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
      -1,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,    -1,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,    -1,    -1,   436,    -1,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,    -1,   484,   485,   486,   487,   488,    -1,    -1,   491,
      -1,    -1,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,    -1,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,    -1,   175,   176,    -1,    -1,    -1,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,    -1,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
      -1,   222,    -1,   224,    -1,    -1,   227,    -1,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,    -1,   249,   250,
      -1,   252,    -1,    -1,   255,   256,   257,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,    -1,   297,    -1,   299,   300,
     301,   302,   303,   304,   305,    -1,   307,   308,   309,    -1,
      -1,   312,   313,   314,    -1,    -1,   317,   318,   319,    -1,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,    -1,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,    -1,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,   488,    -1,    -1,
     491,    -1,    -1,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,    -1,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,    -1,   249,
     250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,    -1,   307,   308,   309,
      -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,    -1,   403,   404,   405,   406,   407,    -1,   409,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,    -1,    -1,
     450,   451,   452,   453,   454,    -1,   456,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,    -1,   482,    -1,   484,   485,   486,   487,   488,    -1,
      -1,   491,    -1,    -1,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,    -1,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,
      -1,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,    -1,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,    -1,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,    -1,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,    -1,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,    -1,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,
      -1,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
      -1,   249,   250,    -1,   252,    -1,    -1,   255,   256,   257,
      -1,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,    -1,   307,
     308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
      -1,    -1,   450,   451,   452,   453,   454,    -1,   456,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,    -1,    -1,   474,   475,   476,   477,
     478,   479,   480,    -1,   482,    -1,   484,   485,   486,   487,
     488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    38,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,    -1,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,    -1,   175,   176,
      -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,   186,
      -1,   188,   189,   190,    -1,   192,   193,   194,   195,   196,
      -1,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,    -1,   222,    -1,   224,    -1,    -1,
     227,    -1,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,    -1,   249,   250,    -1,   252,    -1,    -1,   255,   256,
     257,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,    -1,
     297,    -1,   299,   300,   301,   302,   303,   304,   305,    -1,
     307,   308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,
     317,   318,   319,    -1,   321,    -1,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,    -1,    -1,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,    -1,    -1,   436,
      -1,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,    -1,   482,    -1,   484,   485,   486,
     487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,    -1,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,    -1,   222,    -1,   224,    -1,
      -1,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,    -1,   249,   250,    -1,   252,    -1,    -1,   255,
     256,   257,    -1,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
      -1,   307,   308,   309,    -1,    -1,   312,   313,   314,    -1,
      -1,   317,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,    -1,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,    -1,    -1,
     436,    -1,   438,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,    -1,    -1,   450,   451,   452,   453,   454,    -1,
     456,   457,   458,   459,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,    -1,    -1,   474,   475,
     476,   477,   478,   479,   480,    -1,   482,    -1,   484,   485,
     486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,    -1,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,    -1,
     175,   176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,
     185,   186,    -1,   188,   189,   190,    -1,   192,   193,   194,
     195,   196,    -1,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,    -1,   222,    -1,   224,
      -1,    -1,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,    -1,   249,   250,    -1,   252,    -1,    -1,
     255,   256,   257,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,    -1,   297,    -1,   299,   300,   301,   302,   303,   304,
     305,    -1,   307,   308,   309,    -1,    -1,   312,   313,   314,
      -1,    -1,   317,   318,   319,    -1,   321,    -1,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,    -1,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,    -1,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,    -1,
      -1,   436,    -1,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,    -1,   484,
     485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
      -1,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,    -1,   222,    -1,
     224,    -1,    -1,   227,    -1,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,    -1,   249,   250,    -1,   252,    -1,
      -1,   255,   256,   257,    -1,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,    -1,    -1,   312,   313,
     314,    -1,    -1,   317,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,    -1,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
      -1,    -1,   436,    -1,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,   452,   453,
     454,    -1,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,    -1,
     484,   485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,    -1,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,    -1,   175,   176,    -1,    -1,    -1,   180,   181,   182,
     183,    -1,   185,   186,    -1,   188,   189,   190,    -1,   192,
     193,   194,   195,   196,    -1,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,    -1,   222,
      -1,   224,    -1,    -1,   227,    -1,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,    -1,   249,   250,    -1,   252,
      -1,    -1,   255,   256,   257,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,    -1,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,    -1,   307,   308,   309,    -1,    -1,   312,
     313,   314,    -1,    -1,   317,   318,   319,    -1,   321,    -1,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,    -1,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
      -1,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,    -1,    -1,   436,    -1,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,    -1,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,    -1,    -1,   491,    -1,
      -1,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,    -1,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,    -1,
     222,    -1,   224,    -1,    -1,   227,    -1,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,    -1,   249,   250,    -1,
     252,    -1,    -1,   255,   256,   257,    -1,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,    -1,   307,   308,   309,    -1,    -1,
     312,   313,   314,    -1,    -1,   317,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
      -1,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,    -1,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,    -1,    -1,   436,    -1,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,    -1,   484,   485,   486,   487,   488,    -1,    -1,   491,
      -1,    -1,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,    -1,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,    -1,   175,   176,    -1,    -1,    -1,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,    -1,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
      -1,   222,    -1,   224,    -1,    -1,   227,    -1,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,    -1,   249,   250,
      -1,   252,    -1,    -1,   255,   256,   257,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,    -1,   297,    -1,   299,   300,
     301,   302,   303,   304,   305,    -1,   307,   308,   309,    -1,
      -1,   312,   313,   314,    -1,    -1,   317,   318,   319,    -1,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,    -1,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,    -1,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,   488,    -1,    -1,
     491,    -1,    -1,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,    -1,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,    -1,   249,
     250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,    -1,   307,   308,   309,
      -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,    -1,   403,   404,   405,   406,   407,    -1,   409,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,    -1,    -1,
     450,   451,   452,   453,   454,    -1,   456,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,    -1,   482,    -1,   484,   485,   486,   487,   488,    -1,
      -1,   491,    -1,    -1,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,    -1,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,
      -1,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,    -1,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,    -1,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,    -1,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,    -1,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,    -1,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,
      -1,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
      -1,   249,   250,    -1,   252,    -1,    -1,   255,   256,   257,
      -1,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,    -1,   307,
     308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
      -1,    -1,   450,   451,   452,   453,   454,    -1,   456,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,    -1,    -1,   474,   475,   476,   477,
     478,   479,   480,    -1,   482,    -1,   484,   485,   486,   487,
     488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,    -1,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,    -1,   175,   176,
      -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,   186,
      -1,   188,   189,   190,    -1,   192,   193,   194,   195,   196,
      -1,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,    -1,   222,    -1,   224,    -1,    -1,
     227,    -1,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,    -1,   249,   250,    -1,   252,    -1,    -1,   255,   256,
     257,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,    -1,
     297,    -1,   299,   300,   301,   302,   303,   304,   305,    -1,
     307,   308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,
     317,   318,   319,    -1,   321,    -1,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,    -1,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,    -1,    -1,   436,
      -1,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,    -1,   482,    -1,   484,   485,   486,
     487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,    -1,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,    -1,   222,    -1,   224,    -1,
      -1,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,    -1,   249,   250,    -1,   252,    -1,    -1,   255,
     256,   257,    -1,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
      -1,   307,   308,   309,    -1,    -1,   312,   313,   314,    -1,
      -1,   317,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,    -1,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,    -1,    -1,
     436,    -1,   438,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,    -1,    -1,   450,   451,   452,   453,   454,    -1,
     456,   457,   458,   459,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,    -1,    -1,   474,   475,
     476,   477,   478,   479,   480,    -1,   482,    -1,   484,   485,
     486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,    -1,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,    -1,
     175,   176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,
     185,   186,    -1,   188,   189,   190,    -1,   192,   193,   194,
     195,   196,    -1,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,    -1,   222,    -1,   224,
      -1,    -1,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,    -1,   249,   250,    -1,   252,    -1,    -1,
     255,   256,   257,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,    -1,   297,    -1,   299,   300,   301,   302,   303,   304,
     305,    -1,   307,   308,   309,    -1,    -1,   312,   313,   314,
      -1,    -1,   317,   318,   319,    -1,   321,    -1,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,    -1,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,    -1,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,    -1,
      -1,   436,    -1,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,    -1,   484,
     485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
      -1,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,    -1,   222,    -1,
     224,    -1,    -1,   227,    -1,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,    -1,   249,   250,    -1,   252,    -1,
      -1,   255,   256,   257,    -1,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,    -1,    -1,   312,   313,
     314,    -1,    -1,   317,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,    -1,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
      -1,    -1,   436,    -1,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,   452,   453,
     454,    -1,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,    -1,
     484,   485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,    -1,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,    -1,   175,   176,    -1,    -1,    -1,   180,   181,   182,
     183,    -1,   185,   186,    -1,   188,   189,   190,    -1,   192,
     193,   194,   195,   196,    -1,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,    -1,   222,
      -1,   224,    -1,    -1,   227,    -1,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,    -1,   249,   250,    -1,   252,
      -1,    -1,   255,   256,   257,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,    -1,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,    -1,   307,   308,   309,    -1,    -1,   312,
     313,   314,    -1,    -1,   317,   318,   319,    -1,   321,    -1,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,    -1,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
      -1,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,    -1,    -1,   436,    -1,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,    -1,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,    -1,    -1,   491,    -1,
      -1,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,    -1,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,    -1,
     222,    -1,   224,    -1,    -1,   227,    -1,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,    -1,   249,   250,    -1,
     252,    -1,    -1,   255,   256,   257,    -1,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,    -1,   307,   308,   309,    -1,    -1,
     312,   313,   314,    -1,    -1,   317,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
      -1,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,    -1,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,    -1,    -1,   436,    -1,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,    -1,   484,   485,   486,   487,   488,    -1,    -1,   491,
      -1,    -1,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,    -1,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,    -1,   175,   176,    -1,    -1,    -1,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,    -1,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
      -1,   222,    -1,   224,    -1,    -1,   227,    -1,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,    -1,   249,   250,
      -1,   252,    -1,    -1,   255,   256,   257,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,    -1,   297,    -1,   299,   300,
     301,   302,   303,   304,   305,    -1,   307,   308,   309,    -1,
      -1,   312,   313,   314,    -1,    -1,   317,   318,   319,    -1,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,    -1,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,    -1,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,   488,    -1,    -1,
     491,    -1,    -1,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,    -1,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,    -1,   249,
     250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,    -1,   307,   308,   309,
      -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,    -1,   403,   404,   405,   406,   407,    -1,   409,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,    -1,    -1,
     450,   451,   452,   453,   454,    -1,   456,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,    -1,   482,    -1,   484,   485,   486,   487,   488,    -1,
      -1,   491,    -1,    -1,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,    -1,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,    -1,    -1,
      -1,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
      -1,   190,    -1,   192,   193,   194,   195,   196,    -1,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,    -1,    -1,   227,    -1,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,   250,    -1,   252,    -1,    -1,   255,   256,   257,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,    -1,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
     319,    -1,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,    -1,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    -1,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
      -1,   159,   160,   161,   162,    -1,    -1,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,    -1,   185,    -1,    -1,
      -1,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,    -1,   222,    -1,   224,   225,   226,   227,
     228,   229,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,    -1,
      -1,   249,    -1,   251,   252,   253,    -1,   255,   256,   257,
      -1,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,    -1,   292,    -1,   294,   295,   296,   297,
      -1,    -1,   300,   301,   302,   303,   304,   305,    -1,   307,
     308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,    -1,   341,    -1,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
      -1,    -1,   450,   451,    -1,   453,    -1,    -1,   456,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,    -1,    -1,   474,   475,   476,   477,
     478,    -1,   480,   481,   482,   483,   484,   485,   486,   487,
     488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,
     498,   499,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   511,   512,   513,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,   157,    -1,   159,   160,
     161,   162,    -1,    -1,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,    -1,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,    -1,    -1,    -1,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,   212,   213,    -1,   215,   216,   217,   218,   219,   220,
      -1,   222,    -1,   224,   225,   226,   227,   228,   229,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,    -1,    -1,   249,    -1,
     251,   252,   253,    -1,   255,   256,   257,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
      -1,   292,    -1,   294,   295,   296,   297,   298,    -1,   300,
     301,   302,   303,   304,   305,    -1,   307,   308,   309,    -1,
      -1,   312,   313,   314,    -1,    -1,   317,   318,    -1,   320,
     321,   322,    -1,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,   339,    -1,
     341,    -1,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,    -1,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
      -1,   432,   433,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,    -1,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,    -1,   480,
      -1,   482,   483,   484,   485,   486,   487,   488,    -1,    -1,
     491,    -1,    -1,   494,   495,   496,   497,   498,   499,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     511,   512,   513,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    -1,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
      -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,   161,   162,    -1,
      -1,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
      -1,   185,    -1,    -1,    -1,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,   212,   213,
      -1,   215,   216,   217,   218,   219,   220,    -1,   222,    -1,
     224,   225,   226,   227,   228,   229,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,    -1,    -1,   249,    -1,   251,   252,   253,
      -1,   255,   256,   257,    -1,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,    -1,   292,    -1,
     294,   295,   296,   297,    -1,    -1,   300,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,    -1,    -1,   312,   313,
     314,    -1,    -1,   317,   318,    -1,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,    -1,   341,    -1,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,    -1,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,    -1,   453,
      -1,    -1,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,
     474,   475,   476,   477,   478,    -1,   480,    -1,   482,   483,
     484,   485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,
     494,   495,   496,   497,   498,   499,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   511,   512,   513,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    -1,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      -1,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,
     107,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
     157,    -1,   159,   160,   161,   162,    -1,    -1,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,    -1,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,    -1,   185,    -1,
      -1,    -1,   189,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,   212,   213,    -1,   215,   216,
     217,   218,   219,   220,    -1,   222,    -1,   224,   225,   226,
     227,   228,   229,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   240,   241,   242,   243,   244,   245,   246,
      -1,    -1,   249,    -1,   251,   252,   253,    -1,   255,   256,
     257,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,    -1,   292,    -1,   294,   295,   296,
     297,    -1,    -1,   300,   301,   302,   303,   304,   305,    -1,
     307,   308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,
     317,   318,    -1,   320,   321,   322,    -1,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,   339,    -1,   341,    -1,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,    -1,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,    -1,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,    -1,   432,   433,    -1,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,    -1,   453,    -1,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,    -1,    -1,   474,   475,   476,
     477,   478,    -1,   480,    -1,   482,   483,   484,   485,   486,
     487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,
     497,   498,   499,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   511,   512,   513,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    -1,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,   161,   162,    -1,    -1,   165,    -1,   167,   168,   169,
     170,   171,   172,   173,    -1,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,    -1,   185,    -1,    -1,    -1,   189,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,   212,   213,    -1,   215,   216,   217,   218,   219,
     220,    -1,   222,    -1,   224,   225,   226,   227,   228,   229,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,    -1,    -1,   249,
      -1,   251,   252,   253,    -1,   255,   256,   257,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,    -1,   292,    -1,   294,   295,   296,   297,    -1,    -1,
     300,   301,   302,   303,   304,   305,    -1,   307,   308,   309,
      -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,    -1,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
      -1,   341,    -1,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,    -1,    -1,
     450,   451,    -1,   453,    -1,    -1,   456,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,    -1,    -1,   474,   475,   476,   477,   478,    -1,
     480,    -1,   482,   483,   484,   485,   486,   487,   488,    -1,
      -1,   491,    -1,    -1,   494,   495,   496,   497,   498,   499,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   511,   512,   513,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    -1,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,    -1,   159,   160,   161,   162,
      -1,    -1,   165,    -1,   167,   168,   169,   170,   171,   172,
     173,    -1,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,    -1,   185,    -1,    -1,    -1,   189,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,   212,
     213,    -1,   215,   216,   217,   218,   219,   220,    -1,   222,
      -1,   224,   225,   226,   227,   228,   229,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   240,   241,   242,
     243,   244,   245,   246,    -1,    -1,   249,    -1,   251,   252,
     253,    -1,   255,   256,   257,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,    -1,   292,
      -1,   294,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,    -1,   307,   308,   309,    -1,    -1,   312,
     313,   314,    -1,    -1,   317,   318,    -1,   320,   321,   322,
      -1,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,   339,    -1,   341,    -1,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,    -1,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,    -1,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
      -1,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,    -1,   432,
     433,    -1,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,    -1,
     453,    -1,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,    -1,
      -1,   474,   475,   476,   477,   478,    -1,   480,    -1,   482,
     483,   484,   485,   486,   487,   488,    -1,    -1,   491,    -1,
      -1,   494,   495,   496,   497,   498,   499,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   511,   512,
     513,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    -1,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,    -1,   159,   160,   161,   162,    -1,    -1,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
      -1,    -1,    -1,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,   212,   213,    -1,   215,
     216,   217,   218,   219,   220,    -1,   222,    -1,   224,   225,
     226,   227,   228,   229,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,    -1,    -1,   249,    -1,   251,   252,   253,    -1,   255,
     256,   257,    -1,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,    -1,   292,    -1,   294,   295,
     296,   297,    -1,    -1,   300,   301,   302,   303,   304,   305,
      -1,   307,   308,   309,    -1,    -1,   312,   313,   314,    -1,
      -1,   317,   318,    -1,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,    -1,   341,    -1,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,    -1,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,    -1,    -1,   450,   451,    -1,   453,    -1,    -1,
     456,   457,   458,   459,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,    -1,    -1,   474,   475,
     476,   477,   478,    -1,   480,    -1,   482,   483,   484,   485,
     486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,   495,
     496,   497,   498,   499,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   511,   512,   513,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    -1,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,    -1,
     159,   160,   161,   162,    -1,    -1,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,    -1,   185,    -1,    -1,    -1,
     189,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,   213,    -1,   215,   216,   217,   218,
     219,   220,    -1,   222,    -1,   224,   225,   226,   227,   228,
     229,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   240,   241,   242,   243,   244,   245,   246,    -1,    -1,
     249,    -1,   251,   252,   253,    -1,   255,   256,   257,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,    -1,   292,    -1,   294,   295,   296,   297,    -1,
      -1,   300,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,   318,
      -1,   320,   321,   322,    -1,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,    -1,   341,    -1,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,    -1,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,    -1,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
      -1,   480,    -1,   482,   483,   484,   485,   486,   487,   488,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   511,   512,   513,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,   160,   161,
     162,    -1,    -1,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,   176,   177,    -1,   179,   180,   181,
     182,   183,    -1,   185,    -1,    -1,    -1,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
     212,   213,    -1,   215,   216,   217,   218,   219,   220,    -1,
     222,    -1,   224,   225,   226,   227,   228,   229,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,    -1,    -1,   249,    -1,   251,
     252,   253,    -1,   255,   256,   257,    -1,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,    -1,
     292,    -1,   294,   295,   296,   297,    -1,    -1,   300,   301,
     302,   303,   304,   305,    -1,   307,   308,   309,    -1,    -1,
     312,   313,   314,    -1,    -1,   317,   318,    -1,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,    -1,   341,
      -1,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
      -1,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
      -1,   453,    -1,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
      -1,    -1,   474,   475,   476,   477,   478,    -1,   480,    -1,
     482,   483,   484,   485,   486,   487,   488,    -1,    -1,   491,
      -1,    -1,   494,   495,   496,   497,   498,   499,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   511,
     512,   513,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    -1,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    -1,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,    -1,
      -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,    -1,   159,   160,   161,   162,    -1,    -1,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,    -1,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,    -1,
     185,    -1,    -1,    -1,   189,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,   212,   213,    -1,
     215,   216,   217,   218,   219,   220,    -1,   222,    -1,   224,
     225,   226,   227,   228,   229,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,    -1,    -1,   249,    -1,   251,   252,   253,    -1,
     255,   256,   257,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,    -1,   292,    -1,   294,
     295,   296,   297,    -1,    -1,   300,   301,   302,   303,   304,
     305,    -1,   307,   308,   309,    -1,    -1,   312,   313,   314,
      -1,    -1,   317,   318,    -1,   320,   321,   322,    -1,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,    -1,   341,    -1,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
      -1,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,    -1,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,    -1,   432,   433,    -1,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,    -1,   453,    -1,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,   474,
     475,   476,   477,   478,    -1,   480,    -1,   482,   483,   484,
     485,   486,   487,   488,    -1,    -1,   491,    -1,    -1,   494,
     495,   496,   497,   498,   499,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   511,   512,   513,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    -1,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
      -1,   159,   160,   161,   162,    -1,    -1,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,    -1,   185,    -1,    -1,
      -1,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,   212,   213,    -1,   215,   216,   217,
     218,   219,   220,    -1,   222,    -1,   224,   225,   226,   227,
     228,   229,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,    -1,
      -1,   249,    -1,   251,   252,   253,    -1,   255,   256,   257,
      -1,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,    -1,   292,    -1,   294,   295,   296,   297,
      -1,    -1,   300,   301,   302,   303,   304,   305,    -1,   307,
     308,   309,    -1,    -1,   312,   313,   314,    -1,    -1,   317,
     318,    -1,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,    -1,   341,    -1,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
      -1,    -1,   450,   451,    -1,   453,    -1,    -1,   456,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,    -1,    -1,   474,   475,   476,   477,
     478,    -1,   480,    -1,   482,   483,   484,   485,   486,   487,
     488,    -1,    -1,   491,    -1,    -1,   494,   495,   496,   497,
     498,   499,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   511,   512,   513,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    -1,    54,    -1,    -1,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    -1,    -1,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,    -1,    -1,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,   157,    -1,   159,   160,
     161,   162,    -1,    -1,   165,    -1,   167,   168,   169,    -1,
     171,    -1,   173,    -1,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,    -1,    -1,    -1,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,   212,   213,    -1,   215,   216,   217,   218,    -1,    -1,
      -1,    -1,    -1,   224,   225,   226,   227,   228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,    -1,    -1,   249,    -1,
     251,   252,   253,    -1,   255,   256,   257,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
      -1,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
      -1,   292,    -1,   294,   295,   296,   297,    -1,    -1,   300,
      -1,   302,   303,   304,   305,    -1,   307,   308,   309,    -1,
      -1,   312,   313,   314,    -1,    -1,   317,   318,    -1,   320,
     321,   322,    -1,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,   339,    -1,
     341,    -1,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,    -1,   403,   404,    -1,   406,   407,   408,   409,   410,
      -1,   412,    -1,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,    -1,    -1,    -1,    -1,   450,
     451,    -1,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,    -1,    -1,
      -1,   482,   483,   484,   485,   486,   487,   488,    -1,    -1,
     491,    -1,    -1,   494,   495,   496,   497,   498,   499,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     511,   512,   513
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    20,    31,    33,    34,    51,    61,    73,    75,    76,
      82,    84,    97,    99,   116,   119,   134,   136,   140,   147,
     157,   159,   166,   184,   201,   255,   256,   261,   276,   295,
     344,   359,   364,   365,   367,   372,   378,   381,   388,   395,
     396,   403,   407,   418,   435,   456,   468,   474,   479,   493,
     517,   519,   520,   521,   522,   523,   536,   543,   544,   545,
     546,   551,   552,   558,   559,   561,   562,   563,   564,   566,
     569,   581,   586,   587,   590,   591,   592,   612,   615,   616,
     631,   686,   689,   690,   693,   696,   697,   698,   706,   713,
     715,   716,   719,   722,   723,   727,   736,   740,   741,   742,
     745,   747,   748,   749,   750,   758,   760,   780,   784,   786,
     787,   797,   799,   805,   806,   809,   810,   811,   812,   813,
     822,   824,   826,   829,   833,   834,   844,   845,   850,   855,
     866,   898,   901,   902,   903,   908,   911,   913,   915,   917,
     918,   922,   923,   926,   928,   929,   933,   934,   935,   938,
     939,   940,   941,   942,   949,   951,   952,   953,   954,   960,
     962,   963,   969,   970,   971,   974,   975,   976,   977,   979,
     980,   982,   983,   985,   986,   988,  1000,  1002,  1005,  1007,
    1008,  1021,  1023,  1028,  1033,  1043,  1047,  1048,  1049,  1050,
    1051,  1052,  1058,  1094,   450,   496,   955,    28,    79,    96,
     114,   120,   138,   152,   161,   174,   180,   187,   207,   245,
     267,   312,   339,   349,   350,   353,   380,   383,   387,   390,
     397,   400,   420,   428,   433,   435,   438,   443,   453,   458,
     472,   485,   712,   955,     3,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    30,    31,    32,    40,    41,    42,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    58,    59,    60,    61,    62,    63,    64,
      67,    68,    69,    70,    71,    73,    74,    75,    76,    77,
      79,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    93,    94,    95,    96,    97,    98,   100,   101,
     102,   103,   107,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   121,   123,   124,   125,   126,   127,   128,   129,
     131,   132,   133,   134,   137,   138,   139,   140,   141,   143,
     144,   145,   146,   148,   149,   150,   151,   152,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   165,   167,
     168,   169,   170,   171,   173,   175,   176,   177,   179,   180,
     181,   182,   183,   185,   186,   188,   189,   190,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   203,   204,
     205,   206,   207,   208,   209,   210,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   222,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   249,
     250,   251,   252,   253,   255,   256,   257,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     294,   295,   296,   297,   299,   300,   301,   302,   303,   304,
     305,   307,   308,   309,   312,   313,   314,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   397,   398,   399,   400,   401,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   432,   433,   436,   437,   438,   439,
     440,   441,   442,   443,   445,   446,   447,   450,   451,   452,
     453,   454,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   467,   468,   469,   470,   471,   474,   475,   476,   477,
     478,   479,   480,   482,   483,   484,   485,   486,   487,   488,
     491,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,  1162,  1255,  1267,  1268,  1272,  1273,  1274,     3,    29,
    1044,  1252,  1267,  1272,   483,   536,   993,   310,   345,   955,
      54,   536,   623,    23,    41,    66,    79,   114,   120,   138,
     152,   161,   174,   183,   187,   257,   312,   315,   339,   353,
     380,   390,   400,   420,   428,   438,   440,   442,   443,   458,
     466,   469,   472,   632,   695,   802,   856,   867,    29,   344,
    1252,  1044,    29,   338,   398,   440,   442,     6,   244,   909,
     910,  1258,    23,    28,    66,    79,    96,   114,   138,   152,
     161,   174,   180,   187,   207,   267,   312,   325,   339,   350,
     353,   380,   383,   387,   390,   397,   400,   420,   428,   435,
     438,   443,   451,   453,   458,   472,   485,   712,   814,   816,
     817,   955,  1252,    99,   483,   536,   690,   693,   696,   988,
    1001,  1005,  1008,  1021,  1028,  1033,  1043,  1047,    11,    22,
      29,    49,   169,   176,   178,   202,   246,   284,   347,   366,
     527,   528,   830,   831,  1044,  1257,  1259,    29,    31,    99,
     362,   396,   835,   836,   837,  1267,   174,  1267,  1254,  1258,
     435,  1061,   830,  1267,   450,  1252,   325,   267,   536,   921,
     388,  1267,    29,   401,   446,   450,   573,   582,   583,  1267,
     184,   835,   836,  1267,   345,   955,  1267,   243,    29,   135,
    1063,  1064,    67,    93,   257,   278,   380,   390,   401,   446,
     450,   499,   570,   571,   572,   573,    29,   401,   446,   450,
     573,   450,   311,  1106,  1107,  1250,  1267,  1061,   529,  1267,
     179,   536,   994,   536,   360,  1053,  1054,  1252,  1053,     3,
      53,    55,    56,    69,    70,   117,   118,   139,   170,   219,
     220,   222,   229,   279,   281,   301,   358,   405,   411,   446,
     447,   480,  1135,  1137,  1139,  1141,  1143,  1145,  1146,  1147,
    1149,  1150,  1151,  1153,  1154,  1158,  1268,  1272,  1063,  1064,
    1065,  1263,    12,  1264,  1265,  1267,  1264,  1264,  1048,  1049,
    1052,     0,   539,   536,   993,   153,   221,   316,   465,  1066,
    1067,  1048,  1050,  1051,   125,   217,   269,   471,   540,    35,
     959,   883,  1255,   819,  1267,   819,  1252,   348,   819,   453,
    1252,   113,   435,   871,  1255,  1267,  1274,     3,   106,   110,
     402,  1260,  1261,  1269,  1272,  1273,  1274,    29,   196,  1250,
     302,   485,    10,    17,    18,    19,    74,   165,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   905,   907,  1193,
    1194,  1267,   196,  1252,   871,  1252,    29,  1260,  1261,   871,
    1252,  1252,   196,  1250,  1252,   196,   819,  1252,   372,   403,
      29,   196,  1106,  1252,   393,  1252,   819,    29,   264,  1260,
    1261,   196,  1250,   244,   122,   227,   293,   357,   956,   957,
     958,   536,   534,   538,  1219,  1221,   514,   987,   988,   989,
     990,  1269,  1250,  1252,  1267,    28,    66,    80,    92,   114,
     138,   180,   207,   245,   312,   350,   380,   383,   428,   438,
     451,   458,   814,   815,   816,   817,  1258,   959,  1004,  1008,
    1021,  1028,  1033,  1047,  1250,   271,   819,   536,   196,   819,
    1252,   819,   453,   196,  1252,   113,   435,   440,   442,  1260,
    1261,   440,   442,    74,   165,   905,   370,  1252,  1252,  1260,
     196,   547,  1267,   196,  1252,   196,   548,   819,  1252,  1252,
     393,   819,   264,  1260,   360,   397,   435,   485,   267,    96,
     207,    28,    92,   180,   350,   387,   451,   453,   457,   707,
      29,  1252,  1045,   580,  1258,  1269,   910,   271,   196,   883,
     884,   196,   914,   196,  1252,   196,   821,  1135,   453,   113,
     435,   196,   870,   871,   196,  1261,  1262,    87,   485,    74,
     165,   196,   906,   907,    59,   196,   870,   196,  1262,   196,
     870,   196,  1252,   196,  1252,   393,   914,   196,   821,   196,
     264,  1262,   244,   196,   818,   819,   196,  1251,  1252,   196,
    1252,   959,   536,  1006,   632,  1001,   479,   987,   993,  1259,
     831,   832,    29,   832,  1259,   832,    29,   832,  1259,   832,
     832,   832,  1259,  1257,  1257,  1044,   832,   348,   536,   433,
     536,   661,   661,   661,   310,   448,   540,   661,   390,  1106,
    1108,   540,   950,  1258,   536,  1003,    59,   485,   987,   114,
     207,   390,   433,   435,   919,   920,  1267,    48,   513,   227,
     538,   313,   310,   178,   313,  1258,   448,   959,   172,   827,
     310,     5,     8,     9,    10,    12,    37,    53,    55,    56,
      65,    66,    69,    70,    77,    79,   104,   105,   106,   107,
     108,   109,   110,   117,   118,   120,   158,   163,   164,   170,
     186,   188,   219,   220,   222,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   239,   250,   258,   259,   270,   279,
     281,   291,   293,   298,   299,   301,   312,   323,   340,   358,
     385,   402,   411,   429,   434,   446,   447,   452,   454,   455,
     466,   472,   480,   501,   502,   503,   504,   506,   507,   508,
     509,   515,   527,   528,   529,   536,  1048,  1138,  1141,  1144,
    1145,  1146,  1148,  1149,  1150,  1153,  1154,  1158,  1159,  1161,
    1162,  1163,  1165,  1189,  1190,  1191,  1195,  1213,  1218,  1244,
    1247,  1248,  1255,  1256,  1257,  1258,  1267,  1246,  1247,  1258,
      29,   588,  1249,  1250,   401,   570,   120,   579,  1258,   580,
    1258,    48,    71,   570,   513,   412,   957,   313,   178,   448,
     526,    48,   513,   227,   958,   536,  1250,   529,  1221,  1108,
     987,   177,   995,  1159,  1198,  1053,   540,   536,   996,   482,
    1152,  1152,  1152,   536,  1140,  1140,   342,   536,  1142,    69,
      70,  1152,  1140,  1137,   517,   518,   536,  1155,   536,  1155,
      37,  1136,   536,   115,   194,   272,   275,   394,   511,   536,
    1156,  1157,   538,   820,  1140,  1246,  1222,   537,   537,   545,
     987,   997,   998,   999,  1106,    29,   135,  1062,  1062,    59,
    1062,   166,   172,   254,   306,  1070,  1072,  1073,  1088,  1090,
    1091,  1092,  1066,  1067,   178,   223,   223,  1106,  1109,   536,
      68,   289,   326,   368,   403,   536,   881,   326,   364,   368,
     403,   820,   326,   368,   403,     3,    91,   145,   260,   326,
     364,   368,   403,   438,   441,   493,   581,   584,   964,   965,
     966,   967,   851,    25,   140,   326,   368,   403,   476,   597,
    1252,    25,   140,   403,   471,   565,   497,   196,  1106,    62,
      98,   162,   199,   249,   289,   293,   326,   327,   368,   377,
     386,   395,   403,   416,   425,   430,   488,   581,   585,   887,
     899,   927,   536,   868,  1221,   368,   565,   202,   158,    25,
      31,    46,    76,   133,   140,   144,   173,   209,   289,   293,
     304,   314,   326,   368,   371,   372,   403,   476,   593,   595,
     596,   730,   927,     5,   527,   528,   704,  1259,    29,   196,
    1250,   819,   819,   536,   904,   326,   403,   538,   158,   310,
     326,   368,   403,   899,   927,    25,   140,   326,   368,   403,
     202,   560,   368,   493,   517,   553,   560,   326,   368,   403,
     899,   927,   310,   326,   368,   158,    38,    60,   112,   205,
     263,   268,   273,   289,   325,   368,   373,   397,   403,   418,
     469,   593,   701,   702,   326,   368,   484,   730,   738,   158,
     326,   368,   403,    25,    91,   133,   140,   144,   326,   364,
     368,   403,   410,   583,   571,   573,   202,   158,    46,   131,
     289,   368,   403,   593,   594,   326,   368,   372,   403,    89,
     132,   329,   441,   310,    25,    31,   140,   326,   368,   403,
     613,   614,   560,   172,   368,   553,   560,   158,   368,   403,
     593,  1252,   252,   122,   311,   498,   540,   956,    29,   135,
     481,   529,   537,   876,  1159,  1199,  1200,  1268,  1159,  1220,
       3,    29,    33,    34,    35,    36,    37,    38,    39,    43,
      57,    65,    66,    72,    78,    80,    92,    99,   104,   105,
     106,   108,   109,   110,   120,   122,   130,   135,   136,   142,
     147,   153,   164,   166,   172,   174,   178,   184,   187,   191,
     202,   211,   221,   223,   247,   248,   254,   258,   259,   293,
     298,   306,   310,   311,   315,   316,   336,   346,   362,   376,
     396,   402,   413,   431,   434,   435,   444,   448,   449,   455,
     465,   466,   472,   473,   481,   489,   490,   492,   493,   529,
    1253,  1270,  1272,  1273,  1274,  1275,  1219,   537,   540,   164,
     310,   455,   577,   580,   704,   991,   473,   984,   310,   883,
     536,   819,  1252,  1135,   871,   302,    74,   165,   907,   871,
     871,   172,  1135,   819,  1252,  1252,   537,   661,  1252,    72,
    1135,   293,   178,   536,   788,   553,    38,   978,  1252,   293,
     553,   497,   196,  1250,   553,   819,   819,   788,   469,   632,
     310,   172,   493,   895,   553,   293,    48,   567,   293,   458,
     737,   293,   996,    91,   326,   714,    89,   132,   329,   441,
      38,   788,   172,   196,   553,   485,   196,  1250,   196,   691,
    1250,  1250,   485,   819,    87,   549,  1255,   453,  1255,  1255,
    1252,   172,  1252,   712,    40,    54,   111,   216,   289,   392,
     158,    63,   374,   540,   550,   158,   536,   158,   553,   158,
     540,   550,   497,   158,   540,   550,   158,   540,   196,   818,
     196,   819,   196,   819,   158,   540,   550,  1262,   158,   550,
     158,   158,   550,   158,   550,   158,    89,   132,   329,   441,
     172,   158,   550,   158,   172,   196,   158,   540,   550,   158,
     540,   550,   158,   310,  1198,   435,   537,  1001,   832,  1044,
     832,  1044,   832,  1044,   832,  1044,   832,  1044,  1044,  1044,
     832,  1044,   536,   662,   665,  1267,   662,    29,   114,   138,
     174,   180,   244,   245,   328,   350,   383,   390,   397,   435,
     438,   458,   840,  1249,  1262,   837,  1252,   202,   540,  1024,
    1258,  1135,  1202,    38,  1262,   549,   537,   549,   549,   549,
     252,  1267,   172,   840,  1262,   172,   388,  1267,   580,   310,
     536,  1222,   534,  1048,  1203,  1159,  1217,   536,   536,   172,
     536,   536,  1048,   536,   536,   536,   536,   536,   536,   536,
     536,   536,   536,   536,   536,   536,   536,   536,   536,   536,
     536,  1159,   536,   536,   536,   536,   536,   536,   536,   536,
     300,   648,   536,   536,   536,   536,   536,   536,   536,   536,
    1159,  1159,  1159,  1048,  1159,  1198,  1221,  1258,   536,  1258,
       3,    10,    13,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   168,   169,   170,   171,
     173,   174,   175,   176,   177,   179,   180,   181,   182,   183,
     185,   186,   188,   189,   190,   192,   193,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   222,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   273,   274,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   307,   308,   309,   311,   312,   313,   314,
     315,   317,   318,   319,   320,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   483,
     484,   485,   486,   487,   488,   489,   491,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   512,   513,   515,   524,   525,   526,   527,   528,
     529,   530,   531,   532,  1193,  1195,  1197,  1271,  1276,   494,
    1176,   322,  1159,   167,  1177,   223,   540,  1059,   536,  1258,
    1221,  1059,   123,   198,   589,   540,    71,   120,   580,    38,
       3,   120,   257,   578,   704,  1154,  1258,  1258,    94,   137,
    1171,   103,   120,   574,   575,   577,   704,   120,   574,   252,
    1250,    95,   373,   823,   537,   993,    35,    45,    52,    78,
     197,   202,   225,   253,   312,   315,   408,   537,   540,  1054,
    1251,    38,   536,  1198,  1257,  1152,  1152,    37,  1136,   446,
     446,  1257,  1257,   534,   534,  1257,   448,   448,   448,   536,
     448,  1257,  1253,   538,  1140,   178,  1095,    15,   526,  1219,
    1266,   537,   540,   996,  1050,  1050,  1068,  1069,  1159,  1050,
     169,   284,  1079,   241,   289,   357,   406,   471,    29,  1074,
    1159,   527,   528,  1075,  1076,  1159,  1161,  1088,  1089,  1073,
    1072,  1070,  1071,   172,  1091,   304,  1093,  1070,  1088,  1109,
    1009,  1250,  1109,    38,  1267,   403,  1198,    68,   448,   448,
     390,   202,   214,   316,   319,   405,   481,   529,   874,   875,
     876,   878,   880,   882,  1135,  1268,   448,   484,   448,   390,
     448,   448,   390,   254,   448,    79,   448,   438,   570,   326,
     964,   966,   526,   968,   172,   184,   202,   378,   852,   853,
      72,    92,   293,   657,   658,    92,   120,   293,   448,    92,
     448,   120,   293,   390,    92,   133,   144,   326,   368,   785,
     390,   720,    28,    66,   138,   180,   312,   350,   383,   451,
     458,   814,   815,  1252,   158,   368,   403,   593,   310,   704,
     395,   249,   448,  1267,   448,   298,   704,   124,   224,   390,
     401,   450,   572,   819,   374,   403,   887,   900,   128,   537,
     869,   874,   448,   472,   438,  1250,    72,    80,    92,   154,
     174,   196,   293,   346,   466,   639,   655,   656,  1267,    80,
      92,   924,   331,   310,   385,   387,   453,    92,   924,    32,
     371,   385,   387,   453,   385,  1250,   173,   209,   304,   819,
     536,   448,   448,   195,   536,   601,    23,   263,   438,   469,
     495,   601,    92,   540,   128,     5,     5,   326,   202,   158,
     368,   403,   593,   927,   473,   473,   290,  1135,   448,   390,
     536,   905,  1252,  1250,   448,   448,   390,   900,   128,   107,
     435,   436,   936,   937,  1107,  1250,  1267,   937,   448,   448,
     788,   937,   114,   403,   584,   448,   555,   584,   448,   448,
     390,   900,   128,  1250,   448,   448,  1250,  1137,   704,    59,
     703,   704,   704,   112,   268,   273,    59,   448,   553,   277,
     390,   553,   289,   702,   448,   448,   298,  1258,   730,   819,
     448,   448,   390,   420,   353,  1258,   353,   448,   353,   448,
     353,   788,   788,   438,  1106,   331,   331,    92,   448,   924,
     390,   448,   448,   601,   601,   819,   819,   819,   819,  1250,
      47,   478,    47,    47,   478,   448,    47,   448,   478,   390,
     536,   540,   584,   472,   746,  1261,   448,   555,   584,  1250,
     448,   924,   390,   326,   368,   357,   369,   399,   576,   956,
    1199,  1199,  1200,   537,    15,    16,   540,  1066,  1067,   535,
     541,  1250,   989,  1252,  1250,   225,  1135,   225,   310,   225,
     225,   704,   819,   819,   225,   225,   225,  1135,   225,   225,
     225,   310,   448,   178,   448,   617,   458,   536,    38,   158,
     819,   789,   790,  1270,   964,  1135,   310,   158,   717,  1252,
     293,   331,   536,   554,   802,   473,   360,   485,  1250,    29,
     937,   788,   554,   158,  1261,    99,   184,   568,   631,   697,
     760,   833,   855,   960,   158,  1258,   738,   739,   158,   310,
    1258,  1261,   260,   819,   819,   819,   819,   149,   356,   536,
     746,   293,   554,  1250,   293,   699,   701,   293,    38,   304,
     331,   536,   661,   661,   196,   694,  1250,   172,   196,   547,
    1267,   536,   792,   881,  1252,   536,   872,   872,    38,  1135,
      27,    50,   218,   761,   244,   493,   495,  1046,   392,   884,
     883,  1135,  1252,   536,   821,  1135,   870,   871,  1262,  1261,
     158,   550,   158,   473,   158,   473,   906,   907,   550,   870,
    1262,   870,  1252,  1252,  1135,   821,  1262,   746,   158,   818,
     819,  1251,  1252,  1252,   819,   537,   196,  1250,  1001,  1044,
    1044,  1044,  1044,  1044,  1044,   662,   537,   540,   537,   181,
     351,   384,   398,   436,  1251,   818,   113,   400,   870,  1251,
     302,   838,   839,  1267,   870,   870,  1251,  1249,  1249,  1251,
     818,   448,   185,   493,   849,   153,   254,   743,   744,    23,
     156,   385,   406,  1025,  1106,   297,  1026,   537,   540,  1004,
     448,  1250,  1252,  1250,   547,   835,   836,   178,   849,   836,
    1267,    28,    80,   138,   180,   245,   350,   383,   458,   814,
     815,  1198,   535,  1198,  1203,  1204,   489,  1214,  1215,  1159,
    1198,   536,  1257,  1257,     3,   115,   194,   272,   275,   394,
     511,  1205,  1206,  1258,  1198,  1198,  1159,  1232,   376,  1048,
    1049,  1232,  1236,  1243,  1232,  1232,  1159,  1161,  1199,  1236,
    1239,  1240,  1159,  1240,  1232,  1159,  1232,  1232,  1198,  1257,
    1257,   537,  1159,  1159,   905,  1159,  1199,  1201,  1208,   385,
     527,   528,   536,  1160,  1161,  1195,  1209,   537,  1198,  1159,
    1201,  1210,  1159,    57,   178,   248,   449,  1159,  1198,  1211,
     135,   293,  1048,  1198,   277,  1161,  1159,  1169,  1170,  1171,
     277,  1159,  1171,   537,   540,  1257,  1156,  1135,  1159,  1159,
    1159,  1159,  1270,   257,   446,    43,   431,  1223,   819,  1159,
     536,  1048,  1212,   135,   137,   164,   229,   285,   286,   287,
     288,   292,   293,   298,   455,   467,  1207,  1237,  1159,   536,
    1159,   448,    52,   197,   202,   253,   408,  1159,  1159,  1159,
    1159,  1159,  1159,  1159,  1159,  1159,  1159,    29,    36,   413,
    1192,   187,  1177,   385,   536,  1189,   536,   321,  1181,   183,
     257,   435,   440,   442,   469,  1060,  1250,  1248,  1095,  1199,
    1095,  1250,   450,   536,  1258,   540,   537,   195,   195,   550,
     999,   988,   992,  1159,   537,   267,   293,  1055,  1198,   537,
     537,   534,   513,   513,   537,   537,  1257,   535,  1257,   537,
     194,   272,  1157,   272,  1157,  1157,  1257,   275,   537,  1253,
     229,   238,   247,   386,   510,   536,  1048,  1096,  1097,  1098,
    1106,  1112,  1122,  1129,  1162,  1164,  1165,  1244,  1267,   490,
    1117,  1263,   999,   997,   540,    39,   130,   473,   864,   385,
     386,   527,   528,  1076,  1078,  1161,   406,   241,   311,   540,
       5,  1077,  1257,  1077,   385,   386,  1078,  1249,   297,   410,
    1027,  1089,  1071,   473,  1022,   120,   324,   536,  1010,  1047,
      38,   473,  1267,   536,  1029,  1030,  1031,  1267,   537,  1261,
    1252,  1252,   319,    59,  1268,   537,   876,   878,   875,   878,
    1268,   316,   537,   540,   820,  1261,  1252,  1252,  1261,  1252,
    1252,  1261,   484,  1252,  1252,   120,   577,   704,   380,   472,
     835,   390,   184,   835,   536,  1252,   298,   196,  1252,   298,
    1261,  1252,  1252,  1159,   298,  1252,  1252,    32,   371,   448,
     448,  1252,   448,   721,   883,   536,  1135,   871,    74,   165,
     907,   871,   871,   172,  1135,   819,  1252,   190,   289,   326,
     368,   477,   724,   725,   726,  1106,   448,   924,   390,   298,
     124,   224,  1261,  1252,   310,  1252,   310,   537,   540,  1260,
    1262,  1252,   368,   593,   536,   196,   639,  1252,   473,   857,
     241,   293,   298,   241,   473,   648,   685,  1135,  1252,  1257,
    1267,  1250,  1252,   252,  1252,    29,   472,  1252,   196,  1252,
     196,  1267,   387,   453,   387,   453,   252,  1252,    29,   472,
    1252,   252,   385,  1250,    25,   140,   403,   731,   732,   733,
     734,  1270,  1261,  1252,   120,   179,   294,   473,   600,   603,
     604,  1270,   271,  1252,    76,   307,  1252,   596,   310,   448,
     438,  1250,   448,   924,   390,   128,  1252,  1252,   540,   537,
     540,  1261,  1252,   930,   931,  1270,   310,   368,   448,   754,
    1261,  1252,  1252,   310,  1106,   202,   540,   661,   661,  1221,
    1261,  1252,  1252,  1260,     3,    91,   146,   209,   333,   464,
     472,   475,   556,  1261,  1252,  1252,   310,   368,  1261,  1252,
     368,   403,   593,   701,   704,   819,  1252,   704,   819,  1252,
     704,  1261,  1252,   403,  1261,  1252,  1252,   120,   607,  1259,
    1251,  1251,  1261,   895,  1252,  1251,  1252,   368,   403,   593,
     594,  1250,  1250,  1252,  1252,  1252,  1252,  1261,  1252,    25,
      31,   140,   326,   368,   403,   326,   368,   403,   788,   368,
     403,   368,   403,   368,   927,  1121,  1267,   196,   798,  1267,
     196,  1267,  1258,  1261,  1252,  1252,  1258,  1252,   930,    25,
     140,   614,   400,  1260,   368,   403,   593,  1252,  1252,  1252,
     448,   448,    85,   463,   357,   540,  1066,  1066,  1066,  1159,
    1159,   481,  1200,   537,  1159,  1220,   984,   298,   825,  1258,
      38,   825,   138,   819,   825,   825,   225,   473,   473,   825,
     825,   825,   244,   825,   825,   825,   819,   352,   618,   618,
     207,   435,   759,  1159,  1135,   819,   537,   540,   526,   645,
    1270,  1252,    63,   178,   390,   484,   718,   725,   726,   158,
     304,   253,   633,   635,   637,   639,   652,   655,    26,   202,
     380,   432,   556,   557,   172,  1252,   485,  1250,    38,   755,
     436,   895,   547,  1267,   567,   632,   867,  1252,   174,   819,
     536,   687,   688,  1164,  1267,   353,  1258,   788,   788,   788,
     788,   536,   788,  1119,  1120,  1121,   400,   158,   536,   158,
     158,   157,  1047,   819,   304,   633,  1267,   473,   680,   493,
     602,   293,    38,   661,  1258,   293,   310,     3,   793,   794,
     788,    27,   537,   873,   874,   879,    38,   244,   377,   451,
     492,   885,   886,   887,   888,   885,   310,   244,   304,   125,
     217,   456,   471,   762,   763,  1252,   193,   193,   172,   550,
      38,   553,   173,   972,   973,   550,   550,   818,   819,  1252,
     819,  1252,   550,   550,   550,   550,   244,   550,   400,   172,
     550,   550,   310,   550,   293,   537,   665,   202,   202,   202,
     202,   202,   497,  1251,   704,   705,   540,   538,   187,   841,
     842,  1261,    59,   846,   847,  1270,   448,   536,   178,   156,
     406,   156,   406,   385,   471,   274,  1135,  1261,   493,   692,
     310,   841,   550,   178,   883,   819,  1135,   871,   302,   871,
     871,  1135,   819,  1252,   537,   535,   535,   540,  1159,   142,
    1215,  1216,    38,   537,  1159,   537,   537,   537,   178,   537,
     537,   514,  1233,  1234,   493,   495,  1238,  1135,  1234,   537,
      21,   298,   540,  1242,   316,  1245,   540,   541,   478,   537,
     537,    21,   298,   540,  1241,  1241,   540,   537,  1236,   540,
     537,   537,   537,   537,   540,   540,   537,   336,   537,   537,
     536,  1160,  1160,  1198,    13,    17,    18,    19,   202,   225,
     312,   524,   525,   526,   527,   528,   529,   530,   531,   532,
    1195,  1160,   537,   537,   172,   178,   408,   537,   537,    38,
    1211,  1198,  1211,  1211,   178,   537,   135,   537,  1270,   332,
    1174,    38,   537,   540,  1159,  1270,   540,  1159,  1222,  1159,
     537,   513,  1160,  1160,   151,  1198,   178,    37,   302,   389,
     478,   135,   137,   164,   292,   298,   455,   467,  1207,  1237,
     292,  1238,   151,   905,  1159,   431,  1223,  1159,  1212,  1159,
     448,   536,  1048,   536,  1181,   536,  1198,   490,   536,  1182,
    1267,   440,   442,   440,   442,  1250,  1061,  1061,  1061,  1117,
    1066,  1117,   957,  1257,  1156,   575,   999,   267,   536,   537,
    1257,  1155,  1155,   535,   535,   537,   536,  1048,  1112,  1122,
    1129,   178,   536,  1048,  1097,  1098,    38,  1099,  1100,  1267,
     540,   100,   179,   213,   228,   251,   280,   379,  1103,  1100,
      38,  1099,  1102,  1267,  1100,  1100,   517,  1116,  1221,  1159,
     187,  1080,  1069,   312,  1193,  1196,   516,   865,     5,  1257,
    1078,   311,   493,   471,  1075,   262,  1096,   490,  1118,   479,
     433,   472,  1011,  1012,  1013,  1267,   310,  1014,  1267,  1097,
    1031,  1032,   540,  1095,   526,  1222,   882,   820,   878,   878,
      59,   880,   531,  1262,  1262,   310,  1251,   313,   310,  1159,
     658,   778,   158,   550,   448,  1261,  1252,   580,  1135,   819,
     819,  1135,   708,  1252,   190,   477,   448,   448,   708,   724,
     730,   368,   403,   593,  1252,  1252,  1252,   215,   298,   161,
     874,   325,   403,   448,  1159,   293,   154,   656,  1252,   536,
     536,   158,  1267,   536,   685,   207,   536,   778,   423,   643,
     644,   209,   778,   403,    25,   140,   372,   373,   403,   597,
     605,   606,   730,   925,   395,   158,   550,   158,   550,  1252,
    1252,  1252,  1252,   395,   395,   252,   733,   734,   733,   537,
     540,   735,  1258,   207,   537,   540,   526,   538,   120,   608,
    1267,   161,  1261,  1252,   368,   403,   593,  1252,  1252,  1252,
     310,   326,   368,   403,    25,   140,   326,   368,   403,  1135,
     290,  1135,   537,   540,   526,  1250,   448,  1262,   473,   751,
     161,   661,   390,   936,   490,   670,   670,   661,   254,   333,
     298,  1258,   333,  1262,   470,   161,   448,   448,   390,   420,
     895,   895,   895,   325,   403,    92,   448,   924,   390,   120,
     172,   609,   168,   549,   448,   448,   264,   264,   264,   448,
     448,   390,   448,   448,   390,   448,   390,   448,   390,   448,
     128,   550,  1135,   293,  1258,   403,   925,   158,   550,   448,
     448,   537,  1252,   448,   924,   390,   448,  1261,  1252,   537,
     537,   537,  1200,   535,  1135,   819,   225,   825,  1252,  1252,
    1252,   225,   421,   422,   619,  1258,   619,   190,   537,   537,
     178,   788,   790,   290,   312,   527,   528,   704,   791,   878,
    1196,  1258,  1275,    72,    78,    92,   120,   122,   148,   182,
     211,   293,   298,   346,   362,   466,   646,   647,   651,   157,
     489,   553,   580,  1252,   580,   314,   728,  1250,  1250,  1250,
     537,   540,  1262,   187,   380,  1262,  1257,   458,  1250,   661,
       3,   172,   756,   895,    48,   567,   435,   737,   113,   996,
    1159,   178,   540,  1251,   602,   795,   796,  1258,   537,   540,
    1252,   172,   662,  1250,   691,  1250,  1252,   692,   536,   634,
    1250,   537,  1252,   493,   495,   681,   601,    38,   158,  1047,
     680,   448,   158,  1106,   526,   537,   540,   762,   537,   540,
     120,   526,   889,  1258,   580,   435,   877,   878,   172,   894,
      51,   375,   890,   891,   888,   891,   125,   217,   396,   471,
     947,  1252,   304,   310,   315,   190,  1047,  1135,   536,   537,
     540,   550,   473,   550,   473,   550,  1252,  1252,   746,   819,
     158,   390,   390,   390,   390,   390,  1251,   540,   839,  1267,
    1261,   493,   540,   843,  1261,   540,   849,   164,   313,   455,
     848,  1108,   400,   156,   156,   113,   289,   840,   849,  1262,
     225,   225,   225,   225,   704,   225,   225,   225,   225,   225,
    1203,   444,  1159,   147,  1135,   537,  1159,   229,   466,   466,
     537,  1234,  1236,   310,   310,  1232,  1236,    59,  1242,  1159,
    1232,  1232,   310,   310,  1240,  1238,  1238,  1159,   537,  1159,
    1207,  1159,  1159,   537,  1198,   540,  1135,  1160,  1160,  1160,
    1160,   135,   137,   293,  1160,  1160,  1160,  1160,  1160,  1160,
    1160,  1160,  1160,  1160,  1159,  1159,  1159,  1135,   537,   537,
     537,  1198,   537,   540,    59,  1161,  1175,   537,  1270,  1170,
     343,   427,  1173,   537,   540,   484,  1166,    38,   537,  1258,
    1159,    35,    35,  1159,   537,  1159,   178,   292,  1238,  1159,
     537,   151,  1160,  1160,   151,   151,  1159,  1159,  1067,   537,
    1198,   540,  1159,  1183,  1267,  1061,  1061,  1061,  1061,  1250,
    1250,  1250,  1080,   537,  1080,   537,  1004,   535,  1232,  1100,
    1102,  1100,  1100,   536,   505,  1161,   537,  1267,   536,  1097,
     228,   320,  1104,  1097,  1104,   228,  1103,  1104,   228,   437,
    1110,   536,  1267,   536,   317,    59,   191,  1087,   536,   865,
     169,   246,   311,   493,   445,   103,  1159,   376,  1016,   478,
     537,   540,  1222,    90,  1016,   310,   537,   540,  1030,  1118,
    1159,   537,   531,   882,   458,   181,   245,   384,   391,   398,
     436,   459,   854,   172,   854,   537,   122,   148,   211,   289,
     293,   779,  1252,  1252,    38,   473,   473,   244,   820,  1261,
    1252,   448,   924,   390,   448,   215,  1252,    59,   438,  1252,
     537,   158,   536,   668,   669,   860,  1164,  1267,   662,   639,
     778,   662,   778,  1252,   662,   120,  1267,    86,   641,   642,
     420,   182,   160,   195,   293,   601,   553,   113,   160,   182,
     293,   420,   601,   641,   643,   702,   403,   606,   458,  1252,
    1267,   395,   732,  1252,   604,   791,  1270,  1252,   325,   403,
     448,   924,   390,   448,   161,   448,   448,   390,   180,   312,
     423,   800,   801,   180,   312,   807,   808,   448,   448,   390,
     537,   537,   537,   931,   290,   704,   878,   932,  1196,  1258,
    1275,   368,  1252,   536,   493,   752,  1252,   670,   107,  1267,
     536,   670,  1259,  1258,  1258,  1258,  1252,  1252,  1252,  1252,
     607,    59,   438,  1252,  1252,  1252,  1252,   479,  1252,  1252,
     172,   172,   370,   172,   196,  1261,  1252,  1252,  1261,  1252,
    1252,  1252,  1252,  1252,  1252,  1252,   310,    78,   598,   158,
      27,    50,   458,  1267,  1252,  1258,   730,  1252,  1252,  1252,
    1252,  1066,   537,   225,   825,   225,   225,   225,   825,   553,
     473,   624,   625,   708,   778,   493,   495,   819,   536,   819,
    1252,  1160,    32,    59,   649,   123,   198,   122,   148,   298,
     241,  1250,   648,   180,   350,   774,   781,   782,  1267,   717,
     536,   331,   536,   634,   653,   210,   675,   637,  1262,  1262,
    1135,   536,   602,    29,   125,   217,   396,   471,   757,   448,
     753,  1261,   196,  1250,   739,   497,   310,   537,  1096,   688,
     895,   537,   540,  1121,   728,   746,   537,   699,    38,   304,
     331,   536,  1006,   636,   638,   640,   655,  1267,   331,   676,
     677,   634,   675,   601,   307,   310,   682,  1047,   694,   692,
     602,  1258,  1252,   857,   791,     3,   794,   310,   879,  1159,
    1159,   540,   536,   885,   458,   540,    44,  1159,   448,   536,
     662,  1250,   763,   708,   537,   972,   973,  1252,  1252,   550,
     400,   550,  1251,  1251,  1251,  1251,  1251,   704,   184,   842,
     849,   847,   537,  1252,   113,   178,   550,   849,   298,   828,
    1258,   828,   828,   828,   225,   828,   828,   828,   828,   828,
    1159,   537,   145,   242,   242,   537,   298,   298,   537,  1068,
    1236,   332,  1224,   298,   298,  1236,  1236,  1224,  1224,   537,
     537,   178,   537,  1159,   178,   135,   137,   178,   172,   151,
     537,   500,  1168,  1198,   361,   478,    59,  1175,  1161,   491,
     491,   537,  1159,   289,  1159,   540,  1167,  1137,  1159,  1159,
    1159,  1159,    35,    35,  1159,  1159,   151,   537,   537,   537,
    1159,   537,   331,  1184,  1250,  1250,  1250,  1250,  1087,  1258,
    1087,  1258,   537,   540,  1113,  1114,  1164,   536,  1174,  1099,
     536,  1251,  1097,   310,   473,  1105,  1097,   228,  1097,  1255,
    1120,   536,  1120,  1267,  1062,  1159,   492,  1178,   905,   445,
     304,   493,  1017,  1047,   324,  1047,  1013,   310,   536,  1015,
    1159,   526,  1031,  1016,   458,   537,   303,   448,   835,   178,
     778,   123,   198,   209,   122,   148,   475,   550,  1135,  1252,
    1252,  1252,  1252,  1252,  1252,  1252,  1262,  1252,   778,   639,
    1159,   537,   540,   493,    78,   859,   863,   859,   540,   663,
     495,   660,   660,   120,  1267,   728,   607,   649,   196,   196,
     298,   704,    38,   649,   298,   607,  1135,   550,   550,   526,
      59,   438,  1252,  1252,  1252,  1252,  1252,  1261,  1252,  1252,
    1257,  1257,  1135,   540,  1257,  1257,   540,  1261,  1252,  1252,
     448,  1159,    72,  1159,  1262,  1252,   448,   448,   178,   202,
     493,  1251,  1251,   819,  1251,   158,   161,   819,  1258,  1258,
    1135,   550,   550,   448,   537,   225,   825,   825,   825,   825,
     536,   620,   621,   553,   127,   180,   214,   180,  1159,   293,
     647,   120,    38,   289,   659,   895,   661,   895,  1255,    35,
     157,   202,   729,   733,   304,   633,   609,   155,   204,   536,
     400,   473,   662,    38,  1262,   751,   567,   293,   536,   174,
    1252,   687,  1258,   400,   602,   157,  1047,   819,   304,   633,
     692,   537,   540,   493,   645,    59,   680,   609,   676,    84,
     438,   683,   493,   961,    38,   683,   178,   310,   536,  1250,
    1258,   876,   896,   897,  1268,   891,  1135,   172,   892,  1250,
     178,   448,   916,   363,   764,   212,   709,   550,   537,   550,
     550,  1252,   313,   223,   841,   550,   828,  1252,   537,  1225,
    1226,  1232,   120,   143,   150,   164,   298,   455,   467,  1228,
    1229,  1231,   537,   537,  1236,  1236,  1159,   537,  1160,   178,
    1159,  1159,  1159,   536,   537,   540,   537,  1175,   537,   478,
     417,   537,   206,   289,  1172,  1159,  1159,  1159,   537,    59,
    1066,  1178,  1178,   393,  1056,  1159,   537,   540,    38,  1115,
     120,  1127,  1128,  1160,    81,  1251,   537,  1159,   536,  1097,
    1105,   536,   537,  1120,   537,   102,   188,   382,   536,  1081,
    1082,  1083,  1084,  1085,  1086,  1159,  1179,  1180,  1267,  1066,
     537,  1044,   536,  1247,  1011,    92,   858,   860,   136,   489,
    1034,  1035,  1036,  1037,  1159,   841,   310,   841,   537,   448,
     403,  1026,   537,   203,   666,   669,   312,   905,   819,   548,
     819,   335,   537,   322,   537,   537,   645,    38,   158,   158,
     536,   598,   791,  1262,  1252,   448,   536,   871,   905,   907,
     801,   536,   536,   808,  1252,   537,   536,   537,   403,  1026,
    1252,  1252,   536,   536,   536,   493,   517,   981,   370,   981,
     981,   172,  1252,   598,  1252,   825,   626,   627,  1270,    54,
     101,   126,   145,   151,   173,   177,   192,   298,   354,   622,
     620,  1258,   871,    38,   912,   912,   537,   195,   536,   209,
     473,   684,   265,   667,   684,   536,   782,   774,   536,   537,
     540,  1250,   537,   400,    29,    83,    86,    93,   121,   182,
     195,   208,   420,   423,   654,   654,  1249,  1252,  1252,   537,
    1047,   752,   158,   113,   728,   178,  1252,    38,  1252,   692,
     634,  1250,   537,   638,   314,  1267,   681,   676,   680,   125,
     140,   343,  1252,    64,    72,   257,  1047,   819,  1106,   858,
     178,   777,   878,   537,   540,   458,   147,   546,   890,   893,
    1117,   415,   415,   537,   283,   308,   765,   766,   767,   172,
     770,   708,   289,   477,   710,   711,  1252,   849,   540,    38,
    1159,    37,   302,   310,   537,   493,   495,  1227,  1228,  1230,
     172,  1160,  1169,  1198,   289,   512,   206,   537,  1198,   189,
     356,   386,  1185,    58,   129,   112,  1057,    38,  1130,  1116,
    1113,   536,  1160,   537,   540,    38,  1123,  1124,  1267,   537,
    1251,  1198,   537,   536,   404,   536,   537,   540,   540,    38,
    1071,   283,   308,  1018,  1019,  1020,   478,  1252,   537,   540,
     294,   471,   266,   293,  1016,  1035,    35,  1038,  1038,   843,
     854,   550,  1252,   438,   859,   536,   895,   536,   864,   601,
     665,   362,   666,   666,   195,  1159,   473,   599,   403,  1026,
    1252,  1202,   172,   804,   804,  1202,  1202,  1159,   438,  1198,
    1198,   610,   611,  1269,   818,   819,   818,   819,  1251,   550,
     537,   540,   120,   529,   536,   577,   628,   704,   978,  1258,
     978,   293,   298,   354,   978,   978,  1117,   912,    42,   200,
     659,   536,   700,  1159,   207,   179,   330,   409,   310,   671,
     672,   673,   537,  1255,     6,   783,   733,   634,   675,  1252,
     537,   728,   165,   803,   602,   961,  1250,   497,  1096,   728,
    1047,  1006,   676,   634,   675,   645,   536,   682,   680,   681,
     386,   386,    72,   313,    72,   692,   857,   537,  1250,   778,
     885,   896,  1135,   539,   136,   493,   493,   766,   385,   435,
     768,   141,   771,   489,   773,   477,   708,   728,   550,  1226,
    1270,   150,    37,    88,   462,   497,    37,   497,   240,   309,
    1235,   310,   537,  1159,   537,   537,   478,    52,   103,   461,
    1159,  1186,  1187,  1186,  1186,   537,   169,   169,   662,  1252,
    1224,  1120,   540,  1128,  1270,   537,   540,   172,  1135,   537,
     537,  1198,   536,  1198,  1082,  1180,  1182,  1089,   537,   540,
      38,  1047,  1117,   860,   403,   266,  1159,   444,   444,   178,
    1252,   662,   684,   905,   865,   864,  1250,   895,   895,   700,
     537,  1159,   438,   537,   316,   393,   537,   537,   537,  1252,
     537,   537,   537,   540,  1257,   981,   627,   577,   629,   630,
    1258,  1258,   298,   529,   662,   529,   662,  1258,  1258,   701,
     537,   438,   125,   471,   310,   673,   310,   672,   536,   537,
     540,   609,   400,   728,   819,    38,    38,   536,  1252,   961,
     692,   680,   609,   676,   536,   678,   679,  1164,  1267,   683,
     681,   682,   313,   313,   536,   203,   861,   172,   891,    30,
     218,   948,   180,   180,   978,   385,   419,   772,   536,   157,
     497,    37,   497,    37,   497,   497,   355,   355,  1230,   143,
     150,  1187,   385,   171,   341,   171,   341,   154,  1188,  1188,
    1188,    59,    59,   403,    81,   537,  1161,  1124,   317,     3,
     120,   293,   298,   334,  1125,  1126,    38,  1101,   369,  1111,
     537,  1081,   537,  1019,  1267,  1029,    59,   125,   136,   471,
    1039,  1040,   136,   217,  1041,   841,  1026,   537,   670,   537,
     865,   536,   664,   684,   684,  1252,   871,    59,  1026,   448,
     610,   819,   537,   540,   529,   662,   537,   424,   487,   650,
    1252,    63,   289,   374,   403,   674,   674,   537,     6,   400,
    1252,   800,  1047,   728,   681,   676,   680,  1159,   537,   540,
     863,   863,   682,   683,   858,   536,   648,   141,   294,   536,
     943,   945,   949,  1008,  1021,  1028,  1047,  1058,   871,   871,
     769,  1267,  1159,   774,   497,   497,   310,   310,   537,  1228,
      35,   103,   187,   289,   445,   662,   662,  1267,   536,  1174,
    1160,  1160,   298,  1160,  1126,  1267,   536,   537,  1117,   414,
     439,   294,   403,   294,   120,   324,   479,   536,  1042,   550,
     778,   662,   667,   778,   778,  1026,   819,   536,   630,    24,
     120,   298,  1252,   728,   961,   682,   680,   681,   537,   679,
     548,   548,   683,   537,   860,   862,   602,   385,   944,   945,
     946,  1048,  1049,   540,   540,   537,  1255,   389,   389,   310,
    1187,   385,   318,   403,   403,   448,   473,   282,  1131,  1132,
    1267,    81,  1159,  1029,   479,  1011,   536,  1012,   663,   671,
    1198,   661,   661,   728,   683,   681,   682,   863,   861,   537,
     540,   683,   773,   537,   539,   448,   178,   536,   426,   426,
     150,  1267,  1267,   229,  1255,  1256,  1267,   334,  1133,   537,
     540,   172,  1135,  1123,   537,   478,  1198,   537,   537,   778,
     537,   682,   683,   548,   648,   860,  1117,   157,   946,   415,
     415,     5,   775,   776,  1257,  1258,  1270,   536,   120,  1258,
    1231,  1132,   317,   158,   334,  1134,  1233,   537,  1042,   537,
     324,  1042,   683,   602,   774,   493,   493,   537,   540,  1199,
    1256,    38,    81,   537,  1134,  1258,  1227,  1134,  1011,   683,
    1255,   180,   180,   776,  1066,   473,  1252,   536,  1231,  1235,
    1227,   478,  1117,   536,   871,   871,   537,  1267,    81,  1131,
    1230,  1235,  1042,   775,   536,   537,  1230,   537,  1131,   537
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   542,   543,   543,   543,   543,   543,   543,   544,   544,
     545,   545,   546,   546,   546,   546,   546,   546,   546,   546,
     546,   546,   546,   546,   546,   546,   546,   546,   546,   546,
     546,   546,   546,   546,   546,   546,   546,   546,   546,   546,
     546,   546,   546,   546,   546,   546,   546,   546,   546,   546,
     546,   546,   546,   546,   546,   546,   546,   546,   546,   546,
     546,   546,   546,   546,   546,   546,   546,   546,   546,   546,
     546,   546,   546,   546,   546,   546,   546,   546,   546,   546,
     546,   546,   546,   546,   546,   546,   546,   546,   546,   546,
     546,   546,   546,   546,   546,   546,   546,   546,   546,   546,
     546,   546,   546,   546,   546,   546,   546,   546,   546,   546,
     546,   546,   546,   546,   546,   546,   546,   546,   546,   546,
     546,   546,   546,   546,   546,   546,   546,   546,   546,   546,
     546,   546,   546,   546,   546,   546,   546,   547,   547,   548,
     548,   549,   549,   550,   550,   550,   551,   552,   553,   553,
     553,   554,   554,   555,   555,   556,   556,   556,   556,   556,
     556,   556,   556,   556,   557,   557,   557,   557,   557,   557,
     558,   559,   559,   560,   560,   561,   561,   561,   561,   562,
     562,   562,   562,   562,   562,   563,   564,   565,   565,   566,
     566,   566,   566,   567,   567,   568,   568,   568,   568,   568,
     568,   569,   569,   569,   570,   570,   570,   571,   571,   571,
     571,   572,   572,   572,   572,   572,   572,   572,   572,   572,
     572,   572,   573,   573,   574,   574,   575,   575,   576,   576,
     576,   576,   577,   577,   577,   577,   578,   578,   578,   578,
     578,   578,   578,   579,   579,   579,   580,   580,   581,   582,
     582,   582,   582,   583,   583,   584,   584,   585,   585,   586,
     586,   586,   586,   586,   587,   588,   588,   589,   589,   590,
     591,   591,   591,   591,   591,   592,   592,   592,   592,   592,
     592,   592,   592,   592,   592,   592,   592,   592,   592,   592,
     592,   592,   592,   592,   592,   592,   593,   593,   594,   594,
     594,   595,   596,   596,   596,   596,   596,   596,   596,   596,
     596,   596,   596,   596,   596,   596,   596,   596,   596,   596,
     596,   596,   596,   596,   596,   596,   596,   596,   596,   596,
     596,   596,   596,   596,   596,   596,   596,   596,   596,   596,
     596,   596,   596,   596,   596,   596,   596,   596,   596,   596,
     596,   596,   596,   596,   596,   596,   596,   596,   596,   596,
     596,   596,   596,   596,   597,   597,   598,   598,   599,   599,
     600,   600,   600,   600,   601,   602,   602,   603,   603,   604,
     604,   604,   604,   605,   605,   606,   606,   606,   606,   607,
     607,   608,   608,   609,   609,   609,   609,   610,   611,   611,
     612,   613,   613,   614,   614,   614,   614,   615,   615,   616,
     616,   617,   617,   618,   618,   619,   619,   619,   620,   620,
     621,   621,   622,   622,   622,   622,   622,   622,   622,   622,
     622,   622,   622,   622,   622,   622,   622,   623,   623,   624,
     624,   625,   625,   626,   626,   627,   628,   628,   628,   628,
     628,   628,   629,   629,   630,   631,   631,   631,   631,   631,
     631,   632,   632,   632,   632,   632,   632,   632,   632,   633,
     633,   634,   634,   635,   635,   636,   636,   637,   637,   637,
     638,   638,   639,   640,   640,   641,   641,   642,   642,   643,
     643,   644,   644,   645,   645,   646,   646,   646,   646,   647,
     647,   647,   647,   647,   647,   647,   647,   647,   648,   648,
     648,   649,   649,   650,   650,   650,   651,   651,   651,   651,
     651,   651,   652,   653,   653,   653,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   655,   655,   656,   656,
     656,   656,   656,   656,   656,   656,   657,   657,   658,   658,
     659,   659,   660,   660,   661,   661,   662,   662,   663,   663,
     664,   664,   665,   666,   666,   667,   667,   667,   667,   668,
     668,   669,   669,   670,   670,   671,   671,   671,   671,   671,
     672,   673,   674,   674,   674,   674,   674,   675,   675,   676,
     676,   677,   678,   678,   679,   679,   679,   680,   680,   681,
     681,   681,   682,   682,   682,   682,   683,   683,   684,   684,
     685,   686,   686,   687,   687,   688,   688,   688,   689,   689,
     690,   690,   691,   692,   692,   692,   693,   693,   694,   695,
     695,   696,   697,   697,   698,   698,   699,   699,   700,   700,
     701,   701,   702,   702,   702,   702,   702,   702,   702,   702,
     702,   702,   702,   702,   702,   702,   702,   702,   703,   703,
     704,   704,   704,   704,   705,   705,   706,   706,   707,   707,
     708,   708,   709,   709,   710,   710,   711,   711,   712,   712,
     713,   714,   714,   715,   715,   716,   716,   717,   717,   718,
     718,   718,   718,   719,   720,   720,   721,   722,   722,   722,
     722,   722,   722,   722,   722,   722,   722,   722,   722,   722,
     723,   724,   724,   724,   724,   725,   725,   726,   726,   727,
     727,   728,   728,   729,   729,   730,   731,   731,   732,   732,
     732,   732,   733,   734,   735,   736,   736,   737,   737,   738,
     738,   739,   739,   740,   740,   740,   741,   741,   741,   741,
     742,   743,   743,   744,   744,   745,   745,   746,   746,   747,
     747,   748,   749,   750,   751,   751,   752,   752,   753,   753,
     754,   754,   755,   755,   756,   756,   757,   757,   757,   757,
     757,   758,   759,   759,   760,   760,   761,   761,   761,   762,
     762,   763,   763,   763,   763,   763,   764,   764,   765,   765,
     766,   767,   767,   768,   768,   769,   770,   770,   771,   771,
     772,   772,   773,   773,   774,   774,   775,   775,   775,   776,
     776,   776,   776,   777,   777,   778,   778,   779,   779,   779,
     779,   779,   779,   779,   779,   780,   780,   781,   781,   782,
     783,   783,   784,   785,   785,   785,   785,   786,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   788,   789,   789,   790,   790,   791,
     791,   791,   791,   791,   791,   792,   793,   793,   794,   795,
     795,   796,   796,   797,   797,   797,   797,   797,   798,   798,
     799,   800,   800,   801,   801,   801,   801,   801,   802,   802,
     803,   803,   804,   804,   804,   805,   806,   806,   807,   807,
     808,   808,   809,   809,   810,   810,   811,   812,   813,   813,
     813,   813,   813,   813,   813,   813,   813,   813,   813,   813,
     814,   814,   814,   814,   814,   814,   814,   814,   814,   814,
     814,   814,   814,   815,   815,   815,   815,   815,   816,   816,
     816,   816,   816,   816,   816,   816,   817,   817,   817,   818,
     818,   819,   819,   820,   820,   821,   821,   822,   823,   823,
     823,   824,   824,   824,   824,   824,   824,   824,   824,   824,
     824,   824,   824,   824,   824,   824,   824,   824,   824,   825,
     825,   826,   826,   826,   826,   826,   826,   826,   826,   826,
     826,   827,   827,   828,   828,   829,   829,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   831,   831,   832,   832,   833,   834,   834,
     835,   835,   835,   835,   835,   836,   836,   837,   837,   837,
     837,   837,   838,   838,   839,   839,   840,   840,   840,   840,
     840,   840,   840,   840,   840,   840,   840,   840,   840,   840,
     840,   840,   840,   840,   840,   840,   840,   841,   841,   842,
     842,   843,   843,   844,   844,   845,   845,   846,   846,   847,
     848,   848,   848,   849,   849,   850,   851,   851,   852,   852,
     852,   853,   853,   853,   854,   854,   854,   854,   854,   854,
     854,   855,   855,   856,   856,   857,   857,   858,   858,   859,
     859,   860,   860,   860,   861,   861,   862,   862,   863,   863,
     864,   864,   864,   865,   865,   865,   866,   866,   866,   866,
     867,   867,   868,   868,   869,   869,   870,   870,   871,   871,
     871,   871,   872,   872,   873,   873,   874,   874,   874,   874,
     874,   875,   875,   875,   875,   875,   876,   877,   878,   878,
     878,   879,   879,   879,   880,   881,   881,   881,   881,   882,
     882,   883,   884,   884,   885,   885,   886,   886,   887,   887,
     887,   887,   887,   887,   887,   887,   887,   887,   887,   887,
     887,   887,   887,   887,   887,   888,   888,   888,   888,   888,
     889,   889,   890,   891,   891,   891,   892,   892,   893,   893,
     894,   894,   895,   895,   896,   897,   897,   898,   898,   898,
     899,   899,   900,   900,   901,   901,   901,   901,   901,   901,
     902,   902,   903,   903,   904,   904,   904,   904,   905,   905,
     906,   906,   907,   908,   909,   909,   910,   910,   911,   911,
     911,   912,   912,   912,   913,   914,   914,   915,   916,   916,
     916,   916,   917,   918,   918,   918,   919,   919,   920,   920,
     921,   921,   922,   922,   923,   923,   923,   923,   923,   923,
     923,   923,   923,   923,   923,   923,   923,   923,   923,   923,
     923,   923,   923,   923,   923,   923,   923,   923,   923,   923,
     923,   923,   923,   923,   923,   923,   923,   923,   923,   923,
     923,   923,   923,   923,   923,   923,   923,   923,   923,   923,
     923,   923,   923,   923,   923,   923,   923,   923,   923,   924,
     924,   925,   925,   926,   926,   926,   926,   926,   926,   927,
     927,   928,   928,   928,   928,   928,   928,   928,   928,   928,
     928,   928,   928,   928,   928,   928,   928,   928,   928,   928,
     928,   928,   928,   928,   928,   928,   928,   928,   929,   930,
     930,   931,   931,   931,   932,   932,   932,   932,   932,   933,
     934,   934,   934,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   935,   935,   935,   936,   936,   936,
     936,   936,   936,   936,   937,   937,   938,   938,   938,   938,
     939,   940,   940,   940,   940,   940,   940,   940,   940,   940,
     941,   941,   942,   943,   943,   943,   944,   944,   945,   945,
     945,   945,   945,   946,   946,   947,   947,   947,   947,   948,
     948,   948,   949,   950,   950,   951,   952,   952,   953,   953,
     953,   953,   953,   953,   953,   953,   953,   953,   953,   953,
     954,   954,   955,   955,   955,   956,   956,   956,   956,   956,
     957,   957,   957,   958,   958,   959,   959,   959,   960,   960,
     960,   960,   961,   961,   961,   961,   962,   963,   964,   964,
     965,   965,   966,   966,   966,   967,   967,   967,   967,   967,
     967,   967,   968,   968,   969,   969,   969,   969,   970,   971,
     971,   971,   971,   972,   972,   973,   974,   975,   975,   976,
     977,   977,   977,   977,   977,   977,   977,   978,   978,   979,
     980,   980,   980,   980,   980,   980,   981,   981,   982,   983,
     983,   983,   983,   983,   984,   984,   985,   985,   986,   986,
     987,   987,   988,   988,   989,   990,   990,   990,   991,   991,
     991,   992,   992,   993,   993,   994,   994,   995,   995,   996,
     996,   997,   998,   998,   999,   999,  1000,  1000,  1000,  1000,
    1001,  1001,  1001,  1001,  1001,  1001,  1001,  1001,  1001,  1001,
    1002,  1003,  1003,  1004,  1004,  1004,  1004,  1004,  1005,  1005,
    1005,  1006,  1006,  1007,  1007,  1007,  1007,  1008,  1009,  1009,
    1010,  1010,  1010,  1010,  1010,  1011,  1011,  1012,  1012,  1013,
    1014,  1014,  1014,  1015,  1015,  1015,  1016,  1016,  1017,  1017,
    1018,  1018,  1019,  1020,  1020,  1021,  1022,  1022,  1023,  1024,
    1024,  1025,  1025,  1025,  1025,  1025,  1025,  1025,  1025,  1026,
    1026,  1027,  1027,  1027,  1028,  1029,  1029,  1030,  1030,  1031,
    1032,  1032,  1033,  1034,  1034,  1035,  1035,  1035,  1035,  1035,
    1036,  1036,  1037,  1037,  1038,  1038,  1039,  1040,  1041,  1041,
    1041,  1041,  1041,  1042,  1043,  1044,  1045,  1045,  1045,  1045,
    1045,  1045,  1046,  1046,  1046,  1047,  1047,  1048,  1048,  1049,
    1049,  1049,  1049,  1049,  1049,  1049,  1049,  1050,  1050,  1051,
    1051,  1051,  1051,  1051,  1051,  1051,  1052,  1052,  1052,  1053,
    1053,  1054,  1055,  1055,  1055,  1056,  1056,  1056,  1057,  1057,
    1057,  1058,  1058,  1059,  1059,  1060,  1060,  1060,  1060,  1060,
    1060,  1060,  1060,  1060,  1061,  1061,  1062,  1062,  1062,  1063,
    1063,  1064,  1064,  1065,  1065,  1066,  1066,  1067,  1068,  1068,
    1069,  1069,  1070,  1070,  1070,  1070,  1071,  1071,  1072,  1072,
    1072,  1072,  1072,  1072,  1073,  1073,  1074,  1074,  1075,  1076,
    1076,  1076,  1077,  1077,  1078,  1078,  1079,  1079,  1080,  1080,
    1081,  1081,  1082,  1082,  1082,  1082,  1082,  1083,  1084,  1085,
    1086,  1087,  1087,  1088,  1088,  1089,  1089,  1090,  1090,  1091,
    1092,  1092,  1092,  1092,  1093,  1093,  1094,  1094,  1095,  1095,
    1096,  1096,  1097,  1097,  1097,  1097,  1097,  1097,  1097,  1097,
    1097,  1097,  1097,  1097,  1098,  1098,  1098,  1098,  1098,  1098,
    1099,  1099,  1099,  1099,  1100,  1100,  1101,  1101,  1102,  1102,
    1102,  1102,  1102,  1103,  1103,  1103,  1103,  1104,  1104,  1105,
    1105,  1106,  1106,  1107,  1107,  1107,  1108,  1108,  1109,  1109,
    1109,  1110,  1111,  1111,  1112,  1112,  1113,  1114,  1114,  1115,
    1115,  1116,  1116,  1117,  1117,  1118,  1118,  1118,  1119,  1119,
    1120,  1120,  1121,  1122,  1122,  1123,  1123,  1124,  1124,  1124,
    1125,  1125,  1126,  1126,  1126,  1126,  1126,  1127,  1127,  1128,
    1128,  1129,  1130,  1130,  1131,  1131,  1132,  1132,  1132,  1132,
    1132,  1132,  1133,  1133,  1134,  1134,  1135,  1135,  1135,  1135,
    1135,  1135,  1136,  1136,  1136,  1137,  1137,  1137,  1137,  1137,
    1137,  1137,  1137,  1138,  1138,  1138,  1138,  1138,  1139,  1139,
    1140,  1140,  1141,  1141,  1141,  1141,  1141,  1141,  1141,  1141,
    1141,  1141,  1141,  1142,  1142,  1143,  1143,  1144,  1144,  1145,
    1146,  1147,  1147,  1148,  1148,  1149,  1150,  1151,  1151,  1151,
    1151,  1151,  1151,  1152,  1152,  1153,  1153,  1153,  1153,  1154,
    1155,  1155,  1155,  1156,  1156,  1156,  1156,  1156,  1156,  1156,
    1156,  1156,  1156,  1156,  1156,  1156,  1156,  1157,  1157,  1158,
    1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,
    1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,
    1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,
    1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,
    1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,
    1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,
    1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1160,  1160,
    1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,
    1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,
    1161,  1161,  1161,  1161,  1161,  1161,  1161,  1161,  1161,  1161,
    1161,  1161,  1161,  1161,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1163,  1163,  1163,  1164,  1164,  1164,  1165,  1165,  1165,
    1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,
    1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,
    1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,
    1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,
    1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,
    1165,  1165,  1165,  1165,  1165,  1165,  1165,  1166,  1166,  1167,
    1167,  1167,  1167,  1168,  1169,  1169,  1170,  1170,  1171,  1171,
    1172,  1172,  1172,  1173,  1173,  1173,  1174,  1174,  1174,  1174,
    1175,  1175,  1176,  1176,  1177,  1177,  1178,  1178,  1179,  1179,
    1180,  1181,  1181,  1181,  1182,  1183,  1183,  1184,  1184,  1185,
    1185,  1185,  1185,  1186,  1186,  1187,  1187,  1187,  1187,  1187,
    1188,  1188,  1188,  1188,  1188,  1189,  1189,  1189,  1190,  1190,
    1191,  1192,  1192,  1192,  1193,  1193,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1195,  1195,
    1196,  1196,  1197,  1197,  1197,  1197,  1197,  1197,  1198,  1198,
    1199,  1199,  1200,  1200,  1200,  1201,  1201,  1202,  1202,  1203,
    1203,  1203,  1204,  1204,  1205,  1206,  1206,  1206,  1206,  1206,
    1206,  1206,  1206,  1207,  1207,  1207,  1207,  1208,  1208,  1209,
    1210,  1210,  1210,  1210,  1210,  1211,  1211,  1211,  1212,  1212,
    1213,  1214,  1214,  1215,  1216,  1216,  1217,  1217,  1218,  1218,
    1219,  1219,  1219,  1219,  1220,  1220,  1221,  1221,  1222,  1222,
    1223,  1223,  1224,  1224,  1225,  1225,  1226,  1227,  1227,  1227,
    1227,  1227,  1227,  1227,  1227,  1227,  1228,  1228,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1230,  1230,  1230,  1230,
    1231,  1231,  1232,  1233,  1233,  1234,  1234,  1235,  1235,  1235,
    1235,  1235,  1236,  1236,  1237,  1237,  1237,  1237,  1237,  1238,
    1238,  1238,  1238,  1238,  1239,  1239,  1240,  1240,  1241,  1241,
    1241,  1242,  1242,  1242,  1243,  1243,  1244,  1244,  1245,  1245,
    1246,  1246,  1247,  1247,  1248,  1248,  1248,  1248,  1249,  1249,
    1250,  1250,  1251,  1251,  1252,  1253,  1254,  1255,  1255,  1256,
    1256,  1256,  1256,  1256,  1256,  1256,  1256,  1256,  1256,  1256,
    1256,  1256,  1257,  1258,  1259,  1259,  1259,  1260,  1261,  1261,
    1261,  1261,  1262,  1262,  1263,  1264,  1265,  1265,  1266,  1266,
    1267,  1267,  1267,  1268,  1268,  1268,  1269,  1269,  1269,  1269,
    1270,  1270,  1270,  1270,  1270,  1271,  1271,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,  1272,
    1272,  1272,  1272,  1272,  1272,  1272,  1272,  1273,  1273,  1273,
    1273,  1273,  1273,  1273,  1273,  1273,  1273,  1273,  1273,  1273,
    1273,  1273,  1273,  1273,  1273,  1273,  1273,  1273,  1273,  1273,
    1273,  1273,  1273,  1273,  1273,  1273,  1273,  1273,  1273,  1273,
    1273,  1273,  1273,  1273,  1273,  1273,  1273,  1273,  1273,  1273,
    1273,  1273,  1273,  1273,  1273,  1273,  1273,  1273,  1273,  1273,
    1273,  1273,  1273,  1273,  1273,  1273,  1273,  1273,  1273,  1273,
    1274,  1274,  1274,  1274,  1274,  1274,  1274,  1274,  1274,  1274,
    1274,  1274,  1274,  1274,  1274,  1274,  1274,  1274,  1274,  1274,
    1274,  1274,  1274,  1275,  1275,  1275,  1275,  1275,  1275,  1275,
    1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,
    1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,
    1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,
    1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,
    1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,
    1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,
    1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,
    1275,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
    1276,  1276,  1276,  1276,  1276,  1276
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     2,     2,     2,     2,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     0,     1,
       0,     1,     0,     1,     1,     0,     2,     5,     1,     1,
       0,     2,     0,     2,     0,     2,     2,     3,     3,     1,
       3,     3,     2,     1,     1,     2,     2,     2,     3,     3,
       5,     5,     5,     0,     3,     5,     5,     5,     5,     3,
       5,     3,     5,     3,     5,     5,     6,     1,     1,     6,
       4,     9,     7,     2,     0,     1,     1,     1,     1,     1,
       1,     2,     3,     3,     2,     5,     1,     3,     3,     3,
       3,     1,     3,     3,     2,     2,     2,     2,     3,     3,
       3,     3,     1,     3,     1,     3,     1,     1,     2,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     3,     5,
       1,     1,     1,     1,     1,     0,     1,     1,     2,     1,
       2,     3,     2,     1,     1,     2,     1,     2,     1,     2,
       3,     4,     3,     2,     4,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     4,     6,     4,     6,    10,
      13,     4,     6,     4,    10,    13,     4,     6,     4,     6,
       5,     7,    11,    14,     5,     7,     1,     3,     4,     4,
       4,     3,     2,     5,     3,     6,     4,     6,     6,     9,
       5,     7,     6,     6,     5,     5,     5,     5,     9,     4,
       5,     7,     6,     4,     8,     4,     2,     4,     4,     3,
       6,     4,     3,     3,     3,     2,     2,     3,     4,     4,
       3,     3,     3,     3,     3,     3,     4,     4,     3,     2,
       3,     2,     2,     3,     4,     3,     2,     2,     3,     4,
       4,     4,     5,     1,     3,     2,     2,     0,     2,     0,
       1,     1,     1,     3,     3,     2,     0,     1,     3,     3,
       1,     5,     3,     1,     2,     1,     3,     2,     3,     1,
       1,     1,     1,     6,     6,    10,     1,     2,     1,     3,
       4,     1,     3,     4,     6,     4,     8,     2,     2,    11,
       9,     1,     1,     1,     0,     1,     1,     1,     1,     3,
       2,     0,     1,     1,     3,     3,     1,     1,     3,     3,
       3,     3,     4,     4,     3,     3,     2,     1,     0,     3,
       0,     1,     0,     1,     3,     2,     1,     1,     1,     1,
       3,     0,     1,     3,     1,    13,    16,    12,    15,    14,
      17,     1,     1,     2,     2,     2,     2,     1,     0,     1,
       0,     3,     0,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     6,     2,     4,     2,     2,     1,     0,     2,
       2,     1,     0,     2,     0,     3,     1,     1,     2,     3,
       1,     4,     4,     5,     2,     5,     7,     5,     2,     3,
       0,     1,     2,     1,     1,     0,     1,     2,     2,     2,
       1,     2,     3,     3,     3,     0,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     5,     4,
      10,     3,    10,     4,    10,    12,     3,     1,     5,     3,
       2,     0,     2,     0,     3,     0,     1,     3,     3,     0,
       4,     0,     1,     4,     0,     2,     2,     2,     0,     1,
       3,     3,     6,     4,     0,     1,     1,     2,     2,     0,
       3,     3,     2,     1,     1,     3,     3,     4,     0,     1,
       0,     6,     1,     3,     3,     3,     5,     2,     0,     2,
       2,     0,     3,     4,     4,     0,     2,     0,     4,     0,
       3,     8,    11,     1,     3,     1,     1,     3,     6,     8,
       7,    10,     6,     2,     3,     0,     8,    11,     5,     1,
       0,     6,     5,     8,     4,     6,     1,     0,     3,     0,
       1,     2,     2,     2,     1,     2,     3,     1,     2,     2,
       2,     2,     3,     3,     3,     1,     3,     1,     1,     0,
       1,     2,     2,     1,     1,     3,     6,    10,     1,     0,
       1,     2,     2,     0,     2,     2,     1,     0,     1,     0,
       7,     2,     0,     3,     5,     5,     8,     2,     0,     2,
       2,     2,     1,     5,     2,     0,     2,     6,     6,     6,
      10,     6,     6,     6,     9,     9,     6,     6,     9,     6,
       7,     2,     2,     2,     2,     1,     2,     1,     0,     7,
       6,     4,     0,     1,     3,     4,     1,     3,     1,     2,
       2,     2,     2,     1,     1,    10,    13,     2,     0,     2,
       2,     1,     0,     5,     4,     4,    11,    14,    12,    15,
      11,     2,     1,     4,     0,     8,    11,     1,     1,     7,
       9,     8,    10,     8,     4,     0,     5,     0,     2,     0,
       2,     0,     2,     0,     2,     0,     1,     1,     1,     1,
       1,     8,     1,     1,    17,    21,     1,     1,     2,     1,
       3,     1,     1,     1,     3,     1,     2,     0,     1,     2,
       4,     1,     1,     1,     1,     1,     3,     0,     1,     0,
       1,     1,     4,     0,     1,     1,     1,     3,     0,     1,
       1,     1,     1,     2,     0,     0,     2,     2,     1,     2,
       2,     2,     2,     2,     1,    11,    13,     1,     3,     5,
       1,     3,     5,     1,     2,     2,     1,     8,     6,     5,
       4,     4,     3,     7,     8,     6,     6,     6,     6,     6,
       4,     7,     5,     8,     3,     1,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     3,     3,     1,
       0,     1,     3,     7,     9,     9,     8,     6,     3,     0,
      13,     1,     3,     4,     4,     3,     6,     2,     1,     0,
       2,     0,     2,     4,     0,     6,     8,     8,     1,     3,
       5,     5,     7,     9,     7,     9,     5,     6,     6,     4,
       6,     4,     6,     8,     4,     6,     4,     6,     5,     7,
       1,     1,     1,     2,     1,     2,     1,     1,     1,     3,
       3,     3,     3,     1,     1,     1,     1,     1,     2,     2,
       1,     3,     2,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     2,     2,     3,     1,     3,     5,     2,     2,
       0,     6,     6,     6,     6,     6,     6,     6,     6,     8,
       9,     8,     6,     6,     9,     9,     9,     7,    10,     1,
       1,     8,     8,     8,     8,     8,     8,     8,     9,     8,
       8,     2,     0,     1,     1,     2,     2,     1,     2,     3,
       3,     3,     3,     4,     4,     3,     3,     3,     4,     4,
       3,     4,     4,     1,     1,     1,     0,     8,     8,    11,
       1,     1,     2,     4,     5,     1,     3,     2,     2,     2,
       2,     2,     1,     3,     1,     3,     1,     2,     2,     4,
       3,     2,     2,     2,     2,     2,     2,     3,     2,     2,
       2,     2,     5,     5,     5,     5,     5,     1,     3,     1,
       2,     3,     0,     5,     7,     6,     9,     3,     1,     2,
       1,     1,     1,     3,     0,     5,     2,     0,     3,     3,
       3,     7,     7,    10,     1,     1,     1,     1,     1,     1,
       2,    16,    19,     1,     0,     2,     0,     1,     3,     4,
       5,     2,     2,     4,     4,     0,     1,     3,     2,     0,
       1,     1,     0,     2,     2,     0,     9,    12,     7,     7,
       2,     0,     3,     2,     1,     3,     1,     3,     2,     1,
       1,     2,     3,     2,     1,     3,     3,     3,     2,     2,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     4,
       5,     1,     3,     3,     1,     3,     3,     5,     6,     1,
       3,     2,     1,     3,     1,     0,     1,     2,     4,     5,
       1,     1,     1,     1,     3,     3,     2,     2,     1,     2,
       2,     2,     2,     1,     2,     2,     2,     2,     1,     1,
       1,     3,     2,     1,     4,     0,     3,     0,     1,     1,
       3,     5,     2,     0,     2,     1,     3,     5,     5,     5,
       1,     2,     1,     0,     4,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     3,     5,     5,     5,     1,     3,
       1,     3,     2,     2,     1,     2,     1,     2,    11,    10,
      10,     2,     2,     0,     9,     2,     0,    10,    11,    11,
       5,     5,     8,     5,     5,     5,     1,     1,     1,     1,
       3,     0,     5,     5,     6,     6,     6,     6,     6,     8,
       8,     6,     6,     7,     9,     9,     8,    10,     6,     6,
       6,     6,     6,     6,     6,     8,     6,     8,     6,     8,
       7,     9,     6,     8,     7,     9,     8,    10,     8,    10,
       9,    11,     8,    10,     9,    11,     8,     8,     7,     6,
       6,     6,     6,     8,     8,     8,     8,     6,     9,     1,
       0,     2,     0,     8,     8,     8,    10,     9,     8,     1,
       0,     6,     6,     6,     6,     6,     6,     6,     9,     9,
       6,     6,     6,     8,     6,     8,     8,     8,     8,     6,
       8,     6,     8,     7,     9,     7,     9,     6,     7,     1,
       3,     3,     3,     1,     1,     1,     1,     1,     1,     7,
       6,     6,     6,     6,     6,     6,     7,     7,     6,     9,
       9,     6,     6,     6,     6,     6,     6,     8,     8,     8,
       6,     7,     6,     6,     4,     7,     6,     4,     4,     4,
       3,     4,     3,     1,     1,     3,     5,     5,     5,     5,
       8,     5,     5,     6,     7,     7,     7,     4,     4,     5,
       4,     6,    13,     1,     1,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     1,     1,     1,     1,
       1,     0,     3,     2,     0,     2,     2,     2,     3,     3,
       3,     3,     2,     3,     2,     5,     4,     3,     3,     3,
       3,     3,     1,     1,     0,     3,     2,     2,     1,     2,
       1,     3,     2,     1,     0,     2,     3,     0,     9,    11,
      12,    14,     3,     4,     4,     0,     2,     5,     1,     0,
       1,     2,     3,     3,     3,     1,     2,     1,     1,     1,
       1,     1,     1,     0,     5,     4,     6,     6,     4,     3,
       5,     7,     9,     1,     3,     1,     5,     4,     4,     6,
       4,     6,     6,     5,     7,     9,     6,     1,     0,     6,
      11,    11,    11,    13,     9,    11,     1,     1,    10,     6,
       4,     4,     2,     5,     2,     0,     6,     5,     3,     5,
       1,     3,     1,     1,     2,     1,     1,     1,     1,     1,
       0,     1,     0,     1,     0,     1,     0,     1,     0,     3,
       0,     2,     1,     3,     1,     0,     2,     4,     3,     5,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       5,     3,     0,     1,     1,     1,     1,     1,     3,     9,
      12,     3,     0,     2,     3,     2,     3,     7,     1,     3,
       1,     4,     4,     7,     2,     1,     1,     1,     3,     2,
       8,     5,     0,     4,     3,     0,     3,     0,     4,     0,
       1,     3,     3,     1,     1,     7,     2,     0,     5,     3,
       0,     2,     2,     2,     3,     1,     3,     1,     2,     1,
       0,     1,     2,     0,     8,     1,     3,     3,     5,     2,
       1,     3,    10,     1,     2,     4,     4,     4,     5,     5,
       2,     5,     3,     5,     2,     0,     3,     1,     2,     5,
       5,     8,     3,     4,     7,     1,     0,     3,     2,     2,
       2,     2,     0,     2,     2,     1,     1,     3,     3,     1,
       2,     4,     4,     2,     3,     5,     5,     1,     1,     9,
       9,     1,     2,     4,     4,     4,     2,     2,     3,     1,
       3,     9,     1,     2,     0,     7,     7,     0,    10,     6,
       0,     1,     0,     2,     0,     3,     3,     4,     4,     4,
       4,     3,     2,     1,     1,     0,     1,     1,     0,     1,
       5,     1,     0,     1,     1,     1,     0,     3,     1,     3,
       4,     3,     2,     2,     1,     1,     1,     0,     2,     4,
       5,     6,     4,     5,     2,     3,     1,     1,     1,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     4,     0,
       1,     3,     1,     1,     1,     1,     1,     2,     4,     4,
       5,     2,     0,     1,     3,     1,     0,     1,     2,     3,
       2,     4,     2,     3,     2,     0,     4,     5,     2,     0,
       1,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       1,     4,     2,     3,     3,     4,     5,     4,     5,     4,
       5,     2,     4,     1,     1,     0,     2,     0,     1,     4,
       5,     4,     0,     2,     2,     2,     1,     1,     0,     5,
       2,     1,     1,     2,     2,     4,     1,     3,     1,     2,
       3,     6,     4,     0,     2,     6,     2,     1,     3,     4,
       0,     2,     0,     2,     0,     2,     4,     0,     1,     0,
       1,     3,     3,     7,    12,     1,     3,     2,     3,     3,
       1,     2,     2,     2,     2,     1,     2,     1,     3,     3,
       2,    13,     2,     0,     1,     3,     3,     6,     7,     5,
       7,     9,     1,     0,     2,     0,     2,     3,     5,     6,
       2,     3,     3,     4,     0,     1,     1,     1,     1,     1,
       2,     4,     1,     1,     1,     1,     1,     1,     2,     3,
       3,     0,     1,     1,     1,     1,     1,     2,     2,     2,
       2,     2,     1,     3,     0,     1,     1,     1,     1,     5,
       2,     1,     1,     1,     1,     4,     1,     2,     2,     1,
       3,     3,     2,     1,     0,     5,     2,     5,     2,     1,
       3,     3,     0,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     0,     1,     4,     1,
       1,     3,     3,     5,     3,     2,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     3,     3,     2,     2,     3,     5,     4,     6,     3,
       5,     4,     6,     4,     6,     5,     7,     3,     2,     4,
       2,     3,     3,     4,     3,     4,     3,     4,     5,     6,
       6,     7,     6,     7,     3,     4,     4,     6,     3,     3,
       4,     3,     4,     4,     5,     4,     5,     1,     1,     3,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     5,     6,     3,     4,
       1,     1,     2,     4,     1,     1,     1,     2,     2,     2,
       2,     1,     1,     4,     3,     5,     6,     8,     6,     6,
       4,     4,     3,     1,     1,     1,     1,     5,     1,     1,
       4,     1,     4,     1,     4,     1,     4,     1,     1,     1,
       1,     1,     1,     1,     6,     4,     4,     6,     4,     4,
       4,     4,     4,     6,     5,     5,     5,     4,     6,     4,
       4,     4,     4,     5,     7,     7,     9,     5,     4,     6,
       5,     7,     7,     8,     4,     7,     4,     6,     6,     4,
       5,     4,     5,     3,    11,     8,     9,     2,     3,     3,
       3,     4,     0,     4,     1,     3,     3,     1,     1,     1,
       1,     2,     0,     2,     2,     0,     2,     3,     3,     4,
       2,     2,     5,     0,     5,     0,     2,     0,     1,     3,
       3,     2,     2,     0,     6,     1,     0,     3,     0,     3,
       3,     3,     0,     1,     4,     2,     2,     2,     2,     2,
       3,     2,     2,     3,     0,     4,     3,     5,     4,     3,
       5,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       1,     4,     1,     4,     1,     2,     1,     2,     1,     3,
       1,     3,     1,     3,     3,     1,     0,     1,     3,     3,
       3,     2,     1,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     7,     5,     3,
       5,     5,     3,     3,     5,     3,     2,     1,     1,     3,
       5,     1,     2,     4,     2,     0,     1,     0,     1,     2,
       2,     2,     3,     5,     1,     0,     1,     2,     0,     2,
       1,     0,     2,     0,     1,     3,     3,     2,     3,     2,
       3,     4,     4,     3,     3,     0,     2,     1,     1,     1,
       1,     1,     1,     2,     2,     1,     3,     3,     6,     0,
       3,     0,     2,     4,     2,     1,     0,     5,     2,     5,
       2,     0,     3,     0,     1,     2,     2,     2,     2,     3,
       2,     3,     2,     0,     1,     3,     3,     3,     3,     3,
       0,     3,     3,     0,     1,     3,     7,     7,     3,     0,
       1,     0,     1,     3,     3,     2,     1,     1,     1,     3,
       1,     2,     1,     3,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     2,     6,     2,     3,     5,     1,
       1,     1,     1,     1,     1,     2,     2,     1,     1,     1,
       1,     1,     1,     3,    10,     4,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  YY_USE (yyscanner);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule, core_yyscan_t yyscanner)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]), yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  YY_USE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* parse_toplevel: stmtmulti  */
#line 917 "gram.y"
                        {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
				(void) yynerrs;		/* suppress compiler warning */
			}
#line 30709 "gram.c"
    break;

  case 3: /* parse_toplevel: MODE_TYPE_NAME Typename  */
#line 922 "gram.y"
                        {
				pg_yyget_extra(yyscanner)->parsetree = list_make1((yyvsp[0].typnam));
			}
#line 30717 "gram.c"
    break;

  case 4: /* parse_toplevel: MODE_PLPGSQL_EXPR PLpgSQL_Expr  */
#line 926 "gram.y"
                        {
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((yyvsp[0].node), (yylsp[0])));
			}
#line 30726 "gram.c"
    break;

  case 5: /* parse_toplevel: MODE_PLPGSQL_ASSIGN1 PLAssignStmt  */
#line 931 "gram.y"
                        {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 1;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, (yylsp[0])));
			}
#line 30738 "gram.c"
    break;

  case 6: /* parse_toplevel: MODE_PLPGSQL_ASSIGN2 PLAssignStmt  */
#line 939 "gram.y"
                        {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 2;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, (yylsp[0])));
			}
#line 30750 "gram.c"
    break;

  case 7: /* parse_toplevel: MODE_PLPGSQL_ASSIGN3 PLAssignStmt  */
#line 947 "gram.y"
                        {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 3;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, (yylsp[0])));
			}
#line 30762 "gram.c"
    break;

  case 8: /* stmtmulti: stmtmulti ';' toplevel_stmt  */
#line 963 "gram.y"
                                {
					if ((yyvsp[-2].list) != NIL)
					{
						/* update length of previous stmt */
						updateRawStmtEnd(llast_node(RawStmt, (yyvsp[-2].list)), (yylsp[-1]));
					}
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), makeRawStmt((yyvsp[0].node), (yylsp[0])));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 30778 "gram.c"
    break;

  case 9: /* stmtmulti: toplevel_stmt  */
#line 975 "gram.y"
                                {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1(makeRawStmt((yyvsp[0].node), (yylsp[0])));
					else
						(yyval.list) = NIL;
				}
#line 30789 "gram.c"
    break;

  case 136: /* stmt: %empty  */
#line 1118 "gram.y"
                                { (yyval.node) = NULL; }
#line 30795 "gram.c"
    break;

  case 137: /* opt_single_name: ColId  */
#line 1125 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 30801 "gram.c"
    break;

  case 138: /* opt_single_name: %empty  */
#line 1126 "gram.y"
                                                                        { (yyval.str) = NULL; }
#line 30807 "gram.c"
    break;

  case 139: /* opt_qualified_name: any_name  */
#line 1130 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 30813 "gram.c"
    break;

  case 140: /* opt_qualified_name: %empty  */
#line 1131 "gram.y"
                                                                                { (yyval.list) = NIL; }
#line 30819 "gram.c"
    break;

  case 141: /* opt_concurrently: CONCURRENTLY  */
#line 1135 "gram.y"
                                                                        { (yyval.boolean) = true; }
#line 30825 "gram.c"
    break;

  case 142: /* opt_concurrently: %empty  */
#line 1136 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 30831 "gram.c"
    break;

  case 143: /* opt_drop_behavior: CASCADE  */
#line 1140 "gram.y"
                                                                                { (yyval.dbehavior) = DROP_CASCADE; }
#line 30837 "gram.c"
    break;

  case 144: /* opt_drop_behavior: RESTRICT  */
#line 1141 "gram.y"
                                                                                { (yyval.dbehavior) = DROP_RESTRICT; }
#line 30843 "gram.c"
    break;

  case 145: /* opt_drop_behavior: %empty  */
#line 1142 "gram.y"
                                                                        { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 30849 "gram.c"
    break;

  case 146: /* CallStmt: CALL func_application  */
#line 1152 "gram.y"
                                {
					CallStmt   *n = makeNode(CallStmt);

					n->funccall = castNode(FuncCall, (yyvsp[0].node));
					(yyval.node) = (Node *) n;
				}
#line 30860 "gram.c"
    break;

  case 147: /* CreateRoleStmt: CREATE ROLE RoleId opt_with OptRoleList  */
#line 1168 "gram.y"
                                {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30873 "gram.c"
    break;

  case 151: /* OptRoleList: OptRoleList CreateOptRoleElem  */
#line 1190 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30879 "gram.c"
    break;

  case 152: /* OptRoleList: %empty  */
#line 1191 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 30885 "gram.c"
    break;

  case 153: /* AlterOptRoleList: AlterOptRoleList AlterOptRoleElem  */
#line 1195 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30891 "gram.c"
    break;

  case 154: /* AlterOptRoleList: %empty  */
#line 1196 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 30897 "gram.c"
    break;

  case 155: /* AlterOptRoleElem: PASSWORD Sconst  */
#line 1201 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("password",
									 (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 30906 "gram.c"
    break;

  case 156: /* AlterOptRoleElem: PASSWORD NULL_P  */
#line 1206 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("password", NULL, (yylsp[-1]));
				}
#line 30914 "gram.c"
    break;

  case 157: /* AlterOptRoleElem: ENCRYPTED PASSWORD Sconst  */
#line 1210 "gram.y"
                                {
					/*
					 * These days, passwords are always stored in encrypted
					 * form, so there is no difference between PASSWORD and
					 * ENCRYPTED PASSWORD.
					 */
					(yyval.defelt) = makeDefElem("password",
									 (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 30928 "gram.c"
    break;

  case 158: /* AlterOptRoleElem: UNENCRYPTED PASSWORD Sconst  */
#line 1220 "gram.y"
                                {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNENCRYPTED PASSWORD is no longer supported"),
							 errhint("Remove UNENCRYPTED to store the password in encrypted form instead."),
							 parser_errposition((yylsp[-2]))));
				}
#line 30940 "gram.c"
    break;

  case 159: /* AlterOptRoleElem: INHERIT  */
#line 1228 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("inherit", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 30948 "gram.c"
    break;

  case 160: /* AlterOptRoleElem: CONNECTION LIMIT SignedIconst  */
#line 1232 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 30956 "gram.c"
    break;

  case 161: /* AlterOptRoleElem: VALID UNTIL Sconst  */
#line 1236 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("validUntil", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 30964 "gram.c"
    break;

  case 162: /* AlterOptRoleElem: USER role_list  */
#line 1241 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 30972 "gram.c"
    break;

  case 163: /* AlterOptRoleElem: IDENT  */
#line 1245 "gram.y"
                                {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "bypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nobypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *) makeBoolean(false), (yylsp[0]));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 31021 "gram.c"
    break;

  case 164: /* CreateOptRoleElem: AlterOptRoleElem  */
#line 1292 "gram.y"
                                                                { (yyval.defelt) = (yyvsp[0].defelt); }
#line 31027 "gram.c"
    break;

  case 165: /* CreateOptRoleElem: SYSID Iconst  */
#line 1295 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("sysid", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-1]));
				}
#line 31035 "gram.c"
    break;

  case 166: /* CreateOptRoleElem: ADMIN role_list  */
#line 1299 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 31043 "gram.c"
    break;

  case 167: /* CreateOptRoleElem: ROLE role_list  */
#line 1303 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 31051 "gram.c"
    break;

  case 168: /* CreateOptRoleElem: IN_P ROLE role_list  */
#line 1307 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("addroleto", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 31059 "gram.c"
    break;

  case 169: /* CreateOptRoleElem: IN_P GROUP_P role_list  */
#line 1311 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("addroleto", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 31067 "gram.c"
    break;

  case 170: /* CreateUserStmt: CREATE USER RoleId opt_with OptRoleList  */
#line 1325 "gram.y"
                                {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31080 "gram.c"
    break;

  case 171: /* AlterRoleStmt: ALTER ROLE RoleSpec opt_with AlterOptRoleList  */
#line 1344 "gram.y"
                                 {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 31093 "gram.c"
    break;

  case 172: /* AlterRoleStmt: ALTER USER RoleSpec opt_with AlterOptRoleList  */
#line 1353 "gram.y"
                                 {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 31106 "gram.c"
    break;

  case 173: /* opt_in_database: %empty  */
#line 1364 "gram.y"
                                                                        { (yyval.str) = NULL; }
#line 31112 "gram.c"
    break;

  case 174: /* opt_in_database: IN_P DATABASE name  */
#line 1365 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 31118 "gram.c"
    break;

  case 175: /* AlterRoleSetStmt: ALTER ROLE RoleSpec opt_in_database SetResetClause  */
#line 1370 "gram.y"
                                {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 31131 "gram.c"
    break;

  case 176: /* AlterRoleSetStmt: ALTER ROLE ALL opt_in_database SetResetClause  */
#line 1379 "gram.y"
                                {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 31144 "gram.c"
    break;

  case 177: /* AlterRoleSetStmt: ALTER USER RoleSpec opt_in_database SetResetClause  */
#line 1388 "gram.y"
                                {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 31157 "gram.c"
    break;

  case 178: /* AlterRoleSetStmt: ALTER USER ALL opt_in_database SetResetClause  */
#line 1397 "gram.y"
                                {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 31170 "gram.c"
    break;

  case 179: /* DropRoleStmt: DROP ROLE role_list  */
#line 1419 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31182 "gram.c"
    break;

  case 180: /* DropRoleStmt: DROP ROLE IF_P EXISTS role_list  */
#line 1427 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31194 "gram.c"
    break;

  case 181: /* DropRoleStmt: DROP USER role_list  */
#line 1435 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31206 "gram.c"
    break;

  case 182: /* DropRoleStmt: DROP USER IF_P EXISTS role_list  */
#line 1443 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->roles = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31218 "gram.c"
    break;

  case 183: /* DropRoleStmt: DROP GROUP_P role_list  */
#line 1451 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31230 "gram.c"
    break;

  case 184: /* DropRoleStmt: DROP GROUP_P IF_P EXISTS role_list  */
#line 1459 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31242 "gram.c"
    break;

  case 185: /* CreateGroupStmt: CREATE GROUP_P RoleId opt_with OptRoleList  */
#line 1477 "gram.y"
                                {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31255 "gram.c"
    break;

  case 186: /* AlterGroupStmt: ALTER GROUP_P RoleSpec add_drop USER role_list  */
#line 1496 "gram.y"
                                {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-3].rolespec);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 31269 "gram.c"
    break;

  case 187: /* add_drop: ADD_P  */
#line 1507 "gram.y"
                                                                                        { (yyval.ival) = +1; }
#line 31275 "gram.c"
    break;

  case 188: /* add_drop: DROP  */
#line 1508 "gram.y"
                                                                                                { (yyval.ival) = -1; }
#line 31281 "gram.c"
    break;

  case 189: /* CreateSchemaStmt: CREATE SCHEMA opt_single_name AUTHORIZATION RoleSpec OptSchemaEltList  */
#line 1520 "gram.y"
                                {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* One can omit the schema name or the authorization id. */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 31296 "gram.c"
    break;

  case 190: /* CreateSchemaStmt: CREATE SCHEMA ColId OptSchemaEltList  */
#line 1531 "gram.y"
                                {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 31311 "gram.c"
    break;

  case 191: /* CreateSchemaStmt: CREATE SCHEMA IF_P NOT EXISTS opt_single_name AUTHORIZATION RoleSpec OptSchemaEltList  */
#line 1542 "gram.y"
                                {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* schema name can be omitted here, too */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 31331 "gram.c"
    break;

  case 192: /* CreateSchemaStmt: CREATE SCHEMA IF_P NOT EXISTS ColId OptSchemaEltList  */
#line 1558 "gram.y"
                                {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* ...but not here */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 31351 "gram.c"
    break;

  case 193: /* OptSchemaEltList: OptSchemaEltList schema_stmt  */
#line 1577 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 31359 "gram.c"
    break;

  case 194: /* OptSchemaEltList: %empty  */
#line 1581 "gram.y"
                                { (yyval.list) = NIL; }
#line 31365 "gram.c"
    break;

  case 201: /* VariableSetStmt: SET set_rest  */
#line 1609 "gram.y"
                                {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 31376 "gram.c"
    break;

  case 202: /* VariableSetStmt: SET LOCAL set_rest  */
#line 1616 "gram.y"
                                {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 31387 "gram.c"
    break;

  case 203: /* VariableSetStmt: SET SESSION set_rest  */
#line 1623 "gram.y"
                                {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 31398 "gram.c"
    break;

  case 204: /* set_rest: TRANSACTION transaction_mode_list  */
#line 1633 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					n->jumble_args = true;
					n->location = -1;
					(yyval.vsetstmt) = n;
				}
#line 31413 "gram.c"
    break;

  case 205: /* set_rest: SESSION CHARACTERISTICS AS TRANSACTION transaction_mode_list  */
#line 1644 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					n->jumble_args = true;
					n->location = -1;
					(yyval.vsetstmt) = n;
				}
#line 31428 "gram.c"
    break;

  case 207: /* generic_set: var_name TO var_list  */
#line 1659 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					n->location = (yylsp[0]);
					(yyval.vsetstmt) = n;
				}
#line 31442 "gram.c"
    break;

  case 208: /* generic_set: var_name '=' var_list  */
#line 1669 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					n->location = (yylsp[0]);
					(yyval.vsetstmt) = n;
				}
#line 31456 "gram.c"
    break;

  case 209: /* generic_set: var_name TO DEFAULT  */
#line 1679 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					n->location = -1;
					(yyval.vsetstmt) = n;
				}
#line 31469 "gram.c"
    break;

  case 210: /* generic_set: var_name '=' DEFAULT  */
#line 1688 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					n->location = -1;
					(yyval.vsetstmt) = n;
				}
#line 31482 "gram.c"
    break;

  case 211: /* set_rest_more: generic_set  */
#line 1699 "gram.y"
                                                                                        {(yyval.vsetstmt) = (yyvsp[0].vsetstmt);}
#line 31488 "gram.c"
    break;

  case 212: /* set_rest_more: var_name FROM CURRENT_P  */
#line 1701 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					n->location = -1;
					(yyval.vsetstmt) = n;
				}
#line 31501 "gram.c"
    break;

  case 213: /* set_rest_more: TIME ZONE zone_value  */
#line 1711 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					n->location = -1;
					n->jumble_args = true;
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 31519 "gram.c"
    break;

  case 214: /* set_rest_more: CATALOG_P Sconst  */
#line 1725 "gram.y"
                                {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 31531 "gram.c"
    break;

  case 215: /* set_rest_more: SCHEMA Sconst  */
#line 1733 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					n->location = (yylsp[0]);
					(yyval.vsetstmt) = n;
				}
#line 31545 "gram.c"
    break;

  case 216: /* set_rest_more: NAMES opt_encoding  */
#line 1743 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					n->location = (yylsp[0]);
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 31562 "gram.c"
    break;

  case 217: /* set_rest_more: ROLE NonReservedWord_or_Sconst  */
#line 1756 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					n->location = (yylsp[0]);
					(yyval.vsetstmt) = n;
				}
#line 31576 "gram.c"
    break;

  case 218: /* set_rest_more: SESSION AUTHORIZATION NonReservedWord_or_Sconst  */
#line 1766 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					n->location = (yylsp[0]);
					(yyval.vsetstmt) = n;
				}
#line 31590 "gram.c"
    break;

  case 219: /* set_rest_more: SESSION AUTHORIZATION DEFAULT  */
#line 1776 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					n->location = -1;
					(yyval.vsetstmt) = n;
				}
#line 31603 "gram.c"
    break;

  case 220: /* set_rest_more: XML_P OPTION document_or_content  */
#line 1785 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					n->jumble_args = true;
					n->location = -1;
					(yyval.vsetstmt) = n;
				}
#line 31618 "gram.c"
    break;

  case 221: /* set_rest_more: TRANSACTION SNAPSHOT Sconst  */
#line 1797 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					n->location = (yylsp[0]);
					(yyval.vsetstmt) = n;
				}
#line 31632 "gram.c"
    break;

  case 222: /* var_name: ColId  */
#line 1808 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 31638 "gram.c"
    break;

  case 223: /* var_name: var_name '.' ColId  */
#line 1810 "gram.y"
                                { (yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str)); }
#line 31644 "gram.c"
    break;

  case 224: /* var_list: var_value  */
#line 1813 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 31650 "gram.c"
    break;

  case 225: /* var_list: var_list ',' var_value  */
#line 1814 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 31656 "gram.c"
    break;

  case 226: /* var_value: opt_boolean_or_string  */
#line 1818 "gram.y"
                                { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 31662 "gram.c"
    break;

  case 227: /* var_value: NumericOnly  */
#line 1820 "gram.y"
                                { (yyval.node) = makeAConst((yyvsp[0].node), (yylsp[0])); }
#line 31668 "gram.c"
    break;

  case 228: /* iso_level: READ UNCOMMITTED  */
#line 1823 "gram.y"
                                                                                { (yyval.str) = "read uncommitted"; }
#line 31674 "gram.c"
    break;

  case 229: /* iso_level: READ COMMITTED  */
#line 1824 "gram.y"
                                                                                        { (yyval.str) = "read committed"; }
#line 31680 "gram.c"
    break;

  case 230: /* iso_level: REPEATABLE READ  */
#line 1825 "gram.y"
                                                                                        { (yyval.str) = "repeatable read"; }
#line 31686 "gram.c"
    break;

  case 231: /* iso_level: SERIALIZABLE  */
#line 1826 "gram.y"
                                                                                        { (yyval.str) = "serializable"; }
#line 31692 "gram.c"
    break;

  case 232: /* opt_boolean_or_string: TRUE_P  */
#line 1830 "gram.y"
                                                                                                { (yyval.str) = "true"; }
#line 31698 "gram.c"
    break;

  case 233: /* opt_boolean_or_string: FALSE_P  */
#line 1831 "gram.y"
                                                                                                { (yyval.str) = "false"; }
#line 31704 "gram.c"
    break;

  case 234: /* opt_boolean_or_string: ON  */
#line 1832 "gram.y"
                                                                                                { (yyval.str) = "on"; }
#line 31710 "gram.c"
    break;

  case 235: /* opt_boolean_or_string: NonReservedWord_or_Sconst  */
#line 1838 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 31716 "gram.c"
    break;

  case 236: /* zone_value: Sconst  */
#line 1851 "gram.y"
                                {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 31724 "gram.c"
    break;

  case 237: /* zone_value: IDENT  */
#line 1855 "gram.y"
                                {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 31732 "gram.c"
    break;

  case 238: /* zone_value: ConstInterval Sconst opt_interval  */
#line 1859 "gram.y"
                                {
					TypeName   *t = (yyvsp[-2].typnam);

					if ((yyvsp[0].list) != NIL)
					{
						A_Const	   *n = (A_Const *) linitial((yyvsp[0].list));

						if ((n->val.ival.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 31753 "gram.c"
    break;

  case 239: /* zone_value: ConstInterval '(' Iconst ')' Sconst  */
#line 1876 "gram.y"
                                {
					TypeName   *t = (yyvsp[-4].typnam);

					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 31765 "gram.c"
    break;

  case 240: /* zone_value: NumericOnly  */
#line 1883 "gram.y"
                                                                                        { (yyval.node) = makeAConst((yyvsp[0].node), (yylsp[0])); }
#line 31771 "gram.c"
    break;

  case 241: /* zone_value: DEFAULT  */
#line 1884 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 31777 "gram.c"
    break;

  case 242: /* zone_value: LOCAL  */
#line 1885 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 31783 "gram.c"
    break;

  case 243: /* opt_encoding: Sconst  */
#line 1889 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 31789 "gram.c"
    break;

  case 244: /* opt_encoding: DEFAULT  */
#line 1890 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 31795 "gram.c"
    break;

  case 245: /* opt_encoding: %empty  */
#line 1891 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 31801 "gram.c"
    break;

  case 246: /* NonReservedWord_or_Sconst: NonReservedWord  */
#line 1895 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 31807 "gram.c"
    break;

  case 247: /* NonReservedWord_or_Sconst: Sconst  */
#line 1896 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 31813 "gram.c"
    break;

  case 248: /* VariableResetStmt: RESET reset_rest  */
#line 1900 "gram.y"
                                                                                        { (yyval.node) = (Node *) (yyvsp[0].vsetstmt); }
#line 31819 "gram.c"
    break;

  case 249: /* reset_rest: generic_reset  */
#line 1904 "gram.y"
                                                                                        { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 31825 "gram.c"
    break;

  case 250: /* reset_rest: TIME ZONE  */
#line 1906 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "timezone";
					n->location = -1;
					(yyval.vsetstmt) = n;
				}
#line 31838 "gram.c"
    break;

  case 251: /* reset_rest: TRANSACTION ISOLATION LEVEL  */
#line 1915 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					n->location = -1;
					(yyval.vsetstmt) = n;
				}
#line 31851 "gram.c"
    break;

  case 252: /* reset_rest: SESSION AUTHORIZATION  */
#line 1924 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "session_authorization";
					n->location = -1;
					(yyval.vsetstmt) = n;
				}
#line 31864 "gram.c"
    break;

  case 253: /* generic_reset: var_name  */
#line 1936 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					n->location = -1;
					(yyval.vsetstmt) = n;
				}
#line 31877 "gram.c"
    break;

  case 254: /* generic_reset: ALL  */
#line 1945 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET_ALL;
					n->location = -1;
					(yyval.vsetstmt) = n;
				}
#line 31889 "gram.c"
    break;

  case 255: /* SetResetClause: SET set_rest  */
#line 1956 "gram.y"
                                                                        { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 31895 "gram.c"
    break;

  case 256: /* SetResetClause: VariableResetStmt  */
#line 1957 "gram.y"
                                                                        { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 31901 "gram.c"
    break;

  case 257: /* FunctionSetResetClause: SET set_rest_more  */
#line 1962 "gram.y"
                                                                        { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 31907 "gram.c"
    break;

  case 258: /* FunctionSetResetClause: VariableResetStmt  */
#line 1963 "gram.y"
                                                                        { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 31913 "gram.c"
    break;

  case 259: /* VariableShowStmt: SHOW var_name  */
#line 1969 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31924 "gram.c"
    break;

  case 260: /* VariableShowStmt: SHOW TIME ZONE  */
#line 1976 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 31935 "gram.c"
    break;

  case 261: /* VariableShowStmt: SHOW TRANSACTION ISOLATION LEVEL  */
#line 1983 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 31946 "gram.c"
    break;

  case 262: /* VariableShowStmt: SHOW SESSION AUTHORIZATION  */
#line 1990 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 31957 "gram.c"
    break;

  case 263: /* VariableShowStmt: SHOW ALL  */
#line 1997 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 31968 "gram.c"
    break;

  case 264: /* ConstraintsSetStmt: SET CONSTRAINTS constraints_set_list constraints_set_mode  */
#line 2008 "gram.y"
                                {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);

					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 31980 "gram.c"
    break;

  case 265: /* constraints_set_list: ALL  */
#line 2018 "gram.y"
                                                                                                        { (yyval.list) = NIL; }
#line 31986 "gram.c"
    break;

  case 266: /* constraints_set_list: qualified_name_list  */
#line 2019 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 31992 "gram.c"
    break;

  case 267: /* constraints_set_mode: DEFERRED  */
#line 2023 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 31998 "gram.c"
    break;

  case 268: /* constraints_set_mode: IMMEDIATE  */
#line 2024 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 32004 "gram.c"
    break;

  case 269: /* CheckPointStmt: CHECKPOINT  */
#line 2033 "gram.y"
                                {
					CheckPointStmt *n = makeNode(CheckPointStmt);

					(yyval.node) = (Node *) n;
				}
#line 32014 "gram.c"
    break;

  case 270: /* DiscardStmt: DISCARD ALL  */
#line 2049 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 32025 "gram.c"
    break;

  case 271: /* DiscardStmt: DISCARD TEMP  */
#line 2056 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 32036 "gram.c"
    break;

  case 272: /* DiscardStmt: DISCARD TEMPORARY  */
#line 2063 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 32047 "gram.c"
    break;

  case 273: /* DiscardStmt: DISCARD PLANS  */
#line 2070 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 32058 "gram.c"
    break;

  case 274: /* DiscardStmt: DISCARD SEQUENCES  */
#line 2077 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
#line 32069 "gram.c"
    break;

  case 275: /* AlterTableStmt: ALTER TABLE relation_expr alter_table_cmds  */
#line 2097 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32083 "gram.c"
    break;

  case 276: /* AlterTableStmt: ALTER TABLE IF_P EXISTS relation_expr alter_table_cmds  */
#line 2107 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32097 "gram.c"
    break;

  case 277: /* AlterTableStmt: ALTER TABLE relation_expr partition_cmd  */
#line 2117 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32111 "gram.c"
    break;

  case 278: /* AlterTableStmt: ALTER TABLE IF_P EXISTS relation_expr partition_cmd  */
#line 2127 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32125 "gram.c"
    break;

  case 279: /* AlterTableStmt: ALTER TABLE ALL IN_P TABLESPACE name SET TABLESPACE name opt_nowait  */
#line 2137 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 32141 "gram.c"
    break;

  case 280: /* AlterTableStmt: ALTER TABLE ALL IN_P TABLESPACE name OWNED BY role_list SET TABLESPACE name opt_nowait  */
#line 2149 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 32157 "gram.c"
    break;

  case 281: /* AlterTableStmt: ALTER INDEX qualified_name alter_table_cmds  */
#line 2161 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32171 "gram.c"
    break;

  case 282: /* AlterTableStmt: ALTER INDEX IF_P EXISTS qualified_name alter_table_cmds  */
#line 2171 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32185 "gram.c"
    break;

  case 283: /* AlterTableStmt: ALTER INDEX qualified_name index_partition_cmd  */
#line 2181 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32199 "gram.c"
    break;

  case 284: /* AlterTableStmt: ALTER INDEX ALL IN_P TABLESPACE name SET TABLESPACE name opt_nowait  */
#line 2191 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 32215 "gram.c"
    break;

  case 285: /* AlterTableStmt: ALTER INDEX ALL IN_P TABLESPACE name OWNED BY role_list SET TABLESPACE name opt_nowait  */
#line 2203 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 32231 "gram.c"
    break;

  case 286: /* AlterTableStmt: ALTER SEQUENCE qualified_name alter_table_cmds  */
#line 2215 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32245 "gram.c"
    break;

  case 287: /* AlterTableStmt: ALTER SEQUENCE IF_P EXISTS qualified_name alter_table_cmds  */
#line 2225 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32259 "gram.c"
    break;

  case 288: /* AlterTableStmt: ALTER VIEW qualified_name alter_table_cmds  */
#line 2235 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32273 "gram.c"
    break;

  case 289: /* AlterTableStmt: ALTER VIEW IF_P EXISTS qualified_name alter_table_cmds  */
#line 2245 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32287 "gram.c"
    break;

  case 290: /* AlterTableStmt: ALTER MATERIALIZED VIEW qualified_name alter_table_cmds  */
#line 2255 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32301 "gram.c"
    break;

  case 291: /* AlterTableStmt: ALTER MATERIALIZED VIEW IF_P EXISTS qualified_name alter_table_cmds  */
#line 2265 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32315 "gram.c"
    break;

  case 292: /* AlterTableStmt: ALTER MATERIALIZED VIEW ALL IN_P TABLESPACE name SET TABLESPACE name opt_nowait  */
#line 2275 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 32331 "gram.c"
    break;

  case 293: /* AlterTableStmt: ALTER MATERIALIZED VIEW ALL IN_P TABLESPACE name OWNED BY role_list SET TABLESPACE name opt_nowait  */
#line 2287 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 32347 "gram.c"
    break;

  case 294: /* AlterTableStmt: ALTER FOREIGN TABLE relation_expr alter_table_cmds  */
#line 2299 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32361 "gram.c"
    break;

  case 295: /* AlterTableStmt: ALTER FOREIGN TABLE IF_P EXISTS relation_expr alter_table_cmds  */
#line 2309 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32375 "gram.c"
    break;

  case 296: /* alter_table_cmds: alter_table_cmd  */
#line 2321 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 32381 "gram.c"
    break;

  case 297: /* alter_table_cmds: alter_table_cmds ',' alter_table_cmd  */
#line 2322 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 32387 "gram.c"
    break;

  case 298: /* partition_cmd: ATTACH PARTITION qualified_name PartitionBoundSpec  */
#line 2328 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = (yyvsp[0].partboundspec);
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 32404 "gram.c"
    break;

  case 299: /* partition_cmd: DETACH PARTITION qualified_name opt_concurrently  */
#line 2342 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->concurrent = (yyvsp[0].boolean);
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 32421 "gram.c"
    break;

  case 300: /* partition_cmd: DETACH PARTITION qualified_name FINALIZE  */
#line 2355 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartitionFinalize;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;
					(yyval.node) = (Node *) n;
				}
#line 32437 "gram.c"
    break;

  case 301: /* index_partition_cmd: ATTACH PARTITION qualified_name  */
#line 2371 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[0].range);
					cmd->bound = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 32454 "gram.c"
    break;

  case 302: /* alter_table_cmd: ADD_P columnDef  */
#line 2388 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32467 "gram.c"
    break;

  case 303: /* alter_table_cmd: ADD_P IF_P NOT EXISTS columnDef  */
#line 2398 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32480 "gram.c"
    break;

  case 304: /* alter_table_cmd: ADD_P COLUMN columnDef  */
#line 2408 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32493 "gram.c"
    break;

  case 305: /* alter_table_cmd: ADD_P COLUMN IF_P NOT EXISTS columnDef  */
#line 2418 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32506 "gram.c"
    break;

  case 306: /* alter_table_cmd: ALTER opt_column ColId alter_column_default  */
#line 2428 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 32519 "gram.c"
    break;

  case 307: /* alter_table_cmd: ALTER opt_column ColId DROP NOT NULL_P  */
#line 2438 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				}
#line 32531 "gram.c"
    break;

  case 308: /* alter_table_cmd: ALTER opt_column ColId SET NOT NULL_P  */
#line 2447 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				}
#line 32543 "gram.c"
    break;

  case 309: /* alter_table_cmd: ALTER opt_column ColId SET EXPRESSION AS '(' a_expr ')'  */
#line 2456 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetExpression;
					n->name = (yyvsp[-6].str);
					n->def = (yyvsp[-1].node);
					(yyval.node) = (Node *) n;
				}
#line 32556 "gram.c"
    break;

  case 310: /* alter_table_cmd: ALTER opt_column ColId DROP EXPRESSION  */
#line 2466 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-2].str);
					(yyval.node) = (Node *) n;
				}
#line 32568 "gram.c"
    break;

  case 311: /* alter_table_cmd: ALTER opt_column ColId DROP EXPRESSION IF_P EXISTS  */
#line 2475 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32581 "gram.c"
    break;

  case 312: /* alter_table_cmd: ALTER opt_column ColId SET STATISTICS set_statistics_value  */
#line 2485 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 32594 "gram.c"
    break;

  case 313: /* alter_table_cmd: ALTER opt_column Iconst SET STATISTICS set_statistics_value  */
#line 2495 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					if ((yyvsp[-3].ival) <= 0 || (yyvsp[-3].ival) > PG_INT16_MAX)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("column number must be in range from 1 to %d", PG_INT16_MAX),
								 parser_errposition((yylsp[-3]))));

					n->subtype = AT_SetStatistics;
					n->num = (int16) (yyvsp[-3].ival);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 32613 "gram.c"
    break;

  case 314: /* alter_table_cmd: ALTER opt_column ColId SET reloptions  */
#line 2511 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32626 "gram.c"
    break;

  case 315: /* alter_table_cmd: ALTER opt_column ColId RESET reloptions  */
#line 2521 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32639 "gram.c"
    break;

  case 316: /* alter_table_cmd: ALTER opt_column ColId SET column_storage  */
#line 2531 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 32652 "gram.c"
    break;

  case 317: /* alter_table_cmd: ALTER opt_column ColId SET column_compression  */
#line 2541 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetCompression;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 32665 "gram.c"
    break;

  case 318: /* alter_table_cmd: ALTER opt_column ColId ADD_P GENERATED generated_when AS IDENTITY_P OptParenthesizedSeqOptList  */
#line 2551 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);

					c->contype = CONSTR_IDENTITY;
					c->generated_when = (yyvsp[-3].ival);
					c->options = (yyvsp[0].list);
					c->location = (yylsp[-4]);

					n->subtype = AT_AddIdentity;
					n->name = (yyvsp[-6].str);
					n->def = (Node *) c;

					(yyval.node) = (Node *) n;
				}
#line 32685 "gram.c"
    break;

  case 319: /* alter_table_cmd: ALTER opt_column ColId alter_identity_column_option_list  */
#line 2568 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetIdentity;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32698 "gram.c"
    break;

  case 320: /* alter_table_cmd: ALTER opt_column ColId DROP IDENTITY_P  */
#line 2578 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-2].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32711 "gram.c"
    break;

  case 321: /* alter_table_cmd: ALTER opt_column ColId DROP IDENTITY_P IF_P EXISTS  */
#line 2588 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32724 "gram.c"
    break;

  case 322: /* alter_table_cmd: DROP opt_column IF_P EXISTS ColId opt_drop_behavior  */
#line 2598 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32738 "gram.c"
    break;

  case 323: /* alter_table_cmd: DROP opt_column ColId opt_drop_behavior  */
#line 2609 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32752 "gram.c"
    break;

  case 324: /* alter_table_cmd: ALTER opt_column ColId opt_set_data TYPE_P Typename opt_collate_clause alter_using  */
#line 2623 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);

					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 32771 "gram.c"
    break;

  case 325: /* alter_table_cmd: ALTER opt_column ColId alter_generic_options  */
#line 2639 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32784 "gram.c"
    break;

  case 326: /* alter_table_cmd: ADD_P TableConstraint  */
#line 2649 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 32796 "gram.c"
    break;

  case 327: /* alter_table_cmd: ALTER CONSTRAINT name ConstraintAttributeSpec  */
#line 2658 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ATAlterConstraint *c = makeNode(ATAlterConstraint);

					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->conname = (yyvsp[-1].str);
					if ((yyvsp[0].ival) & (CAS_NOT_ENFORCED | CAS_ENFORCED))
						c->alterEnforceability = true;
					if ((yyvsp[0].ival) & (CAS_DEFERRABLE | CAS_NOT_DEFERRABLE |
							  CAS_INITIALLY_DEFERRED | CAS_INITIALLY_IMMEDIATE))
						c->alterDeferrability = true;
					if ((yyvsp[0].ival) & CAS_NO_INHERIT)
						c->alterInheritability = true;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
									&c->deferrable,
									&c->initdeferred,
									&c->is_enforced,
									NULL,
									&c->noinherit,
									yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 32824 "gram.c"
    break;

  case 328: /* alter_table_cmd: ALTER CONSTRAINT name INHERIT  */
#line 2683 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ATAlterConstraint *c = makeNode(ATAlterConstraint);

					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->conname = (yyvsp[-1].str);
					c->alterInheritability = true;
					c->noinherit = false;

					(yyval.node) = (Node *) n;
				}
#line 32841 "gram.c"
    break;

  case 329: /* alter_table_cmd: VALIDATE CONSTRAINT name  */
#line 2697 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32853 "gram.c"
    break;

  case 330: /* alter_table_cmd: DROP CONSTRAINT IF_P EXISTS name opt_drop_behavior  */
#line 2706 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32867 "gram.c"
    break;

  case 331: /* alter_table_cmd: DROP CONSTRAINT name opt_drop_behavior  */
#line 2717 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32881 "gram.c"
    break;

  case 332: /* alter_table_cmd: SET WITHOUT OIDS  */
#line 2728 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropOids;
					(yyval.node) = (Node *) n;
				}
#line 32892 "gram.c"
    break;

  case 333: /* alter_table_cmd: CLUSTER ON name  */
#line 2736 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32904 "gram.c"
    break;

  case 334: /* alter_table_cmd: SET WITHOUT CLUSTER  */
#line 2745 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 32916 "gram.c"
    break;

  case 335: /* alter_table_cmd: SET LOGGED  */
#line 2754 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetLogged;
					(yyval.node) = (Node *) n;
				}
#line 32927 "gram.c"
    break;

  case 336: /* alter_table_cmd: SET UNLOGGED  */
#line 2762 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetUnLogged;
					(yyval.node) = (Node *) n;
				}
#line 32938 "gram.c"
    break;

  case 337: /* alter_table_cmd: ENABLE_P TRIGGER name  */
#line 2770 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32950 "gram.c"
    break;

  case 338: /* alter_table_cmd: ENABLE_P ALWAYS TRIGGER name  */
#line 2779 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32962 "gram.c"
    break;

  case 339: /* alter_table_cmd: ENABLE_P REPLICA TRIGGER name  */
#line 2788 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32974 "gram.c"
    break;

  case 340: /* alter_table_cmd: ENABLE_P TRIGGER ALL  */
#line 2797 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *) n;
				}
#line 32985 "gram.c"
    break;

  case 341: /* alter_table_cmd: ENABLE_P TRIGGER USER  */
#line 2805 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *) n;
				}
#line 32996 "gram.c"
    break;

  case 342: /* alter_table_cmd: DISABLE_P TRIGGER name  */
#line 2813 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33008 "gram.c"
    break;

  case 343: /* alter_table_cmd: DISABLE_P TRIGGER ALL  */
#line 2822 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *) n;
				}
#line 33019 "gram.c"
    break;

  case 344: /* alter_table_cmd: DISABLE_P TRIGGER USER  */
#line 2830 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *) n;
				}
#line 33030 "gram.c"
    break;

  case 345: /* alter_table_cmd: ENABLE_P RULE name  */
#line 2838 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33042 "gram.c"
    break;

  case 346: /* alter_table_cmd: ENABLE_P ALWAYS RULE name  */
#line 2847 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33054 "gram.c"
    break;

  case 347: /* alter_table_cmd: ENABLE_P REPLICA RULE name  */
#line 2856 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33066 "gram.c"
    break;

  case 348: /* alter_table_cmd: DISABLE_P RULE name  */
#line 2865 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33078 "gram.c"
    break;

  case 349: /* alter_table_cmd: INHERIT qualified_name  */
#line 2874 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *) n;
				}
#line 33090 "gram.c"
    break;

  case 350: /* alter_table_cmd: NO INHERIT qualified_name  */
#line 2883 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *) n;
				}
#line 33102 "gram.c"
    break;

  case 351: /* alter_table_cmd: OF any_name  */
#line 2892 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName   *def = makeTypeNameFromNameList((yyvsp[0].list));

					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *) n;
				}
#line 33116 "gram.c"
    break;

  case 352: /* alter_table_cmd: NOT OF  */
#line 2903 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropOf;
					(yyval.node) = (Node *) n;
				}
#line 33127 "gram.c"
    break;

  case 353: /* alter_table_cmd: OWNER TO RoleSpec  */
#line 2911 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ChangeOwner;
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 33139 "gram.c"
    break;

  case 354: /* alter_table_cmd: SET ACCESS METHOD set_access_method_name  */
#line 2920 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetAccessMethod;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33151 "gram.c"
    break;

  case 355: /* alter_table_cmd: SET TABLESPACE name  */
#line 2929 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33163 "gram.c"
    break;

  case 356: /* alter_table_cmd: SET reloptions  */
#line 2938 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetRelOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33175 "gram.c"
    break;

  case 357: /* alter_table_cmd: RESET reloptions  */
#line 2947 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ResetRelOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33187 "gram.c"
    break;

  case 358: /* alter_table_cmd: REPLICA IDENTITY_P replica_identity  */
#line 2956 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 33199 "gram.c"
    break;

  case 359: /* alter_table_cmd: ENABLE_P ROW LEVEL SECURITY  */
#line 2965 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 33210 "gram.c"
    break;

  case 360: /* alter_table_cmd: DISABLE_P ROW LEVEL SECURITY  */
#line 2973 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 33221 "gram.c"
    break;

  case 361: /* alter_table_cmd: FORCE ROW LEVEL SECURITY  */
#line 2981 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ForceRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 33232 "gram.c"
    break;

  case 362: /* alter_table_cmd: NO FORCE ROW LEVEL SECURITY  */
#line 2989 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_NoForceRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 33243 "gram.c"
    break;

  case 363: /* alter_table_cmd: alter_generic_options  */
#line 2996 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_GenericOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33255 "gram.c"
    break;

  case 364: /* alter_column_default: SET DEFAULT a_expr  */
#line 3006 "gram.y"
                                                                { (yyval.node) = (yyvsp[0].node); }
#line 33261 "gram.c"
    break;

  case 365: /* alter_column_default: DROP DEFAULT  */
#line 3007 "gram.y"
                                                                { (yyval.node) = NULL; }
#line 33267 "gram.c"
    break;

  case 366: /* opt_collate_clause: COLLATE any_name  */
#line 3012 "gram.y"
                                {
					CollateClause *n = makeNode(CollateClause);

					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 33280 "gram.c"
    break;

  case 367: /* opt_collate_clause: %empty  */
#line 3020 "gram.y"
                                                                { (yyval.node) = NULL; }
#line 33286 "gram.c"
    break;

  case 368: /* alter_using: USING a_expr  */
#line 3024 "gram.y"
                                                                { (yyval.node) = (yyvsp[0].node); }
#line 33292 "gram.c"
    break;

  case 369: /* alter_using: %empty  */
#line 3025 "gram.y"
                                                                { (yyval.node) = NULL; }
#line 33298 "gram.c"
    break;

  case 370: /* replica_identity: NOTHING  */
#line 3030 "gram.y"
                                {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 33310 "gram.c"
    break;

  case 371: /* replica_identity: FULL  */
#line 3038 "gram.y"
                                {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 33322 "gram.c"
    break;

  case 372: /* replica_identity: DEFAULT  */
#line 3046 "gram.y"
                                {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 33334 "gram.c"
    break;

  case 373: /* replica_identity: USING INDEX name  */
#line 3054 "gram.y"
                                {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33346 "gram.c"
    break;

  case 374: /* reloptions: '(' reloption_list ')'  */
#line 3064 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 33352 "gram.c"
    break;

  case 375: /* opt_reloptions: WITH reloptions  */
#line 3067 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 33358 "gram.c"
    break;

  case 376: /* opt_reloptions: %empty  */
#line 3068 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 33364 "gram.c"
    break;

  case 377: /* reloption_list: reloption_elem  */
#line 3072 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33370 "gram.c"
    break;

  case 378: /* reloption_list: reloption_list ',' reloption_elem  */
#line 3073 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 33376 "gram.c"
    break;

  case 379: /* reloption_elem: ColLabel '=' def_arg  */
#line 3079 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 33384 "gram.c"
    break;

  case 380: /* reloption_elem: ColLabel  */
#line 3083 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 33392 "gram.c"
    break;

  case 381: /* reloption_elem: ColLabel '.' ColLabel '=' def_arg  */
#line 3087 "gram.y"
                                {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC, (yylsp[-4]));
				}
#line 33401 "gram.c"
    break;

  case 382: /* reloption_elem: ColLabel '.' ColLabel  */
#line 3092 "gram.y"
                                {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC, (yylsp[-2]));
				}
#line 33409 "gram.c"
    break;

  case 383: /* alter_identity_column_option_list: alter_identity_column_option  */
#line 3099 "gram.y"
                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33415 "gram.c"
    break;

  case 384: /* alter_identity_column_option_list: alter_identity_column_option_list alter_identity_column_option  */
#line 3101 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33421 "gram.c"
    break;

  case 385: /* alter_identity_column_option: RESTART  */
#line 3106 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 33429 "gram.c"
    break;

  case 386: /* alter_identity_column_option: RESTART opt_with NumericOnly  */
#line 3110 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("restart", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 33437 "gram.c"
    break;

  case 387: /* alter_identity_column_option: SET SeqOptElem  */
#line 3114 "gram.y"
                                {
					if (strcmp((yyvsp[0].defelt)->defname, "as") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "restart") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "owned_by") == 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("sequence option \"%s\" not supported here", (yyvsp[0].defelt)->defname),
								 parser_errposition((yylsp[0]))));
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 33452 "gram.c"
    break;

  case 388: /* alter_identity_column_option: SET GENERATED generated_when  */
#line 3125 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("generated", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 33460 "gram.c"
    break;

  case 389: /* set_statistics_value: SignedIconst  */
#line 3131 "gram.y"
                                                                        { (yyval.node) = (Node *) makeInteger((yyvsp[0].ival)); }
#line 33466 "gram.c"
    break;

  case 390: /* set_statistics_value: DEFAULT  */
#line 3132 "gram.y"
                                                                                { (yyval.node) = NULL; }
#line 33472 "gram.c"
    break;

  case 391: /* set_access_method_name: ColId  */
#line 3136 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 33478 "gram.c"
    break;

  case 392: /* set_access_method_name: DEFAULT  */
#line 3137 "gram.y"
                                                                                { (yyval.str) = NULL; }
#line 33484 "gram.c"
    break;

  case 393: /* PartitionBoundSpec: FOR VALUES WITH '(' hash_partbound ')'  */
#line 3143 "gram.y"
                                {
					ListCell   *lc;
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_HASH;
					n->modulus = n->remainder = -1;

					foreach (lc, (yyvsp[-1].list))
					{
						DefElem    *opt = lfirst_node(DefElem, lc);

						if (strcmp(opt->defname, "modulus") == 0)
						{
							if (n->modulus != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("modulus for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->modulus = defGetInt32(opt);
						}
						else if (strcmp(opt->defname, "remainder") == 0)
						{
							if (n->remainder != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("remainder for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->remainder = defGetInt32(opt);
						}
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized hash partition bound specification \"%s\"",
											opt->defname),
									 parser_errposition(opt->location)));
					}

					if (n->modulus == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("modulus for hash partition must be specified"),
								 parser_errposition((yylsp[-3]))));
					if (n->remainder == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("remainder for hash partition must be specified"),
								 parser_errposition((yylsp[-3]))));

					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 33541 "gram.c"
    break;

  case 394: /* PartitionBoundSpec: FOR VALUES IN_P '(' expr_list ')'  */
#line 3198 "gram.y"
                                {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_LIST;
					n->is_default = false;
					n->listdatums = (yyvsp[-1].list);
					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 33556 "gram.c"
    break;

  case 395: /* PartitionBoundSpec: FOR VALUES FROM '(' expr_list ')' TO '(' expr_list ')'  */
#line 3211 "gram.y"
                                {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_RANGE;
					n->is_default = false;
					n->lowerdatums = (yyvsp[-5].list);
					n->upperdatums = (yyvsp[-1].list);
					n->location = (yylsp[-7]);

					(yyval.partboundspec) = n;
				}
#line 33572 "gram.c"
    break;

  case 396: /* PartitionBoundSpec: DEFAULT  */
#line 3225 "gram.y"
                                {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->is_default = true;
					n->location = (yylsp[0]);

					(yyval.partboundspec) = n;
				}
#line 33585 "gram.c"
    break;

  case 397: /* hash_partbound_elem: NonReservedWord Iconst  */
#line 3237 "gram.y"
                        {
				(yyval.defelt) = makeDefElem((yyvsp[-1].str), (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-1]));
			}
#line 33593 "gram.c"
    break;

  case 398: /* hash_partbound: hash_partbound_elem  */
#line 3244 "gram.y"
                        {
				(yyval.list) = list_make1((yyvsp[0].defelt));
			}
#line 33601 "gram.c"
    break;

  case 399: /* hash_partbound: hash_partbound ',' hash_partbound_elem  */
#line 3248 "gram.y"
                        {
				(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
			}
#line 33609 "gram.c"
    break;

  case 400: /* AlterCompositeTypeStmt: ALTER TYPE_P any_name alter_type_cmds  */
#line 3262 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TYPE;
					(yyval.node) = (Node *) n;
				}
#line 33623 "gram.c"
    break;

  case 401: /* alter_type_cmds: alter_type_cmd  */
#line 3274 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 33629 "gram.c"
    break;

  case 402: /* alter_type_cmds: alter_type_cmds ',' alter_type_cmd  */
#line 3275 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 33635 "gram.c"
    break;

  case 403: /* alter_type_cmd: ADD_P ATTRIBUTE TableFuncElement opt_drop_behavior  */
#line 3281 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 33648 "gram.c"
    break;

  case 404: /* alter_type_cmd: DROP ATTRIBUTE IF_P EXISTS ColId opt_drop_behavior  */
#line 3291 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 33662 "gram.c"
    break;

  case 405: /* alter_type_cmd: DROP ATTRIBUTE ColId opt_drop_behavior  */
#line 3302 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 33676 "gram.c"
    break;

  case 406: /* alter_type_cmd: ALTER ATTRIBUTE ColId opt_set_data TYPE_P Typename opt_collate_clause opt_drop_behavior  */
#line 3313 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);

					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 33696 "gram.c"
    break;

  case 407: /* ClosePortalStmt: CLOSE cursor_name  */
#line 3340 "gram.y"
                                {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);

					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33707 "gram.c"
    break;

  case 408: /* ClosePortalStmt: CLOSE ALL  */
#line 3347 "gram.y"
                                {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);

					n->portalname = NULL;
					(yyval.node) = (Node *) n;
				}
#line 33718 "gram.c"
    break;

  case 409: /* CopyStmt: COPY opt_binary qualified_name opt_column_list copy_from opt_program copy_file_name copy_delimiter opt_with copy_options where_clause  */
#line 3383 "gram.y"
                                {
					CopyStmt *n = makeNode(CopyStmt);

					n->relation = (yyvsp[-8].range);
					n->query = NULL;
					n->attlist = (yyvsp[-7].list);
					n->is_from = (yyvsp[-6].boolean);
					n->is_program = (yyvsp[-5].boolean);
					n->filename = (yyvsp[-4].str);
					n->whereClause = (yyvsp[0].node);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-3]))));

					if (!n->is_from && n->whereClause != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("WHERE clause not allowed with COPY TO"),
								 parser_errposition((yylsp[0]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-9].defelt))
						n->options = lappend(n->options, (yyvsp[-9].defelt));
					if ((yyvsp[-3].defelt))
						n->options = lappend(n->options, (yyvsp[-3].defelt));
					if ((yyvsp[-1].list))
						n->options = list_concat(n->options, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 33756 "gram.c"
    break;

  case 410: /* CopyStmt: COPY '(' PreparableStmt ')' TO opt_program copy_file_name opt_with copy_options  */
#line 3417 "gram.y"
                                {
					CopyStmt *n = makeNode(CopyStmt);

					updatePreparableStmtEnd((yyvsp[-6].node), (yylsp[-5]));
					n->relation = NULL;
					n->query = (yyvsp[-6].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[-3].boolean);
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-4]))));

					(yyval.node) = (Node *) n;
				}
#line 33781 "gram.c"
    break;

  case 411: /* copy_from: FROM  */
#line 3440 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 33787 "gram.c"
    break;

  case 412: /* copy_from: TO  */
#line 3441 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 33793 "gram.c"
    break;

  case 413: /* opt_program: PROGRAM  */
#line 3445 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 33799 "gram.c"
    break;

  case 414: /* opt_program: %empty  */
#line 3446 "gram.y"
                                                                                        { (yyval.boolean) = false; }
#line 33805 "gram.c"
    break;

  case 415: /* copy_file_name: Sconst  */
#line 3455 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 33811 "gram.c"
    break;

  case 416: /* copy_file_name: STDIN  */
#line 3456 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 33817 "gram.c"
    break;

  case 417: /* copy_file_name: STDOUT  */
#line 3457 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 33823 "gram.c"
    break;

  case 418: /* copy_options: copy_opt_list  */
#line 3460 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 33829 "gram.c"
    break;

  case 419: /* copy_options: '(' copy_generic_opt_list ')'  */
#line 3461 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 33835 "gram.c"
    break;

  case 420: /* copy_opt_list: copy_opt_list copy_opt_item  */
#line 3466 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33841 "gram.c"
    break;

  case 421: /* copy_opt_list: %empty  */
#line 3467 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 33847 "gram.c"
    break;

  case 422: /* copy_opt_item: BINARY  */
#line 3472 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("binary"), (yylsp[0]));
				}
#line 33855 "gram.c"
    break;

  case 423: /* copy_opt_item: FREEZE  */
#line 3476 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("freeze", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 33863 "gram.c"
    break;

  case 424: /* copy_opt_item: DELIMITER opt_as Sconst  */
#line 3480 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("delimiter", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 33871 "gram.c"
    break;

  case 425: /* copy_opt_item: NULL_P opt_as Sconst  */
#line 3484 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("null", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 33879 "gram.c"
    break;

  case 426: /* copy_opt_item: CSV  */
#line 3488 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("csv"), (yylsp[0]));
				}
#line 33887 "gram.c"
    break;

  case 427: /* copy_opt_item: HEADER_P  */
#line 3492 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("header", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 33895 "gram.c"
    break;

  case 428: /* copy_opt_item: QUOTE opt_as Sconst  */
#line 3496 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("quote", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 33903 "gram.c"
    break;

  case 429: /* copy_opt_item: ESCAPE opt_as Sconst  */
#line 3500 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("escape", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 33911 "gram.c"
    break;

  case 430: /* copy_opt_item: FORCE QUOTE columnList  */
#line 3504 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force_quote", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 33919 "gram.c"
    break;

  case 431: /* copy_opt_item: FORCE QUOTE '*'  */
#line 3508 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force_quote", (Node *) makeNode(A_Star), (yylsp[-2]));
				}
#line 33927 "gram.c"
    break;

  case 432: /* copy_opt_item: FORCE NOT NULL_P columnList  */
#line 3512 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *) (yyvsp[0].list), (yylsp[-3]));
				}
#line 33935 "gram.c"
    break;

  case 433: /* copy_opt_item: FORCE NOT NULL_P '*'  */
#line 3516 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *) makeNode(A_Star), (yylsp[-3]));
				}
#line 33943 "gram.c"
    break;

  case 434: /* copy_opt_item: FORCE NULL_P columnList  */
#line 3520 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force_null", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 33951 "gram.c"
    break;

  case 435: /* copy_opt_item: FORCE NULL_P '*'  */
#line 3524 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force_null", (Node *) makeNode(A_Star), (yylsp[-2]));
				}
#line 33959 "gram.c"
    break;

  case 436: /* copy_opt_item: ENCODING Sconst  */
#line 3528 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("encoding", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 33967 "gram.c"
    break;

  case 437: /* opt_binary: BINARY  */
#line 3537 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("binary"), (yylsp[0]));
				}
#line 33975 "gram.c"
    break;

  case 438: /* opt_binary: %empty  */
#line 3540 "gram.y"
                                                                                                { (yyval.defelt) = NULL; }
#line 33981 "gram.c"
    break;

  case 439: /* copy_delimiter: opt_using DELIMITERS Sconst  */
#line 3545 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("delimiter", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 33989 "gram.c"
    break;

  case 440: /* copy_delimiter: %empty  */
#line 3548 "gram.y"
                                                                                                { (yyval.defelt) = NULL; }
#line 33995 "gram.c"
    break;

  case 443: /* copy_generic_opt_list: copy_generic_opt_elem  */
#line 3559 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 34003 "gram.c"
    break;

  case 444: /* copy_generic_opt_list: copy_generic_opt_list ',' copy_generic_opt_elem  */
#line 3563 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 34011 "gram.c"
    break;

  case 445: /* copy_generic_opt_elem: ColLabel copy_generic_opt_arg  */
#line 3570 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 34019 "gram.c"
    break;

  case 446: /* copy_generic_opt_arg: opt_boolean_or_string  */
#line 3576 "gram.y"
                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 34025 "gram.c"
    break;

  case 447: /* copy_generic_opt_arg: NumericOnly  */
#line 3577 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 34031 "gram.c"
    break;

  case 448: /* copy_generic_opt_arg: '*'  */
#line 3578 "gram.y"
                                                                                { (yyval.node) = (Node *) makeNode(A_Star); }
#line 34037 "gram.c"
    break;

  case 449: /* copy_generic_opt_arg: DEFAULT  */
#line 3579 "gram.y"
                                                        { (yyval.node) = (Node *) makeString("default"); }
#line 34043 "gram.c"
    break;

  case 450: /* copy_generic_opt_arg: '(' copy_generic_opt_arg_list ')'  */
#line 3580 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 34049 "gram.c"
    break;

  case 451: /* copy_generic_opt_arg: %empty  */
#line 3581 "gram.y"
                                                                        { (yyval.node) = NULL; }
#line 34055 "gram.c"
    break;

  case 452: /* copy_generic_opt_arg_list: copy_generic_opt_arg_list_item  */
#line 3586 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 34063 "gram.c"
    break;

  case 453: /* copy_generic_opt_arg_list: copy_generic_opt_arg_list ',' copy_generic_opt_arg_list_item  */
#line 3590 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 34071 "gram.c"
    break;

  case 454: /* copy_generic_opt_arg_list_item: opt_boolean_or_string  */
#line 3597 "gram.y"
                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 34077 "gram.c"
    break;

  case 455: /* CreateStmt: CREATE OptTemp TABLE qualified_name '(' OptTableElementList ')' OptInherit OptPartitionSpec table_access_method_clause OptWith OnCommitOption OptTableSpace  */
#line 3611 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-9].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 34099 "gram.c"
    break;

  case 456: /* CreateStmt: CREATE OptTemp TABLE IF_P NOT EXISTS qualified_name '(' OptTableElementList ')' OptInherit OptPartitionSpec table_access_method_clause OptWith OnCommitOption OptTableSpace  */
#line 3631 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-9].range)->relpersistence = (yyvsp[-14].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34121 "gram.c"
    break;

  case 457: /* CreateStmt: CREATE OptTemp TABLE qualified_name OF any_name OptTypedTableElementList OptPartitionSpec table_access_method_clause OptWith OnCommitOption OptTableSpace  */
#line 3651 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-8].range)->relpersistence = (yyvsp[-10].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 34144 "gram.c"
    break;

  case 458: /* CreateStmt: CREATE OptTemp TABLE IF_P NOT EXISTS qualified_name OF any_name OptTypedTableElementList OptPartitionSpec table_access_method_clause OptWith OnCommitOption OptTableSpace  */
#line 3672 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-8].range)->relpersistence = (yyvsp[-13].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34167 "gram.c"
    break;

  case 459: /* CreateStmt: CREATE OptTemp TABLE qualified_name PARTITION OF qualified_name OptTypedTableElementList PartitionBoundSpec OptPartitionSpec table_access_method_clause OptWith OnCommitOption OptTableSpace  */
#line 3693 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-10].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 34190 "gram.c"
    break;

  case 460: /* CreateStmt: CREATE OptTemp TABLE IF_P NOT EXISTS qualified_name PARTITION OF qualified_name OptTypedTableElementList PartitionBoundSpec OptPartitionSpec table_access_method_clause OptWith OnCommitOption OptTableSpace  */
#line 3714 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-10].range)->relpersistence = (yyvsp[-15].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34213 "gram.c"
    break;

  case 461: /* OptTemp: TEMPORARY  */
#line 3745 "gram.y"
                                                                { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 34219 "gram.c"
    break;

  case 462: /* OptTemp: TEMP  */
#line 3746 "gram.y"
                                                                        { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 34225 "gram.c"
    break;

  case 463: /* OptTemp: LOCAL TEMPORARY  */
#line 3747 "gram.y"
                                                                { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 34231 "gram.c"
    break;

  case 464: /* OptTemp: LOCAL TEMP  */
#line 3748 "gram.y"
                                                                { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 34237 "gram.c"
    break;

  case 465: /* OptTemp: GLOBAL TEMPORARY  */
#line 3750 "gram.y"
                                {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 34248 "gram.c"
    break;

  case 466: /* OptTemp: GLOBAL TEMP  */
#line 3757 "gram.y"
                                {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 34259 "gram.c"
    break;

  case 467: /* OptTemp: UNLOGGED  */
#line 3763 "gram.y"
                                                                        { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 34265 "gram.c"
    break;

  case 468: /* OptTemp: %empty  */
#line 3764 "gram.y"
                                                                        { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 34271 "gram.c"
    break;

  case 469: /* OptTableElementList: TableElementList  */
#line 3768 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 34277 "gram.c"
    break;

  case 470: /* OptTableElementList: %empty  */
#line 3769 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 34283 "gram.c"
    break;

  case 471: /* OptTypedTableElementList: '(' TypedTableElementList ')'  */
#line 3773 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 34289 "gram.c"
    break;

  case 472: /* OptTypedTableElementList: %empty  */
#line 3774 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 34295 "gram.c"
    break;

  case 473: /* TableElementList: TableElement  */
#line 3779 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 34303 "gram.c"
    break;

  case 474: /* TableElementList: TableElementList ',' TableElement  */
#line 3783 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 34311 "gram.c"
    break;

  case 475: /* TypedTableElementList: TypedTableElement  */
#line 3790 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 34319 "gram.c"
    break;

  case 476: /* TypedTableElementList: TypedTableElementList ',' TypedTableElement  */
#line 3794 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 34327 "gram.c"
    break;

  case 477: /* TableElement: columnDef  */
#line 3800 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 34333 "gram.c"
    break;

  case 478: /* TableElement: TableLikeClause  */
#line 3801 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 34339 "gram.c"
    break;

  case 479: /* TableElement: TableConstraint  */
#line 3802 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 34345 "gram.c"
    break;

  case 480: /* TypedTableElement: columnOptions  */
#line 3806 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 34351 "gram.c"
    break;

  case 481: /* TypedTableElement: TableConstraint  */
#line 3807 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 34357 "gram.c"
    break;

  case 482: /* columnDef: ColId Typename opt_column_storage opt_column_compression create_generic_options ColQualList  */
#line 3811 "gram.y"
                                {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-5].str);
					n->typeName = (yyvsp[-4].typnam);
					n->storage_name = (yyvsp[-3].str);
					n->compression = (yyvsp[-2].str);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-1].list);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 34383 "gram.c"
    break;

  case 483: /* columnOptions: ColId ColQualList  */
#line 3835 "gram.y"
                                {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-1].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34406 "gram.c"
    break;

  case 484: /* columnOptions: ColId WITH OPTIONS ColQualList  */
#line 3854 "gram.y"
                                {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 34429 "gram.c"
    break;

  case 485: /* column_compression: COMPRESSION ColId  */
#line 3875 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 34435 "gram.c"
    break;

  case 486: /* column_compression: COMPRESSION DEFAULT  */
#line 3876 "gram.y"
                                                                                { (yyval.str) = pstrdup("default"); }
#line 34441 "gram.c"
    break;

  case 487: /* opt_column_compression: column_compression  */
#line 3880 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 34447 "gram.c"
    break;

  case 488: /* opt_column_compression: %empty  */
#line 3881 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 34453 "gram.c"
    break;

  case 489: /* column_storage: STORAGE ColId  */
#line 3885 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 34459 "gram.c"
    break;

  case 490: /* column_storage: STORAGE DEFAULT  */
#line 3886 "gram.y"
                                                                                        { (yyval.str) = pstrdup("default"); }
#line 34465 "gram.c"
    break;

  case 491: /* opt_column_storage: column_storage  */
#line 3890 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 34471 "gram.c"
    break;

  case 492: /* opt_column_storage: %empty  */
#line 3891 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 34477 "gram.c"
    break;

  case 493: /* ColQualList: ColQualList ColConstraint  */
#line 3895 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 34483 "gram.c"
    break;

  case 494: /* ColQualList: %empty  */
#line 3896 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 34489 "gram.c"
    break;

  case 495: /* ColConstraint: CONSTRAINT name ColConstraintElem  */
#line 3901 "gram.y"
                                {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 34501 "gram.c"
    break;

  case 496: /* ColConstraint: ColConstraintElem  */
#line 3908 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 34507 "gram.c"
    break;

  case 497: /* ColConstraint: ConstraintAttr  */
#line 3909 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 34513 "gram.c"
    break;

  case 498: /* ColConstraint: COLLATE any_name  */
#line 3911 "gram.y"
                                {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);

					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34531 "gram.c"
    break;

  case 499: /* ColConstraintElem: NOT NULL_P opt_no_inherit  */
#line 3943 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-2]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->is_enforced = true;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 34547 "gram.c"
    break;

  case 500: /* ColConstraintElem: NULL_P  */
#line 3955 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 34559 "gram.c"
    break;

  case 501: /* ColConstraintElem: UNIQUE opt_unique_null_treatment opt_definition OptConsTableSpace  */
#line 3963 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-3]);
					n->nulls_not_distinct = !(yyvsp[-2].boolean);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34576 "gram.c"
    break;

  case 502: /* ColConstraintElem: PRIMARY KEY opt_definition OptConsTableSpace  */
#line 3976 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34592 "gram.c"
    break;

  case 503: /* ColConstraintElem: CHECK '(' a_expr ')' opt_no_inherit  */
#line 3988 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->is_enforced = true;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 34610 "gram.c"
    break;

  case 504: /* ColConstraintElem: DEFAULT b_expr  */
#line 4002 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *) n;
				}
#line 34624 "gram.c"
    break;

  case 505: /* ColConstraintElem: GENERATED generated_when AS IDENTITY_P OptParenthesizedSeqOptList  */
#line 4012 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_IDENTITY;
					n->generated_when = (yyvsp[-3].ival);
					n->options = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 34638 "gram.c"
    break;

  case 506: /* ColConstraintElem: GENERATED generated_when AS '(' a_expr ')' opt_virtual_or_stored  */
#line 4022 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_GENERATED;
					n->generated_when = (yyvsp[-5].ival);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->generated_kind = (yyvsp[0].ival);
					n->location = (yylsp[-6]);

					/*
					 * Can't do this in the grammar because of shift/reduce
					 * conflicts.  (IDENTITY allows both ALWAYS and BY
					 * DEFAULT, but generated columns only allow ALWAYS.)  We
					 * can also give a more useful error message and location.
					 */
					if ((yyvsp[-5].ival) != ATTRIBUTE_IDENTITY_ALWAYS)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("for a generated column, GENERATED ALWAYS must be specified"),
								 parser_errposition((yylsp[-5]))));

					(yyval.node) = (Node *) n;
				}
#line 34667 "gram.c"
    break;

  case 507: /* ColConstraintElem: REFERENCES qualified_name opt_column_list key_match key_actions  */
#line 4047 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable = (yyvsp[-3].range);
					n->fk_attrs = NIL;
					n->pk_attrs = (yyvsp[-2].list);
					n->fk_matchtype = (yyvsp[-1].ival);
					n->fk_upd_action = ((yyvsp[0].keyactions))->updateAction->action;
					n->fk_del_action = ((yyvsp[0].keyactions))->deleteAction->action;
					n->fk_del_set_cols = ((yyvsp[0].keyactions))->deleteAction->cols;
					n->is_enforced = true;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 34689 "gram.c"
    break;

  case 508: /* opt_unique_null_treatment: NULLS_P DISTINCT  */
#line 4067 "gram.y"
                                                        { (yyval.boolean) = true; }
#line 34695 "gram.c"
    break;

  case 509: /* opt_unique_null_treatment: NULLS_P NOT DISTINCT  */
#line 4068 "gram.y"
                                                { (yyval.boolean) = false; }
#line 34701 "gram.c"
    break;

  case 510: /* opt_unique_null_treatment: %empty  */
#line 4069 "gram.y"
                                                                { (yyval.boolean) = true; }
#line 34707 "gram.c"
    break;

  case 511: /* generated_when: ALWAYS  */
#line 4073 "gram.y"
                                                { (yyval.ival) = ATTRIBUTE_IDENTITY_ALWAYS; }
#line 34713 "gram.c"
    break;

  case 512: /* generated_when: BY DEFAULT  */
#line 4074 "gram.y"
                                        { (yyval.ival) = ATTRIBUTE_IDENTITY_BY_DEFAULT; }
#line 34719 "gram.c"
    break;

  case 513: /* opt_virtual_or_stored: STORED  */
#line 4078 "gram.y"
                                                { (yyval.ival) = ATTRIBUTE_GENERATED_STORED; }
#line 34725 "gram.c"
    break;

  case 514: /* opt_virtual_or_stored: VIRTUAL  */
#line 4079 "gram.y"
                                                { (yyval.ival) = ATTRIBUTE_GENERATED_VIRTUAL; }
#line 34731 "gram.c"
    break;

  case 515: /* opt_virtual_or_stored: %empty  */
#line 4080 "gram.y"
                                                { (yyval.ival) = ATTRIBUTE_GENERATED_VIRTUAL; }
#line 34737 "gram.c"
    break;

  case 516: /* ConstraintAttr: DEFERRABLE  */
#line 4100 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 34749 "gram.c"
    break;

  case 517: /* ConstraintAttr: NOT DEFERRABLE  */
#line 4108 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34761 "gram.c"
    break;

  case 518: /* ConstraintAttr: INITIALLY DEFERRED  */
#line 4116 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34773 "gram.c"
    break;

  case 519: /* ConstraintAttr: INITIALLY IMMEDIATE  */
#line 4124 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34785 "gram.c"
    break;

  case 520: /* ConstraintAttr: ENFORCED  */
#line 4132 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_ENFORCED;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 34797 "gram.c"
    break;

  case 521: /* ConstraintAttr: NOT ENFORCED  */
#line 4140 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_NOT_ENFORCED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34809 "gram.c"
    break;

  case 522: /* TableLikeClause: LIKE qualified_name TableLikeOptionList  */
#line 4152 "gram.y"
                                {
					TableLikeClause *n = makeNode(TableLikeClause);

					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					n->relationOid = InvalidOid;
					(yyval.node) = (Node *) n;
				}
#line 34822 "gram.c"
    break;

  case 523: /* TableLikeOptionList: TableLikeOptionList INCLUDING TableLikeOption  */
#line 4163 "gram.y"
                                                                                { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 34828 "gram.c"
    break;

  case 524: /* TableLikeOptionList: TableLikeOptionList EXCLUDING TableLikeOption  */
#line 4164 "gram.y"
                                                                                { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 34834 "gram.c"
    break;

  case 525: /* TableLikeOptionList: %empty  */
#line 4165 "gram.y"
                                                                                        { (yyval.ival) = 0; }
#line 34840 "gram.c"
    break;

  case 526: /* TableLikeOption: COMMENTS  */
#line 4169 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 34846 "gram.c"
    break;

  case 527: /* TableLikeOption: COMPRESSION  */
#line 4170 "gram.y"
                                                        { (yyval.ival) = CREATE_TABLE_LIKE_COMPRESSION; }
#line 34852 "gram.c"
    break;

  case 528: /* TableLikeOption: CONSTRAINTS  */
#line 4171 "gram.y"
                                                        { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 34858 "gram.c"
    break;

  case 529: /* TableLikeOption: DEFAULTS  */
#line 4172 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 34864 "gram.c"
    break;

  case 530: /* TableLikeOption: IDENTITY_P  */
#line 4173 "gram.y"
                                                        { (yyval.ival) = CREATE_TABLE_LIKE_IDENTITY; }
#line 34870 "gram.c"
    break;

  case 531: /* TableLikeOption: GENERATED  */
#line 4174 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_GENERATED; }
#line 34876 "gram.c"
    break;

  case 532: /* TableLikeOption: INDEXES  */
#line 4175 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 34882 "gram.c"
    break;

  case 533: /* TableLikeOption: STATISTICS  */
#line 4176 "gram.y"
                                                        { (yyval.ival) = CREATE_TABLE_LIKE_STATISTICS; }
#line 34888 "gram.c"
    break;

  case 534: /* TableLikeOption: STORAGE  */
#line 4177 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 34894 "gram.c"
    break;

  case 535: /* TableLikeOption: ALL  */
#line 4178 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 34900 "gram.c"
    break;

  case 536: /* TableConstraint: CONSTRAINT name ConstraintElem  */
#line 4188 "gram.y"
                                {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 34912 "gram.c"
    break;

  case 537: /* TableConstraint: ConstraintElem  */
#line 4195 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 34918 "gram.c"
    break;

  case 538: /* ConstraintElem: CHECK '(' a_expr ')' ConstraintAttributeSpec  */
#line 4200 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->is_enforced, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 34936 "gram.c"
    break;

  case 539: /* ConstraintElem: NOT NULL_P ColId ConstraintAttributeSpec  */
#line 4214 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-3]);
					n->keys = list_make1(makeString((yyvsp[-1].str)));
					processCASbits((yyvsp[0].ival), (yylsp[0]), "NOT NULL",
								   NULL, NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 34953 "gram.c"
    break;

  case 540: /* ConstraintElem: UNIQUE opt_unique_null_treatment '(' columnList opt_without_overlaps ')' opt_c_include opt_definition OptConsTableSpace ConstraintAttributeSpec  */
#line 4228 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-9]);
					n->nulls_not_distinct = !(yyvsp[-8].boolean);
					n->keys = (yyvsp[-6].list);
					n->without_overlaps = (yyvsp[-5].boolean);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 34975 "gram.c"
    break;

  case 541: /* ConstraintElem: UNIQUE ExistingIndex ConstraintAttributeSpec  */
#line 4246 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 34995 "gram.c"
    break;

  case 542: /* ConstraintElem: PRIMARY KEY '(' columnList opt_without_overlaps ')' opt_c_include opt_definition OptConsTableSpace ConstraintAttributeSpec  */
#line 4263 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-9]);
					n->keys = (yyvsp[-6].list);
					n->without_overlaps = (yyvsp[-5].boolean);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 35016 "gram.c"
    break;

  case 543: /* ConstraintElem: PRIMARY KEY ExistingIndex ConstraintAttributeSpec  */
#line 4280 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 35036 "gram.c"
    break;

  case 544: /* ConstraintElem: EXCLUDE access_method_clause '(' ExclusionConstraintList ')' opt_c_include opt_definition OptConsTableSpace OptWhereClause ConstraintAttributeSpec  */
#line 4298 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-9]);
					n->access_method = (yyvsp[-8].str);
					n->exclusions = (yyvsp[-6].list);
					n->including = (yyvsp[-4].list);
					n->options = (yyvsp[-3].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-2].str);
					n->where_clause = (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 35058 "gram.c"
    break;

  case 545: /* ConstraintElem: FOREIGN KEY '(' columnList optionalPeriodName ')' REFERENCES qualified_name opt_column_and_period_list key_match key_actions ConstraintAttributeSpec  */
#line 4317 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-11]);
					n->pktable = (yyvsp[-4].range);
					n->fk_attrs = (yyvsp[-8].list);
					if ((yyvsp[-7].node))
					{
						n->fk_attrs = lappend(n->fk_attrs, (yyvsp[-7].node));
						n->fk_with_period = true;
					}
					n->pk_attrs = linitial((yyvsp[-3].list));
					if (lsecond((yyvsp[-3].list)))
					{
						n->pk_attrs = lappend(n->pk_attrs, lsecond((yyvsp[-3].list)));
						n->pk_with_period = true;
					}
					n->fk_matchtype = (yyvsp[-2].ival);
					n->fk_upd_action = ((yyvsp[-1].keyactions))->updateAction->action;
					n->fk_del_action = ((yyvsp[-1].keyactions))->deleteAction->action;
					n->fk_del_set_cols = ((yyvsp[-1].keyactions))->deleteAction->cols;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->is_enforced, &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 35092 "gram.c"
    break;

  case 546: /* DomainConstraint: CONSTRAINT name DomainConstraintElem  */
#line 4361 "gram.y"
                                {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 35104 "gram.c"
    break;

  case 547: /* DomainConstraint: DomainConstraintElem  */
#line 4368 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 35110 "gram.c"
    break;

  case 548: /* DomainConstraintElem: CHECK '(' a_expr ')' ConstraintAttributeSpec  */
#line 4373 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->is_enforced = true;
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 35129 "gram.c"
    break;

  case 549: /* DomainConstraintElem: NOT NULL_P ConstraintAttributeSpec  */
#line 4388 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-2]);
					n->keys = list_make1(makeString("value"));
					/* no NOT VALID, NO INHERIT support */
					processCASbits((yyvsp[0].ival), (yylsp[0]), "NOT NULL",
								   NULL, NULL, NULL,
								   NULL, NULL, yyscanner);
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 35147 "gram.c"
    break;

  case 550: /* opt_no_inherit: NO INHERIT  */
#line 4403 "gram.y"
                                                                                {  (yyval.boolean) = true; }
#line 35153 "gram.c"
    break;

  case 551: /* opt_no_inherit: %empty  */
#line 4404 "gram.y"
                                                                                        {  (yyval.boolean) = false; }
#line 35159 "gram.c"
    break;

  case 552: /* opt_without_overlaps: WITHOUT OVERLAPS  */
#line 4408 "gram.y"
                                                                                        { (yyval.boolean) = true; }
#line 35165 "gram.c"
    break;

  case 553: /* opt_without_overlaps: %empty  */
#line 4409 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 35171 "gram.c"
    break;

  case 554: /* opt_column_list: '(' columnList ')'  */
#line 4413 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 35177 "gram.c"
    break;

  case 555: /* opt_column_list: %empty  */
#line 4414 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 35183 "gram.c"
    break;

  case 556: /* columnList: columnElem  */
#line 4418 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35189 "gram.c"
    break;

  case 557: /* columnList: columnList ',' columnElem  */
#line 4419 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 35195 "gram.c"
    break;

  case 558: /* optionalPeriodName: ',' PERIOD columnElem  */
#line 4423 "gram.y"
                                              { (yyval.node) = (yyvsp[0].node); }
#line 35201 "gram.c"
    break;

  case 559: /* optionalPeriodName: %empty  */
#line 4424 "gram.y"
                                                  { (yyval.node) = NULL; }
#line 35207 "gram.c"
    break;

  case 560: /* opt_column_and_period_list: '(' columnList optionalPeriodName ')'  */
#line 4428 "gram.y"
                                                                                { (yyval.list) = list_make2((yyvsp[-2].list), (yyvsp[-1].node)); }
#line 35213 "gram.c"
    break;

  case 561: /* opt_column_and_period_list: %empty  */
#line 4429 "gram.y"
                                                                                                { (yyval.list) = list_make2(NIL, NULL); }
#line 35219 "gram.c"
    break;

  case 562: /* columnElem: ColId  */
#line 4433 "gram.y"
                                {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 35227 "gram.c"
    break;

  case 563: /* opt_c_include: INCLUDE '(' columnList ')'  */
#line 4438 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 35233 "gram.c"
    break;

  case 564: /* opt_c_include: %empty  */
#line 4439 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 35239 "gram.c"
    break;

  case 565: /* key_match: MATCH FULL  */
#line 4443 "gram.y"
                        {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 35247 "gram.c"
    break;

  case 566: /* key_match: MATCH PARTIAL  */
#line 4447 "gram.y"
                        {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 35259 "gram.c"
    break;

  case 567: /* key_match: MATCH SIMPLE  */
#line 4455 "gram.y"
                        {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 35267 "gram.c"
    break;

  case 568: /* key_match: %empty  */
#line 4459 "gram.y"
                        {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 35275 "gram.c"
    break;

  case 569: /* ExclusionConstraintList: ExclusionConstraintElem  */
#line 4465 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 35281 "gram.c"
    break;

  case 570: /* ExclusionConstraintList: ExclusionConstraintList ',' ExclusionConstraintElem  */
#line 4467 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 35287 "gram.c"
    break;

  case 571: /* ExclusionConstraintElem: index_elem WITH any_operator  */
#line 4471 "gram.y"
                        {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 35295 "gram.c"
    break;

  case 572: /* ExclusionConstraintElem: index_elem WITH OPERATOR '(' any_operator ')'  */
#line 4476 "gram.y"
                        {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 35303 "gram.c"
    break;

  case 573: /* OptWhereClause: WHERE '(' a_expr ')'  */
#line 4482 "gram.y"
                                                                                { (yyval.node) = (yyvsp[-1].node); }
#line 35309 "gram.c"
    break;

  case 574: /* OptWhereClause: %empty  */
#line 4483 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 35315 "gram.c"
    break;

  case 575: /* key_actions: key_update  */
#line 4488 "gram.y"
                                {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[0].keyaction);
					n->deleteAction = palloc(sizeof(KeyAction));
					n->deleteAction->action = FKCONSTR_ACTION_NOACTION;
					n->deleteAction->cols = NIL;
					(yyval.keyactions) = n;
				}
#line 35329 "gram.c"
    break;

  case 576: /* key_actions: key_delete  */
#line 4498 "gram.y"
                                {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = palloc(sizeof(KeyAction));
					n->updateAction->action = FKCONSTR_ACTION_NOACTION;
					n->updateAction->cols = NIL;
					n->deleteAction = (yyvsp[0].keyaction);
					(yyval.keyactions) = n;
				}
#line 35343 "gram.c"
    break;

  case 577: /* key_actions: key_update key_delete  */
#line 4508 "gram.y"
                                {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[-1].keyaction);
					n->deleteAction = (yyvsp[0].keyaction);
					(yyval.keyactions) = n;
				}
#line 35355 "gram.c"
    break;

  case 578: /* key_actions: key_delete key_update  */
#line 4516 "gram.y"
                                {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[0].keyaction);
					n->deleteAction = (yyvsp[-1].keyaction);
					(yyval.keyactions) = n;
				}
#line 35367 "gram.c"
    break;

  case 579: /* key_actions: %empty  */
#line 4524 "gram.y"
                                {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = palloc(sizeof(KeyAction));
					n->updateAction->action = FKCONSTR_ACTION_NOACTION;
					n->updateAction->cols = NIL;
					n->deleteAction = palloc(sizeof(KeyAction));
					n->deleteAction->action = FKCONSTR_ACTION_NOACTION;
					n->deleteAction->cols = NIL;
					(yyval.keyactions) = n;
				}
#line 35383 "gram.c"
    break;

  case 580: /* key_update: ON UPDATE key_action  */
#line 4538 "gram.y"
                                {
					if (((yyvsp[0].keyaction))->cols)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("a column list with %s is only supported for ON DELETE actions",
										((yyvsp[0].keyaction))->action == FKCONSTR_ACTION_SETNULL ? "SET NULL" : "SET DEFAULT"),
								 parser_errposition((yylsp[-2]))));
					(yyval.keyaction) = (yyvsp[0].keyaction);
				}
#line 35397 "gram.c"
    break;

  case 581: /* key_delete: ON DELETE_P key_action  */
#line 4550 "gram.y"
                                {
					(yyval.keyaction) = (yyvsp[0].keyaction);
				}
#line 35405 "gram.c"
    break;

  case 582: /* key_action: NO ACTION  */
#line 4557 "gram.y"
                                {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_NOACTION;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 35417 "gram.c"
    break;

  case 583: /* key_action: RESTRICT  */
#line 4565 "gram.y"
                                {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_RESTRICT;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 35429 "gram.c"
    break;

  case 584: /* key_action: CASCADE  */
#line 4573 "gram.y"
                                {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_CASCADE;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 35441 "gram.c"
    break;

  case 585: /* key_action: SET NULL_P opt_column_list  */
#line 4581 "gram.y"
                                {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_SETNULL;
					n->cols = (yyvsp[0].list);
					(yyval.keyaction) = n;
				}
#line 35453 "gram.c"
    break;

  case 586: /* key_action: SET DEFAULT opt_column_list  */
#line 4589 "gram.y"
                                {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_SETDEFAULT;
					n->cols = (yyvsp[0].list);
					(yyval.keyaction) = n;
				}
#line 35465 "gram.c"
    break;

  case 587: /* OptInherit: INHERITS '(' qualified_name_list ')'  */
#line 4598 "gram.y"
                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 35471 "gram.c"
    break;

  case 588: /* OptInherit: %empty  */
#line 4599 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 35477 "gram.c"
    break;

  case 589: /* OptPartitionSpec: PartitionSpec  */
#line 4603 "gram.y"
                                { (yyval.partspec) = (yyvsp[0].partspec); }
#line 35483 "gram.c"
    break;

  case 590: /* OptPartitionSpec: %empty  */
#line 4604 "gram.y"
                                                        { (yyval.partspec) = NULL; }
#line 35489 "gram.c"
    break;

  case 591: /* PartitionSpec: PARTITION BY ColId '(' part_params ')'  */
#line 4608 "gram.y"
                                {
					PartitionSpec *n = makeNode(PartitionSpec);

					n->strategy = parsePartitionStrategy((yyvsp[-3].str), (yylsp[-3]), yyscanner);
					n->partParams = (yyvsp[-1].list);
					n->location = (yylsp[-5]);

					(yyval.partspec) = n;
				}
#line 35503 "gram.c"
    break;

  case 592: /* part_params: part_elem  */
#line 4619 "gram.y"
                                                                        { (yyval.list) = list_make1((yyvsp[0].partelem)); }
#line 35509 "gram.c"
    break;

  case 593: /* part_params: part_params ',' part_elem  */
#line 4620 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].partelem)); }
#line 35515 "gram.c"
    break;

  case 594: /* part_elem: ColId opt_collate opt_qualified_name  */
#line 4624 "gram.y"
                                {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = (yyvsp[-2].str);
					n->expr = NULL;
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 35530 "gram.c"
    break;

  case 595: /* part_elem: func_expr_windowless opt_collate opt_qualified_name  */
#line 4635 "gram.y"
                                {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-2].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 35545 "gram.c"
    break;

  case 596: /* part_elem: '(' a_expr ')' opt_collate opt_qualified_name  */
#line 4646 "gram.y"
                                {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-3].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.partelem) = n;
				}
#line 35560 "gram.c"
    break;

  case 597: /* table_access_method_clause: USING name  */
#line 4659 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 35566 "gram.c"
    break;

  case 598: /* table_access_method_clause: %empty  */
#line 4660 "gram.y"
                                                                                        { (yyval.str) = NULL; }
#line 35572 "gram.c"
    break;

  case 599: /* OptWith: WITH reloptions  */
#line 4665 "gram.y"
                                                                { (yyval.list) = (yyvsp[0].list); }
#line 35578 "gram.c"
    break;

  case 600: /* OptWith: WITHOUT OIDS  */
#line 4666 "gram.y"
                                                                { (yyval.list) = NIL; }
#line 35584 "gram.c"
    break;

  case 601: /* OptWith: %empty  */
#line 4667 "gram.y"
                                                                        { (yyval.list) = NIL; }
#line 35590 "gram.c"
    break;

  case 602: /* OnCommitOption: ON COMMIT DROP  */
#line 4670 "gram.y"
                                                        { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 35596 "gram.c"
    break;

  case 603: /* OnCommitOption: ON COMMIT DELETE_P ROWS  */
#line 4671 "gram.y"
                                                                { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 35602 "gram.c"
    break;

  case 604: /* OnCommitOption: ON COMMIT PRESERVE ROWS  */
#line 4672 "gram.y"
                                                                { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 35608 "gram.c"
    break;

  case 605: /* OnCommitOption: %empty  */
#line 4673 "gram.y"
                                                                                { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 35614 "gram.c"
    break;

  case 606: /* OptTableSpace: TABLESPACE name  */
#line 4676 "gram.y"
                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 35620 "gram.c"
    break;

  case 607: /* OptTableSpace: %empty  */
#line 4677 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 35626 "gram.c"
    break;

  case 608: /* OptConsTableSpace: USING INDEX TABLESPACE name  */
#line 4680 "gram.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 35632 "gram.c"
    break;

  case 609: /* OptConsTableSpace: %empty  */
#line 4681 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 35638 "gram.c"
    break;

  case 610: /* ExistingIndex: USING INDEX name  */
#line 4684 "gram.y"
                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 35644 "gram.c"
    break;

  case 611: /* CreateStatsStmt: CREATE STATISTICS opt_qualified_name opt_name_list ON stats_params FROM from_list  */
#line 4706 "gram.y"
                                {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);

					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 35660 "gram.c"
    break;

  case 612: /* CreateStatsStmt: CREATE STATISTICS IF_P NOT EXISTS any_name opt_name_list ON stats_params FROM from_list  */
#line 4719 "gram.y"
                                {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);

					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 35676 "gram.c"
    break;

  case 613: /* stats_params: stats_param  */
#line 4739 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].selem)); }
#line 35682 "gram.c"
    break;

  case 614: /* stats_params: stats_params ',' stats_param  */
#line 4740 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].selem)); }
#line 35688 "gram.c"
    break;

  case 615: /* stats_param: ColId  */
#line 4744 "gram.y"
                                {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = (yyvsp[0].str);
					(yyval.selem)->expr = NULL;
				}
#line 35698 "gram.c"
    break;

  case 616: /* stats_param: func_expr_windowless  */
#line 4750 "gram.y"
                                {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[0].node);
				}
#line 35708 "gram.c"
    break;

  case 617: /* stats_param: '(' a_expr ')'  */
#line 4756 "gram.y"
                                {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[-1].node);
				}
#line 35718 "gram.c"
    break;

  case 618: /* AlterStatsStmt: ALTER STATISTICS any_name SET STATISTICS set_statistics_value  */
#line 4773 "gram.y"
                                {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);

					n->defnames = (yyvsp[-3].list);
					n->missing_ok = false;
					n->stxstattarget = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 35731 "gram.c"
    break;

  case 619: /* AlterStatsStmt: ALTER STATISTICS IF_P EXISTS any_name SET STATISTICS set_statistics_value  */
#line 4782 "gram.y"
                                {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);

					n->defnames = (yyvsp[-3].list);
					n->missing_ok = true;
					n->stxstattarget = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 35744 "gram.c"
    break;

  case 620: /* CreateAsStmt: CREATE OptTemp TABLE create_as_target AS SelectStmt opt_with_data  */
#line 4804 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 35762 "gram.c"
    break;

  case 621: /* CreateAsStmt: CREATE OptTemp TABLE IF_P NOT EXISTS create_as_target AS SelectStmt opt_with_data  */
#line 4818 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-8].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 35780 "gram.c"
    break;

  case 622: /* create_as_target: qualified_name opt_column_list table_access_method_clause OptWith OnCommitOption OptTableSpace  */
#line 4836 "gram.y"
                                {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-5].range);
					(yyval.into)->colNames = (yyvsp[-4].list);
					(yyval.into)->accessMethod = (yyvsp[-3].str);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 35796 "gram.c"
    break;

  case 623: /* opt_with_data: WITH DATA_P  */
#line 4850 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 35802 "gram.c"
    break;

  case 624: /* opt_with_data: WITH NO DATA_P  */
#line 4851 "gram.y"
                                                                                        { (yyval.boolean) = false; }
#line 35808 "gram.c"
    break;

  case 625: /* opt_with_data: %empty  */
#line 4852 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 35814 "gram.c"
    break;

  case 626: /* CreateMatViewStmt: CREATE OptNoLog MATERIALIZED VIEW create_mv_target AS SelectStmt opt_with_data  */
#line 4865 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-6].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 35832 "gram.c"
    break;

  case 627: /* CreateMatViewStmt: CREATE OptNoLog MATERIALIZED VIEW IF_P NOT EXISTS create_mv_target AS SelectStmt opt_with_data  */
#line 4879 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-9].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 35850 "gram.c"
    break;

  case 628: /* create_mv_target: qualified_name opt_column_list table_access_method_clause opt_reloptions OptTableSpace  */
#line 4896 "gram.y"
                                {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->accessMethod = (yyvsp[-2].str);
					(yyval.into)->options = (yyvsp[-1].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 35866 "gram.c"
    break;

  case 629: /* OptNoLog: UNLOGGED  */
#line 4909 "gram.y"
                                                                { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 35872 "gram.c"
    break;

  case 630: /* OptNoLog: %empty  */
#line 4910 "gram.y"
                                                                        { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 35878 "gram.c"
    break;

  case 631: /* RefreshMatViewStmt: REFRESH MATERIALIZED VIEW opt_concurrently qualified_name opt_with_data  */
#line 4923 "gram.y"
                                {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);

					n->concurrent = (yyvsp[-2].boolean);
					n->relation = (yyvsp[-1].range);
					n->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) n;
				}
#line 35891 "gram.c"
    break;

  case 632: /* CreateSeqStmt: CREATE OptTemp SEQUENCE qualified_name OptSeqOptList  */
#line 4944 "gram.y"
                                {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);

					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 35906 "gram.c"
    break;

  case 633: /* CreateSeqStmt: CREATE OptTemp SEQUENCE IF_P NOT EXISTS qualified_name OptSeqOptList  */
#line 4955 "gram.y"
                                {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);

					(yyvsp[-1].range)->relpersistence = (yyvsp[-6].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 35921 "gram.c"
    break;

  case 634: /* AlterSeqStmt: ALTER SEQUENCE qualified_name SeqOptList  */
#line 4969 "gram.y"
                                {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);

					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 35934 "gram.c"
    break;

  case 635: /* AlterSeqStmt: ALTER SEQUENCE IF_P EXISTS qualified_name SeqOptList  */
#line 4978 "gram.y"
                                {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);

					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 35947 "gram.c"
    break;

  case 636: /* OptSeqOptList: SeqOptList  */
#line 4989 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 35953 "gram.c"
    break;

  case 637: /* OptSeqOptList: %empty  */
#line 4990 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 35959 "gram.c"
    break;

  case 638: /* OptParenthesizedSeqOptList: '(' SeqOptList ')'  */
#line 4993 "gram.y"
                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 35965 "gram.c"
    break;

  case 639: /* OptParenthesizedSeqOptList: %empty  */
#line 4994 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 35971 "gram.c"
    break;

  case 640: /* SeqOptList: SeqOptElem  */
#line 4997 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 35977 "gram.c"
    break;

  case 641: /* SeqOptList: SeqOptList SeqOptElem  */
#line 4998 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 35983 "gram.c"
    break;

  case 642: /* SeqOptElem: AS SimpleTypename  */
#line 5002 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("as", (Node *) (yyvsp[0].typnam), (yylsp[-1]));
				}
#line 35991 "gram.c"
    break;

  case 643: /* SeqOptElem: CACHE NumericOnly  */
#line 5006 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cache", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 35999 "gram.c"
    break;

  case 644: /* SeqOptElem: CYCLE  */
#line 5010 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cycle", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 36007 "gram.c"
    break;

  case 645: /* SeqOptElem: NO CYCLE  */
#line 5014 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cycle", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 36015 "gram.c"
    break;

  case 646: /* SeqOptElem: INCREMENT opt_by NumericOnly  */
#line 5018 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("increment", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 36023 "gram.c"
    break;

  case 647: /* SeqOptElem: LOGGED  */
#line 5022 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("logged", NULL, (yylsp[0]));
				}
#line 36031 "gram.c"
    break;

  case 648: /* SeqOptElem: MAXVALUE NumericOnly  */
#line 5026 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 36039 "gram.c"
    break;

  case 649: /* SeqOptElem: MINVALUE NumericOnly  */
#line 5030 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("minvalue", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 36047 "gram.c"
    break;

  case 650: /* SeqOptElem: NO MAXVALUE  */
#line 5034 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("maxvalue", NULL, (yylsp[-1]));
				}
#line 36055 "gram.c"
    break;

  case 651: /* SeqOptElem: NO MINVALUE  */
#line 5038 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("minvalue", NULL, (yylsp[-1]));
				}
#line 36063 "gram.c"
    break;

  case 652: /* SeqOptElem: OWNED BY any_name  */
#line 5042 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("owned_by", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 36071 "gram.c"
    break;

  case 653: /* SeqOptElem: SEQUENCE NAME_P any_name  */
#line 5046 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("sequence_name", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 36079 "gram.c"
    break;

  case 654: /* SeqOptElem: START opt_with NumericOnly  */
#line 5050 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("start", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 36087 "gram.c"
    break;

  case 655: /* SeqOptElem: RESTART  */
#line 5054 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 36095 "gram.c"
    break;

  case 656: /* SeqOptElem: RESTART opt_with NumericOnly  */
#line 5058 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("restart", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 36103 "gram.c"
    break;

  case 657: /* SeqOptElem: UNLOGGED  */
#line 5062 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("unlogged", NULL, (yylsp[0]));
				}
#line 36111 "gram.c"
    break;

  case 660: /* NumericOnly: FCONST  */
#line 5072 "gram.y"
                                                                                        { (yyval.node) = (Node *) makeFloat((yyvsp[0].str)); }
#line 36117 "gram.c"
    break;

  case 661: /* NumericOnly: '+' FCONST  */
#line 5073 "gram.y"
                                                                                { (yyval.node) = (Node *) makeFloat((yyvsp[0].str)); }
#line 36123 "gram.c"
    break;

  case 662: /* NumericOnly: '-' FCONST  */
#line 5075 "gram.y"
                                {
					Float	   *f = makeFloat((yyvsp[0].str));

					doNegateFloat(f);
					(yyval.node) = (Node *) f;
				}
#line 36134 "gram.c"
    break;

  case 663: /* NumericOnly: SignedIconst  */
#line 5081 "gram.y"
                                                                                { (yyval.node) = (Node *) makeInteger((yyvsp[0].ival)); }
#line 36140 "gram.c"
    break;

  case 664: /* NumericOnly_list: NumericOnly  */
#line 5084 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36146 "gram.c"
    break;

  case 665: /* NumericOnly_list: NumericOnly_list ',' NumericOnly  */
#line 5085 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 36152 "gram.c"
    break;

  case 666: /* CreatePLangStmt: CREATE opt_or_replace opt_trusted opt_procedural LANGUAGE name  */
#line 5098 "gram.y"
                        {
				/*
				 * We now interpret parameterless CREATE LANGUAGE as
				 * CREATE EXTENSION.  "OR REPLACE" is silently translated
				 * to "IF NOT EXISTS", which isn't quite the same, but
				 * seems more useful than throwing an error.  We just
				 * ignore TRUSTED, as the previous code would have too.
				 */
				CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

				n->if_not_exists = (yyvsp[-4].boolean);
				n->extname = (yyvsp[0].str);
				n->options = NIL;
				(yyval.node) = (Node *) n;
			}
#line 36172 "gram.c"
    break;

  case 667: /* CreatePLangStmt: CREATE opt_or_replace opt_trusted opt_procedural LANGUAGE name HANDLER handler_name opt_inline_handler opt_validator  */
#line 5115 "gram.y"
                        {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);

				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *) n;
			}
#line 36188 "gram.c"
    break;

  case 668: /* opt_trusted: TRUSTED  */
#line 5129 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 36194 "gram.c"
    break;

  case 669: /* opt_trusted: %empty  */
#line 5130 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 36200 "gram.c"
    break;

  case 670: /* handler_name: name  */
#line 5138 "gram.y"
                                                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36206 "gram.c"
    break;

  case 671: /* handler_name: name attrs  */
#line 5139 "gram.y"
                                                                { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 36212 "gram.c"
    break;

  case 672: /* opt_inline_handler: INLINE_P handler_name  */
#line 5143 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 36218 "gram.c"
    break;

  case 673: /* opt_inline_handler: %empty  */
#line 5144 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 36224 "gram.c"
    break;

  case 674: /* validator_clause: VALIDATOR handler_name  */
#line 5148 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 36230 "gram.c"
    break;

  case 675: /* validator_clause: NO VALIDATOR  */
#line 5149 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 36236 "gram.c"
    break;

  case 676: /* opt_validator: validator_clause  */
#line 5153 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 36242 "gram.c"
    break;

  case 677: /* opt_validator: %empty  */
#line 5154 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 36248 "gram.c"
    break;

  case 680: /* CreateTableSpaceStmt: CREATE TABLESPACE name OptTableSpaceOwner LOCATION Sconst opt_reloptions  */
#line 5170 "gram.y"
                                {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);

					n->tablespacename = (yyvsp[-4].str);
					n->owner = (yyvsp[-3].rolespec);
					n->location = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36262 "gram.c"
    break;

  case 681: /* OptTableSpaceOwner: OWNER RoleSpec  */
#line 5181 "gram.y"
                                                { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 36268 "gram.c"
    break;

  case 682: /* OptTableSpaceOwner: %empty  */
#line 5182 "gram.y"
                                                                { (yyval.rolespec) = NULL; }
#line 36274 "gram.c"
    break;

  case 683: /* DropTableSpaceStmt: DROP TABLESPACE name  */
#line 5196 "gram.y"
                                {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);

					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 36286 "gram.c"
    break;

  case 684: /* DropTableSpaceStmt: DROP TABLESPACE IF_P EXISTS name  */
#line 5204 "gram.y"
                                {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);

					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 36298 "gram.c"
    break;

  case 685: /* CreateExtensionStmt: CREATE EXTENSION name opt_with create_extension_opt_list  */
#line 5222 "gram.y"
                                {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36311 "gram.c"
    break;

  case 686: /* CreateExtensionStmt: CREATE EXTENSION IF_P NOT EXISTS name opt_with create_extension_opt_list  */
#line 5231 "gram.y"
                                {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36324 "gram.c"
    break;

  case 687: /* create_extension_opt_list: create_extension_opt_list create_extension_opt_item  */
#line 5243 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 36330 "gram.c"
    break;

  case 688: /* create_extension_opt_list: %empty  */
#line 5245 "gram.y"
                                { (yyval.list) = NIL; }
#line 36336 "gram.c"
    break;

  case 689: /* create_extension_opt_item: SCHEMA name  */
#line 5250 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("schema", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 36344 "gram.c"
    break;

  case 690: /* create_extension_opt_item: VERSION_P NonReservedWord_or_Sconst  */
#line 5254 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("new_version", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 36352 "gram.c"
    break;

  case 691: /* create_extension_opt_item: FROM NonReservedWord_or_Sconst  */
#line 5258 "gram.y"
                                {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE EXTENSION ... FROM is no longer supported"),
							 parser_errposition((yylsp[-1]))));
				}
#line 36363 "gram.c"
    break;

  case 692: /* create_extension_opt_item: CASCADE  */
#line 5265 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cascade", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 36371 "gram.c"
    break;

  case 693: /* AlterExtensionStmt: ALTER EXTENSION name UPDATE alter_extension_opt_list  */
#line 5277 "gram.y"
                                {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36383 "gram.c"
    break;

  case 694: /* alter_extension_opt_list: alter_extension_opt_list alter_extension_opt_item  */
#line 5288 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 36389 "gram.c"
    break;

  case 695: /* alter_extension_opt_list: %empty  */
#line 5290 "gram.y"
                                { (yyval.list) = NIL; }
#line 36395 "gram.c"
    break;

  case 696: /* alter_extension_opt_item: TO NonReservedWord_or_Sconst  */
#line 5295 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("new_version", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 36403 "gram.c"
    break;

  case 697: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop object_type_name name  */
#line 5308 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 36417 "gram.c"
    break;

  case 698: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop object_type_any_name any_name  */
#line 5318 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36431 "gram.c"
    break;

  case 699: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop AGGREGATE aggregate_with_argtypes  */
#line 5328 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 36445 "gram.c"
    break;

  case 700: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop CAST '(' Typename AS Typename ')'  */
#line 5338 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 36459 "gram.c"
    break;

  case 701: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop DOMAIN_P Typename  */
#line 5348 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 36473 "gram.c"
    break;

  case 702: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop FUNCTION function_with_argtypes  */
#line 5358 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 36487 "gram.c"
    break;

  case 703: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop OPERATOR operator_with_argtypes  */
#line 5368 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 36501 "gram.c"
    break;

  case 704: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop OPERATOR CLASS any_name USING name  */
#line 5378 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *) n;
				}
#line 36515 "gram.c"
    break;

  case 705: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop OPERATOR FAMILY any_name USING name  */
#line 5388 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *) n;
				}
#line 36529 "gram.c"
    break;

  case 706: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop PROCEDURE function_with_argtypes  */
#line 5398 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 36543 "gram.c"
    break;

  case 707: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop ROUTINE function_with_argtypes  */
#line 5408 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 36557 "gram.c"
    break;

  case 708: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop TRANSFORM FOR Typename LANGUAGE name  */
#line 5418 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-2].typnam), makeString((yyvsp[0].str)));
					(yyval.node) = (Node *) n;
				}
#line 36571 "gram.c"
    break;

  case 709: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop TYPE_P Typename  */
#line 5428 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 36585 "gram.c"
    break;

  case 710: /* CreateFdwStmt: CREATE FOREIGN DATA_P WRAPPER name opt_fdw_options create_generic_options  */
#line 5447 "gram.y"
                                {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);

					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36598 "gram.c"
    break;

  case 711: /* fdw_option: HANDLER handler_name  */
#line 5458 "gram.y"
                                                                        { (yyval.defelt) = makeDefElem("handler", (Node *) (yyvsp[0].list), (yylsp[-1])); }
#line 36604 "gram.c"
    break;

  case 712: /* fdw_option: NO HANDLER  */
#line 5459 "gram.y"
                                                                                { (yyval.defelt) = makeDefElem("handler", NULL, (yylsp[-1])); }
#line 36610 "gram.c"
    break;

  case 713: /* fdw_option: VALIDATOR handler_name  */
#line 5460 "gram.y"
                                                                        { (yyval.defelt) = makeDefElem("validator", (Node *) (yyvsp[0].list), (yylsp[-1])); }
#line 36616 "gram.c"
    break;

  case 714: /* fdw_option: NO VALIDATOR  */
#line 5461 "gram.y"
                                                                                { (yyval.defelt) = makeDefElem("validator", NULL, (yylsp[-1])); }
#line 36622 "gram.c"
    break;

  case 715: /* fdw_options: fdw_option  */
#line 5465 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 36628 "gram.c"
    break;

  case 716: /* fdw_options: fdw_options fdw_option  */
#line 5466 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 36634 "gram.c"
    break;

  case 717: /* opt_fdw_options: fdw_options  */
#line 5470 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 36640 "gram.c"
    break;

  case 718: /* opt_fdw_options: %empty  */
#line 5471 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 36646 "gram.c"
    break;

  case 719: /* AlterFdwStmt: ALTER FOREIGN DATA_P WRAPPER name opt_fdw_options alter_generic_options  */
#line 5482 "gram.y"
                                {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);

					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36659 "gram.c"
    break;

  case 720: /* AlterFdwStmt: ALTER FOREIGN DATA_P WRAPPER name fdw_options  */
#line 5491 "gram.y"
                                {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);

					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 36672 "gram.c"
    break;

  case 721: /* create_generic_options: OPTIONS '(' generic_option_list ')'  */
#line 5503 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 36678 "gram.c"
    break;

  case 722: /* create_generic_options: %empty  */
#line 5504 "gram.y"
                                                                                                        { (yyval.list) = NIL; }
#line 36684 "gram.c"
    break;

  case 723: /* generic_option_list: generic_option_elem  */
#line 5509 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 36692 "gram.c"
    break;

  case 724: /* generic_option_list: generic_option_list ',' generic_option_elem  */
#line 5513 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 36700 "gram.c"
    break;

  case 725: /* alter_generic_options: OPTIONS '(' alter_generic_option_list ')'  */
#line 5520 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 36706 "gram.c"
    break;

  case 726: /* alter_generic_option_list: alter_generic_option_elem  */
#line 5525 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 36714 "gram.c"
    break;

  case 727: /* alter_generic_option_list: alter_generic_option_list ',' alter_generic_option_elem  */
#line 5529 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 36722 "gram.c"
    break;

  case 728: /* alter_generic_option_elem: generic_option_elem  */
#line 5536 "gram.y"
                                {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 36730 "gram.c"
    break;

  case 729: /* alter_generic_option_elem: SET generic_option_elem  */
#line 5540 "gram.y"
                                {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 36739 "gram.c"
    break;

  case 730: /* alter_generic_option_elem: ADD_P generic_option_elem  */
#line 5545 "gram.y"
                                {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 36748 "gram.c"
    break;

  case 731: /* alter_generic_option_elem: DROP generic_option_name  */
#line 5550 "gram.y"
                                {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP, (yylsp[0]));
				}
#line 36756 "gram.c"
    break;

  case 732: /* generic_option_elem: generic_option_name generic_option_arg  */
#line 5557 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 36764 "gram.c"
    break;

  case 733: /* generic_option_name: ColLabel  */
#line 5563 "gram.y"
                                                                { (yyval.str) = (yyvsp[0].str); }
#line 36770 "gram.c"
    break;

  case 734: /* generic_option_arg: Sconst  */
#line 5568 "gram.y"
                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 36776 "gram.c"
    break;

  case 735: /* CreateForeignServerStmt: CREATE SERVER name opt_type opt_foreign_server_version FOREIGN DATA_P WRAPPER name create_generic_options  */
#line 5580 "gram.y"
                                {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);

					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 36792 "gram.c"
    break;

  case 736: /* CreateForeignServerStmt: CREATE SERVER IF_P NOT EXISTS name opt_type opt_foreign_server_version FOREIGN DATA_P WRAPPER name create_generic_options  */
#line 5593 "gram.y"
                                {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);

					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 36808 "gram.c"
    break;

  case 737: /* opt_type: TYPE_P Sconst  */
#line 5607 "gram.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 36814 "gram.c"
    break;

  case 738: /* opt_type: %empty  */
#line 5608 "gram.y"
                                                                { (yyval.str) = NULL; }
#line 36820 "gram.c"
    break;

  case 739: /* foreign_server_version: VERSION_P Sconst  */
#line 5613 "gram.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 36826 "gram.c"
    break;

  case 740: /* foreign_server_version: VERSION_P NULL_P  */
#line 5614 "gram.y"
                                                        { (yyval.str) = NULL; }
#line 36832 "gram.c"
    break;

  case 741: /* opt_foreign_server_version: foreign_server_version  */
#line 5618 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 36838 "gram.c"
    break;

  case 742: /* opt_foreign_server_version: %empty  */
#line 5619 "gram.y"
                                                                { (yyval.str) = NULL; }
#line 36844 "gram.c"
    break;

  case 743: /* AlterForeignServerStmt: ALTER SERVER name foreign_server_version alter_generic_options  */
#line 5630 "gram.y"
                                {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 36858 "gram.c"
    break;

  case 744: /* AlterForeignServerStmt: ALTER SERVER name foreign_server_version  */
#line 5640 "gram.y"
                                {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 36871 "gram.c"
    break;

  case 745: /* AlterForeignServerStmt: ALTER SERVER name alter_generic_options  */
#line 5649 "gram.y"
                                {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36883 "gram.c"
    break;

  case 746: /* CreateForeignTableStmt: CREATE FOREIGN TABLE qualified_name '(' OptTableElementList ')' OptInherit SERVER name create_generic_options  */
#line 5669 "gram.y"
                                {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36906 "gram.c"
    break;

  case 747: /* CreateForeignTableStmt: CREATE FOREIGN TABLE IF_P NOT EXISTS qualified_name '(' OptTableElementList ')' OptInherit SERVER name create_generic_options  */
#line 5690 "gram.y"
                                {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36929 "gram.c"
    break;

  case 748: /* CreateForeignTableStmt: CREATE FOREIGN TABLE qualified_name PARTITION OF qualified_name OptTypedTableElementList PartitionBoundSpec SERVER name create_generic_options  */
#line 5711 "gram.y"
                                {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36953 "gram.c"
    break;

  case 749: /* CreateForeignTableStmt: CREATE FOREIGN TABLE IF_P NOT EXISTS qualified_name PARTITION OF qualified_name OptTypedTableElementList PartitionBoundSpec SERVER name create_generic_options  */
#line 5733 "gram.y"
                                {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36977 "gram.c"
    break;

  case 750: /* ImportForeignSchemaStmt: IMPORT_P FOREIGN SCHEMA name import_qualification FROM SERVER name INTO name create_generic_options  */
#line 5766 "gram.y"
                        {
				ImportForeignSchemaStmt *n = makeNode(ImportForeignSchemaStmt);

				n->server_name = (yyvsp[-3].str);
				n->remote_schema = (yyvsp[-7].str);
				n->local_schema = (yyvsp[-1].str);
				n->list_type = (yyvsp[-6].importqual)->type;
				n->table_list = (yyvsp[-6].importqual)->table_names;
				n->options = (yyvsp[0].list);
				(yyval.node) = (Node *) n;
			}
#line 36993 "gram.c"
    break;

  case 751: /* import_qualification_type: LIMIT TO  */
#line 5780 "gram.y"
                                                        { (yyval.ival) = FDW_IMPORT_SCHEMA_LIMIT_TO; }
#line 36999 "gram.c"
    break;

  case 752: /* import_qualification_type: EXCEPT  */
#line 5781 "gram.y"
                                                        { (yyval.ival) = FDW_IMPORT_SCHEMA_EXCEPT; }
#line 37005 "gram.c"
    break;

  case 753: /* import_qualification: import_qualification_type '(' relation_expr_list ')'  */
#line 5786 "gram.y"
                        {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));

				n->type = (yyvsp[-3].ival);
				n->table_names = (yyvsp[-1].list);
				(yyval.importqual) = n;
			}
#line 37017 "gram.c"
    break;

  case 754: /* import_qualification: %empty  */
#line 5794 "gram.y"
                        {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = FDW_IMPORT_SCHEMA_ALL;
				n->table_names = NIL;
				(yyval.importqual) = n;
			}
#line 37028 "gram.c"
    break;

  case 755: /* CreateUserMappingStmt: CREATE USER MAPPING FOR auth_ident SERVER name create_generic_options  */
#line 5810 "gram.y"
                                {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 37042 "gram.c"
    break;

  case 756: /* CreateUserMappingStmt: CREATE USER MAPPING IF_P NOT EXISTS FOR auth_ident SERVER name create_generic_options  */
#line 5820 "gram.y"
                                {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 37056 "gram.c"
    break;

  case 757: /* auth_ident: RoleSpec  */
#line 5832 "gram.y"
                                        { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 37062 "gram.c"
    break;

  case 758: /* auth_ident: USER  */
#line 5833 "gram.y"
                                                        { (yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0])); }
#line 37068 "gram.c"
    break;

  case 759: /* DropUserMappingStmt: DROP USER MAPPING FOR auth_ident SERVER name  */
#line 5846 "gram.y"
                                {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);

					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 37081 "gram.c"
    break;

  case 760: /* DropUserMappingStmt: DROP USER MAPPING IF_P EXISTS FOR auth_ident SERVER name  */
#line 5855 "gram.y"
                                {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);

					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 37094 "gram.c"
    break;

  case 761: /* AlterUserMappingStmt: ALTER USER MAPPING FOR auth_ident SERVER name alter_generic_options  */
#line 5873 "gram.y"
                                {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37107 "gram.c"
    break;

  case 762: /* CreatePolicyStmt: CREATE POLICY name ON qualified_name RowSecurityDefaultPermissive RowSecurityDefaultForCmd RowSecurityDefaultToRole RowSecurityOptionalExpr RowSecurityOptionalWithCheck  */
#line 5900 "gram.y"
                                {
					CreatePolicyStmt *n = makeNode(CreatePolicyStmt);

					n->policy_name = (yyvsp[-7].str);
					n->table = (yyvsp[-5].range);
					n->permissive = (yyvsp[-4].boolean);
					n->cmd_name = (yyvsp[-3].str);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 37124 "gram.c"
    break;

  case 763: /* AlterPolicyStmt: ALTER POLICY name ON qualified_name RowSecurityOptionalToRole RowSecurityOptionalExpr RowSecurityOptionalWithCheck  */
#line 5917 "gram.y"
                                {
					AlterPolicyStmt *n = makeNode(AlterPolicyStmt);

					n->policy_name = (yyvsp[-5].str);
					n->table = (yyvsp[-3].range);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 37139 "gram.c"
    break;

  case 764: /* RowSecurityOptionalExpr: USING '(' a_expr ')'  */
#line 5930 "gram.y"
                                                { (yyval.node) = (yyvsp[-1].node); }
#line 37145 "gram.c"
    break;

  case 765: /* RowSecurityOptionalExpr: %empty  */
#line 5931 "gram.y"
                                                        { (yyval.node) = NULL; }
#line 37151 "gram.c"
    break;

  case 766: /* RowSecurityOptionalWithCheck: WITH CHECK '(' a_expr ')'  */
#line 5935 "gram.y"
                                                                { (yyval.node) = (yyvsp[-1].node); }
#line 37157 "gram.c"
    break;

  case 767: /* RowSecurityOptionalWithCheck: %empty  */
#line 5936 "gram.y"
                                                                        { (yyval.node) = NULL; }
#line 37163 "gram.c"
    break;

  case 768: /* RowSecurityDefaultToRole: TO role_list  */
#line 5940 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 37169 "gram.c"
    break;

  case 769: /* RowSecurityDefaultToRole: %empty  */
#line 5941 "gram.y"
                                                        { (yyval.list) = list_make1(makeRoleSpec(ROLESPEC_PUBLIC, -1)); }
#line 37175 "gram.c"
    break;

  case 770: /* RowSecurityOptionalToRole: TO role_list  */
#line 5945 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 37181 "gram.c"
    break;

  case 771: /* RowSecurityOptionalToRole: %empty  */
#line 5946 "gram.y"
                                                        { (yyval.list) = NULL; }
#line 37187 "gram.c"
    break;

  case 772: /* RowSecurityDefaultPermissive: AS IDENT  */
#line 5951 "gram.y"
                                {
					if (strcmp((yyvsp[0].str), "permissive") == 0)
						(yyval.boolean) = true;
					else if (strcmp((yyvsp[0].str), "restrictive") == 0)
						(yyval.boolean) = false;
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized row security option \"%s\"", (yyvsp[0].str)),
								 errhint("Only PERMISSIVE or RESTRICTIVE policies are supported currently."),
								 parser_errposition((yylsp[0]))));

				}
#line 37205 "gram.c"
    break;

  case 773: /* RowSecurityDefaultPermissive: %empty  */
#line 5964 "gram.y"
                                                        { (yyval.boolean) = true; }
#line 37211 "gram.c"
    break;

  case 774: /* RowSecurityDefaultForCmd: FOR row_security_cmd  */
#line 5968 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 37217 "gram.c"
    break;

  case 775: /* RowSecurityDefaultForCmd: %empty  */
#line 5969 "gram.y"
                                                        { (yyval.str) = "all"; }
#line 37223 "gram.c"
    break;

  case 776: /* row_security_cmd: ALL  */
#line 5973 "gram.y"
                                                        { (yyval.str) = "all"; }
#line 37229 "gram.c"
    break;

  case 777: /* row_security_cmd: SELECT  */
#line 5974 "gram.y"
                                                { (yyval.str) = "select"; }
#line 37235 "gram.c"
    break;

  case 778: /* row_security_cmd: INSERT  */
#line 5975 "gram.y"
                                                { (yyval.str) = "insert"; }
#line 37241 "gram.c"
    break;

  case 779: /* row_security_cmd: UPDATE  */
#line 5976 "gram.y"
                                                { (yyval.str) = "update"; }
#line 37247 "gram.c"
    break;

  case 780: /* row_security_cmd: DELETE_P  */
#line 5977 "gram.y"
                                                { (yyval.str) = "delete"; }
#line 37253 "gram.c"
    break;

  case 781: /* CreateAmStmt: CREATE ACCESS METHOD name TYPE_P am_type HANDLER handler_name  */
#line 5988 "gram.y"
                                {
					CreateAmStmt *n = makeNode(CreateAmStmt);

					n->amname = (yyvsp[-4].str);
					n->handler_name = (yyvsp[0].list);
					n->amtype = (yyvsp[-2].chr);
					(yyval.node) = (Node *) n;
				}
#line 37266 "gram.c"
    break;

  case 782: /* am_type: INDEX  */
#line 5999 "gram.y"
                                                { (yyval.chr) = AMTYPE_INDEX; }
#line 37272 "gram.c"
    break;

  case 783: /* am_type: TABLE  */
#line 6000 "gram.y"
                                                { (yyval.chr) = AMTYPE_TABLE; }
#line 37278 "gram.c"
    break;

  case 784: /* CreateTrigStmt: CREATE opt_or_replace TRIGGER name TriggerActionTime TriggerEvents ON qualified_name TriggerReferencing TriggerForSpec TriggerWhen EXECUTE FUNCTION_or_PROCEDURE func_name '(' TriggerFuncArgs ')'  */
#line 6014 "gram.y"
                                {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);

					n->replace = (yyvsp[-15].boolean);
					n->isconstraint = false;
					n->trigname = (yyvsp[-13].str);
					n->relation = (yyvsp[-9].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-12].ival);
					n->events = intVal(linitial((yyvsp[-11].list)));
					n->columns = (List *) lsecond((yyvsp[-11].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = (yyvsp[-8].list);
					n->deferrable = false;
					n->initdeferred = false;
					n->constrrel = NULL;
					(yyval.node) = (Node *) n;
				}
#line 37303 "gram.c"
    break;

  case 785: /* CreateTrigStmt: CREATE opt_or_replace CONSTRAINT TRIGGER name AFTER TriggerEvents ON qualified_name OptConstrFromTable ConstraintAttributeSpec FOR EACH ROW TriggerWhen EXECUTE FUNCTION_or_PROCEDURE func_name '(' TriggerFuncArgs ')'  */
#line 6038 "gram.y"
                                {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);

					n->replace = (yyvsp[-19].boolean);
					if (n->replace) /* not supported, see CreateTrigger */
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE OR REPLACE CONSTRAINT TRIGGER is not supported"),
								 parser_errposition((yylsp[-20]))));
					n->isconstraint = true;
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = true;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = NIL;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *) n;
				}
#line 37334 "gram.c"
    break;

  case 786: /* TriggerActionTime: BEFORE  */
#line 6067 "gram.y"
                                                                                        { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 37340 "gram.c"
    break;

  case 787: /* TriggerActionTime: AFTER  */
#line 6068 "gram.y"
                                                                                        { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 37346 "gram.c"
    break;

  case 788: /* TriggerActionTime: INSTEAD OF  */
#line 6069 "gram.y"
                                                                                { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 37352 "gram.c"
    break;

  case 789: /* TriggerEvents: TriggerOneEvent  */
#line 6074 "gram.y"
                                { (yyval.list) = (yyvsp[0].list); }
#line 37358 "gram.c"
    break;

  case 790: /* TriggerEvents: TriggerEvents OR TriggerOneEvent  */
#line 6076 "gram.y"
                                {
					int			events1 = intVal(linitial((yyvsp[-2].list)));
					int			events2 = intVal(linitial((yyvsp[0].list)));
					List	   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List	   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 37381 "gram.c"
    break;

  case 791: /* TriggerOneEvent: INSERT  */
#line 6098 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 37387 "gram.c"
    break;

  case 792: /* TriggerOneEvent: DELETE_P  */
#line 6100 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 37393 "gram.c"
    break;

  case 793: /* TriggerOneEvent: UPDATE  */
#line 6102 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 37399 "gram.c"
    break;

  case 794: /* TriggerOneEvent: UPDATE OF columnList  */
#line 6104 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 37405 "gram.c"
    break;

  case 795: /* TriggerOneEvent: TRUNCATE  */
#line 6106 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 37411 "gram.c"
    break;

  case 796: /* TriggerReferencing: REFERENCING TriggerTransitions  */
#line 6110 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 37417 "gram.c"
    break;

  case 797: /* TriggerReferencing: %empty  */
#line 6111 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 37423 "gram.c"
    break;

  case 798: /* TriggerTransitions: TriggerTransition  */
#line 6115 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 37429 "gram.c"
    break;

  case 799: /* TriggerTransitions: TriggerTransitions TriggerTransition  */
#line 6116 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 37435 "gram.c"
    break;

  case 800: /* TriggerTransition: TransitionOldOrNew TransitionRowOrTable opt_as TransitionRelName  */
#line 6121 "gram.y"
                                {
					TriggerTransition *n = makeNode(TriggerTransition);

					n->name = (yyvsp[0].str);
					n->isNew = (yyvsp[-3].boolean);
					n->isTable = (yyvsp[-2].boolean);
					(yyval.node) = (Node *) n;
				}
#line 37448 "gram.c"
    break;

  case 801: /* TransitionOldOrNew: NEW  */
#line 6132 "gram.y"
                                                                                                        { (yyval.boolean) = true; }
#line 37454 "gram.c"
    break;

  case 802: /* TransitionOldOrNew: OLD  */
#line 6133 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 37460 "gram.c"
    break;

  case 803: /* TransitionRowOrTable: TABLE  */
#line 6137 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 37466 "gram.c"
    break;

  case 804: /* TransitionRowOrTable: ROW  */
#line 6146 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 37472 "gram.c"
    break;

  case 805: /* TransitionRelName: ColId  */
#line 6150 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 37478 "gram.c"
    break;

  case 806: /* TriggerForSpec: FOR TriggerForOptEach TriggerForType  */
#line 6155 "gram.y"
                                {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 37486 "gram.c"
    break;

  case 807: /* TriggerForSpec: %empty  */
#line 6159 "gram.y"
                                {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = false;
				}
#line 37498 "gram.c"
    break;

  case 810: /* TriggerForType: ROW  */
#line 6174 "gram.y"
                                                                                                        { (yyval.boolean) = true; }
#line 37504 "gram.c"
    break;

  case 811: /* TriggerForType: STATEMENT  */
#line 6175 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 37510 "gram.c"
    break;

  case 812: /* TriggerWhen: WHEN '(' a_expr ')'  */
#line 6179 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[-1].node); }
#line 37516 "gram.c"
    break;

  case 813: /* TriggerWhen: %empty  */
#line 6180 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 37522 "gram.c"
    break;

  case 816: /* TriggerFuncArgs: TriggerFuncArg  */
#line 6189 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 37528 "gram.c"
    break;

  case 817: /* TriggerFuncArgs: TriggerFuncArgs ',' TriggerFuncArg  */
#line 6190 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 37534 "gram.c"
    break;

  case 818: /* TriggerFuncArgs: %empty  */
#line 6191 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 37540 "gram.c"
    break;

  case 819: /* TriggerFuncArg: Iconst  */
#line 6196 "gram.y"
                                {
					(yyval.node) = (Node *) makeString(psprintf("%d", (yyvsp[0].ival)));
				}
#line 37548 "gram.c"
    break;

  case 820: /* TriggerFuncArg: FCONST  */
#line 6199 "gram.y"
                                                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 37554 "gram.c"
    break;

  case 821: /* TriggerFuncArg: Sconst  */
#line 6200 "gram.y"
                                                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 37560 "gram.c"
    break;

  case 822: /* TriggerFuncArg: ColLabel  */
#line 6201 "gram.y"
                                                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 37566 "gram.c"
    break;

  case 823: /* OptConstrFromTable: FROM qualified_name  */
#line 6205 "gram.y"
                                                                                        { (yyval.range) = (yyvsp[0].range); }
#line 37572 "gram.c"
    break;

  case 824: /* OptConstrFromTable: %empty  */
#line 6206 "gram.y"
                                                                                                { (yyval.range) = NULL; }
#line 37578 "gram.c"
    break;

  case 825: /* ConstraintAttributeSpec: %empty  */
#line 6211 "gram.y"
                                { (yyval.ival) = 0; }
#line 37584 "gram.c"
    break;

  case 826: /* ConstraintAttributeSpec: ConstraintAttributeSpec ConstraintAttributeElem  */
#line 6213 "gram.y"
                                {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED) ||
						(newspec & (CAS_NOT_ENFORCED | CAS_ENFORCED)) == (CAS_NOT_ENFORCED | CAS_ENFORCED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 37613 "gram.c"
    break;

  case 827: /* ConstraintAttributeElem: NOT DEFERRABLE  */
#line 6240 "gram.y"
                                                                        { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 37619 "gram.c"
    break;

  case 828: /* ConstraintAttributeElem: DEFERRABLE  */
#line 6241 "gram.y"
                                                                        { (yyval.ival) = CAS_DEFERRABLE; }
#line 37625 "gram.c"
    break;

  case 829: /* ConstraintAttributeElem: INITIALLY IMMEDIATE  */
#line 6242 "gram.y"
                                                                { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 37631 "gram.c"
    break;

  case 830: /* ConstraintAttributeElem: INITIALLY DEFERRED  */
#line 6243 "gram.y"
                                                                { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 37637 "gram.c"
    break;

  case 831: /* ConstraintAttributeElem: NOT VALID  */
#line 6244 "gram.y"
                                                                                { (yyval.ival) = CAS_NOT_VALID; }
#line 37643 "gram.c"
    break;

  case 832: /* ConstraintAttributeElem: NO INHERIT  */
#line 6245 "gram.y"
                                                                        { (yyval.ival) = CAS_NO_INHERIT; }
#line 37649 "gram.c"
    break;

  case 833: /* ConstraintAttributeElem: NOT ENFORCED  */
#line 6246 "gram.y"
                                                                        { (yyval.ival) = CAS_NOT_ENFORCED; }
#line 37655 "gram.c"
    break;

  case 834: /* ConstraintAttributeElem: ENFORCED  */
#line 6247 "gram.y"
                                                                                { (yyval.ival) = CAS_ENFORCED; }
#line 37661 "gram.c"
    break;

  case 835: /* CreateEventTrigStmt: CREATE EVENT TRIGGER name ON ColLabel EXECUTE FUNCTION_or_PROCEDURE func_name '(' ')'  */
#line 6262 "gram.y"
                                {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);

					n->trigname = (yyvsp[-7].str);
					n->eventname = (yyvsp[-5].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 37675 "gram.c"
    break;

  case 836: /* CreateEventTrigStmt: CREATE EVENT TRIGGER name ON ColLabel WHEN event_trigger_when_list EXECUTE FUNCTION_or_PROCEDURE func_name '(' ')'  */
#line 6274 "gram.y"
                                {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);

					n->trigname = (yyvsp[-9].str);
					n->eventname = (yyvsp[-7].str);
					n->whenclause = (yyvsp[-5].list);
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 37689 "gram.c"
    break;

  case 837: /* event_trigger_when_list: event_trigger_when_item  */
#line 6287 "gram.y"
                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 37695 "gram.c"
    break;

  case 838: /* event_trigger_when_list: event_trigger_when_list AND event_trigger_when_item  */
#line 6289 "gram.y"
                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 37701 "gram.c"
    break;

  case 839: /* event_trigger_when_item: ColId IN_P '(' event_trigger_value_list ')'  */
#line 6294 "gram.y"
                        { (yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list), (yylsp[-4])); }
#line 37707 "gram.c"
    break;

  case 840: /* event_trigger_value_list: SCONST  */
#line 6299 "gram.y"
                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 37713 "gram.c"
    break;

  case 841: /* event_trigger_value_list: event_trigger_value_list ',' SCONST  */
#line 6301 "gram.y"
                        { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 37719 "gram.c"
    break;

  case 842: /* AlterEventTrigStmt: ALTER EVENT TRIGGER name enable_trigger  */
#line 6306 "gram.y"
                                {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);

					n->trigname = (yyvsp[-1].str);
					n->tgenabled = (yyvsp[0].chr);
					(yyval.node) = (Node *) n;
				}
#line 37731 "gram.c"
    break;

  case 843: /* enable_trigger: ENABLE_P  */
#line 6316 "gram.y"
                                                                        { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
#line 37737 "gram.c"
    break;

  case 844: /* enable_trigger: ENABLE_P REPLICA  */
#line 6317 "gram.y"
                                                                { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
#line 37743 "gram.c"
    break;

  case 845: /* enable_trigger: ENABLE_P ALWAYS  */
#line 6318 "gram.y"
                                                                { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
#line 37749 "gram.c"
    break;

  case 846: /* enable_trigger: DISABLE_P  */
#line 6319 "gram.y"
                                                                        { (yyval.chr) = TRIGGER_DISABLED; }
#line 37755 "gram.c"
    break;

  case 847: /* CreateAssertionStmt: CREATE ASSERTION any_name CHECK '(' a_expr ')' ConstraintAttributeSpec  */
#line 6331 "gram.y"
                                {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented"),
							 parser_errposition((yylsp[-7]))));

					(yyval.node) = NULL;
				}
#line 37768 "gram.c"
    break;

  case 848: /* DefineStmt: CREATE opt_or_replace AGGREGATE func_name aggr_args definition  */
#line 6351 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->replace = (yyvsp[-4].boolean);
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37784 "gram.c"
    break;

  case 849: /* DefineStmt: CREATE opt_or_replace AGGREGATE func_name old_aggr_definition  */
#line 6363 "gram.y"
                                {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->replace = (yyvsp[-3].boolean);
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37801 "gram.c"
    break;

  case 850: /* DefineStmt: CREATE OPERATOR any_operator definition  */
#line 6376 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37816 "gram.c"
    break;

  case 851: /* DefineStmt: CREATE TYPE_P any_name definition  */
#line 6387 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37831 "gram.c"
    break;

  case 852: /* DefineStmt: CREATE TYPE_P any_name  */
#line 6398 "gram.y"
                                {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *) n;
				}
#line 37847 "gram.c"
    break;

  case 853: /* DefineStmt: CREATE TYPE_P any_name AS '(' OptTableFuncElementList ')'  */
#line 6410 "gram.y"
                                {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 37860 "gram.c"
    break;

  case 854: /* DefineStmt: CREATE TYPE_P any_name AS ENUM_P '(' opt_enum_val_list ')'  */
#line 6419 "gram.y"
                                {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);

					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 37872 "gram.c"
    break;

  case 855: /* DefineStmt: CREATE TYPE_P any_name AS RANGE definition  */
#line 6427 "gram.y"
                                {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);

					n->typeName = (yyvsp[-3].list);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37884 "gram.c"
    break;

  case 856: /* DefineStmt: CREATE TEXT_P SEARCH PARSER any_name definition  */
#line 6435 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37898 "gram.c"
    break;

  case 857: /* DefineStmt: CREATE TEXT_P SEARCH DICTIONARY any_name definition  */
#line 6445 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37912 "gram.c"
    break;

  case 858: /* DefineStmt: CREATE TEXT_P SEARCH TEMPLATE any_name definition  */
#line 6455 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37926 "gram.c"
    break;

  case 859: /* DefineStmt: CREATE TEXT_P SEARCH CONFIGURATION any_name definition  */
#line 6465 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37940 "gram.c"
    break;

  case 860: /* DefineStmt: CREATE COLLATION any_name definition  */
#line 6475 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37954 "gram.c"
    break;

  case 861: /* DefineStmt: CREATE COLLATION IF_P NOT EXISTS any_name definition  */
#line 6485 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 37969 "gram.c"
    break;

  case 862: /* DefineStmt: CREATE COLLATION any_name FROM any_name  */
#line 6496 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 37983 "gram.c"
    break;

  case 863: /* DefineStmt: CREATE COLLATION IF_P NOT EXISTS any_name FROM any_name  */
#line 6506 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 37998 "gram.c"
    break;

  case 864: /* definition: '(' def_list ')'  */
#line 6518 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 38004 "gram.c"
    break;

  case 865: /* def_list: def_elem  */
#line 6521 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 38010 "gram.c"
    break;

  case 866: /* def_list: def_list ',' def_elem  */
#line 6522 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 38016 "gram.c"
    break;

  case 867: /* def_elem: ColLabel '=' def_arg  */
#line 6526 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 38024 "gram.c"
    break;

  case 868: /* def_elem: ColLabel  */
#line 6530 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 38032 "gram.c"
    break;

  case 869: /* def_arg: func_type  */
#line 6536 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[0].typnam); }
#line 38038 "gram.c"
    break;

  case 870: /* def_arg: reserved_keyword  */
#line 6537 "gram.y"
                                                                        { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 38044 "gram.c"
    break;

  case 871: /* def_arg: qual_all_Op  */
#line 6538 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[0].list); }
#line 38050 "gram.c"
    break;

  case 872: /* def_arg: NumericOnly  */
#line 6539 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 38056 "gram.c"
    break;

  case 873: /* def_arg: Sconst  */
#line 6540 "gram.y"
                                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 38062 "gram.c"
    break;

  case 874: /* def_arg: NONE  */
#line 6541 "gram.y"
                                                                                { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 38068 "gram.c"
    break;

  case 875: /* old_aggr_definition: '(' old_aggr_list ')'  */
#line 6544 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 38074 "gram.c"
    break;

  case 876: /* old_aggr_list: old_aggr_elem  */
#line 6547 "gram.y"
                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 38080 "gram.c"
    break;

  case 877: /* old_aggr_list: old_aggr_list ',' old_aggr_elem  */
#line 6548 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 38086 "gram.c"
    break;

  case 878: /* old_aggr_elem: IDENT '=' def_arg  */
#line 6557 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 38094 "gram.c"
    break;

  case 879: /* opt_enum_val_list: enum_val_list  */
#line 6563 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 38100 "gram.c"
    break;

  case 880: /* opt_enum_val_list: %empty  */
#line 6564 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 38106 "gram.c"
    break;

  case 881: /* enum_val_list: Sconst  */
#line 6568 "gram.y"
                                { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 38112 "gram.c"
    break;

  case 882: /* enum_val_list: enum_val_list ',' Sconst  */
#line 6570 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 38118 "gram.c"
    break;

  case 883: /* AlterEnumStmt: ALTER TYPE_P any_name ADD_P VALUE_P opt_if_not_exists Sconst  */
#line 6581 "gram.y"
                        {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-4].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-1].boolean);
				(yyval.node) = (Node *) n;
			}
#line 38134 "gram.c"
    break;

  case 884: /* AlterEnumStmt: ALTER TYPE_P any_name ADD_P VALUE_P opt_if_not_exists Sconst BEFORE Sconst  */
#line 6593 "gram.y"
                        {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 38150 "gram.c"
    break;

  case 885: /* AlterEnumStmt: ALTER TYPE_P any_name ADD_P VALUE_P opt_if_not_exists Sconst AFTER Sconst  */
#line 6605 "gram.y"
                        {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 38166 "gram.c"
    break;

  case 886: /* AlterEnumStmt: ALTER TYPE_P any_name RENAME VALUE_P Sconst TO Sconst  */
#line 6617 "gram.y"
                        {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-5].list);
				n->oldVal = (yyvsp[-2].str);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = false;
				n->skipIfNewValExists = false;
				(yyval.node) = (Node *) n;
			}
#line 38182 "gram.c"
    break;

  case 887: /* AlterEnumStmt: ALTER TYPE_P any_name DROP VALUE_P Sconst  */
#line 6629 "gram.y"
                        {
				/*
				 * The following problems must be solved before this can be
				 * implemented:
				 *
				 * - There must be no instance of the target value in
				 *   any table.
				 *
				 * - The value must not appear in any catalog metadata,
				 *   such as stored view expressions or column defaults.
				 *
				 * - The value must not appear in any non-leaf page of a
				 *   btree (and similar issues with other index types).
				 *   This is problematic because a value could persist
				 *   there long after it's gone from user-visible data.
				 *
				 * - Concurrent sessions must not be able to insert the
				 *   value while the preceding conditions are being checked.
				 *
				 * - Possibly more...
				 */
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("dropping an enum value is not implemented"),
						 parser_errposition((yylsp[-2]))));
			}
#line 38213 "gram.c"
    break;

  case 888: /* opt_if_not_exists: IF_P NOT EXISTS  */
#line 6657 "gram.y"
                                                { (yyval.boolean) = true; }
#line 38219 "gram.c"
    break;

  case 889: /* opt_if_not_exists: %empty  */
#line 6658 "gram.y"
                                                       { (yyval.boolean) = false; }
#line 38225 "gram.c"
    break;

  case 890: /* CreateOpClassStmt: CREATE OPERATOR CLASS any_name opt_default FOR TYPE_P Typename USING name opt_opfamily AS opclass_item_list  */
#line 6676 "gram.y"
                                {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);

					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 38241 "gram.c"
    break;

  case 891: /* opclass_item_list: opclass_item  */
#line 6690 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 38247 "gram.c"
    break;

  case 892: /* opclass_item_list: opclass_item_list ',' opclass_item  */
#line 6691 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 38253 "gram.c"
    break;

  case 893: /* opclass_item: OPERATOR Iconst any_operator opclass_purpose  */
#line 6696 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					ObjectWithArgs *owa = makeNode(ObjectWithArgs);

					owa->objname = (yyvsp[-1].list);
					owa->objargs = NIL;
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = owa;
					n->number = (yyvsp[-2].ival);
					n->order_family = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 38270 "gram.c"
    break;

  case 894: /* opclass_item: OPERATOR Iconst operator_with_argtypes opclass_purpose  */
#line 6709 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-1].objwithargs);
					n->number = (yyvsp[-2].ival);
					n->order_family = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 38284 "gram.c"
    break;

  case 895: /* opclass_item: FUNCTION Iconst function_with_argtypes  */
#line 6719 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-1].ival);
					(yyval.node) = (Node *) n;
				}
#line 38297 "gram.c"
    break;

  case 896: /* opclass_item: FUNCTION Iconst '(' type_list ')' function_with_argtypes  */
#line 6728 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-4].ival);
					n->class_args = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 38311 "gram.c"
    break;

  case 897: /* opclass_item: STORAGE Typename  */
#line 6738 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 38323 "gram.c"
    break;

  case 898: /* opt_default: DEFAULT  */
#line 6747 "gram.y"
                                                                { (yyval.boolean) = true; }
#line 38329 "gram.c"
    break;

  case 899: /* opt_default: %empty  */
#line 6748 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 38335 "gram.c"
    break;

  case 900: /* opt_opfamily: FAMILY any_name  */
#line 6751 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 38341 "gram.c"
    break;

  case 901: /* opt_opfamily: %empty  */
#line 6752 "gram.y"
                                                                                { (yyval.list) = NIL; }
#line 38347 "gram.c"
    break;

  case 902: /* opclass_purpose: FOR SEARCH  */
#line 6755 "gram.y"
                                                                { (yyval.list) = NIL; }
#line 38353 "gram.c"
    break;

  case 903: /* opclass_purpose: FOR ORDER BY any_name  */
#line 6756 "gram.y"
                                                                { (yyval.list) = (yyvsp[0].list); }
#line 38359 "gram.c"
    break;

  case 904: /* opclass_purpose: %empty  */
#line 6757 "gram.y"
                                                                                { (yyval.list) = NIL; }
#line 38365 "gram.c"
    break;

  case 905: /* CreateOpFamilyStmt: CREATE OPERATOR FAMILY any_name USING name  */
#line 6763 "gram.y"
                                {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);

					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38377 "gram.c"
    break;

  case 906: /* AlterOpFamilyStmt: ALTER OPERATOR FAMILY any_name USING name ADD_P opclass_item_list  */
#line 6774 "gram.y"
                                {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);

					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 38391 "gram.c"
    break;

  case 907: /* AlterOpFamilyStmt: ALTER OPERATOR FAMILY any_name USING name DROP opclass_drop_list  */
#line 6784 "gram.y"
                                {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);

					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 38405 "gram.c"
    break;

  case 908: /* opclass_drop_list: opclass_drop  */
#line 6796 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 38411 "gram.c"
    break;

  case 909: /* opclass_drop_list: opclass_drop_list ',' opclass_drop  */
#line 6797 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 38417 "gram.c"
    break;

  case 910: /* opclass_drop: OPERATOR Iconst '(' type_list ')'  */
#line 6802 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 38430 "gram.c"
    break;

  case 911: /* opclass_drop: FUNCTION Iconst '(' type_list ')'  */
#line 6811 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 38443 "gram.c"
    break;

  case 912: /* DropOpClassStmt: DROP OPERATOR CLASS any_name USING name opt_drop_behavior  */
#line 6824 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38458 "gram.c"
    break;

  case 913: /* DropOpClassStmt: DROP OPERATOR CLASS IF_P EXISTS any_name USING name opt_drop_behavior  */
#line 6835 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38473 "gram.c"
    break;

  case 914: /* DropOpFamilyStmt: DROP OPERATOR FAMILY any_name USING name opt_drop_behavior  */
#line 6849 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38488 "gram.c"
    break;

  case 915: /* DropOpFamilyStmt: DROP OPERATOR FAMILY IF_P EXISTS any_name USING name opt_drop_behavior  */
#line 6860 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38503 "gram.c"
    break;

  case 916: /* DropOwnedStmt: DROP OWNED BY role_list opt_drop_behavior  */
#line 6883 "gram.y"
                                {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);

					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38515 "gram.c"
    break;

  case 917: /* ReassignOwnedStmt: REASSIGN OWNED BY role_list TO RoleSpec  */
#line 6894 "gram.y"
                                {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);

					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 38527 "gram.c"
    break;

  case 918: /* DropStmt: DROP object_type_any_name IF_P EXISTS any_name_list opt_drop_behavior  */
#line 6913 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38542 "gram.c"
    break;

  case 919: /* DropStmt: DROP object_type_any_name any_name_list opt_drop_behavior  */
#line 6924 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38557 "gram.c"
    break;

  case 920: /* DropStmt: DROP drop_type_name IF_P EXISTS name_list opt_drop_behavior  */
#line 6935 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38572 "gram.c"
    break;

  case 921: /* DropStmt: DROP drop_type_name name_list opt_drop_behavior  */
#line 6946 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38587 "gram.c"
    break;

  case 922: /* DropStmt: DROP object_type_name_on_any_name name ON any_name opt_drop_behavior  */
#line 6957 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38602 "gram.c"
    break;

  case 923: /* DropStmt: DROP object_type_name_on_any_name IF_P EXISTS name ON any_name opt_drop_behavior  */
#line 6968 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-6].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38617 "gram.c"
    break;

  case 924: /* DropStmt: DROP TYPE_P type_name_list opt_drop_behavior  */
#line 6979 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TYPE;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38632 "gram.c"
    break;

  case 925: /* DropStmt: DROP TYPE_P IF_P EXISTS type_name_list opt_drop_behavior  */
#line 6990 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TYPE;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38647 "gram.c"
    break;

  case 926: /* DropStmt: DROP DOMAIN_P type_name_list opt_drop_behavior  */
#line 7001 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38662 "gram.c"
    break;

  case 927: /* DropStmt: DROP DOMAIN_P IF_P EXISTS type_name_list opt_drop_behavior  */
#line 7012 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38677 "gram.c"
    break;

  case 928: /* DropStmt: DROP INDEX CONCURRENTLY any_name_list opt_drop_behavior  */
#line 7023 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_INDEX;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *) n;
				}
#line 38692 "gram.c"
    break;

  case 929: /* DropStmt: DROP INDEX CONCURRENTLY IF_P EXISTS any_name_list opt_drop_behavior  */
#line 7034 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_INDEX;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *) n;
				}
#line 38707 "gram.c"
    break;

  case 930: /* object_type_any_name: TABLE  */
#line 7048 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_TABLE; }
#line 38713 "gram.c"
    break;

  case 931: /* object_type_any_name: SEQUENCE  */
#line 7049 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 38719 "gram.c"
    break;

  case 932: /* object_type_any_name: VIEW  */
#line 7050 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_VIEW; }
#line 38725 "gram.c"
    break;

  case 933: /* object_type_any_name: MATERIALIZED VIEW  */
#line 7051 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_MATVIEW; }
#line 38731 "gram.c"
    break;

  case 934: /* object_type_any_name: INDEX  */
#line 7052 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_INDEX; }
#line 38737 "gram.c"
    break;

  case 935: /* object_type_any_name: FOREIGN TABLE  */
#line 7053 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 38743 "gram.c"
    break;

  case 936: /* object_type_any_name: COLLATION  */
#line 7054 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_COLLATION; }
#line 38749 "gram.c"
    break;

  case 937: /* object_type_any_name: CONVERSION_P  */
#line 7055 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_CONVERSION; }
#line 38755 "gram.c"
    break;

  case 938: /* object_type_any_name: STATISTICS  */
#line 7056 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_STATISTIC_EXT; }
#line 38761 "gram.c"
    break;

  case 939: /* object_type_any_name: TEXT_P SEARCH PARSER  */
#line 7057 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_TSPARSER; }
#line 38767 "gram.c"
    break;

  case 940: /* object_type_any_name: TEXT_P SEARCH DICTIONARY  */
#line 7058 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 38773 "gram.c"
    break;

  case 941: /* object_type_any_name: TEXT_P SEARCH TEMPLATE  */
#line 7059 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 38779 "gram.c"
    break;

  case 942: /* object_type_any_name: TEXT_P SEARCH CONFIGURATION  */
#line 7060 "gram.y"
                                                                        { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 38785 "gram.c"
    break;

  case 943: /* object_type_name: drop_type_name  */
#line 7070 "gram.y"
                                                                                        { (yyval.objtype) = (yyvsp[0].objtype); }
#line 38791 "gram.c"
    break;

  case 944: /* object_type_name: DATABASE  */
#line 7071 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_DATABASE; }
#line 38797 "gram.c"
    break;

  case 945: /* object_type_name: ROLE  */
#line 7072 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_ROLE; }
#line 38803 "gram.c"
    break;

  case 946: /* object_type_name: SUBSCRIPTION  */
#line 7073 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_SUBSCRIPTION; }
#line 38809 "gram.c"
    break;

  case 947: /* object_type_name: TABLESPACE  */
#line 7074 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 38815 "gram.c"
    break;

  case 948: /* drop_type_name: ACCESS METHOD  */
#line 7078 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 38821 "gram.c"
    break;

  case 949: /* drop_type_name: EVENT TRIGGER  */
#line 7079 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 38827 "gram.c"
    break;

  case 950: /* drop_type_name: EXTENSION  */
#line 7080 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_EXTENSION; }
#line 38833 "gram.c"
    break;

  case 951: /* drop_type_name: FOREIGN DATA_P WRAPPER  */
#line 7081 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_FDW; }
#line 38839 "gram.c"
    break;

  case 952: /* drop_type_name: opt_procedural LANGUAGE  */
#line 7082 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_LANGUAGE; }
#line 38845 "gram.c"
    break;

  case 953: /* drop_type_name: PUBLICATION  */
#line 7083 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 38851 "gram.c"
    break;

  case 954: /* drop_type_name: SCHEMA  */
#line 7084 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_SCHEMA; }
#line 38857 "gram.c"
    break;

  case 955: /* drop_type_name: SERVER  */
#line 7085 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 38863 "gram.c"
    break;

  case 956: /* object_type_name_on_any_name: POLICY  */
#line 7090 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_POLICY; }
#line 38869 "gram.c"
    break;

  case 957: /* object_type_name_on_any_name: RULE  */
#line 7091 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_RULE; }
#line 38875 "gram.c"
    break;

  case 958: /* object_type_name_on_any_name: TRIGGER  */
#line 7092 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_TRIGGER; }
#line 38881 "gram.c"
    break;

  case 959: /* any_name_list: any_name  */
#line 7096 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 38887 "gram.c"
    break;

  case 960: /* any_name_list: any_name_list ',' any_name  */
#line 7097 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 38893 "gram.c"
    break;

  case 961: /* any_name: ColId  */
#line 7100 "gram.y"
                                                                { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 38899 "gram.c"
    break;

  case 962: /* any_name: ColId attrs  */
#line 7101 "gram.y"
                                                                { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 38905 "gram.c"
    break;

  case 963: /* attrs: '.' attr_name  */
#line 7105 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 38911 "gram.c"
    break;

  case 964: /* attrs: attrs '.' attr_name  */
#line 7107 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 38917 "gram.c"
    break;

  case 965: /* type_name_list: Typename  */
#line 7111 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 38923 "gram.c"
    break;

  case 966: /* type_name_list: type_name_list ',' Typename  */
#line 7112 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 38929 "gram.c"
    break;

  case 967: /* TruncateStmt: TRUNCATE opt_table relation_expr_list opt_restart_seqs opt_drop_behavior  */
#line 7124 "gram.y"
                                {
					TruncateStmt *n = makeNode(TruncateStmt);

					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38942 "gram.c"
    break;

  case 968: /* opt_restart_seqs: CONTINUE_P IDENTITY_P  */
#line 7135 "gram.y"
                                                        { (yyval.boolean) = false; }
#line 38948 "gram.c"
    break;

  case 969: /* opt_restart_seqs: RESTART IDENTITY_P  */
#line 7136 "gram.y"
                                                        { (yyval.boolean) = true; }
#line 38954 "gram.c"
    break;

  case 970: /* opt_restart_seqs: %empty  */
#line 7137 "gram.y"
                                                                { (yyval.boolean) = false; }
#line 38960 "gram.c"
    break;

  case 971: /* CommentStmt: COMMENT ON object_type_any_name any_name IS comment_text  */
#line 7148 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38973 "gram.c"
    break;

  case 972: /* CommentStmt: COMMENT ON COLUMN any_name IS comment_text  */
#line 7157 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38986 "gram.c"
    break;

  case 973: /* CommentStmt: COMMENT ON object_type_name name IS comment_text  */
#line 7166 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38999 "gram.c"
    break;

  case 974: /* CommentStmt: COMMENT ON TYPE_P Typename IS comment_text  */
#line 7175 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39012 "gram.c"
    break;

  case 975: /* CommentStmt: COMMENT ON DOMAIN_P Typename IS comment_text  */
#line 7184 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39025 "gram.c"
    break;

  case 976: /* CommentStmt: COMMENT ON AGGREGATE aggregate_with_argtypes IS comment_text  */
#line 7193 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39038 "gram.c"
    break;

  case 977: /* CommentStmt: COMMENT ON FUNCTION function_with_argtypes IS comment_text  */
#line 7202 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39051 "gram.c"
    break;

  case 978: /* CommentStmt: COMMENT ON OPERATOR operator_with_argtypes IS comment_text  */
#line 7211 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39064 "gram.c"
    break;

  case 979: /* CommentStmt: COMMENT ON CONSTRAINT name ON any_name IS comment_text  */
#line 7220 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TABCONSTRAINT;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39077 "gram.c"
    break;

  case 980: /* CommentStmt: COMMENT ON CONSTRAINT name ON DOMAIN_P any_name IS comment_text  */
#line 7229 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_DOMCONSTRAINT;
					/*
					 * should use Typename not any_name in the production, but
					 * there's a shift/reduce conflict if we do that, so fix it
					 * up here.
					 */
					n->object = (Node *) list_make2(makeTypeNameFromNameList((yyvsp[-2].list)), makeString((yyvsp[-5].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39095 "gram.c"
    break;

  case 981: /* CommentStmt: COMMENT ON object_type_name_on_any_name name ON any_name IS comment_text  */
#line 7243 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-5].objtype);
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39108 "gram.c"
    break;

  case 982: /* CommentStmt: COMMENT ON PROCEDURE function_with_argtypes IS comment_text  */
#line 7252 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39121 "gram.c"
    break;

  case 983: /* CommentStmt: COMMENT ON ROUTINE function_with_argtypes IS comment_text  */
#line 7261 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39134 "gram.c"
    break;

  case 984: /* CommentStmt: COMMENT ON TRANSFORM FOR Typename LANGUAGE name IS comment_text  */
#line 7270 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-4].typnam), makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39147 "gram.c"
    break;

  case 985: /* CommentStmt: COMMENT ON OPERATOR CLASS any_name USING name IS comment_text  */
#line 7279 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39160 "gram.c"
    break;

  case 986: /* CommentStmt: COMMENT ON OPERATOR FAMILY any_name USING name IS comment_text  */
#line 7288 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39173 "gram.c"
    break;

  case 987: /* CommentStmt: COMMENT ON LARGE_P OBJECT_P NumericOnly IS comment_text  */
#line 7297 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].node);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39186 "gram.c"
    break;

  case 988: /* CommentStmt: COMMENT ON CAST '(' Typename AS Typename ')' IS comment_text  */
#line 7306 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-5].typnam), (yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39199 "gram.c"
    break;

  case 989: /* comment_text: Sconst  */
#line 7317 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 39205 "gram.c"
    break;

  case 990: /* comment_text: NULL_P  */
#line 7318 "gram.y"
                                                                                        { (yyval.str) = NULL; }
#line 39211 "gram.c"
    break;

  case 991: /* SecLabelStmt: SECURITY LABEL opt_provider ON object_type_any_name any_name IS security_label  */
#line 7334 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39225 "gram.c"
    break;

  case 992: /* SecLabelStmt: SECURITY LABEL opt_provider ON COLUMN any_name IS security_label  */
#line 7345 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39239 "gram.c"
    break;

  case 993: /* SecLabelStmt: SECURITY LABEL opt_provider ON object_type_name name IS security_label  */
#line 7356 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39253 "gram.c"
    break;

  case 994: /* SecLabelStmt: SECURITY LABEL opt_provider ON TYPE_P Typename IS security_label  */
#line 7367 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39267 "gram.c"
    break;

  case 995: /* SecLabelStmt: SECURITY LABEL opt_provider ON DOMAIN_P Typename IS security_label  */
#line 7378 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39281 "gram.c"
    break;

  case 996: /* SecLabelStmt: SECURITY LABEL opt_provider ON AGGREGATE aggregate_with_argtypes IS security_label  */
#line 7389 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39295 "gram.c"
    break;

  case 997: /* SecLabelStmt: SECURITY LABEL opt_provider ON FUNCTION function_with_argtypes IS security_label  */
#line 7400 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39309 "gram.c"
    break;

  case 998: /* SecLabelStmt: SECURITY LABEL opt_provider ON LARGE_P OBJECT_P NumericOnly IS security_label  */
#line 7411 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].node);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39323 "gram.c"
    break;

  case 999: /* SecLabelStmt: SECURITY LABEL opt_provider ON PROCEDURE function_with_argtypes IS security_label  */
#line 7422 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39337 "gram.c"
    break;

  case 1000: /* SecLabelStmt: SECURITY LABEL opt_provider ON ROUTINE function_with_argtypes IS security_label  */
#line 7433 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39351 "gram.c"
    break;

  case 1001: /* opt_provider: FOR NonReservedWord_or_Sconst  */
#line 7444 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 39357 "gram.c"
    break;

  case 1002: /* opt_provider: %empty  */
#line 7445 "gram.y"
                                                                                { (yyval.str) = NULL; }
#line 39363 "gram.c"
    break;

  case 1003: /* security_label: Sconst  */
#line 7448 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 39369 "gram.c"
    break;

  case 1004: /* security_label: NULL_P  */
#line 7449 "gram.y"
                                                                { (yyval.str) = NULL; }
#line 39375 "gram.c"
    break;

  case 1005: /* FetchStmt: FETCH fetch_args  */
#line 7460 "gram.y"
                                {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);

					n->ismove = false;
					(yyval.node) = (Node *) n;
				}
#line 39386 "gram.c"
    break;

  case 1006: /* FetchStmt: MOVE fetch_args  */
#line 7467 "gram.y"
                                {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);

					n->ismove = true;
					(yyval.node) = (Node *) n;
				}
#line 39397 "gram.c"
    break;

  case 1007: /* fetch_args: cursor_name  */
#line 7476 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39410 "gram.c"
    break;

  case 1008: /* fetch_args: from_in cursor_name  */
#line 7485 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39423 "gram.c"
    break;

  case 1009: /* fetch_args: NEXT opt_from_in cursor_name  */
#line 7494 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39436 "gram.c"
    break;

  case 1010: /* fetch_args: PRIOR opt_from_in cursor_name  */
#line 7503 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39449 "gram.c"
    break;

  case 1011: /* fetch_args: FIRST_P opt_from_in cursor_name  */
#line 7512 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39462 "gram.c"
    break;

  case 1012: /* fetch_args: LAST_P opt_from_in cursor_name  */
#line 7521 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *) n;
				}
#line 39475 "gram.c"
    break;

  case 1013: /* fetch_args: ABSOLUTE_P SignedIconst opt_from_in cursor_name  */
#line 7530 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 39488 "gram.c"
    break;

  case 1014: /* fetch_args: RELATIVE_P SignedIconst opt_from_in cursor_name  */
#line 7539 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 39501 "gram.c"
    break;

  case 1015: /* fetch_args: SignedIconst opt_from_in cursor_name  */
#line 7548 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 39514 "gram.c"
    break;

  case 1016: /* fetch_args: ALL opt_from_in cursor_name  */
#line 7557 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 39527 "gram.c"
    break;

  case 1017: /* fetch_args: FORWARD opt_from_in cursor_name  */
#line 7566 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39540 "gram.c"
    break;

  case 1018: /* fetch_args: FORWARD SignedIconst opt_from_in cursor_name  */
#line 7575 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 39553 "gram.c"
    break;

  case 1019: /* fetch_args: FORWARD ALL opt_from_in cursor_name  */
#line 7584 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 39566 "gram.c"
    break;

  case 1020: /* fetch_args: BACKWARD opt_from_in cursor_name  */
#line 7593 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39579 "gram.c"
    break;

  case 1021: /* fetch_args: BACKWARD SignedIconst opt_from_in cursor_name  */
#line 7602 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 39592 "gram.c"
    break;

  case 1022: /* fetch_args: BACKWARD ALL opt_from_in cursor_name  */
#line 7611 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 39605 "gram.c"
    break;

  case 1027: /* GrantStmt: GRANT privileges ON privilege_target TO grantee_list opt_grant_grant_option opt_granted_by  */
#line 7638 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grant_option = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 39623 "gram.c"
    break;

  case 1028: /* RevokeStmt: REVOKE privileges ON privilege_target FROM grantee_list opt_granted_by opt_drop_behavior  */
#line 7656 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 39642 "gram.c"
    break;

  case 1029: /* RevokeStmt: REVOKE GRANT OPTION FOR privileges ON privilege_target FROM grantee_list opt_granted_by opt_drop_behavior  */
#line 7672 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 39661 "gram.c"
    break;

  case 1030: /* privileges: privilege_list  */
#line 7699 "gram.y"
                                { (yyval.list) = (yyvsp[0].list); }
#line 39667 "gram.c"
    break;

  case 1031: /* privileges: ALL  */
#line 7701 "gram.y"
                                { (yyval.list) = NIL; }
#line 39673 "gram.c"
    break;

  case 1032: /* privileges: ALL PRIVILEGES  */
#line 7703 "gram.y"
                                { (yyval.list) = NIL; }
#line 39679 "gram.c"
    break;

  case 1033: /* privileges: ALL '(' columnList ')'  */
#line 7705 "gram.y"
                                {
					AccessPriv *n = makeNode(AccessPriv);

					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 39691 "gram.c"
    break;

  case 1034: /* privileges: ALL PRIVILEGES '(' columnList ')'  */
#line 7713 "gram.y"
                                {
					AccessPriv *n = makeNode(AccessPriv);

					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 39703 "gram.c"
    break;

  case 1035: /* privilege_list: privilege  */
#line 7722 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 39709 "gram.c"
    break;

  case 1036: /* privilege_list: privilege_list ',' privilege  */
#line 7723 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 39715 "gram.c"
    break;

  case 1037: /* privilege: SELECT opt_column_list  */
#line 7727 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 39727 "gram.c"
    break;

  case 1038: /* privilege: REFERENCES opt_column_list  */
#line 7735 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 39739 "gram.c"
    break;

  case 1039: /* privilege: CREATE opt_column_list  */
#line 7743 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 39751 "gram.c"
    break;

  case 1040: /* privilege: ALTER SYSTEM_P  */
#line 7751 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup("alter system");
				n->cols = NIL;
				(yyval.accesspriv) = n;
			}
#line 39762 "gram.c"
    break;

  case 1041: /* privilege: ColId opt_column_list  */
#line 7758 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 39774 "gram.c"
    break;

  case 1042: /* parameter_name_list: parameter_name  */
#line 7769 "gram.y"
                        {
				(yyval.list) = list_make1(makeString((yyvsp[0].str)));
			}
#line 39782 "gram.c"
    break;

  case 1043: /* parameter_name_list: parameter_name_list ',' parameter_name  */
#line 7773 "gram.y"
                        {
				(yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str)));
			}
#line 39790 "gram.c"
    break;

  case 1044: /* parameter_name: ColId  */
#line 7780 "gram.y"
                        {
				(yyval.str) = (yyvsp[0].str);
			}
#line 39798 "gram.c"
    break;

  case 1045: /* parameter_name: parameter_name '.' ColId  */
#line 7784 "gram.y"
                        {
				(yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str));
			}
#line 39806 "gram.c"
    break;

  case 1046: /* privilege_target: qualified_name_list  */
#line 7795 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39819 "gram.c"
    break;

  case 1047: /* privilege_target: TABLE qualified_name_list  */
#line 7804 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39832 "gram.c"
    break;

  case 1048: /* privilege_target: SEQUENCE qualified_name_list  */
#line 7813 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39845 "gram.c"
    break;

  case 1049: /* privilege_target: FOREIGN DATA_P WRAPPER name_list  */
#line 7822 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39858 "gram.c"
    break;

  case 1050: /* privilege_target: FOREIGN SERVER name_list  */
#line 7831 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39871 "gram.c"
    break;

  case 1051: /* privilege_target: FUNCTION function_with_argtypes_list  */
#line 7840 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39884 "gram.c"
    break;

  case 1052: /* privilege_target: PROCEDURE function_with_argtypes_list  */
#line 7849 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39897 "gram.c"
    break;

  case 1053: /* privilege_target: ROUTINE function_with_argtypes_list  */
#line 7858 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39910 "gram.c"
    break;

  case 1054: /* privilege_target: DATABASE name_list  */
#line 7867 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39923 "gram.c"
    break;

  case 1055: /* privilege_target: DOMAIN_P any_name_list  */
#line 7876 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39936 "gram.c"
    break;

  case 1056: /* privilege_target: LANGUAGE name_list  */
#line 7885 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39949 "gram.c"
    break;

  case 1057: /* privilege_target: LARGE_P OBJECT_P NumericOnly_list  */
#line 7894 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39962 "gram.c"
    break;

  case 1058: /* privilege_target: PARAMETER parameter_name_list  */
#line 7903 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PARAMETER_ACL;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39974 "gram.c"
    break;

  case 1059: /* privilege_target: SCHEMA name_list  */
#line 7911 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SCHEMA;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39987 "gram.c"
    break;

  case 1060: /* privilege_target: TABLESPACE name_list  */
#line 7920 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 40000 "gram.c"
    break;

  case 1061: /* privilege_target: TYPE_P any_name_list  */
#line 7929 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 40013 "gram.c"
    break;

  case 1062: /* privilege_target: ALL TABLES IN_P SCHEMA name_list  */
#line 7938 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 40026 "gram.c"
    break;

  case 1063: /* privilege_target: ALL SEQUENCES IN_P SCHEMA name_list  */
#line 7947 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 40039 "gram.c"
    break;

  case 1064: /* privilege_target: ALL FUNCTIONS IN_P SCHEMA name_list  */
#line 7956 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 40052 "gram.c"
    break;

  case 1065: /* privilege_target: ALL PROCEDURES IN_P SCHEMA name_list  */
#line 7965 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 40065 "gram.c"
    break;

  case 1066: /* privilege_target: ALL ROUTINES IN_P SCHEMA name_list  */
#line 7974 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 40078 "gram.c"
    break;

  case 1067: /* grantee_list: grantee  */
#line 7986 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 40084 "gram.c"
    break;

  case 1068: /* grantee_list: grantee_list ',' grantee  */
#line 7987 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 40090 "gram.c"
    break;

  case 1069: /* grantee: RoleSpec  */
#line 7991 "gram.y"
                                                                                                { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 40096 "gram.c"
    break;

  case 1070: /* grantee: GROUP_P RoleSpec  */
#line 7992 "gram.y"
                                                                                        { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 40102 "gram.c"
    break;

  case 1071: /* opt_grant_grant_option: WITH GRANT OPTION  */
#line 7997 "gram.y"
                                          { (yyval.boolean) = true; }
#line 40108 "gram.c"
    break;

  case 1072: /* opt_grant_grant_option: %empty  */
#line 7998 "gram.y"
                                    { (yyval.boolean) = false; }
#line 40114 "gram.c"
    break;

  case 1073: /* GrantRoleStmt: GRANT privilege_list TO role_list opt_granted_by  */
#line 8009 "gram.y"
                                {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = true;
					n->granted_roles = (yyvsp[-3].list);
					n->grantee_roles = (yyvsp[-1].list);
					n->opt = NIL;
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40129 "gram.c"
    break;

  case 1074: /* GrantRoleStmt: GRANT privilege_list TO role_list WITH grant_role_opt_list opt_granted_by  */
#line 8020 "gram.y"
                                {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = true;
					n->granted_roles = (yyvsp[-5].list);
					n->grantee_roles = (yyvsp[-3].list);
					n->opt = (yyvsp[-1].list);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40144 "gram.c"
    break;

  case 1075: /* RevokeRoleStmt: REVOKE privilege_list FROM role_list opt_granted_by opt_drop_behavior  */
#line 8034 "gram.y"
                                {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = false;
					n->opt = NIL;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 40160 "gram.c"
    break;

  case 1076: /* RevokeRoleStmt: REVOKE ColId OPTION FOR privilege_list FROM role_list opt_granted_by opt_drop_behavior  */
#line 8046 "gram.y"
                                {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					DefElem *opt;

					opt = makeDefElem(pstrdup((yyvsp[-7].str)),
									  (Node *) makeBoolean(false), (yylsp[-7]));
					n->is_grant = false;
					n->opt = list_make1(opt);
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 40179 "gram.c"
    break;

  case 1077: /* grant_role_opt_list: grant_role_opt_list ',' grant_role_opt  */
#line 8063 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 40185 "gram.c"
    break;

  case 1078: /* grant_role_opt_list: grant_role_opt  */
#line 8064 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 40191 "gram.c"
    break;

  case 1079: /* grant_role_opt: ColLabel grant_role_opt_value  */
#line 8069 "gram.y"
                        {
				(yyval.defelt) = makeDefElem(pstrdup((yyvsp[-1].str)), (yyvsp[0].node), (yylsp[-1]));
			}
#line 40199 "gram.c"
    break;

  case 1080: /* grant_role_opt_value: OPTION  */
#line 8075 "gram.y"
                                        { (yyval.node) = (Node *) makeBoolean(true); }
#line 40205 "gram.c"
    break;

  case 1081: /* grant_role_opt_value: TRUE_P  */
#line 8076 "gram.y"
                                        { (yyval.node) = (Node *) makeBoolean(true); }
#line 40211 "gram.c"
    break;

  case 1082: /* grant_role_opt_value: FALSE_P  */
#line 8077 "gram.y"
                                        { (yyval.node) = (Node *) makeBoolean(false); }
#line 40217 "gram.c"
    break;

  case 1083: /* opt_granted_by: GRANTED BY RoleSpec  */
#line 8080 "gram.y"
                                                                                { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 40223 "gram.c"
    break;

  case 1084: /* opt_granted_by: %empty  */
#line 8081 "gram.y"
                                                                                                        { (yyval.rolespec) = NULL; }
#line 40229 "gram.c"
    break;

  case 1085: /* AlterDefaultPrivilegesStmt: ALTER DEFAULT PRIVILEGES DefACLOptionList DefACLAction  */
#line 8092 "gram.y"
                                {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);

					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 40241 "gram.c"
    break;

  case 1086: /* DefACLOptionList: DefACLOptionList DefACLOption  */
#line 8102 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 40247 "gram.c"
    break;

  case 1087: /* DefACLOptionList: %empty  */
#line 8103 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 40253 "gram.c"
    break;

  case 1088: /* DefACLOption: IN_P SCHEMA name_list  */
#line 8108 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("schemas", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 40261 "gram.c"
    break;

  case 1089: /* DefACLOption: FOR ROLE role_list  */
#line 8112 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("roles", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 40269 "gram.c"
    break;

  case 1090: /* DefACLOption: FOR USER role_list  */
#line 8116 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("roles", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 40277 "gram.c"
    break;

  case 1091: /* DefACLAction: GRANT privileges ON defacl_privilege_target TO grantee_list opt_grant_grant_option  */
#line 8128 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40294 "gram.c"
    break;

  case 1092: /* DefACLAction: REVOKE privileges ON defacl_privilege_target FROM grantee_list opt_drop_behavior  */
#line 8142 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 40312 "gram.c"
    break;

  case 1093: /* DefACLAction: REVOKE GRANT OPTION FOR privileges ON defacl_privilege_target FROM grantee_list opt_drop_behavior  */
#line 8157 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 40330 "gram.c"
    break;

  case 1094: /* defacl_privilege_target: TABLES  */
#line 8173 "gram.y"
                                                { (yyval.ival) = OBJECT_TABLE; }
#line 40336 "gram.c"
    break;

  case 1095: /* defacl_privilege_target: FUNCTIONS  */
#line 8174 "gram.y"
                                                { (yyval.ival) = OBJECT_FUNCTION; }
#line 40342 "gram.c"
    break;

  case 1096: /* defacl_privilege_target: ROUTINES  */
#line 8175 "gram.y"
                                                { (yyval.ival) = OBJECT_FUNCTION; }
#line 40348 "gram.c"
    break;

  case 1097: /* defacl_privilege_target: SEQUENCES  */
#line 8176 "gram.y"
                                                { (yyval.ival) = OBJECT_SEQUENCE; }
#line 40354 "gram.c"
    break;

  case 1098: /* defacl_privilege_target: TYPES_P  */
#line 8177 "gram.y"
                                                { (yyval.ival) = OBJECT_TYPE; }
#line 40360 "gram.c"
    break;

  case 1099: /* defacl_privilege_target: SCHEMAS  */
#line 8178 "gram.y"
                                                { (yyval.ival) = OBJECT_SCHEMA; }
#line 40366 "gram.c"
    break;

  case 1100: /* defacl_privilege_target: LARGE_P OBJECTS_P  */
#line 8179 "gram.y"
                                                { (yyval.ival) = OBJECT_LARGEOBJECT; }
#line 40372 "gram.c"
    break;

  case 1101: /* IndexStmt: CREATE opt_unique INDEX opt_concurrently opt_single_name ON relation_expr access_method_clause '(' index_params ')' opt_include opt_unique_null_treatment opt_reloptions OptTableSpace where_clause  */
#line 8194 "gram.y"
                                {
					IndexStmt *n = makeNode(IndexStmt);

					n->unique = (yyvsp[-14].boolean);
					n->concurrent = (yyvsp[-12].boolean);
					n->idxname = (yyvsp[-11].str);
					n->relation = (yyvsp[-9].range);
					n->accessMethod = (yyvsp[-8].str);
					n->indexParams = (yyvsp[-6].list);
					n->indexIncludingParams = (yyvsp[-4].list);
					n->nulls_not_distinct = !(yyvsp[-3].boolean);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNumber = InvalidRelFileNumber;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilelocatorSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = false;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *) n;
				}
#line 40406 "gram.c"
    break;

  case 1102: /* IndexStmt: CREATE opt_unique INDEX opt_concurrently IF_P NOT EXISTS name ON relation_expr access_method_clause '(' index_params ')' opt_include opt_unique_null_treatment opt_reloptions OptTableSpace where_clause  */
#line 8226 "gram.y"
                                {
					IndexStmt *n = makeNode(IndexStmt);

					n->unique = (yyvsp[-17].boolean);
					n->concurrent = (yyvsp[-15].boolean);
					n->idxname = (yyvsp[-11].str);
					n->relation = (yyvsp[-9].range);
					n->accessMethod = (yyvsp[-8].str);
					n->indexParams = (yyvsp[-6].list);
					n->indexIncludingParams = (yyvsp[-4].list);
					n->nulls_not_distinct = !(yyvsp[-3].boolean);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNumber = InvalidRelFileNumber;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilelocatorSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = true;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *) n;
				}
#line 40440 "gram.c"
    break;

  case 1103: /* opt_unique: UNIQUE  */
#line 8258 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 40446 "gram.c"
    break;

  case 1104: /* opt_unique: %empty  */
#line 8259 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 40452 "gram.c"
    break;

  case 1105: /* access_method_clause: USING name  */
#line 8263 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 40458 "gram.c"
    break;

  case 1106: /* access_method_clause: %empty  */
#line 8264 "gram.y"
                                                                                                { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 40464 "gram.c"
    break;

  case 1107: /* index_params: index_elem  */
#line 8267 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 40470 "gram.c"
    break;

  case 1108: /* index_params: index_params ',' index_elem  */
#line 8268 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 40476 "gram.c"
    break;

  case 1109: /* index_elem_options: opt_collate opt_qualified_name opt_asc_desc opt_nulls_order  */
#line 8274 "gram.y"
                {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-3].list);
			(yyval.ielem)->opclass = (yyvsp[-2].list);
			(yyval.ielem)->opclassopts = NIL;
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 40492 "gram.c"
    break;

  case 1110: /* index_elem_options: opt_collate any_name reloptions opt_asc_desc opt_nulls_order  */
#line 8286 "gram.y"
                {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-4].list);
			(yyval.ielem)->opclass = (yyvsp[-3].list);
			(yyval.ielem)->opclassopts = (yyvsp[-2].list);
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 40508 "gram.c"
    break;

  case 1111: /* index_elem: ColId index_elem_options  */
#line 8305 "gram.y"
                                {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->name = (yyvsp[-1].str);
				}
#line 40517 "gram.c"
    break;

  case 1112: /* index_elem: func_expr_windowless index_elem_options  */
#line 8310 "gram.y"
                                {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-1].node);
				}
#line 40526 "gram.c"
    break;

  case 1113: /* index_elem: '(' a_expr ')' index_elem_options  */
#line 8315 "gram.y"
                                {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-2].node);
				}
#line 40535 "gram.c"
    break;

  case 1114: /* opt_include: INCLUDE '(' index_including_params ')'  */
#line 8321 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 40541 "gram.c"
    break;

  case 1115: /* opt_include: %empty  */
#line 8322 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 40547 "gram.c"
    break;

  case 1116: /* index_including_params: index_elem  */
#line 8325 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 40553 "gram.c"
    break;

  case 1117: /* index_including_params: index_including_params ',' index_elem  */
#line 8326 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 40559 "gram.c"
    break;

  case 1118: /* opt_collate: COLLATE any_name  */
#line 8329 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 40565 "gram.c"
    break;

  case 1119: /* opt_collate: %empty  */
#line 8330 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 40571 "gram.c"
    break;

  case 1120: /* opt_asc_desc: ASC  */
#line 8334 "gram.y"
                                                                        { (yyval.ival) = SORTBY_ASC; }
#line 40577 "gram.c"
    break;

  case 1121: /* opt_asc_desc: DESC  */
#line 8335 "gram.y"
                                                                                { (yyval.ival) = SORTBY_DESC; }
#line 40583 "gram.c"
    break;

  case 1122: /* opt_asc_desc: %empty  */
#line 8336 "gram.y"
                                                                                { (yyval.ival) = SORTBY_DEFAULT; }
#line 40589 "gram.c"
    break;

  case 1123: /* opt_nulls_order: NULLS_LA FIRST_P  */
#line 8339 "gram.y"
                                                        { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 40595 "gram.c"
    break;

  case 1124: /* opt_nulls_order: NULLS_LA LAST_P  */
#line 8340 "gram.y"
                                                                        { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 40601 "gram.c"
    break;

  case 1125: /* opt_nulls_order: %empty  */
#line 8341 "gram.y"
                                                                                { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 40607 "gram.c"
    break;

  case 1126: /* CreateFunctionStmt: CREATE opt_or_replace FUNCTION func_name func_args_with_defaults RETURNS func_return opt_createfunc_opt_list opt_routine_body  */
#line 8359 "gram.y"
                                {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-7].boolean);
					n->funcname = (yyvsp[-5].list);
					n->parameters = (yyvsp[-4].list);
					n->returnType = (yyvsp[-2].typnam);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 40624 "gram.c"
    break;

  case 1127: /* CreateFunctionStmt: CREATE opt_or_replace FUNCTION func_name func_args_with_defaults RETURNS TABLE '(' table_func_column_list ')' opt_createfunc_opt_list opt_routine_body  */
#line 8373 "gram.y"
                                {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-10].boolean);
					n->funcname = (yyvsp[-8].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-7].list), (yyvsp[-3].list), yyscanner);
					n->returnType = TableFuncTypeName((yyvsp[-3].list));
					n->returnType->location = (yylsp[-5]);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 40642 "gram.c"
    break;

  case 1128: /* CreateFunctionStmt: CREATE opt_or_replace FUNCTION func_name func_args_with_defaults opt_createfunc_opt_list opt_routine_body  */
#line 8388 "gram.y"
                                {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 40659 "gram.c"
    break;

  case 1129: /* CreateFunctionStmt: CREATE opt_or_replace PROCEDURE func_name func_args_with_defaults opt_createfunc_opt_list opt_routine_body  */
#line 8402 "gram.y"
                                {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = true;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 40676 "gram.c"
    break;

  case 1130: /* opt_or_replace: OR REPLACE  */
#line 8417 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 40682 "gram.c"
    break;

  case 1131: /* opt_or_replace: %empty  */
#line 8418 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 40688 "gram.c"
    break;

  case 1132: /* func_args: '(' func_args_list ')'  */
#line 8421 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 40694 "gram.c"
    break;

  case 1133: /* func_args: '(' ')'  */
#line 8422 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 40700 "gram.c"
    break;

  case 1134: /* func_args_list: func_arg  */
#line 8426 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 40706 "gram.c"
    break;

  case 1135: /* func_args_list: func_args_list ',' func_arg  */
#line 8427 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 40712 "gram.c"
    break;

  case 1136: /* function_with_argtypes_list: function_with_argtypes  */
#line 8431 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 40718 "gram.c"
    break;

  case 1137: /* function_with_argtypes_list: function_with_argtypes_list ',' function_with_argtypes  */
#line 8433 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 40724 "gram.c"
    break;

  case 1138: /* function_with_argtypes: func_name func_args  */
#line 8438 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = extractArgTypes((yyvsp[0].list));
					n->objfuncargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 40737 "gram.c"
    break;

  case 1139: /* function_with_argtypes: type_func_name_keyword  */
#line 8452 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = list_make1(makeString(pstrdup((yyvsp[0].keyword))));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 40749 "gram.c"
    break;

  case 1140: /* function_with_argtypes: ColId  */
#line 8460 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = list_make1(makeString((yyvsp[0].str)));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 40761 "gram.c"
    break;

  case 1141: /* function_with_argtypes: ColId indirection  */
#line 8468 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
												  yyscanner);
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 40774 "gram.c"
    break;

  case 1142: /* func_args_with_defaults: '(' func_args_with_defaults_list ')'  */
#line 8483 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 40780 "gram.c"
    break;

  case 1143: /* func_args_with_defaults: '(' ')'  */
#line 8484 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 40786 "gram.c"
    break;

  case 1144: /* func_args_with_defaults_list: func_arg_with_default  */
#line 8488 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 40792 "gram.c"
    break;

  case 1145: /* func_args_with_defaults_list: func_args_with_defaults_list ',' func_arg_with_default  */
#line 8490 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 40798 "gram.c"
    break;

  case 1146: /* func_arg: arg_class param_name func_type  */
#line 8505 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					n->location = (yylsp[-2]);
					(yyval.fun_param) = n;
				}
#line 40813 "gram.c"
    break;

  case 1147: /* func_arg: param_name arg_class func_type  */
#line 8516 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					n->location = (yylsp[-2]);
					(yyval.fun_param) = n;
				}
#line 40828 "gram.c"
    break;

  case 1148: /* func_arg: param_name func_type  */
#line 8527 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					n->location = (yylsp[-1]);
					(yyval.fun_param) = n;
				}
#line 40843 "gram.c"
    break;

  case 1149: /* func_arg: arg_class func_type  */
#line 8538 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					n->location = (yylsp[-1]);
					(yyval.fun_param) = n;
				}
#line 40858 "gram.c"
    break;

  case 1150: /* func_arg: func_type  */
#line 8549 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					n->location = (yylsp[0]);
					(yyval.fun_param) = n;
				}
#line 40873 "gram.c"
    break;

  case 1151: /* arg_class: IN_P  */
#line 8562 "gram.y"
                                                                                { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 40879 "gram.c"
    break;

  case 1152: /* arg_class: OUT_P  */
#line 8563 "gram.y"
                                                                                        { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 40885 "gram.c"
    break;

  case 1153: /* arg_class: INOUT  */
#line 8564 "gram.y"
                                                                                        { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 40891 "gram.c"
    break;

  case 1154: /* arg_class: IN_P OUT_P  */
#line 8565 "gram.y"
                                                                                { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 40897 "gram.c"
    break;

  case 1155: /* arg_class: VARIADIC  */
#line 8566 "gram.y"
                                                                                        { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 40903 "gram.c"
    break;

  case 1157: /* func_return: func_type  */
#line 8577 "gram.y"
                                {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 40915 "gram.c"
    break;

  case 1158: /* func_type: Typename  */
#line 8591 "gram.y"
                                                                                        { (yyval.typnam) = (yyvsp[0].typnam); }
#line 40921 "gram.c"
    break;

  case 1159: /* func_type: type_function_name attrs '%' TYPE_P  */
#line 8593 "gram.y"
                                {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 40931 "gram.c"
    break;

  case 1160: /* func_type: SETOF type_function_name attrs '%' TYPE_P  */
#line 8599 "gram.y"
                                {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 40942 "gram.c"
    break;

  case 1161: /* func_arg_with_default: func_arg  */
#line 8609 "gram.y"
                                {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 40950 "gram.c"
    break;

  case 1162: /* func_arg_with_default: func_arg DEFAULT a_expr  */
#line 8613 "gram.y"
                                {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 40959 "gram.c"
    break;

  case 1163: /* func_arg_with_default: func_arg '=' a_expr  */
#line 8618 "gram.y"
                                {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 40968 "gram.c"
    break;

  case 1164: /* aggr_arg: func_arg  */
#line 8626 "gram.y"
                                {
					if (!((yyvsp[0].fun_param)->mode == FUNC_PARAM_DEFAULT ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[0]))));
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 40983 "gram.c"
    break;

  case 1165: /* aggr_args: '(' '*' ')'  */
#line 8668 "gram.y"
                                {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
#line 40991 "gram.c"
    break;

  case 1166: /* aggr_args: '(' aggr_args_list ')'  */
#line 8672 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(-1));
				}
#line 40999 "gram.c"
    break;

  case 1167: /* aggr_args: '(' ORDER BY aggr_args_list ')'  */
#line 8676 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(0));
				}
#line 41007 "gram.c"
    break;

  case 1168: /* aggr_args: '(' aggr_args_list ORDER BY aggr_args_list ')'  */
#line 8680 "gram.y"
                                {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[-4].list), (yyvsp[-1].list), yyscanner);
				}
#line 41016 "gram.c"
    break;

  case 1169: /* aggr_args_list: aggr_arg  */
#line 8687 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 41022 "gram.c"
    break;

  case 1170: /* aggr_args_list: aggr_args_list ',' aggr_arg  */
#line 8688 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 41028 "gram.c"
    break;

  case 1171: /* aggregate_with_argtypes: func_name aggr_args  */
#line 8693 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = extractAggrArgTypes((yyvsp[0].list));
					n->objfuncargs = (List *) linitial((yyvsp[0].list));
					(yyval.objwithargs) = n;
				}
#line 41041 "gram.c"
    break;

  case 1172: /* aggregate_with_argtypes_list: aggregate_with_argtypes  */
#line 8704 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 41047 "gram.c"
    break;

  case 1173: /* aggregate_with_argtypes_list: aggregate_with_argtypes_list ',' aggregate_with_argtypes  */
#line 8706 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 41053 "gram.c"
    break;

  case 1175: /* opt_createfunc_opt_list: %empty  */
#line 8711 "gram.y"
                                    { (yyval.list) = NIL; }
#line 41059 "gram.c"
    break;

  case 1176: /* createfunc_opt_list: createfunc_opt_item  */
#line 8716 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 41065 "gram.c"
    break;

  case 1177: /* createfunc_opt_list: createfunc_opt_list createfunc_opt_item  */
#line 8717 "gram.y"
                                                                  { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 41071 "gram.c"
    break;

  case 1178: /* common_func_opt_item: CALLED ON NULL_P INPUT_P  */
#line 8725 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(false), (yylsp[-3]));
				}
#line 41079 "gram.c"
    break;

  case 1179: /* common_func_opt_item: RETURNS NULL_P ON NULL_P INPUT_P  */
#line 8729 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(true), (yylsp[-4]));
				}
#line 41087 "gram.c"
    break;

  case 1180: /* common_func_opt_item: STRICT_P  */
#line 8733 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 41095 "gram.c"
    break;

  case 1181: /* common_func_opt_item: IMMUTABLE  */
#line 8737 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("immutable"), (yylsp[0]));
				}
#line 41103 "gram.c"
    break;

  case 1182: /* common_func_opt_item: STABLE  */
#line 8741 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("stable"), (yylsp[0]));
				}
#line 41111 "gram.c"
    break;

  case 1183: /* common_func_opt_item: VOLATILE  */
#line 8745 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("volatile"), (yylsp[0]));
				}
#line 41119 "gram.c"
    break;

  case 1184: /* common_func_opt_item: EXTERNAL SECURITY DEFINER  */
#line 8749 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(true), (yylsp[-2]));
				}
#line 41127 "gram.c"
    break;

  case 1185: /* common_func_opt_item: EXTERNAL SECURITY INVOKER  */
#line 8753 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(false), (yylsp[-2]));
				}
#line 41135 "gram.c"
    break;

  case 1186: /* common_func_opt_item: SECURITY DEFINER  */
#line 8757 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(true), (yylsp[-1]));
				}
#line 41143 "gram.c"
    break;

  case 1187: /* common_func_opt_item: SECURITY INVOKER  */
#line 8761 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 41151 "gram.c"
    break;

  case 1188: /* common_func_opt_item: LEAKPROOF  */
#line 8765 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("leakproof", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 41159 "gram.c"
    break;

  case 1189: /* common_func_opt_item: NOT LEAKPROOF  */
#line 8769 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("leakproof", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 41167 "gram.c"
    break;

  case 1190: /* common_func_opt_item: COST NumericOnly  */
#line 8773 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cost", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 41175 "gram.c"
    break;

  case 1191: /* common_func_opt_item: ROWS NumericOnly  */
#line 8777 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("rows", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 41183 "gram.c"
    break;

  case 1192: /* common_func_opt_item: SUPPORT any_name  */
#line 8781 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("support", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 41191 "gram.c"
    break;

  case 1193: /* common_func_opt_item: FunctionSetResetClause  */
#line 8785 "gram.y"
                                {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *) (yyvsp[0].vsetstmt), (yylsp[0]));
				}
#line 41200 "gram.c"
    break;

  case 1194: /* common_func_opt_item: PARALLEL ColId  */
#line 8790 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("parallel", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 41208 "gram.c"
    break;

  case 1195: /* createfunc_opt_item: AS func_as  */
#line 8797 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("as", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 41216 "gram.c"
    break;

  case 1196: /* createfunc_opt_item: LANGUAGE NonReservedWord_or_Sconst  */
#line 8801 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("language", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 41224 "gram.c"
    break;

  case 1197: /* createfunc_opt_item: TRANSFORM transform_type_list  */
#line 8805 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("transform", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 41232 "gram.c"
    break;

  case 1198: /* createfunc_opt_item: WINDOW  */
#line 8809 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("window", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 41240 "gram.c"
    break;

  case 1199: /* createfunc_opt_item: common_func_opt_item  */
#line 8813 "gram.y"
                                {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 41248 "gram.c"
    break;

  case 1200: /* func_as: Sconst  */
#line 8818 "gram.y"
                                                                { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 41254 "gram.c"
    break;

  case 1201: /* func_as: Sconst ',' Sconst  */
#line 8820 "gram.y"
                                {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 41262 "gram.c"
    break;

  case 1202: /* ReturnStmt: RETURN a_expr  */
#line 8826 "gram.y"
                                {
					ReturnStmt *r = makeNode(ReturnStmt);

					r->returnval = (Node *) (yyvsp[0].node);
					(yyval.node) = (Node *) r;
				}
#line 41273 "gram.c"
    break;

  case 1203: /* opt_routine_body: ReturnStmt  */
#line 8836 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 41281 "gram.c"
    break;

  case 1204: /* opt_routine_body: BEGIN_P ATOMIC routine_body_stmt_list END_P  */
#line 8840 "gram.y"
                                {
					/*
					 * A compound statement is stored as a single-item list
					 * containing the list of statements as its member.  That
					 * way, the parse analysis code can tell apart an empty
					 * body from no body at all.
					 */
					(yyval.node) = (Node *) list_make1((yyvsp[-1].list));
				}
#line 41295 "gram.c"
    break;

  case 1205: /* opt_routine_body: %empty  */
#line 8850 "gram.y"
                                {
					(yyval.node) = NULL;
				}
#line 41303 "gram.c"
    break;

  case 1206: /* routine_body_stmt_list: routine_body_stmt_list routine_body_stmt ';'  */
#line 8857 "gram.y"
                                {
					/* As in stmtmulti, discard empty statements */
					if ((yyvsp[-1].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[-1].node));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 41315 "gram.c"
    break;

  case 1207: /* routine_body_stmt_list: %empty  */
#line 8865 "gram.y"
                                {
					(yyval.list) = NIL;
				}
#line 41323 "gram.c"
    break;

  case 1210: /* transform_type_list: FOR TYPE_P Typename  */
#line 8876 "gram.y"
                                            { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 41329 "gram.c"
    break;

  case 1211: /* transform_type_list: transform_type_list ',' FOR TYPE_P Typename  */
#line 8877 "gram.y"
                                                                      { (yyval.list) = lappend((yyvsp[-4].list), (yyvsp[0].typnam)); }
#line 41335 "gram.c"
    break;

  case 1212: /* opt_definition: WITH definition  */
#line 8881 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 41341 "gram.c"
    break;

  case 1213: /* opt_definition: %empty  */
#line 8882 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 41347 "gram.c"
    break;

  case 1214: /* table_func_column: param_name func_type  */
#line 8886 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					n->location = (yylsp[-1]);
					(yyval.fun_param) = n;
				}
#line 41362 "gram.c"
    break;

  case 1215: /* table_func_column_list: table_func_column  */
#line 8900 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 41370 "gram.c"
    break;

  case 1216: /* table_func_column_list: table_func_column_list ',' table_func_column  */
#line 8904 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 41378 "gram.c"
    break;

  case 1217: /* AlterFunctionStmt: ALTER FUNCTION function_with_argtypes alterfunc_opt_list opt_restrict  */
#line 8919 "gram.y"
                                {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_FUNCTION;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 41391 "gram.c"
    break;

  case 1218: /* AlterFunctionStmt: ALTER PROCEDURE function_with_argtypes alterfunc_opt_list opt_restrict  */
#line 8928 "gram.y"
                                {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_PROCEDURE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 41404 "gram.c"
    break;

  case 1219: /* AlterFunctionStmt: ALTER ROUTINE function_with_argtypes alterfunc_opt_list opt_restrict  */
#line 8937 "gram.y"
                                {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_ROUTINE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 41417 "gram.c"
    break;

  case 1220: /* alterfunc_opt_list: common_func_opt_item  */
#line 8949 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 41423 "gram.c"
    break;

  case 1221: /* alterfunc_opt_list: alterfunc_opt_list common_func_opt_item  */
#line 8950 "gram.y"
                                                                  { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 41429 "gram.c"
    break;

  case 1224: /* RemoveFuncStmt: DROP FUNCTION function_with_argtypes_list opt_drop_behavior  */
#line 8974 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41444 "gram.c"
    break;

  case 1225: /* RemoveFuncStmt: DROP FUNCTION IF_P EXISTS function_with_argtypes_list opt_drop_behavior  */
#line 8985 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41459 "gram.c"
    break;

  case 1226: /* RemoveFuncStmt: DROP PROCEDURE function_with_argtypes_list opt_drop_behavior  */
#line 8996 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41474 "gram.c"
    break;

  case 1227: /* RemoveFuncStmt: DROP PROCEDURE IF_P EXISTS function_with_argtypes_list opt_drop_behavior  */
#line 9007 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41489 "gram.c"
    break;

  case 1228: /* RemoveFuncStmt: DROP ROUTINE function_with_argtypes_list opt_drop_behavior  */
#line 9018 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41504 "gram.c"
    break;

  case 1229: /* RemoveFuncStmt: DROP ROUTINE IF_P EXISTS function_with_argtypes_list opt_drop_behavior  */
#line 9029 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41519 "gram.c"
    break;

  case 1230: /* RemoveAggrStmt: DROP AGGREGATE aggregate_with_argtypes_list opt_drop_behavior  */
#line 9043 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41534 "gram.c"
    break;

  case 1231: /* RemoveAggrStmt: DROP AGGREGATE IF_P EXISTS aggregate_with_argtypes_list opt_drop_behavior  */
#line 9054 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41549 "gram.c"
    break;

  case 1232: /* RemoveOperStmt: DROP OPERATOR operator_with_argtypes_list opt_drop_behavior  */
#line 9068 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41564 "gram.c"
    break;

  case 1233: /* RemoveOperStmt: DROP OPERATOR IF_P EXISTS operator_with_argtypes_list opt_drop_behavior  */
#line 9079 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41579 "gram.c"
    break;

  case 1234: /* oper_argtypes: '(' Typename ')'  */
#line 9093 "gram.y"
                                {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 41591 "gram.c"
    break;

  case 1235: /* oper_argtypes: '(' Typename ',' Typename ')'  */
#line 9101 "gram.y"
                                        { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 41597 "gram.c"
    break;

  case 1236: /* oper_argtypes: '(' NONE ',' Typename ')'  */
#line 9103 "gram.y"
                                        { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 41603 "gram.c"
    break;

  case 1237: /* oper_argtypes: '(' Typename ',' NONE ')'  */
#line 9105 "gram.y"
                                        { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 41609 "gram.c"
    break;

  case 1238: /* any_operator: all_Op  */
#line 9110 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 41615 "gram.c"
    break;

  case 1239: /* any_operator: ColId '.' any_operator  */
#line 9112 "gram.y"
                                        { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 41621 "gram.c"
    break;

  case 1240: /* operator_with_argtypes_list: operator_with_argtypes  */
#line 9116 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 41627 "gram.c"
    break;

  case 1241: /* operator_with_argtypes_list: operator_with_argtypes_list ',' operator_with_argtypes  */
#line 9118 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 41633 "gram.c"
    break;

  case 1242: /* operator_with_argtypes: any_operator oper_argtypes  */
#line 9123 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 41645 "gram.c"
    break;

  case 1243: /* DoStmt: DO dostmt_opt_list  */
#line 9142 "gram.y"
                                {
					DoStmt *n = makeNode(DoStmt);

					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41656 "gram.c"
    break;

  case 1244: /* dostmt_opt_list: dostmt_opt_item  */
#line 9151 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 41662 "gram.c"
    break;

  case 1245: /* dostmt_opt_list: dostmt_opt_list dostmt_opt_item  */
#line 9152 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 41668 "gram.c"
    break;

  case 1246: /* dostmt_opt_item: Sconst  */
#line 9157 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("as", (Node *) makeString((yyvsp[0].str)), (yylsp[0]));
				}
#line 41676 "gram.c"
    break;

  case 1247: /* dostmt_opt_item: LANGUAGE NonReservedWord_or_Sconst  */
#line 9161 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("language", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 41684 "gram.c"
    break;

  case 1248: /* CreateCastStmt: CREATE CAST '(' Typename AS Typename ')' WITH FUNCTION function_with_argtypes cast_context  */
#line 9174 "gram.y"
                                {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].objwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *) n;
				}
#line 41699 "gram.c"
    break;

  case 1249: /* CreateCastStmt: CREATE CAST '(' Typename AS Typename ')' WITHOUT FUNCTION cast_context  */
#line 9186 "gram.y"
                                {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *) n;
				}
#line 41714 "gram.c"
    break;

  case 1250: /* CreateCastStmt: CREATE CAST '(' Typename AS Typename ')' WITH INOUT cast_context  */
#line 9198 "gram.y"
                                {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *) n;
				}
#line 41729 "gram.c"
    break;

  case 1251: /* cast_context: AS IMPLICIT_P  */
#line 9210 "gram.y"
                                                                { (yyval.ival) = COERCION_IMPLICIT; }
#line 41735 "gram.c"
    break;

  case 1252: /* cast_context: AS ASSIGNMENT  */
#line 9211 "gram.y"
                                                                                { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 41741 "gram.c"
    break;

  case 1253: /* cast_context: %empty  */
#line 9212 "gram.y"
                                                                                        { (yyval.ival) = COERCION_EXPLICIT; }
#line 41747 "gram.c"
    break;

  case 1254: /* DropCastStmt: DROP CAST opt_if_exists '(' Typename AS Typename ')' opt_drop_behavior  */
#line 9217 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make2((yyvsp[-4].typnam), (yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41762 "gram.c"
    break;

  case 1255: /* opt_if_exists: IF_P EXISTS  */
#line 9229 "gram.y"
                                                                        { (yyval.boolean) = true; }
#line 41768 "gram.c"
    break;

  case 1256: /* opt_if_exists: %empty  */
#line 9230 "gram.y"
                                                                                        { (yyval.boolean) = false; }
#line 41774 "gram.c"
    break;

  case 1257: /* CreateTransformStmt: CREATE opt_or_replace TRANSFORM FOR Typename LANGUAGE name '(' transform_element_list ')'  */
#line 9241 "gram.y"
                                {
					CreateTransformStmt *n = makeNode(CreateTransformStmt);

					n->replace = (yyvsp[-8].boolean);
					n->type_name = (yyvsp[-5].typnam);
					n->lang = (yyvsp[-3].str);
					n->fromsql = linitial((yyvsp[-1].list));
					n->tosql = lsecond((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 41789 "gram.c"
    break;

  case 1258: /* transform_element_list: FROM SQL_P WITH FUNCTION function_with_argtypes ',' TO SQL_P WITH FUNCTION function_with_argtypes  */
#line 9254 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[-6].objwithargs), (yyvsp[0].objwithargs));
				}
#line 41797 "gram.c"
    break;

  case 1259: /* transform_element_list: TO SQL_P WITH FUNCTION function_with_argtypes ',' FROM SQL_P WITH FUNCTION function_with_argtypes  */
#line 9258 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), (yyvsp[-6].objwithargs));
				}
#line 41805 "gram.c"
    break;

  case 1260: /* transform_element_list: FROM SQL_P WITH FUNCTION function_with_argtypes  */
#line 9262 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), NULL);
				}
#line 41813 "gram.c"
    break;

  case 1261: /* transform_element_list: TO SQL_P WITH FUNCTION function_with_argtypes  */
#line 9266 "gram.y"
                                {
					(yyval.list) = list_make2(NULL, (yyvsp[0].objwithargs));
				}
#line 41821 "gram.c"
    break;

  case 1262: /* DropTransformStmt: DROP TRANSFORM opt_if_exists FOR Typename LANGUAGE name opt_drop_behavior  */
#line 9273 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TRANSFORM;
					n->objects = list_make1(list_make2((yyvsp[-3].typnam), makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-5].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41835 "gram.c"
    break;

  case 1263: /* ReindexStmt: REINDEX opt_reindex_option_list reindex_target_relation opt_concurrently qualified_name  */
#line 9295 "gram.y"
                                {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->params = (yyvsp[-3].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 41852 "gram.c"
    break;

  case 1264: /* ReindexStmt: REINDEX opt_reindex_option_list SCHEMA opt_concurrently name  */
#line 9308 "gram.y"
                                {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = REINDEX_OBJECT_SCHEMA;
					n->relation = NULL;
					n->name = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 41869 "gram.c"
    break;

  case 1265: /* ReindexStmt: REINDEX opt_reindex_option_list reindex_target_all opt_concurrently opt_single_name  */
#line 9321 "gram.y"
                                {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->relation = NULL;
					n->name = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 41886 "gram.c"
    break;

  case 1266: /* reindex_target_relation: INDEX  */
#line 9335 "gram.y"
                                                                { (yyval.ival) = REINDEX_OBJECT_INDEX; }
#line 41892 "gram.c"
    break;

  case 1267: /* reindex_target_relation: TABLE  */
#line 9336 "gram.y"
                                                                { (yyval.ival) = REINDEX_OBJECT_TABLE; }
#line 41898 "gram.c"
    break;

  case 1268: /* reindex_target_all: SYSTEM_P  */
#line 9339 "gram.y"
                                                                { (yyval.ival) = REINDEX_OBJECT_SYSTEM; }
#line 41904 "gram.c"
    break;

  case 1269: /* reindex_target_all: DATABASE  */
#line 9340 "gram.y"
                                                                { (yyval.ival) = REINDEX_OBJECT_DATABASE; }
#line 41910 "gram.c"
    break;

  case 1270: /* opt_reindex_option_list: '(' utility_option_list ')'  */
#line 9343 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 41916 "gram.c"
    break;

  case 1271: /* opt_reindex_option_list: %empty  */
#line 9344 "gram.y"
                                                                                        { (yyval.list) = NULL; }
#line 41922 "gram.c"
    break;

  case 1272: /* AlterTblSpcStmt: ALTER TABLESPACE name SET reloptions  */
#line 9355 "gram.y"
                                {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);

					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = false;
					(yyval.node) = (Node *) n;
				}
#line 41936 "gram.c"
    break;

  case 1273: /* AlterTblSpcStmt: ALTER TABLESPACE name RESET reloptions  */
#line 9365 "gram.y"
                                {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);

					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = true;
					(yyval.node) = (Node *) n;
				}
#line 41950 "gram.c"
    break;

  case 1274: /* RenameStmt: ALTER AGGREGATE aggregate_with_argtypes RENAME TO name  */
#line 9383 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41964 "gram.c"
    break;

  case 1275: /* RenameStmt: ALTER COLLATION any_name RENAME TO name  */
#line 9393 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41978 "gram.c"
    break;

  case 1276: /* RenameStmt: ALTER CONVERSION_P any_name RENAME TO name  */
#line 9403 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41992 "gram.c"
    break;

  case 1277: /* RenameStmt: ALTER DATABASE name RENAME TO name  */
#line 9413 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42006 "gram.c"
    break;

  case 1278: /* RenameStmt: ALTER DOMAIN_P any_name RENAME TO name  */
#line 9423 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42020 "gram.c"
    break;

  case 1279: /* RenameStmt: ALTER DOMAIN_P any_name RENAME CONSTRAINT name TO name  */
#line 9433 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DOMCONSTRAINT;
					n->object = (Node *) (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42034 "gram.c"
    break;

  case 1280: /* RenameStmt: ALTER FOREIGN DATA_P WRAPPER name RENAME TO name  */
#line 9443 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42048 "gram.c"
    break;

  case 1281: /* RenameStmt: ALTER FUNCTION function_with_argtypes RENAME TO name  */
#line 9453 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42062 "gram.c"
    break;

  case 1282: /* RenameStmt: ALTER GROUP_P RoleId RENAME TO RoleId  */
#line 9463 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42076 "gram.c"
    break;

  case 1283: /* RenameStmt: ALTER opt_procedural LANGUAGE name RENAME TO name  */
#line 9473 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42090 "gram.c"
    break;

  case 1284: /* RenameStmt: ALTER OPERATOR CLASS any_name USING name RENAME TO name  */
#line 9483 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42104 "gram.c"
    break;

  case 1285: /* RenameStmt: ALTER OPERATOR FAMILY any_name USING name RENAME TO name  */
#line 9493 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42118 "gram.c"
    break;

  case 1286: /* RenameStmt: ALTER POLICY name ON qualified_name RENAME TO name  */
#line 9503 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42133 "gram.c"
    break;

  case 1287: /* RenameStmt: ALTER POLICY IF_P EXISTS name ON qualified_name RENAME TO name  */
#line 9514 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42148 "gram.c"
    break;

  case 1288: /* RenameStmt: ALTER PROCEDURE function_with_argtypes RENAME TO name  */
#line 9525 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42162 "gram.c"
    break;

  case 1289: /* RenameStmt: ALTER PUBLICATION name RENAME TO name  */
#line 9535 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42176 "gram.c"
    break;

  case 1290: /* RenameStmt: ALTER ROUTINE function_with_argtypes RENAME TO name  */
#line 9545 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42190 "gram.c"
    break;

  case 1291: /* RenameStmt: ALTER SCHEMA name RENAME TO name  */
#line 9555 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42204 "gram.c"
    break;

  case 1292: /* RenameStmt: ALTER SERVER name RENAME TO name  */
#line 9565 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42218 "gram.c"
    break;

  case 1293: /* RenameStmt: ALTER SUBSCRIPTION name RENAME TO name  */
#line 9575 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42232 "gram.c"
    break;

  case 1294: /* RenameStmt: ALTER TABLE relation_expr RENAME TO name  */
#line 9585 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42247 "gram.c"
    break;

  case 1295: /* RenameStmt: ALTER TABLE IF_P EXISTS relation_expr RENAME TO name  */
#line 9596 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42262 "gram.c"
    break;

  case 1296: /* RenameStmt: ALTER SEQUENCE qualified_name RENAME TO name  */
#line 9607 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42277 "gram.c"
    break;

  case 1297: /* RenameStmt: ALTER SEQUENCE IF_P EXISTS qualified_name RENAME TO name  */
#line 9618 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42292 "gram.c"
    break;

  case 1298: /* RenameStmt: ALTER VIEW qualified_name RENAME TO name  */
#line 9629 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42307 "gram.c"
    break;

  case 1299: /* RenameStmt: ALTER VIEW IF_P EXISTS qualified_name RENAME TO name  */
#line 9640 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42322 "gram.c"
    break;

  case 1300: /* RenameStmt: ALTER MATERIALIZED VIEW qualified_name RENAME TO name  */
#line 9651 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42337 "gram.c"
    break;

  case 1301: /* RenameStmt: ALTER MATERIALIZED VIEW IF_P EXISTS qualified_name RENAME TO name  */
#line 9662 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42352 "gram.c"
    break;

  case 1302: /* RenameStmt: ALTER INDEX qualified_name RENAME TO name  */
#line 9673 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42367 "gram.c"
    break;

  case 1303: /* RenameStmt: ALTER INDEX IF_P EXISTS qualified_name RENAME TO name  */
#line 9684 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42382 "gram.c"
    break;

  case 1304: /* RenameStmt: ALTER FOREIGN TABLE relation_expr RENAME TO name  */
#line 9695 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42397 "gram.c"
    break;

  case 1305: /* RenameStmt: ALTER FOREIGN TABLE IF_P EXISTS relation_expr RENAME TO name  */
#line 9706 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42412 "gram.c"
    break;

  case 1306: /* RenameStmt: ALTER TABLE relation_expr RENAME opt_column name TO name  */
#line 9717 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42428 "gram.c"
    break;

  case 1307: /* RenameStmt: ALTER TABLE IF_P EXISTS relation_expr RENAME opt_column name TO name  */
#line 9729 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42444 "gram.c"
    break;

  case 1308: /* RenameStmt: ALTER VIEW qualified_name RENAME opt_column name TO name  */
#line 9741 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42460 "gram.c"
    break;

  case 1309: /* RenameStmt: ALTER VIEW IF_P EXISTS qualified_name RENAME opt_column name TO name  */
#line 9753 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42476 "gram.c"
    break;

  case 1310: /* RenameStmt: ALTER MATERIALIZED VIEW qualified_name RENAME opt_column name TO name  */
#line 9765 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42492 "gram.c"
    break;

  case 1311: /* RenameStmt: ALTER MATERIALIZED VIEW IF_P EXISTS qualified_name RENAME opt_column name TO name  */
#line 9777 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42508 "gram.c"
    break;

  case 1312: /* RenameStmt: ALTER TABLE relation_expr RENAME CONSTRAINT name TO name  */
#line 9789 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42523 "gram.c"
    break;

  case 1313: /* RenameStmt: ALTER TABLE IF_P EXISTS relation_expr RENAME CONSTRAINT name TO name  */
#line 9800 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42538 "gram.c"
    break;

  case 1314: /* RenameStmt: ALTER FOREIGN TABLE relation_expr RENAME opt_column name TO name  */
#line 9811 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42554 "gram.c"
    break;

  case 1315: /* RenameStmt: ALTER FOREIGN TABLE IF_P EXISTS relation_expr RENAME opt_column name TO name  */
#line 9823 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42570 "gram.c"
    break;

  case 1316: /* RenameStmt: ALTER RULE name ON qualified_name RENAME TO name  */
#line 9835 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42585 "gram.c"
    break;

  case 1317: /* RenameStmt: ALTER TRIGGER name ON qualified_name RENAME TO name  */
#line 9846 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42600 "gram.c"
    break;

  case 1318: /* RenameStmt: ALTER EVENT TRIGGER name RENAME TO name  */
#line 9857 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42613 "gram.c"
    break;

  case 1319: /* RenameStmt: ALTER ROLE RoleId RENAME TO RoleId  */
#line 9866 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42627 "gram.c"
    break;

  case 1320: /* RenameStmt: ALTER USER RoleId RENAME TO RoleId  */
#line 9876 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42641 "gram.c"
    break;

  case 1321: /* RenameStmt: ALTER TABLESPACE name RENAME TO name  */
#line 9886 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42655 "gram.c"
    break;

  case 1322: /* RenameStmt: ALTER STATISTICS any_name RENAME TO name  */
#line 9896 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42669 "gram.c"
    break;

  case 1323: /* RenameStmt: ALTER TEXT_P SEARCH PARSER any_name RENAME TO name  */
#line 9906 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42683 "gram.c"
    break;

  case 1324: /* RenameStmt: ALTER TEXT_P SEARCH DICTIONARY any_name RENAME TO name  */
#line 9916 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42697 "gram.c"
    break;

  case 1325: /* RenameStmt: ALTER TEXT_P SEARCH TEMPLATE any_name RENAME TO name  */
#line 9926 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42711 "gram.c"
    break;

  case 1326: /* RenameStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name RENAME TO name  */
#line 9936 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42725 "gram.c"
    break;

  case 1327: /* RenameStmt: ALTER TYPE_P any_name RENAME TO name  */
#line 9946 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42739 "gram.c"
    break;

  case 1328: /* RenameStmt: ALTER TYPE_P any_name RENAME ATTRIBUTE name TO name opt_drop_behavior  */
#line 9956 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42756 "gram.c"
    break;

  case 1331: /* opt_set_data: SET DATA_P  */
#line 9974 "gram.y"
                                                                                { (yyval.ival) = 1; }
#line 42762 "gram.c"
    break;

  case 1332: /* opt_set_data: %empty  */
#line 9975 "gram.y"
                                                                                                { (yyval.ival) = 0; }
#line 42768 "gram.c"
    break;

  case 1333: /* AlterObjectDependsStmt: ALTER FUNCTION function_with_argtypes opt_no DEPENDS ON EXTENSION name  */
#line 9986 "gram.y"
                                {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42782 "gram.c"
    break;

  case 1334: /* AlterObjectDependsStmt: ALTER PROCEDURE function_with_argtypes opt_no DEPENDS ON EXTENSION name  */
#line 9996 "gram.y"
                                {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42796 "gram.c"
    break;

  case 1335: /* AlterObjectDependsStmt: ALTER ROUTINE function_with_argtypes opt_no DEPENDS ON EXTENSION name  */
#line 10006 "gram.y"
                                {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42810 "gram.c"
    break;

  case 1336: /* AlterObjectDependsStmt: ALTER TRIGGER name ON qualified_name opt_no DEPENDS ON EXTENSION name  */
#line 10016 "gram.y"
                                {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-5].range);
					n->object = (Node *) list_make1(makeString((yyvsp[-7].str)));
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42825 "gram.c"
    break;

  case 1337: /* AlterObjectDependsStmt: ALTER MATERIALIZED VIEW qualified_name opt_no DEPENDS ON EXTENSION name  */
#line 10027 "gram.y"
                                {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42839 "gram.c"
    break;

  case 1338: /* AlterObjectDependsStmt: ALTER INDEX qualified_name opt_no DEPENDS ON EXTENSION name  */
#line 10037 "gram.y"
                                {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_INDEX;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42853 "gram.c"
    break;

  case 1339: /* opt_no: NO  */
#line 10048 "gram.y"
                                                { (yyval.boolean) = true; }
#line 42859 "gram.c"
    break;

  case 1340: /* opt_no: %empty  */
#line 10049 "gram.y"
                                        { (yyval.boolean) = false;	}
#line 42865 "gram.c"
    break;

  case 1341: /* AlterObjectSchemaStmt: ALTER AGGREGATE aggregate_with_argtypes SET SCHEMA name  */
#line 10060 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42879 "gram.c"
    break;

  case 1342: /* AlterObjectSchemaStmt: ALTER COLLATION any_name SET SCHEMA name  */
#line 10070 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42893 "gram.c"
    break;

  case 1343: /* AlterObjectSchemaStmt: ALTER CONVERSION_P any_name SET SCHEMA name  */
#line 10080 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42907 "gram.c"
    break;

  case 1344: /* AlterObjectSchemaStmt: ALTER DOMAIN_P any_name SET SCHEMA name  */
#line 10090 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42921 "gram.c"
    break;

  case 1345: /* AlterObjectSchemaStmt: ALTER EXTENSION name SET SCHEMA name  */
#line 10100 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_EXTENSION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42935 "gram.c"
    break;

  case 1346: /* AlterObjectSchemaStmt: ALTER FUNCTION function_with_argtypes SET SCHEMA name  */
#line 10110 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42949 "gram.c"
    break;

  case 1347: /* AlterObjectSchemaStmt: ALTER OPERATOR operator_with_argtypes SET SCHEMA name  */
#line 10120 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42963 "gram.c"
    break;

  case 1348: /* AlterObjectSchemaStmt: ALTER OPERATOR CLASS any_name USING name SET SCHEMA name  */
#line 10130 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42977 "gram.c"
    break;

  case 1349: /* AlterObjectSchemaStmt: ALTER OPERATOR FAMILY any_name USING name SET SCHEMA name  */
#line 10140 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42991 "gram.c"
    break;

  case 1350: /* AlterObjectSchemaStmt: ALTER PROCEDURE function_with_argtypes SET SCHEMA name  */
#line 10150 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43005 "gram.c"
    break;

  case 1351: /* AlterObjectSchemaStmt: ALTER ROUTINE function_with_argtypes SET SCHEMA name  */
#line 10160 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43019 "gram.c"
    break;

  case 1352: /* AlterObjectSchemaStmt: ALTER TABLE relation_expr SET SCHEMA name  */
#line 10170 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43033 "gram.c"
    break;

  case 1353: /* AlterObjectSchemaStmt: ALTER TABLE IF_P EXISTS relation_expr SET SCHEMA name  */
#line 10180 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 43047 "gram.c"
    break;

  case 1354: /* AlterObjectSchemaStmt: ALTER STATISTICS any_name SET SCHEMA name  */
#line 10190 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43061 "gram.c"
    break;

  case 1355: /* AlterObjectSchemaStmt: ALTER TEXT_P SEARCH PARSER any_name SET SCHEMA name  */
#line 10200 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43075 "gram.c"
    break;

  case 1356: /* AlterObjectSchemaStmt: ALTER TEXT_P SEARCH DICTIONARY any_name SET SCHEMA name  */
#line 10210 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43089 "gram.c"
    break;

  case 1357: /* AlterObjectSchemaStmt: ALTER TEXT_P SEARCH TEMPLATE any_name SET SCHEMA name  */
#line 10220 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43103 "gram.c"
    break;

  case 1358: /* AlterObjectSchemaStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name SET SCHEMA name  */
#line 10230 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43117 "gram.c"
    break;

  case 1359: /* AlterObjectSchemaStmt: ALTER SEQUENCE qualified_name SET SCHEMA name  */
#line 10240 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43131 "gram.c"
    break;

  case 1360: /* AlterObjectSchemaStmt: ALTER SEQUENCE IF_P EXISTS qualified_name SET SCHEMA name  */
#line 10250 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 43145 "gram.c"
    break;

  case 1361: /* AlterObjectSchemaStmt: ALTER VIEW qualified_name SET SCHEMA name  */
#line 10260 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43159 "gram.c"
    break;

  case 1362: /* AlterObjectSchemaStmt: ALTER VIEW IF_P EXISTS qualified_name SET SCHEMA name  */
#line 10270 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 43173 "gram.c"
    break;

  case 1363: /* AlterObjectSchemaStmt: ALTER MATERIALIZED VIEW qualified_name SET SCHEMA name  */
#line 10280 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43187 "gram.c"
    break;

  case 1364: /* AlterObjectSchemaStmt: ALTER MATERIALIZED VIEW IF_P EXISTS qualified_name SET SCHEMA name  */
#line 10290 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 43201 "gram.c"
    break;

  case 1365: /* AlterObjectSchemaStmt: ALTER FOREIGN TABLE relation_expr SET SCHEMA name  */
#line 10300 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43215 "gram.c"
    break;

  case 1366: /* AlterObjectSchemaStmt: ALTER FOREIGN TABLE IF_P EXISTS relation_expr SET SCHEMA name  */
#line 10310 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 43229 "gram.c"
    break;

  case 1367: /* AlterObjectSchemaStmt: ALTER TYPE_P any_name SET SCHEMA name  */
#line 10320 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43243 "gram.c"
    break;

  case 1368: /* AlterOperatorStmt: ALTER OPERATOR operator_with_argtypes SET '(' operator_def_list ')'  */
#line 10339 "gram.y"
                                {
					AlterOperatorStmt *n = makeNode(AlterOperatorStmt);

					n->opername = (yyvsp[-4].objwithargs);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 43255 "gram.c"
    break;

  case 1369: /* operator_def_list: operator_def_elem  */
#line 10348 "gram.y"
                                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 43261 "gram.c"
    break;

  case 1370: /* operator_def_list: operator_def_list ',' operator_def_elem  */
#line 10349 "gram.y"
                                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 43267 "gram.c"
    break;

  case 1371: /* operator_def_elem: ColLabel '=' NONE  */
#line 10353 "gram.y"
                                                { (yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2])); }
#line 43273 "gram.c"
    break;

  case 1372: /* operator_def_elem: ColLabel '=' operator_def_arg  */
#line 10355 "gram.y"
                                                { (yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2])); }
#line 43279 "gram.c"
    break;

  case 1373: /* operator_def_elem: ColLabel  */
#line 10357 "gram.y"
                                                { (yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0])); }
#line 43285 "gram.c"
    break;

  case 1374: /* operator_def_arg: func_type  */
#line 10362 "gram.y"
                                                                                { (yyval.node) = (Node *) (yyvsp[0].typnam); }
#line 43291 "gram.c"
    break;

  case 1375: /* operator_def_arg: reserved_keyword  */
#line 10363 "gram.y"
                                                                        { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 43297 "gram.c"
    break;

  case 1376: /* operator_def_arg: qual_all_Op  */
#line 10364 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[0].list); }
#line 43303 "gram.c"
    break;

  case 1377: /* operator_def_arg: NumericOnly  */
#line 10365 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 43309 "gram.c"
    break;

  case 1378: /* operator_def_arg: Sconst  */
#line 10366 "gram.y"
                                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 43315 "gram.c"
    break;

  case 1379: /* AlterTypeStmt: ALTER TYPE_P any_name SET '(' operator_def_list ')'  */
#line 10379 "gram.y"
                                {
					AlterTypeStmt *n = makeNode(AlterTypeStmt);

					n->typeName = (yyvsp[-4].list);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 43327 "gram.c"
    break;

  case 1380: /* AlterOwnerStmt: ALTER AGGREGATE aggregate_with_argtypes OWNER TO RoleSpec  */
#line 10395 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43340 "gram.c"
    break;

  case 1381: /* AlterOwnerStmt: ALTER COLLATION any_name OWNER TO RoleSpec  */
#line 10404 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43353 "gram.c"
    break;

  case 1382: /* AlterOwnerStmt: ALTER CONVERSION_P any_name OWNER TO RoleSpec  */
#line 10413 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43366 "gram.c"
    break;

  case 1383: /* AlterOwnerStmt: ALTER DATABASE name OWNER TO RoleSpec  */
#line 10422 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_DATABASE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43379 "gram.c"
    break;

  case 1384: /* AlterOwnerStmt: ALTER DOMAIN_P any_name OWNER TO RoleSpec  */
#line 10431 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43392 "gram.c"
    break;

  case 1385: /* AlterOwnerStmt: ALTER FUNCTION function_with_argtypes OWNER TO RoleSpec  */
#line 10440 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43405 "gram.c"
    break;

  case 1386: /* AlterOwnerStmt: ALTER opt_procedural LANGUAGE name OWNER TO RoleSpec  */
#line 10449 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43418 "gram.c"
    break;

  case 1387: /* AlterOwnerStmt: ALTER LARGE_P OBJECT_P NumericOnly OWNER TO RoleSpec  */
#line 10458 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-3].node);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43431 "gram.c"
    break;

  case 1388: /* AlterOwnerStmt: ALTER OPERATOR operator_with_argtypes OWNER TO RoleSpec  */
#line 10467 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43444 "gram.c"
    break;

  case 1389: /* AlterOwnerStmt: ALTER OPERATOR CLASS any_name USING name OWNER TO RoleSpec  */
#line 10476 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43457 "gram.c"
    break;

  case 1390: /* AlterOwnerStmt: ALTER OPERATOR FAMILY any_name USING name OWNER TO RoleSpec  */
#line 10485 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43470 "gram.c"
    break;

  case 1391: /* AlterOwnerStmt: ALTER PROCEDURE function_with_argtypes OWNER TO RoleSpec  */
#line 10494 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43483 "gram.c"
    break;

  case 1392: /* AlterOwnerStmt: ALTER ROUTINE function_with_argtypes OWNER TO RoleSpec  */
#line 10503 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43496 "gram.c"
    break;

  case 1393: /* AlterOwnerStmt: ALTER SCHEMA name OWNER TO RoleSpec  */
#line 10512 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_SCHEMA;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43509 "gram.c"
    break;

  case 1394: /* AlterOwnerStmt: ALTER TYPE_P any_name OWNER TO RoleSpec  */
#line 10521 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43522 "gram.c"
    break;

  case 1395: /* AlterOwnerStmt: ALTER TABLESPACE name OWNER TO RoleSpec  */
#line 10530 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TABLESPACE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43535 "gram.c"
    break;

  case 1396: /* AlterOwnerStmt: ALTER STATISTICS any_name OWNER TO RoleSpec  */
#line 10539 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43548 "gram.c"
    break;

  case 1397: /* AlterOwnerStmt: ALTER TEXT_P SEARCH DICTIONARY any_name OWNER TO RoleSpec  */
#line 10548 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43561 "gram.c"
    break;

  case 1398: /* AlterOwnerStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name OWNER TO RoleSpec  */
#line 10557 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43574 "gram.c"
    break;

  case 1399: /* AlterOwnerStmt: ALTER FOREIGN DATA_P WRAPPER name OWNER TO RoleSpec  */
#line 10566 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43587 "gram.c"
    break;

  case 1400: /* AlterOwnerStmt: ALTER SERVER name OWNER TO RoleSpec  */
#line 10575 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43600 "gram.c"
    break;

  case 1401: /* AlterOwnerStmt: ALTER EVENT TRIGGER name OWNER TO RoleSpec  */
#line 10584 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43613 "gram.c"
    break;

  case 1402: /* AlterOwnerStmt: ALTER PUBLICATION name OWNER TO RoleSpec  */
#line 10593 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43626 "gram.c"
    break;

  case 1403: /* AlterOwnerStmt: ALTER SUBSCRIPTION name OWNER TO RoleSpec  */
#line 10602 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43639 "gram.c"
    break;

  case 1404: /* CreatePublicationStmt: CREATE PUBLICATION name opt_definition  */
#line 10630 "gram.y"
                                {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43651 "gram.c"
    break;

  case 1405: /* CreatePublicationStmt: CREATE PUBLICATION name FOR ALL TABLES opt_definition  */
#line 10638 "gram.y"
                                {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-4].str);
					n->options = (yyvsp[0].list);
					n->for_all_tables = true;
					(yyval.node) = (Node *) n;
				}
#line 43664 "gram.c"
    break;

  case 1406: /* CreatePublicationStmt: CREATE PUBLICATION name FOR pub_obj_list opt_definition  */
#line 10647 "gram.y"
                                {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					n->pubobjects = (List *) (yyvsp[-1].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 43678 "gram.c"
    break;

  case 1407: /* PublicationObjSpec: TABLE relation_expr opt_column_list OptWhereClause  */
#line 10673 "gram.y"
                                {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLE;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = (yyvsp[-2].range);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
				}
#line 43691 "gram.c"
    break;

  case 1408: /* PublicationObjSpec: TABLES IN_P SCHEMA ColId  */
#line 10682 "gram.y"
                                {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLES_IN_SCHEMA;
					(yyval.publicationobjectspec)->name = (yyvsp[0].str);
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 43702 "gram.c"
    break;

  case 1409: /* PublicationObjSpec: TABLES IN_P SCHEMA CURRENT_SCHEMA  */
#line 10689 "gram.y"
                                {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA;
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 43712 "gram.c"
    break;

  case 1410: /* PublicationObjSpec: ColId opt_column_list OptWhereClause  */
#line 10695 "gram.y"
                                {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					/*
					 * If either a row filter or column list is specified, create
					 * a PublicationTable object.
					 */
					if ((yyvsp[-1].list) || (yyvsp[0].node))
					{
						/*
						 * The OptWhereClause must be stored here but it is
						 * valid only for tables. For non-table objects, an
						 * error will be thrown later via
						 * preprocess_pubobj_list().
						 */
						(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
						(yyval.publicationobjectspec)->pubtable->relation = makeRangeVar(NULL, (yyvsp[-2].str), (yylsp[-2]));
						(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
						(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
					}
					else
					{
						(yyval.publicationobjectspec)->name = (yyvsp[-2].str);
					}
					(yyval.publicationobjectspec)->location = (yylsp[-2]);
				}
#line 43743 "gram.c"
    break;

  case 1411: /* PublicationObjSpec: ColId indirection opt_column_list OptWhereClause  */
#line 10722 "gram.y"
                                {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = makeRangeVarFromQualifiedName((yyvsp[-3].str), (yyvsp[-2].list), (yylsp[-3]), yyscanner);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
					(yyval.publicationobjectspec)->location = (yylsp[-3]);
				}
#line 43757 "gram.c"
    break;

  case 1412: /* PublicationObjSpec: extended_relation_expr opt_column_list OptWhereClause  */
#line 10733 "gram.y"
                                {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = (yyvsp[-2].range);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
				}
#line 43770 "gram.c"
    break;

  case 1413: /* PublicationObjSpec: CURRENT_SCHEMA  */
#line 10742 "gram.y"
                                {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 43780 "gram.c"
    break;

  case 1414: /* pub_obj_list: PublicationObjSpec  */
#line 10750 "gram.y"
                                        { (yyval.list) = list_make1((yyvsp[0].publicationobjectspec)); }
#line 43786 "gram.c"
    break;

  case 1415: /* pub_obj_list: pub_obj_list ',' PublicationObjSpec  */
#line 10752 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].publicationobjectspec)); }
#line 43792 "gram.c"
    break;

  case 1416: /* AlterPublicationStmt: ALTER PUBLICATION name SET definition  */
#line 10774 "gram.y"
                                {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43804 "gram.c"
    break;

  case 1417: /* AlterPublicationStmt: ALTER PUBLICATION name ADD_P pub_obj_list  */
#line 10782 "gram.y"
                                {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_AddObjects;
					(yyval.node) = (Node *) n;
				}
#line 43818 "gram.c"
    break;

  case 1418: /* AlterPublicationStmt: ALTER PUBLICATION name SET pub_obj_list  */
#line 10792 "gram.y"
                                {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_SetObjects;
					(yyval.node) = (Node *) n;
				}
#line 43832 "gram.c"
    break;

  case 1419: /* AlterPublicationStmt: ALTER PUBLICATION name DROP pub_obj_list  */
#line 10802 "gram.y"
                                {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_DropObjects;
					(yyval.node) = (Node *) n;
				}
#line 43846 "gram.c"
    break;

  case 1420: /* CreateSubscriptionStmt: CREATE SUBSCRIPTION name CONNECTION Sconst PUBLICATION name_list opt_definition  */
#line 10821 "gram.y"
                                {
					CreateSubscriptionStmt *n =
						makeNode(CreateSubscriptionStmt);
					n->subname = (yyvsp[-5].str);
					n->conninfo = (yyvsp[-3].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43860 "gram.c"
    break;

  case 1421: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name SET definition  */
#line 10840 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_OPTIONS;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43874 "gram.c"
    break;

  case 1422: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name CONNECTION Sconst  */
#line 10850 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_CONNECTION;
					n->subname = (yyvsp[-2].str);
					n->conninfo = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 43888 "gram.c"
    break;

  case 1423: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name REFRESH PUBLICATION opt_definition  */
#line 10860 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_REFRESH;
					n->subname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43902 "gram.c"
    break;

  case 1424: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name ADD_P PUBLICATION name_list opt_definition  */
#line 10870 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ADD_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43917 "gram.c"
    break;

  case 1425: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name DROP PUBLICATION name_list opt_definition  */
#line 10881 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_DROP_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43932 "gram.c"
    break;

  case 1426: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name SET PUBLICATION name_list opt_definition  */
#line 10892 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_SET_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43947 "gram.c"
    break;

  case 1427: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name ENABLE_P  */
#line 10903 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *) makeBoolean(true), (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 43962 "gram.c"
    break;

  case 1428: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name DISABLE_P  */
#line 10914 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *) makeBoolean(false), (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 43977 "gram.c"
    break;

  case 1429: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name SKIP definition  */
#line 10925 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_SKIP;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43991 "gram.c"
    break;

  case 1430: /* DropSubscriptionStmt: DROP SUBSCRIPTION name opt_drop_behavior  */
#line 10943 "gram.y"
                                {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);

					n->subname = (yyvsp[-1].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 44004 "gram.c"
    break;

  case 1431: /* DropSubscriptionStmt: DROP SUBSCRIPTION IF_P EXISTS name opt_drop_behavior  */
#line 10952 "gram.y"
                                {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);

					n->subname = (yyvsp[-1].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 44017 "gram.c"
    break;

  case 1432: /* RuleStmt: CREATE opt_or_replace RULE name AS ON event TO qualified_name where_clause DO opt_instead RuleActionList  */
#line 10971 "gram.y"
                                {
					RuleStmt   *n = makeNode(RuleStmt);

					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 44034 "gram.c"
    break;

  case 1433: /* RuleActionList: NOTHING  */
#line 10986 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 44040 "gram.c"
    break;

  case 1434: /* RuleActionList: RuleActionStmt  */
#line 10987 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 44046 "gram.c"
    break;

  case 1435: /* RuleActionList: '(' RuleActionMulti ')'  */
#line 10988 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 44052 "gram.c"
    break;

  case 1436: /* RuleActionMulti: RuleActionMulti ';' RuleActionStmtOrEmpty  */
#line 10994 "gram.y"
                                { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 44062 "gram.c"
    break;

  case 1437: /* RuleActionMulti: RuleActionStmtOrEmpty  */
#line 11000 "gram.y"
                                { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 44072 "gram.c"
    break;

  case 1443: /* RuleActionStmtOrEmpty: RuleActionStmt  */
#line 11016 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 44078 "gram.c"
    break;

  case 1444: /* RuleActionStmtOrEmpty: %empty  */
#line 11017 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 44084 "gram.c"
    break;

  case 1445: /* event: SELECT  */
#line 11020 "gram.y"
                                                                                        { (yyval.ival) = CMD_SELECT; }
#line 44090 "gram.c"
    break;

  case 1446: /* event: UPDATE  */
#line 11021 "gram.y"
                                                                                                { (yyval.ival) = CMD_UPDATE; }
#line 44096 "gram.c"
    break;

  case 1447: /* event: DELETE_P  */
#line 11022 "gram.y"
                                                                                                { (yyval.ival) = CMD_DELETE; }
#line 44102 "gram.c"
    break;

  case 1448: /* event: INSERT  */
#line 11023 "gram.y"
                                                                                                { (yyval.ival) = CMD_INSERT; }
#line 44108 "gram.c"
    break;

  case 1449: /* opt_instead: INSTEAD  */
#line 11027 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 44114 "gram.c"
    break;

  case 1450: /* opt_instead: ALSO  */
#line 11028 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 44120 "gram.c"
    break;

  case 1451: /* opt_instead: %empty  */
#line 11029 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 44126 "gram.c"
    break;

  case 1452: /* NotifyStmt: NOTIFY ColId notify_payload  */
#line 11042 "gram.y"
                                {
					NotifyStmt *n = makeNode(NotifyStmt);

					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 44138 "gram.c"
    break;

  case 1453: /* notify_payload: ',' Sconst  */
#line 11052 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 44144 "gram.c"
    break;

  case 1454: /* notify_payload: %empty  */
#line 11053 "gram.y"
                                                                                        { (yyval.str) = NULL; }
#line 44150 "gram.c"
    break;

  case 1455: /* ListenStmt: LISTEN ColId  */
#line 11057 "gram.y"
                                {
					ListenStmt *n = makeNode(ListenStmt);

					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 44161 "gram.c"
    break;

  case 1456: /* UnlistenStmt: UNLISTEN ColId  */
#line 11067 "gram.y"
                                {
					UnlistenStmt *n = makeNode(UnlistenStmt);

					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 44172 "gram.c"
    break;

  case 1457: /* UnlistenStmt: UNLISTEN '*'  */
#line 11074 "gram.y"
                                {
					UnlistenStmt *n = makeNode(UnlistenStmt);

					n->conditionname = NULL;
					(yyval.node) = (Node *) n;
				}
#line 44183 "gram.c"
    break;

  case 1458: /* TransactionStmt: ABORT_P opt_transaction opt_transaction_chain  */
#line 11094 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 44197 "gram.c"
    break;

  case 1459: /* TransactionStmt: START TRANSACTION transaction_mode_list_or_empty  */
#line 11104 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 44210 "gram.c"
    break;

  case 1460: /* TransactionStmt: COMMIT opt_transaction opt_transaction_chain  */
#line 11113 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 44224 "gram.c"
    break;

  case 1461: /* TransactionStmt: ROLLBACK opt_transaction opt_transaction_chain  */
#line 11123 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 44238 "gram.c"
    break;

  case 1462: /* TransactionStmt: SAVEPOINT ColId  */
#line 11133 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_SAVEPOINT;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44251 "gram.c"
    break;

  case 1463: /* TransactionStmt: RELEASE SAVEPOINT ColId  */
#line 11142 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44264 "gram.c"
    break;

  case 1464: /* TransactionStmt: RELEASE ColId  */
#line 11151 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44277 "gram.c"
    break;

  case 1465: /* TransactionStmt: ROLLBACK opt_transaction TO SAVEPOINT ColId  */
#line 11160 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44290 "gram.c"
    break;

  case 1466: /* TransactionStmt: ROLLBACK opt_transaction TO ColId  */
#line 11169 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44303 "gram.c"
    break;

  case 1467: /* TransactionStmt: PREPARE TRANSACTION Sconst  */
#line 11178 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44316 "gram.c"
    break;

  case 1468: /* TransactionStmt: COMMIT PREPARED Sconst  */
#line 11187 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44329 "gram.c"
    break;

  case 1469: /* TransactionStmt: ROLLBACK PREPARED Sconst  */
#line 11196 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44342 "gram.c"
    break;

  case 1470: /* TransactionStmtLegacy: BEGIN_P opt_transaction transaction_mode_list_or_empty  */
#line 11208 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 44355 "gram.c"
    break;

  case 1471: /* TransactionStmtLegacy: END_P opt_transaction opt_transaction_chain  */
#line 11217 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 44369 "gram.c"
    break;

  case 1475: /* transaction_mode_item: ISOLATION LEVEL iso_level  */
#line 11235 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0])), (yylsp[-2])); }
#line 44376 "gram.c"
    break;

  case 1476: /* transaction_mode_item: READ ONLY  */
#line 11238 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(true, (yylsp[-1])), (yylsp[-1])); }
#line 44383 "gram.c"
    break;

  case 1477: /* transaction_mode_item: READ WRITE  */
#line 11241 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 44390 "gram.c"
    break;

  case 1478: /* transaction_mode_item: DEFERRABLE  */
#line 11244 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(true, (yylsp[0])), (yylsp[0])); }
#line 44397 "gram.c"
    break;

  case 1479: /* transaction_mode_item: NOT DEFERRABLE  */
#line 11247 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 44404 "gram.c"
    break;

  case 1480: /* transaction_mode_list: transaction_mode_item  */
#line 11254 "gram.y"
                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 44410 "gram.c"
    break;

  case 1481: /* transaction_mode_list: transaction_mode_list ',' transaction_mode_item  */
#line 11256 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 44416 "gram.c"
    break;

  case 1482: /* transaction_mode_list: transaction_mode_list transaction_mode_item  */
#line 11258 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 44422 "gram.c"
    break;

  case 1484: /* transaction_mode_list_or_empty: %empty  */
#line 11264 "gram.y"
                                        { (yyval.list) = NIL; }
#line 44428 "gram.c"
    break;

  case 1485: /* opt_transaction_chain: AND CHAIN  */
#line 11268 "gram.y"
                                                { (yyval.boolean) = true; }
#line 44434 "gram.c"
    break;

  case 1486: /* opt_transaction_chain: AND NO CHAIN  */
#line 11269 "gram.y"
                                        { (yyval.boolean) = false; }
#line 44440 "gram.c"
    break;

  case 1487: /* opt_transaction_chain: %empty  */
#line 11270 "gram.y"
                                        { (yyval.boolean) = false; }
#line 44446 "gram.c"
    break;

  case 1488: /* ViewStmt: CREATE OptTemp VIEW qualified_name opt_column_list opt_reloptions AS SelectStmt opt_check_option  */
#line 11284 "gram.y"
                                {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 44463 "gram.c"
    break;

  case 1489: /* ViewStmt: CREATE OR REPLACE OptTemp VIEW qualified_name opt_column_list opt_reloptions AS SelectStmt opt_check_option  */
#line 11298 "gram.y"
                                {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 44480 "gram.c"
    break;

  case 1490: /* ViewStmt: CREATE OptTemp RECURSIVE VIEW qualified_name '(' columnList ')' opt_reloptions AS SelectStmt opt_check_option  */
#line 11312 "gram.y"
                                {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 44502 "gram.c"
    break;

  case 1491: /* ViewStmt: CREATE OR REPLACE OptTemp RECURSIVE VIEW qualified_name '(' columnList ')' opt_reloptions AS SelectStmt opt_check_option  */
#line 11331 "gram.y"
                                {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 44524 "gram.c"
    break;

  case 1492: /* opt_check_option: WITH CHECK OPTION  */
#line 11351 "gram.y"
                                                                { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 44530 "gram.c"
    break;

  case 1493: /* opt_check_option: WITH CASCADED CHECK OPTION  */
#line 11352 "gram.y"
                                                { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 44536 "gram.c"
    break;

  case 1494: /* opt_check_option: WITH LOCAL CHECK OPTION  */
#line 11353 "gram.y"
                                                        { (yyval.ival) = LOCAL_CHECK_OPTION; }
#line 44542 "gram.c"
    break;

  case 1495: /* opt_check_option: %empty  */
#line 11354 "gram.y"
                                                                { (yyval.ival) = NO_CHECK_OPTION; }
#line 44548 "gram.c"
    break;

  case 1496: /* LoadStmt: LOAD file_name  */
#line 11365 "gram.y"
                                {
					LoadStmt   *n = makeNode(LoadStmt);

					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 44559 "gram.c"
    break;

  case 1497: /* CreatedbStmt: CREATE DATABASE name opt_with createdb_opt_list  */
#line 11382 "gram.y"
                                {
					CreatedbStmt *n = makeNode(CreatedbStmt);

					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 44571 "gram.c"
    break;

  case 1498: /* createdb_opt_list: createdb_opt_items  */
#line 11392 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 44577 "gram.c"
    break;

  case 1499: /* createdb_opt_list: %empty  */
#line 11393 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 44583 "gram.c"
    break;

  case 1500: /* createdb_opt_items: createdb_opt_item  */
#line 11397 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 44589 "gram.c"
    break;

  case 1501: /* createdb_opt_items: createdb_opt_items createdb_opt_item  */
#line 11398 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 44595 "gram.c"
    break;

  case 1502: /* createdb_opt_item: createdb_opt_name opt_equal NumericOnly  */
#line 11403 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (yyvsp[0].node), (yylsp[-2]));
				}
#line 44603 "gram.c"
    break;

  case 1503: /* createdb_opt_item: createdb_opt_name opt_equal opt_boolean_or_string  */
#line 11407 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 44611 "gram.c"
    break;

  case 1504: /* createdb_opt_item: createdb_opt_name opt_equal DEFAULT  */
#line 11411 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2]));
				}
#line 44619 "gram.c"
    break;

  case 1505: /* createdb_opt_name: IDENT  */
#line 11428 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 44625 "gram.c"
    break;

  case 1506: /* createdb_opt_name: CONNECTION LIMIT  */
#line 11429 "gram.y"
                                                                        { (yyval.str) = pstrdup("connection_limit"); }
#line 44631 "gram.c"
    break;

  case 1507: /* createdb_opt_name: ENCODING  */
#line 11430 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44637 "gram.c"
    break;

  case 1508: /* createdb_opt_name: LOCATION  */
#line 11431 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44643 "gram.c"
    break;

  case 1509: /* createdb_opt_name: OWNER  */
#line 11432 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44649 "gram.c"
    break;

  case 1510: /* createdb_opt_name: TABLESPACE  */
#line 11433 "gram.y"
                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44655 "gram.c"
    break;

  case 1511: /* createdb_opt_name: TEMPLATE  */
#line 11434 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44661 "gram.c"
    break;

  case 1514: /* AlterDatabaseStmt: ALTER DATABASE name WITH createdb_opt_list  */
#line 11454 "gram.y"
                                 {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 44673 "gram.c"
    break;

  case 1515: /* AlterDatabaseStmt: ALTER DATABASE name createdb_opt_list  */
#line 11462 "gram.y"
                                 {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 44685 "gram.c"
    break;

  case 1516: /* AlterDatabaseStmt: ALTER DATABASE name SET TABLESPACE name  */
#line 11470 "gram.y"
                                 {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
														(Node *) makeString((yyvsp[0].str)), (yylsp[0])));
					(yyval.node) = (Node *) n;
				 }
#line 44698 "gram.c"
    break;

  case 1517: /* AlterDatabaseStmt: ALTER DATABASE name REFRESH COLLATION VERSION_P  */
#line 11479 "gram.y"
                                 {
					AlterDatabaseRefreshCollStmt *n = makeNode(AlterDatabaseRefreshCollStmt);

					n->dbname = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				 }
#line 44709 "gram.c"
    break;

  case 1518: /* AlterDatabaseSetStmt: ALTER DATABASE name SetResetClause  */
#line 11489 "gram.y"
                                {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);

					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 44721 "gram.c"
    break;

  case 1519: /* DropdbStmt: DROP DATABASE name  */
#line 11507 "gram.y"
                                {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[0].str);
					n->missing_ok = false;
					n->options = NULL;
					(yyval.node) = (Node *) n;
				}
#line 44734 "gram.c"
    break;

  case 1520: /* DropdbStmt: DROP DATABASE IF_P EXISTS name  */
#line 11516 "gram.y"
                                {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[0].str);
					n->missing_ok = true;
					n->options = NULL;
					(yyval.node) = (Node *) n;
				}
#line 44747 "gram.c"
    break;

  case 1521: /* DropdbStmt: DROP DATABASE name opt_with '(' drop_option_list ')'  */
#line 11525 "gram.y"
                                {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[-4].str);
					n->missing_ok = false;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 44760 "gram.c"
    break;

  case 1522: /* DropdbStmt: DROP DATABASE IF_P EXISTS name opt_with '(' drop_option_list ')'  */
#line 11534 "gram.y"
                                {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[-4].str);
					n->missing_ok = true;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 44773 "gram.c"
    break;

  case 1523: /* drop_option_list: drop_option  */
#line 11546 "gram.y"
                                {
					(yyval.list) = list_make1((Node *) (yyvsp[0].defelt));
				}
#line 44781 "gram.c"
    break;

  case 1524: /* drop_option_list: drop_option_list ',' drop_option  */
#line 11550 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (Node *) (yyvsp[0].defelt));
				}
#line 44789 "gram.c"
    break;

  case 1525: /* drop_option: FORCE  */
#line 11561 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force", NULL, (yylsp[0]));
				}
#line 44797 "gram.c"
    break;

  case 1526: /* AlterCollationStmt: ALTER COLLATION any_name REFRESH VERSION_P  */
#line 11573 "gram.y"
                                {
					AlterCollationStmt *n = makeNode(AlterCollationStmt);

					n->collname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 44808 "gram.c"
    break;

  case 1527: /* AlterSystemStmt: ALTER SYSTEM_P SET generic_set  */
#line 11591 "gram.y"
                                {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);

					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 44819 "gram.c"
    break;

  case 1528: /* AlterSystemStmt: ALTER SYSTEM_P RESET generic_reset  */
#line 11598 "gram.y"
                                {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);

					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 44830 "gram.c"
    break;

  case 1529: /* CreateDomainStmt: CREATE DOMAIN_P any_name opt_as Typename ColQualList  */
#line 11615 "gram.y"
                                {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);

					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 44844 "gram.c"
    break;

  case 1530: /* AlterDomainStmt: ALTER DOMAIN_P any_name alter_column_default  */
#line 11629 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 44857 "gram.c"
    break;

  case 1531: /* AlterDomainStmt: ALTER DOMAIN_P any_name DROP NOT NULL_P  */
#line 11639 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 44869 "gram.c"
    break;

  case 1532: /* AlterDomainStmt: ALTER DOMAIN_P any_name SET NOT NULL_P  */
#line 11648 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 44881 "gram.c"
    break;

  case 1533: /* AlterDomainStmt: ALTER DOMAIN_P any_name ADD_P DomainConstraint  */
#line 11657 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 44894 "gram.c"
    break;

  case 1534: /* AlterDomainStmt: ALTER DOMAIN_P any_name DROP CONSTRAINT name opt_drop_behavior  */
#line 11667 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 44909 "gram.c"
    break;

  case 1535: /* AlterDomainStmt: ALTER DOMAIN_P any_name DROP CONSTRAINT IF_P EXISTS name opt_drop_behavior  */
#line 11679 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 44924 "gram.c"
    break;

  case 1536: /* AlterDomainStmt: ALTER DOMAIN_P any_name VALIDATE CONSTRAINT name  */
#line 11691 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 44937 "gram.c"
    break;

  case 1539: /* AlterTSDictionaryStmt: ALTER TEXT_P SEARCH DICTIONARY any_name definition  */
#line 11714 "gram.y"
                                {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);

					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 44949 "gram.c"
    break;

  case 1540: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name ADD_P MAPPING FOR name_list any_with any_name_list  */
#line 11725 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_ADD_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node *) n;
				}
#line 44965 "gram.c"
    break;

  case 1541: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name ALTER MAPPING FOR name_list any_with any_name_list  */
#line 11737 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_ALTER_MAPPING_FOR_TOKEN;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node *) n;
				}
#line 44981 "gram.c"
    break;

  case 1542: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name ALTER MAPPING REPLACE any_name any_with any_name  */
#line 11749 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_REPLACE_DICT;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node *) n;
				}
#line 44997 "gram.c"
    break;

  case 1543: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name ALTER MAPPING FOR name_list REPLACE any_name any_with any_name  */
#line 11761 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_REPLACE_DICT_FOR_TOKEN;
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node *) n;
				}
#line 45013 "gram.c"
    break;

  case 1544: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name DROP MAPPING FOR name_list  */
#line 11773 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 45027 "gram.c"
    break;

  case 1545: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name DROP MAPPING IF_P EXISTS FOR name_list  */
#line 11783 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 45041 "gram.c"
    break;

  case 1548: /* CreateConversionStmt: CREATE opt_default CONVERSION_P any_name FOR Sconst TO Sconst FROM any_name  */
#line 11812 "gram.y"
                        {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);

				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *) n;
			}
#line 45056 "gram.c"
    break;

  case 1549: /* ClusterStmt: CLUSTER '(' utility_option_list ')' qualified_name cluster_index_specification  */
#line 11835 "gram.y"
                                {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 45069 "gram.c"
    break;

  case 1550: /* ClusterStmt: CLUSTER '(' utility_option_list ')'  */
#line 11844 "gram.y"
                                {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = NULL;
					n->indexname = NULL;
					n->params = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 45082 "gram.c"
    break;

  case 1551: /* ClusterStmt: CLUSTER opt_verbose qualified_name cluster_index_specification  */
#line 11854 "gram.y"
                                {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = NIL;
					if ((yyvsp[-2].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-2])));
					(yyval.node) = (Node *) n;
				}
#line 45097 "gram.c"
    break;

  case 1552: /* ClusterStmt: CLUSTER opt_verbose  */
#line 11866 "gram.y"
                                {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = NULL;
					n->indexname = NULL;
					n->params = NIL;
					if ((yyvsp[0].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 45112 "gram.c"
    break;

  case 1553: /* ClusterStmt: CLUSTER opt_verbose name ON qualified_name  */
#line 11878 "gram.y"
                                {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->params = NIL;
					if ((yyvsp[-3].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 45127 "gram.c"
    break;

  case 1554: /* cluster_index_specification: USING name  */
#line 11891 "gram.y"
                                                                { (yyval.str) = (yyvsp[0].str); }
#line 45133 "gram.c"
    break;

  case 1555: /* cluster_index_specification: %empty  */
#line 11892 "gram.y"
                                                                { (yyval.str) = NULL; }
#line 45139 "gram.c"
    break;

  case 1556: /* VacuumStmt: VACUUM opt_full opt_freeze opt_verbose opt_analyze opt_vacuum_relation_list  */
#line 11905 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = NIL;
					if ((yyvsp[-4].boolean))
						n->options = lappend(n->options,
											 makeDefElem("full", NULL, (yylsp[-4])));
					if ((yyvsp[-3].boolean))
						n->options = lappend(n->options,
											 makeDefElem("freeze", NULL, (yylsp[-3])));
					if ((yyvsp[-2].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("analyze", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 45164 "gram.c"
    break;

  case 1557: /* VacuumStmt: VACUUM '(' utility_option_list ')' opt_vacuum_relation_list  */
#line 11926 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 45177 "gram.c"
    break;

  case 1558: /* AnalyzeStmt: analyze_keyword opt_verbose opt_vacuum_relation_list  */
#line 11937 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = NIL;
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 45193 "gram.c"
    break;

  case 1559: /* AnalyzeStmt: analyze_keyword '(' utility_option_list ')' opt_vacuum_relation_list  */
#line 11949 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 45206 "gram.c"
    break;

  case 1560: /* utility_option_list: utility_option_elem  */
#line 11961 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 45214 "gram.c"
    break;

  case 1561: /* utility_option_list: utility_option_list ',' utility_option_elem  */
#line 11965 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 45222 "gram.c"
    break;

  case 1564: /* utility_option_elem: utility_option_name utility_option_arg  */
#line 11977 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 45230 "gram.c"
    break;

  case 1565: /* utility_option_name: NonReservedWord  */
#line 11983 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 45236 "gram.c"
    break;

  case 1566: /* utility_option_name: analyze_keyword  */
#line 11984 "gram.y"
                                                                                        { (yyval.str) = "analyze"; }
#line 45242 "gram.c"
    break;

  case 1567: /* utility_option_name: FORMAT_LA  */
#line 11985 "gram.y"
                                                                                                { (yyval.str) = "format"; }
#line 45248 "gram.c"
    break;

  case 1568: /* utility_option_arg: opt_boolean_or_string  */
#line 11989 "gram.y"
                                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 45254 "gram.c"
    break;

  case 1569: /* utility_option_arg: NumericOnly  */
#line 11990 "gram.y"
                                                                                        { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 45260 "gram.c"
    break;

  case 1570: /* utility_option_arg: %empty  */
#line 11991 "gram.y"
                                                                                        { (yyval.node) = NULL; }
#line 45266 "gram.c"
    break;

  case 1571: /* opt_analyze: analyze_keyword  */
#line 11995 "gram.y"
                                                                                        { (yyval.boolean) = true; }
#line 45272 "gram.c"
    break;

  case 1572: /* opt_analyze: %empty  */
#line 11996 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 45278 "gram.c"
    break;

  case 1573: /* opt_verbose: VERBOSE  */
#line 12000 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 45284 "gram.c"
    break;

  case 1574: /* opt_verbose: %empty  */
#line 12001 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 45290 "gram.c"
    break;

  case 1575: /* opt_full: FULL  */
#line 12004 "gram.y"
                                                                                        { (yyval.boolean) = true; }
#line 45296 "gram.c"
    break;

  case 1576: /* opt_full: %empty  */
#line 12005 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 45302 "gram.c"
    break;

  case 1577: /* opt_freeze: FREEZE  */
#line 12008 "gram.y"
                                                                                        { (yyval.boolean) = true; }
#line 45308 "gram.c"
    break;

  case 1578: /* opt_freeze: %empty  */
#line 12009 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 45314 "gram.c"
    break;

  case 1579: /* opt_name_list: '(' name_list ')'  */
#line 12013 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 45320 "gram.c"
    break;

  case 1580: /* opt_name_list: %empty  */
#line 12014 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 45326 "gram.c"
    break;

  case 1581: /* vacuum_relation: relation_expr opt_name_list  */
#line 12019 "gram.y"
                                {
					(yyval.node) = (Node *) makeVacuumRelation((yyvsp[-1].range), InvalidOid, (yyvsp[0].list));
				}
#line 45334 "gram.c"
    break;

  case 1582: /* vacuum_relation_list: vacuum_relation  */
#line 12026 "gram.y"
                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45340 "gram.c"
    break;

  case 1583: /* vacuum_relation_list: vacuum_relation_list ',' vacuum_relation  */
#line 12028 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 45346 "gram.c"
    break;

  case 1584: /* opt_vacuum_relation_list: vacuum_relation_list  */
#line 12032 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 45352 "gram.c"
    break;

  case 1585: /* opt_vacuum_relation_list: %empty  */
#line 12033 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 45358 "gram.c"
    break;

  case 1586: /* ExplainStmt: EXPLAIN ExplainableStmt  */
#line 12047 "gram.y"
                                {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 45370 "gram.c"
    break;

  case 1587: /* ExplainStmt: EXPLAIN analyze_keyword opt_verbose ExplainableStmt  */
#line 12055 "gram.y"
                                {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 45385 "gram.c"
    break;

  case 1588: /* ExplainStmt: EXPLAIN VERBOSE ExplainableStmt  */
#line 12066 "gram.y"
                                {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 45397 "gram.c"
    break;

  case 1589: /* ExplainStmt: EXPLAIN '(' utility_option_list ')' ExplainableStmt  */
#line 12074 "gram.y"
                                {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 45409 "gram.c"
    break;

  case 1600: /* PrepareStmt: PREPARE name prep_type_clause AS PreparableStmt  */
#line 12104 "gram.y"
                                {
					PrepareStmt *n = makeNode(PrepareStmt);

					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 45422 "gram.c"
    break;

  case 1601: /* prep_type_clause: '(' type_list ')'  */
#line 12114 "gram.y"
                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 45428 "gram.c"
    break;

  case 1602: /* prep_type_clause: %empty  */
#line 12115 "gram.y"
                                                                        { (yyval.list) = NIL; }
#line 45434 "gram.c"
    break;

  case 1608: /* ExecuteStmt: EXECUTE name execute_param_clause  */
#line 12134 "gram.y"
                                {
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 45446 "gram.c"
    break;

  case 1609: /* ExecuteStmt: CREATE OptTemp TABLE create_as_target AS EXECUTE name execute_param_clause opt_with_data  */
#line 12143 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 45467 "gram.c"
    break;

  case 1610: /* ExecuteStmt: CREATE OptTemp TABLE IF_P NOT EXISTS create_as_target AS EXECUTE name execute_param_clause opt_with_data  */
#line 12161 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-10].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 45488 "gram.c"
    break;

  case 1611: /* execute_param_clause: '(' expr_list ')'  */
#line 12179 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 45494 "gram.c"
    break;

  case 1612: /* execute_param_clause: %empty  */
#line 12180 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 45500 "gram.c"
    break;

  case 1613: /* DeallocateStmt: DEALLOCATE name  */
#line 12191 "gram.y"
                                        {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = (yyvsp[0].str);
						n->isall = false;
						n->location = (yylsp[0]);
						(yyval.node) = (Node *) n;
					}
#line 45513 "gram.c"
    break;

  case 1614: /* DeallocateStmt: DEALLOCATE PREPARE name  */
#line 12200 "gram.y"
                                        {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = (yyvsp[0].str);
						n->isall = false;
						n->location = (yylsp[0]);
						(yyval.node) = (Node *) n;
					}
#line 45526 "gram.c"
    break;

  case 1615: /* DeallocateStmt: DEALLOCATE ALL  */
#line 12209 "gram.y"
                                        {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = NULL;
						n->isall = true;
						n->location = -1;
						(yyval.node) = (Node *) n;
					}
#line 45539 "gram.c"
    break;

  case 1616: /* DeallocateStmt: DEALLOCATE PREPARE ALL  */
#line 12218 "gram.y"
                                        {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = NULL;
						n->isall = true;
						n->location = -1;
						(yyval.node) = (Node *) n;
					}
#line 45552 "gram.c"
    break;

  case 1617: /* InsertStmt: opt_with_clause INSERT INTO insert_target insert_rest opt_on_conflict returning_clause  */
#line 12238 "gram.y"
                                {
					(yyvsp[-2].istmt)->relation = (yyvsp[-3].range);
					(yyvsp[-2].istmt)->onConflictClause = (yyvsp[-1].onconflict);
					(yyvsp[-2].istmt)->returningClause = (yyvsp[0].retclause);
					(yyvsp[-2].istmt)->withClause = (yyvsp[-6].with);
					(yyvsp[-2].istmt)->stmt_location = (yyloc);
					(yyval.node) = (Node *) (yyvsp[-2].istmt);
				}
#line 45565 "gram.c"
    break;

  case 1618: /* insert_target: qualified_name  */
#line 12256 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
				}
#line 45573 "gram.c"
    break;

  case 1619: /* insert_target: qualified_name AS ColId  */
#line 12260 "gram.y"
                                {
					(yyvsp[-2].range)->alias = makeAlias((yyvsp[0].str), NIL);
					(yyval.range) = (yyvsp[-2].range);
				}
#line 45582 "gram.c"
    break;

  case 1620: /* insert_rest: SelectStmt  */
#line 12268 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 45592 "gram.c"
    break;

  case 1621: /* insert_rest: OVERRIDING override_kind VALUE_P SelectStmt  */
#line 12274 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 45603 "gram.c"
    break;

  case 1622: /* insert_rest: '(' insert_column_list ')' SelectStmt  */
#line 12281 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 45613 "gram.c"
    break;

  case 1623: /* insert_rest: '(' insert_column_list ')' OVERRIDING override_kind VALUE_P SelectStmt  */
#line 12287 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-5].list);
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 45624 "gram.c"
    break;

  case 1624: /* insert_rest: DEFAULT VALUES  */
#line 12294 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 45634 "gram.c"
    break;

  case 1625: /* override_kind: USER  */
#line 12302 "gram.y"
                                        { (yyval.ival) = OVERRIDING_USER_VALUE; }
#line 45640 "gram.c"
    break;

  case 1626: /* override_kind: SYSTEM_P  */
#line 12303 "gram.y"
                                        { (yyval.ival) = OVERRIDING_SYSTEM_VALUE; }
#line 45646 "gram.c"
    break;

  case 1627: /* insert_column_list: insert_column_item  */
#line 12308 "gram.y"
                                        { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 45652 "gram.c"
    break;

  case 1628: /* insert_column_list: insert_column_list ',' insert_column_item  */
#line 12310 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 45658 "gram.c"
    break;

  case 1629: /* insert_column_item: ColId opt_indirection  */
#line 12315 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 45670 "gram.c"
    break;

  case 1630: /* opt_on_conflict: ON CONFLICT opt_conf_expr DO UPDATE SET set_clause_list where_clause  */
#line 12326 "gram.y"
                                {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_UPDATE;
					(yyval.onconflict)->infer = (yyvsp[-5].infer);
					(yyval.onconflict)->targetList = (yyvsp[-1].list);
					(yyval.onconflict)->whereClause = (yyvsp[0].node);
					(yyval.onconflict)->location = (yylsp[-7]);
				}
#line 45683 "gram.c"
    break;

  case 1631: /* opt_on_conflict: ON CONFLICT opt_conf_expr DO NOTHING  */
#line 12336 "gram.y"
                                {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_NOTHING;
					(yyval.onconflict)->infer = (yyvsp[-2].infer);
					(yyval.onconflict)->targetList = NIL;
					(yyval.onconflict)->whereClause = NULL;
					(yyval.onconflict)->location = (yylsp[-4]);
				}
#line 45696 "gram.c"
    break;

  case 1632: /* opt_on_conflict: %empty  */
#line 12345 "gram.y"
                                {
					(yyval.onconflict) = NULL;
				}
#line 45704 "gram.c"
    break;

  case 1633: /* opt_conf_expr: '(' index_params ')' where_clause  */
#line 12352 "gram.y"
                                {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = (yyvsp[-2].list);
					(yyval.infer)->whereClause = (yyvsp[0].node);
					(yyval.infer)->conname = NULL;
					(yyval.infer)->location = (yylsp[-3]);
				}
#line 45716 "gram.c"
    break;

  case 1634: /* opt_conf_expr: ON CONSTRAINT name  */
#line 12361 "gram.y"
                                {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = NIL;
					(yyval.infer)->whereClause = NULL;
					(yyval.infer)->conname = (yyvsp[0].str);
					(yyval.infer)->location = (yylsp[-2]);
				}
#line 45728 "gram.c"
    break;

  case 1635: /* opt_conf_expr: %empty  */
#line 12369 "gram.y"
                                {
					(yyval.infer) = NULL;
				}
#line 45736 "gram.c"
    break;

  case 1636: /* returning_clause: RETURNING returning_with_clause target_list  */
#line 12376 "gram.y"
                                {
					ReturningClause *n = makeNode(ReturningClause);

					n->options = (yyvsp[-1].list);
					n->exprs = (yyvsp[0].list);
					(yyval.retclause) = n;
				}
#line 45748 "gram.c"
    break;

  case 1637: /* returning_clause: %empty  */
#line 12384 "gram.y"
                                {
					(yyval.retclause) = NULL;
				}
#line 45756 "gram.c"
    break;

  case 1638: /* returning_with_clause: WITH '(' returning_options ')'  */
#line 12390 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 45762 "gram.c"
    break;

  case 1639: /* returning_with_clause: %empty  */
#line 12391 "gram.y"
                                                                                { (yyval.list) = NIL; }
#line 45768 "gram.c"
    break;

  case 1640: /* returning_options: returning_option  */
#line 12395 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45774 "gram.c"
    break;

  case 1641: /* returning_options: returning_options ',' returning_option  */
#line 12396 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 45780 "gram.c"
    break;

  case 1642: /* returning_option: returning_option_kind AS ColId  */
#line 12401 "gram.y"
                                {
					ReturningOption *n = makeNode(ReturningOption);

					n->option = (yyvsp[-2].retoptionkind);
					n->value = (yyvsp[0].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 45793 "gram.c"
    break;

  case 1643: /* returning_option_kind: OLD  */
#line 12412 "gram.y"
                                                { (yyval.retoptionkind) = RETURNING_OPTION_OLD; }
#line 45799 "gram.c"
    break;

  case 1644: /* returning_option_kind: NEW  */
#line 12413 "gram.y"
                                        { (yyval.retoptionkind) = RETURNING_OPTION_NEW; }
#line 45805 "gram.c"
    break;

  case 1645: /* DeleteStmt: opt_with_clause DELETE_P FROM relation_expr_opt_alias using_clause where_or_current_clause returning_clause  */
#line 12426 "gram.y"
                                {
					DeleteStmt *n = makeNode(DeleteStmt);

					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningClause = (yyvsp[0].retclause);
					n->withClause = (yyvsp[-6].with);
					n->stmt_location = (yyloc);
					(yyval.node) = (Node *) n;
				}
#line 45821 "gram.c"
    break;

  case 1646: /* using_clause: USING from_list  */
#line 12440 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 45827 "gram.c"
    break;

  case 1647: /* using_clause: %empty  */
#line 12441 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 45833 "gram.c"
    break;

  case 1648: /* LockStmt: LOCK_P opt_table relation_expr_list opt_lock opt_nowait  */
#line 12453 "gram.y"
                                {
					LockStmt   *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 45846 "gram.c"
    break;

  case 1649: /* opt_lock: IN_P lock_type MODE  */
#line 12463 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-1].ival); }
#line 45852 "gram.c"
    break;

  case 1650: /* opt_lock: %empty  */
#line 12464 "gram.y"
                                                                                { (yyval.ival) = AccessExclusiveLock; }
#line 45858 "gram.c"
    break;

  case 1651: /* lock_type: ACCESS SHARE  */
#line 12467 "gram.y"
                                                                { (yyval.ival) = AccessShareLock; }
#line 45864 "gram.c"
    break;

  case 1652: /* lock_type: ROW SHARE  */
#line 12468 "gram.y"
                                                                                { (yyval.ival) = RowShareLock; }
#line 45870 "gram.c"
    break;

  case 1653: /* lock_type: ROW EXCLUSIVE  */
#line 12469 "gram.y"
                                                                        { (yyval.ival) = RowExclusiveLock; }
#line 45876 "gram.c"
    break;

  case 1654: /* lock_type: SHARE UPDATE EXCLUSIVE  */
#line 12470 "gram.y"
                                                                { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 45882 "gram.c"
    break;

  case 1655: /* lock_type: SHARE  */
#line 12471 "gram.y"
                                                                                { (yyval.ival) = ShareLock; }
#line 45888 "gram.c"
    break;

  case 1656: /* lock_type: SHARE ROW EXCLUSIVE  */
#line 12472 "gram.y"
                                                                { (yyval.ival) = ShareRowExclusiveLock; }
#line 45894 "gram.c"
    break;

  case 1657: /* lock_type: EXCLUSIVE  */
#line 12473 "gram.y"
                                                                                { (yyval.ival) = ExclusiveLock; }
#line 45900 "gram.c"
    break;

  case 1658: /* lock_type: ACCESS EXCLUSIVE  */
#line 12474 "gram.y"
                                                                        { (yyval.ival) = AccessExclusiveLock; }
#line 45906 "gram.c"
    break;

  case 1659: /* opt_nowait: NOWAIT  */
#line 12477 "gram.y"
                                                                        { (yyval.boolean) = true; }
#line 45912 "gram.c"
    break;

  case 1660: /* opt_nowait: %empty  */
#line 12478 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 45918 "gram.c"
    break;

  case 1661: /* opt_nowait_or_skip: NOWAIT  */
#line 12482 "gram.y"
                                                                                { (yyval.ival) = LockWaitError; }
#line 45924 "gram.c"
    break;

  case 1662: /* opt_nowait_or_skip: SKIP LOCKED  */
#line 12483 "gram.y"
                                                                        { (yyval.ival) = LockWaitSkip; }
#line 45930 "gram.c"
    break;

  case 1663: /* opt_nowait_or_skip: %empty  */
#line 12484 "gram.y"
                                                                                { (yyval.ival) = LockWaitBlock; }
#line 45936 "gram.c"
    break;

  case 1664: /* UpdateStmt: opt_with_clause UPDATE relation_expr_opt_alias SET set_clause_list from_clause where_or_current_clause returning_clause  */
#line 12500 "gram.y"
                                {
					UpdateStmt *n = makeNode(UpdateStmt);

					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningClause = (yyvsp[0].retclause);
					n->withClause = (yyvsp[-7].with);
					n->stmt_location = (yyloc);
					(yyval.node) = (Node *) n;
				}
#line 45953 "gram.c"
    break;

  case 1665: /* set_clause_list: set_clause  */
#line 12515 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 45959 "gram.c"
    break;

  case 1666: /* set_clause_list: set_clause_list ',' set_clause  */
#line 12516 "gram.y"
                                                                { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 45965 "gram.c"
    break;

  case 1667: /* set_clause: set_target '=' a_expr  */
#line 12521 "gram.y"
                                {
					(yyvsp[-2].target)->val = (Node *) (yyvsp[0].node);
					(yyval.list) = list_make1((yyvsp[-2].target));
				}
#line 45974 "gram.c"
    break;

  case 1668: /* set_clause: '(' set_target_list ')' '=' a_expr  */
#line 12526 "gram.y"
                                {
					int			ncolumns = list_length((yyvsp[-3].list));
					int			i = 1;
					ListCell   *col_cell;

					/* Create a MultiAssignRef source for each target */
					foreach(col_cell, (yyvsp[-3].list))
					{
						ResTarget  *res_col = (ResTarget *) lfirst(col_cell);
						MultiAssignRef *r = makeNode(MultiAssignRef);

						r->source = (Node *) (yyvsp[0].node);
						r->colno = i;
						r->ncolumns = ncolumns;
						res_col->val = (Node *) r;
						i++;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 45999 "gram.c"
    break;

  case 1669: /* set_target: ColId opt_indirection  */
#line 12550 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 46011 "gram.c"
    break;

  case 1670: /* set_target_list: set_target  */
#line 12560 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 46017 "gram.c"
    break;

  case 1671: /* set_target_list: set_target_list ',' set_target  */
#line 12561 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 46023 "gram.c"
    break;

  case 1672: /* MergeStmt: opt_with_clause MERGE INTO relation_expr_opt_alias USING table_ref ON a_expr merge_when_list returning_clause  */
#line 12578 "gram.y"
                                {
					MergeStmt  *m = makeNode(MergeStmt);

					m->withClause = (yyvsp[-9].with);
					m->relation = (yyvsp[-6].range);
					m->sourceRelation = (yyvsp[-4].node);
					m->joinCondition = (yyvsp[-2].node);
					m->mergeWhenClauses = (yyvsp[-1].list);
					m->returningClause = (yyvsp[0].retclause);
					m->stmt_location = (yyloc);

					(yyval.node) = (Node *) m;
				}
#line 46041 "gram.c"
    break;

  case 1673: /* merge_when_list: merge_when_clause  */
#line 12594 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46047 "gram.c"
    break;

  case 1674: /* merge_when_list: merge_when_list merge_when_clause  */
#line 12595 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list),(yyvsp[0].node)); }
#line 46053 "gram.c"
    break;

  case 1675: /* merge_when_clause: merge_when_tgt_matched opt_merge_when_condition THEN merge_update  */
#line 12606 "gram.y"
                                {
					(yyvsp[0].mergewhen)->matchKind = (yyvsp[-3].mergematch);
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 46064 "gram.c"
    break;

  case 1676: /* merge_when_clause: merge_when_tgt_matched opt_merge_when_condition THEN merge_delete  */
#line 12613 "gram.y"
                                {
					(yyvsp[0].mergewhen)->matchKind = (yyvsp[-3].mergematch);
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 46075 "gram.c"
    break;

  case 1677: /* merge_when_clause: merge_when_tgt_not_matched opt_merge_when_condition THEN merge_insert  */
#line 12620 "gram.y"
                                {
					(yyvsp[0].mergewhen)->matchKind = (yyvsp[-3].mergematch);
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 46086 "gram.c"
    break;

  case 1678: /* merge_when_clause: merge_when_tgt_matched opt_merge_when_condition THEN DO NOTHING  */
#line 12627 "gram.y"
                                {
					MergeWhenClause *m = makeNode(MergeWhenClause);

					m->matchKind = (yyvsp[-4].mergematch);
					m->commandType = CMD_NOTHING;
					m->condition = (yyvsp[-3].node);

					(yyval.node) = (Node *) m;
				}
#line 46100 "gram.c"
    break;

  case 1679: /* merge_when_clause: merge_when_tgt_not_matched opt_merge_when_condition THEN DO NOTHING  */
#line 12637 "gram.y"
                                {
					MergeWhenClause *m = makeNode(MergeWhenClause);

					m->matchKind = (yyvsp[-4].mergematch);
					m->commandType = CMD_NOTHING;
					m->condition = (yyvsp[-3].node);

					(yyval.node) = (Node *) m;
				}
#line 46114 "gram.c"
    break;

  case 1680: /* merge_when_tgt_matched: WHEN MATCHED  */
#line 12649 "gram.y"
                                                                        { (yyval.mergematch) = MERGE_WHEN_MATCHED; }
#line 46120 "gram.c"
    break;

  case 1681: /* merge_when_tgt_matched: WHEN NOT MATCHED BY SOURCE  */
#line 12650 "gram.y"
                                                        { (yyval.mergematch) = MERGE_WHEN_NOT_MATCHED_BY_SOURCE; }
#line 46126 "gram.c"
    break;

  case 1682: /* merge_when_tgt_not_matched: WHEN NOT MATCHED  */
#line 12654 "gram.y"
                                                                        { (yyval.mergematch) = MERGE_WHEN_NOT_MATCHED_BY_TARGET; }
#line 46132 "gram.c"
    break;

  case 1683: /* merge_when_tgt_not_matched: WHEN NOT MATCHED BY TARGET  */
#line 12655 "gram.y"
                                                        { (yyval.mergematch) = MERGE_WHEN_NOT_MATCHED_BY_TARGET; }
#line 46138 "gram.c"
    break;

  case 1684: /* opt_merge_when_condition: AND a_expr  */
#line 12659 "gram.y"
                                                                { (yyval.node) = (yyvsp[0].node); }
#line 46144 "gram.c"
    break;

  case 1685: /* opt_merge_when_condition: %empty  */
#line 12660 "gram.y"
                                                                        { (yyval.node) = NULL; }
#line 46150 "gram.c"
    break;

  case 1686: /* merge_update: UPDATE SET set_clause_list  */
#line 12665 "gram.y"
                                {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_UPDATE;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = (yyvsp[0].list);
					n->values = NIL;

					(yyval.mergewhen) = n;
				}
#line 46164 "gram.c"
    break;

  case 1687: /* merge_delete: DELETE_P  */
#line 12678 "gram.y"
                                {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_DELETE;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = NIL;

					(yyval.mergewhen) = n;
				}
#line 46178 "gram.c"
    break;

  case 1688: /* merge_insert: INSERT merge_values_clause  */
#line 12691 "gram.y"
                                {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 46191 "gram.c"
    break;

  case 1689: /* merge_insert: INSERT OVERRIDING override_kind VALUE_P merge_values_clause  */
#line 12700 "gram.y"
                                {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = (yyvsp[-2].ival);
					n->targetList = NIL;
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 46204 "gram.c"
    break;

  case 1690: /* merge_insert: INSERT '(' insert_column_list ')' merge_values_clause  */
#line 12709 "gram.y"
                                {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = (yyvsp[-2].list);
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 46217 "gram.c"
    break;

  case 1691: /* merge_insert: INSERT '(' insert_column_list ')' OVERRIDING override_kind VALUE_P merge_values_clause  */
#line 12718 "gram.y"
                                {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = (yyvsp[-2].ival);
					n->targetList = (yyvsp[-5].list);
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 46230 "gram.c"
    break;

  case 1692: /* merge_insert: INSERT DEFAULT VALUES  */
#line 12727 "gram.y"
                                {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = NIL;
					(yyval.mergewhen) = n;
				}
#line 46243 "gram.c"
    break;

  case 1693: /* merge_values_clause: VALUES '(' expr_list ')'  */
#line 12739 "gram.y"
                                {
					(yyval.list) = (yyvsp[-1].list);
				}
#line 46251 "gram.c"
    break;

  case 1694: /* DeclareCursorStmt: DECLARE cursor_name cursor_options CURSOR opt_hold FOR SelectStmt  */
#line 12751 "gram.y"
                                {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);

					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 46265 "gram.c"
    break;

  case 1695: /* cursor_name: name  */
#line 12762 "gram.y"
                                                                { (yyval.str) = (yyvsp[0].str); }
#line 46271 "gram.c"
    break;

  case 1696: /* cursor_options: %empty  */
#line 12765 "gram.y"
                                                                { (yyval.ival) = 0; }
#line 46277 "gram.c"
    break;

  case 1697: /* cursor_options: cursor_options NO SCROLL  */
#line 12766 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 46283 "gram.c"
    break;

  case 1698: /* cursor_options: cursor_options SCROLL  */
#line 12767 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 46289 "gram.c"
    break;

  case 1699: /* cursor_options: cursor_options BINARY  */
#line 12768 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 46295 "gram.c"
    break;

  case 1700: /* cursor_options: cursor_options ASENSITIVE  */
#line 12769 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_ASENSITIVE; }
#line 46301 "gram.c"
    break;

  case 1701: /* cursor_options: cursor_options INSENSITIVE  */
#line 12770 "gram.y"
                                                        { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 46307 "gram.c"
    break;

  case 1702: /* opt_hold: %empty  */
#line 12773 "gram.y"
                                                                { (yyval.ival) = 0; }
#line 46313 "gram.c"
    break;

  case 1703: /* opt_hold: WITH HOLD  */
#line 12774 "gram.y"
                                                                                { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 46319 "gram.c"
    break;

  case 1704: /* opt_hold: WITHOUT HOLD  */
#line 12775 "gram.y"
                                                                        { (yyval.ival) = 0; }
#line 46325 "gram.c"
    break;

  case 1707: /* select_with_parens: '(' select_no_parens ')'  */
#line 12829 "gram.y"
                                {
					SelectStmt *n = (SelectStmt *) (yyvsp[-1].node);

					/*
					 * As SelectStmt's location starts at the SELECT keyword,
					 * we need to track the length of the SelectStmt within
					 * parentheses to be able to extract the relevant part
					 * of the query.  Without this, the RawStmt's length would
					 * be used and would include the closing parenthesis.
					 */
					n->stmt_len = (yylsp[0]) - (yylsp[-1]);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 46343 "gram.c"
    break;

  case 1708: /* select_with_parens: '(' select_with_parens ')'  */
#line 12842 "gram.y"
                                                                        { (yyval.node) = (yyvsp[-1].node); }
#line 46349 "gram.c"
    break;

  case 1709: /* select_no_parens: simple_select  */
#line 12857 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 46355 "gram.c"
    break;

  case 1710: /* select_no_parens: select_clause sort_clause  */
#line 12859 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 46366 "gram.c"
    break;

  case 1711: /* select_no_parens: select_clause opt_sort_clause for_locking_clause opt_select_limit  */
#line 12866 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 46378 "gram.c"
    break;

  case 1712: /* select_no_parens: select_clause opt_sort_clause select_limit opt_for_locking_clause  */
#line 12874 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 46390 "gram.c"
    break;

  case 1713: /* select_no_parens: with_clause select_clause  */
#line 12882 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 46402 "gram.c"
    break;

  case 1714: /* select_no_parens: with_clause select_clause sort_clause  */
#line 12890 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 46414 "gram.c"
    break;

  case 1715: /* select_no_parens: with_clause select_clause opt_sort_clause for_locking_clause opt_select_limit  */
#line 12898 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 46426 "gram.c"
    break;

  case 1716: /* select_no_parens: with_clause select_clause opt_sort_clause select_limit opt_for_locking_clause  */
#line 12906 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 46438 "gram.c"
    break;

  case 1717: /* select_clause: simple_select  */
#line 12916 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 46444 "gram.c"
    break;

  case 1718: /* select_clause: select_with_parens  */
#line 12917 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 46450 "gram.c"
    break;

  case 1719: /* simple_select: SELECT opt_all_clause opt_target_list into_clause from_clause where_clause group_clause having_clause window_clause  */
#line 12952 "gram.y"
                                {
					SelectStmt *n = makeNode(SelectStmt);

					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					n->stmt_location = (yylsp[-8]);
					(yyval.node) = (Node *) n;
				}
#line 46469 "gram.c"
    break;

  case 1720: /* simple_select: SELECT distinct_clause target_list into_clause from_clause where_clause group_clause having_clause window_clause  */
#line 12969 "gram.y"
                                {
					SelectStmt *n = makeNode(SelectStmt);

					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					n->stmt_location = (yylsp[-8]);
					(yyval.node) = (Node *) n;
				}
#line 46489 "gram.c"
    break;

  case 1721: /* simple_select: values_clause  */
#line 12984 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 46495 "gram.c"
    break;

  case 1722: /* simple_select: TABLE relation_expr  */
#line 12986 "gram.y"
                                {
					/* same as SELECT * FROM relation_expr */
					ColumnRef  *cr = makeNode(ColumnRef);
					ResTarget  *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *) cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					n->stmt_location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 46519 "gram.c"
    break;

  case 1723: /* simple_select: select_clause UNION set_quantifier select_clause  */
#line 13006 "gram.y"
                                {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 46527 "gram.c"
    break;

  case 1724: /* simple_select: select_clause INTERSECT set_quantifier select_clause  */
#line 13010 "gram.y"
                                {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 46535 "gram.c"
    break;

  case 1725: /* simple_select: select_clause EXCEPT set_quantifier select_clause  */
#line 13014 "gram.y"
                                {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 46543 "gram.c"
    break;

  case 1726: /* with_clause: WITH cte_list  */
#line 13029 "gram.y"
                        {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 46554 "gram.c"
    break;

  case 1727: /* with_clause: WITH_LA cte_list  */
#line 13036 "gram.y"
                        {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 46565 "gram.c"
    break;

  case 1728: /* with_clause: WITH RECURSIVE cte_list  */
#line 13043 "gram.y"
                        {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 46576 "gram.c"
    break;

  case 1729: /* cte_list: common_table_expr  */
#line 13052 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46582 "gram.c"
    break;

  case 1730: /* cte_list: cte_list ',' common_table_expr  */
#line 13053 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 46588 "gram.c"
    break;

  case 1731: /* common_table_expr: name opt_name_list AS opt_materialized '(' PreparableStmt ')' opt_search_clause opt_cycle_clause  */
#line 13057 "gram.y"
                        {
				CommonTableExpr *n = makeNode(CommonTableExpr);

				n->ctename = (yyvsp[-8].str);
				n->aliascolnames = (yyvsp[-7].list);
				n->ctematerialized = (yyvsp[-5].ival);
				n->ctequery = (yyvsp[-3].node);
				n->search_clause = castNode(CTESearchClause, (yyvsp[-1].node));
				n->cycle_clause = castNode(CTECycleClause, (yyvsp[0].node));
				n->location = (yylsp[-8]);
				(yyval.node) = (Node *) n;
			}
#line 46605 "gram.c"
    break;

  case 1732: /* opt_materialized: MATERIALIZED  */
#line 13072 "gram.y"
                                                                                { (yyval.ival) = CTEMaterializeAlways; }
#line 46611 "gram.c"
    break;

  case 1733: /* opt_materialized: NOT MATERIALIZED  */
#line 13073 "gram.y"
                                                                                { (yyval.ival) = CTEMaterializeNever; }
#line 46617 "gram.c"
    break;

  case 1734: /* opt_materialized: %empty  */
#line 13074 "gram.y"
                                                                                        { (yyval.ival) = CTEMaterializeDefault; }
#line 46623 "gram.c"
    break;

  case 1735: /* opt_search_clause: SEARCH DEPTH FIRST_P BY columnList SET ColId  */
#line 13079 "gram.y"
                        {
				CTESearchClause *n = makeNode(CTESearchClause);

				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = false;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 46637 "gram.c"
    break;

  case 1736: /* opt_search_clause: SEARCH BREADTH FIRST_P BY columnList SET ColId  */
#line 13089 "gram.y"
                        {
				CTESearchClause *n = makeNode(CTESearchClause);

				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = true;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 46651 "gram.c"
    break;

  case 1737: /* opt_search_clause: %empty  */
#line 13099 "gram.y"
                        {
				(yyval.node) = NULL;
			}
#line 46659 "gram.c"
    break;

  case 1738: /* opt_cycle_clause: CYCLE columnList SET ColId TO AexprConst DEFAULT AexprConst USING ColId  */
#line 13106 "gram.y"
                        {
				CTECycleClause *n = makeNode(CTECycleClause);

				n->cycle_col_list = (yyvsp[-8].list);
				n->cycle_mark_column = (yyvsp[-6].str);
				n->cycle_mark_value = (yyvsp[-4].node);
				n->cycle_mark_default = (yyvsp[-2].node);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-9]);
				(yyval.node) = (Node *) n;
			}
#line 46675 "gram.c"
    break;

  case 1739: /* opt_cycle_clause: CYCLE columnList SET ColId USING ColId  */
#line 13118 "gram.y"
                        {
				CTECycleClause *n = makeNode(CTECycleClause);

				n->cycle_col_list = (yyvsp[-4].list);
				n->cycle_mark_column = (yyvsp[-2].str);
				n->cycle_mark_value = makeBoolAConst(true, -1);
				n->cycle_mark_default = makeBoolAConst(false, -1);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-5]);
				(yyval.node) = (Node *) n;
			}
#line 46691 "gram.c"
    break;

  case 1740: /* opt_cycle_clause: %empty  */
#line 13130 "gram.y"
                        {
				(yyval.node) = NULL;
			}
#line 46699 "gram.c"
    break;

  case 1741: /* opt_with_clause: with_clause  */
#line 13136 "gram.y"
                                                                                        { (yyval.with) = (yyvsp[0].with); }
#line 46705 "gram.c"
    break;

  case 1742: /* opt_with_clause: %empty  */
#line 13137 "gram.y"
                                                                                        { (yyval.with) = NULL; }
#line 46711 "gram.c"
    break;

  case 1743: /* into_clause: INTO OptTempTableName  */
#line 13142 "gram.y"
                                {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
#line 46726 "gram.c"
    break;

  case 1744: /* into_clause: %empty  */
#line 13153 "gram.y"
                                { (yyval.into) = NULL; }
#line 46732 "gram.c"
    break;

  case 1745: /* OptTempTableName: TEMPORARY opt_table qualified_name  */
#line 13162 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46741 "gram.c"
    break;

  case 1746: /* OptTempTableName: TEMP opt_table qualified_name  */
#line 13167 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46750 "gram.c"
    break;

  case 1747: /* OptTempTableName: LOCAL TEMPORARY opt_table qualified_name  */
#line 13172 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46759 "gram.c"
    break;

  case 1748: /* OptTempTableName: LOCAL TEMP opt_table qualified_name  */
#line 13177 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46768 "gram.c"
    break;

  case 1749: /* OptTempTableName: GLOBAL TEMPORARY opt_table qualified_name  */
#line 13182 "gram.y"
                                {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46780 "gram.c"
    break;

  case 1750: /* OptTempTableName: GLOBAL TEMP opt_table qualified_name  */
#line 13190 "gram.y"
                                {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46792 "gram.c"
    break;

  case 1751: /* OptTempTableName: UNLOGGED opt_table qualified_name  */
#line 13198 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 46801 "gram.c"
    break;

  case 1752: /* OptTempTableName: TABLE qualified_name  */
#line 13203 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 46810 "gram.c"
    break;

  case 1753: /* OptTempTableName: qualified_name  */
#line 13208 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 46819 "gram.c"
    break;

  case 1756: /* set_quantifier: ALL  */
#line 13219 "gram.y"
                                                                                                        { (yyval.setquantifier) = SET_QUANTIFIER_ALL; }
#line 46825 "gram.c"
    break;

  case 1757: /* set_quantifier: DISTINCT  */
#line 13220 "gram.y"
                                                                                                { (yyval.setquantifier) = SET_QUANTIFIER_DISTINCT; }
#line 46831 "gram.c"
    break;

  case 1758: /* set_quantifier: %empty  */
#line 13221 "gram.y"
                                                                                                { (yyval.setquantifier) = SET_QUANTIFIER_DEFAULT; }
#line 46837 "gram.c"
    break;

  case 1759: /* distinct_clause: DISTINCT  */
#line 13228 "gram.y"
                                                                                                { (yyval.list) = list_make1(NIL); }
#line 46843 "gram.c"
    break;

  case 1760: /* distinct_clause: DISTINCT ON '(' expr_list ')'  */
#line 13229 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 46849 "gram.c"
    break;

  case 1763: /* opt_distinct_clause: distinct_clause  */
#line 13238 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 46855 "gram.c"
    break;

  case 1764: /* opt_distinct_clause: opt_all_clause  */
#line 13239 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 46861 "gram.c"
    break;

  case 1765: /* opt_sort_clause: sort_clause  */
#line 13243 "gram.y"
                                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 46867 "gram.c"
    break;

  case 1766: /* opt_sort_clause: %empty  */
#line 13244 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 46873 "gram.c"
    break;

  case 1767: /* sort_clause: ORDER BY sortby_list  */
#line 13248 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 46879 "gram.c"
    break;

  case 1768: /* sortby_list: sortby  */
#line 13252 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 46885 "gram.c"
    break;

  case 1769: /* sortby_list: sortby_list ',' sortby  */
#line 13253 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 46891 "gram.c"
    break;

  case 1770: /* sortby: a_expr USING qual_all_Op opt_nulls_order  */
#line 13257 "gram.y"
                                {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 46904 "gram.c"
    break;

  case 1771: /* sortby: a_expr opt_asc_desc opt_nulls_order  */
#line 13266 "gram.y"
                                {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 46917 "gram.c"
    break;

  case 1772: /* select_limit: limit_clause offset_clause  */
#line 13279 "gram.y"
                                {
					(yyval.selectlimit) = (yyvsp[-1].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[0].node);
					((yyval.selectlimit))->offsetLoc = (yylsp[0]);
				}
#line 46927 "gram.c"
    break;

  case 1773: /* select_limit: offset_clause limit_clause  */
#line 13285 "gram.y"
                                {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[-1].node);
					((yyval.selectlimit))->offsetLoc = (yylsp[-1]);
				}
#line 46937 "gram.c"
    break;

  case 1774: /* select_limit: limit_clause  */
#line 13291 "gram.y"
                                {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
				}
#line 46945 "gram.c"
    break;

  case 1775: /* select_limit: offset_clause  */
#line 13295 "gram.y"
                                {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = (yyvsp[0].node);
					n->limitCount = NULL;
					n->limitOption = LIMIT_OPTION_COUNT;
					n->offsetLoc = (yylsp[0]);
					n->countLoc = -1;
					n->optionLoc = -1;
					(yyval.selectlimit) = n;
				}
#line 46961 "gram.c"
    break;

  case 1776: /* opt_select_limit: select_limit  */
#line 13309 "gram.y"
                                                                                { (yyval.selectlimit) = (yyvsp[0].selectlimit); }
#line 46967 "gram.c"
    break;

  case 1777: /* opt_select_limit: %empty  */
#line 13310 "gram.y"
                                                                                { (yyval.selectlimit) = NULL; }
#line 46973 "gram.c"
    break;

  case 1778: /* limit_clause: LIMIT select_limit_value  */
#line 13315 "gram.y"
                                {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[0].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					n->offsetLoc = -1;
					n->countLoc = (yylsp[-1]);
					n->optionLoc = -1;
					(yyval.selectlimit) = n;
				}
#line 46989 "gram.c"
    break;

  case 1779: /* limit_clause: LIMIT select_limit_value ',' select_offset_value  */
#line 13327 "gram.y"
                                {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 47002 "gram.c"
    break;

  case 1780: /* limit_clause: FETCH first_or_next select_fetch_first_value row_or_rows ONLY  */
#line 13343 "gram.y"
                                {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-2].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					n->offsetLoc = -1;
					n->countLoc = (yylsp[-4]);
					n->optionLoc = -1;
					(yyval.selectlimit) = n;
				}
#line 47018 "gram.c"
    break;

  case 1781: /* limit_clause: FETCH first_or_next select_fetch_first_value row_or_rows WITH TIES  */
#line 13355 "gram.y"
                                {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-3].node);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					n->offsetLoc = -1;
					n->countLoc = (yylsp[-5]);
					n->optionLoc = (yylsp[-1]);
					(yyval.selectlimit) = n;
				}
#line 47034 "gram.c"
    break;

  case 1782: /* limit_clause: FETCH first_or_next row_or_rows ONLY  */
#line 13367 "gram.y"
                                {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_COUNT;
					n->offsetLoc = -1;
					n->countLoc = (yylsp[-3]);
					n->optionLoc = -1;
					(yyval.selectlimit) = n;
				}
#line 47050 "gram.c"
    break;

  case 1783: /* limit_clause: FETCH first_or_next row_or_rows WITH TIES  */
#line 13379 "gram.y"
                                {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					n->offsetLoc = -1;
					n->countLoc = (yylsp[-4]);
					n->optionLoc = (yylsp[-1]);
					(yyval.selectlimit) = n;
				}
#line 47066 "gram.c"
    break;

  case 1784: /* offset_clause: OFFSET select_offset_value  */
#line 13394 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 47072 "gram.c"
    break;

  case 1785: /* offset_clause: OFFSET select_fetch_first_value row_or_rows  */
#line 13397 "gram.y"
                                { (yyval.node) = (yyvsp[-1].node); }
#line 47078 "gram.c"
    break;

  case 1786: /* select_limit_value: a_expr  */
#line 13401 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 47084 "gram.c"
    break;

  case 1787: /* select_limit_value: ALL  */
#line 13403 "gram.y"
                                {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 47093 "gram.c"
    break;

  case 1788: /* select_offset_value: a_expr  */
#line 13410 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 47099 "gram.c"
    break;

  case 1789: /* select_fetch_first_value: c_expr  */
#line 13430 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 47105 "gram.c"
    break;

  case 1790: /* select_fetch_first_value: '+' I_or_F_const  */
#line 13432 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 47111 "gram.c"
    break;

  case 1791: /* select_fetch_first_value: '-' I_or_F_const  */
#line 13434 "gram.y"
                                { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 47117 "gram.c"
    break;

  case 1792: /* I_or_F_const: Iconst  */
#line 13438 "gram.y"
                                                                                                { (yyval.node) = makeIntConst((yyvsp[0].ival),(yylsp[0])); }
#line 47123 "gram.c"
    break;

  case 1793: /* I_or_F_const: FCONST  */
#line 13439 "gram.y"
                                                                                                { (yyval.node) = makeFloatConst((yyvsp[0].str),(yylsp[0])); }
#line 47129 "gram.c"
    break;

  case 1794: /* row_or_rows: ROW  */
#line 13443 "gram.y"
                                                                                        { (yyval.ival) = 0; }
#line 47135 "gram.c"
    break;

  case 1795: /* row_or_rows: ROWS  */
#line 13444 "gram.y"
                                                                                                { (yyval.ival) = 0; }
#line 47141 "gram.c"
    break;

  case 1796: /* first_or_next: FIRST_P  */
#line 13447 "gram.y"
                                                                                { (yyval.ival) = 0; }
#line 47147 "gram.c"
    break;

  case 1797: /* first_or_next: NEXT  */
#line 13448 "gram.y"
                                                                                                { (yyval.ival) = 0; }
#line 47153 "gram.c"
    break;

  case 1798: /* group_clause: GROUP_P BY set_quantifier group_by_list  */
#line 13474 "gram.y"
                                {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));

					n->distinct = (yyvsp[-1].setquantifier) == SET_QUANTIFIER_DISTINCT;
					n->list = (yyvsp[0].list);
					(yyval.groupclause) = n;
				}
#line 47165 "gram.c"
    break;

  case 1799: /* group_clause: %empty  */
#line 13482 "gram.y"
                                {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));

					n->distinct = false;
					n->list = NIL;
					(yyval.groupclause) = n;
				}
#line 47177 "gram.c"
    break;

  case 1800: /* group_by_list: group_by_item  */
#line 13492 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 47183 "gram.c"
    break;

  case 1801: /* group_by_list: group_by_list ',' group_by_item  */
#line 13493 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].node)); }
#line 47189 "gram.c"
    break;

  case 1802: /* group_by_item: a_expr  */
#line 13497 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 47195 "gram.c"
    break;

  case 1803: /* group_by_item: empty_grouping_set  */
#line 13498 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 47201 "gram.c"
    break;

  case 1804: /* group_by_item: cube_clause  */
#line 13499 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 47207 "gram.c"
    break;

  case 1805: /* group_by_item: rollup_clause  */
#line 13500 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 47213 "gram.c"
    break;

  case 1806: /* group_by_item: grouping_sets_clause  */
#line 13501 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 47219 "gram.c"
    break;

  case 1807: /* empty_grouping_set: '(' ')'  */
#line 13506 "gram.y"
                                {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_EMPTY, NIL, (yylsp[-1]));
				}
#line 47227 "gram.c"
    break;

  case 1808: /* rollup_clause: ROLLUP '(' expr_list ')'  */
#line 13519 "gram.y"
                                {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_ROLLUP, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 47235 "gram.c"
    break;

  case 1809: /* cube_clause: CUBE '(' expr_list ')'  */
#line 13526 "gram.y"
                                {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_CUBE, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 47243 "gram.c"
    break;

  case 1810: /* grouping_sets_clause: GROUPING SETS '(' group_by_list ')'  */
#line 13533 "gram.y"
                                {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_SETS, (yyvsp[-1].list), (yylsp[-4]));
				}
#line 47251 "gram.c"
    break;

  case 1811: /* having_clause: HAVING a_expr  */
#line 13539 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 47257 "gram.c"
    break;

  case 1812: /* having_clause: %empty  */
#line 13540 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 47263 "gram.c"
    break;

  case 1813: /* for_locking_clause: for_locking_items  */
#line 13544 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 47269 "gram.c"
    break;

  case 1814: /* for_locking_clause: FOR READ ONLY  */
#line 13545 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 47275 "gram.c"
    break;

  case 1815: /* opt_for_locking_clause: for_locking_clause  */
#line 13549 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 47281 "gram.c"
    break;

  case 1816: /* opt_for_locking_clause: %empty  */
#line 13550 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 47287 "gram.c"
    break;

  case 1817: /* for_locking_items: for_locking_item  */
#line 13554 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 47293 "gram.c"
    break;

  case 1818: /* for_locking_items: for_locking_items for_locking_item  */
#line 13555 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 47299 "gram.c"
    break;

  case 1819: /* for_locking_item: for_locking_strength locked_rels_list opt_nowait_or_skip  */
#line 13560 "gram.y"
                                {
					LockingClause *n = makeNode(LockingClause);

					n->lockedRels = (yyvsp[-1].list);
					n->strength = (yyvsp[-2].ival);
					n->waitPolicy = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 47312 "gram.c"
    break;

  case 1820: /* for_locking_strength: FOR UPDATE  */
#line 13571 "gram.y"
                                                                                        { (yyval.ival) = LCS_FORUPDATE; }
#line 47318 "gram.c"
    break;

  case 1821: /* for_locking_strength: FOR NO KEY UPDATE  */
#line 13572 "gram.y"
                                                                                { (yyval.ival) = LCS_FORNOKEYUPDATE; }
#line 47324 "gram.c"
    break;

  case 1822: /* for_locking_strength: FOR SHARE  */
#line 13573 "gram.y"
                                                                                        { (yyval.ival) = LCS_FORSHARE; }
#line 47330 "gram.c"
    break;

  case 1823: /* for_locking_strength: FOR KEY SHARE  */
#line 13574 "gram.y"
                                                                                { (yyval.ival) = LCS_FORKEYSHARE; }
#line 47336 "gram.c"
    break;

  case 1824: /* locked_rels_list: OF qualified_name_list  */
#line 13578 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 47342 "gram.c"
    break;

  case 1825: /* locked_rels_list: %empty  */
#line 13579 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 47348 "gram.c"
    break;

  case 1826: /* values_clause: VALUES '(' expr_list ')'  */
#line 13590 "gram.y"
                                {
					SelectStmt *n = makeNode(SelectStmt);

					n->stmt_location = (yylsp[-3]);
					n->valuesLists = list_make1((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 47360 "gram.c"
    break;

  case 1827: /* values_clause: values_clause ',' '(' expr_list ')'  */
#line 13598 "gram.y"
                                {
					SelectStmt *n = (SelectStmt *) (yyvsp[-4].node);

					n->valuesLists = lappend(n->valuesLists, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 47371 "gram.c"
    break;

  case 1828: /* from_clause: FROM from_list  */
#line 13616 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 47377 "gram.c"
    break;

  case 1829: /* from_clause: %empty  */
#line 13617 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 47383 "gram.c"
    break;

  case 1830: /* from_list: table_ref  */
#line 13621 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 47389 "gram.c"
    break;

  case 1831: /* from_list: from_list ',' table_ref  */
#line 13622 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 47395 "gram.c"
    break;

  case 1832: /* table_ref: relation_expr opt_alias_clause  */
#line 13629 "gram.y"
                                {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 47404 "gram.c"
    break;

  case 1833: /* table_ref: relation_expr opt_alias_clause tablesample_clause  */
#line 13634 "gram.y"
                                {
					RangeTableSample *n = (RangeTableSample *) (yyvsp[0].node);

					(yyvsp[-2].range)->alias = (yyvsp[-1].alias);
					/* relation_expr goes inside the RangeTableSample node */
					n->relation = (Node *) (yyvsp[-2].range);
					(yyval.node) = (Node *) n;
				}
#line 47417 "gram.c"
    break;

  case 1834: /* table_ref: func_table func_alias_clause  */
#line 13643 "gram.y"
                                {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);

					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 47429 "gram.c"
    break;

  case 1835: /* table_ref: LATERAL_P func_table func_alias_clause  */
#line 13651 "gram.y"
                                {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);

					n->lateral = true;
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 47442 "gram.c"
    break;

  case 1836: /* table_ref: xmltable opt_alias_clause  */
#line 13660 "gram.y"
                                {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);

					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 47453 "gram.c"
    break;

  case 1837: /* table_ref: LATERAL_P xmltable opt_alias_clause  */
#line 13667 "gram.y"
                                {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);

					n->lateral = true;
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 47465 "gram.c"
    break;

  case 1838: /* table_ref: select_with_parens opt_alias_clause  */
#line 13675 "gram.y"
                                {
					RangeSubselect *n = makeNode(RangeSubselect);

					n->lateral = false;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 47478 "gram.c"
    break;

  case 1839: /* table_ref: LATERAL_P select_with_parens opt_alias_clause  */
#line 13684 "gram.y"
                                {
					RangeSubselect *n = makeNode(RangeSubselect);

					n->lateral = true;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 47491 "gram.c"
    break;

  case 1840: /* table_ref: joined_table  */
#line 13693 "gram.y"
                                {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 47499 "gram.c"
    break;

  case 1841: /* table_ref: '(' joined_table ')' alias_clause  */
#line 13697 "gram.y"
                                {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 47508 "gram.c"
    break;

  case 1842: /* table_ref: json_table opt_alias_clause  */
#line 13702 "gram.y"
                                {
					JsonTable  *jt = castNode(JsonTable, (yyvsp[-1].node));

					jt->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) jt;
				}
#line 47519 "gram.c"
    break;

  case 1843: /* table_ref: LATERAL_P json_table opt_alias_clause  */
#line 13709 "gram.y"
                                {
					JsonTable  *jt = castNode(JsonTable, (yyvsp[-1].node));

					jt->alias = (yyvsp[0].alias);
					jt->lateral = true;
					(yyval.node) = (Node *) jt;
				}
#line 47531 "gram.c"
    break;

  case 1844: /* joined_table: '(' joined_table ')'  */
#line 13738 "gram.y"
                                {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 47539 "gram.c"
    break;

  case 1845: /* joined_table: table_ref CROSS JOIN table_ref  */
#line 13742 "gram.y"
                                {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->join_using_alias = NULL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 47557 "gram.c"
    break;

  case 1846: /* joined_table: table_ref join_type JOIN table_ref join_qual  */
#line 13756 "gram.y"
                                {
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = false;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						 /* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 47582 "gram.c"
    break;

  case 1847: /* joined_table: table_ref JOIN table_ref join_qual  */
#line 13777 "gram.y"
                                {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						/* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 47608 "gram.c"
    break;

  case 1848: /* joined_table: table_ref NATURAL join_type JOIN table_ref  */
#line 13799 "gram.y"
                                {
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = true;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 47625 "gram.c"
    break;

  case 1849: /* joined_table: table_ref NATURAL JOIN table_ref  */
#line 13812 "gram.y"
                                {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = true;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 47643 "gram.c"
    break;

  case 1850: /* alias_clause: AS ColId '(' name_list ')'  */
#line 13829 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 47653 "gram.c"
    break;

  case 1851: /* alias_clause: AS ColId  */
#line 13835 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 47662 "gram.c"
    break;

  case 1852: /* alias_clause: ColId '(' name_list ')'  */
#line 13840 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 47672 "gram.c"
    break;

  case 1853: /* alias_clause: ColId  */
#line 13846 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 47681 "gram.c"
    break;

  case 1854: /* opt_alias_clause: alias_clause  */
#line 13852 "gram.y"
                                                                        { (yyval.alias) = (yyvsp[0].alias); }
#line 47687 "gram.c"
    break;

  case 1855: /* opt_alias_clause: %empty  */
#line 13853 "gram.y"
                                                                                                { (yyval.alias) = NULL; }
#line 47693 "gram.c"
    break;

  case 1856: /* opt_alias_clause_for_join_using: AS ColId  */
#line 13864 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
					/* the column name list will be inserted later */
				}
#line 47703 "gram.c"
    break;

  case 1857: /* opt_alias_clause_for_join_using: %empty  */
#line 13869 "gram.y"
                                                                                                { (yyval.alias) = NULL; }
#line 47709 "gram.c"
    break;

  case 1858: /* func_alias_clause: alias_clause  */
#line 13878 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[0].alias), NIL);
				}
#line 47717 "gram.c"
    break;

  case 1859: /* func_alias_clause: AS '(' TableFuncElementList ')'  */
#line 13882 "gram.y"
                                {
					(yyval.list) = list_make2(NULL, (yyvsp[-1].list));
				}
#line 47725 "gram.c"
    break;

  case 1860: /* func_alias_clause: AS ColId '(' TableFuncElementList ')'  */
#line 13886 "gram.y"
                                {
					Alias	   *a = makeNode(Alias);

					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 47736 "gram.c"
    break;

  case 1861: /* func_alias_clause: ColId '(' TableFuncElementList ')'  */
#line 13893 "gram.y"
                                {
					Alias	   *a = makeNode(Alias);

					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 47747 "gram.c"
    break;

  case 1862: /* func_alias_clause: %empty  */
#line 13900 "gram.y"
                                {
					(yyval.list) = list_make2(NULL, NIL);
				}
#line 47755 "gram.c"
    break;

  case 1863: /* join_type: FULL opt_outer  */
#line 13905 "gram.y"
                                                                                { (yyval.jtype) = JOIN_FULL; }
#line 47761 "gram.c"
    break;

  case 1864: /* join_type: LEFT opt_outer  */
#line 13906 "gram.y"
                                                                                        { (yyval.jtype) = JOIN_LEFT; }
#line 47767 "gram.c"
    break;

  case 1865: /* join_type: RIGHT opt_outer  */
#line 13907 "gram.y"
                                                                                        { (yyval.jtype) = JOIN_RIGHT; }
#line 47773 "gram.c"
    break;

  case 1866: /* join_type: INNER_P  */
#line 13908 "gram.y"
                                                                                                { (yyval.jtype) = JOIN_INNER; }
#line 47779 "gram.c"
    break;

  case 1869: /* join_qual: USING '(' name_list ')' opt_alias_clause_for_join_using  */
#line 13929 "gram.y"
                                {
					(yyval.node) = (Node *) list_make2((yyvsp[-2].list), (yyvsp[0].alias));
				}
#line 47787 "gram.c"
    break;

  case 1870: /* join_qual: ON a_expr  */
#line 13933 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 47795 "gram.c"
    break;

  case 1871: /* relation_expr: qualified_name  */
#line 13941 "gram.y"
                                {
					/* inheritance query, implicitly */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 47806 "gram.c"
    break;

  case 1872: /* relation_expr: extended_relation_expr  */
#line 13948 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
				}
#line 47814 "gram.c"
    break;

  case 1873: /* extended_relation_expr: qualified_name '*'  */
#line 13955 "gram.y"
                                {
					/* inheritance query, explicitly */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 47825 "gram.c"
    break;

  case 1874: /* extended_relation_expr: ONLY qualified_name  */
#line 13962 "gram.y"
                                {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 47836 "gram.c"
    break;

  case 1875: /* extended_relation_expr: ONLY '(' qualified_name ')'  */
#line 13969 "gram.y"
                                {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 47847 "gram.c"
    break;

  case 1876: /* relation_expr_list: relation_expr  */
#line 13979 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 47853 "gram.c"
    break;

  case 1877: /* relation_expr_list: relation_expr_list ',' relation_expr  */
#line 13980 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 47859 "gram.c"
    break;

  case 1878: /* relation_expr_opt_alias: relation_expr  */
#line 13994 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
				}
#line 47867 "gram.c"
    break;

  case 1879: /* relation_expr_opt_alias: relation_expr ColId  */
#line 13998 "gram.y"
                                {
					Alias	   *alias = makeNode(Alias);

					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 47879 "gram.c"
    break;

  case 1880: /* relation_expr_opt_alias: relation_expr AS ColId  */
#line 14006 "gram.y"
                                {
					Alias	   *alias = makeNode(Alias);

					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 47891 "gram.c"
    break;

  case 1881: /* tablesample_clause: TABLESAMPLE func_name '(' expr_list ')' opt_repeatable_clause  */
#line 14020 "gram.y"
                                {
					RangeTableSample *n = makeNode(RangeTableSample);

					/* n->relation will be filled in later */
					n->method = (yyvsp[-4].list);
					n->args = (yyvsp[-2].list);
					n->repeatable = (yyvsp[0].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 47906 "gram.c"
    break;

  case 1882: /* opt_repeatable_clause: REPEATABLE '(' a_expr ')'  */
#line 14033 "gram.y"
                                                        { (yyval.node) = (Node *) (yyvsp[-1].node); }
#line 47912 "gram.c"
    break;

  case 1883: /* opt_repeatable_clause: %empty  */
#line 14034 "gram.y"
                                                                        { (yyval.node) = NULL; }
#line 47918 "gram.c"
    break;

  case 1884: /* func_table: func_expr_windowless opt_ordinality  */
#line 14050 "gram.y"
                                {
					RangeFunction *n = makeNode(RangeFunction);

					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[-1].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 47933 "gram.c"
    break;

  case 1885: /* func_table: ROWS FROM '(' rowsfrom_list ')' opt_ordinality  */
#line 14061 "gram.y"
                                {
					RangeFunction *n = makeNode(RangeFunction);

					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[-2].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 47948 "gram.c"
    break;

  case 1886: /* rowsfrom_item: func_expr_windowless opt_col_def_list  */
#line 14074 "gram.y"
                                { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].list)); }
#line 47954 "gram.c"
    break;

  case 1887: /* rowsfrom_list: rowsfrom_item  */
#line 14078 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 47960 "gram.c"
    break;

  case 1888: /* rowsfrom_list: rowsfrom_list ',' rowsfrom_item  */
#line 14079 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 47966 "gram.c"
    break;

  case 1889: /* opt_col_def_list: AS '(' TableFuncElementList ')'  */
#line 14082 "gram.y"
                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 47972 "gram.c"
    break;

  case 1890: /* opt_col_def_list: %empty  */
#line 14083 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 47978 "gram.c"
    break;

  case 1891: /* opt_ordinality: WITH_LA ORDINALITY  */
#line 14086 "gram.y"
                                                                        { (yyval.boolean) = true; }
#line 47984 "gram.c"
    break;

  case 1892: /* opt_ordinality: %empty  */
#line 14087 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 47990 "gram.c"
    break;

  case 1893: /* where_clause: WHERE a_expr  */
#line 14092 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 47996 "gram.c"
    break;

  case 1894: /* where_clause: %empty  */
#line 14093 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 48002 "gram.c"
    break;

  case 1895: /* where_or_current_clause: WHERE a_expr  */
#line 14098 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 48008 "gram.c"
    break;

  case 1896: /* where_or_current_clause: WHERE CURRENT_P OF cursor_name  */
#line 14100 "gram.y"
                                {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);

					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 48021 "gram.c"
    break;

  case 1897: /* where_or_current_clause: %empty  */
#line 14108 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 48027 "gram.c"
    break;

  case 1898: /* OptTableFuncElementList: TableFuncElementList  */
#line 14113 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 48033 "gram.c"
    break;

  case 1899: /* OptTableFuncElementList: %empty  */
#line 14114 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 48039 "gram.c"
    break;

  case 1900: /* TableFuncElementList: TableFuncElement  */
#line 14119 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 48047 "gram.c"
    break;

  case 1901: /* TableFuncElementList: TableFuncElementList ',' TableFuncElement  */
#line 14123 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 48055 "gram.c"
    break;

  case 1902: /* TableFuncElement: ColId Typename opt_collate_clause  */
#line 14129 "gram.y"
                                {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 48078 "gram.c"
    break;

  case 1903: /* xmltable: XMLTABLE '(' c_expr xmlexists_argument COLUMNS xmltable_column_list ')'  */
#line 14154 "gram.y"
                                {
					RangeTableFunc *n = makeNode(RangeTableFunc);

					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = NIL;
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 48093 "gram.c"
    break;

  case 1904: /* xmltable: XMLTABLE '(' XMLNAMESPACES '(' xml_namespace_list ')' ',' c_expr xmlexists_argument COLUMNS xmltable_column_list ')'  */
#line 14166 "gram.y"
                                {
					RangeTableFunc *n = makeNode(RangeTableFunc);

					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = (yyvsp[-7].list);
					n->location = (yylsp[-11]);
					(yyval.node) = (Node *) n;
				}
#line 48108 "gram.c"
    break;

  case 1905: /* xmltable_column_list: xmltable_column_el  */
#line 14178 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 48114 "gram.c"
    break;

  case 1906: /* xmltable_column_list: xmltable_column_list ',' xmltable_column_el  */
#line 14179 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 48120 "gram.c"
    break;

  case 1907: /* xmltable_column_el: ColId Typename  */
#line 14184 "gram.y"
                                {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-1].str);
					fc->for_ordinality = false;
					fc->typeName = (yyvsp[0].typnam);
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-1]);

					(yyval.node) = (Node *) fc;
				}
#line 48138 "gram.c"
    break;

  case 1908: /* xmltable_column_el: ColId Typename xmltable_column_option_list  */
#line 14198 "gram.y"
                                {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);
					ListCell   *option;
					bool		nullability_seen = false;

					fc->colname = (yyvsp[-2].str);
					fc->typeName = (yyvsp[-1].typnam);
					fc->for_ordinality = false;
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-2]);

					foreach(option, (yyvsp[0].list))
					{
						DefElem   *defel = (DefElem *) lfirst(option);

						if (strcmp(defel->defname, "default") == 0)
						{
							if (fc->coldefexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one DEFAULT value is allowed"),
										 parser_errposition(defel->location)));
							fc->coldefexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "path") == 0)
						{
							if (fc->colexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one PATH value per column is allowed"),
										 parser_errposition(defel->location)));
							fc->colexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "is_not_null") == 0)
						{
							if (nullability_seen)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("conflicting or redundant NULL / NOT NULL declarations for column \"%s\"", fc->colname),
										 parser_errposition(defel->location)));
							fc->is_not_null = boolVal(defel->arg);
							nullability_seen = true;
						}
						else
						{
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized column option \"%s\"",
											defel->defname),
									 parser_errposition(defel->location)));
						}
					}
					(yyval.node) = (Node *) fc;
				}
#line 48199 "gram.c"
    break;

  case 1909: /* xmltable_column_el: ColId FOR ORDINALITY  */
#line 14255 "gram.y"
                                {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-2].str);
					fc->for_ordinality = true;
					/* other fields are ignored, initialized by makeNode */
					fc->location = (yylsp[-2]);

					(yyval.node) = (Node *) fc;
				}
#line 48214 "gram.c"
    break;

  case 1910: /* xmltable_column_option_list: xmltable_column_option_el  */
#line 14269 "gram.y"
                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 48220 "gram.c"
    break;

  case 1911: /* xmltable_column_option_list: xmltable_column_option_list xmltable_column_option_el  */
#line 14271 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 48226 "gram.c"
    break;

  case 1912: /* xmltable_column_option_el: IDENT b_expr  */
#line 14276 "gram.y"
                                { (yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1])); }
#line 48232 "gram.c"
    break;

  case 1913: /* xmltable_column_option_el: DEFAULT b_expr  */
#line 14278 "gram.y"
                                { (yyval.defelt) = makeDefElem("default", (yyvsp[0].node), (yylsp[-1])); }
#line 48238 "gram.c"
    break;

  case 1914: /* xmltable_column_option_el: NOT NULL_P  */
#line 14280 "gram.y"
                                { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeBoolean(true), (yylsp[-1])); }
#line 48244 "gram.c"
    break;

  case 1915: /* xmltable_column_option_el: NULL_P  */
#line 14282 "gram.y"
                                { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeBoolean(false), (yylsp[0])); }
#line 48250 "gram.c"
    break;

  case 1916: /* xmltable_column_option_el: PATH b_expr  */
#line 14284 "gram.y"
                                { (yyval.defelt) = makeDefElem("path", (yyvsp[0].node), (yylsp[-1])); }
#line 48256 "gram.c"
    break;

  case 1917: /* xml_namespace_list: xml_namespace_el  */
#line 14289 "gram.y"
                                { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 48262 "gram.c"
    break;

  case 1918: /* xml_namespace_list: xml_namespace_list ',' xml_namespace_el  */
#line 14291 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 48268 "gram.c"
    break;

  case 1919: /* xml_namespace_el: b_expr AS ColLabel  */
#line 14296 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 48280 "gram.c"
    break;

  case 1920: /* xml_namespace_el: DEFAULT b_expr  */
#line 14304 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[0].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 48292 "gram.c"
    break;

  case 1921: /* json_table: JSON_TABLE '(' json_value_expr ',' a_expr json_table_path_name_opt json_passing_clause_opt COLUMNS '(' json_table_column_definition_list ')' json_on_error_clause_opt ')'  */
#line 14320 "gram.y"
                                {
					JsonTable *n = makeNode(JsonTable);
					char	  *pathstring;

					n->context_item = (JsonValueExpr *) (yyvsp[-10].node);
					if (!IsA((yyvsp[-8].node), A_Const) ||
						castNode(A_Const, (yyvsp[-8].node))->val.node.type != T_String)
						ereport(ERROR,
								errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								errmsg("only string constants are supported in JSON_TABLE path specification"),
								parser_errposition((yylsp[-8])));
					pathstring = castNode(A_Const, (yyvsp[-8].node))->val.sval.sval;
					n->pathspec = makeJsonTablePathSpec(pathstring, (yyvsp[-7].str), (yylsp[-8]), (yylsp[-7]));
					n->passing = (yyvsp[-6].list);
					n->columns = (yyvsp[-3].list);
					n->on_error = (JsonBehavior *) (yyvsp[-1].node);
					n->location = (yylsp[-12]);
					(yyval.node) = (Node *) n;
				}
#line 48316 "gram.c"
    break;

  case 1922: /* json_table_path_name_opt: AS name  */
#line 14342 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 48322 "gram.c"
    break;

  case 1923: /* json_table_path_name_opt: %empty  */
#line 14343 "gram.y"
                                        { (yyval.str) = NULL; }
#line 48328 "gram.c"
    break;

  case 1924: /* json_table_column_definition_list: json_table_column_definition  */
#line 14348 "gram.y"
                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 48334 "gram.c"
    break;

  case 1925: /* json_table_column_definition_list: json_table_column_definition_list ',' json_table_column_definition  */
#line 14350 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 48340 "gram.c"
    break;

  case 1926: /* json_table_column_definition: ColId FOR ORDINALITY  */
#line 14355 "gram.y"
                                {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_FOR_ORDINALITY;
					n->name = (yyvsp[-2].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 48353 "gram.c"
    break;

  case 1927: /* json_table_column_definition: ColId Typename json_table_column_path_clause_opt json_wrapper_behavior json_quotes_clause_opt json_behavior_clause_opt  */
#line 14368 "gram.y"
                                {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_REGULAR;
					n->name = (yyvsp[-5].str);
					n->typeName = (yyvsp[-4].typnam);
					n->format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);
					n->pathspec = (JsonTablePathSpec *) (yyvsp[-3].node);
					n->wrapper = (yyvsp[-2].ival);
					n->quotes = (yyvsp[-1].ival);
					n->on_empty = (JsonBehavior *) linitial((yyvsp[0].list));
					n->on_error = (JsonBehavior *) lsecond((yyvsp[0].list));
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 48373 "gram.c"
    break;

  case 1928: /* json_table_column_definition: ColId Typename json_format_clause json_table_column_path_clause_opt json_wrapper_behavior json_quotes_clause_opt json_behavior_clause_opt  */
#line 14388 "gram.y"
                                {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_FORMATTED;
					n->name = (yyvsp[-6].str);
					n->typeName = (yyvsp[-5].typnam);
					n->format = (JsonFormat *) (yyvsp[-4].node);
					n->pathspec = (JsonTablePathSpec *) (yyvsp[-3].node);
					n->wrapper = (yyvsp[-2].ival);
					n->quotes = (yyvsp[-1].ival);
					n->on_empty = (JsonBehavior *) linitial((yyvsp[0].list));
					n->on_error = (JsonBehavior *) lsecond((yyvsp[0].list));
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 48393 "gram.c"
    break;

  case 1929: /* json_table_column_definition: ColId Typename EXISTS json_table_column_path_clause_opt json_on_error_clause_opt  */
#line 14406 "gram.y"
                                {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_EXISTS;
					n->name = (yyvsp[-4].str);
					n->typeName = (yyvsp[-3].typnam);
					n->format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);
					n->wrapper = JSW_NONE;
					n->quotes = JS_QUOTES_UNSPEC;
					n->pathspec = (JsonTablePathSpec *) (yyvsp[-1].node);
					n->on_empty = NULL;
					n->on_error = (JsonBehavior *) (yyvsp[0].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 48413 "gram.c"
    break;

  case 1930: /* json_table_column_definition: NESTED path_opt Sconst COLUMNS '(' json_table_column_definition_list ')'  */
#line 14423 "gram.y"
                                {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_NESTED;
					n->pathspec = (JsonTablePathSpec *)
						makeJsonTablePathSpec((yyvsp[-4].str), NULL, (yylsp[-4]), -1);
					n->columns = (yyvsp[-1].list);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 48428 "gram.c"
    break;

  case 1931: /* json_table_column_definition: NESTED path_opt Sconst AS name COLUMNS '(' json_table_column_definition_list ')'  */
#line 14435 "gram.y"
                                {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_NESTED;
					n->pathspec = (JsonTablePathSpec *)
						makeJsonTablePathSpec((yyvsp[-6].str), (yyvsp[-4].str), (yylsp[-6]), (yylsp[-4]));
					n->columns = (yyvsp[-1].list);
					n->location = (yylsp[-8]);
					(yyval.node) = (Node *) n;
				}
#line 48443 "gram.c"
    break;

  case 1934: /* json_table_column_path_clause_opt: PATH Sconst  */
#line 14454 "gram.y"
                                { (yyval.node) = (Node *) makeJsonTablePathSpec((yyvsp[0].str), NULL, (yylsp[0]), -1); }
#line 48449 "gram.c"
    break;

  case 1935: /* json_table_column_path_clause_opt: %empty  */
#line 14456 "gram.y"
                                { (yyval.node) = NULL; }
#line 48455 "gram.c"
    break;

  case 1936: /* Typename: SimpleTypename opt_array_bounds  */
#line 14470 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 48464 "gram.c"
    break;

  case 1937: /* Typename: SETOF SimpleTypename opt_array_bounds  */
#line 14475 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = true;
				}
#line 48474 "gram.c"
    break;

  case 1938: /* Typename: SimpleTypename ARRAY '[' Iconst ']'  */
#line 14482 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 48483 "gram.c"
    break;

  case 1939: /* Typename: SETOF SimpleTypename ARRAY '[' Iconst ']'  */
#line 14487 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = true;
				}
#line 48493 "gram.c"
    break;

  case 1940: /* Typename: SimpleTypename ARRAY  */
#line 14493 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 48502 "gram.c"
    break;

  case 1941: /* Typename: SETOF SimpleTypename ARRAY  */
#line 14498 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = true;
				}
#line 48512 "gram.c"
    break;

  case 1942: /* opt_array_bounds: opt_array_bounds '[' ']'  */
#line 14507 "gram.y"
                                        {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 48518 "gram.c"
    break;

  case 1943: /* opt_array_bounds: opt_array_bounds '[' Iconst ']'  */
#line 14509 "gram.y"
                                        {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 48524 "gram.c"
    break;

  case 1944: /* opt_array_bounds: %empty  */
#line 14511 "gram.y"
                                        {  (yyval.list) = NIL; }
#line 48530 "gram.c"
    break;

  case 1945: /* SimpleTypename: GenericType  */
#line 14515 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48536 "gram.c"
    break;

  case 1946: /* SimpleTypename: Numeric  */
#line 14516 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48542 "gram.c"
    break;

  case 1947: /* SimpleTypename: Bit  */
#line 14517 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48548 "gram.c"
    break;

  case 1948: /* SimpleTypename: Character  */
#line 14518 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48554 "gram.c"
    break;

  case 1949: /* SimpleTypename: ConstDatetime  */
#line 14519 "gram.y"
                                                                                        { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48560 "gram.c"
    break;

  case 1950: /* SimpleTypename: ConstInterval opt_interval  */
#line 14521 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 48569 "gram.c"
    break;

  case 1951: /* SimpleTypename: ConstInterval '(' Iconst ')'  */
#line 14526 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-3].typnam);
					(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											 makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 48579 "gram.c"
    break;

  case 1952: /* SimpleTypename: JsonType  */
#line 14531 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48585 "gram.c"
    break;

  case 1953: /* ConstTypename: Numeric  */
#line 14546 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48591 "gram.c"
    break;

  case 1954: /* ConstTypename: ConstBit  */
#line 14547 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48597 "gram.c"
    break;

  case 1955: /* ConstTypename: ConstCharacter  */
#line 14548 "gram.y"
                                                                                        { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48603 "gram.c"
    break;

  case 1956: /* ConstTypename: ConstDatetime  */
#line 14549 "gram.y"
                                                                                        { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48609 "gram.c"
    break;

  case 1957: /* ConstTypename: JsonType  */
#line 14550 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48615 "gram.c"
    break;

  case 1958: /* GenericType: type_function_name opt_type_modifiers  */
#line 14562 "gram.y"
                                {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48625 "gram.c"
    break;

  case 1959: /* GenericType: type_function_name attrs opt_type_modifiers  */
#line 14568 "gram.y"
                                {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 48635 "gram.c"
    break;

  case 1960: /* opt_type_modifiers: '(' expr_list ')'  */
#line 14575 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 48641 "gram.c"
    break;

  case 1961: /* opt_type_modifiers: %empty  */
#line 14576 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 48647 "gram.c"
    break;

  case 1962: /* Numeric: INT_P  */
#line 14583 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48656 "gram.c"
    break;

  case 1963: /* Numeric: INTEGER  */
#line 14588 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48665 "gram.c"
    break;

  case 1964: /* Numeric: SMALLINT  */
#line 14593 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48674 "gram.c"
    break;

  case 1965: /* Numeric: BIGINT  */
#line 14598 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48683 "gram.c"
    break;

  case 1966: /* Numeric: REAL  */
#line 14603 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48692 "gram.c"
    break;

  case 1967: /* Numeric: FLOAT_P opt_float  */
#line 14608 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48701 "gram.c"
    break;

  case 1968: /* Numeric: DOUBLE_P PRECISION  */
#line 14613 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48710 "gram.c"
    break;

  case 1969: /* Numeric: DECIMAL_P opt_type_modifiers  */
#line 14618 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48720 "gram.c"
    break;

  case 1970: /* Numeric: DEC opt_type_modifiers  */
#line 14624 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48730 "gram.c"
    break;

  case 1971: /* Numeric: NUMERIC opt_type_modifiers  */
#line 14630 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48740 "gram.c"
    break;

  case 1972: /* Numeric: BOOLEAN_P  */
#line 14636 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48749 "gram.c"
    break;

  case 1973: /* opt_float: '(' Iconst ')'  */
#line 14643 "gram.y"
                                {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 48774 "gram.c"
    break;

  case 1974: /* opt_float: %empty  */
#line 14664 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 48782 "gram.c"
    break;

  case 1975: /* Bit: BitWithLength  */
#line 14674 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48790 "gram.c"
    break;

  case 1976: /* Bit: BitWithoutLength  */
#line 14678 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48798 "gram.c"
    break;

  case 1977: /* ConstBit: BitWithLength  */
#line 14686 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48806 "gram.c"
    break;

  case 1978: /* ConstBit: BitWithoutLength  */
#line 14690 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 48815 "gram.c"
    break;

  case 1979: /* BitWithLength: BIT opt_varying '(' expr_list ')'  */
#line 14698 "gram.y"
                                {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 48828 "gram.c"
    break;

  case 1980: /* BitWithoutLength: BIT opt_varying  */
#line 14710 "gram.y"
                                {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48846 "gram.c"
    break;

  case 1981: /* Character: CharacterWithLength  */
#line 14731 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48854 "gram.c"
    break;

  case 1982: /* Character: CharacterWithoutLength  */
#line 14735 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48862 "gram.c"
    break;

  case 1983: /* ConstCharacter: CharacterWithLength  */
#line 14741 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48870 "gram.c"
    break;

  case 1984: /* ConstCharacter: CharacterWithoutLength  */
#line 14745 "gram.y"
                                {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 48885 "gram.c"
    break;

  case 1985: /* CharacterWithLength: character '(' Iconst ')'  */
#line 14758 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName((yyvsp[-3].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 48895 "gram.c"
    break;

  case 1986: /* CharacterWithoutLength: character  */
#line 14766 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName((yyvsp[0].str));
					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[0].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48907 "gram.c"
    break;

  case 1987: /* character: CHARACTER opt_varying  */
#line 14776 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 48913 "gram.c"
    break;

  case 1988: /* character: CHAR_P opt_varying  */
#line 14778 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 48919 "gram.c"
    break;

  case 1989: /* character: VARCHAR  */
#line 14780 "gram.y"
                                                                                { (yyval.str) = "varchar"; }
#line 48925 "gram.c"
    break;

  case 1990: /* character: NATIONAL CHARACTER opt_varying  */
#line 14782 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 48931 "gram.c"
    break;

  case 1991: /* character: NATIONAL CHAR_P opt_varying  */
#line 14784 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 48937 "gram.c"
    break;

  case 1992: /* character: NCHAR opt_varying  */
#line 14786 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 48943 "gram.c"
    break;

  case 1993: /* opt_varying: VARYING  */
#line 14790 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 48949 "gram.c"
    break;

  case 1994: /* opt_varying: %empty  */
#line 14791 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 48955 "gram.c"
    break;

  case 1995: /* ConstDatetime: TIMESTAMP '(' Iconst ')' opt_timezone  */
#line 14799 "gram.y"
                                {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 48968 "gram.c"
    break;

  case 1996: /* ConstDatetime: TIMESTAMP opt_timezone  */
#line 14808 "gram.y"
                                {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48980 "gram.c"
    break;

  case 1997: /* ConstDatetime: TIME '(' Iconst ')' opt_timezone  */
#line 14816 "gram.y"
                                {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 48993 "gram.c"
    break;

  case 1998: /* ConstDatetime: TIME opt_timezone  */
#line 14825 "gram.y"
                                {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 49005 "gram.c"
    break;

  case 1999: /* ConstInterval: INTERVAL  */
#line 14836 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 49014 "gram.c"
    break;

  case 2000: /* opt_timezone: WITH_LA TIME ZONE  */
#line 14843 "gram.y"
                                                                                        { (yyval.boolean) = true; }
#line 49020 "gram.c"
    break;

  case 2001: /* opt_timezone: WITHOUT_LA TIME ZONE  */
#line 14844 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 49026 "gram.c"
    break;

  case 2002: /* opt_timezone: %empty  */
#line 14845 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 49032 "gram.c"
    break;

  case 2003: /* opt_interval: YEAR_P  */
#line 14850 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 49038 "gram.c"
    break;

  case 2004: /* opt_interval: MONTH_P  */
#line 14852 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 49044 "gram.c"
    break;

  case 2005: /* opt_interval: DAY_P  */
#line 14854 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 49050 "gram.c"
    break;

  case 2006: /* opt_interval: HOUR_P  */
#line 14856 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 49056 "gram.c"
    break;

  case 2007: /* opt_interval: MINUTE_P  */
#line 14858 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 49062 "gram.c"
    break;

  case 2008: /* opt_interval: interval_second  */
#line 14860 "gram.y"
                                { (yyval.list) = (yyvsp[0].list); }
#line 49068 "gram.c"
    break;

  case 2009: /* opt_interval: YEAR_P TO MONTH_P  */
#line 14862 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 49077 "gram.c"
    break;

  case 2010: /* opt_interval: DAY_P TO HOUR_P  */
#line 14867 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 49086 "gram.c"
    break;

  case 2011: /* opt_interval: DAY_P TO MINUTE_P  */
#line 14872 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 49096 "gram.c"
    break;

  case 2012: /* opt_interval: DAY_P TO interval_second  */
#line 14878 "gram.y"
                                {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 49108 "gram.c"
    break;

  case 2013: /* opt_interval: HOUR_P TO MINUTE_P  */
#line 14886 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 49117 "gram.c"
    break;

  case 2014: /* opt_interval: HOUR_P TO interval_second  */
#line 14891 "gram.y"
                                {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 49128 "gram.c"
    break;

  case 2015: /* opt_interval: MINUTE_P TO interval_second  */
#line 14898 "gram.y"
                                {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 49138 "gram.c"
    break;

  case 2016: /* opt_interval: %empty  */
#line 14904 "gram.y"
                                { (yyval.list) = NIL; }
#line 49144 "gram.c"
    break;

  case 2017: /* interval_second: SECOND_P  */
#line 14909 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 49152 "gram.c"
    break;

  case 2018: /* interval_second: SECOND_P '(' Iconst ')'  */
#line 14913 "gram.y"
                                {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 49161 "gram.c"
    break;

  case 2019: /* JsonType: JSON  */
#line 14921 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("json");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 49170 "gram.c"
    break;

  case 2020: /* a_expr: c_expr  */
#line 14955 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 49176 "gram.c"
    break;

  case 2021: /* a_expr: a_expr TYPECAST Typename  */
#line 14957 "gram.y"
                                        { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 49182 "gram.c"
    break;

  case 2022: /* a_expr: a_expr COLLATE any_name  */
#line 14959 "gram.y"
                                {
					CollateClause *n = makeNode(CollateClause);

					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 49195 "gram.c"
    break;

  case 2023: /* a_expr: a_expr AT TIME ZONE a_expr  */
#line 14968 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[0].node), (yyvsp[-4].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 49206 "gram.c"
    break;

  case 2024: /* a_expr: a_expr AT LOCAL  */
#line 14975 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make1((yyvsp[-2].node)),
											   COERCE_SQL_SYNTAX,
											   -1);
				}
#line 49217 "gram.c"
    break;

  case 2025: /* a_expr: '+' a_expr  */
#line 14991 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 49223 "gram.c"
    break;

  case 2026: /* a_expr: '-' a_expr  */
#line 14993 "gram.y"
                                { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 49229 "gram.c"
    break;

  case 2027: /* a_expr: a_expr '+' a_expr  */
#line 14995 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49235 "gram.c"
    break;

  case 2028: /* a_expr: a_expr '-' a_expr  */
#line 14997 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49241 "gram.c"
    break;

  case 2029: /* a_expr: a_expr '*' a_expr  */
#line 14999 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49247 "gram.c"
    break;

  case 2030: /* a_expr: a_expr '/' a_expr  */
#line 15001 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49253 "gram.c"
    break;

  case 2031: /* a_expr: a_expr '%' a_expr  */
#line 15003 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49259 "gram.c"
    break;

  case 2032: /* a_expr: a_expr '^' a_expr  */
#line 15005 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49265 "gram.c"
    break;

  case 2033: /* a_expr: a_expr '<' a_expr  */
#line 15007 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49271 "gram.c"
    break;

  case 2034: /* a_expr: a_expr '>' a_expr  */
#line 15009 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49277 "gram.c"
    break;

  case 2035: /* a_expr: a_expr '=' a_expr  */
#line 15011 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49283 "gram.c"
    break;

  case 2036: /* a_expr: a_expr LESS_EQUALS a_expr  */
#line 15013 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49289 "gram.c"
    break;

  case 2037: /* a_expr: a_expr GREATER_EQUALS a_expr  */
#line 15015 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49295 "gram.c"
    break;

  case 2038: /* a_expr: a_expr NOT_EQUALS a_expr  */
#line 15017 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49301 "gram.c"
    break;

  case 2039: /* a_expr: a_expr qual_Op a_expr  */
#line 15020 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49307 "gram.c"
    break;

  case 2040: /* a_expr: qual_Op a_expr  */
#line 15022 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 49313 "gram.c"
    break;

  case 2041: /* a_expr: a_expr AND a_expr  */
#line 15025 "gram.y"
                                { (yyval.node) = makeAndExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49319 "gram.c"
    break;

  case 2042: /* a_expr: a_expr OR a_expr  */
#line 15027 "gram.y"
                                { (yyval.node) = makeOrExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49325 "gram.c"
    break;

  case 2043: /* a_expr: NOT a_expr  */
#line 15029 "gram.y"
                                { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 49331 "gram.c"
    break;

  case 2044: /* a_expr: NOT_LA a_expr  */
#line 15031 "gram.y"
                                { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 49337 "gram.c"
    break;

  case 2045: /* a_expr: a_expr LIKE a_expr  */
#line 15034 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 49346 "gram.c"
    break;

  case 2046: /* a_expr: a_expr LIKE a_expr ESCAPE a_expr  */
#line 15039 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 49359 "gram.c"
    break;

  case 2047: /* a_expr: a_expr NOT_LA LIKE a_expr  */
#line 15048 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 49368 "gram.c"
    break;

  case 2048: /* a_expr: a_expr NOT_LA LIKE a_expr ESCAPE a_expr  */
#line 15053 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 49381 "gram.c"
    break;

  case 2049: /* a_expr: a_expr ILIKE a_expr  */
#line 15062 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 49390 "gram.c"
    break;

  case 2050: /* a_expr: a_expr ILIKE a_expr ESCAPE a_expr  */
#line 15067 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 49403 "gram.c"
    break;

  case 2051: /* a_expr: a_expr NOT_LA ILIKE a_expr  */
#line 15076 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 49412 "gram.c"
    break;

  case 2052: /* a_expr: a_expr NOT_LA ILIKE a_expr ESCAPE a_expr  */
#line 15081 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 49425 "gram.c"
    break;

  case 2053: /* a_expr: a_expr SIMILAR TO a_expr  */
#line 15091 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make1((yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-2]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 49438 "gram.c"
    break;

  case 2054: /* a_expr: a_expr SIMILAR TO a_expr ESCAPE a_expr  */
#line 15100 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 49451 "gram.c"
    break;

  case 2055: /* a_expr: a_expr NOT_LA SIMILAR TO a_expr  */
#line 15109 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make1((yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 49464 "gram.c"
    break;

  case 2056: /* a_expr: a_expr NOT_LA SIMILAR TO a_expr ESCAPE a_expr  */
#line 15118 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 49477 "gram.c"
    break;

  case 2057: /* a_expr: a_expr IS NULL_P  */
#line 15137 "gram.y"
                                {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 49490 "gram.c"
    break;

  case 2058: /* a_expr: a_expr ISNULL  */
#line 15146 "gram.y"
                                {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 49503 "gram.c"
    break;

  case 2059: /* a_expr: a_expr IS NOT NULL_P  */
#line 15155 "gram.y"
                                {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 49516 "gram.c"
    break;

  case 2060: /* a_expr: a_expr NOTNULL  */
#line 15164 "gram.y"
                                {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 49529 "gram.c"
    break;

  case 2061: /* a_expr: row OVERLAPS row  */
#line 15173 "gram.y"
                                {
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[-2].list), (yyvsp[0].list)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 49550 "gram.c"
    break;

  case 2062: /* a_expr: a_expr IS TRUE_P  */
#line 15190 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 49563 "gram.c"
    break;

  case 2063: /* a_expr: a_expr IS NOT TRUE_P  */
#line 15199 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 49576 "gram.c"
    break;

  case 2064: /* a_expr: a_expr IS FALSE_P  */
#line 15208 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 49589 "gram.c"
    break;

  case 2065: /* a_expr: a_expr IS NOT FALSE_P  */
#line 15217 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 49602 "gram.c"
    break;

  case 2066: /* a_expr: a_expr IS UNKNOWN  */
#line 15226 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 49615 "gram.c"
    break;

  case 2067: /* a_expr: a_expr IS NOT UNKNOWN  */
#line 15235 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 49628 "gram.c"
    break;

  case 2068: /* a_expr: a_expr IS DISTINCT FROM a_expr  */
#line 15244 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 49636 "gram.c"
    break;

  case 2069: /* a_expr: a_expr IS NOT DISTINCT FROM a_expr  */
#line 15248 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 49644 "gram.c"
    break;

  case 2070: /* a_expr: a_expr BETWEEN opt_asymmetric b_expr AND a_expr  */
#line 15252 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN,
												   "BETWEEN",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 49656 "gram.c"
    break;

  case 2071: /* a_expr: a_expr NOT_LA BETWEEN opt_asymmetric b_expr AND a_expr  */
#line 15260 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN,
												   "NOT BETWEEN",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 49668 "gram.c"
    break;

  case 2072: /* a_expr: a_expr BETWEEN SYMMETRIC b_expr AND a_expr  */
#line 15268 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN_SYM,
												   "BETWEEN SYMMETRIC",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 49680 "gram.c"
    break;

  case 2073: /* a_expr: a_expr NOT_LA BETWEEN SYMMETRIC b_expr AND a_expr  */
#line 15276 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN_SYM,
												   "NOT BETWEEN SYMMETRIC",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 49692 "gram.c"
    break;

  case 2074: /* a_expr: a_expr IN_P in_expr  */
#line 15284 "gram.y"
                                {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink	   *n = (SubLink *) (yyvsp[0].node);

						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-2].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *) n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 49717 "gram.c"
    break;

  case 2075: /* a_expr: a_expr NOT_LA IN_P in_expr  */
#line 15305 "gram.y"
                                {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink	   *n = (SubLink *) (yyvsp[0].node);

						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-3].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-2]);
						/* Stick a NOT on top; must have same parse location */
						(yyval.node) = makeNotExpr((Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 49744 "gram.c"
    break;

  case 2076: /* a_expr: a_expr subquery_Op sub_type select_with_parens  */
#line 15328 "gram.y"
                                {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = (yyvsp[-1].ival);
					n->subLinkId = 0;
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 49760 "gram.c"
    break;

  case 2077: /* a_expr: a_expr subquery_Op sub_type '(' a_expr ')'  */
#line 15340 "gram.y"
                                {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 49771 "gram.c"
    break;

  case 2078: /* a_expr: UNIQUE opt_unique_null_treatment select_with_parens  */
#line 15347 "gram.y"
                                {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-2]))));
				}
#line 49791 "gram.c"
    break;

  case 2079: /* a_expr: a_expr IS DOCUMENT_P  */
#line 15363 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 49800 "gram.c"
    break;

  case 2080: /* a_expr: a_expr IS NOT DOCUMENT_P  */
#line 15368 "gram.y"
                                {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 49810 "gram.c"
    break;

  case 2081: /* a_expr: a_expr IS NORMALIZED  */
#line 15374 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make1((yyvsp[-2].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 49821 "gram.c"
    break;

  case 2082: /* a_expr: a_expr IS unicode_normal_form NORMALIZED  */
#line 15381 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-2]));
				}
#line 49832 "gram.c"
    break;

  case 2083: /* a_expr: a_expr IS NOT NORMALIZED  */
#line 15388 "gram.y"
                                {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make1((yyvsp[-3].node)),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 49844 "gram.c"
    break;

  case 2084: /* a_expr: a_expr IS NOT unicode_normal_form NORMALIZED  */
#line 15396 "gram.y"
                                {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make2((yyvsp[-4].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-3])),
									 (yylsp[-3]));
				}
#line 49856 "gram.c"
    break;

  case 2085: /* a_expr: a_expr IS json_predicate_type_constraint json_key_uniqueness_constraint_opt  */
#line 15405 "gram.y"
                                {
					JsonFormat *format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);

					(yyval.node) = makeJsonIsPredicate((yyvsp[-3].node), format, (yyvsp[-1].ival), (yyvsp[0].boolean), (yylsp[-3]));
				}
#line 49866 "gram.c"
    break;

  case 2086: /* a_expr: a_expr IS NOT json_predicate_type_constraint json_key_uniqueness_constraint_opt  */
#line 15423 "gram.y"
                                {
					JsonFormat *format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);

					(yyval.node) = makeNotExpr(makeJsonIsPredicate((yyvsp[-4].node), format, (yyvsp[-1].ival), (yyvsp[0].boolean), (yylsp[-4])), (yylsp[-4]));
				}
#line 49876 "gram.c"
    break;

  case 2087: /* a_expr: DEFAULT  */
#line 15440 "gram.y"
                                {
					/*
					 * The SQL spec only allows DEFAULT in "contextually typed
					 * expressions", but for us, it's easier to allow it in
					 * any a_expr and then throw error during parse analysis
					 * if it's in an inappropriate context.  This way also
					 * lets us say something smarter than "syntax error".
					 */
					SetToDefault *n = makeNode(SetToDefault);

					/* parse analysis will fill in the rest */
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 49895 "gram.c"
    break;

  case 2088: /* b_expr: c_expr  */
#line 15466 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 49901 "gram.c"
    break;

  case 2089: /* b_expr: b_expr TYPECAST Typename  */
#line 15468 "gram.y"
                                { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 49907 "gram.c"
    break;

  case 2090: /* b_expr: '+' b_expr  */
#line 15470 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 49913 "gram.c"
    break;

  case 2091: /* b_expr: '-' b_expr  */
#line 15472 "gram.y"
                                { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 49919 "gram.c"
    break;

  case 2092: /* b_expr: b_expr '+' b_expr  */
#line 15474 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49925 "gram.c"
    break;

  case 2093: /* b_expr: b_expr '-' b_expr  */
#line 15476 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49931 "gram.c"
    break;

  case 2094: /* b_expr: b_expr '*' b_expr  */
#line 15478 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49937 "gram.c"
    break;

  case 2095: /* b_expr: b_expr '/' b_expr  */
#line 15480 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49943 "gram.c"
    break;

  case 2096: /* b_expr: b_expr '%' b_expr  */
#line 15482 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49949 "gram.c"
    break;

  case 2097: /* b_expr: b_expr '^' b_expr  */
#line 15484 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49955 "gram.c"
    break;

  case 2098: /* b_expr: b_expr '<' b_expr  */
#line 15486 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49961 "gram.c"
    break;

  case 2099: /* b_expr: b_expr '>' b_expr  */
#line 15488 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49967 "gram.c"
    break;

  case 2100: /* b_expr: b_expr '=' b_expr  */
#line 15490 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49973 "gram.c"
    break;

  case 2101: /* b_expr: b_expr LESS_EQUALS b_expr  */
#line 15492 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49979 "gram.c"
    break;

  case 2102: /* b_expr: b_expr GREATER_EQUALS b_expr  */
#line 15494 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49985 "gram.c"
    break;

  case 2103: /* b_expr: b_expr NOT_EQUALS b_expr  */
#line 15496 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49991 "gram.c"
    break;

  case 2104: /* b_expr: b_expr qual_Op b_expr  */
#line 15498 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49997 "gram.c"
    break;

  case 2105: /* b_expr: qual_Op b_expr  */
#line 15500 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 50003 "gram.c"
    break;

  case 2106: /* b_expr: b_expr IS DISTINCT FROM b_expr  */
#line 15502 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 50011 "gram.c"
    break;

  case 2107: /* b_expr: b_expr IS NOT DISTINCT FROM b_expr  */
#line 15506 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 50019 "gram.c"
    break;

  case 2108: /* b_expr: b_expr IS DOCUMENT_P  */
#line 15510 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 50028 "gram.c"
    break;

  case 2109: /* b_expr: b_expr IS NOT DOCUMENT_P  */
#line 15515 "gram.y"
                                {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 50038 "gram.c"
    break;

  case 2110: /* c_expr: columnref  */
#line 15530 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 50044 "gram.c"
    break;

  case 2111: /* c_expr: AexprConst  */
#line 15531 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 50050 "gram.c"
    break;

  case 2112: /* c_expr: PARAM opt_indirection  */
#line 15533 "gram.y"
                                {
					ParamRef   *p = makeNode(ParamRef);

					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);

						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 50071 "gram.c"
    break;

  case 2113: /* c_expr: '(' a_expr ')' opt_indirection  */
#line 15550 "gram.y"
                                {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);

						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 50088 "gram.c"
    break;

  case 2114: /* c_expr: case_expr  */
#line 15563 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 50094 "gram.c"
    break;

  case 2115: /* c_expr: func_expr  */
#line 15565 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 50100 "gram.c"
    break;

  case 2116: /* c_expr: select_with_parens  */
#line 15567 "gram.y"
                                {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 50116 "gram.c"
    break;

  case 2117: /* c_expr: select_with_parens indirection  */
#line 15579 "gram.y"
                                {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink	   *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);

					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *) n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *) a;
				}
#line 50145 "gram.c"
    break;

  case 2118: /* c_expr: EXISTS select_with_parens  */
#line 15604 "gram.y"
                                {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = EXISTS_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 50161 "gram.c"
    break;

  case 2119: /* c_expr: ARRAY select_with_parens  */
#line 15616 "gram.y"
                                {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = ARRAY_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 50177 "gram.c"
    break;

  case 2120: /* c_expr: ARRAY array_expr  */
#line 15628 "gram.y"
                                {
					A_ArrayExpr *n = castNode(A_ArrayExpr, (yyvsp[0].node));

					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 50189 "gram.c"
    break;

  case 2121: /* c_expr: explicit_row  */
#line 15636 "gram.y"
                                {
					RowExpr	   *r = makeNode(RowExpr);

					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_EXPLICIT_CALL; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *) r;
				}
#line 50204 "gram.c"
    break;

  case 2122: /* c_expr: implicit_row  */
#line 15647 "gram.y"
                                {
					RowExpr	   *r = makeNode(RowExpr);

					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_IMPLICIT_CAST; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *) r;
				}
#line 50219 "gram.c"
    break;

  case 2123: /* c_expr: GROUPING '(' expr_list ')'  */
#line 15658 "gram.y"
                          {
				  GroupingFunc *g = makeNode(GroupingFunc);

				  g->args = (yyvsp[-1].list);
				  g->location = (yylsp[-3]);
				  (yyval.node) = (Node *) g;
			  }
#line 50231 "gram.c"
    break;

  case 2124: /* func_application: func_name '(' ')'  */
#line 15668 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[-2].list), NIL,
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-2]));
				}
#line 50241 "gram.c"
    break;

  case 2125: /* func_application: func_name '(' func_arg_list opt_sort_clause ')'  */
#line 15674 "gram.y"
                                {
					FuncCall   *n = makeFuncCall((yyvsp[-4].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));

					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 50254 "gram.c"
    break;

  case 2126: /* func_application: func_name '(' VARIADIC func_arg_expr opt_sort_clause ')'  */
#line 15683 "gram.y"
                                {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), list_make1((yyvsp[-2].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 50268 "gram.c"
    break;

  case 2127: /* func_application: func_name '(' func_arg_list ',' VARIADIC func_arg_expr opt_sort_clause ')'  */
#line 15693 "gram.y"
                                {
					FuncCall   *n = makeFuncCall((yyvsp[-7].list), lappend((yyvsp[-5].list), (yyvsp[-2].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-7]));

					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 50282 "gram.c"
    break;

  case 2128: /* func_application: func_name '(' ALL func_arg_list opt_sort_clause ')'  */
#line 15703 "gram.y"
                                {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->agg_order = (yyvsp[-1].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *) n;
				}
#line 50299 "gram.c"
    break;

  case 2129: /* func_application: func_name '(' DISTINCT func_arg_list opt_sort_clause ')'  */
#line 15716 "gram.y"
                                {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->agg_order = (yyvsp[-1].list);
					n->agg_distinct = true;
					(yyval.node) = (Node *) n;
				}
#line 50313 "gram.c"
    break;

  case 2130: /* func_application: func_name '(' '*' ')'  */
#line 15726 "gram.y"
                                {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall   *n = makeFuncCall((yyvsp[-3].list), NIL,
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));

					n->agg_star = true;
					(yyval.node) = (Node *) n;
				}
#line 50336 "gram.c"
    break;

  case 2131: /* func_expr: func_application within_group_clause filter_clause over_clause  */
#line 15757 "gram.y"
                                {
					FuncCall   *n = (FuncCall *) (yyvsp[-3].node);

					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[-2].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						n->agg_order = (yyvsp[-2].list);
						n->agg_within_group = true;
					}
					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) n;
				}
#line 50376 "gram.c"
    break;

  case 2132: /* func_expr: json_aggregate_func filter_clause over_clause  */
#line 15793 "gram.y"
                                {
					JsonAggConstructor *n = IsA((yyvsp[-2].node), JsonObjectAgg) ?
						((JsonObjectAgg *) (yyvsp[-2].node))->constructor :
						((JsonArrayAgg *) (yyvsp[-2].node))->constructor;

					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) (yyvsp[-2].node);
				}
#line 50390 "gram.c"
    break;

  case 2133: /* func_expr: func_expr_common_subexpr  */
#line 15803 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 50396 "gram.c"
    break;

  case 2134: /* func_expr_windowless: func_application  */
#line 15813 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 50402 "gram.c"
    break;

  case 2135: /* func_expr_windowless: func_expr_common_subexpr  */
#line 15814 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 50408 "gram.c"
    break;

  case 2136: /* func_expr_windowless: json_aggregate_func  */
#line 15815 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 50414 "gram.c"
    break;

  case 2137: /* func_expr_common_subexpr: COLLATION FOR '(' a_expr ')'  */
#line 15823 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 50425 "gram.c"
    break;

  case 2138: /* func_expr_common_subexpr: CURRENT_DATE  */
#line 15830 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_DATE, -1, (yylsp[0]));
				}
#line 50433 "gram.c"
    break;

  case 2139: /* func_expr_common_subexpr: CURRENT_TIME  */
#line 15834 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME, -1, (yylsp[0]));
				}
#line 50441 "gram.c"
    break;

  case 2140: /* func_expr_common_subexpr: CURRENT_TIME '(' Iconst ')'  */
#line 15838 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 50449 "gram.c"
    break;

  case 2141: /* func_expr_common_subexpr: CURRENT_TIMESTAMP  */
#line 15842 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP, -1, (yylsp[0]));
				}
#line 50457 "gram.c"
    break;

  case 2142: /* func_expr_common_subexpr: CURRENT_TIMESTAMP '(' Iconst ')'  */
#line 15846 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 50465 "gram.c"
    break;

  case 2143: /* func_expr_common_subexpr: LOCALTIME  */
#line 15850 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME, -1, (yylsp[0]));
				}
#line 50473 "gram.c"
    break;

  case 2144: /* func_expr_common_subexpr: LOCALTIME '(' Iconst ')'  */
#line 15854 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 50481 "gram.c"
    break;

  case 2145: /* func_expr_common_subexpr: LOCALTIMESTAMP  */
#line 15858 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP, -1, (yylsp[0]));
				}
#line 50489 "gram.c"
    break;

  case 2146: /* func_expr_common_subexpr: LOCALTIMESTAMP '(' Iconst ')'  */
#line 15862 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 50497 "gram.c"
    break;

  case 2147: /* func_expr_common_subexpr: CURRENT_ROLE  */
#line 15866 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_ROLE, -1, (yylsp[0]));
				}
#line 50505 "gram.c"
    break;

  case 2148: /* func_expr_common_subexpr: CURRENT_USER  */
#line 15870 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_USER, -1, (yylsp[0]));
				}
#line 50513 "gram.c"
    break;

  case 2149: /* func_expr_common_subexpr: SESSION_USER  */
#line 15874 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_SESSION_USER, -1, (yylsp[0]));
				}
#line 50521 "gram.c"
    break;

  case 2150: /* func_expr_common_subexpr: SYSTEM_USER  */
#line 15878 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("system_user"),
											   NIL,
											   COERCE_SQL_SYNTAX,
											   (yylsp[0]));
				}
#line 50532 "gram.c"
    break;

  case 2151: /* func_expr_common_subexpr: USER  */
#line 15885 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_USER, -1, (yylsp[0]));
				}
#line 50540 "gram.c"
    break;

  case 2152: /* func_expr_common_subexpr: CURRENT_CATALOG  */
#line 15889 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_CATALOG, -1, (yylsp[0]));
				}
#line 50548 "gram.c"
    break;

  case 2153: /* func_expr_common_subexpr: CURRENT_SCHEMA  */
#line 15893 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_SCHEMA, -1, (yylsp[0]));
				}
#line 50556 "gram.c"
    break;

  case 2154: /* func_expr_common_subexpr: CAST '(' a_expr AS Typename ')'  */
#line 15897 "gram.y"
                                { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 50562 "gram.c"
    break;

  case 2155: /* func_expr_common_subexpr: EXTRACT '(' extract_list ')'  */
#line 15899 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("extract"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 50573 "gram.c"
    break;

  case 2156: /* func_expr_common_subexpr: NORMALIZE '(' a_expr ')'  */
#line 15906 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 50584 "gram.c"
    break;

  case 2157: /* func_expr_common_subexpr: NORMALIZE '(' a_expr ',' unicode_normal_form ')'  */
#line 15913 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-5]));
				}
#line 50595 "gram.c"
    break;

  case 2158: /* func_expr_common_subexpr: OVERLAY '(' overlay_list ')'  */
#line 15920 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 50606 "gram.c"
    break;

  case 2159: /* func_expr_common_subexpr: OVERLAY '(' func_arg_list_opt ')'  */
#line 15927 "gram.y"
                                {
					/*
					 * allow functions named overlay() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("overlay")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 50621 "gram.c"
    break;

  case 2160: /* func_expr_common_subexpr: POSITION '(' position_list ')'  */
#line 15938 "gram.y"
                                {
					/*
					 * position(A in B) is converted to position(B, A)
					 *
					 * We deliberately don't offer a "plain syntax" option
					 * for position(), because the reversal of the arguments
					 * creates too much risk of confusion.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 50639 "gram.c"
    break;

  case 2161: /* func_expr_common_subexpr: SUBSTRING '(' substr_list ')'  */
#line 15952 "gram.y"
                                {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 50653 "gram.c"
    break;

  case 2162: /* func_expr_common_subexpr: SUBSTRING '(' func_arg_list_opt ')'  */
#line 15962 "gram.y"
                                {
					/*
					 * allow functions named substring() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("substring")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 50668 "gram.c"
    break;

  case 2163: /* func_expr_common_subexpr: TREAT '(' a_expr AS Typename ')'  */
#line 15973 "gram.y"
                                {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(strVal(llast((yyvsp[-1].typnam)->names))),
											   list_make1((yyvsp[-3].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-5]));
				}
#line 50688 "gram.c"
    break;

  case 2164: /* func_expr_common_subexpr: TRIM '(' BOTH trim_list ')'  */
#line 15989 "gram.y"
                                {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 50702 "gram.c"
    break;

  case 2165: /* func_expr_common_subexpr: TRIM '(' LEADING trim_list ')'  */
#line 15999 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 50713 "gram.c"
    break;

  case 2166: /* func_expr_common_subexpr: TRIM '(' TRAILING trim_list ')'  */
#line 16006 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 50724 "gram.c"
    break;

  case 2167: /* func_expr_common_subexpr: TRIM '(' trim_list ')'  */
#line 16013 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 50735 "gram.c"
    break;

  case 2168: /* func_expr_common_subexpr: NULLIF '(' a_expr ',' a_expr ')'  */
#line 16020 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 50743 "gram.c"
    break;

  case 2169: /* func_expr_common_subexpr: COALESCE '(' expr_list ')'  */
#line 16024 "gram.y"
                                {
					CoalesceExpr *c = makeNode(CoalesceExpr);

					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *) c;
				}
#line 50755 "gram.c"
    break;

  case 2170: /* func_expr_common_subexpr: GREATEST '(' expr_list ')'  */
#line 16032 "gram.y"
                                {
					MinMaxExpr *v = makeNode(MinMaxExpr);

					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *) v;
				}
#line 50768 "gram.c"
    break;

  case 2171: /* func_expr_common_subexpr: LEAST '(' expr_list ')'  */
#line 16041 "gram.y"
                                {
					MinMaxExpr *v = makeNode(MinMaxExpr);

					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *) v;
				}
#line 50781 "gram.c"
    break;

  case 2172: /* func_expr_common_subexpr: XMLCONCAT '(' expr_list ')'  */
#line 16050 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 50789 "gram.c"
    break;

  case 2173: /* func_expr_common_subexpr: XMLELEMENT '(' NAME_P ColLabel ')'  */
#line 16054 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 50797 "gram.c"
    break;

  case 2174: /* func_expr_common_subexpr: XMLELEMENT '(' NAME_P ColLabel ',' xml_attributes ')'  */
#line 16058 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 50805 "gram.c"
    break;

  case 2175: /* func_expr_common_subexpr: XMLELEMENT '(' NAME_P ColLabel ',' expr_list ')'  */
#line 16062 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 50813 "gram.c"
    break;

  case 2176: /* func_expr_common_subexpr: XMLELEMENT '(' NAME_P ColLabel ',' xml_attributes ',' expr_list ')'  */
#line 16066 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 50821 "gram.c"
    break;

  case 2177: /* func_expr_common_subexpr: XMLEXISTS '(' c_expr xmlexists_argument ')'  */
#line 16070 "gram.y"
                                {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"),
											   list_make2((yyvsp[-2].node), (yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 50834 "gram.c"
    break;

  case 2178: /* func_expr_common_subexpr: XMLFOREST '(' xml_attribute_list ')'  */
#line 16079 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 50842 "gram.c"
    break;

  case 2179: /* func_expr_common_subexpr: XMLPARSE '(' document_or_content a_expr xml_whitespace_option ')'  */
#line 16083 "gram.y"
                                {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));

					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *) x;
				}
#line 50856 "gram.c"
    break;

  case 2180: /* func_expr_common_subexpr: XMLPI '(' NAME_P ColLabel ')'  */
#line 16093 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 50864 "gram.c"
    break;

  case 2181: /* func_expr_common_subexpr: XMLPI '(' NAME_P ColLabel ',' a_expr ')'  */
#line 16097 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 50872 "gram.c"
    break;

  case 2182: /* func_expr_common_subexpr: XMLROOT '(' a_expr ',' xml_root_version opt_xml_root_standalone ')'  */
#line 16101 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 50881 "gram.c"
    break;

  case 2183: /* func_expr_common_subexpr: XMLSERIALIZE '(' document_or_content a_expr AS SimpleTypename xml_indent_option ')'  */
#line 16106 "gram.y"
                                {
					XmlSerialize *n = makeNode(XmlSerialize);

					n->xmloption = (yyvsp[-5].ival);
					n->expr = (yyvsp[-4].node);
					n->typeName = (yyvsp[-2].typnam);
					n->indent = (yyvsp[-1].boolean);
					n->location = (yylsp[-7]);
					(yyval.node) = (Node *) n;
				}
#line 50896 "gram.c"
    break;

  case 2184: /* func_expr_common_subexpr: JSON_OBJECT '(' func_arg_list ')'  */
#line 16117 "gram.y"
                                {
					/* Support for legacy (non-standard) json_object() */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("json_object"),
											   (yyvsp[-1].list), COERCE_EXPLICIT_CALL, (yylsp[-3]));
				}
#line 50906 "gram.c"
    break;

  case 2185: /* func_expr_common_subexpr: JSON_OBJECT '(' json_name_and_value_list json_object_constructor_null_clause_opt json_key_uniqueness_constraint_opt json_returning_clause_opt ')'  */
#line 16126 "gram.y"
                                {
					JsonObjectConstructor *n = makeNode(JsonObjectConstructor);

					n->exprs = (yyvsp[-4].list);
					n->absent_on_null = (yyvsp[-3].boolean);
					n->unique = (yyvsp[-2].boolean);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 50921 "gram.c"
    break;

  case 2186: /* func_expr_common_subexpr: JSON_OBJECT '(' json_returning_clause_opt ')'  */
#line 16137 "gram.y"
                                {
					JsonObjectConstructor *n = makeNode(JsonObjectConstructor);

					n->exprs = NULL;
					n->absent_on_null = false;
					n->unique = false;
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 50936 "gram.c"
    break;

  case 2187: /* func_expr_common_subexpr: JSON_ARRAY '(' json_value_expr_list json_array_constructor_null_clause_opt json_returning_clause_opt ')'  */
#line 16152 "gram.y"
                                {
					JsonArrayConstructor *n = makeNode(JsonArrayConstructor);

					n->exprs = (yyvsp[-3].list);
					n->absent_on_null = (yyvsp[-2].boolean);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 50950 "gram.c"
    break;

  case 2188: /* func_expr_common_subexpr: JSON_ARRAY '(' select_no_parens json_format_clause_opt json_returning_clause_opt ')'  */
#line 16167 "gram.y"
                                {
					JsonArrayQueryConstructor *n = makeNode(JsonArrayQueryConstructor);

					n->query = (yyvsp[-3].node);
					n->format = (JsonFormat *) (yyvsp[-2].node);
					n->absent_on_null = true;	/* XXX */
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 50965 "gram.c"
    break;

  case 2189: /* func_expr_common_subexpr: JSON_ARRAY '(' json_returning_clause_opt ')'  */
#line 16180 "gram.y"
                                {
					JsonArrayConstructor *n = makeNode(JsonArrayConstructor);

					n->exprs = NIL;
					n->absent_on_null = true;
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 50979 "gram.c"
    break;

  case 2190: /* func_expr_common_subexpr: JSON '(' json_value_expr json_key_uniqueness_constraint_opt ')'  */
#line 16190 "gram.y"
                                {
					JsonParseExpr *n = makeNode(JsonParseExpr);

					n->expr = (JsonValueExpr *) (yyvsp[-2].node);
					n->unique_keys = (yyvsp[-1].boolean);
					n->output = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 50993 "gram.c"
    break;

  case 2191: /* func_expr_common_subexpr: JSON_SCALAR '(' a_expr ')'  */
#line 16200 "gram.y"
                                {
					JsonScalarExpr *n = makeNode(JsonScalarExpr);

					n->expr = (Expr *) (yyvsp[-1].node);
					n->output = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 51006 "gram.c"
    break;

  case 2192: /* func_expr_common_subexpr: JSON_SERIALIZE '(' json_value_expr json_returning_clause_opt ')'  */
#line 16209 "gram.y"
                                {
					JsonSerializeExpr *n = makeNode(JsonSerializeExpr);

					n->expr = (JsonValueExpr *) (yyvsp[-2].node);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 51019 "gram.c"
    break;

  case 2193: /* func_expr_common_subexpr: MERGE_ACTION '(' ')'  */
#line 16218 "gram.y"
                                {
					MergeSupportFunc *m = makeNode(MergeSupportFunc);

					m->msftype = TEXTOID;
					m->location = (yylsp[-2]);
					(yyval.node) = (Node *) m;
				}
#line 51031 "gram.c"
    break;

  case 2194: /* func_expr_common_subexpr: JSON_QUERY '(' json_value_expr ',' a_expr json_passing_clause_opt json_returning_clause_opt json_wrapper_behavior json_quotes_clause_opt json_behavior_clause_opt ')'  */
#line 16232 "gram.y"
                                {
					JsonFuncExpr *n = makeNode(JsonFuncExpr);

					n->op = JSON_QUERY_OP;
					n->context_item = (JsonValueExpr *) (yyvsp[-8].node);
					n->pathspec = (yyvsp[-6].node);
					n->passing = (yyvsp[-5].list);
					n->output = (JsonOutput *) (yyvsp[-4].node);
					n->wrapper = (yyvsp[-3].ival);
					n->quotes = (yyvsp[-2].ival);
					n->on_empty = (JsonBehavior *) linitial((yyvsp[-1].list));
					n->on_error = (JsonBehavior *) lsecond((yyvsp[-1].list));
					n->location = (yylsp[-10]);
					(yyval.node) = (Node *) n;
				}
#line 51051 "gram.c"
    break;

  case 2195: /* func_expr_common_subexpr: JSON_EXISTS '(' json_value_expr ',' a_expr json_passing_clause_opt json_on_error_clause_opt ')'  */
#line 16251 "gram.y"
                                {
					JsonFuncExpr *n = makeNode(JsonFuncExpr);

					n->op = JSON_EXISTS_OP;
					n->context_item = (JsonValueExpr *) (yyvsp[-5].node);
					n->pathspec = (yyvsp[-3].node);
					n->passing = (yyvsp[-2].list);
					n->output = NULL;
					n->on_error = (JsonBehavior *) (yyvsp[-1].node);
					n->location = (yylsp[-7]);
					(yyval.node) = (Node *) n;
				}
#line 51068 "gram.c"
    break;

  case 2196: /* func_expr_common_subexpr: JSON_VALUE '(' json_value_expr ',' a_expr json_passing_clause_opt json_returning_clause_opt json_behavior_clause_opt ')'  */
#line 16268 "gram.y"
                                {
					JsonFuncExpr *n = makeNode(JsonFuncExpr);

					n->op = JSON_VALUE_OP;
					n->context_item = (JsonValueExpr *) (yyvsp[-6].node);
					n->pathspec = (yyvsp[-4].node);
					n->passing = (yyvsp[-3].list);
					n->output = (JsonOutput *) (yyvsp[-2].node);
					n->on_empty = (JsonBehavior *) linitial((yyvsp[-1].list));
					n->on_error = (JsonBehavior *) lsecond((yyvsp[-1].list));
					n->location = (yylsp[-8]);
					(yyval.node) = (Node *) n;
				}
#line 51086 "gram.c"
    break;

  case 2197: /* xml_root_version: VERSION_P a_expr  */
#line 16288 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 51092 "gram.c"
    break;

  case 2198: /* xml_root_version: VERSION_P NO VALUE_P  */
#line 16290 "gram.y"
                                { (yyval.node) = makeNullAConst(-1); }
#line 51098 "gram.c"
    break;

  case 2199: /* opt_xml_root_standalone: ',' STANDALONE_P YES_P  */
#line 16294 "gram.y"
                                { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 51104 "gram.c"
    break;

  case 2200: /* opt_xml_root_standalone: ',' STANDALONE_P NO  */
#line 16296 "gram.y"
                                { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 51110 "gram.c"
    break;

  case 2201: /* opt_xml_root_standalone: ',' STANDALONE_P NO VALUE_P  */
#line 16298 "gram.y"
                                { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 51116 "gram.c"
    break;

  case 2202: /* opt_xml_root_standalone: %empty  */
#line 16300 "gram.y"
                                { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 51122 "gram.c"
    break;

  case 2203: /* xml_attributes: XMLATTRIBUTES '(' xml_attribute_list ')'  */
#line 16303 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 51128 "gram.c"
    break;

  case 2204: /* xml_attribute_list: xml_attribute_el  */
#line 16306 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 51134 "gram.c"
    break;

  case 2205: /* xml_attribute_list: xml_attribute_list ',' xml_attribute_el  */
#line 16307 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 51140 "gram.c"
    break;

  case 2206: /* xml_attribute_el: a_expr AS ColLabel  */
#line 16311 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 51152 "gram.c"
    break;

  case 2207: /* xml_attribute_el: a_expr  */
#line 16319 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 51164 "gram.c"
    break;

  case 2208: /* document_or_content: DOCUMENT_P  */
#line 16328 "gram.y"
                                                                        { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 51170 "gram.c"
    break;

  case 2209: /* document_or_content: CONTENT_P  */
#line 16329 "gram.y"
                                                                                                { (yyval.ival) = XMLOPTION_CONTENT; }
#line 51176 "gram.c"
    break;

  case 2210: /* xml_indent_option: INDENT  */
#line 16332 "gram.y"
                                                                                { (yyval.boolean) = true; }
#line 51182 "gram.c"
    break;

  case 2211: /* xml_indent_option: NO INDENT  */
#line 16333 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 51188 "gram.c"
    break;

  case 2212: /* xml_indent_option: %empty  */
#line 16334 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 51194 "gram.c"
    break;

  case 2213: /* xml_whitespace_option: PRESERVE WHITESPACE_P  */
#line 16337 "gram.y"
                                                        { (yyval.boolean) = true; }
#line 51200 "gram.c"
    break;

  case 2214: /* xml_whitespace_option: STRIP_P WHITESPACE_P  */
#line 16338 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 51206 "gram.c"
    break;

  case 2215: /* xml_whitespace_option: %empty  */
#line 16339 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 51212 "gram.c"
    break;

  case 2216: /* xmlexists_argument: PASSING c_expr  */
#line 16345 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 51220 "gram.c"
    break;

  case 2217: /* xmlexists_argument: PASSING c_expr xml_passing_mech  */
#line 16349 "gram.y"
                                {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 51228 "gram.c"
    break;

  case 2218: /* xmlexists_argument: PASSING xml_passing_mech c_expr  */
#line 16353 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 51236 "gram.c"
    break;

  case 2219: /* xmlexists_argument: PASSING xml_passing_mech c_expr xml_passing_mech  */
#line 16357 "gram.y"
                                {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 51244 "gram.c"
    break;

  case 2222: /* within_group_clause: WITHIN GROUP_P '(' sort_clause ')'  */
#line 16372 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 51250 "gram.c"
    break;

  case 2223: /* within_group_clause: %empty  */
#line 16373 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 51256 "gram.c"
    break;

  case 2224: /* filter_clause: FILTER '(' WHERE a_expr ')'  */
#line 16377 "gram.y"
                                                                                { (yyval.node) = (yyvsp[-1].node); }
#line 51262 "gram.c"
    break;

  case 2225: /* filter_clause: %empty  */
#line 16378 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 51268 "gram.c"
    break;

  case 2226: /* window_clause: WINDOW window_definition_list  */
#line 16386 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 51274 "gram.c"
    break;

  case 2227: /* window_clause: %empty  */
#line 16387 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 51280 "gram.c"
    break;

  case 2228: /* window_definition_list: window_definition  */
#line 16391 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 51286 "gram.c"
    break;

  case 2229: /* window_definition_list: window_definition_list ',' window_definition  */
#line 16393 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 51292 "gram.c"
    break;

  case 2230: /* window_definition: ColId AS window_specification  */
#line 16398 "gram.y"
                                {
					WindowDef  *n = (yyvsp[0].windef);

					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 51303 "gram.c"
    break;

  case 2231: /* over_clause: OVER window_specification  */
#line 16407 "gram.y"
                                { (yyval.windef) = (yyvsp[0].windef); }
#line 51309 "gram.c"
    break;

  case 2232: /* over_clause: OVER ColId  */
#line 16409 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 51327 "gram.c"
    break;

  case 2233: /* over_clause: %empty  */
#line 16423 "gram.y"
                                { (yyval.windef) = NULL; }
#line 51333 "gram.c"
    break;

  case 2234: /* window_specification: '(' opt_existing_window_name opt_partition_clause opt_sort_clause opt_frame_clause ')'  */
#line 16428 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 51352 "gram.c"
    break;

  case 2235: /* opt_existing_window_name: ColId  */
#line 16454 "gram.y"
                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 51358 "gram.c"
    break;

  case 2236: /* opt_existing_window_name: %empty  */
#line 16455 "gram.y"
                                                                                        { (yyval.str) = NULL; }
#line 51364 "gram.c"
    break;

  case 2237: /* opt_partition_clause: PARTITION BY expr_list  */
#line 16458 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 51370 "gram.c"
    break;

  case 2238: /* opt_partition_clause: %empty  */
#line 16459 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 51376 "gram.c"
    break;

  case 2239: /* opt_frame_clause: RANGE frame_extent opt_window_exclusion_clause  */
#line 16468 "gram.y"
                                {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 51388 "gram.c"
    break;

  case 2240: /* opt_frame_clause: ROWS frame_extent opt_window_exclusion_clause  */
#line 16476 "gram.y"
                                {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 51400 "gram.c"
    break;

  case 2241: /* opt_frame_clause: GROUPS frame_extent opt_window_exclusion_clause  */
#line 16484 "gram.y"
                                {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_GROUPS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 51412 "gram.c"
    break;

  case 2242: /* opt_frame_clause: %empty  */
#line 16492 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 51425 "gram.c"
    break;

  case 2243: /* frame_extent: frame_bound  */
#line 16503 "gram.y"
                                {
					WindowDef  *n = (yyvsp[0].windef);

					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 51447 "gram.c"
    break;

  case 2244: /* frame_extent: BETWEEN frame_bound AND frame_bound  */
#line 16521 "gram.y"
                                {
					WindowDef  *n1 = (yyvsp[-2].windef);
					WindowDef  *n2 = (yyvsp[0].windef);

					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_OFFSET_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_OFFSET_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 51489 "gram.c"
    break;

  case 2245: /* frame_bound: UNBOUNDED PRECEDING  */
#line 16567 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 51502 "gram.c"
    break;

  case 2246: /* frame_bound: UNBOUNDED FOLLOWING  */
#line 16576 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 51515 "gram.c"
    break;

  case 2247: /* frame_bound: CURRENT_P ROW  */
#line 16585 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 51528 "gram.c"
    break;

  case 2248: /* frame_bound: a_expr PRECEDING  */
#line 16594 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_OFFSET_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 51541 "gram.c"
    break;

  case 2249: /* frame_bound: a_expr FOLLOWING  */
#line 16603 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_OFFSET_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 51554 "gram.c"
    break;

  case 2250: /* opt_window_exclusion_clause: EXCLUDE CURRENT_P ROW  */
#line 16614 "gram.y"
                                                { (yyval.ival) = FRAMEOPTION_EXCLUDE_CURRENT_ROW; }
#line 51560 "gram.c"
    break;

  case 2251: /* opt_window_exclusion_clause: EXCLUDE GROUP_P  */
#line 16615 "gram.y"
                                                        { (yyval.ival) = FRAMEOPTION_EXCLUDE_GROUP; }
#line 51566 "gram.c"
    break;

  case 2252: /* opt_window_exclusion_clause: EXCLUDE TIES  */
#line 16616 "gram.y"
                                                        { (yyval.ival) = FRAMEOPTION_EXCLUDE_TIES; }
#line 51572 "gram.c"
    break;

  case 2253: /* opt_window_exclusion_clause: EXCLUDE NO OTHERS  */
#line 16617 "gram.y"
                                                        { (yyval.ival) = 0; }
#line 51578 "gram.c"
    break;

  case 2254: /* opt_window_exclusion_clause: %empty  */
#line 16618 "gram.y"
                                                                { (yyval.ival) = 0; }
#line 51584 "gram.c"
    break;

  case 2255: /* row: ROW '(' expr_list ')'  */
#line 16632 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 51590 "gram.c"
    break;

  case 2256: /* row: ROW '(' ')'  */
#line 16633 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 51596 "gram.c"
    break;

  case 2257: /* row: '(' expr_list ',' a_expr ')'  */
#line 16634 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 51602 "gram.c"
    break;

  case 2258: /* explicit_row: ROW '(' expr_list ')'  */
#line 16637 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 51608 "gram.c"
    break;

  case 2259: /* explicit_row: ROW '(' ')'  */
#line 16638 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 51614 "gram.c"
    break;

  case 2260: /* implicit_row: '(' expr_list ',' a_expr ')'  */
#line 16641 "gram.y"
                                                        { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 51620 "gram.c"
    break;

  case 2261: /* sub_type: ANY  */
#line 16644 "gram.y"
                                                                                                { (yyval.ival) = ANY_SUBLINK; }
#line 51626 "gram.c"
    break;

  case 2262: /* sub_type: SOME  */
#line 16645 "gram.y"
                                                                                                { (yyval.ival) = ANY_SUBLINK; }
#line 51632 "gram.c"
    break;

  case 2263: /* sub_type: ALL  */
#line 16646 "gram.y"
                                                                                                { (yyval.ival) = ALL_SUBLINK; }
#line 51638 "gram.c"
    break;

  case 2264: /* all_Op: Op  */
#line 16649 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 51644 "gram.c"
    break;

  case 2265: /* all_Op: MathOp  */
#line 16650 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 51650 "gram.c"
    break;

  case 2266: /* MathOp: '+'  */
#line 16653 "gram.y"
                                                                                        { (yyval.str) = "+"; }
#line 51656 "gram.c"
    break;

  case 2267: /* MathOp: '-'  */
#line 16654 "gram.y"
                                                                                                { (yyval.str) = "-"; }
#line 51662 "gram.c"
    break;

  case 2268: /* MathOp: '*'  */
#line 16655 "gram.y"
                                                                                                { (yyval.str) = "*"; }
#line 51668 "gram.c"
    break;

  case 2269: /* MathOp: '/'  */
#line 16656 "gram.y"
                                                                                                { (yyval.str) = "/"; }
#line 51674 "gram.c"
    break;

  case 2270: /* MathOp: '%'  */
#line 16657 "gram.y"
                                                                                                { (yyval.str) = "%"; }
#line 51680 "gram.c"
    break;

  case 2271: /* MathOp: '^'  */
#line 16658 "gram.y"
                                                                                                { (yyval.str) = "^"; }
#line 51686 "gram.c"
    break;

  case 2272: /* MathOp: '<'  */
#line 16659 "gram.y"
                                                                                                { (yyval.str) = "<"; }
#line 51692 "gram.c"
    break;

  case 2273: /* MathOp: '>'  */
#line 16660 "gram.y"
                                                                                                { (yyval.str) = ">"; }
#line 51698 "gram.c"
    break;

  case 2274: /* MathOp: '='  */
#line 16661 "gram.y"
                                                                                                { (yyval.str) = "="; }
#line 51704 "gram.c"
    break;

  case 2275: /* MathOp: LESS_EQUALS  */
#line 16662 "gram.y"
                                                                                        { (yyval.str) = "<="; }
#line 51710 "gram.c"
    break;

  case 2276: /* MathOp: GREATER_EQUALS  */
#line 16663 "gram.y"
                                                                                        { (yyval.str) = ">="; }
#line 51716 "gram.c"
    break;

  case 2277: /* MathOp: NOT_EQUALS  */
#line 16664 "gram.y"
                                                                                        { (yyval.str) = "<>"; }
#line 51722 "gram.c"
    break;

  case 2278: /* qual_Op: Op  */
#line 16668 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 51728 "gram.c"
    break;

  case 2279: /* qual_Op: OPERATOR '(' any_operator ')'  */
#line 16670 "gram.y"
                                        { (yyval.list) = (yyvsp[-1].list); }
#line 51734 "gram.c"
    break;

  case 2280: /* qual_all_Op: all_Op  */
#line 16675 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 51740 "gram.c"
    break;

  case 2281: /* qual_all_Op: OPERATOR '(' any_operator ')'  */
#line 16677 "gram.y"
                                        { (yyval.list) = (yyvsp[-1].list); }
#line 51746 "gram.c"
    break;

  case 2282: /* subquery_Op: all_Op  */
#line 16682 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 51752 "gram.c"
    break;

  case 2283: /* subquery_Op: OPERATOR '(' any_operator ')'  */
#line 16684 "gram.y"
                                        { (yyval.list) = (yyvsp[-1].list); }
#line 51758 "gram.c"
    break;

  case 2284: /* subquery_Op: LIKE  */
#line 16686 "gram.y"
                                        { (yyval.list) = list_make1(makeString("~~")); }
#line 51764 "gram.c"
    break;

  case 2285: /* subquery_Op: NOT_LA LIKE  */
#line 16688 "gram.y"
                                        { (yyval.list) = list_make1(makeString("!~~")); }
#line 51770 "gram.c"
    break;

  case 2286: /* subquery_Op: ILIKE  */
#line 16690 "gram.y"
                                        { (yyval.list) = list_make1(makeString("~~*")); }
#line 51776 "gram.c"
    break;

  case 2287: /* subquery_Op: NOT_LA ILIKE  */
#line 16692 "gram.y"
                                        { (yyval.list) = list_make1(makeString("!~~*")); }
#line 51782 "gram.c"
    break;

  case 2288: /* expr_list: a_expr  */
#line 16704 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 51790 "gram.c"
    break;

  case 2289: /* expr_list: expr_list ',' a_expr  */
#line 16708 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 51798 "gram.c"
    break;

  case 2290: /* func_arg_list: func_arg_expr  */
#line 16715 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 51806 "gram.c"
    break;

  case 2291: /* func_arg_list: func_arg_list ',' func_arg_expr  */
#line 16719 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 51814 "gram.c"
    break;

  case 2292: /* func_arg_expr: a_expr  */
#line 16725 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 51822 "gram.c"
    break;

  case 2293: /* func_arg_expr: param_name COLON_EQUALS a_expr  */
#line 16729 "gram.y"
                                {
					NamedArgExpr *na = makeNode(NamedArgExpr);

					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 51836 "gram.c"
    break;

  case 2294: /* func_arg_expr: param_name EQUALS_GREATER a_expr  */
#line 16739 "gram.y"
                                {
					NamedArgExpr *na = makeNode(NamedArgExpr);

					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 51850 "gram.c"
    break;

  case 2295: /* func_arg_list_opt: func_arg_list  */
#line 16750 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 51856 "gram.c"
    break;

  case 2296: /* func_arg_list_opt: %empty  */
#line 16751 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 51862 "gram.c"
    break;

  case 2297: /* type_list: Typename  */
#line 16754 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 51868 "gram.c"
    break;

  case 2298: /* type_list: type_list ',' Typename  */
#line 16755 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 51874 "gram.c"
    break;

  case 2299: /* array_expr: '[' expr_list ']'  */
#line 16759 "gram.y"
                                {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 51882 "gram.c"
    break;

  case 2300: /* array_expr: '[' array_expr_list ']'  */
#line 16763 "gram.y"
                                {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 51890 "gram.c"
    break;

  case 2301: /* array_expr: '[' ']'  */
#line 16767 "gram.y"
                                {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 51898 "gram.c"
    break;

  case 2302: /* array_expr_list: array_expr  */
#line 16772 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 51904 "gram.c"
    break;

  case 2303: /* array_expr_list: array_expr_list ',' array_expr  */
#line 16773 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 51910 "gram.c"
    break;

  case 2304: /* extract_list: extract_arg FROM a_expr  */
#line 16779 "gram.y"
                                {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 51918 "gram.c"
    break;

  case 2305: /* extract_arg: IDENT  */
#line 16788 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 51924 "gram.c"
    break;

  case 2306: /* extract_arg: YEAR_P  */
#line 16789 "gram.y"
                                                                                                { (yyval.str) = "year"; }
#line 51930 "gram.c"
    break;

  case 2307: /* extract_arg: MONTH_P  */
#line 16790 "gram.y"
                                                                                                { (yyval.str) = "month"; }
#line 51936 "gram.c"
    break;

  case 2308: /* extract_arg: DAY_P  */
#line 16791 "gram.y"
                                                                                                { (yyval.str) = "day"; }
#line 51942 "gram.c"
    break;

  case 2309: /* extract_arg: HOUR_P  */
#line 16792 "gram.y"
                                                                                                { (yyval.str) = "hour"; }
#line 51948 "gram.c"
    break;

  case 2310: /* extract_arg: MINUTE_P  */
#line 16793 "gram.y"
                                                                                                { (yyval.str) = "minute"; }
#line 51954 "gram.c"
    break;

  case 2311: /* extract_arg: SECOND_P  */
#line 16794 "gram.y"
                                                                                                { (yyval.str) = "second"; }
#line 51960 "gram.c"
    break;

  case 2312: /* extract_arg: Sconst  */
#line 16795 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 51966 "gram.c"
    break;

  case 2313: /* unicode_normal_form: NFC  */
#line 16799 "gram.y"
                                                                                                        { (yyval.str) = "NFC"; }
#line 51972 "gram.c"
    break;

  case 2314: /* unicode_normal_form: NFD  */
#line 16800 "gram.y"
                                                                                                { (yyval.str) = "NFD"; }
#line 51978 "gram.c"
    break;

  case 2315: /* unicode_normal_form: NFKC  */
#line 16801 "gram.y"
                                                                                                { (yyval.str) = "NFKC"; }
#line 51984 "gram.c"
    break;

  case 2316: /* unicode_normal_form: NFKD  */
#line 16802 "gram.y"
                                                                                                { (yyval.str) = "NFKD"; }
#line 51990 "gram.c"
    break;

  case 2317: /* overlay_list: a_expr PLACING a_expr FROM a_expr FOR a_expr  */
#line 16808 "gram.y"
                                {
					/* overlay(A PLACING B FROM C FOR D) is converted to overlay(A, B, C, D) */
					(yyval.list) = list_make4((yyvsp[-6].node), (yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 51999 "gram.c"
    break;

  case 2318: /* overlay_list: a_expr PLACING a_expr FROM a_expr  */
#line 16813 "gram.y"
                                {
					/* overlay(A PLACING B FROM C) is converted to overlay(A, B, C) */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 52008 "gram.c"
    break;

  case 2319: /* position_list: b_expr IN_P b_expr  */
#line 16821 "gram.y"
                                                                                        { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 52014 "gram.c"
    break;

  case 2320: /* substr_list: a_expr FROM a_expr FOR a_expr  */
#line 16843 "gram.y"
                                {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 52022 "gram.c"
    break;

  case 2321: /* substr_list: a_expr FOR a_expr FROM a_expr  */
#line 16847 "gram.y"
                                {
					/* not legal per SQL, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[0].node), (yyvsp[-2].node));
				}
#line 52031 "gram.c"
    break;

  case 2322: /* substr_list: a_expr FROM a_expr  */
#line 16852 "gram.y"
                                {
					/*
					 * Because we aren't restricting data types here, this
					 * syntax can end up resolving to textregexsubstr().
					 * We've historically allowed that to happen, so continue
					 * to accept it.  However, ruleutils.c will reverse-list
					 * such a call in regular function call syntax.
					 */
					(yyval.list) = list_make2((yyvsp[-2].node), (yyvsp[0].node));
				}
#line 52046 "gram.c"
    break;

  case 2323: /* substr_list: a_expr FOR a_expr  */
#line 16863 "gram.y"
                                {
					/* not legal per SQL */

					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-2].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 52067 "gram.c"
    break;

  case 2324: /* substr_list: a_expr SIMILAR a_expr ESCAPE a_expr  */
#line 16880 "gram.y"
                                {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 52075 "gram.c"
    break;

  case 2325: /* trim_list: a_expr FROM expr_list  */
#line 16885 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 52081 "gram.c"
    break;

  case 2326: /* trim_list: FROM expr_list  */
#line 16886 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 52087 "gram.c"
    break;

  case 2327: /* trim_list: expr_list  */
#line 16887 "gram.y"
                                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 52093 "gram.c"
    break;

  case 2328: /* in_expr: select_with_parens  */
#line 16891 "gram.y"
                                {
					SubLink	   *n = makeNode(SubLink);

					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *) n;
				}
#line 52105 "gram.c"
    break;

  case 2329: /* in_expr: '(' expr_list ')'  */
#line 16898 "gram.y"
                                                                                        { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 52111 "gram.c"
    break;

  case 2330: /* case_expr: CASE case_arg when_clause_list case_default END_P  */
#line 16909 "gram.y"
                                {
					CaseExpr   *c = makeNode(CaseExpr);

					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *) c;
				}
#line 52126 "gram.c"
    break;

  case 2331: /* when_clause_list: when_clause  */
#line 16923 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 52132 "gram.c"
    break;

  case 2332: /* when_clause_list: when_clause_list when_clause  */
#line 16924 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 52138 "gram.c"
    break;

  case 2333: /* when_clause: WHEN a_expr THEN a_expr  */
#line 16929 "gram.y"
                                {
					CaseWhen   *w = makeNode(CaseWhen);

					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *) w;
				}
#line 52151 "gram.c"
    break;

  case 2334: /* case_default: ELSE a_expr  */
#line 16940 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 52157 "gram.c"
    break;

  case 2335: /* case_default: %empty  */
#line 16941 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 52163 "gram.c"
    break;

  case 2336: /* case_arg: a_expr  */
#line 16944 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 52169 "gram.c"
    break;

  case 2337: /* case_arg: %empty  */
#line 16945 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 52175 "gram.c"
    break;

  case 2338: /* columnref: ColId  */
#line 16949 "gram.y"
                                {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 52183 "gram.c"
    break;

  case 2339: /* columnref: ColId indirection  */
#line 16953 "gram.y"
                                {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 52191 "gram.c"
    break;

  case 2340: /* indirection_el: '.' attr_name  */
#line 16960 "gram.y"
                                {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 52199 "gram.c"
    break;

  case 2341: /* indirection_el: '.' '*'  */
#line 16964 "gram.y"
                                {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 52207 "gram.c"
    break;

  case 2342: /* indirection_el: '[' a_expr ']'  */
#line 16968 "gram.y"
                                {
					A_Indices *ai = makeNode(A_Indices);

					ai->is_slice = false;
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 52220 "gram.c"
    break;

  case 2343: /* indirection_el: '[' opt_slice_bound ':' opt_slice_bound ']'  */
#line 16977 "gram.y"
                                {
					A_Indices *ai = makeNode(A_Indices);

					ai->is_slice = true;
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 52233 "gram.c"
    break;

  case 2344: /* opt_slice_bound: a_expr  */
#line 16988 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 52239 "gram.c"
    break;

  case 2345: /* opt_slice_bound: %empty  */
#line 16989 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 52245 "gram.c"
    break;

  case 2346: /* indirection: indirection_el  */
#line 16993 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 52251 "gram.c"
    break;

  case 2347: /* indirection: indirection indirection_el  */
#line 16994 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 52257 "gram.c"
    break;

  case 2348: /* opt_indirection: %empty  */
#line 16998 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 52263 "gram.c"
    break;

  case 2349: /* opt_indirection: opt_indirection indirection_el  */
#line 16999 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 52269 "gram.c"
    break;

  case 2352: /* json_passing_clause_opt: PASSING json_arguments  */
#line 17008 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 52275 "gram.c"
    break;

  case 2353: /* json_passing_clause_opt: %empty  */
#line 17009 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 52281 "gram.c"
    break;

  case 2354: /* json_arguments: json_argument  */
#line 17013 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 52287 "gram.c"
    break;

  case 2355: /* json_arguments: json_arguments ',' json_argument  */
#line 17014 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 52293 "gram.c"
    break;

  case 2356: /* json_argument: json_value_expr AS ColLabel  */
#line 17019 "gram.y"
                        {
				JsonArgument *n = makeNode(JsonArgument);

				n->val = (JsonValueExpr *) (yyvsp[-2].node);
				n->name = (yyvsp[0].str);
				(yyval.node) = (Node *) n;
			}
#line 52305 "gram.c"
    break;

  case 2357: /* json_wrapper_behavior: WITHOUT WRAPPER  */
#line 17030 "gram.y"
                                                                                { (yyval.ival) = JSW_NONE; }
#line 52311 "gram.c"
    break;

  case 2358: /* json_wrapper_behavior: WITHOUT ARRAY WRAPPER  */
#line 17031 "gram.y"
                                                                        { (yyval.ival) = JSW_NONE; }
#line 52317 "gram.c"
    break;

  case 2359: /* json_wrapper_behavior: WITH WRAPPER  */
#line 17032 "gram.y"
                                                                                { (yyval.ival) = JSW_UNCONDITIONAL; }
#line 52323 "gram.c"
    break;

  case 2360: /* json_wrapper_behavior: WITH ARRAY WRAPPER  */
#line 17033 "gram.y"
                                                                        { (yyval.ival) = JSW_UNCONDITIONAL; }
#line 52329 "gram.c"
    break;

  case 2361: /* json_wrapper_behavior: WITH CONDITIONAL ARRAY WRAPPER  */
#line 17034 "gram.y"
                                                                { (yyval.ival) = JSW_CONDITIONAL; }
#line 52335 "gram.c"
    break;

  case 2362: /* json_wrapper_behavior: WITH UNCONDITIONAL ARRAY WRAPPER  */
#line 17035 "gram.y"
                                                                { (yyval.ival) = JSW_UNCONDITIONAL; }
#line 52341 "gram.c"
    break;

  case 2363: /* json_wrapper_behavior: WITH CONDITIONAL WRAPPER  */
#line 17036 "gram.y"
                                                                        { (yyval.ival) = JSW_CONDITIONAL; }
#line 52347 "gram.c"
    break;

  case 2364: /* json_wrapper_behavior: WITH UNCONDITIONAL WRAPPER  */
#line 17037 "gram.y"
                                                                { (yyval.ival) = JSW_UNCONDITIONAL; }
#line 52353 "gram.c"
    break;

  case 2365: /* json_wrapper_behavior: %empty  */
#line 17038 "gram.y"
                                                                                { (yyval.ival) = JSW_UNSPEC; }
#line 52359 "gram.c"
    break;

  case 2366: /* json_behavior: DEFAULT a_expr  */
#line 17043 "gram.y"
                                { (yyval.node) = (Node *) makeJsonBehavior(JSON_BEHAVIOR_DEFAULT, (yyvsp[0].node), (yylsp[-1])); }
#line 52365 "gram.c"
    break;

  case 2367: /* json_behavior: json_behavior_type  */
#line 17045 "gram.y"
                                { (yyval.node) = (Node *) makeJsonBehavior((yyvsp[0].ival), NULL, (yylsp[0])); }
#line 52371 "gram.c"
    break;

  case 2368: /* json_behavior_type: ERROR_P  */
#line 17049 "gram.y"
                                        { (yyval.ival) = JSON_BEHAVIOR_ERROR; }
#line 52377 "gram.c"
    break;

  case 2369: /* json_behavior_type: NULL_P  */
#line 17050 "gram.y"
                                        { (yyval.ival) = JSON_BEHAVIOR_NULL; }
#line 52383 "gram.c"
    break;

  case 2370: /* json_behavior_type: TRUE_P  */
#line 17051 "gram.y"
                                        { (yyval.ival) = JSON_BEHAVIOR_TRUE; }
#line 52389 "gram.c"
    break;

  case 2371: /* json_behavior_type: FALSE_P  */
#line 17052 "gram.y"
                                        { (yyval.ival) = JSON_BEHAVIOR_FALSE; }
#line 52395 "gram.c"
    break;

  case 2372: /* json_behavior_type: UNKNOWN  */
#line 17053 "gram.y"
                                        { (yyval.ival) = JSON_BEHAVIOR_UNKNOWN; }
#line 52401 "gram.c"
    break;

  case 2373: /* json_behavior_type: EMPTY_P ARRAY  */
#line 17054 "gram.y"
                                        { (yyval.ival) = JSON_BEHAVIOR_EMPTY_ARRAY; }
#line 52407 "gram.c"
    break;

  case 2374: /* json_behavior_type: EMPTY_P OBJECT_P  */
#line 17055 "gram.y"
                                                { (yyval.ival) = JSON_BEHAVIOR_EMPTY_OBJECT; }
#line 52413 "gram.c"
    break;

  case 2375: /* json_behavior_type: EMPTY_P  */
#line 17057 "gram.y"
                                        { (yyval.ival) = JSON_BEHAVIOR_EMPTY_ARRAY; }
#line 52419 "gram.c"
    break;

  case 2376: /* json_behavior_clause_opt: json_behavior ON EMPTY_P  */
#line 17062 "gram.y"
                                { (yyval.list) = list_make2((yyvsp[-2].node), NULL); }
#line 52425 "gram.c"
    break;

  case 2377: /* json_behavior_clause_opt: json_behavior ON ERROR_P  */
#line 17064 "gram.y"
                                { (yyval.list) = list_make2(NULL, (yyvsp[-2].node)); }
#line 52431 "gram.c"
    break;

  case 2378: /* json_behavior_clause_opt: json_behavior ON EMPTY_P json_behavior ON ERROR_P  */
#line 17066 "gram.y"
                                { (yyval.list) = list_make2((yyvsp[-5].node), (yyvsp[-2].node)); }
#line 52437 "gram.c"
    break;

  case 2379: /* json_behavior_clause_opt: %empty  */
#line 17068 "gram.y"
                                { (yyval.list) = list_make2(NULL, NULL); }
#line 52443 "gram.c"
    break;

  case 2380: /* json_on_error_clause_opt: json_behavior ON ERROR_P  */
#line 17073 "gram.y"
                                { (yyval.node) = (yyvsp[-2].node); }
#line 52449 "gram.c"
    break;

  case 2381: /* json_on_error_clause_opt: %empty  */
#line 17075 "gram.y"
                                { (yyval.node) = NULL; }
#line 52455 "gram.c"
    break;

  case 2382: /* json_value_expr: a_expr json_format_clause_opt  */
#line 17080 "gram.y"
                        {
				/* formatted_expr will be set during parse-analysis. */
				(yyval.node) = (Node *) makeJsonValueExpr((Expr *) (yyvsp[-1].node), NULL,
												castNode(JsonFormat, (yyvsp[0].node)));
			}
#line 52465 "gram.c"
    break;

  case 2383: /* json_format_clause: FORMAT_LA JSON ENCODING name  */
#line 17089 "gram.y"
                                {
					int		encoding;

					if (!pg_strcasecmp((yyvsp[0].str), "utf8"))
						encoding = JS_ENC_UTF8;
					else if (!pg_strcasecmp((yyvsp[0].str), "utf16"))
						encoding = JS_ENC_UTF16;
					else if (!pg_strcasecmp((yyvsp[0].str), "utf32"))
						encoding = JS_ENC_UTF32;
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("unrecognized JSON encoding: %s", (yyvsp[0].str)),
								 parser_errposition((yylsp[0]))));

					(yyval.node) = (Node *) makeJsonFormat(JS_FORMAT_JSON, encoding, (yylsp[-3]));
				}
#line 52487 "gram.c"
    break;

  case 2384: /* json_format_clause: FORMAT_LA JSON  */
#line 17107 "gram.y"
                                {
					(yyval.node) = (Node *) makeJsonFormat(JS_FORMAT_JSON, JS_ENC_DEFAULT, (yylsp[-1]));
				}
#line 52495 "gram.c"
    break;

  case 2385: /* json_format_clause_opt: json_format_clause  */
#line 17114 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 52503 "gram.c"
    break;

  case 2386: /* json_format_clause_opt: %empty  */
#line 17118 "gram.y"
                                {
					(yyval.node) = (Node *) makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);
				}
#line 52511 "gram.c"
    break;

  case 2387: /* json_quotes_clause_opt: KEEP QUOTES ON SCALAR STRING_P  */
#line 17124 "gram.y"
                                                                { (yyval.ival) = JS_QUOTES_KEEP; }
#line 52517 "gram.c"
    break;

  case 2388: /* json_quotes_clause_opt: KEEP QUOTES  */
#line 17125 "gram.y"
                                                                                { (yyval.ival) = JS_QUOTES_KEEP; }
#line 52523 "gram.c"
    break;

  case 2389: /* json_quotes_clause_opt: OMIT QUOTES ON SCALAR STRING_P  */
#line 17126 "gram.y"
                                                                { (yyval.ival) = JS_QUOTES_OMIT; }
#line 52529 "gram.c"
    break;

  case 2390: /* json_quotes_clause_opt: OMIT QUOTES  */
#line 17127 "gram.y"
                                                                                { (yyval.ival) = JS_QUOTES_OMIT; }
#line 52535 "gram.c"
    break;

  case 2391: /* json_quotes_clause_opt: %empty  */
#line 17128 "gram.y"
                                                                                { (yyval.ival) = JS_QUOTES_UNSPEC; }
#line 52541 "gram.c"
    break;

  case 2392: /* json_returning_clause_opt: RETURNING Typename json_format_clause_opt  */
#line 17133 "gram.y"
                                {
					JsonOutput *n = makeNode(JsonOutput);

					n->typeName = (yyvsp[-1].typnam);
					n->returning = makeNode(JsonReturning);
					n->returning->format = (JsonFormat *) (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 52554 "gram.c"
    break;

  case 2393: /* json_returning_clause_opt: %empty  */
#line 17141 "gram.y"
                                                                                        { (yyval.node) = NULL; }
#line 52560 "gram.c"
    break;

  case 2394: /* json_predicate_type_constraint: JSON  */
#line 17155 "gram.y"
                                                                                { (yyval.ival) = JS_TYPE_ANY; }
#line 52566 "gram.c"
    break;

  case 2395: /* json_predicate_type_constraint: JSON VALUE_P  */
#line 17156 "gram.y"
                                                                                        { (yyval.ival) = JS_TYPE_ANY; }
#line 52572 "gram.c"
    break;

  case 2396: /* json_predicate_type_constraint: JSON ARRAY  */
#line 17157 "gram.y"
                                                                                        { (yyval.ival) = JS_TYPE_ARRAY; }
#line 52578 "gram.c"
    break;

  case 2397: /* json_predicate_type_constraint: JSON OBJECT_P  */
#line 17158 "gram.y"
                                                                                        { (yyval.ival) = JS_TYPE_OBJECT; }
#line 52584 "gram.c"
    break;

  case 2398: /* json_predicate_type_constraint: JSON SCALAR  */
#line 17159 "gram.y"
                                                                                        { (yyval.ival) = JS_TYPE_SCALAR; }
#line 52590 "gram.c"
    break;

  case 2399: /* json_key_uniqueness_constraint_opt: WITH UNIQUE KEYS  */
#line 17168 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 52596 "gram.c"
    break;

  case 2400: /* json_key_uniqueness_constraint_opt: WITH UNIQUE  */
#line 17169 "gram.y"
                                                                                { (yyval.boolean) = true; }
#line 52602 "gram.c"
    break;

  case 2401: /* json_key_uniqueness_constraint_opt: WITHOUT UNIQUE KEYS  */
#line 17170 "gram.y"
                                                                                        { (yyval.boolean) = false; }
#line 52608 "gram.c"
    break;

  case 2402: /* json_key_uniqueness_constraint_opt: WITHOUT UNIQUE  */
#line 17171 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 52614 "gram.c"
    break;

  case 2403: /* json_key_uniqueness_constraint_opt: %empty  */
#line 17172 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 52620 "gram.c"
    break;

  case 2404: /* json_name_and_value_list: json_name_and_value  */
#line 17177 "gram.y"
                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 52626 "gram.c"
    break;

  case 2405: /* json_name_and_value_list: json_name_and_value_list ',' json_name_and_value  */
#line 17179 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 52632 "gram.c"
    break;

  case 2406: /* json_name_and_value: c_expr VALUE_P json_value_expr  */
#line 17189 "gram.y"
                                { (yyval.node) = makeJsonKeyValue((yyvsp[-2].node), (yyvsp[0].node)); }
#line 52638 "gram.c"
    break;

  case 2407: /* json_name_and_value: a_expr ':' json_value_expr  */
#line 17192 "gram.y"
                                { (yyval.node) = makeJsonKeyValue((yyvsp[-2].node), (yyvsp[0].node)); }
#line 52644 "gram.c"
    break;

  case 2408: /* json_object_constructor_null_clause_opt: NULL_P ON NULL_P  */
#line 17197 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 52650 "gram.c"
    break;

  case 2409: /* json_object_constructor_null_clause_opt: ABSENT ON NULL_P  */
#line 17198 "gram.y"
                                                                                { (yyval.boolean) = true; }
#line 52656 "gram.c"
    break;

  case 2410: /* json_object_constructor_null_clause_opt: %empty  */
#line 17199 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 52662 "gram.c"
    break;

  case 2411: /* json_array_constructor_null_clause_opt: NULL_P ON NULL_P  */
#line 17203 "gram.y"
                                                                                        { (yyval.boolean) = false; }
#line 52668 "gram.c"
    break;

  case 2412: /* json_array_constructor_null_clause_opt: ABSENT ON NULL_P  */
#line 17204 "gram.y"
                                                                                        { (yyval.boolean) = true; }
#line 52674 "gram.c"
    break;

  case 2413: /* json_array_constructor_null_clause_opt: %empty  */
#line 17205 "gram.y"
                                                                                        { (yyval.boolean) = true; }
#line 52680 "gram.c"
    break;

  case 2414: /* json_value_expr_list: json_value_expr  */
#line 17209 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 52686 "gram.c"
    break;

  case 2415: /* json_value_expr_list: json_value_expr_list ',' json_value_expr  */
#line 17210 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));}
#line 52692 "gram.c"
    break;

  case 2416: /* json_aggregate_func: JSON_OBJECTAGG '(' json_name_and_value json_object_constructor_null_clause_opt json_key_uniqueness_constraint_opt json_returning_clause_opt ')'  */
#line 17220 "gram.y"
                                {
					JsonObjectAgg *n = makeNode(JsonObjectAgg);

					n->arg = (JsonKeyValue *) (yyvsp[-4].node);
					n->absent_on_null = (yyvsp[-3].boolean);
					n->unique = (yyvsp[-2].boolean);
					n->constructor = makeNode(JsonAggConstructor);
					n->constructor->output = (JsonOutput *) (yyvsp[-1].node);
					n->constructor->agg_order = NULL;
					n->constructor->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 52709 "gram.c"
    break;

  case 2417: /* json_aggregate_func: JSON_ARRAYAGG '(' json_value_expr json_array_aggregate_order_by_clause_opt json_array_constructor_null_clause_opt json_returning_clause_opt ')'  */
#line 17238 "gram.y"
                                {
					JsonArrayAgg *n = makeNode(JsonArrayAgg);

					n->arg = (JsonValueExpr *) (yyvsp[-4].node);
					n->absent_on_null = (yyvsp[-2].boolean);
					n->constructor = makeNode(JsonAggConstructor);
					n->constructor->agg_order = (yyvsp[-3].list);
					n->constructor->output = (JsonOutput *) (yyvsp[-1].node);
					n->constructor->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 52725 "gram.c"
    break;

  case 2418: /* json_array_aggregate_order_by_clause_opt: ORDER BY sortby_list  */
#line 17252 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 52731 "gram.c"
    break;

  case 2419: /* json_array_aggregate_order_by_clause_opt: %empty  */
#line 17253 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 52737 "gram.c"
    break;

  case 2420: /* opt_target_list: target_list  */
#line 17262 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 52743 "gram.c"
    break;

  case 2421: /* opt_target_list: %empty  */
#line 17263 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 52749 "gram.c"
    break;

  case 2422: /* target_list: target_el  */
#line 17267 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 52755 "gram.c"
    break;

  case 2423: /* target_list: target_list ',' target_el  */
#line 17268 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 52761 "gram.c"
    break;

  case 2424: /* target_el: a_expr AS ColLabel  */
#line 17272 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 52773 "gram.c"
    break;

  case 2425: /* target_el: a_expr BareColLabel  */
#line 17280 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 52785 "gram.c"
    break;

  case 2426: /* target_el: a_expr  */
#line 17288 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 52797 "gram.c"
    break;

  case 2427: /* target_el: '*'  */
#line 17296 "gram.y"
                                {
					ColumnRef  *n = makeNode(ColumnRef);

					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 52814 "gram.c"
    break;

  case 2428: /* qualified_name_list: qualified_name  */
#line 17318 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 52820 "gram.c"
    break;

  case 2429: /* qualified_name_list: qualified_name_list ',' qualified_name  */
#line 17319 "gram.y"
                                                                 { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 52826 "gram.c"
    break;

  case 2430: /* qualified_name: ColId  */
#line 17331 "gram.y"
                                {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 52834 "gram.c"
    break;

  case 2431: /* qualified_name: ColId indirection  */
#line 17335 "gram.y"
                                {
					(yyval.range) = makeRangeVarFromQualifiedName((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 52842 "gram.c"
    break;

  case 2432: /* name_list: name  */
#line 17341 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 52848 "gram.c"
    break;

  case 2433: /* name_list: name_list ',' name  */
#line 17343 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 52854 "gram.c"
    break;

  case 2434: /* name: ColId  */
#line 17347 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 52860 "gram.c"
    break;

  case 2435: /* attr_name: ColLabel  */
#line 17349 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 52866 "gram.c"
    break;

  case 2436: /* file_name: Sconst  */
#line 17351 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 52872 "gram.c"
    break;

  case 2437: /* func_name: type_function_name  */
#line 17362 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 52878 "gram.c"
    break;

  case 2438: /* func_name: ColId indirection  */
#line 17364 "gram.y"
                                        {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 52887 "gram.c"
    break;

  case 2439: /* AexprConst: Iconst  */
#line 17375 "gram.y"
                                {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 52895 "gram.c"
    break;

  case 2440: /* AexprConst: FCONST  */
#line 17379 "gram.y"
                                {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 52903 "gram.c"
    break;

  case 2441: /* AexprConst: Sconst  */
#line 17383 "gram.y"
                                {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 52911 "gram.c"
    break;

  case 2442: /* AexprConst: BCONST  */
#line 17387 "gram.y"
                                {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 52919 "gram.c"
    break;

  case 2443: /* AexprConst: XCONST  */
#line 17391 "gram.y"
                                {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 52932 "gram.c"
    break;

  case 2444: /* AexprConst: func_name Sconst  */
#line 17400 "gram.y"
                                {
					/* generic type 'literal' syntax */
					TypeName   *t = makeTypeNameFromNameList((yyvsp[-1].list));

					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 52944 "gram.c"
    break;

  case 2445: /* AexprConst: func_name '(' func_arg_list opt_sort_clause ')' Sconst  */
#line 17408 "gram.y"
                                {
					/* generic syntax with a type modifier */
					TypeName   *t = makeTypeNameFromNameList((yyvsp[-5].list));
					ListCell   *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[-3].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[-2].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[-2]))));

					t->typmods = (yyvsp[-3].list);
					t->location = (yylsp[-5]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 52980 "gram.c"
    break;

  case 2446: /* AexprConst: ConstTypename Sconst  */
#line 17440 "gram.y"
                                {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 52988 "gram.c"
    break;

  case 2447: /* AexprConst: ConstInterval Sconst opt_interval  */
#line 17444 "gram.y"
                                {
					TypeName   *t = (yyvsp[-2].typnam);

					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 52999 "gram.c"
    break;

  case 2448: /* AexprConst: ConstInterval '(' Iconst ')' Sconst  */
#line 17451 "gram.y"
                                {
					TypeName   *t = (yyvsp[-4].typnam);

					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 53011 "gram.c"
    break;

  case 2449: /* AexprConst: TRUE_P  */
#line 17459 "gram.y"
                                {
					(yyval.node) = makeBoolAConst(true, (yylsp[0]));
				}
#line 53019 "gram.c"
    break;

  case 2450: /* AexprConst: FALSE_P  */
#line 17463 "gram.y"
                                {
					(yyval.node) = makeBoolAConst(false, (yylsp[0]));
				}
#line 53027 "gram.c"
    break;

  case 2451: /* AexprConst: NULL_P  */
#line 17467 "gram.y"
                                {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 53035 "gram.c"
    break;

  case 2452: /* Iconst: ICONST  */
#line 17472 "gram.y"
                                                                                        { (yyval.ival) = (yyvsp[0].ival); }
#line 53041 "gram.c"
    break;

  case 2453: /* Sconst: SCONST  */
#line 17473 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 53047 "gram.c"
    break;

  case 2454: /* SignedIconst: Iconst  */
#line 17475 "gram.y"
                                                                                { (yyval.ival) = (yyvsp[0].ival); }
#line 53053 "gram.c"
    break;

  case 2455: /* SignedIconst: '+' Iconst  */
#line 17476 "gram.y"
                                                                                        { (yyval.ival) = + (yyvsp[0].ival); }
#line 53059 "gram.c"
    break;

  case 2456: /* SignedIconst: '-' Iconst  */
#line 17477 "gram.y"
                                                                                        { (yyval.ival) = - (yyvsp[0].ival); }
#line 53065 "gram.c"
    break;

  case 2457: /* RoleId: RoleSpec  */
#line 17482 "gram.y"
                                {
					RoleSpec   *spc = (RoleSpec *) (yyvsp[0].rolespec);

					switch (spc->roletype)
					{
						case ROLESPEC_CSTRING:
							(yyval.str) = spc->rolename;
							break;
						case ROLESPEC_PUBLIC:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"public"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_SESSION_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"SESSION_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_ROLE:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_ROLE"),
									 parser_errposition((yylsp[0]))));
							break;
					}
				}
#line 53108 "gram.c"
    break;

  case 2458: /* RoleSpec: NonReservedWord  */
#line 17523 "gram.y"
                                {
					/*
					 * "public" and "none" are not keywords, but they must
					 * be treated specially here.
					 */
					RoleSpec   *n;

					if (strcmp((yyvsp[0].str), "public") == 0)
					{
						n = (RoleSpec *) makeRoleSpec(ROLESPEC_PUBLIC, (yylsp[0]));
						n->roletype = ROLESPEC_PUBLIC;
					}
					else if (strcmp((yyvsp[0].str), "none") == 0)
					{
						ereport(ERROR,
								(errcode(ERRCODE_RESERVED_NAME),
								 errmsg("role name \"%s\" is reserved",
										"none"),
								 parser_errposition((yylsp[0]))));
					}
					else
					{
						n = makeRoleSpec(ROLESPEC_CSTRING, (yylsp[0]));
						n->rolename = pstrdup((yyvsp[0].str));
					}
					(yyval.rolespec) = n;
				}
#line 53140 "gram.c"
    break;

  case 2459: /* RoleSpec: CURRENT_ROLE  */
#line 17551 "gram.y"
                                {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_ROLE, (yylsp[0]));
				}
#line 53148 "gram.c"
    break;

  case 2460: /* RoleSpec: CURRENT_USER  */
#line 17555 "gram.y"
                                {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0]));
				}
#line 53156 "gram.c"
    break;

  case 2461: /* RoleSpec: SESSION_USER  */
#line 17559 "gram.y"
                                {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_SESSION_USER, (yylsp[0]));
				}
#line 53164 "gram.c"
    break;

  case 2462: /* role_list: RoleSpec  */
#line 17565 "gram.y"
                                { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 53170 "gram.c"
    break;

  case 2463: /* role_list: role_list ',' RoleSpec  */
#line 17567 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 53176 "gram.c"
    break;

  case 2464: /* PLpgSQL_Expr: opt_distinct_clause opt_target_list from_clause where_clause group_clause having_clause window_clause opt_sort_clause opt_select_limit opt_for_locking_clause  */
#line 17584 "gram.y"
                                {
					SelectStmt *n = makeNode(SelectStmt);

					n->distinctClause = (yyvsp[-9].list);
					n->targetList = (yyvsp[-8].list);
					n->fromClause = (yyvsp[-7].list);
					n->whereClause = (yyvsp[-6].node);
					n->groupClause = ((yyvsp[-5].groupclause))->list;
					n->groupDistinct = ((yyvsp[-5].groupclause))->distinct;
					n->havingClause = (yyvsp[-4].node);
					n->windowClause = (yyvsp[-3].list);
					n->sortClause = (yyvsp[-2].list);
					if ((yyvsp[-1].selectlimit))
					{
						n->limitOffset = (yyvsp[-1].selectlimit)->limitOffset;
						n->limitCount = (yyvsp[-1].selectlimit)->limitCount;
						if (!n->sortClause &&
							(yyvsp[-1].selectlimit)->limitOption == LIMIT_OPTION_WITH_TIES)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("WITH TIES cannot be specified without ORDER BY clause"),
									 parser_errposition((yyvsp[-1].selectlimit)->optionLoc)));
						n->limitOption = (yyvsp[-1].selectlimit)->limitOption;
					}
					n->lockingClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 53208 "gram.c"
    break;

  case 2465: /* PLAssignStmt: plassign_target opt_indirection plassign_equals PLpgSQL_Expr  */
#line 17618 "gram.y"
                                {
					PLAssignStmt *n = makeNode(PLAssignStmt);

					n->name = (yyvsp[-3].str);
					n->indirection = check_indirection((yyvsp[-2].list), yyscanner);
					/* nnames will be filled by calling production */
					n->val = (SelectStmt *) (yyvsp[0].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 53223 "gram.c"
    break;

  case 2466: /* plassign_target: ColId  */
#line 17630 "gram.y"
                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 53229 "gram.c"
    break;

  case 2467: /* plassign_target: PARAM  */
#line 17631 "gram.y"
                                                                                        { (yyval.str) = psprintf("$%d", (yyvsp[0].ival)); }
#line 53235 "gram.c"
    break;

  case 2470: /* ColId: IDENT  */
#line 17652 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 53241 "gram.c"
    break;

  case 2471: /* ColId: unreserved_keyword  */
#line 17653 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53247 "gram.c"
    break;

  case 2472: /* ColId: col_name_keyword  */
#line 17654 "gram.y"
                                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53253 "gram.c"
    break;

  case 2473: /* type_function_name: IDENT  */
#line 17659 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 53259 "gram.c"
    break;

  case 2474: /* type_function_name: unreserved_keyword  */
#line 17660 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53265 "gram.c"
    break;

  case 2475: /* type_function_name: type_func_name_keyword  */
#line 17661 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53271 "gram.c"
    break;

  case 2476: /* NonReservedWord: IDENT  */
#line 17666 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 53277 "gram.c"
    break;

  case 2477: /* NonReservedWord: unreserved_keyword  */
#line 17667 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53283 "gram.c"
    break;

  case 2478: /* NonReservedWord: col_name_keyword  */
#line 17668 "gram.y"
                                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53289 "gram.c"
    break;

  case 2479: /* NonReservedWord: type_func_name_keyword  */
#line 17669 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53295 "gram.c"
    break;

  case 2480: /* ColLabel: IDENT  */
#line 17675 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 53301 "gram.c"
    break;

  case 2481: /* ColLabel: unreserved_keyword  */
#line 17676 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53307 "gram.c"
    break;

  case 2482: /* ColLabel: col_name_keyword  */
#line 17677 "gram.y"
                                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53313 "gram.c"
    break;

  case 2483: /* ColLabel: type_func_name_keyword  */
#line 17678 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53319 "gram.c"
    break;

  case 2484: /* ColLabel: reserved_keyword  */
#line 17679 "gram.y"
                                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53325 "gram.c"
    break;

  case 2485: /* BareColLabel: IDENT  */
#line 17685 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 53331 "gram.c"
    break;

  case 2486: /* BareColLabel: bare_label_keyword  */
#line 17686 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53337 "gram.c"
    break;


#line 53341 "gram.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 18704 "gram.y"


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static RawStmt *
makeRawStmt(Node *stmt, int stmt_location)
{
	RawStmt    *rs = makeNode(RawStmt);

	rs->stmt = stmt;
	rs->stmt_location = stmt_location;
	rs->stmt_len = 0;			/* might get changed later */
	return rs;
}

/* Adjust a RawStmt to reflect that it doesn't run to the end of the string */
static void
updateRawStmtEnd(RawStmt *rs, int end_location)
{
	/*
	 * If we already set the length, don't change it.  This is for situations
	 * like "select foo ;; select bar" where the same statement will be last
	 * in the string for more than one semicolon.
	 */
	if (rs->stmt_len > 0)
		return;

	/* OK, update length of RawStmt */
	rs->stmt_len = end_location - rs->stmt_location;
}

/*
 * Adjust a PreparableStmt to reflect that it doesn't run to the end of the
 * string.
 */
static void
updatePreparableStmtEnd(Node *n, int end_location)
{
	if (IsA(n, SelectStmt))
	{
		SelectStmt *stmt = (SelectStmt *) n;

		stmt->stmt_len = end_location - stmt->stmt_location;
	}
	else if (IsA(n, InsertStmt))
	{
		InsertStmt *stmt = (InsertStmt *) n;

		stmt->stmt_len = end_location - stmt->stmt_location;
	}
	else if (IsA(n, UpdateStmt))
	{
		UpdateStmt *stmt = (UpdateStmt *) n;

		stmt->stmt_len = end_location - stmt->stmt_location;
	}
	else if (IsA(n, DeleteStmt))
	{
		DeleteStmt *stmt = (DeleteStmt *) n;

		stmt->stmt_len = end_location - stmt->stmt_location;
	}
	else if (IsA(n, MergeStmt))
	{
		MergeStmt  *stmt = (MergeStmt *) n;

		stmt->stmt_len = end_location - stmt->stmt_location;
	}
	else
		elog(ERROR, "unexpected node type %d", (int) n->type);
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there is
	 * any subscripting in the specified indirection list.  However, any field
	 * selection at the start of the indirection list must be transposed into
	 * the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int			nfields = 0;
	ListCell   *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast   *n = makeNode(TypeCast);

	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node	   *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const    *n = makeNode(A_Const);

	n->val.ival.type = T_Integer;
	n->val.ival.ival = val;
	n->location = location;

	return (Node *) n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const    *n = makeNode(A_Const);

	n->val.fval.type = T_Float;
	n->val.fval.fval = str;
	n->location = location;

	return (Node *) n;
}

static Node *
makeBoolAConst(bool state, int location)
{
	A_Const    *n = makeNode(A_Const);

	n->val.boolval.type = T_Boolean;
	n->val.boolval.boolval = state;
	n->location = location;

	return (Node *) n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const    *n = makeNode(A_Const);

	n->val.bsval.type = T_BitString;
	n->val.bsval.bsval = str;
	n->location = location;

	return (Node *) n;
}

static Node *
makeNullAConst(int location)
{
	A_Const    *n = makeNode(A_Const);

	n->isnull = true;
	n->location = location;

	return (Node *) n;
}

static Node *
makeAConst(Node *v, int location)
{
	Node	   *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(castNode(Float, v)->fval, location);
			break;

		case T_Integer:
			n = makeIntConst(castNode(Integer, v)->ival, location);
			break;

		default:
			/* currently not used */
			Assert(false);
			n = NULL;
	}

	return n;
}

/* makeRoleSpec
 * Create a RoleSpec with the given type
 */
static RoleSpec *
makeRoleSpec(RoleSpecType type, int location)
{
	RoleSpec   *spec = makeNode(RoleSpec);

	spec->roletype = type;
	spec->location = location;

	return spec;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell   *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	Integer    *ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them; it
		 * doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC ||
			!equal(lastd->argType, firsto->argType))
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(firsto->location)));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = makeInteger(list_length(directargs));

	return list_make2(list_concat(directargs, orderedargs),
					  ndirectargs);
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					SelectLimit *limitClause,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitClause && limitClause->limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(limitClause->offsetLoc)));
		stmt->limitOffset = limitClause->limitOffset;
	}
	if (limitClause && limitClause->limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(limitClause->countLoc)));
		stmt->limitCount = limitClause->limitCount;
	}
	if (limitClause)
	{
		/* If there was a conflict, we must have detected it above */
		Assert(!stmt->limitOption);
		if (!stmt->sortClause && limitClause->limitOption == LIMIT_OPTION_WITH_TIES)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("WITH TIES cannot be specified without ORDER BY clause"),
					 parser_errposition(limitClause->optionLoc)));
		if (limitClause->limitOption == LIMIT_OPTION_WITH_TIES && stmt->lockingClause)
		{
			ListCell   *lc;

			foreach(lc, stmt->lockingClause)
			{
				LockingClause *lock = lfirst_node(LockingClause, lc);

				if (lock->waitPolicy == LockWaitSkip)
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("%s and %s options cannot be used together",
									"SKIP LOCKED", "WITH TIES"),
							 parser_errposition(limitClause->optionLoc)));
			}
		}
		stmt->limitOption = limitClause->limitOption;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;

		/* Update SelectStmt's location to the start of the WITH clause */
		stmt->stmt_location = withClause->location;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg, int location)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	n->stmt_location = location;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const    *con = (A_Const *) n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (IsA(&con->val, Integer))
		{
			con->val.ival.ival = -con->val.ival.ival;
			return n;
		}
		if (IsA(&con->val, Float))
		{
			doNegateFloat(&con->val.fval);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Float *v)
{
	char	   *oldval = v->fval;

	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->fval = oldval + 1;	/* just strip the '-' */
	else
		v->fval = psprintf("-%s", oldval);
}

static Node *
makeAndExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a AND b AND c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr   *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == AND_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(AND_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeOrExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a OR b OR c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr   *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == OR_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(OR_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeNotExpr(Node *expr, int location)
{
	return (Node *) makeBoolExpr(NOT_EXPR, list_make1(expr), location);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod, int location)
{
	SQLValueFunction *svf = makeNode(SQLValueFunction);

	svf->op = op;
	/* svf->type will be filled during parse analysis */
	svf->typmod = typmod;
	svf->location = location;
	return (Node *) svf;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr    *x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;

	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;		/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns, core_yyscan_t yyscanner)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_DEFAULT &&
			p->mode != FUNC_PARAM_IN &&
			p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions"),
					 parser_errposition(p->location)));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName   *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar   *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/*
 * Convert a relation_name with name and namelist to a RangeVar using
 * makeRangeVar.
 */
static RangeVar *
makeRangeVarFromQualifiedName(char *name, List *namelist, int location,
							  core_yyscan_t yyscanner)
{
	RangeVar   *r;

	check_qualified_name(namelist, yyscanner);
	r = makeRangeVar(NULL, NULL, location);

	switch (list_length(namelist))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = name;
			r->relname = strVal(linitial(namelist));
			break;
		case 2:
			r->catalogname = name;
			r->schemaname = strVal(linitial(namelist));
			r->relname = strVal(lsecond(namelist));
			break;
		default:
			ereport(ERROR,
					errcode(ERRCODE_SYNTAX_ERROR),
					errmsg("improper qualified name (too many dotted names): %s",
						   NameListToString(lcons(makeString(name), namelist))),
					parser_errposition(location));
			break;
	}

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;

	*collClause = NULL;
	foreach(cell, qualList)
	{
		Node	   *n = (Node *) lfirst(cell);

		if (IsA(n, Constraint))
		{
			/* keep it in list */
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = foreach_delete_current(qualList, cell);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *is_enforced,
			   bool *not_valid, bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;
	if (is_enforced)
		*is_enforced = true;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
			/* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
			/* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
			/* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
			/* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_ENFORCED)
	{
		if (is_enforced)
			*is_enforced = false;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT ENFORCED",
							constrType),
					 parser_errposition(location)));

		/*
		 * NB: The validated status is irrelevant when the constraint is set to
		 * NOT ENFORCED, but for consistency, it should be set accordingly.
		 * This ensures that if the constraint is later changed to ENFORCED, it
		 * will automatically be in the correct NOT VALIDATED state.
		 */
		if (not_valid)
			*not_valid = true;
	}

	if (cas_bits & CAS_ENFORCED)
	{
		if (is_enforced)
			*is_enforced = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked ENFORCED",
							constrType),
					 parser_errposition(location)));
	}
}

/*
 * Parse a user-supplied partition strategy string into parse node
 * PartitionStrategy representation, or die trying.
 */
static PartitionStrategy
parsePartitionStrategy(char *strategy, int location, core_yyscan_t yyscanner)
{
	if (pg_strcasecmp(strategy, "list") == 0)
		return PARTITION_STRATEGY_LIST;
	else if (pg_strcasecmp(strategy, "range") == 0)
		return PARTITION_STRATEGY_RANGE;
	else if (pg_strcasecmp(strategy, "hash") == 0)
		return PARTITION_STRATEGY_HASH;

	ereport(ERROR,
			(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
			 errmsg("unrecognized partitioning strategy \"%s\"", strategy),
			 parser_errposition(location)));
	return PARTITION_STRATEGY_LIST; /* keep compiler quiet */

}

/*
 * Process pubobjspec_list to check for errors in any of the objects and
 * convert PUBLICATIONOBJ_CONTINUATION into appropriate PublicationObjSpecType.
 */
static void
preprocess_pubobj_list(List *pubobjspec_list, core_yyscan_t yyscanner)
{
	ListCell   *cell;
	PublicationObjSpec *pubobj;
	PublicationObjSpecType prevobjtype = PUBLICATIONOBJ_CONTINUATION;

	if (!pubobjspec_list)
		return;

	pubobj = (PublicationObjSpec *) linitial(pubobjspec_list);
	if (pubobj->pubobjtype == PUBLICATIONOBJ_CONTINUATION)
		ereport(ERROR,
				errcode(ERRCODE_SYNTAX_ERROR),
				errmsg("invalid publication object list"),
				errdetail("One of TABLE or TABLES IN SCHEMA must be specified before a standalone table or schema name."),
				parser_errposition(pubobj->location));

	foreach(cell, pubobjspec_list)
	{
		pubobj = (PublicationObjSpec *) lfirst(cell);

		if (pubobj->pubobjtype == PUBLICATIONOBJ_CONTINUATION)
			pubobj->pubobjtype = prevobjtype;

		if (pubobj->pubobjtype == PUBLICATIONOBJ_TABLE)
		{
			/* relation name or pubtable must be set for this type of object */
			if (!pubobj->name && !pubobj->pubtable)
				ereport(ERROR,
						errcode(ERRCODE_SYNTAX_ERROR),
						errmsg("invalid table name"),
						parser_errposition(pubobj->location));

			if (pubobj->name)
			{
				/* convert it to PublicationTable */
				PublicationTable *pubtable = makeNode(PublicationTable);

				pubtable->relation =
					makeRangeVar(NULL, pubobj->name, pubobj->location);
				pubobj->pubtable = pubtable;
				pubobj->name = NULL;
			}
		}
		else if (pubobj->pubobjtype == PUBLICATIONOBJ_TABLES_IN_SCHEMA ||
				 pubobj->pubobjtype == PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA)
		{
			/* WHERE clause is not allowed on a schema object */
			if (pubobj->pubtable && pubobj->pubtable->whereClause)
				ereport(ERROR,
						errcode(ERRCODE_SYNTAX_ERROR),
						errmsg("WHERE clause not allowed for schema"),
						parser_errposition(pubobj->location));

			/* Column list is not allowed on a schema object */
			if (pubobj->pubtable && pubobj->pubtable->columns)
				ereport(ERROR,
						errcode(ERRCODE_SYNTAX_ERROR),
						errmsg("column specification not allowed for schema"),
						parser_errposition(pubobj->location));

			/*
			 * We can distinguish between the different type of schema objects
			 * based on whether name and pubtable is set.
			 */
			if (pubobj->name)
				pubobj->pubobjtype = PUBLICATIONOBJ_TABLES_IN_SCHEMA;
			else if (!pubobj->name && !pubobj->pubtable)
				pubobj->pubobjtype = PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA;
			else
				ereport(ERROR,
						errcode(ERRCODE_SYNTAX_ERROR),
						errmsg("invalid schema name"),
						parser_errposition(pubobj->location));
		}

		prevobjtype = pubobj->pubobjtype;
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctematerialized = CTEMaterializeDefault;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/*
	 * create target list for the new SELECT from the alias list of the
	 * recursive view specification
	 */
	foreach(lc, aliases)
	{
		ResTarget  *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/*
	 * create new SELECT combining WITH clause, target list, and fake FROM
	 * clause
	 */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}
